"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","os","fs","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetry","vs/platform/registry/common/platform","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/extpath","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/server/node/serverEnvironmentService","vs/base/common/codicons","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/performance","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/mime","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/remote/common/remoteHosts","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/htmlContent","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/telemetry/common/commonProperties","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/node/loggerService","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","zlib","vs/server/node/server.main"],ve=function(re){for(var e=[],v=0,t=re.length;v<t;v++)e[v]=be[re[v]];return e};define(be[135],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class v{static get(){const P=new Map,S=new Map,D=new Map,A=new Map;function y(p,m){p.has(m.detail)||p.set(m.detail,-m.timestamp)}function E(p,m){const g=p.get(m.detail);!g||g>=0||p.set(m.detail,g+m.timestamp)}let I=[];typeof re.getStats=="function"&&(I=re.getStats().slice(0).sort((p,m)=>p.timestamp-m.timestamp));for(const p of I)switch(p.type){case 10:y(P,p);break;case 11:case 12:E(P,p);break;case 21:y(S,p);break;case 22:E(S,p);break;case 33:y(D,p);break;case 34:E(D,p);break;case 31:y(A,p);break;case 32:E(A,p);break}let k=0;D.forEach(p=>k+=p);function C(p){const m=[];return p.forEach((g,w)=>m.push([w,g])),m}return{amdLoad:C(P),amdInvoke:C(S),nodeRequire:C(D),nodeEval:C(A),nodeRequireTotal:k}}static toMarkdownTable(P,S){let D="";const A=[];return P.forEach((y,E)=>{A[E]=y.length}),S.forEach(y=>{y.forEach((E,I)=>{typeof E>"u"&&(E=y[I]="-");const k=E.toString().length;A[I]=Math.max(k,A[I])})}),P.forEach((y,E)=>{D+=`| ${y+" ".repeat(A[E]-y.toString().length)} `}),D+=`|
`,P.forEach((y,E)=>{D+=`| ${"-".repeat(A[E])} `}),D+=`|
`,S.forEach(y=>{y.forEach((E,I)=>{typeof E<"u"&&(D+=`| ${E+" ".repeat(A[I]-E.toString().length)} `)}),D+=`|
`}),D}}e.LoaderStats=v}),define(be[41],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function v(S){return S?S.replace(/\$\((.*?)\)/g,(D,A)=>` ${A} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(D,A,y){this.id=D,this.definition=A,this.description=y,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var P;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function A(I){if(I instanceof t)return["codicon","codicon-"+I.id];const k=D.exec(I.id);if(!k)return A(t.error);const[,C,p]=k,m=["codicon","codicon-"+C];return p&&m.push("codicon-modifier-"+p.substring(1)),m}S.asClassNameArray=A;function y(I){return A(I).join(" ")}S.asClassName=y;function E(I){return"."+A(I).join(".")}S.asCSSSelector=E})(P=e.CSSIcon||(e.CSSIcon={}))}),define(be[85],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function v(D){return(A,y,E)=>{let I=null,k=null;if(typeof E.value=="function"?(I="value",k=E.value):typeof E.get=="function"&&(I="get",k=E.get),!k)throw new Error("not supported");E[I]=D(k,y)}}function t(D,A,y){let E=null,I=null;if(typeof y.value=="function"?(E="value",I=y.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(E="get",I=y.get),!I)throw new Error("not supported");const k=`$memoize$${A}`;y[E]=function(...C){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,C)}),this[k]}}e.memoize=t;function P(D,A,y){return v((E,I)=>{const k=`$debounce$${I}`,C=`$debounce$result$${I}`;return function(...p){this[C]||(this[C]=y?y():void 0),clearTimeout(this[k]),A&&(this[C]=A(this[C],...p),p=[this[C]]),this[k]=setTimeout(()=>{E.apply(this,p),this[C]=y?y():void 0},D)}})}e.debounce=P;function S(D,A,y){return v((E,I)=>{const k=`$throttle$timer$${I}`,C=`$throttle$result$${I}`,p=`$throttle$lastRun$${I}`,m=`$throttle$pending$${I}`;return function(...g){if(this[C]||(this[C]=y?y():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),A&&(this[C]=A(this[C],...g)),this[m])return;const w=this[p]+D;w<=Date.now()?(this[p]=Date.now(),E.apply(this,[this[C]]),this[C]=y?y():void 0):(this[m]=!0,this[k]=setTimeout(()=>{this[m]=!1,this[p]=Date.now(),E.apply(this,[this[C]]),this[C]=y?y():void 0},w-Date.now()))}})}e.throttle=S}),define(be[8],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?c.isErrorNoTelemetry(i)?new c(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=v,e.errorHandler=new v;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function P(u){y(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=P;function S(u){y(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=S;function D(u){if(u instanceof Error){const{name:i,message:n}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:i,message:n,stack:r,noTelemetry:c.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=D;const A="Canceled";function y(u){return u instanceof E?!0:u instanceof Error&&u.name===A&&u.message===A}e.isCancellationError=y;class E extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=E;function I(){const u=new Error(A);return u.name=u.message,u}e.canceled=I;function k(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=k;function C(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=C;function p(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function m(u){const i=new Error(`${u} has been disposed`);return i.name="DISPOSED",i}e.disposed=m;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=w;class d extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=d;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class c extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof c)return i;const n=new c;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(be[18],ve([1,0,8]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(z,Y=0){return z[z.length-(1+Y)]}e.tail=t;function P(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=P;function S(z,Y,_=(j,q)=>j===q){if(z===Y)return!0;if(!z||!Y||z.length!==Y.length)return!1;for(let j=0,q=z.length;j<q;j++)if(!_(z[j],Y[j]))return!1;return!0}e.equals=S;function D(z,Y){const _=z.length-1;Y<_&&(z[Y]=z[_]),z.pop()}e.removeFastWithoutKeepingOrder=D;function A(z,Y,_){return y(z.length,j=>_(z[j],Y))}e.binarySearch=A;function y(z,Y){let _=0,j=z-1;for(;_<=j;){const q=(_+j)/2|0,G=Y(q);if(G<0)_=q+1;else if(G>0)j=q-1;else return q}return-(_+1)}e.binarySearch2=y;function E(z,Y){let _=0,j=z.length;if(j===0)return 0;for(;_<j;){const q=Math.floor((_+j)/2);Y(z[q])?j=q:_=q+1}return _}e.findFirstInSorted=E;function I(z,Y,_){if(z=z|0,z>=Y.length)throw new TypeError("invalid index");const j=Y[Math.floor(Y.length*Math.random())],q=[],G=[],x=[];for(const oe of Y){const pe=_(oe,j);pe<0?q.push(oe):pe>0?G.push(oe):x.push(oe)}return z<q.length?I(z,q,_):z<q.length+x.length?x[0]:I(z-(q.length+x.length),G,_)}e.quickSelect=I;function k(z,Y){const _=[];let j;for(const q of z.slice(0).sort(Y))!j||Y(j[0],q)!==0?(j=[q],_.push(j)):j.push(q);return _}e.groupBy=k;function C(z,Y,_){const j=[];function q(oe,pe,ke){if(pe===0&&ke.length===0)return;const Ae=j[j.length-1];Ae&&Ae.start+Ae.deleteCount===oe?(Ae.deleteCount+=pe,Ae.toInsert.push(...ke)):j.push({start:oe,deleteCount:pe,toInsert:ke})}let G=0,x=0;for(;;){if(G===z.length){q(G,0,Y.slice(x));break}if(x===Y.length){q(G,z.length-G,[]);break}const oe=z[G],pe=Y[x],ke=_(oe,pe);ke===0?(G+=1,x+=1):ke<0?(q(G,1,[]),G+=1):ke>0&&(q(G,0,[pe]),x+=1)}return j}e.sortedDiff=C;function p(z,Y,_){const j=C(z,Y,_),q=[],G=[];for(const x of j)q.push(...z.slice(x.start,x.start+x.deleteCount)),G.push(...x.toInsert);return{removed:q,added:G}}e.delta=p;function m(z,Y,_){if(_===0)return[];const j=z.slice(0,_).sort(Y);return w(z,Y,j,_,z.length),j}e.top=m;function g(z,Y,_,j,q){return _===0?Promise.resolve([]):new Promise((G,x)=>{(async()=>{const oe=z.length,pe=z.slice(0,_).sort(Y);for(let ke=_,Ae=Math.min(_+j,oe);ke<oe;ke=Ae,Ae=Math.min(Ae+j,oe)){if(ke>_&&await new Promise(Fe=>setTimeout(Fe)),q&&q.isCancellationRequested)throw new v.CancellationError;w(z,Y,pe,ke,Ae)}return pe})().then(G,x)})}e.topAsync=g;function w(z,Y,_,j,q){for(const G=_.length;j<q;j++){const x=z[j];if(Y(x,_[G-1])<0){_.pop();const oe=E(_,pe=>Y(x,pe)<0);_.splice(oe,0,x)}}}function d(z){return z.filter(Y=>!!Y)}e.coalesce=d;function b(z){let Y=0;for(let _=0;_<z.length;_++)z[_]&&(z[Y]=z[_],Y+=1);z.length=Y}e.coalesceInPlace=b;function c(z,Y,_){z.splice(_,0,z.splice(Y,1)[0])}e.move=c;function f(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=f;function u(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=u;function i(z,Y=_=>_){const _=new Set;return z.filter(j=>{const q=Y(j);return _.has(q)?!1:(_.add(q),!0)})}e.distinct=i;function n(z){const Y=new Set;return _=>{const j=z(_);return Y.has(j)?!1:(Y.add(j),!0)}}e.uniqueFilter=n;function r(z,Y){const _=o(z,Y);if(_!==-1)return z[_]}e.findLast=r;function o(z,Y){for(let _=z.length-1;_>=0;_--){const j=z[_];if(Y(j))return _}return-1}e.lastIndex=o;function a(z,Y){return z.length>0?z[0]:Y}e.firstOrDefault=a;function l(z,Y){return z.length>0?z[z.length-1]:Y}e.lastOrDefault=l;function s(z,Y,_=(j,q)=>j===q){let j=0;for(let q=0,G=Math.min(z.length,Y.length);q<G&&_(z[q],Y[q]);q++)j++;return j}e.commonPrefixLength=s;function h(z){return[].concat(...z)}e.flatten=h;function T(z,Y){let _=typeof Y=="number"?z:0;typeof Y=="number"?_=z:(_=0,Y=z);const j=[];if(_<=Y)for(let q=_;q<Y;q++)j.push(q);else for(let q=_;q>Y;q--)j.push(q);return j}e.range=T;function F(z,Y,_){return z.reduce((j,q)=>(j[Y(q)]=_?_(q):q,j),Object.create(null))}e.index=F;function Z(z,Y){return z.push(Y),()=>ne(z,Y)}e.insert=Z;function ne(z,Y){const _=z.indexOf(Y);if(_>-1)return z.splice(_,1),Y}e.remove=ne;function ce(z,Y,_){const j=z.slice(0,Y),q=z.slice(Y);return j.concat(_,q)}e.arrayInsert=ce;function ie(z,Y){let _;if(typeof Y=="number"){let j=Y;_=()=>{const q=Math.sin(j++)*179426549;return q-Math.floor(q)}}else _=Math.random;for(let j=z.length-1;j>0;j-=1){const q=Math.floor(_()*(j+1)),G=z[j];z[j]=z[q],z[q]=G}}e.shuffle=ie;function M(z,Y){const _=z.indexOf(Y);_>-1&&(z.splice(_,1),z.unshift(Y))}e.pushToStart=M;function J(z,Y){const _=z.indexOf(Y);_>-1&&(z.splice(_,1),z.push(Y))}e.pushToEnd=J;function $(z,Y){for(const _ of Y)z.push(_)}e.pushMany=$;function V(z,Y){return Array.isArray(z)?z.map(Y):Y(z)}e.mapArrayOrNot=V;function X(z){return Array.isArray(z)?z:[z]}e.asArray=X;function ue(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=ue;function L(z,Y){for(const _ of z){const j=Y(_);if(j!==void 0)return j}}e.mapFind=L;function N(z,Y,_){const j=ee(z,Y),q=z.length,G=_.length;z.length=q+G;for(let x=q-1;x>=j;x--)z[x+G]=z[x];for(let x=0;x<G;x++)z[x+j]=_[x]}e.insertInto=N;function H(z,Y,_,j){const q=ee(z,Y),G=z.splice(q,_);return N(z,q,j),G}e.splice=H;function ee(z,Y){return Y<0?Math.max(Y+z.length,0):Math.min(Y,z.length)}var ae;(function(z){function Y(q){return q<0}z.isLessThan=Y;function _(q){return q>0}z.isGreaterThan=_;function j(q){return q===0}z.isNeitherLessOrGreaterThan=j,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(ae=e.CompareResult||(e.CompareResult={}));function ge(z,Y){return(_,j)=>Y(z(_),z(j))}e.compareBy=ge;function fe(...z){return(Y,_)=>{for(const j of z){const q=j(Y,_);if(!ae.isNeitherLessOrGreaterThan(q))return q}return ae.neitherLessOrGreaterThan}}e.tieBreakComparators=fe;const R=(z,Y)=>z-Y;e.numberComparator=R;function U(z,Y){if(z.length===0)return;let _=z[0];for(let j=1;j<z.length;j++){const q=z[j];Y(q,_)>0&&(_=q)}return _}e.findMaxBy=U;function W(z,Y){if(z.length===0)return;let _=z[0];for(let j=1;j<z.length;j++){const q=z[j];Y(q,_)>=0&&(_=q)}return _}e.findLastMaxBy=W;function Q(z,Y){return U(z,(_,j)=>-Y(_,j))}e.findMinBy=Q;class se{constructor(Y){this.f=Y,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let _=this.c;for(;_<this.f.length&&Y(this.f[_]);)_++;const j=_===this.c?null:this.f.slice(this.c,_);return this.c=_,j}takeFromEndWhile(Y){let _=this.d;for(;_>=0&&Y(this.f[_]);)_--;const j=_===this.d?null:this.f.slice(_+1,this.d+1);return this.d=_,j}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Y=this.f[this.c];return this.c++,Y}removeLast(){const Y=this.f[this.d];return this.d--,Y}takeCount(Y){const _=this.f.slice(this.c,this.c+Y);return this.c+=Y,_}}e.ArrayQueue=se;class de{constructor(Y){this.iterate=Y}forEach(Y){this.iterate(_=>(Y(_),!0))}toArray(){const Y=[];return this.iterate(_=>(Y.push(_),!0)),Y}filter(Y){return new de(_=>this.iterate(j=>Y(j)?_(j):!0))}map(Y){return new de(_=>this.iterate(j=>_(Y(j))))}some(Y){let _=!1;return this.iterate(j=>(_=Y(j),!_)),_}findFirst(Y){let _;return this.iterate(j=>Y(j)?(_=j,!1):!0),_}findLast(Y){let _;return this.iterate(j=>(Y(j)&&(_=j),!0)),_}findLastMaxBy(Y){let _,j=!0;return this.iterate(q=>((j||ae.isGreaterThan(Y(q,_)))&&(j=!1,_=q),!0)),_}}e.CallbackIterable=de,de.empty=new de(z=>{})}),define(be[86],ve([1,0,8]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(y,E){if(!y)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=t;function P(y,E="Unreachable"){throw new Error(E)}e.assertNever=P;function S(y){if(!y)throw new v.BugIndicatingError("Assertion Failed")}e.assert=S;function D(y){if(!y()){debugger;y(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function A(y,E){let I=0;for(;I<y.length-1;){const k=y[I],C=y[I+1];if(!E(k,C))return!1;I++}return!0}e.checkAdjacentItems=A}),define(be[68],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const P=this;let S=!1,D;return function(){return S||(S=!0,D=t.apply(P,arguments)),D}}e.once=v}),define(be[55],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function P(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=P;const S=Object.freeze([]);function D(){return S}t.empty=D;function*A(f){yield f}t.single=A;function y(f){return P(f)?f:A(f)}t.wrap=y;function E(f){return f||S}t.from=E;function I(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=I;function k(f){return f[Symbol.iterator]().next().value}t.first=k;function C(f,u){for(const i of f)if(u(i))return!0;return!1}t.some=C;function p(f,u){for(const i of f)if(u(i))return i}t.find=p;function*m(f,u){for(const i of f)u(i)&&(yield i)}t.filter=m;function*g(f,u){let i=0;for(const n of f)yield u(n,i++)}t.map=g;function*w(...f){for(const u of f)for(const i of u)yield i}t.concat=w;function d(f,u,i){let n=i;for(const r of f)n=u(n,r);return n}t.reduce=d;function*b(f,u,i=f.length){for(u<0&&(u+=f.length),i<0?i+=f.length:i>f.length&&(i=f.length);u<i;u++)yield f[u]}t.slice=b;function c(f,u=Number.POSITIVE_INFINITY){const i=[];if(u===0)return[i,f];const n=f[Symbol.iterator]();for(let r=0;r<u;r++){const o=n.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return n}}]}t.consume=c})(v=e.Iterable||(e.Iterable={}))}),define(be[69],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(i){i.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function D(i,n=!1){let r=0;const o=i.length;let a="",l=0,s=16,h=0;function T(J){let $=0,V=0;for(;$<J;){const X=i.charCodeAt(r);if(X>=48&&X<=57)V=V*16+X-48;else if(X>=65&&X<=70)V=V*16+X-65+10;else if(X>=97&&X<=102)V=V*16+X-97+10;else break;r++,$++}return $<J&&(V=-1),V}function F(J){r=J,a="",l=0,s=16,h=0}function Z(){const J=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&E(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&E(i.charCodeAt(r)))for(r++;r<i.length&&E(i.charCodeAt(r));)r++;else return h=3,i.substring(J,r);let $=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&E(i.charCodeAt(r))){for(r++;r<i.length&&E(i.charCodeAt(r));)r++;$=r}else h=3;return i.substring(J,$)}function ne(){let J="",$=r;for(;;){if(r>=o){J+=i.substring($,r),h=2;break}const V=i.charCodeAt(r);if(V===34){J+=i.substring($,r),r++;break}if(V===92){if(J+=i.substring($,r),r++,r>=o){h=2;break}switch(i.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const ue=T(4);ue>=0?J+=String.fromCharCode(ue):h=4;break}default:h=5}$=r;continue}if(V>=0&&V<=31)if(y(V)){J+=i.substring($,r),h=2;break}else h=6;r++}return J}function ce(){if(a="",h=0,l=r,r>=o)return l=o,s=17;let J=i.charCodeAt(r);if(A(J)){do r++,a+=String.fromCharCode(J),J=i.charCodeAt(r);while(A(J));return s=15}if(y(J))return r++,a+=String.fromCharCode(J),J===13&&i.charCodeAt(r)===10&&(r++,a+=`
`),s=14;switch(J){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,a=ne(),s=10;case 47:{const $=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<o&&!y(i.charCodeAt(r));)r++;return a=i.substring($,r),s=12}if(i.charCodeAt(r+1)===42){r+=2;const V=o-1;let X=!1;for(;r<V;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,X=!0;break}r++}return X||(r++,h=1),a=i.substring($,r),s=13}return a+=String.fromCharCode(J),r++,s=16}case 45:if(a+=String.fromCharCode(J),r++,r===o||!E(i.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=Z(),s=11;default:for(;r<o&&ie(J);)r++,J=i.charCodeAt(r);if(l!==r){switch(a=i.substring(l,r),a){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return a+=String.fromCharCode(J),r++,s=16}}function ie(J){if(A(J)||y(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let J;do J=ce();while(J>=12&&J<=15);return J}return{setPosition:F,getPosition:()=>r,scan:n?M:ce,getToken:()=>s,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>h}}e.createScanner=D;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function k(i,n){const r=[],o=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function h(T,F,Z,ne){l.value=T,l.offset=F,l.length=Z,l.type=ne,l.colonOffset=void 0,a=l}try{c(i,{onObjectBegin:(T,F)=>{if(n<=T)throw o;a=void 0,s=n>T,r.push("")},onObjectProperty:(T,F,Z)=>{if(n<F||(h(T,F,Z,"property"),r[r.length-1]=T,n<=F+Z))throw o},onObjectEnd:(T,F)=>{if(n<=T)throw o;a=void 0,r.pop()},onArrayBegin:(T,F)=>{if(n<=T)throw o;a=void 0,r.push(0)},onArrayEnd:(T,F)=>{if(n<=T)throw o;a=void 0,r.pop()},onLiteralValue:(T,F,Z)=>{if(n<F||(h(T,F,Z,u(T)),n<=F+Z))throw o},onSeparator:(T,F,Z)=>{if(n<=F)throw o;if(T===":"&&a&&a.type==="property")a.colonOffset=F,s=!1,a=void 0;else if(T===","){const ne=r[r.length-1];typeof ne=="number"?r[r.length-1]=ne+1:(s=!0,r[r.length-1]=""),a=void 0}}})}catch(T){if(T!==o)throw T}return{path:r,previousNode:a,isAtPropertyKey:s,matches:T=>{let F=0;for(let Z=0;F<T.length&&Z<r.length;Z++)if(T[F]===r[Z]||T[F]==="*")F++;else if(T[F]!=="**")return!1;return F===T.length}}}e.getLocation=k;function C(i,n=[],r=S.DEFAULT){let o=null,a=[];const l=[];function s(T){Array.isArray(a)?a.push(T):o!==null&&(a[o]=T)}return c(i,{onObjectBegin:()=>{const T={};s(T),l.push(a),a=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const T=[];s(T),l.push(a),a=T,o=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:s,onError:(T,F,Z)=>{n.push({error:T,offset:F,length:Z})}},r),a[0]}e.parse=C;function p(i,n=[],r=S.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(T){o.type==="property"&&(o.length=T-o.offset,o=o.parent)}function l(T){return o.children.push(T),T}c(i,{onObjectBegin:T=>{o=l({type:"object",offset:T,length:-1,parent:o,children:[]})},onObjectProperty:(T,F,Z)=>{o=l({type:"property",offset:F,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:T,offset:F,length:Z,parent:o})},onObjectEnd:(T,F)=>{o.length=T+F-o.offset,o=o.parent,a(T+F)},onArrayBegin:(T,F)=>{o=l({type:"array",offset:T,length:-1,parent:o,children:[]})},onArrayEnd:(T,F)=>{o.length=T+F-o.offset,o=o.parent,a(T+F)},onLiteralValue:(T,F,Z)=>{l({type:u(T),offset:F,length:Z,parent:o,value:T}),a(F+Z)},onSeparator:(T,F,Z)=>{o.type==="property"&&(T===":"?o.colonOffset=F:T===","&&a(F))},onError:(T,F,Z)=>{n.push({error:T,offset:F,length:Z})}},r);const h=o.children[0];return h&&delete h.parent,h}e.parseTree=p;function m(i,n){if(!i)return;let r=i;for(const o of n)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===o){r=l.children[1],a=!0;break}if(!a)return}else{const a=o;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=m;function g(i){if(!i.parent||!i.parent.children)return[];const n=g(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;n.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&n.push(r)}return n}e.getNodePath=g;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const n=Object.create(null);for(const r of i.children){const o=r.children[1];o&&(n[r.children[0].value]=w(o))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=w;function d(i,n,r=!1){return n>=i.offset&&n<i.offset+i.length||r&&n===i.offset+i.length}e.contains=d;function b(i,n,r=!1){if(d(i,n,r)){const o=i.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=n;a++){const l=b(o[a],n,r);if(l)return l}return i}}e.findNodeAtOffset=b;function c(i,n,r=S.DEFAULT){const o=D(i,!1);function a(ge){return ge?()=>ge(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(ge){return ge?fe=>ge(fe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=a(n.onObjectBegin),h=l(n.onObjectProperty),T=a(n.onObjectEnd),F=a(n.onArrayBegin),Z=a(n.onArrayEnd),ne=l(n.onLiteralValue),ce=l(n.onSeparator),ie=a(n.onComment),M=l(n.onError),J=r&&r.disallowComments,$=r&&r.allowTrailingComma;function V(){for(;;){const ge=o.scan();switch(o.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:J||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(ge){case 12:case 13:J?X(10):ie();break;case 16:X(1);break;case 15:case 14:break;default:return ge}}}function X(ge,fe=[],R=[]){if(M(ge),fe.length+R.length>0){let U=o.getToken();for(;U!==17;){if(fe.indexOf(U)!==-1){V();break}else if(R.indexOf(U)!==-1)break;U=V()}}}function ue(ge){const fe=o.getTokenValue();return ge?ne(fe):h(fe),V(),!0}function L(){switch(o.getToken()){case 11:{let ge=0;try{ge=JSON.parse(o.getTokenValue()),typeof ge!="number"&&(X(2),ge=0)}catch{X(2)}ne(ge);break}case 7:ne(null);break;case 8:ne(!0);break;case 9:ne(!1);break;default:return!1}return V(),!0}function N(){return o.getToken()!==10?(X(3,[],[2,5]),!1):(ue(!1),o.getToken()===6?(ce(":"),V(),ae()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function H(){s(),V();let ge=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ge||X(4,[],[]),ce(","),V(),o.getToken()===2&&$)break}else ge&&X(6,[],[]);N()||X(4,[],[2,5]),ge=!0}return T(),o.getToken()!==2?X(7,[2],[]):V(),!0}function ee(){F(),V();let ge=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ge||X(4,[],[]),ce(","),V(),o.getToken()===4&&$)break}else ge&&X(6,[],[]);ae()||X(4,[],[4,5]),ge=!0}return Z(),o.getToken()!==4?X(8,[4],[]):V(),!0}function ae(){switch(o.getToken()){case 3:return ee();case 1:return H();case 10:return ue(!0);default:return L()}}return V(),o.getToken()===17?r.allowEmptyContent?!0:(X(4,[],[]),!1):ae()?(o.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=c;function f(i,n){const r=D(i),o=[];let a,l=0,s;do switch(s=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:l!==s&&o.push(i.substring(l,s)),n!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,n)),l=r.getPosition();break}while(a!==17);return o.join("")}e.stripComments=f;function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(be[136],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(P){this.d=P,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(P){return new v(()=>P(this.getValue()))}}e.Lazy=v}),define(be[2],ve([1,0,68,55]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let S=null;function D(l){S=l}if(e.setDisposableTracker=D,P){const l="__is_disposable_tracked__";D(new class{trackDisposable(s){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[l]||console.log(h)},3e3)}setParent(s,h){if(s&&s!==b.None)try{s[l]=!0}catch{}}markAsDisposed(s){if(s&&s!==b.None)try{s[l]=!0}catch{}}markAsSingleton(s){}})}function A(l){return S?.trackDisposable(l),l}function y(l){S?.markAsDisposed(l)}function E(l,s){S?.setParent(l,s)}function I(l,s){if(!!S)for(const h of l)S.setParent(h,s)}function k(l){return S?.markAsSingleton(l),l}e.markAsSingleton=k;function C(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=C;function p(l){if(t.Iterable.is(l)){const s=[];for(const h of l)if(h)try{h.dispose()}catch(T){s.push(T)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=p;function m(l){for(const s of l)C(s)&&s.dispose();return[]}e.disposeIfDisposable=m;function g(...l){const s=w(()=>p(l));return I(l,s),s}e.combinedDisposable=g;function w(l){const s=A({dispose:(0,v.once)(()=>{y(s),l()})});return s}e.toDisposable=w;class d{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{p(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return E(s,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this.q=new d,A(this),E(this.q,this)}dispose(){y(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class c{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&E(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&E(s,null),s}}e.MutableDisposable=c;class f{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=f;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(s){let h=s;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,y(this))},this}}e.SafeDisposable=u;class i{constructor(){this.a=new Map}acquire(s,...h){let T=this.a.get(s);T||(T={counter:0,object:this.b(s,...h)},this.a.set(s,T));const{object:F}=T,Z=(0,v.once)(()=>{--T.counter===0&&(this.c(s,T.object),this.a.delete(s))});return T.counter++,{object:F,dispose:Z}}}e.ReferenceCollection=i;class n{constructor(s){this.a=s}async acquire(s,...h){const T=this.a.acquire(s,...h);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(F){throw T.dispose(),F}}}e.AsyncReferenceCollection=n;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r;function o(l){const s=new d;try{l(s)}finally{s.dispose()}}e.disposeOnReturn=o;class a{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,h,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(s)?.dispose(),this.a.set(s,h)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(be[87],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(S){this.element=S,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let S=this.a;for(;S!==v.Undefined;){const D=S.next;S.prev=v.Undefined,S.next=v.Undefined,S=D}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(S){return this.d(S,!1)}push(S){return this.d(S,!0)}d(S,D){const A=new v(S);if(this.a===v.Undefined)this.a=A,this.b=A;else if(D){const E=this.b;this.b=A,A.prev=E,E.next=A}else{const E=this.a;this.a=A,A.next=E,E.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==v.Undefined){const S=this.a.element;return this.e(this.a),S}}pop(){if(this.b!==v.Undefined){const S=this.b.element;return this.e(this.b),S}}e(S){if(S.prev!==v.Undefined&&S.next!==v.Undefined){const D=S.prev;D.next=S.next,S.next.prev=D}else S.prev===v.Undefined&&S.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):S.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):S.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let S=this.a;for(;S!==v.Undefined;)yield S.element,S=S.next}}e.LinkedList=t}),define(be[26],ve([1,0]),function(re,e){"use strict";var v,t,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function S(m,g,w){let d=m.get(g);return d===void 0&&(d=w,m.set(g,d)),d}e.getOrSet=S;function D(m){const g=[];return m.forEach((w,d)=>{g.push(`${d} => ${w}`)}),`Map(${m.size}) {${g.join(", ")}}`}e.mapToString=D;function A(m){const g=[];return m.forEach(w=>{g.push(w)}),`Set(${m.size}) {${g.join(", ")}}`}e.setToString=A;class y{constructor(g,w){this.uri=g,this.value=w}}class E{constructor(g,w){this[v]="ResourceMap",g instanceof E?(this.b=new Map(g.b),this.c=w??E.a):(this.b=new Map,this.c=g??E.a)}set(g,w){return this.b.set(this.c(g),new y(g,w)),this}get(g){return this.b.get(this.c(g))?.value}has(g){return this.b.has(this.c(g))}get size(){return this.b.size}clear(){this.b.clear()}delete(g){return this.b.delete(this.c(g))}forEach(g,w){typeof w<"u"&&(g=g.bind(w));for(const[d,b]of this.b)g(b.value,b.uri,this)}*values(){for(const g of this.b.values())yield g.value}*keys(){for(const g of this.b.values())yield g.uri}*entries(){for(const g of this.b.values())yield[g.uri,g.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.b)yield[g.uri,g.value]}}e.ResourceMap=E,E.a=m=>m.toString();class I{constructor(g,w){this[t]="ResourceSet",!g||typeof g=="function"?this.a=new E(g):(this.a=new E(w),g.forEach(this.add,this))}get size(){return this.a.size}add(g){return this.a.set(g,g),this}clear(){this.a.clear()}delete(g){return this.a.delete(g)}forEach(g,w){this.a.forEach((d,b)=>g.call(w,b,b,this))}has(g){return this.a.has(g)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var k;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class C{constructor(){this[P]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(g){return this.a.has(g)}get(g,w=0){const d=this.a.get(g);if(!!d)return w!==0&&this.j(d,w),d.value}set(g,w,d=0){let b=this.a.get(g);if(b)b.value=w,d!==0&&this.j(b,d);else{switch(b={key:g,value:w,next:void 0,previous:void 0},d){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(g,b),this.d++}return this}delete(g){return!!this.remove(g)}remove(g){const w=this.a.get(g);if(!!w)return this.a.delete(g),this.i(w),this.d--,w.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const g=this.b;return this.a.delete(g.key),this.i(g),this.d--,g.value}forEach(g,w){const d=this.e;let b=this.b;for(;b;){if(w?g.bind(w)(b.value,b.key,this):g(b.value,b.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const g=this,w=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(g.e!==w)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:d.key,done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return b}values(){const g=this,w=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(g.e!==w)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:d.value,done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return b}entries(){const g=this,w=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(g.e!==w)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:[d.key,d.value],done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return b}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(g){if(g>=this.size)return;if(g===0){this.clear();return}let w=this.b,d=this.size;for(;w&&d>g;)this.a.delete(w.key),w=w.next,d--;this.b=w,this.d=d,w&&(w.previous=void 0),this.e++}g(g){if(!this.b&&!this.c)this.c=g;else if(this.b)g.next=this.b,this.b.previous=g;else throw new Error("Invalid list");this.b=g,this.e++}h(g){if(!this.b&&!this.c)this.b=g;else if(this.c)g.previous=this.c,this.c.next=g;else throw new Error("Invalid list");this.c=g,this.e++}i(g){if(g===this.b&&g===this.c)this.b=void 0,this.c=void 0;else if(g===this.b){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.b=g.next}else if(g===this.c){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.c=g.previous}else{const w=g.next,d=g.previous;if(!w||!d)throw new Error("Invalid list");w.previous=d,d.next=w}g.next=void 0,g.previous=void 0,this.e++}j(g,w){if(!this.b||!this.c)throw new Error("Invalid list");if(!(w!==1&&w!==2)){if(w===1){if(g===this.b)return;const d=g.next,b=g.previous;g===this.c?(b.next=void 0,this.c=b):(d.previous=b,b.next=d),g.previous=void 0,g.next=this.b,this.b.previous=g,this.b=g,this.e++}else if(w===2){if(g===this.c)return;const d=g.next,b=g.previous;g===this.b?(d.previous=void 0,this.b=d):(d.previous=b,b.next=d),g.next=void 0,g.previous=this.c,this.c.next=g,this.c=g,this.e++}}}toJSON(){const g=[];return this.forEach((w,d)=>{g.push([d,w])}),g}fromJSON(g){this.clear();for(const[w,d]of g)this.set(w,d)}}e.LinkedMap=C;class p extends C{constructor(g,w=1){super(),this.k=g,this.l=Math.min(Math.max(0,w),1)}get limit(){return this.k}set limit(g){this.k=g,this.m()}get ratio(){return this.l}set ratio(g){this.l=Math.min(Math.max(0,g),1),this.m()}get(g,w=2){return super.get(g,w)}peek(g){return super.get(g,0)}set(g,w){return super.set(g,w,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),function(re,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(be[137],ve([0]),e):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(z,Y){for(var _=0;_<Y.length;_++){var j=Y[_];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(z,j.key,j)}}function v(z,Y,_){return Y&&e(z.prototype,Y),_&&e(z,_),Object.defineProperty(z,"prototype",{writable:!1}),z}function t(z,Y){if(!!z){if(typeof z=="string")return P(z,Y);var _=Object.prototype.toString.call(z).slice(8,-1);if(_==="Object"&&z.constructor&&(_=z.constructor.name),_==="Map"||_==="Set")return Array.from(z);if(_==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_))return P(z,Y)}}function P(z,Y){(Y==null||Y>z.length)&&(Y=z.length);for(var _=0,j=new Array(Y);_<Y;_++)j[_]=z[_];return j}function S(z,Y){var _=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(_)return(_=_.call(z)).next.bind(_);if(Array.isArray(z)||(_=t(z))||Y&&z&&typeof z.length=="number"){_&&(z=_);var j=0;return function(){return j>=z.length?{done:!0}:{done:!1,value:z[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=D();function A(z){re.defaults=z}var y=/[&<>"']/,E=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(Y){return C[Y]};function m(z,Y){if(Y){if(y.test(z))return z.replace(E,p)}else if(I.test(z))return z.replace(k,p);return z}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(z){return z.replace(g,function(Y,_){return _=_.toLowerCase(),_==="colon"?":":_.charAt(0)==="#"?_.charAt(1)==="x"?String.fromCharCode(parseInt(_.substring(2),16)):String.fromCharCode(+_.substring(1)):""})}var d=/(^|[^\[])\^/g;function b(z,Y){z=typeof z=="string"?z:z.source,Y=Y||"";var _={replace:function(q,G){return G=G.source||G,G=G.replace(d,"$1"),z=z.replace(q,G),_},getRegex:function(){return new RegExp(z,Y)}};return _}var c=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(z,Y,_){if(z){var j;try{j=decodeURIComponent(w(_)).replace(c,"").toLowerCase()}catch{return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}Y&&!f.test(_)&&(_=a(Y,_));try{_=encodeURI(_).replace(/%25/g,"%")}catch{return null}return _}var i={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(z,Y){i[" "+z]||(n.test(z)?i[" "+z]=z+"/":i[" "+z]=T(z,"/",!0)),z=i[" "+z];var _=z.indexOf(":")===-1;return Y.substring(0,2)==="//"?_?Y:z.replace(r,"$1")+Y:Y.charAt(0)==="/"?_?Y:z.replace(o,"$1")+Y:z+Y}var l={exec:function(){}};function s(z){for(var Y=1,_,j;Y<arguments.length;Y++){_=arguments[Y];for(j in _)Object.prototype.hasOwnProperty.call(_,j)&&(z[j]=_[j])}return z}function h(z,Y){var _=z.replace(/\|/g,function(G,x,oe){for(var pe=!1,ke=x;--ke>=0&&oe[ke]==="\\";)pe=!pe;return pe?"|":" |"}),j=_.split(/ \|/),q=0;if(j[0].trim()||j.shift(),j.length>0&&!j[j.length-1].trim()&&j.pop(),j.length>Y)j.splice(Y);else for(;j.length<Y;)j.push("");for(;q<j.length;q++)j[q]=j[q].trim().replace(/\\\|/g,"|");return j}function T(z,Y,_){var j=z.length;if(j===0)return"";for(var q=0;q<j;){var G=z.charAt(j-q-1);if(G===Y&&!_)q++;else if(G!==Y&&_)q++;else break}return z.slice(0,j-q)}function F(z,Y){if(z.indexOf(Y[1])===-1)return-1;for(var _=z.length,j=0,q=0;q<_;q++)if(z[q]==="\\")q++;else if(z[q]===Y[0])j++;else if(z[q]===Y[1]&&(j--,j<0))return q;return-1}function Z(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ne(z,Y){if(Y<1)return"";for(var _="";Y>1;)Y&1&&(_+=z),Y>>=1,z+=z;return _+z}function ce(z,Y,_,j){var q=Y.href,G=Y.title?m(Y.title):null,x=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){j.state.inLink=!0;var oe={type:"link",raw:_,href:q,title:G,text:x,tokens:j.inlineTokens(x)};return j.state.inLink=!1,oe}return{type:"image",raw:_,href:q,title:G,text:m(x)}}function ie(z,Y){var _=z.match(/^(\s+)(?:```)/);if(_===null)return Y;var j=_[1];return Y.split(`
`).map(function(q){var G=q.match(/^\s+/);if(G===null)return q;var x=G[0];return x.length>=j.length?q.slice(j.length):q}).join(`
`)}var M=function(){function z(_){this.options=_||re.defaults}var Y=z.prototype;return Y.space=function(j){var q=this.rules.block.newline.exec(j);if(q&&q[0].length>0)return{type:"space",raw:q[0]}},Y.code=function(j){var q=this.rules.block.code.exec(j);if(q){var G=q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:q[0],codeBlockStyle:"indented",text:this.options.pedantic?G:T(G,`
`)}}},Y.fences=function(j){var q=this.rules.block.fences.exec(j);if(q){var G=q[0],x=ie(G,q[3]||"");return{type:"code",raw:G,lang:q[2]?q[2].trim():q[2],text:x}}},Y.heading=function(j){var q=this.rules.block.heading.exec(j);if(q){var G=q[2].trim();if(/#$/.test(G)){var x=T(G,"#");(this.options.pedantic||!x||/ $/.test(x))&&(G=x.trim())}return{type:"heading",raw:q[0],depth:q[1].length,text:G,tokens:this.lexer.inline(G)}}},Y.hr=function(j){var q=this.rules.block.hr.exec(j);if(q)return{type:"hr",raw:q[0]}},Y.blockquote=function(j){var q=this.rules.block.blockquote.exec(j);if(q){var G=q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:q[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},Y.list=function(j){var q=this.rules.block.list.exec(j);if(q){var G,x,oe,pe,ke,Ae,Fe,je,me,ye,Ee,Me,Be=q[1].trim(),Je=Be.length>1,He={type:"list",raw:"",ordered:Je,start:Je?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Je?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Je?Be:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");j&&(Me=!1,!(!(q=Xe.exec(j))||this.rules.block.hr.test(j)));){if(G=q[0],j=j.substring(G.length),je=q[2].split(`
`,1)[0],me=j.split(`
`,1)[0],this.options.pedantic?(pe=2,Ee=je.trimLeft()):(pe=q[2].search(/[^ ]/),pe=pe>4?1:pe,Ee=je.slice(pe),pe+=q[1].length),Ae=!1,!je&&/^ *$/.test(me)&&(G+=me+`
`,j=j.substring(me.length+1),Me=!0),!Me)for(var Ke=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Qe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");j&&(ye=j.split(`
`,1)[0],je=ye,this.options.pedantic&&(je=je.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Qe.test(je)||Ve.test(je)||Ke.test(je)||nt.test(j)));){if(je.search(/[^ ]/)>=pe||!je.trim())Ee+=`
`+je.slice(pe);else if(!Ae)Ee+=`
`+je;else break;!Ae&&!je.trim()&&(Ae=!0),G+=ye+`
`,j=j.substring(ye.length+1)}He.loose||(Fe?He.loose=!0:/\n *\n *$/.test(G)&&(Fe=!0)),this.options.gfm&&(x=/^\[[ xX]\] /.exec(Ee),x&&(oe=x[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:G,task:!!x,checked:oe,loose:!1,text:Ee}),He.raw+=G}He.items[He.items.length-1].raw=G.trimRight(),He.items[He.items.length-1].text=Ee.trimRight(),He.raw=He.raw.trimRight();var Ge=He.items.length;for(ke=0;ke<Ge;ke++){this.lexer.state.top=!1,He.items[ke].tokens=this.lexer.blockTokens(He.items[ke].text,[]);var le=He.items[ke].tokens.filter(function(Ce){return Ce.type==="space"}),De=le.every(function(Ce){for(var Te=Ce.raw.split(""),Ne=0,ze=S(Te),Ye;!(Ye=ze()).done;){var tt=Ye.value;if(tt===`
`&&(Ne+=1),Ne>1)return!0}return!1});!He.loose&&le.length&&De&&(He.loose=!0,He.items[ke].loose=!0)}return He}},Y.html=function(j){var q=this.rules.block.html.exec(j);if(q){var G={type:"html",raw:q[0],pre:!this.options.sanitizer&&(q[1]==="pre"||q[1]==="script"||q[1]==="style"),text:q[0]};if(this.options.sanitize){var x=this.options.sanitizer?this.options.sanitizer(q[0]):m(q[0]);G.type="paragraph",G.text=x,G.tokens=this.lexer.inline(x)}return G}},Y.def=function(j){var q=this.rules.block.def.exec(j);if(q){q[3]&&(q[3]=q[3].substring(1,q[3].length-1));var G=q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:q[0],href:q[2],title:q[3]}}},Y.table=function(j){var q=this.rules.block.table.exec(j);if(q){var G={type:"table",header:h(q[1]).map(function(Fe){return{text:Fe}}),align:q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:q[3]&&q[3].trim()?q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=q[0];var x=G.align.length,oe,pe,ke,Ae;for(oe=0;oe<x;oe++)/^ *-+: *$/.test(G.align[oe])?G.align[oe]="right":/^ *:-+: *$/.test(G.align[oe])?G.align[oe]="center":/^ *:-+ *$/.test(G.align[oe])?G.align[oe]="left":G.align[oe]=null;for(x=G.rows.length,oe=0;oe<x;oe++)G.rows[oe]=h(G.rows[oe],G.header.length).map(function(Fe){return{text:Fe}});for(x=G.header.length,pe=0;pe<x;pe++)G.header[pe].tokens=this.lexer.inline(G.header[pe].text);for(x=G.rows.length,pe=0;pe<x;pe++)for(Ae=G.rows[pe],ke=0;ke<Ae.length;ke++)Ae[ke].tokens=this.lexer.inline(Ae[ke].text);return G}}},Y.lheading=function(j){var q=this.rules.block.lheading.exec(j);if(q)return{type:"heading",raw:q[0],depth:q[2].charAt(0)==="="?1:2,text:q[1],tokens:this.lexer.inline(q[1])}},Y.paragraph=function(j){var q=this.rules.block.paragraph.exec(j);if(q){var G=q[1].charAt(q[1].length-1)===`
`?q[1].slice(0,-1):q[1];return{type:"paragraph",raw:q[0],text:G,tokens:this.lexer.inline(G)}}},Y.text=function(j){var q=this.rules.block.text.exec(j);if(q)return{type:"text",raw:q[0],text:q[0],tokens:this.lexer.inline(q[0])}},Y.escape=function(j){var q=this.rules.inline.escape.exec(j);if(q)return{type:"escape",raw:q[0],text:m(q[1])}},Y.tag=function(j){var q=this.rules.inline.tag.exec(j);if(q)return!this.lexer.state.inLink&&/^<a /i.test(q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(q[0]):m(q[0]):q[0]}},Y.link=function(j){var q=this.rules.inline.link.exec(j);if(q){var G=q[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var x=T(G.slice(0,-1),"\\");if((G.length-x.length)%2===0)return}else{var oe=F(q[2],"()");if(oe>-1){var pe=q[0].indexOf("!")===0?5:4,ke=pe+q[1].length+oe;q[2]=q[2].substring(0,oe),q[0]=q[0].substring(0,ke).trim(),q[3]=""}}var Ae=q[2],Fe="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);je&&(Ae=je[1],Fe=je[3])}else Fe=q[3]?q[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(G)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),ce(q,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},q[0],this.lexer)}},Y.reflink=function(j,q){var G;if((G=this.rules.inline.reflink.exec(j))||(G=this.rules.inline.nolink.exec(j))){var x=(G[2]||G[1]).replace(/\s+/g," ");if(x=q[x.toLowerCase()],!x||!x.href){var oe=G[0].charAt(0);return{type:"text",raw:oe,text:oe}}return ce(G,x,G[0],this.lexer)}},Y.emStrong=function(j,q,G){G===void 0&&(G="");var x=this.rules.inline.emStrong.lDelim.exec(j);if(!!x&&!(x[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var oe=x[1]||x[2]||"";if(!oe||oe&&(G===""||this.rules.inline.punctuation.exec(G))){var pe=x[0].length-1,ke,Ae,Fe=pe,je=0,me=x[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,q=q.slice(-1*j.length+pe);(x=me.exec(q))!=null;)if(ke=x[1]||x[2]||x[3]||x[4]||x[5]||x[6],!!ke){if(Ae=ke.length,x[3]||x[4]){Fe+=Ae;continue}else if((x[5]||x[6])&&pe%3&&!((pe+Ae)%3)){je+=Ae;continue}if(Fe-=Ae,!(Fe>0)){if(Ae=Math.min(Ae,Ae+Fe+je),Math.min(pe,Ae)%2){var ye=j.slice(1,pe+x.index+Ae);return{type:"em",raw:j.slice(0,pe+x.index+Ae+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}var Ee=j.slice(2,pe+x.index+Ae-1);return{type:"strong",raw:j.slice(0,pe+x.index+Ae+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Y.codespan=function(j){var q=this.rules.inline.code.exec(j);if(q){var G=q[2].replace(/\n/g," "),x=/[^ ]/.test(G),oe=/^ /.test(G)&&/ $/.test(G);return x&&oe&&(G=G.substring(1,G.length-1)),G=m(G,!0),{type:"codespan",raw:q[0],text:G}}},Y.br=function(j){var q=this.rules.inline.br.exec(j);if(q)return{type:"br",raw:q[0]}},Y.del=function(j){var q=this.rules.inline.del.exec(j);if(q)return{type:"del",raw:q[0],text:q[2],tokens:this.lexer.inlineTokens(q[2])}},Y.autolink=function(j,q){var G=this.rules.inline.autolink.exec(j);if(G){var x,oe;return G[2]==="@"?(x=m(this.options.mangle?q(G[1]):G[1]),oe="mailto:"+x):(x=m(G[1]),oe=x),{type:"link",raw:G[0],text:x,href:oe,tokens:[{type:"text",raw:x,text:x}]}}},Y.url=function(j,q){var G;if(G=this.rules.inline.url.exec(j)){var x,oe;if(G[2]==="@")x=m(this.options.mangle?q(G[0]):G[0]),oe="mailto:"+x;else{var pe;do pe=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(pe!==G[0]);x=m(G[0]),G[1]==="www."?oe="http://"+x:oe=x}return{type:"link",raw:G[0],text:x,href:oe,tokens:[{type:"text",raw:x,text:x}]}}},Y.inlineText=function(j,q){var G=this.rules.inline.text.exec(j);if(G){var x;return this.lexer.state.inRawBlock?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):m(G[0]):G[0]:x=m(this.options.smartypants?q(G[0]):G[0]),{type:"text",raw:G[0],text:x}}},z}(),J={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};J._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,J._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,J.def=b(J.def).replace("label",J._label).replace("title",J._title).getRegex(),J.bullet=/(?:[*+-]|\d{1,9}[.)])/,J.listItemStart=b(/^( *)(bull) */).replace("bull",J.bullet).getRegex(),J.list=b(J.list).replace(/bull/g,J.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+J.def.source+")").getRegex(),J._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",J._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,J.html=b(J.html,"i").replace("comment",J._comment).replace("tag",J._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),J.paragraph=b(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.blockquote=b(J.blockquote).replace("paragraph",J.paragraph).getRegex(),J.normal=s({},J),J.gfm=s({},J.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),J.gfm.table=b(J.gfm.table).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.gfm.paragraph=b(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",J.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.pedantic=s({},J.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",J._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:b(J.normal._paragraph).replace("hr",J.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",J.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var $={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};$._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",$.punctuation=b($.punctuation).replace(/punctuation/g,$._punctuation).getRegex(),$.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,$.escapedEmSt=/\\\*|\\_/g,$._comment=b(J._comment).replace("(?:-->|$)","-->").getRegex(),$.emStrong.lDelim=b($.emStrong.lDelim).replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimAst=b($.emStrong.rDelimAst,"g").replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimUnd=b($.emStrong.rDelimUnd,"g").replace(/punct/g,$._punctuation).getRegex(),$._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,$._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,$._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,$.autolink=b($.autolink).replace("scheme",$._scheme).replace("email",$._email).getRegex(),$._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,$.tag=b($.tag).replace("comment",$._comment).replace("attribute",$._attribute).getRegex(),$._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,$._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,$._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,$.link=b($.link).replace("label",$._label).replace("href",$._href).replace("title",$._title).getRegex(),$.reflink=b($.reflink).replace("label",$._label).replace("ref",J._label).getRegex(),$.nolink=b($.nolink).replace("ref",J._label).getRegex(),$.reflinkSearch=b($.reflinkSearch,"g").replace("reflink",$.reflink).replace("nolink",$.nolink).getRegex(),$.normal=s({},$),$.pedantic=s({},$.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",$._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",$._label).getRegex()}),$.gfm=s({},$.normal,{escape:b($.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),$.gfm.url=b($.gfm.url,"i").replace("email",$.gfm._extended_email).getRegex(),$.breaks=s({},$.gfm,{br:b($.br).replace("{2,}","*").getRegex(),text:b($.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function V(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(z){var Y="",_,j,q=z.length;for(_=0;_<q;_++)j=z.charCodeAt(_),Math.random()>.5&&(j="x"+j.toString(16)),Y+="&#"+j+";";return Y}var ue=function(){function z(_){this.tokens=[],this.tokens.links=Object.create(null),this.options=_||re.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var j={block:J.normal,inline:$.normal};this.options.pedantic?(j.block=J.pedantic,j.inline=$.pedantic):this.options.gfm&&(j.block=J.gfm,this.options.breaks?j.inline=$.breaks:j.inline=$.gfm),this.tokenizer.rules=j}z.lex=function(j,q){var G=new z(q);return G.lex(j)},z.lexInline=function(j,q){var G=new z(q);return G.inlineTokens(j)};var Y=z.prototype;return Y.lex=function(j){j=j.replace(/\r\n|\r/g,`
`),this.blockTokens(j,this.tokens);for(var q;q=this.inlineQueue.shift();)this.inlineTokens(q.src,q.tokens);return this.tokens},Y.blockTokens=function(j,q){var G=this;q===void 0&&(q=[]),this.options.pedantic?j=j.replace(/\t/g,"    ").replace(/^ +$/gm,""):j=j.replace(/^( *)(\t+)/gm,function(Fe,je,me){return je+"    ".repeat(me.length)});for(var x,oe,pe,ke;j;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(x=Fe.call({lexer:G},j,q))?(j=j.substring(x.raw.length),q.push(x),!0):!1}))){if(x=this.tokenizer.space(j)){j=j.substring(x.raw.length),x.raw.length===1&&q.length>0?q[q.length-1].raw+=`
`:q.push(x);continue}if(x=this.tokenizer.code(j)){j=j.substring(x.raw.length),oe=q[q.length-1],oe&&(oe.type==="paragraph"||oe.type==="text")?(oe.raw+=`
`+x.raw,oe.text+=`
`+x.text,this.inlineQueue[this.inlineQueue.length-1].src=oe.text):q.push(x);continue}if(x=this.tokenizer.fences(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.heading(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.hr(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.blockquote(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.list(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.html(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.def(j)){j=j.substring(x.raw.length),oe=q[q.length-1],oe&&(oe.type==="paragraph"||oe.type==="text")?(oe.raw+=`
`+x.raw,oe.text+=`
`+x.raw,this.inlineQueue[this.inlineQueue.length-1].src=oe.text):this.tokens.links[x.tag]||(this.tokens.links[x.tag]={href:x.href,title:x.title});continue}if(x=this.tokenizer.table(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.lheading(j)){j=j.substring(x.raw.length),q.push(x);continue}if(pe=j,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,je=j.slice(1),me=void 0;G.options.extensions.startBlock.forEach(function(ye){me=ye.call({lexer:this},je),typeof me=="number"&&me>=0&&(Fe=Math.min(Fe,me))}),Fe<1/0&&Fe>=0&&(pe=j.substring(0,Fe+1))}(),this.state.top&&(x=this.tokenizer.paragraph(pe))){oe=q[q.length-1],ke&&oe.type==="paragraph"?(oe.raw+=`
`+x.raw,oe.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=oe.text):q.push(x),ke=pe.length!==j.length,j=j.substring(x.raw.length);continue}if(x=this.tokenizer.text(j)){j=j.substring(x.raw.length),oe=q[q.length-1],oe&&oe.type==="text"?(oe.raw+=`
`+x.raw,oe.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=oe.text):q.push(x);continue}if(j){var Ae="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,q},Y.inline=function(j,q){return q===void 0&&(q=[]),this.inlineQueue.push({src:j,tokens:q}),q},Y.inlineTokens=function(j,q){var G=this;q===void 0&&(q=[]);var x,oe,pe,ke=j,Ae,Fe,je;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)me.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ae.index)+"["+ne("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"["+ne("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;)if(Fe||(je=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(x=Ee.call({lexer:G},j,q))?(j=j.substring(x.raw.length),q.push(x),!0):!1}))){if(x=this.tokenizer.escape(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.tag(j)){j=j.substring(x.raw.length),oe=q[q.length-1],oe&&x.type==="text"&&oe.type==="text"?(oe.raw+=x.raw,oe.text+=x.text):q.push(x);continue}if(x=this.tokenizer.link(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(x.raw.length),oe=q[q.length-1],oe&&x.type==="text"&&oe.type==="text"?(oe.raw+=x.raw,oe.text+=x.text):q.push(x);continue}if(x=this.tokenizer.emStrong(j,ke,je)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.codespan(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.br(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.del(j)){j=j.substring(x.raw.length),q.push(x);continue}if(x=this.tokenizer.autolink(j,X)){j=j.substring(x.raw.length),q.push(x);continue}if(!this.state.inLink&&(x=this.tokenizer.url(j,X))){j=j.substring(x.raw.length),q.push(x);continue}if(pe=j,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,Me=j.slice(1),Be=void 0;G.options.extensions.startInline.forEach(function(Je){Be=Je.call({lexer:this},Me),typeof Be=="number"&&Be>=0&&(Ee=Math.min(Ee,Be))}),Ee<1/0&&Ee>=0&&(pe=j.substring(0,Ee+1))}(),x=this.tokenizer.inlineText(pe,V)){j=j.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(je=x.raw.slice(-1)),Fe=!0,oe=q[q.length-1],oe&&oe.type==="text"?(oe.raw+=x.raw,oe.text+=x.text):q.push(x);continue}if(j){var ye="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return q},v(z,null,[{key:"rules",get:function(){return{block:J,inline:$}}}]),z}(),L=function(){function z(_){this.options=_||re.defaults}var Y=z.prototype;return Y.code=function(j,q,G){var x=(q||"").match(/\S*/)[0];if(this.options.highlight){var oe=this.options.highlight(j,x);oe!=null&&oe!==j&&(G=!0,j=oe)}return j=j.replace(/\n$/,"")+`
`,x?'<pre><code class="'+this.options.langPrefix+m(x,!0)+'">'+(G?j:m(j,!0))+`</code></pre>
`:"<pre><code>"+(G?j:m(j,!0))+`</code></pre>
`},Y.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},Y.html=function(j){return j},Y.heading=function(j,q,G,x){if(this.options.headerIds){var oe=this.options.headerPrefix+x.slug(G);return"<h"+q+' id="'+oe+'">'+j+"</h"+q+`>
`}return"<h"+q+">"+j+"</h"+q+`>
`},Y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Y.list=function(j,q,G){var x=q?"ol":"ul",oe=q&&G!==1?' start="'+G+'"':"";return"<"+x+oe+`>
`+j+"</"+x+`>
`},Y.listitem=function(j){return"<li>"+j+`</li>
`},Y.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Y.paragraph=function(j){return"<p>"+j+`</p>
`},Y.table=function(j,q){return q&&(q="<tbody>"+q+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+q+`</table>
`},Y.tablerow=function(j){return`<tr>
`+j+`</tr>
`},Y.tablecell=function(j,q){var G=q.header?"th":"td",x=q.align?"<"+G+' align="'+q.align+'">':"<"+G+">";return x+j+("</"+G+`>
`)},Y.strong=function(j){return"<strong>"+j+"</strong>"},Y.em=function(j){return"<em>"+j+"</em>"},Y.codespan=function(j){return"<code>"+j+"</code>"},Y.br=function(){return this.options.xhtml?"<br/>":"<br>"},Y.del=function(j){return"<del>"+j+"</del>"},Y.link=function(j,q,G){if(j=u(this.options.sanitize,this.options.baseUrl,j),j===null)return G;var x='<a href="'+m(j)+'"';return q&&(x+=' title="'+q+'"'),x+=">"+G+"</a>",x},Y.image=function(j,q,G){if(j=u(this.options.sanitize,this.options.baseUrl,j),j===null)return G;var x='<img src="'+j+'" alt="'+G+'"';return q&&(x+=' title="'+q+'"'),x+=this.options.xhtml?"/>":">",x},Y.text=function(j){return j},z}(),N=function(){function z(){}var Y=z.prototype;return Y.strong=function(j){return j},Y.em=function(j){return j},Y.codespan=function(j){return j},Y.del=function(j){return j},Y.html=function(j){return j},Y.text=function(j){return j},Y.link=function(j,q,G){return""+G},Y.image=function(j,q,G){return""+G},Y.br=function(){return""},z}(),H=function(){function z(){this.seen={}}var Y=z.prototype;return Y.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Y.getNextSafeSlug=function(j,q){var G=j,x=0;if(this.seen.hasOwnProperty(G)){x=this.seen[j];do x++,G=j+"-"+x;while(this.seen.hasOwnProperty(G))}return q||(this.seen[j]=x,this.seen[G]=0),G},Y.slug=function(j,q){q===void 0&&(q={});var G=this.serialize(j);return this.getNextSafeSlug(G,q.dryrun)},z}(),ee=function(){function z(_){this.options=_||re.defaults,this.options.renderer=this.options.renderer||new L,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new N,this.slugger=new H}z.parse=function(j,q){var G=new z(q);return G.parse(j)},z.parseInline=function(j,q){var G=new z(q);return G.parseInline(j)};var Y=z.prototype;return Y.parse=function(j,q){q===void 0&&(q=!0);var G="",x,oe,pe,ke,Ae,Fe,je,me,ye,Ee,Me,Be,Je,He,Xe,Ke,nt,Qe,Ve,Ge=j.length;for(x=0;x<Ge;x++){if(Ee=j[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(Ve=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){G+=Ve||"";continue}switch(Ee.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,w(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(me="",je="",ke=Ee.header.length,oe=0;oe<ke;oe++)je+=this.renderer.tablecell(this.parseInline(Ee.header[oe].tokens),{header:!0,align:Ee.align[oe]});for(me+=this.renderer.tablerow(je),ye="",ke=Ee.rows.length,oe=0;oe<ke;oe++){for(Fe=Ee.rows[oe],je="",Ae=Fe.length,pe=0;pe<Ae;pe++)je+=this.renderer.tablecell(this.parseInline(Fe[pe].tokens),{header:!1,align:Ee.align[pe]});ye+=this.renderer.tablerow(je)}G+=this.renderer.table(me,ye);continue}case"blockquote":{ye=this.parse(Ee.tokens),G+=this.renderer.blockquote(ye);continue}case"list":{for(Me=Ee.ordered,Be=Ee.start,Je=Ee.loose,ke=Ee.items.length,ye="",oe=0;oe<ke;oe++)Xe=Ee.items[oe],Ke=Xe.checked,nt=Xe.task,He="",Xe.task&&(Qe=this.renderer.checkbox(Ke),Je?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=Qe+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=Qe+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:Qe}):He+=Qe),He+=this.parse(Xe.tokens,Je),ye+=this.renderer.listitem(He,nt,Ke);G+=this.renderer.list(ye,Me,Be);continue}case"html":{G+=this.renderer.html(Ee.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ye=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;x+1<Ge&&j[x+1].type==="text";)Ee=j[++x],ye+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);G+=q?this.renderer.paragraph(ye):ye;continue}default:{var le='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(le);return}else throw new Error(le)}}}return G},Y.parseInline=function(j,q){q=q||this.renderer;var G="",x,oe,pe,ke=j.length;for(x=0;x<ke;x++){if(oe=j[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[oe.type]&&(pe=this.options.extensions.renderers[oe.type].call({parser:this},oe),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(oe.type))){G+=pe||"";continue}switch(oe.type){case"escape":{G+=q.text(oe.text);break}case"html":{G+=q.html(oe.text);break}case"link":{G+=q.link(oe.href,oe.title,this.parseInline(oe.tokens,q));break}case"image":{G+=q.image(oe.href,oe.title,oe.text);break}case"strong":{G+=q.strong(this.parseInline(oe.tokens,q));break}case"em":{G+=q.em(this.parseInline(oe.tokens,q));break}case"codespan":{G+=q.codespan(oe.text);break}case"br":{G+=q.br();break}case"del":{G+=q.del(this.parseInline(oe.tokens,q));break}case"text":{G+=q.text(oe.text);break}default:{var Ae='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return G},z}();function ae(z,Y,_){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof Y=="function"&&(_=Y,Y=null),Y=s({},ae.defaults,Y||{}),Z(Y),_){var j=Y.highlight,q;try{q=ue.lex(z,Y)}catch(ke){return _(ke)}var G=function(Ae){var Fe;if(!Ae)try{Y.walkTokens&&ae.walkTokens(q,Y.walkTokens),Fe=ee.parse(q,Y)}catch(je){Ae=je}return Y.highlight=j,Ae?_(Ae):_(null,Fe)};if(!j||j.length<3||(delete Y.highlight,!q.length))return G();var x=0;ae.walkTokens(q,function(ke){ke.type==="code"&&(x++,setTimeout(function(){j(ke.text,ke.lang,function(Ae,Fe){if(Ae)return G(Ae);Fe!=null&&Fe!==ke.text&&(ke.text=Fe,ke.escaped=!0),x--,x===0&&G()})},0))}),x===0&&G();return}function oe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+m(ke.message+"",!0)+"</pre>";throw ke}try{var pe=ue.lex(z,Y);if(Y.walkTokens){if(Y.async)return Promise.all(ae.walkTokens(pe,Y.walkTokens)).then(function(){return ee.parse(pe,Y)}).catch(oe);ae.walkTokens(pe,Y.walkTokens)}return ee.parse(pe,Y)}catch(ke){oe(ke)}}ae.options=ae.setOptions=function(z){return s(ae.defaults,z),A(ae.defaults),ae},ae.getDefaults=D,ae.defaults=re.defaults,ae.use=function(){for(var z=arguments.length,Y=new Array(z),_=0;_<z;_++)Y[_]=arguments[_];var j=s.apply(void 0,[{}].concat(Y)),q=ae.defaults.extensions||{renderers:{},childTokens:{}},G;Y.forEach(function(x){if(x.extensions&&(G=!0,x.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var ke=q.renderers?q.renderers[pe.name]:null;ke?q.renderers[pe.name]=function(){for(var Ae=arguments.length,Fe=new Array(Ae),je=0;je<Ae;je++)Fe[je]=arguments[je];var me=pe.renderer.apply(this,Fe);return me===!1&&(me=ke.apply(this,Fe)),me}:q.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");q[pe.level]?q[pe.level].unshift(pe.tokenizer):q[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?q.startBlock?q.startBlock.push(pe.start):q.startBlock=[pe.start]:pe.level==="inline"&&(q.startInline?q.startInline.push(pe.start):q.startInline=[pe.start]))}pe.childTokens&&(q.childTokens[pe.name]=pe.childTokens)})),x.renderer&&function(){var pe=ae.defaults.renderer||new L,ke=function(je){var me=pe[je];pe[je]=function(){for(var ye=arguments.length,Ee=new Array(ye),Me=0;Me<ye;Me++)Ee[Me]=arguments[Me];var Be=x.renderer[je].apply(pe,Ee);return Be===!1&&(Be=me.apply(pe,Ee)),Be}};for(var Ae in x.renderer)ke(Ae);j.renderer=pe}(),x.tokenizer&&function(){var pe=ae.defaults.tokenizer||new M,ke=function(je){var me=pe[je];pe[je]=function(){for(var ye=arguments.length,Ee=new Array(ye),Me=0;Me<ye;Me++)Ee[Me]=arguments[Me];var Be=x.tokenizer[je].apply(pe,Ee);return Be===!1&&(Be=me.apply(pe,Ee)),Be}};for(var Ae in x.tokenizer)ke(Ae);j.tokenizer=pe}(),x.walkTokens){var oe=ae.defaults.walkTokens;j.walkTokens=function(pe){var ke=[];return ke.push(x.walkTokens.call(this,pe)),oe&&(ke=ke.concat(oe.call(this,pe))),ke}}G&&(j.extensions=q),ae.setOptions(j)})},ae.walkTokens=function(z,Y){for(var _=[],j=function(){var oe=G.value;switch(_=_.concat(Y.call(ae,oe)),oe.type){case"table":{for(var pe=S(oe.header),ke;!(ke=pe()).done;){var Ae=ke.value;_=_.concat(ae.walkTokens(Ae.tokens,Y))}for(var Fe=S(oe.rows),je;!(je=Fe()).done;)for(var me=je.value,ye=S(me),Ee;!(Ee=ye()).done;){var Me=Ee.value;_=_.concat(ae.walkTokens(Me.tokens,Y))}break}case"list":{_=_.concat(ae.walkTokens(oe.items,Y));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[oe.type]?ae.defaults.extensions.childTokens[oe.type].forEach(function(Be){_=_.concat(ae.walkTokens(oe[Be],Y))}):oe.tokens&&(_=_.concat(ae.walkTokens(oe.tokens,Y)))}},q=S(z),G;!(G=q()).done;)j();return _},ae.parseInline=function(z,Y){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");Y=s({},ae.defaults,Y||{}),Z(Y);try{var _=ue.lexInline(z,Y);return Y.walkTokens&&ae.walkTokens(_,Y.walkTokens),ee.parseInline(_,Y)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+m(j.message+"",!0)+"</pre>";throw j}},ae.Parser=ee,ae.parser=ee.parse,ae.Renderer=L,ae.TextRenderer=N,ae.Lexer=ue,ae.lexer=ue.lex,ae.Tokenizer=M,ae.Slugger=H,ae.parse=ae;var ge=ae.options,fe=ae.setOptions,R=ae.use,U=ae.walkTokens,W=ae.parseInline,Q=ae,se=ee.parse,de=ue.lex;re.Lexer=ue,re.Parser=ee,re.Renderer=L,re.Slugger=H,re.TextRenderer=N,re.Tokenizer=M,re.getDefaults=D,re.lexer=de,re.marked=ae,re.options=ge,re.parse=Q,re.parseInline=W,re.parser=se,re.setOptions=fe,re.use=R,re.walkTokens=U,Object.defineProperty(re,"__esModule",{value:!0})}),define(be[88],ve([1,0,26]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function P(E){return y(E,"NFC",t)}e.normalizeNFC=P;const S=new v.LRUCache(1e4);function D(E){return y(E,"NFD",S)}e.normalizeNFD=D;const A=/[^\u0000-\u0080]/;function y(E,I,k){if(!E)return E;const C=k.get(E);if(C)return C;let p;return A.test(E)?p=E.normalize(I):p=E,k.set(E,p),p}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(I){return D(I).replace(E,"")}}()}),function(){function re(P){const S=[];typeof P=="number"&&S.push("code/timeOrigin",P);function D(y){S.push(y,Date.now())}function A(){const y=[];for(let E=0;E<S.length;E+=2)y.push({name:S[E],startTime:S[E+1]});return y}return{mark:D,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const D of performance.getEntriesByType("mark"))S.push({name:D.name,startTime:Math.round(P+D.startTime)});return S}};if(typeof process=="object"){const P=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),define(be[3],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let v=!1,t=!1,P=!1,S=!1,D=!1,A=!1,y=!1,E=!1,I=!1,k=!1,C,p=e.LANGUAGE_DEFAULT,m,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?w=e.globals.vscode.process:typeof process<"u"&&(w=process);const d=typeof w?.versions?.electron=="string",b=d&&w?.type==="renderer";if(typeof navigator=="object"&&!b){g=navigator.userAgent,v=g.indexOf("Windows")>=0,t=g.indexOf("Macintosh")>=0,E=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=g.indexOf("Linux")>=0,k=g?.indexOf("Mobi")>=0,A=!0,C=e.LANGUAGE_DEFAULT,p=C;const l=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),s=l&&l.getAttribute("data-settings");if(s)try{const h=JSON.parse(s);C=h.locale,m=h._translationsConfigFile,p=h.availableLanguages["*"]||e.LANGUAGE_DEFAULT}catch{}}else if(typeof w=="object"){v=w.platform==="win32",t=w.platform==="darwin",P=w.platform==="linux",S=P&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,y=d,I=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const l=w.env.VSCODE_NLS_CONFIG;if(l)try{const s=JSON.parse(l),h=s.availableLanguages["*"];C=s.locale,p=h||e.LANGUAGE_DEFAULT,m=s._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var c;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function f(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let u=0;t?u=1:v?u=3:P&&(u=2),e.isWindows=v,e.isMacintosh=t,e.isLinux=P,e.isLinuxSnap=S,e.isNative=D,e.isElectron=y,e.isWeb=A,e.isWebWorker=A&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isMobile=k,e.isCI=I,e.platform=u,e.userAgent=g,e.language=p;var i;(function(l){function s(){return e.language}l.value=s;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=h;function T(){return e.language==="en"}l.isDefault=T})(i=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let T=0,F=l.length;T<F;T++){const Z=l[T];if(Z.id===h.data.vscodeScheduleAsyncWork){l.splice(T,1),Z.callback();return}}});let s=0;return h=>{const T=++s;l.push({id:T,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return l=>setTimeout(l)})();var n;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=t||E?2:v?1:3;let r=!0,o=!1;function a(){if(!o){o=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,r=new Uint16Array(l.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(be[27],ve([1,0,3]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const P=v.globals.vscode.process;t={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(be[7],ve([1,0,27]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,P=97,S=90,D=122,A=46,y=47,E=92,I=58,k=63;class C extends Error{constructor(f,u,i){let n;typeof u=="string"&&u.indexOf("not ")===0?(n="must not be",u=u.replace(/^not /,"")):n="must be";const r=f.indexOf(".")!==-1?"property":"argument";let o=`The "${f}" ${r} ${n} of type ${u}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function p(c,f){if(typeof c!="string")throw new C(f,"string",c)}function m(c){return c===y||c===E}function g(c){return c===y}function w(c){return c>=t&&c<=S||c>=P&&c<=D}function d(c,f,u,i){let n="",r=0,o=-1,a=0,l=0;for(let s=0;s<=c.length;++s){if(s<c.length)l=c.charCodeAt(s);else{if(i(l))break;l=y}if(i(l)){if(!(o===s-1||a===1))if(a===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==A||n.charCodeAt(n.length-2)!==A){if(n.length>2){const h=n.lastIndexOf(u);h===-1?(n="",r=0):(n=n.slice(0,h),r=n.length-1-n.lastIndexOf(u)),o=s,a=0;continue}else if(n.length!==0){n="",r=0,o=s,a=0;continue}}f&&(n+=n.length>0?`${u}..`:"..",r=2)}else n.length>0?n+=`${u}${c.slice(o+1,s)}`:n=c.slice(o+1,s),r=s-o-1;o=s,a=0}else l===A&&a!==-1?++a:a=-1}return n}function b(c,f){if(f===null||typeof f!="object")throw new C("pathObject","Object",f);const u=f.dir||f.root,i=f.base||`${f.name||""}${f.ext||""}`;return u?u===f.root?`${u}${i}`:`${u}${c}${i}`:i}e.win32={resolve(...c){let f="",u="",i=!1;for(let n=c.length-1;n>=-1;n--){let r;if(n>=0){if(r=c[n],p(r,"path"),r.length===0)continue}else f.length===0?r=v.cwd():(r=v.env[`=${f}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==f.toLowerCase()&&r.charCodeAt(2)===E)&&(r=`${f}\\`));const o=r.length;let a=0,l="",s=!1;const h=r.charCodeAt(0);if(o===1)m(h)&&(a=1,s=!0);else if(m(h))if(s=!0,m(r.charCodeAt(1))){let T=2,F=T;for(;T<o&&!m(r.charCodeAt(T));)T++;if(T<o&&T!==F){const Z=r.slice(F,T);for(F=T;T<o&&m(r.charCodeAt(T));)T++;if(T<o&&T!==F){for(F=T;T<o&&!m(r.charCodeAt(T));)T++;(T===o||T!==F)&&(l=`\\\\${Z}\\${r.slice(F,T)}`,a=T)}}}else a=1;else w(h)&&r.charCodeAt(1)===I&&(l=r.slice(0,2),a=2,o>2&&m(r.charCodeAt(2))&&(s=!0,a=3));if(l.length>0)if(f.length>0){if(l.toLowerCase()!==f.toLowerCase())continue}else f=l;if(i){if(f.length>0)break}else if(u=`${r.slice(a)}\\${u}`,i=s,s&&f.length>0)break}return u=d(u,!i,"\\",m),i?`${f}\\${u}`:`${f}${u}`||"."},normalize(c){p(c,"path");const f=c.length;if(f===0)return".";let u=0,i,n=!1;const r=c.charCodeAt(0);if(f===1)return g(r)?"\\":c;if(m(r))if(n=!0,m(c.charCodeAt(1))){let a=2,l=a;for(;a<f&&!m(c.charCodeAt(a));)a++;if(a<f&&a!==l){const s=c.slice(l,a);for(l=a;a<f&&m(c.charCodeAt(a));)a++;if(a<f&&a!==l){for(l=a;a<f&&!m(c.charCodeAt(a));)a++;if(a===f)return`\\\\${s}\\${c.slice(l)}\\`;a!==l&&(i=`\\\\${s}\\${c.slice(l,a)}`,u=a)}}}else u=1;else w(r)&&c.charCodeAt(1)===I&&(i=c.slice(0,2),u=2,f>2&&m(c.charCodeAt(2))&&(n=!0,u=3));let o=u<f?d(c.slice(u),!n,"\\",m):"";return o.length===0&&!n&&(o="."),o.length>0&&m(c.charCodeAt(f-1))&&(o+="\\"),i===void 0?n?`\\${o}`:o:n?`${i}\\${o}`:`${i}${o}`},isAbsolute(c){p(c,"path");const f=c.length;if(f===0)return!1;const u=c.charCodeAt(0);return m(u)||f>2&&w(u)&&c.charCodeAt(1)===I&&m(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let f,u;for(let r=0;r<c.length;++r){const o=c[r];p(o,"path"),o.length>0&&(f===void 0?f=u=o:f+=`\\${o}`)}if(f===void 0)return".";let i=!0,n=0;if(typeof u=="string"&&m(u.charCodeAt(0))){++n;const r=u.length;r>1&&m(u.charCodeAt(1))&&(++n,r>2&&(m(u.charCodeAt(2))?++n:i=!1))}if(i){for(;n<f.length&&m(f.charCodeAt(n));)n++;n>=2&&(f=`\\${f.slice(n)}`)}return e.win32.normalize(f)},relative(c,f){if(p(c,"from"),p(f,"to"),c===f)return"";const u=e.win32.resolve(c),i=e.win32.resolve(f);if(u===i||(c=u.toLowerCase(),f=i.toLowerCase(),c===f))return"";let n=0;for(;n<c.length&&c.charCodeAt(n)===E;)n++;let r=c.length;for(;r-1>n&&c.charCodeAt(r-1)===E;)r--;const o=r-n;let a=0;for(;a<f.length&&f.charCodeAt(a)===E;)a++;let l=f.length;for(;l-1>a&&f.charCodeAt(l-1)===E;)l--;const s=l-a,h=o<s?o:s;let T=-1,F=0;for(;F<h;F++){const ne=c.charCodeAt(n+F);if(ne!==f.charCodeAt(a+F))break;ne===E&&(T=F)}if(F!==h){if(T===-1)return i}else{if(s>h){if(f.charCodeAt(a+F)===E)return i.slice(a+F+1);if(F===2)return i.slice(a+F)}o>h&&(c.charCodeAt(n+F)===E?T=F:F===2&&(T=3)),T===-1&&(T=0)}let Z="";for(F=n+T+1;F<=r;++F)(F===r||c.charCodeAt(F)===E)&&(Z+=Z.length===0?"..":"\\..");return a+=T,Z.length>0?`${Z}${i.slice(a,l)}`:(i.charCodeAt(a)===E&&++a,i.slice(a,l))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const f=e.win32.resolve(c);if(f.length<=2)return c;if(f.charCodeAt(0)===E){if(f.charCodeAt(1)===E){const u=f.charCodeAt(2);if(u!==k&&u!==A)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(w(f.charCodeAt(0))&&f.charCodeAt(1)===I&&f.charCodeAt(2)===E)return`\\\\?\\${f}`;return c},dirname(c){p(c,"path");const f=c.length;if(f===0)return".";let u=-1,i=0;const n=c.charCodeAt(0);if(f===1)return m(n)?c:".";if(m(n)){if(u=i=1,m(c.charCodeAt(1))){let a=2,l=a;for(;a<f&&!m(c.charCodeAt(a));)a++;if(a<f&&a!==l){for(l=a;a<f&&m(c.charCodeAt(a));)a++;if(a<f&&a!==l){for(l=a;a<f&&!m(c.charCodeAt(a));)a++;if(a===f)return c;a!==l&&(u=i=a+1)}}}}else w(n)&&c.charCodeAt(1)===I&&(u=f>2&&m(c.charCodeAt(2))?3:2,i=u);let r=-1,o=!0;for(let a=f-1;a>=i;--a)if(m(c.charCodeAt(a))){if(!o){r=a;break}}else o=!1;if(r===-1){if(u===-1)return".";r=u}return c.slice(0,r)},basename(c,f){f!==void 0&&p(f,"ext"),p(c,"path");let u=0,i=-1,n=!0,r;if(c.length>=2&&w(c.charCodeAt(0))&&c.charCodeAt(1)===I&&(u=2),f!==void 0&&f.length>0&&f.length<=c.length){if(f===c)return"";let o=f.length-1,a=-1;for(r=c.length-1;r>=u;--r){const l=c.charCodeAt(r);if(m(l)){if(!n){u=r+1;break}}else a===-1&&(n=!1,a=r+1),o>=0&&(l===f.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=a))}return u===i?i=a:i===-1&&(i=c.length),c.slice(u,i)}for(r=c.length-1;r>=u;--r)if(m(c.charCodeAt(r))){if(!n){u=r+1;break}}else i===-1&&(n=!1,i=r+1);return i===-1?"":c.slice(u,i)},extname(c){p(c,"path");let f=0,u=-1,i=0,n=-1,r=!0,o=0;c.length>=2&&c.charCodeAt(1)===I&&w(c.charCodeAt(0))&&(f=i=2);for(let a=c.length-1;a>=f;--a){const l=c.charCodeAt(a);if(m(l)){if(!r){i=a+1;break}continue}n===-1&&(r=!1,n=a+1),l===A?u===-1?u=a:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||n===-1||o===0||o===1&&u===n-1&&u===i+1?"":c.slice(u,n)},format:b.bind(null,"\\"),parse(c){p(c,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return f;const u=c.length;let i=0,n=c.charCodeAt(0);if(u===1)return m(n)?(f.root=f.dir=c,f):(f.base=f.name=c,f);if(m(n)){if(i=1,m(c.charCodeAt(1))){let T=2,F=T;for(;T<u&&!m(c.charCodeAt(T));)T++;if(T<u&&T!==F){for(F=T;T<u&&m(c.charCodeAt(T));)T++;if(T<u&&T!==F){for(F=T;T<u&&!m(c.charCodeAt(T));)T++;T===u?i=T:T!==F&&(i=T+1)}}}}else if(w(n)&&c.charCodeAt(1)===I){if(u<=2)return f.root=f.dir=c,f;if(i=2,m(c.charCodeAt(2))){if(u===3)return f.root=f.dir=c,f;i=3}}i>0&&(f.root=c.slice(0,i));let r=-1,o=i,a=-1,l=!0,s=c.length-1,h=0;for(;s>=i;--s){if(n=c.charCodeAt(s),m(n)){if(!l){o=s+1;break}continue}a===-1&&(l=!1,a=s+1),n===A?r===-1?r=s:h!==1&&(h=1):r!==-1&&(h=-1)}return a!==-1&&(r===-1||h===0||h===1&&r===a-1&&r===o+1?f.base=f.name=c.slice(o,a):(f.name=c.slice(o,r),f.base=c.slice(o,a),f.ext=c.slice(r,a))),o>0&&o!==i?f.dir=c.slice(0,o-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let f="",u=!1;for(let i=c.length-1;i>=-1&&!u;i--){const n=i>=0?c[i]:v.cwd();p(n,"path"),n.length!==0&&(f=`${n}/${f}`,u=n.charCodeAt(0)===y)}return f=d(f,!u,"/",g),u?`/${f}`:f.length>0?f:"."},normalize(c){if(p(c,"path"),c.length===0)return".";const f=c.charCodeAt(0)===y,u=c.charCodeAt(c.length-1)===y;return c=d(c,!f,"/",g),c.length===0?f?"/":u?"./":".":(u&&(c+="/"),f?`/${c}`:c)},isAbsolute(c){return p(c,"path"),c.length>0&&c.charCodeAt(0)===y},join(...c){if(c.length===0)return".";let f;for(let u=0;u<c.length;++u){const i=c[u];p(i,"path"),i.length>0&&(f===void 0?f=i:f+=`/${i}`)}return f===void 0?".":e.posix.normalize(f)},relative(c,f){if(p(c,"from"),p(f,"to"),c===f||(c=e.posix.resolve(c),f=e.posix.resolve(f),c===f))return"";const u=1,i=c.length,n=i-u,r=1,o=f.length-r,a=n<o?n:o;let l=-1,s=0;for(;s<a;s++){const T=c.charCodeAt(u+s);if(T!==f.charCodeAt(r+s))break;T===y&&(l=s)}if(s===a)if(o>a){if(f.charCodeAt(r+s)===y)return f.slice(r+s+1);if(s===0)return f.slice(r+s)}else n>a&&(c.charCodeAt(u+s)===y?l=s:s===0&&(l=0));let h="";for(s=u+l+1;s<=i;++s)(s===i||c.charCodeAt(s)===y)&&(h+=h.length===0?"..":"/..");return`${h}${f.slice(r+l)}`},toNamespacedPath(c){return c},dirname(c){if(p(c,"path"),c.length===0)return".";const f=c.charCodeAt(0)===y;let u=-1,i=!0;for(let n=c.length-1;n>=1;--n)if(c.charCodeAt(n)===y){if(!i){u=n;break}}else i=!1;return u===-1?f?"/":".":f&&u===1?"//":c.slice(0,u)},basename(c,f){f!==void 0&&p(f,"ext"),p(c,"path");let u=0,i=-1,n=!0,r;if(f!==void 0&&f.length>0&&f.length<=c.length){if(f===c)return"";let o=f.length-1,a=-1;for(r=c.length-1;r>=0;--r){const l=c.charCodeAt(r);if(l===y){if(!n){u=r+1;break}}else a===-1&&(n=!1,a=r+1),o>=0&&(l===f.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=a))}return u===i?i=a:i===-1&&(i=c.length),c.slice(u,i)}for(r=c.length-1;r>=0;--r)if(c.charCodeAt(r)===y){if(!n){u=r+1;break}}else i===-1&&(n=!1,i=r+1);return i===-1?"":c.slice(u,i)},extname(c){p(c,"path");let f=-1,u=0,i=-1,n=!0,r=0;for(let o=c.length-1;o>=0;--o){const a=c.charCodeAt(o);if(a===y){if(!n){u=o+1;break}continue}i===-1&&(n=!1,i=o+1),a===A?f===-1?f=o:r!==1&&(r=1):f!==-1&&(r=-1)}return f===-1||i===-1||r===0||r===1&&f===i-1&&f===u+1?"":c.slice(f,i)},format:b.bind(null,"/"),parse(c){p(c,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return f;const u=c.charCodeAt(0)===y;let i;u?(f.root="/",i=1):i=0;let n=-1,r=0,o=-1,a=!0,l=c.length-1,s=0;for(;l>=i;--l){const h=c.charCodeAt(l);if(h===y){if(!a){r=l+1;break}continue}o===-1&&(a=!1,o=l+1),h===A?n===-1?n=l:s!==1&&(s=1):n!==-1&&(s=-1)}if(o!==-1){const h=r===0&&u?1:r;n===-1||s===0||s===1&&n===o-1&&n===r+1?f.base=f.name=c.slice(h,o):(f.name=c.slice(h,n),f.base=c.slice(h,o),f.ext=c.slice(n,o))}return r>0?f.dir=c.slice(0,r-1):u&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[56],ve([1,0,7]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(I){const k=(0,v.extname)(I),C=t[k.toLowerCase()];return C!==void 0?C:D(I)}e.getMediaOrTextMime=S;function D(I){const k=(0,v.extname)(I);return P[k.toLowerCase()]}e.getMediaMime=D;function A(I){for(const k in P)if(P[k]===I)return k}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function E(I,k){const C=y.exec(I);return C?`${C[1].toLowerCase()}/${C[2].toLowerCase()}${C[3]??""}`:k?void 0:I}e.normalizeMimeType=E}),define(be[57],ve([1,0,3]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var P;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function S(A,...y){const E=y.reduce((C,p)=>(C[p]=!0,C),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(A).filter(C=>!E[C]).forEach(C=>{for(let p=0;p<I.length;p++)if(C.search(I[p])!==-1){delete A[C];break}})}e.sanitizeProcessEnvironment=S;function D(A){!A||(delete A.DEBUG,v.isMacintosh&&delete A.DYLD_LIBRARY_PATH,v.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:re)[t]=v[t]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function v(t){if(e[t])return e[t].exports;var P=e[t]={i:t,l:!1,exports:{}};return re[t].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=re,v.c=e,v.d=function(t,P,S){v.o(t,P)||Object.defineProperty(t,P,{enumerable:!0,get:S})},v.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,P){if(1&P&&(t=v(t)),8&P||4&P&&typeof t=="object"&&t&&t.__esModule)return t;var S=Object.create(null);if(v.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:t}),2&P&&typeof t!="string")for(var D in t)v.d(S,D,function(A){return t[A]}.bind(null,D));return S},v.n=function(t){var P=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(P,"a",P),P},v.o=function(t,P){return Object.prototype.hasOwnProperty.call(t,P)},v.p="",v(v.s=0)}([function(re,e,v){(function(t){var P;e=re.exports=R,P=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var S=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],E=0,I=E++;y[I]="0|[1-9]\\d*";var k=E++;y[k]="[0-9]+";var C=E++;y[C]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=E++;y[p]="("+y[I]+")\\.("+y[I]+")\\.("+y[I]+")";var m=E++;y[m]="("+y[k]+")\\.("+y[k]+")\\.("+y[k]+")";var g=E++;y[g]="(?:"+y[I]+"|"+y[C]+")";var w=E++;y[w]="(?:"+y[k]+"|"+y[C]+")";var d=E++;y[d]="(?:-("+y[g]+"(?:\\."+y[g]+")*))";var b=E++;y[b]="(?:-?("+y[w]+"(?:\\."+y[w]+")*))";var c=E++;y[c]="[0-9A-Za-z-]+";var f=E++;y[f]="(?:\\+("+y[c]+"(?:\\."+y[c]+")*))";var u=E++,i="v?"+y[p]+y[d]+"?"+y[f]+"?";y[u]="^"+i+"$";var n="[v=\\s]*"+y[m]+y[b]+"?"+y[f]+"?",r=E++;y[r]="^"+n+"$";var o=E++;y[o]="((?:<|>)?=?)";var a=E++;y[a]=y[k]+"|x|X|\\*";var l=E++;y[l]=y[I]+"|x|X|\\*";var s=E++;y[s]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[d]+")?"+y[f]+"?)?)?";var h=E++;y[h]="[v=\\s]*("+y[a]+")(?:\\.("+y[a]+")(?:\\.("+y[a]+")(?:"+y[b]+")?"+y[f]+"?)?)?";var T=E++;y[T]="^"+y[o]+"\\s*"+y[s]+"$";var F=E++;y[F]="^"+y[o]+"\\s*"+y[h]+"$";var Z=E++;y[Z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var ne=E++;y[ne]="(?:~>?)";var ce=E++;y[ce]="(\\s*)"+y[ne]+"\\s+",A[ce]=new RegExp(y[ce],"g");var ie=E++;y[ie]="^"+y[ne]+y[s]+"$";var M=E++;y[M]="^"+y[ne]+y[h]+"$";var J=E++;y[J]="(?:\\^)";var $=E++;y[$]="(\\s*)"+y[J]+"\\s+",A[$]=new RegExp(y[$],"g");var V=E++;y[V]="^"+y[J]+y[s]+"$";var X=E++;y[X]="^"+y[J]+y[h]+"$";var ue=E++;y[ue]="^"+y[o]+"\\s*("+n+")$|^$";var L=E++;y[L]="^"+y[o]+"\\s*("+i+")$|^$";var N=E++;y[N]="(\\s*)"+y[o]+"\\s*("+n+"|"+y[s]+")",A[N]=new RegExp(y[N],"g");var H=E++;y[H]="^\\s*("+y[s]+")\\s+-\\s+("+y[s]+")\\s*$";var ee=E++;y[ee]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var ae=E++;y[ae]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)P(ge,y[ge]),A[ge]||(A[ge]=new RegExp(y[ge]));function fe(me,ye){if(me instanceof R)return me;if(typeof me!="string"||me.length>S||!(ye?A[r]:A[u]).test(me))return null;try{return new R(me,ye)}catch{return null}}function R(me,ye){if(me instanceof R){if(me.loose===ye)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof R))return new R(me,ye);P("SemVer",me,ye),this.loose=ye;var Ee=me.trim().match(ye?A[r]:A[u]);if(!Ee)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Be=+Me;if(Be>=0&&Be<D)return Be}return Me}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=fe,e.valid=function(me,ye){var Ee=fe(me,ye);return Ee?Ee.version:null},e.clean=function(me,ye){var Ee=fe(me.trim().replace(/^[=v]+/,""),ye);return Ee?Ee.version:null},e.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(me){return P("SemVer.compare",this.version,this.loose,me),me instanceof R||(me=new R(me,this.loose)),this.compareMain(me)||this.comparePre(me)},R.prototype.compareMain=function(me){return me instanceof R||(me=new R(me,this.loose)),W(this.major,me.major)||W(this.minor,me.minor)||W(this.patch,me.patch)},R.prototype.comparePre=function(me){if(me instanceof R||(me=new R(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var ye=0;do{var Ee=this.prerelease[ye],Me=me.prerelease[ye];if(P("prerelease compare",ye,Ee,Me),Ee===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==Me)return W(Ee,Me)}while(++ye)},R.prototype.inc=function(me,ye){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ye);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ye);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ye),this.inc("pre",ye);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ye),this.inc("pre",ye);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ye&&(this.prerelease[0]===ye?isNaN(this.prerelease[1])&&(this.prerelease=[ye,0]):this.prerelease=[ye,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,ye,Ee,Me){typeof Ee=="string"&&(Me=Ee,Ee=void 0);try{return new R(me,Ee).inc(ye,Me).version}catch{return null}},e.diff=function(me,ye){if(z(me,ye))return null;var Ee=fe(me),Me=fe(ye);if(Ee.prerelease.length||Me.prerelease.length){for(var Be in Ee)if((Be==="major"||Be==="minor"||Be==="patch")&&Ee[Be]!==Me[Be])return"pre"+Be;return"prerelease"}for(var Be in Ee)if((Be==="major"||Be==="minor"||Be==="patch")&&Ee[Be]!==Me[Be])return Be},e.compareIdentifiers=W;var U=/^[0-9]+$/;function W(me,ye){var Ee=U.test(me),Me=U.test(ye);return Ee&&Me&&(me=+me,ye=+ye),Ee&&!Me?-1:Me&&!Ee?1:me<ye?-1:me>ye?1:0}function Q(me,ye,Ee){return new R(me,Ee).compare(new R(ye,Ee))}function se(me,ye,Ee){return Q(me,ye,Ee)>0}function de(me,ye,Ee){return Q(me,ye,Ee)<0}function z(me,ye,Ee){return Q(me,ye,Ee)===0}function Y(me,ye,Ee){return Q(me,ye,Ee)!==0}function _(me,ye,Ee){return Q(me,ye,Ee)>=0}function j(me,ye,Ee){return Q(me,ye,Ee)<=0}function q(me,ye,Ee,Me){var Be;switch(ye){case"===":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),Be=me===Ee;break;case"!==":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),Be=me!==Ee;break;case"":case"=":case"==":Be=z(me,Ee,Me);break;case"!=":Be=Y(me,Ee,Me);break;case">":Be=se(me,Ee,Me);break;case">=":Be=_(me,Ee,Me);break;case"<":Be=de(me,Ee,Me);break;case"<=":Be=j(me,Ee,Me);break;default:throw new TypeError("Invalid operator: "+ye)}return Be}function G(me,ye){if(me instanceof G){if(me.loose===ye)return me;me=me.value}if(!(this instanceof G))return new G(me,ye);P("comparator",me,ye),this.loose=ye,this.parse(me),this.semver===x?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(me,ye){return W(ye,me)},e.major=function(me,ye){return new R(me,ye).major},e.minor=function(me,ye){return new R(me,ye).minor},e.patch=function(me,ye){return new R(me,ye).patch},e.compare=Q,e.compareLoose=function(me,ye){return Q(me,ye,!0)},e.rcompare=function(me,ye,Ee){return Q(ye,me,Ee)},e.sort=function(me,ye){return me.sort(function(Ee,Me){return e.compare(Ee,Me,ye)})},e.rsort=function(me,ye){return me.sort(function(Ee,Me){return e.rcompare(Ee,Me,ye)})},e.gt=se,e.lt=de,e.eq=z,e.neq=Y,e.gte=_,e.lte=j,e.cmp=q,e.Comparator=G;var x={};function oe(me,ye){if(me instanceof oe)return me.loose===ye?me:new oe(me.raw,ye);if(me instanceof G)return new oe(me.value,ye);if(!(this instanceof oe))return new oe(me,ye);if(this.loose=ye,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function pe(me){return!me||me.toLowerCase()==="x"||me==="*"}function ke(me,ye,Ee,Me,Be,Je,He,Xe,Ke,nt,Qe,Ve,Ge){return((ye=pe(Ee)?"":pe(Me)?">="+Ee+".0.0":pe(Be)?">="+Ee+"."+Me+".0":">="+ye)+" "+(Xe=pe(Ke)?"":pe(nt)?"<"+(+Ke+1)+".0.0":pe(Qe)?"<"+Ke+"."+(+nt+1)+".0":Ve?"<="+Ke+"."+nt+"."+Qe+"-"+Ve:"<="+Xe)).trim()}function Ae(me,ye){for(var Ee=0;Ee<me.length;Ee++)if(!me[Ee].test(ye))return!1;if(ye.prerelease.length){for(Ee=0;Ee<me.length;Ee++)if(P(me[Ee].semver),me[Ee].semver!==x&&me[Ee].semver.prerelease.length>0){var Me=me[Ee].semver;if(Me.major===ye.major&&Me.minor===ye.minor&&Me.patch===ye.patch)return!0}return!1}return!0}function Fe(me,ye,Ee){try{ye=new oe(ye,Ee)}catch{return!1}return ye.test(me)}function je(me,ye,Ee,Me){var Be,Je,He,Xe,Ke;switch(me=new R(me,Me),ye=new oe(ye,Me),Ee){case">":Be=se,Je=j,He=de,Xe=">",Ke=">=";break;case"<":Be=de,Je=_,He=se,Xe="<",Ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(me,ye,Me))return!1;for(var nt=0;nt<ye.set.length;++nt){var Qe=ye.set[nt],Ve=null,Ge=null;if(Qe.forEach(function(le){le.semver===x&&(le=new G(">=0.0.0")),Ve=Ve||le,Ge=Ge||le,Be(le.semver,Ve.semver,Me)?Ve=le:He(le.semver,Ge.semver,Me)&&(Ge=le)}),Ve.operator===Xe||Ve.operator===Ke||(!Ge.operator||Ge.operator===Xe)&&Je(me,Ge.semver)||Ge.operator===Ke&&He(me,Ge.semver))return!1}return!0}G.prototype.parse=function(me){var ye=this.loose?A[ue]:A[L],Ee=me.match(ye);if(!Ee)throw new TypeError("Invalid comparator: "+me);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new R(Ee[2],this.loose):this.semver=x},G.prototype.toString=function(){return this.value},G.prototype.test=function(me){return P("Comparator.test",me,this.loose),this.semver===x||(typeof me=="string"&&(me=new R(me,this.loose)),q(me,this.operator,this.semver,this.loose))},G.prototype.intersects=function(me,ye){if(!(me instanceof G))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new oe(me.value,ye),Fe(this.value,Ee,ye);if(me.operator==="")return Ee=new oe(this.value,ye),Fe(me.semver,Ee,ye);var Me=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Je=this.semver.version===me.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Xe=q(this.semver,"<",me.semver,ye)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Ke=q(this.semver,">",me.semver,ye)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Me||Be||Je&&He||Xe||Ke},e.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(me){var ye=this.loose;me=me.trim(),P("range",me,ye);var Ee=ye?A[ee]:A[H];me=me.replace(Ee,ke),P("hyphen replace",me),me=me.replace(A[N],"$1$2$3"),P("comparator trim",me,A[N]),me=(me=(me=me.replace(A[ce],"$1~")).replace(A[$],"$1^")).split(/\s+/).join(" ");var Me=ye?A[ue]:A[L],Be=me.split(" ").map(function(Je){return function(He,Xe){return P("comp",He),He=function(Ke,nt){return Ke.trim().split(/\s+/).map(function(Qe){return function(Ve,Ge){P("caret",Ve,Ge);var le=Ge?A[X]:A[V];return Ve.replace(le,function(De,Ce,Te,Ne,ze){var Ye;return P("caret",Ve,De,Ce,Te,Ne,ze),pe(Ce)?Ye="":pe(Te)?Ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":pe(Ne)?Ye=Ce==="0"?">="+Ce+"."+Te+".0 <"+Ce+"."+(+Te+1)+".0":">="+Ce+"."+Te+".0 <"+(+Ce+1)+".0.0":ze?(P("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ye=Ce==="0"?Te==="0"?">="+Ce+"."+Te+"."+Ne+ze+" <"+Ce+"."+Te+"."+(+Ne+1):">="+Ce+"."+Te+"."+Ne+ze+" <"+Ce+"."+(+Te+1)+".0":">="+Ce+"."+Te+"."+Ne+ze+" <"+(+Ce+1)+".0.0"):(P("no pr"),Ye=Ce==="0"?Te==="0"?">="+Ce+"."+Te+"."+Ne+" <"+Ce+"."+Te+"."+(+Ne+1):">="+Ce+"."+Te+"."+Ne+" <"+Ce+"."+(+Te+1)+".0":">="+Ce+"."+Te+"."+Ne+" <"+(+Ce+1)+".0.0"),P("caret return",Ye),Ye})}(Qe,nt)}).join(" ")}(He,Xe),P("caret",He),He=function(Ke,nt){return Ke.trim().split(/\s+/).map(function(Qe){return function(Ve,Ge){var le=Ge?A[M]:A[ie];return Ve.replace(le,function(De,Ce,Te,Ne,ze){var Ye;return P("tilde",Ve,De,Ce,Te,Ne,ze),pe(Ce)?Ye="":pe(Te)?Ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":pe(Ne)?Ye=">="+Ce+"."+Te+".0 <"+Ce+"."+(+Te+1)+".0":ze?(P("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ye=">="+Ce+"."+Te+"."+Ne+ze+" <"+Ce+"."+(+Te+1)+".0"):Ye=">="+Ce+"."+Te+"."+Ne+" <"+Ce+"."+(+Te+1)+".0",P("tilde return",Ye),Ye})}(Qe,nt)}).join(" ")}(He,Xe),P("tildes",He),He=function(Ke,nt){return P("replaceXRanges",Ke,nt),Ke.split(/\s+/).map(function(Qe){return function(Ve,Ge){Ve=Ve.trim();var le=Ge?A[F]:A[T];return Ve.replace(le,function(De,Ce,Te,Ne,ze,Ye){P("xRange",Ve,De,Ce,Te,Ne,ze,Ye);var tt=pe(Te),rt=tt||pe(Ne),xe=rt||pe(ze);return Ce==="="&&xe&&(Ce=""),tt?De=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&xe?(rt&&(Ne=0),xe&&(ze=0),Ce===">"?(Ce=">=",rt?(Te=+Te+1,Ne=0,ze=0):xe&&(Ne=+Ne+1,ze=0)):Ce==="<="&&(Ce="<",rt?Te=+Te+1:Ne=+Ne+1),De=Ce+Te+"."+Ne+"."+ze):rt?De=">="+Te+".0.0 <"+(+Te+1)+".0.0":xe&&(De=">="+Te+"."+Ne+".0 <"+Te+"."+(+Ne+1)+".0"),P("xRange return",De),De})}(Qe,nt)}).join(" ")}(He,Xe),P("xrange",He),He=function(Ke,nt){return P("replaceStars",Ke,nt),Ke.trim().replace(A[ae],"")}(He,Xe),P("stars",He),He}(Je,ye)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Je){return!!Je.match(Me)})),Be=Be.map(function(Je){return new G(Je,ye)})},oe.prototype.intersects=function(me,ye){if(!(me instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(Me){return me.set.some(function(Be){return Be.every(function(Je){return Me.intersects(Je,ye)})})})})},e.toComparators=function(me,ye){return new oe(me,ye).set.map(function(Ee){return Ee.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new R(me,this.loose));for(var ye=0;ye<this.set.length;ye++)if(Ae(this.set[ye],me))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(me,ye,Ee){var Me=null,Be=null;try{var Je=new oe(ye,Ee)}catch{return null}return me.forEach(function(He){Je.test(He)&&(Me&&Be.compare(He)!==-1||(Be=new R(Me=He,Ee)))}),Me},e.minSatisfying=function(me,ye,Ee){var Me=null,Be=null;try{var Je=new oe(ye,Ee)}catch{return null}return me.forEach(function(He){Je.test(He)&&(Me&&Be.compare(He)!==1||(Be=new R(Me=He,Ee)))}),Me},e.validRange=function(me,ye){try{return new oe(me,ye).range||"*"}catch{return null}},e.ltr=function(me,ye,Ee){return je(me,ye,"<",Ee)},e.gtr=function(me,ye,Ee){return je(me,ye,">",Ee)},e.outside=je,e.prerelease=function(me,ye){var Ee=fe(me,ye);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(me,ye,Ee){return me=new oe(me,Ee),ye=new oe(ye,Ee),me.intersects(ye)},e.coerce=function(me){if(me instanceof R)return me;if(typeof me!="string")return null;var ye=me.match(A[Z]);return ye==null?null:fe((ye[1]||"0")+"."+(ye[2]||"0")+"."+(ye[3]||"0"))}}).call(this,v(1))},function(re,e){var v,t,P=re.exports={};function S(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function A(w){if(v===setTimeout)return setTimeout(w,0);if((v===S||!v)&&setTimeout)return v=setTimeout,setTimeout(w,0);try{return v(w,0)}catch{try{return v.call(null,w,0)}catch{return v.call(this,w,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:S}catch{v=S}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var y,E=[],I=!1,k=-1;function C(){I&&y&&(I=!1,y.length?E=y.concat(E):k=-1,E.length&&p())}function p(){if(!I){var w=A(C);I=!0;for(var d=E.length;d;){for(y=E,E=[];++k<d;)y&&y[k].run();k=-1,d=E.length}y=null,I=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(w)}}function m(w,d){this.fun=w,this.array=d}function g(){}P.nextTick=function(w){var d=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)d[b-1]=arguments[b];E.push(new m(w,d)),E.length!==1||I||A(p)},m.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(w){return[]},P.binding=function(w){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(w){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(be[138],ve([1,0]),function(re,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(A,y,E){this.level=A,this.key=y,this.value=E,this.forward=[]}}const P=void 0;class S{constructor(A,y=2**16){this.comparator=A,this[v]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(y)|0),this.e=new t(this.c,P,P)}get size(){return this.f}clear(){this.e=new t(this.c,P,P)}has(A){return Boolean(S.g(this,A,this.comparator))}get(A){return S.g(this,A,this.comparator)?.value}set(A,y){return S.h(this,A,y,this.comparator)&&(this.f+=1),this}delete(A){const y=S.k(this,A,this.comparator);return y&&(this.f-=1),y}forEach(A,y){let E=this.e.forward[0];for(;E;)A.call(y,E.value,E.key,this),E=E.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",y=this.e.forward[0];for(;y;)A+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return A}static g(A,y,E){let I=A.e;for(let k=A.d-1;k>=0;k--)for(;I.forward[k]&&E(I.forward[k].key,y)<0;)I=I.forward[k];if(I=I.forward[0],I&&E(I.key,y)===0)return I}static h(A,y,E,I){const k=[];let C=A.e;for(let p=A.d-1;p>=0;p--){for(;C.forward[p]&&I(C.forward[p].key,y)<0;)C=C.forward[p];k[p]=C}if(C=C.forward[0],C&&I(C.key,y)===0)return C.value=E,!1;{const p=S.j(A);if(p>A.d){for(let m=A.d;m<p;m++)k[m]=A.e;A.d=p}C=new t(p,y,E);for(let m=0;m<p;m++)C.forward[m]=k[m].forward[m],k[m].forward[m]=C;return!0}}static j(A,y=.5){let E=1;for(;Math.random()<y&&E<A.c;)E+=1;return E}static k(A,y,E){const I=[];let k=A.e;for(let C=A.d-1;C>=0;C--){for(;k.forward[C]&&E(k.forward[C].key,y)<0;)k=k.forward[C];I[C]=k}if(k=k.forward[0],!k||E(k.key,y)!==0)return!1;for(let C=0;C<A.d&&I[C].forward[C]===k;C++)I[C].forward[C]=k.forward[C];for(;A.d>0&&A.e.forward[A.d-1]===P;)A.d-=1;return!0}}e.SkipList=S}),define(be[139],ve([1,0,3]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class P{static create(D=!0){return new P(D)}constructor(D){this.a=t&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?v.globals.performance.now():Date.now()}}e.StopWatch=P}),define(be[6],ve([1,0,8,68,2,87,139]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var E;(function(l){l.None=()=>P.Disposable.None;function s(Q){if(y){const{onDidAddListener:se}=Q,de=m.create();let z=0;Q.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),se?.()}}}function h(Q,se){return $(Q,()=>{},0,void 0,void 0,se)}l.defer=h;function T(Q){return(se,de=null,z)=>{let Y=!1,_;return _=Q(j=>{if(!Y)return _?_.dispose():Y=!0,se.call(de,j)},null,z),Y&&_.dispose(),_}}l.once=T;function F(Q,se,de){return J((z,Y=null,_)=>Q(j=>z.call(Y,se(j)),null,_),de)}l.map=F;function Z(Q,se,de){return J((z,Y=null,_)=>Q(j=>{se(j),z.call(Y,j)},null,_),de)}l.forEach=Z;function ne(Q,se,de){return J((z,Y=null,_)=>Q(j=>se(j)&&z.call(Y,j),null,_),de)}l.filter=ne;function ce(Q){return Q}l.signal=ce;function ie(...Q){return(se,de=null,z)=>(0,P.combinedDisposable)(...Q.map(Y=>Y(_=>se.call(de,_),null,z)))}l.any=ie;function M(Q,se,de,z){let Y=de;return F(Q,_=>(Y=se(Y,_),Y),z)}l.reduce=M;function J(Q,se){let de;const z={onWillAddFirstListener(){de=Q(Y.fire,Y)},onDidRemoveLastListener(){de?.dispose()}};se||s(z);const Y=new w(z);return se?.add(Y),Y.event}function $(Q,se,de=100,z=!1,Y,_){let j,q,G,x=0;const oe={leakWarningThreshold:Y,onWillAddFirstListener(){j=Q(ke=>{x++,q=se(q,ke),z&&!G&&(pe.fire(q),q=void 0),clearTimeout(G),G=setTimeout(()=>{const Ae=q;q=void 0,G=void 0,(!z||x>1)&&pe.fire(Ae),x=0},de)})},onDidRemoveLastListener(){j.dispose()}};_||s(oe);const pe=new w(oe);return _?.add(pe),pe.event}l.debounce=$;function V(Q,se=0,de){return l.debounce(Q,(z,Y)=>z?(z.push(Y),z):[Y],se,void 0,void 0,de)}l.accumulate=V;function X(Q,se=(z,Y)=>z===Y,de){let z=!0,Y;return ne(Q,_=>{const j=z||!se(_,Y);return z=!1,Y=_,j},de)}l.latch=X;function ue(Q,se,de){return[l.filter(Q,se,de),l.filter(Q,z=>!se(z),de)]}l.split=ue;function L(Q,se=!1,de=[]){let z=de.slice(),Y=Q(q=>{z?z.push(q):j.fire(q)});const _=()=>{z?.forEach(q=>j.fire(q)),z=null},j=new w({onWillAddFirstListener(){Y||(Y=Q(q=>j.fire(q)))},onDidAddFirstListener(){z&&(se?setTimeout(_):_())},onDidRemoveLastListener(){Y&&Y.dispose(),Y=null}});return j.event}l.buffer=L;class N{constructor(se){this.event=se,this.c=new P.DisposableStore}map(se){return new N(F(this.event,se,this.c))}forEach(se){return new N(Z(this.event,se,this.c))}filter(se){return new N(ne(this.event,se,this.c))}reduce(se,de){return new N(M(this.event,se,de,this.c))}latch(){return new N(X(this.event,void 0,this.c))}debounce(se,de=100,z=!1,Y){return new N($(this.event,se,de,z,Y,this.c))}on(se,de,z){return this.event(se,de,z)}once(se,de,z){return T(this.event)(se,de,z)}dispose(){this.c.dispose()}}function H(Q){return new N(Q)}l.chain=H;function ee(Q,se,de=z=>z){const z=(...q)=>j.fire(de(...q)),Y=()=>Q.on(se,z),_=()=>Q.removeListener(se,z),j=new w({onWillAddFirstListener:Y,onDidRemoveLastListener:_});return j.event}l.fromNodeEventEmitter=ee;function ae(Q,se,de=z=>z){const z=(...q)=>j.fire(de(...q)),Y=()=>Q.addEventListener(se,z),_=()=>Q.removeEventListener(se,z),j=new w({onWillAddFirstListener:Y,onDidRemoveLastListener:_});return j.event}l.fromDOMEventEmitter=ae;function ge(Q){return new Promise(se=>T(Q)(se))}l.toPromise=ge;function fe(Q,se){return se(void 0),Q(de=>se(de))}l.runAndSubscribe=fe;function R(Q,se){let de=null;function z(_){de?.dispose(),de=new P.DisposableStore,se(_,de)}z(void 0);const Y=Q(_=>z(_));return(0,P.toDisposable)(()=>{Y.dispose(),de?.dispose()})}l.runAndSubscribeWithStore=R;class U{constructor(se,de){this.obs=se,this.c=0,this.d=!1;const z={onWillAddFirstListener:()=>{se.addObserver(this)},onDidRemoveLastListener:()=>{se.removeObserver(this)}};de||s(z),this.emitter=new w(z),de&&de.add(this.emitter)}beginUpdate(se){this.c++}handleChange(se,de){this.d=!0}endUpdate(se){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(Q,se){return new U(Q,se).emitter.event}l.fromObservable=W})(E=e.Event||(e.Event={}));class I{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${I.c++}`,I.all.add(this)}start(s){this.d=new D.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=I,I.all=new Set,I.c=0;let k=-1;function C(l){const s=k;return k=l,{dispose(){k=s}}}e.setGlobalLeakWarningThreshold=C;class p{constructor(s,h=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=h,this.d=0}dispose(){this.c?.clear()}check(s,h){const T=this.threshold;if(T<=0||h<T)return;this.c||(this.c=new Map);const F=this.c.get(s.value)||0;if(this.c.set(s.value,F+1),this.d-=1,this.d<=0){this.d=T*.5;let Z,ne=0;for(const[ce,ie]of this.c)(!Z||ne<ie)&&(Z=ce,ne=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${ne}):`),console.warn(Z)}return()=>{const Z=this.c.get(s.value)||0;this.c.set(s.value,Z-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(s,h,T){this.callback=s,this.callbackThis=h,this.stack=T,this.subscription=new P.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class w{constructor(s){this.j=!1,this.d=s,this.f=k>0||this.d?.leakWarningThreshold?new p(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new I(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const s=Array.from(this.q);queueMicrotask(()=>{for(const h of s)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,h,T)=>{if(this.q||(this.q=new S.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.Disposable.None;const F=this.q.isEmpty();F&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let Z,ne;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(ne=m.create(),Z=this.f.check(ne,this.q.size+1)),A&&(ne=ne??m.create());const ce=new g(s,h,ne),ie=this.q.push(ce);F&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,h);const M=ce.subscription.set(()=>{Z?.(),this.j||(ie(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return T instanceof P.DisposableStore?T.add(M):Array.isArray(T)&&T.push(M),M}),this.l}fire(s){if(this.q){this.m||(this.m=new b);for(const h of this.q)this.m.push(this,h,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=w;class d{constructor(){this.c=new S.LinkedList}get size(){return this.c.size}push(s,h,T){this.c.push(new c(s,h,T))}clear(s){const h=new S.LinkedList;for(const T of this.c)T.emitter!==s&&h.push(T);this.c=h}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(h){(0,v.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=d;class b extends d{clear(s){this.c.clear()}}class c{constructor(s,h,T){this.emitter=s,this.listener=h,this.event=T}}class f extends w{async fireAsync(s,h,T){if(!!this.q){this.c||(this.c=new S.LinkedList);for(const F of this.q)this.c.push([F,s]);for(;this.c.size>0&&!h.isCancellationRequested;){const[F,Z]=this.c.shift(),ne=[],ce={...Z,token:h,waitUntil:ie=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");T&&(ie=T(ie,F.callback)),ne.push(ie)}};try{F.invoke(ce)}catch(ie){(0,v.onUnexpectedError)(ie);continue}Object.freeze(ne),await Promise.allSettled(ne).then(ie=>{for(const M of ie)M.status==="rejected"&&(0,v.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=f;class u extends w{constructor(s){super(s),this.h=0,this.s=new S.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=u;class i extends u{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=i;class n extends w{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=n;class r{constructor(){this.d=!1,this.f=[],this.c=new w({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const h={event:s,listener:null};this.f.push(h),this.d&&this.j(h);const T=()=>{this.d&&this.k(h);const F=this.f.indexOf(h);this.f.splice(F,1)};return(0,P.toDisposable)((0,t.once)(T))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(h=>this.c.fire(h))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.c=[]}wrapEvent(s){return(h,T,F)=>s(Z=>{const ne=this.c[this.c.length-1];ne?ne.push(()=>h.call(T,Z)):h.call(T,Z)},void 0,F)}bufferEvents(s){const h=[];this.c.push(h);const T=s();return this.c.pop(),h.forEach(F=>F()),T}}e.EventBufferer=o;class a{constructor(){this.c=!1,this.d=E.None,this.f=P.Disposable.None,this.g=new w({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(be[19],ve([1,0,6]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(A,y){const E=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(E)}}});var P;(function(A){function y(E){return E===A.None||E===A.Cancelled||E instanceof S?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(P=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new v.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new S),this.a}cancel(){this.a?this.a instanceof S&&this.a.cancel():this.a=P.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof S&&this.a.dispose():this.a=P.None}}e.CancellationTokenSource=D}),define(be[140],ve([1,0,19]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new v.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=t;class P{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=P;class S{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=S}),define(be[44],ve([1,0,8,2]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(f){const u=f;return u?typeof u.read=="function":!1}e.isReadable=P;function S(f){const u=f;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=S;function D(f){const u=f;return u?S(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=D;function A(f,u){return new y(f,u)}e.newWriteableStream=A;class y{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,v.onUnexpectedError)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let n;switch(u){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(i);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(f,u){const i=[];let n;for(;(n=f.read())!==null;)i.push(n);return u(i)}e.consumeReadable=E;function I(f,u,i){const n=[];let r;for(;(r=f.read())!==null&&n.length<i;)n.push(r);return r===null&&n.length>0?u(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const o=r;return r=void 0,o}return f.read()}}}e.peekReadable=I;function k(f,u){return new Promise((i,n)=>{const r=[];C(f,{onData:o=>{u&&r.push(o)},onError:o=>{u?n(o):i(void 0)},onEnd:()=>{i(u?u(r):void 0)}})})}e.consumeStream=k;function C(f,u){let i=!1;return f.on("error",n=>{i||u.onError(n)}),f.on("end",()=>{i||u.onEnd()}),f.on("data",n=>{i||u.onData(n)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=C;function p(f,u){return new Promise((i,n)=>{const r=new t.DisposableStore,o=[],a=h=>{if(o.push(h),o.length>u)return r.dispose(),f.pause(),i({stream:f,buffer:o,ended:!1})},l=h=>n(h),s=()=>i({stream:f,buffer:o,ended:!0});r.add((0,t.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),r.add((0,t.toDisposable)(()=>f.removeListener("end",s))),f.on("end",s),r.add((0,t.toDisposable)(()=>f.removeListener("data",a))),f.on("data",a)})}e.peekStream=p;function m(f,u){const i=A(u);return i.end(f),i}e.toStream=m;function g(){const f=A(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=g;function w(f){let u=!1;return{read:()=>u?null:(u=!0,f)}}e.toReadable=w;function d(f,u,i){const n=A(i);return C(f,{onData:r=>n.write(u.data(r)),onError:r=>n.error(u.error?u.error(r):r),onEnd:()=>n.end()}),n}e.transform=d;function b(f,u,i){let n=!1;return{read:()=>{const r=u.read();return n?r:(n=!0,r!==null?i([f,r]):f)}}}e.prefixedReadable=b;function c(f,u,i){let n=!1;const r=A(i);return C(u,{onData:o=>n?r.write(o):(n=!0,r.write(i([f,o]))),onError:o=>r.error(o),onEnd:()=>{n||(n=!0,r.write(f)),r.end()}}),r}e.prefixedStream=c}),define(be[16],ve([1,0,44]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let P,S;class D{static alloc(h){return t?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,T){return!(T?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(h)):(P||(P=new TextEncoder),new D(P.encode(h)))}static fromByteArray(h){const T=D.alloc(h.length);for(let F=0,Z=h.length;F<Z;F++)T.buffer[F]=h[F];return T}static concat(h,T){if(typeof T>"u"){T=0;for(let ne=0,ce=h.length;ne<ce;ne++)T+=h[ne].byteLength}const F=D.alloc(T);let Z=0;for(let ne=0,ce=h.length;ne<ce;ne++){const ie=h[ne];F.set(ie,Z),Z+=ie.byteLength}return F}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(h,T){return new D(this.buffer.subarray(h,T))}set(h,T){if(h instanceof D)this.buffer.set(h.buffer,T);else if(h instanceof Uint8Array)this.buffer.set(h,T);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),T);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,T){I(this.buffer,h,T)}readUInt32LE(h){return k(this.buffer,h)}writeUInt32LE(h,T){C(this.buffer,h,T)}readUInt8(h){return p(this.buffer,h)}writeUInt8(h,T){m(this.buffer,h,T)}}e.VSBuffer=D;function A(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0}e.readUInt16LE=A;function y(s,h,T){s[T+0]=h&255,h=h>>>8,s[T+1]=h&255}e.writeUInt16LE=y;function E(s,h){return s[h]*2**24+s[h+1]*2**16+s[h+2]*2**8+s[h+3]}e.readUInt32BE=E;function I(s,h,T){s[T+3]=h,h=h>>>8,s[T+2]=h,h=h>>>8,s[T+1]=h,h=h>>>8,s[T]=h}e.writeUInt32BE=I;function k(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0|s[h+2]<<16>>>0|s[h+3]<<24>>>0}e.readUInt32LE=k;function C(s,h,T){s[T+0]=h&255,h=h>>>8,s[T+1]=h&255,h=h>>>8,s[T+2]=h&255,h=h>>>8,s[T+3]=h&255}e.writeUInt32LE=C;function p(s,h){return s[h]}e.readUInt8=p;function m(s,h,T){s[T]=h}e.writeUInt8=m;function g(s){return v.consumeReadable(s,h=>D.concat(h))}e.readableToBuffer=g;function w(s){return v.toReadable(s)}e.bufferToReadable=w;function d(s){return v.consumeStream(s,h=>D.concat(h))}e.streamToBuffer=d;async function b(s){return s.ended?D.concat(s.buffer):D.concat([...s.buffer,await d(s.stream)])}e.bufferedStreamToBuffer=b;function c(s){return v.toStream(s,h=>D.concat(h))}e.bufferToStream=c;function f(s){return v.transform(s,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.streamToBufferReadableStream=f;function u(s){return v.newWriteableStream(h=>D.concat(h),s)}e.newWriteableBufferStream=u;function i(s,h){return v.prefixedReadable(s,h,T=>D.concat(T))}e.prefixedBufferReadable=i;function n(s,h){return v.prefixedStream(s,h,T=>D.concat(T))}e.prefixedBufferStream=n;function r(s){let h=0,T=0,F=0;const Z=new Uint8Array(Math.floor(s.length/4*3)),ne=ie=>{switch(T){case 3:Z[F++]=h|ie,T=0;break;case 2:Z[F++]=h|ie>>>2,h=ie<<6,T=3;break;case 1:Z[F++]=h|ie>>>4,h=ie<<4,T=2;break;default:h=ie<<2,T=1}};for(let ie=0;ie<s.length;ie++){const M=s.charCodeAt(ie);if(M>=65&&M<=90)ne(M-65);else if(M>=97&&M<=122)ne(M-97+26);else if(M>=48&&M<=57)ne(M-48+52);else if(M===43||M===45)ne(62);else if(M===47||M===95)ne(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${s[ie]}`)}}const ce=F;for(;T>0;)ne(0);return D.wrap(Z).slice(0,ce)}e.decodeBase64=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:s},h=!0,T=!1){const F=T?a:o;let Z="";const ne=s.byteLength%3;let ce=0;for(;ce<s.byteLength-ne;ce+=3){const ie=s[ce+0],M=s[ce+1],J=s[ce+2];Z+=F[ie>>>2],Z+=F[(ie<<4|M>>>4)&63],Z+=F[(M<<2|J>>>6)&63],Z+=F[J&63]}if(ne===1){const ie=s[ce+0];Z+=F[ie>>>2],Z+=F[ie<<4&63],h&&(Z+="==")}else if(ne===2){const ie=s[ce+0],M=s[ce+1];Z+=F[ie>>>2],Z+=F[(ie<<4|M>>>4)&63],Z+=F[M<<2&63],h&&(Z+="=")}return Z}e.encodeBase64=l}),define(be[15],ve([1,0,140,136]),function(re,e,v,t){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=S;const D=/{(\d+)}/g;function A(le,...De){return De.length===0?le:le.replace(D,function(Ce,Te){const Ne=parseInt(Te,10);return isNaN(Ne)||Ne<0||Ne>=De.length?Ce:De[Ne]})}e.format=A;const y=/{([^}]+)}/g;function E(le,De){return le.replace(y,(Ce,Te)=>De[Te]??Ce)}e.format2=E;function I(le){return le.replace(/[<>&]/g,function(De){switch(De){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return De}})}e.escape=I;function k(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function C(le,De){let Ce=0;const Te=De.charCodeAt(0);for(let Ne=le.length-1;Ne>=0;Ne--)le.charCodeAt(Ne)===Te&&Ce++;return Ce}e.count=C;function p(le,De,Ce="\u2026"){return le.length<=De?le:`${le.substr(0,De)}${Ce}`}e.truncate=p;function m(le,De=" "){const Ce=g(le,De);return w(Ce,De)}e.trim=m;function g(le,De){if(!le||!De)return le;const Ce=De.length;if(Ce===0||le.length===0)return le;let Te=0;for(;le.indexOf(De,Te)===Te;)Te=Te+Ce;return le.substring(Te)}e.ltrim=g;function w(le,De){if(!le||!De)return le;const Ce=De.length,Te=le.length;if(Ce===0||Te===0)return le;let Ne=Te,ze=-1;for(;ze=le.lastIndexOf(De,Ne-1),!(ze===-1||ze+Ce!==Ne);){if(ze===0)return"";Ne=ze}return le.substring(0,Ne)}e.rtrim=w;function d(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function b(le){return le.replace(/\*/g,"")}e.stripWildcards=b;function c(le,De,Ce={}){if(!le)throw new Error("Cannot create regex from empty string");De||(le=k(le)),Ce.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Te="";return Ce.global&&(Te+="g"),Ce.matchCase||(Te+="i"),Ce.multiline&&(Te+="m"),Ce.unicode&&(Te+="u"),new RegExp(le,Te)}e.createRegExp=c;function f(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function u(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function i(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=i;function n(le){return le.split(/\r\n|\r|\n/)}e.splitLines=n;function r(le){for(let De=0,Ce=le.length;De<Ce;De++){const Te=le.charCodeAt(De);if(Te!==32&&Te!==9)return De}return-1}e.firstNonWhitespaceIndex=r;function o(le,De=0,Ce=le.length){for(let Te=De;Te<Ce;Te++){const Ne=le.charCodeAt(Te);if(Ne!==32&&Ne!==9)return le.substring(De,Te)}return le.substring(De,Ce)}e.getLeadingWhitespace=o;function a(le,De=le.length-1){for(let Ce=De;Ce>=0;Ce--){const Te=le.charCodeAt(Ce);if(Te!==32&&Te!==9)return Ce}return-1}e.lastNonWhitespaceIndex=a;function l(le,De,Ce){const Te=[];let Ne=0;for(const ze of le.matchAll(De)){if(Te.push(le.slice(Ne,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Ne=ze.index+ze[0].length,Te.push(Ce(ze[0],...ze.slice(1),ze.index,le,ze.groups))}return Te.push(le.slice(Ne)),Promise.all(Te).then(ze=>ze.join(""))}e.replaceAsync=l;function s(le,De){return le<De?-1:le>De?1:0}e.compare=s;function h(le,De,Ce=0,Te=le.length,Ne=0,ze=De.length){for(;Ce<Te&&Ne<ze;Ce++,Ne++){const rt=le.charCodeAt(Ce),xe=De.charCodeAt(Ne);if(rt<xe)return-1;if(rt>xe)return 1}const Ye=Te-Ce,tt=ze-Ne;return Ye<tt?-1:Ye>tt?1:0}e.compareSubstring=h;function T(le,De){return F(le,De,0,le.length,0,De.length)}e.compareIgnoreCase=T;function F(le,De,Ce=0,Te=le.length,Ne=0,ze=De.length){for(;Ce<Te&&Ne<ze;Ce++,Ne++){let rt=le.charCodeAt(Ce),xe=De.charCodeAt(Ne);if(rt===xe)continue;if(rt>=128||xe>=128)return h(le.toLowerCase(),De.toLowerCase(),Ce,Te,Ne,ze);ne(rt)&&(rt-=32),ne(xe)&&(xe-=32);const st=rt-xe;if(st!==0)return st}const Ye=Te-Ce,tt=ze-Ne;return Ye<tt?-1:Ye>tt?1:0}e.compareSubstringIgnoreCase=F;function Z(le){return le>=48&&le<=57}e.isAsciiDigit=Z;function ne(le){return le>=97&&le<=122}e.isLowerAsciiLetter=ne;function ce(le){return le>=65&&le<=90}e.isUpperAsciiLetter=ce;function ie(le,De){return le.length===De.length&&F(le,De)===0}e.equalsIgnoreCase=ie;function M(le,De){const Ce=De.length;return De.length>le.length?!1:F(le,De,0,Ce)===0}e.startsWithIgnoreCase=M;function J(le,De){const Ce=Math.min(le.length,De.length);let Te;for(Te=0;Te<Ce;Te++)if(le.charCodeAt(Te)!==De.charCodeAt(Te))return Te;return Ce}e.commonPrefixLength=J;function $(le,De){const Ce=Math.min(le.length,De.length);let Te;const Ne=le.length-1,ze=De.length-1;for(Te=0;Te<Ce;Te++)if(le.charCodeAt(Ne-Te)!==De.charCodeAt(ze-Te))return Te;return Ce}e.commonSuffixLength=$;function V(le){return 55296<=le&&le<=56319}e.isHighSurrogate=V;function X(le){return 56320<=le&&le<=57343}e.isLowSurrogate=X;function ue(le,De){return(le-55296<<10)+(De-56320)+65536}e.computeCodePoint=ue;function L(le,De,Ce){const Te=le.charCodeAt(Ce);if(V(Te)&&Ce+1<De){const Ne=le.charCodeAt(Ce+1);if(X(Ne))return ue(Te,Ne)}return Te}e.getNextCodePoint=L;function N(le,De){const Ce=le.charCodeAt(De-1);if(X(Ce)&&De>1){const Te=le.charCodeAt(De-2);if(V(Te))return ue(Te,Ce)}return Ce}class H{get offset(){return this.e}constructor(De,Ce=0){this.c=De,this.d=De.length,this.e=Ce}setOffset(De){this.e=De}prevCodePoint(){const De=N(this.c,this.e);return this.e-=De>=65536?2:1,De}nextCodePoint(){const De=L(this.c,this.d,this.e);return this.e+=De>=65536?2:1,De}eol(){return this.e>=this.d}}e.CodePointIterator=H;class ee{get offset(){return this.c.offset}constructor(De,Ce=0){this.c=new H(De,Ce)}nextGraphemeLength(){const De=Je.getInstance(),Ce=this.c,Te=Ce.offset;let Ne=De.getGraphemeBreakType(Ce.nextCodePoint());for(;!Ce.eol();){const ze=Ce.offset,Ye=De.getGraphemeBreakType(Ce.nextCodePoint());if(Me(Ne,Ye)){Ce.setOffset(ze);break}Ne=Ye}return Ce.offset-Te}prevGraphemeLength(){const De=Je.getInstance(),Ce=this.c,Te=Ce.offset;let Ne=De.getGraphemeBreakType(Ce.prevCodePoint());for(;Ce.offset>0;){const ze=Ce.offset,Ye=De.getGraphemeBreakType(Ce.prevCodePoint());if(Me(Ye,Ne)){Ce.setOffset(ze);break}Ne=Ye}return Te-Ce.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ee;function ae(le,De){return new ee(le,De).nextGraphemeLength()}e.nextCharLength=ae;function ge(le,De){return new ee(le,De).prevGraphemeLength()}e.prevCharLength=ge;function fe(le,De){De>0&&X(le.charCodeAt(De))&&De--;const Ce=De+ae(le,De);return[Ce-ge(le,Ce),Ce]}e.getCharContainingOffset=fe;function R(le){const De=new ee(le);let Ce=0;for(;!De.eol();)Ce++,De.nextGraphemeLength();return Ce}e.charCount=R;let U;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Q(le){return U||(U=W()),U.test(le)}e.containsRTL=Q;const se=/^[\t\n\r\x20-\x7E]*$/;function de(le){return se.test(le)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=z;function Y(le){return le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Y;function _(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129008||le>=129280&&le<=129535||le>=129648&&le<=129782}e.isEmojiImprecise=_;function j(le,De){if(le.length<De)return le;const Ce=/\b/g;let Te=0;for(;Ce.test(le)&&!(le.length-Ce.lastIndex<De);)Te=Ce.lastIndex,Ce.lastIndex+=1;return le.substring(Te).replace(/^\s/,"")}e.lcut=j;const q=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,x=/\x1b\[0?m/g;function oe(le){return le&&(le=le.replace(q,""),le=le.replace(G,""),le=le.replace(x,"")),le}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function ke(le){return pe(le)?le.substr(1):le}e.stripUTF8BOM=ke;function Ae(le,De){if(!le||!De||le.length<De.length)return!1;const Ce=De.length,Te=le.toLowerCase();let Ne=0,ze=-1;for(;Ne<Ce;){const Ye=Te.indexOf(De[Ne],ze+1);if(Ye<0)return!1;ze=Ye,Ne++}return!0}e.fuzzyContains=Ae;function Fe(le,De=!1){return le?(De&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=Fe;function je(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=je;function me(le,De=1){if(De===0)return"";let Ce=-1;do Ce=le.indexOf(`
`,Ce+1),De--;while(De>0&&Ce>=0);return Ce===-1?le:(le[Ce-1]==="\r"&&Ce--,le.substr(0,Ce))}e.getNLines=me;function ye(le){return le=le%(2*26),le<26?String.fromCharCode(97+le):String.fromCharCode(65+le-26)}e.singleLetterHash=ye;function Ee(le){return Je.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=Ee;function Me(le,De){return le===0?De!==5&&De!==7:le===2&&De===3?!1:le===4||le===2||le===3||De===4||De===2||De===3?!0:!(le===8&&(De===8||De===9||De===11||De===12)||(le===11||le===9)&&(De===9||De===10)||(le===12||le===10)&&De===10||De===5||De===13||De===7||le===1||le===13&&De===14||le===6&&De===6)}var Be;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(Be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Je{static getInstance(){return Je.c||(Je.c=new Je),Je.c}constructor(){this.d=He()}getGraphemeBreakType(De){if(De<32)return De===10?3:De===13?2:4;if(De<127)return 0;const Ce=this.d,Te=Ce.length/3;let Ne=1;for(;Ne<=Te;)if(De<Ce[3*Ne])Ne=2*Ne;else if(De>Ce[3*Ne+1])Ne=2*Ne+1;else return Ce[3*Ne+2];return 0}}Je.c=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(le,De){if(le===0)return 0;const Ce=Ke(le,De);if(Ce!==void 0)return Ce;const Te=new H(De,le);return Te.prevCodePoint(),Te.offset}e.getLeftDeleteOffset=Xe;function Ke(le,De){const Ce=new H(De,le);let Te=Ce.prevCodePoint();for(;nt(Te)||Te===65039||Te===8419;){if(Ce.offset===0)return;Te=Ce.prevCodePoint()}if(!_(Te))return;let Ne=Ce.offset;return Ne>0&&Ce.prevCodePoint()===8205&&(Ne=Ce.offset),Ne}function nt(le){return 127995<=le&&le<=127999}var Qe;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Ve{static getInstance(De){return Ve.d.get(Array.from(De))}static getLocales(){return Ve.e.getValue()}constructor(De){this.f=De}isAmbiguous(De){return this.f.has(De)}getPrimaryConfusable(De){return this.f.get(De)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Ve,P=Ve,Ve.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ve.d=new v.LRUCachedFunction(le=>{function De(xe){const st=new Map;for(let lt=0;lt<xe.length;lt+=2)st.set(xe[lt],xe[lt+1]);return st}function Ce(xe,st){const lt=new Map(xe);for(const[gt,ft]of st)lt.set(gt,ft);return lt}function Te(xe,st){if(!xe)return st;const lt=new Map;for(const[gt,ft]of xe)st.has(gt)&&lt.set(gt,ft);return lt}const Ne=P.c.getValue();let ze=le.filter(xe=>!xe.startsWith("_")&&xe in Ne);ze.length===0&&(ze=["_default"]);let Ye;for(const xe of ze){const st=De(Ne[xe]);Ye=Te(Ye,st)}const tt=De(Ne._common),rt=Ce(tt,Ye);return new Ve(rt)}),Ve.e=new t.Lazy(()=>Object.keys(Ve.c.getValue()).filter(le=>!le.startsWith("_")));class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(De){return Ge.e().has(De)}static get codePoints(){return Ge.e()}}e.InvisibleCharacters=Ge,Ge.d=void 0}),define(be[141],ve([1,0,26,15]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...G){return function(x,oe){for(let pe=0,ke=G.length;pe<ke;pe++){const Ae=G[pe](x,oe);if(Ae)return Ae}return null}}e.or=P,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(G,x,oe){if(!oe||oe.length<x.length)return null;let pe;return G?pe=t.startsWithIgnoreCase(oe,x):pe=oe.indexOf(x)===0,pe?x.length>0?[{start:0,end:x.length}]:[]:null}function D(G,x){const oe=x.toLowerCase().indexOf(G.toLowerCase());return oe===-1?null:[{start:oe,end:oe+G.length}]}e.matchesContiguousSubString=D;function A(G,x){return y(G.toLowerCase(),x.toLowerCase(),0,0)}e.matchesSubString=A;function y(G,x,oe,pe){if(oe===G.length)return[];if(pe===x.length)return null;if(G[oe]===x[pe]){let ke=null;return(ke=y(G,x,oe+1,pe+1))?d({start:pe,end:pe+1},ke):null}return y(G,x,oe,pe+1)}function E(G){return 97<=G&&G<=122}function I(G){return 65<=G&&G<=90}e.isUpper=I;function k(G){return 48<=G&&G<=57}function C(G){return G===32||G===9||G===10||G===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>p.add(G.charCodeAt(0)));function m(G){return C(G)||p.has(G)}function g(G,x){return G===x||m(G)&&m(x)}function w(G){return E(G)||I(G)||k(G)}function d(G,x){return x.length===0?x=[G]:G.end===x[0].start?x[0].start=G.start:x.unshift(G),x}function b(G,x){for(let oe=x;oe<G.length;oe++){const pe=G.charCodeAt(oe);if(I(pe)||k(pe)||oe>0&&!w(G.charCodeAt(oe-1)))return oe}return G.length}function c(G,x,oe,pe){if(oe===G.length)return[];if(pe===x.length)return null;if(G[oe]!==x[pe].toLowerCase())return null;{let ke=null,Ae=pe+1;for(ke=c(G,x,oe+1,pe+1);!ke&&(Ae=b(x,Ae))<x.length;)ke=c(G,x,oe+1,Ae),Ae++;return ke===null?null:d({start:pe,end:pe+1},ke)}}function f(G){let x=0,oe=0,pe=0,ke=0,Ae=0;for(let Ee=0;Ee<G.length;Ee++)Ae=G.charCodeAt(Ee),I(Ae)&&x++,E(Ae)&&oe++,w(Ae)&&pe++,k(Ae)&&ke++;const Fe=x/G.length,je=oe/G.length,me=pe/G.length,ye=ke/G.length;return{upperPercent:Fe,lowerPercent:je,alphaPercent:me,numericPercent:ye}}function u(G){const{upperPercent:x,lowerPercent:oe}=G;return oe===0&&x>.6}function i(G){const{upperPercent:x,lowerPercent:oe,alphaPercent:pe,numericPercent:ke}=G;return oe>.2&&x<.8&&pe>.6&&ke<.2}function n(G){let x=0,oe=0,pe=0,ke=0;for(let Ae=0;Ae<G.length;Ae++)pe=G.charCodeAt(Ae),I(pe)&&x++,E(pe)&&oe++,C(pe)&&ke++;return(x===0||oe===0)&&ke===0?G.length<=30:x<=5}function r(G,x){if(!x||(x=x.trim(),x.length===0)||!n(G)||x.length>60)return null;const oe=f(x);if(!i(oe)){if(!u(oe))return null;x=x.toLowerCase()}let pe=null,ke=0;for(G=G.toLowerCase();ke<x.length&&(pe=c(G,x,0,ke))===null;)ke=b(x,ke+1);return pe}e.matchesCamelCase=r;function o(G,x,oe=!1){if(!x||x.length===0)return null;let pe=null,ke=0;for(G=G.toLowerCase(),x=x.toLowerCase();ke<x.length&&(pe=a(G,x,0,ke,oe))===null;)ke=l(x,ke+1);return pe}e.matchesWords=o;function a(G,x,oe,pe,ke){if(oe===G.length)return[];if(pe===x.length)return null;if(g(G.charCodeAt(oe),x.charCodeAt(pe))){let Ae=null,Fe=pe+1;if(Ae=a(G,x,oe+1,pe+1,ke),!ke)for(;!Ae&&(Fe=l(x,Fe))<x.length;)Ae=a(G,x,oe+1,Fe,ke),Fe++;return Ae?G.charCodeAt(oe)!==x.charCodeAt(pe)?Ae:d({start:pe,end:pe+1},Ae):null}else return null}function l(G,x){for(let oe=x;oe<G.length;oe++)if(m(G.charCodeAt(oe))||oe>0&&m(G.charCodeAt(oe-1)))return oe;return G.length}const s=P(e.matchesPrefix,r,D),h=P(e.matchesPrefix,r,A),T=new v.LRUCache(1e4);function F(G,x,oe=!1){if(typeof G!="string"||typeof x!="string")return null;let pe=T.get(G);pe||(pe=new RegExp(t.convertSimple2RegExpPattern(G),"i"),T.set(G,pe));const ke=pe.exec(x);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:oe?h(G,x):s(G,x)}e.matchesFuzzy=F;function Z(G,x){const oe=se(G,G.toLowerCase(),0,x,x.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return oe?ce(oe):null}e.matchesFuzzy2=Z;function ne(G,x,oe,pe,ke,Ae){const Fe=Math.min(13,G.length);for(;oe<Fe;oe++){const je=se(G,x,oe,pe,ke,Ae,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(je)return je}return[0,Ae]}e.anyScore=ne;function ce(G){if(typeof G>"u")return[];const x=[],oe=G[1];for(let pe=G.length-1;pe>1;pe--){const ke=G[pe]+oe,Ae=x[x.length-1];Ae&&Ae.end===ke?Ae.end=ke+1:x.push({start:ke,end:ke+1})}return x}e.createMatches=ce;const ie=128;function M(){const G=[],x=[];for(let oe=0;oe<=ie;oe++)x[oe]=0;for(let oe=0;oe<=ie;oe++)G.push(x.slice(0));return G}function J(G){const x=[];for(let oe=0;oe<=G;oe++)x[oe]=0;return x}const $=J(2*ie),V=J(2*ie),X=M(),ue=M(),L=M(),N=!1;function H(G,x,oe,pe,ke){function Ae(je,me,ye=" "){for(;je.length<me;)je=ye+je;return je}let Fe=` |   |${pe.split("").map(je=>Ae(je,3)).join("|")}
`;for(let je=0;je<=oe;je++)je===0?Fe+=" |":Fe+=`${x[je-1]}|`,Fe+=G[je].slice(0,ke+1).map(me=>Ae(me.toString(),3)).join("|")+`
`;return Fe}function ee(G,x,oe,pe){G=G.substr(x),oe=oe.substr(pe),console.log(H(ue,G,G.length,oe,oe.length)),console.log(H(L,G,G.length,oe,oe.length)),console.log(H(X,G,G.length,oe,oe.length))}function ae(G,x){if(x<0||x>=G.length)return!1;const oe=G.codePointAt(x);switch(oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(oe)}}function ge(G,x){if(x<0||x>=G.length)return!1;switch(G.charCodeAt(x)){case 32:case 9:return!0;default:return!1}}function fe(G,x,oe){return x[G]!==oe[G]}function R(G,x,oe,pe,ke,Ae,Fe=!1){for(;x<oe&&ke<Ae;)G[x]===pe[ke]&&(Fe&&($[x]=ke),x+=1),ke+=1;return x===oe}e.isPatternInWord=R;var U;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(U||(U={}));var W;(function(G){G.Default=[-100,0];function x(oe){return!oe||oe.length===2&&oe[0]===-100&&oe[1]===0}G.isDefault=x})(W=e.FuzzyScore||(e.FuzzyScore={}));class Q{constructor(x,oe){this.firstMatchCanBeWeak=x,this.boostFullMatch=oe}}e.FuzzyScoreOptions=Q,Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function se(G,x,oe,pe,ke,Ae,Fe=Q.default){const je=G.length>ie?ie:G.length,me=pe.length>ie?ie:pe.length;if(oe>=je||Ae>=me||je-oe>me-Ae||!R(x,oe,je,ke,Ae,me,!0))return;de(je,me,oe,Ae,x,ke);let ye=1,Ee=1,Me=oe,Be=Ae;const Je=[!1];for(ye=1,Me=oe;Me<je;ye++,Me++){const Qe=$[Me],Ve=V[Me],Ge=Me+1<je?V[Me+1]:me;for(Ee=Qe-Ae+1,Be=Qe;Be<Ge;Ee++,Be++){let le=Number.MIN_SAFE_INTEGER,De=!1;Be<=Ve&&(le=z(G,x,Me,oe,pe,ke,Be,me,Ae,X[ye-1][Ee-1]===0,Je));let Ce=0;le!==Number.MAX_SAFE_INTEGER&&(De=!0,Ce=le+ue[ye-1][Ee-1]);const Te=Be>Qe,Ne=Te?ue[ye][Ee-1]+(X[ye][Ee-1]>0?-5:0):0,ze=Be>Qe+1&&X[ye][Ee-1]>0,Ye=ze?ue[ye][Ee-2]+(X[ye][Ee-2]>0?-5:0):0;if(ze&&(!Te||Ye>=Ne)&&(!De||Ye>=Ce))ue[ye][Ee]=Ye,L[ye][Ee]=3,X[ye][Ee]=0;else if(Te&&(!De||Ne>=Ce))ue[ye][Ee]=Ne,L[ye][Ee]=2,X[ye][Ee]=0;else if(De)ue[ye][Ee]=Ce,L[ye][Ee]=1,X[ye][Ee]=X[ye-1][Ee-1]+1;else throw new Error("not possible")}}if(N&&ee(G,oe,pe,Ae),!Je[0]&&!Fe.firstMatchCanBeWeak)return;ye--,Ee--;const He=[ue[ye][Ee],Ae];let Xe=0,Ke=0;for(;ye>=1;){let Qe=Ee;do{const Ve=L[ye][Qe];if(Ve===3)Qe=Qe-2;else if(Ve===2)Qe=Qe-1;else break}while(Qe>=1);Xe>1&&x[oe+ye-1]===ke[Ae+Ee-1]&&!fe(Qe+Ae-1,pe,ke)&&Xe+1>X[ye][Qe]&&(Qe=Ee),Qe===Ee?Xe++:Xe=1,Ke||(Ke=Qe),ye--,Ee=Qe-1,He.push(Ee)}me===je&&Fe.boostFullMatch&&(He[0]+=2);const nt=Ke-je;return He[0]-=nt,He}e.fuzzyScore=se;function de(G,x,oe,pe,ke,Ae){let Fe=G-1,je=x-1;for(;Fe>=oe&&je>=pe;)ke[Fe]===Ae[je]&&(V[Fe]=je,Fe--),je--}function z(G,x,oe,pe,ke,Ae,Fe,je,me,ye,Ee){if(x[oe]!==Ae[Fe])return Number.MIN_SAFE_INTEGER;let Me=1,Be=!1;return Fe===oe-pe?Me=G[oe]===ke[Fe]?7:5:fe(Fe,ke,Ae)&&(Fe===0||!fe(Fe-1,ke,Ae))?(Me=G[oe]===ke[Fe]?7:5,Be=!0):ae(Ae,Fe)&&(Fe===0||!ae(Ae,Fe-1))?Me=5:(ae(Ae,Fe-1)||ge(Ae,Fe-1))&&(Me=5,Be=!0),Me>1&&oe===pe&&(Ee[0]=!0),Be||(Be=fe(Fe,ke,Ae)||ae(Ae,Fe-1)||ge(Ae,Fe-1)),oe===pe?Fe>me&&(Me-=Be?3:5):ye?Me+=Be?2:0:Me+=Be?0:1,Fe+1===je&&(Me-=Be?3:5),Me}function Y(G,x,oe,pe,ke,Ae,Fe){return j(G,x,oe,pe,ke,Ae,!0,Fe)}e.fuzzyScoreGracefulAggressive=Y;function _(G,x,oe,pe,ke,Ae,Fe){return j(G,x,oe,pe,ke,Ae,!1,Fe)}e.fuzzyScoreGraceful=_;function j(G,x,oe,pe,ke,Ae,Fe,je){let me=se(G,x,oe,pe,ke,Ae,je);if(me&&!Fe)return me;if(G.length>=3){const ye=Math.min(7,G.length-1);for(let Ee=oe+1;Ee<ye;Ee++){const Me=q(G,Ee);if(Me){const Be=se(Me,Me.toLowerCase(),oe,pe,ke,Ae,je);Be&&(Be[0]-=3,(!me||Be[0]>me[0])&&(me=Be))}}}return me}function q(G,x){if(x+1>=G.length)return;const oe=G[x],pe=G[x+1];if(oe!==pe)return G.slice(0,x)+pe+oe+G.slice(x+2)}}),define(be[89],ve([1,0,15]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return P(d,0)}e.hash=t;function P(d,b){switch(typeof d){case"object":return d===null?S(349,b):Array.isArray(d)?y(d,b):E(d,b);case"string":return A(d,b);case"boolean":return D(d,b);case"number":return S(d,b);case"undefined":return S(937,b);default:return S(617,b)}}e.doHash=P;function S(d,b){return(b<<5)-b+d|0}e.numberHash=S;function D(d,b){return S(d?433:863,b)}function A(d,b){b=S(149417,b);for(let c=0,f=d.length;c<f;c++)b=S(d.charCodeAt(c),b);return b}e.stringHash=A;function y(d,b){return b=S(104579,b),d.reduce((c,f)=>P(f,c),b)}function E(d,b){return b=S(181387,b),Object.keys(d).sort().reduce((c,f)=>(c=A(f,c),P(d[f],c)),b)}class I{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=P(b,this.g),this.g}}e.Hasher=I;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function C(d,b,c=32){const f=c-b,u=~((1<<f)-1);return(d<<b|(u&d)>>>f)>>>0}function p(d,b=0,c=d.byteLength,f=0){for(let u=0;u<c;u++)d[b+u]=f}function m(d,b,c="0"){for(;d.length<b;)d=c+d;return d}function g(d,b=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(c=>c.toString(16).padStart(2,"0")).join(""):m((d>>>0).toString(16),b/4)}e.toHexString=g;class w{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const c=b.length;if(c===0)return;const f=this.p;let u=this.r,i=this.u,n,r;for(i!==0?(n=i,r=-1,i=0):(n=b.charCodeAt(0),r=0);;){let o=n;if(v.isHighSurrogate(n))if(r+1<c){const a=b.charCodeAt(r+1);v.isLowSurrogate(a)?(r++,o=v.computeCodePoint(n,a)):o=65533}else{i=n;break}else v.isLowSurrogate(n)&&(o=65533);if(u=this.w(f,u,o),r++,r<c)n=b.charCodeAt(r);else break}this.r=u,this.u=i}w(b,c,f){return f<128?b[c++]=f:f<2048?(b[c++]=192|(f&1984)>>>6,b[c++]=128|(f&63)>>>0):f<65536?(b[c++]=224|(f&61440)>>>12,b[c++]=128|(f&4032)>>>6,b[c++]=128|(f&63)>>>0):(b[c++]=240|(f&1835008)>>>18,b[c++]=128|(f&258048)>>>12,b[c++]=128|(f&4032)>>>6,b[c++]=128|(f&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=w.g,c=this.q;for(let s=0;s<64;s+=4)b.setUint32(s,c.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)b.setUint32(s,C(b.getUint32(s-12,!1)^b.getUint32(s-32,!1)^b.getUint32(s-56,!1)^b.getUint32(s-64,!1),1),!1);let f=this.h,u=this.l,i=this.m,n=this.n,r=this.o,o,a,l;for(let s=0;s<80;s++)s<20?(o=u&i|~u&n,a=1518500249):s<40?(o=u^i^n,a=1859775393):s<60?(o=u&i|u&n|i&n,a=2400959708):(o=u^i^n,a=3395469782),l=C(f,5)+o+r+a+b.getUint32(s*4,!1)&4294967295,r=n,n=i,i=C(u,30),u=f,f=l;this.h=this.h+f&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.StringSHA1=w,w.g=new DataView(new ArrayBuffer(320))}),define(be[142],ve([1,0,41,141,15]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const S="$(",D=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(v.CSSIcon.iconNameCharacter),y=new RegExp(`(\\\\)?${D.source}`,"g");function E(d){return d.replace(y,(b,c)=>c?b:`\\${b}`)}e.escapeIcons=E;const I=new RegExp(`\\\\${D.source}`,"g");function k(d){return d.replace(I,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=k;const C=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function p(d){return d.indexOf(S)===-1?d:d.replace(C,(b,c,f,u)=>f?b:c||u||"")}e.stripIcons=p;function m(d){const b=d.indexOf(S);return b===-1?{text:d}:g(d,b)}e.parseLabelWithIcons=m;function g(d,b){const c=[];let f="";function u(h){if(h){f+=h;for(const T of h)c.push(r)}}let i=-1,n="",r=0,o,a,l=b;const s=d.length;for(u(d.substr(0,b));l<s;)o=d[l],a=d[l+1],o===S[0]&&a===S[1]?(i=l,u(n),n=S,l++):o===")"&&i!==-1?(r+=l-i+1,i=-1,n=""):i!==-1?A.test(o)?n+=o:(u(n),i=-1,n=""):u(o),l++;return u(n),{text:f,iconOffsets:c}}function w(d,b,c=!1){const{text:f,iconOffsets:u}=b;if(!u||u.length===0)return(0,t.matchesFuzzy)(d,f,c);const i=(0,P.ltrim)(f," "),n=f.length-i.length,r=(0,t.matchesFuzzy)(d,i,c);if(r)for(const o of r){const a=u[o.start+n]+n;o.start+=a,o.end+=a}return r}e.matchesFuzzyIconAware=w}),define(be[70],ve([1,0,15]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(t||(t={})),function(P){const S="error",D="warning",A="warn",y="info",E="ignore";function I(C){return C?v.equalsIgnoreCase(S,C)?P.Error:v.equalsIgnoreCase(D,C)||v.equalsIgnoreCase(A,C)?P.Warning:v.equalsIgnoreCase(y,C)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function k(C){switch(C){case P.Error:return S;case P.Warning:return D;case P.Info:return y;default:return E}}P.toString=k}(t||(t={})),e.default=t}),define(be[58],ve([1,0,18,15]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class P{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const m=p.charCodeAt(0),g=this.b.charCodeAt(this.c);return m-g}value(){return this.b[this.c]}}e.StringIterator=P;class S{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,t.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=S;class D{constructor(p=!0,m=!0){this.f=p,this.g=m}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let m=p.length-1;m>=0;m--,this.c--){const g=this.b.charCodeAt(m);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,t.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var A;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(p,m){this.f=p,this.g=m,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,t.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(I||(I={}));class k{static forUris(p=()=>!1,m=()=>!1){return new k(new y(p,m))}static forPaths(p=!1){return new k(new D(void 0,!p))}static forStrings(){return new k(new P)}static forConfigKeys(){return new k(new S)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,m){if(m){const g=m.slice(0);(0,v.shuffle)(g);for(const w of g)this.set(w,p)}else{const g=p.slice(0);(0,v.shuffle)(g);for(const w of g)this.set(w[0],w[1])}}set(p,m){const g=this.b.reset(p);let w;this.c||(this.c=new E,this.c.segment=g.value());const d=[];for(w=this.c;;){const c=g.cmp(w.segment);if(c>0)w.left||(w.left=new E,w.left.segment=g.value()),d.push([-1,w]),w=w.left;else if(c<0)w.right||(w.right=new E,w.right.segment=g.value()),d.push([1,w]),w=w.right;else if(g.hasNext())g.next(),w.mid||(w.mid=new E,w.mid.segment=g.value()),d.push([0,w]),w=w.mid;else break}const b=w.value;w.value=m,w.key=p;for(let c=d.length-1;c>=0;c--){const f=d[c][1];f.updateHeight();const u=f.balanceFactor();if(u<-1||u>1){const i=d[c][0],n=d[c+1][0];if(i===1&&n===1)d[c][1]=f.rotateLeft();else if(i===-1&&n===-1)d[c][1]=f.rotateRight();else if(i===1&&n===-1)f.right=d[c+1][1]=d[c+1][1].rotateRight(),d[c][1]=f.rotateLeft();else if(i===-1&&n===1)f.left=d[c+1][1]=d[c+1][1].rotateLeft(),d[c][1]=f.rotateRight();else throw new Error;if(c>0)switch(d[c-1][0]){case-1:d[c-1][1].left=d[c][1];break;case 1:d[c-1][1].right=d[c][1];break;case 0:d[c-1][1].mid=d[c][1];break}else this.c=d[0][1]}}return b}get(p){return this.d(p)?.value}d(p){const m=this.b.reset(p);let g=this.c;for(;g;){const w=m.cmp(g.segment);if(w>0)g=g.left;else if(w<0)g=g.right;else if(m.hasNext())m.next(),g=g.mid;else break}return g}has(p){const m=this.d(p);return!(m?.value===void 0&&m?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,m){const g=this.b.reset(p),w=[];let d=this.c;for(;d;){const b=g.cmp(d.segment);if(b>0)w.push([-1,d]),d=d.left;else if(b<0)w.push([1,d]),d=d.right;else if(g.hasNext())g.next(),w.push([0,d]),d=d.mid;else break}if(!!d){if(m?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const b=this.f(d.right);if(b.key){const{key:c,value:f,segment:u}=b;this.e(b.key,!1),d.key=c,d.value=f,d.segment=u}}else{const b=d.left??d.right;if(w.length>0){const[c,f]=w[w.length-1];switch(c){case-1:f.left=b;break;case 0:f.mid=b;break;case 1:f.right=b;break}}else this.c=b}for(let b=w.length-1;b>=0;b--){const c=w[b][1];c.updateHeight();const f=c.balanceFactor();if(f>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),w[b][1]=c.rotateLeft()):f<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),w[b][1]=c.rotateRight()),b>0)switch(w[b-1][0]){case-1:w[b-1][1].left=w[b][1];break;case 1:w[b-1][1].right=w[b][1];break;case 0:w[b-1][1].mid=w[b][1];break}else this.c=w[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const m=this.b.reset(p);let g=this.c,w;for(;g;){const d=m.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(m.hasNext())m.next(),w=g.value||w,g=g.mid;else break}return g&&g.value||w}findSuperstr(p){const m=this.b.reset(p);let g=this.c;for(;g;){const w=m.cmp(g.segment);if(w>0)g=g.left;else if(w<0)g=g.right;else if(m.hasNext())m.next(),g=g.mid;else return g.mid?this.g(g.mid):void 0}}forEach(p){for(const[m,g]of this)p(g,m)}*[Symbol.iterator](){yield*this.g(this.c)}g(p){const m=[];return this.h(p,m),m[Symbol.iterator]()}h(p,m){!p||(p.left&&this.h(p.left,m),p.value&&m.push([p.key,p.value]),p.mid&&this.h(p.mid,m),p.right&&this.h(p.right,m))}_isBalanced(){const p=m=>{if(!m)return!0;const g=m.balanceFactor();return g<-1||g>1?!1:p(m.left)&&p(m.right)};return p(this.c)}}e.TernarySearchTree=k}),define(be[9],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(n){return typeof n=="string"}e.isString=v;function t(n){return Array.isArray(n)&&n.every(r=>v(r))}e.isStringArray=t;function P(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=P;function S(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}e.isTypedArray=S;function D(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=D;function A(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=A;function y(n){return n===!0||n===!1}e.isBoolean=y;function E(n){return typeof n>"u"}e.isUndefined=E;function I(n){return!k(n)}e.isDefined=I;function k(n){return E(n)||n===null}e.isUndefinedOrNull=k;function C(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=C;function p(n){if(k(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=p;function m(...n){const r=[];for(let o=0;o<n.length;o++){const a=n[o];if(k(a))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);r.push(a)}return r}e.assertAllDefined=m;const g=Object.prototype.hasOwnProperty;function w(n){if(!P(n))return!1;for(const r in n)if(g.call(n,r))return!1;return!0}e.isEmptyObject=w;function d(n){return typeof n=="function"}e.isFunction=d;function b(...n){return n.length>0&&n.every(d)}e.areFunctions=b;function c(n,r){const o=Math.min(n.length,r.length);for(let a=0;a<o;a++)f(n[a],r[a])}e.validateConstraints=c;function f(n,r){if(v(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(n instanceof r)return}catch{}if(!k(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function u(n){return n===null?void 0:n}e.withNullAsUndefined=u;function i(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=i}),define(be[37],ve([1,0,7,3,15,9]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(a){return a===47||a===92}e.isPathSeparator=D;function A(a){return a.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=A;function y(a){return a.indexOf("/")===-1&&(a=A(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=y;function E(a,l=v.posix.sep){if(!a)return"";const s=a.length,h=a.charCodeAt(0);if(D(h)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let F=3;const Z=F;for(;F<s&&!D(a.charCodeAt(F));F++);if(Z!==F&&!D(a.charCodeAt(F+1))){for(F+=1;F<s;F++)if(D(a.charCodeAt(F)))return a.slice(0,F+1).replace(/[\\/]/g,l)}}return l}else if(d(h)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+l:a.slice(0,2);let T=a.indexOf("://");if(T!==-1){for(T+=3;T<s;T++)if(D(a.charCodeAt(T)))return a.slice(0,T+1)}return""}e.getRoot=E;function I(a){if(!t.isWindows||!a||a.length<5)return!1;let l=a.charCodeAt(0);if(l!==92||(l=a.charCodeAt(1),l!==92))return!1;let s=2;const h=s;for(;s<a.length&&(l=a.charCodeAt(s),l!==92);s++);return!(h===s||(l=a.charCodeAt(s+1),isNaN(l)||l===92))}e.isUNC=I;const k=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(a,l=t.isWindows){const s=l?k:C;return!(!a||a.length===0||/^\s+$/.test(a)||(s.lastIndex=0,s.test(a))||l&&p.test(a)||a==="."||a===".."||l&&a[a.length-1]==="."||l&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=m;function g(a,l,s){const h=a===l;return!s||h?h:!a||!l?!1:(0,P.equalsIgnoreCase)(a,l)}e.isEqual=g;function w(a,l,s,h=v.sep){if(a===l)return!0;if(!a||!l||l.length>a.length)return!1;if(s){if(!(0,P.startsWithIgnoreCase)(a,l))return!1;if(l.length===a.length)return!0;let F=l.length;return l.charAt(l.length-1)===h&&F--,a.charAt(F)===h}return l.charAt(l.length-1)!==h&&(l+=h),a.indexOf(l)===0}e.isEqualOrParent=w;function d(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=d;function b(a,l){return t.isWindows&&a.endsWith(":")&&(a+=v.sep),(0,v.isAbsolute)(a)||(a=(0,v.join)(l,a)),a=(0,v.normalize)(a),t.isWindows?(a=(0,P.rtrim)(a,v.sep),a.endsWith(":")&&(a+=v.sep)):(a=(0,P.rtrim)(a,v.sep),a||(a=v.sep)),a}e.sanitizeFilePath=b;function c(a){const l=(0,v.normalize)(a);return t.isWindows?a.length>3?!1:f(l)&&(a.length===2||l.charCodeAt(2)===92):l===v.posix.sep}e.isRootOrDriveLetter=c;function f(a,l=t.isWindows){return l?d(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function u(a){return f(a)?a[0]:void 0}e.getDriveLetter=u;function i(a,l,s){return l.length>a.length?-1:a===l?0:(s&&(a=a.toLowerCase(),l=l.toLowerCase()),a.indexOf(l))}e.indexOfPath=i;function n(a){const l=a.split(":");let s,h,T;for(const F of l){const Z=Number(F);(0,S.isNumber)(Z)?h===void 0?h=Z:T===void 0&&(T=Z):s=s?[s,F].join(":"):F}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:h!==void 0?h:void 0,column:T!==void 0?T:h!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(a,l,s=8){let h="";for(let F=0;F<s;F++)h+=r.charAt(Math.floor(Math.random()*r.length));let T;return l?T=`${l}-${h}`:T=h,a?(0,v.join)(a,T):T}e.randomPath=o}),define(be[23],ve([1,0,9]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const b=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([c,f])=>{b[c]=f&&typeof f=="object"?t(f):f}),b}e.deepClone=t;function P(d){if(!d||typeof d!="object")return d;const b=[d];for(;b.length>0;){const c=b.shift();Object.freeze(c);for(const f in c)if(S.call(c,f)){const u=c[f];typeof u=="object"&&!Object.isFrozen(u)&&!(0,v.isTypedArray)(u)&&b.push(u)}}return d}e.deepFreeze=P;const S=Object.prototype.hasOwnProperty;function D(d,b){return A(d,b,new Set)}e.cloneAndChange=D;function A(d,b,c){if((0,v.isUndefinedOrNull)(d))return d;const f=b(d);if(typeof f<"u")return f;if(Array.isArray(d)){const u=[];for(const i of d)u.push(A(i,b,c));return u}if((0,v.isObject)(d)){if(c.has(d))throw new Error("Cannot clone recursive data-structure");c.add(d);const u={};for(const i in d)S.call(d,i)&&(u[i]=A(d[i],b,c));return c.delete(d),u}return d}function y(d,b,c=!0){return(0,v.isObject)(d)?((0,v.isObject)(b)&&Object.keys(b).forEach(f=>{f in d?c&&((0,v.isObject)(d[f])&&(0,v.isObject)(b[f])?y(d[f],b[f],c):d[f]=b[f]):d[f]=b[f]}),d):b}e.mixin=y;function E(d,b){if(d===b)return!0;if(d==null||b===null||b===void 0||typeof d!=typeof b||typeof d!="object"||Array.isArray(d)!==Array.isArray(b))return!1;let c,f;if(Array.isArray(d)){if(d.length!==b.length)return!1;for(c=0;c<d.length;c++)if(!E(d[c],b[c]))return!1}else{const u=[];for(f in d)u.push(f);u.sort();const i=[];for(f in b)i.push(f);if(i.sort(),!E(u,i))return!1;for(c=0;c<u.length;c++)if(!E(d[u[c]],b[u[c]]))return!1}return!0}e.equals=E;function I(d){const b=new Set;return JSON.stringify(d,(c,f)=>{if((0,v.isObject)(f)||Array.isArray(f)){if(b.has(f))return"[Circular]";b.add(f)}return f})}e.safeStringify=I;function k(d,b){const c=Object.create(null);return!d||!b||Object.keys(b).forEach(u=>{const i=d[u],n=b[u];E(i,n)||(c[u]=n)}),c}e.distinct=k;function C(d,b){const c=b.toLowerCase(),f=Object.keys(d).find(u=>u.toLowerCase()===c);return f?d[f]:d[b]}e.getCaseInsensitive=C;function p(d,b){const c=Object.create(null);for(const[f,u]of Object.entries(d))b(f,u)&&(c[f]=u);return c}e.filter=p;function m(d){let b=[],c=Object.getPrototypeOf(d);for(;Object.prototype!==c;)b=b.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return b}e.getAllPropertyNames=m;function g(d){const b=[];for(const c of m(d))typeof d[c]=="function"&&b.push(c);return b}e.getAllMethodNames=g;function w(d,b){const c=u=>function(){const i=Array.prototype.slice.call(arguments,0);return b(u,i)},f={};for(const u of d)f[u]=c(u);return f}e.createProxyObject=w}),define(be[4],ve([1,0,7,3]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,S=/^\//,D=/^\/\//;function A(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!P.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,o){return!r&&!o?"file":r}function E(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const I="",k="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(o){return o instanceof p?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,a,l,s,h,T=!1){typeof o=="object"?(this.scheme=o.scheme||I,this.authority=o.authority||I,this.path=o.path||I,this.query=o.query||I,this.fragment=o.fragment||I):(this.scheme=y(o,T),this.authority=a||I,this.path=E(this.scheme,l||I),this.query=s||I,this.fragment=h||I,A(this,T))}get fsPath(){return c(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:l,path:s,query:h,fragment:T}=o;return a===void 0?a=this.scheme:a===null&&(a=I),l===void 0?l=this.authority:l===null&&(l=I),s===void 0?s=this.path:s===null&&(s=I),h===void 0?h=this.query:h===null&&(h=I),T===void 0?T=this.fragment:T===null&&(T=I),a===this.scheme&&l===this.authority&&s===this.path&&h===this.query&&T===this.fragment?this:new g(a,l,s,h,T)}static parse(o,a=!1){const l=C.exec(o);return l?new g(l[2]||I,n(l[4]||I),n(l[5]||I),n(l[7]||I),n(l[9]||I),a):new g(I,I,I,I,I)}static file(o){let a=I;if(t.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const l=o.indexOf(k,2);l===-1?(a=o.substring(2),o=k):(a=o.substring(2,l),o=o.substring(l)||k)}return new g("file",a,o,I,I)}static from(o){const a=new g(o.scheme,o.authority,o.path,o.query,o.fragment);return A(a,!0),a}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&o.scheme==="file"?l=p.file(v.win32.join(c(o,!0),...a)).path:l=v.posix.join(o.path,...a),o.with({path:l})}toString(o=!1){return f(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof p)return o;{const a=new g(o);return a._formatted=o.external,a._fsPath=o._sep===m?o.fsPath:null,a}}else return o}}e.URI=p;const m=t.isWindows?1:void 0;class g extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(o=!1){return o?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=m),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,o){let a,l=-1;for(let s=0;s<r.length;s++){const h=r.charCodeAt(s);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||o&&h===47)l!==-1&&(a+=encodeURIComponent(r.substring(l,s)),l=-1),a!==void 0&&(a+=r.charAt(s));else{a===void 0&&(a=r.substr(0,s));const T=w[h];T!==void 0?(l!==-1&&(a+=encodeURIComponent(r.substring(l,s)),l=-1),a+=T):l===-1&&(l=s)}}return l!==-1&&(a+=encodeURIComponent(r.substring(l))),a!==void 0?a:r}function b(r){let o;for(let a=0;a<r.length;a++){const l=r.charCodeAt(a);l===35||l===63?(o===void 0&&(o=r.substr(0,a)),o+=w[l]):o!==void 0&&(o+=r[a])}return o!==void 0?o:r}function c(r,o){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=c;function f(r,o){const a=o?b:d;let l="",{scheme:s,authority:h,path:T,query:F,fragment:Z}=r;if(s&&(l+=s,l+=":"),(h||s==="file")&&(l+=k,l+=k),h){let ne=h.indexOf("@");if(ne!==-1){const ce=h.substr(0,ne);h=h.substr(ne+1),ne=ce.indexOf(":"),ne===-1?l+=a(ce,!1):(l+=a(ce.substr(0,ne),!1),l+=":",l+=a(ce.substr(ne+1),!1)),l+="@"}h=h.toLowerCase(),ne=h.indexOf(":"),ne===-1?l+=a(h,!1):(l+=a(h.substr(0,ne),!1),l+=h.substr(ne))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const ne=T.charCodeAt(1);ne>=65&&ne<=90&&(T=`/${String.fromCharCode(ne+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const ne=T.charCodeAt(0);ne>=65&&ne<=90&&(T=`${String.fromCharCode(ne+32)}:${T.substr(2)}`)}l+=a(T,!0)}return F&&(l+="?",l+=a(F,!1)),Z&&(l+="#",l+=o?Z:d(Z,!1)),l}function u(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+u(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(i)?r.replace(i,o=>u(o)):r}}),define(be[143],ve([1,0,4]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(E){const I=E;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function P(E){const I=[];let k;try{const C=JSON.parse(E.arguments),p=C[C.length-1];p&&p.__$stack&&(C.pop(),k=p.__$stack),I.push(...C)}catch{I.push("Unable to log remote console arguments",E.arguments)}return{args:I,stack:k}}e.parse=P;function S(E){if(typeof E!="string")return S(P(E).stack);const I=E;if(I){const k=D(I),C=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(C&&C.length===4)return{uri:v.URI.file(C[1]),line:Number(C[2]),column:Number(C[3])}}}e.getFirstFrame=S;function D(E){if(!E)return E;const I=E.indexOf(`
`);return I===-1?E:E.substring(0,I)}function A(E,I){const{args:k,stack:C}=P(E),p=typeof k[0]=="string"&&k.length===1;let m=D(C);m&&(m=`(${m.trim()})`);let g=[];if(typeof k[0]=="string"?m&&p?g=[`%c[${I}] %c${k[0]} %c${m}`,y("blue"),y(""),y("grey")]:g=[`%c[${I}] %c${k[0]}`,y("blue"),y(""),...k.slice(1)]:g=[`%c[${I}]%`,y("blue"),...k],m&&!p&&g.push(m),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,g)}e.log=A;function y(E){return`color: ${E}`}}),define(be[45],ve([1,0,16,15,4]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(E){return JSON.stringify(E,A)}e.stringify=S;function D(E){let I=JSON.parse(E);return I=y(I),I}e.parse=D;function A(E,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function y(E,I=0){if(!E||I>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return P.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 16:return new Date(E.source)}if(E instanceof v.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let k=0;k<E.length;++k)E[k]=y(E[k],I+1);else for(const k in E)Object.hasOwnProperty.call(E,k)&&(E[k]=y(E[k],I+1))}return E}e.revive=y}),define(be[13],ve([1,0,3,4]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var P;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(P=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(E){this.d=E}setDelegate(E){this.e=E}setServerRootPath(E){this.f=`${E}/${P.vscodeRemoteResource}`}set(E,I,k){this.a[E]=I,this.b[E]=k}setConnectionToken(E,I){this.c[E]=I}getPreferredWebSchema(){return this.d}rewrite(E){if(this.e)return this.e(E);const I=E.authority;let k=this.a[I];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const C=this.b[I],p=this.c[I];let m=`path=${encodeURIComponent(E.path)}`;return typeof p=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),t.URI.from({scheme:v.isWeb?this.d:P.vscodeRemoteResource,authority:`${k}:${C}`,path:v.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:m})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(E){const I=this.b(E,re);return this.uriToBrowserUri(I)}uriToBrowserUri(E){return E.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===P.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${P.vscodeFileResource}://${D.a}`)?E.with({scheme:P.vscodeFileResource,authority:E.authority||D.a,query:null,fragment:null}):E}asFileUri(E){const I=this.b(E,re);return this.uriToFileUri(I)}uriToFileUri(E){return E.scheme===P.vscodeFileResource?E.with({scheme:P.file,authority:E.authority!==D.a?E.authority:null,query:null,fragment:null}):E}b(E,I){return t.URI.isUri(E)?E:t.URI.parse(I.toUrl(E))}}D.a="vscode-app",e.FileAccess=new D;var A;(function(y){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(E.get("3"));const I="vscode-coi";function k(p){let m;typeof p=="string"?m=new URL(p).searchParams:p instanceof URL?m=p.searchParams:t.URI.isUri(p)&&(m=new URL(p.toString(!0)).searchParams);const g=m?.get(I);if(!!g)return E.get(g)}y.getHeadersFromQuery=k;function C(p,m,g){if(!globalThis.crossOriginIsolated)return;const w=m&&g?"3":g?"2":"1";p instanceof URLSearchParams?p.set(I,w):p[I]=w}y.addSearchParam=C})(A=e.COI||(e.COI={}))}),define(be[20],ve([1,0,37,13,7,3,15,4]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(p){return(0,A.uriToFsPath)(p,!0)}e.originalFSPath=y;class E{constructor(m){this.a=m}compare(m,g,w=!1){return m===g?0:(0,D.compare)(this.getComparisonKey(m,w),this.getComparisonKey(g,w))}isEqual(m,g,w=!1){return m===g?!0:!m||!g?!1:this.getComparisonKey(m,w)===this.getComparisonKey(g,w)}getComparisonKey(m,g=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,g,w=!1){if(m.scheme===g.scheme){if(m.scheme===t.Schemas.file)return v.isEqualOrParent(y(m),y(g),this.a(m))&&m.query===g.query&&(w||m.fragment===g.fragment);if((0,e.isEqualAuthority)(m.authority,g.authority))return v.isEqualOrParent(m.path,g.path,this.a(m),"/")&&m.query===g.query&&(w||m.fragment===g.fragment)}return!1}joinPath(m,...g){return A.URI.joinPath(m,...g)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return P.posix.basename(m.path)}extname(m){return P.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let g;return m.scheme===t.Schemas.file?g=A.URI.file(P.dirname(y(m))).path:(g=P.posix.dirname(m.path),m.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),g="/")),m.with({path:g})}normalizePath(m){if(!m.path.length)return m;let g;return m.scheme===t.Schemas.file?g=A.URI.file(P.normalize(y(m))).path:g=P.posix.normalize(m.path),m.with({path:g})}relativePath(m,g){if(m.scheme!==g.scheme||!(0,e.isEqualAuthority)(m.authority,g.authority))return;if(m.scheme===t.Schemas.file){const b=P.relative(y(m),y(g));return S.isWindows?v.toSlashes(b):b}let w=m.path||"/";const d=g.path||"/";if(this.a(m)){let b=0;for(const c=Math.min(w.length,d.length);b<c&&!(w.charCodeAt(b)!==d.charCodeAt(b)&&w.charAt(b).toLowerCase()!==d.charAt(b).toLowerCase());b++);w=d.substr(0,b)+w.substr(b)}return P.posix.relative(w,d)}resolvePath(m,g){if(m.scheme===t.Schemas.file){const w=A.URI.file(P.resolve(y(m),g));return m.with({authority:w.authority,path:w.path})}return g=v.toPosixPath(g),m.with({path:P.posix.resolve(m.path,g)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,g){return m===g||m!==void 0&&g!==void 0&&(0,D.equalsIgnoreCase)(m,g)}hasTrailingPathSeparator(m,g=P.sep){if(m.scheme===t.Schemas.file){const w=y(m);return w.length>v.getRoot(w).length&&w[w.length-1]===g}else{const w=m.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,g=P.sep){return(0,e.hasTrailingPathSeparator)(m,g)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,g=P.sep){let w=!1;if(m.scheme===t.Schemas.file){const d=y(m);w=d!==void 0&&d.length===v.getRoot(d).length&&d[d.length-1]===g}else{g="/";const d=m.path;w=d.length===1&&d.charCodeAt(d.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(m,g)?m.with({path:m.path+"/"}):m}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(p=>p.scheme===t.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new E(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(p,m){const g=[];for(let w=0;w<p.length;w++){const d=m(p[w]);p.some((b,c)=>c===w?!1:(0,e.isEqualOrParent)(d,m(b)))||g.push(p[w])}return g}e.distinctParents=I;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function m(g){const w=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[f,u]=c.split(":");f&&u&&w.set(f,u)});const b=g.path.substring(0,g.path.indexOf(";"));return b&&w.set(p.META_DATA_MIME,b),w}p.parseMetaData=m})(k=e.DataUri||(e.DataUri={}));function C(p,m,g){if(m){let w=p.path;return w&&w[0]!==P.posix.sep&&(w=P.posix.sep+w),p.with({scheme:g,authority:m,path:w})}return p.with({scheme:g})}e.toLocalResource=C}),define(be[14],ve([1,0,19,8,6,2,20,3]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=y;function E(fe){const R=new v.CancellationTokenSource,U=fe(R.token),W=new Promise((Q,se)=>{const de=R.token.onCancellationRequested(()=>{de.dispose(),R.dispose(),se(new t.CancellationError)});Promise.resolve(U).then(z=>{de.dispose(),R.dispose(),Q(z)},z=>{de.dispose(),R.dispose(),se(z)})});return new class{cancel(){R.cancel()}then(Q,se){return W.then(Q,se)}catch(Q){return this.then(void 0,Q)}finally(Q){return W.finally(Q)}}}e.createCancelablePromise=E;function I(fe,R,U){return new Promise((W,Q)=>{const se=R.onCancellationRequested(()=>{se.dispose(),W(U)});fe.then(W,Q).finally(()=>se.dispose())})}e.raceCancellation=I;function k(fe,R){return new Promise((U,W)=>{const Q=R.onCancellationRequested(()=>{Q.dispose(),W(new t.CancellationError)});fe.then(U,W).finally(()=>Q.dispose())})}e.raceCancellationError=k;async function C(fe){let R=-1;const U=fe.map((Q,se)=>Q.then(de=>(R=se,de))),W=await Promise.race(U);return fe.forEach((Q,se)=>{se!==R&&Q.cancel()}),W}e.raceCancellablePromises=C;function p(fe,R,U){let W;const Q=setTimeout(()=>{W?.(void 0),U?.()},R);return Promise.race([fe.finally(()=>clearTimeout(Q)),new Promise(se=>W=se)])}e.raceTimeout=p;function m(fe){return new Promise((R,U)=>{const W=fe();y(W)?W.then(R,U):R(W)})}e.asPromise=m;class g{constructor(){this.a=null,this.b=null,this.d=null}queue(R){if(this.a){if(this.d=R,!this.b){const U=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(U,U).then(W)})}return new Promise((U,W)=>{this.b.then(U,W)})}return this.a=R(),new Promise((U,W)=>{this.a.then(Q=>{this.a=null,U(Q)},Q=>{this.a=null,W(Q)})})}}e.Throttler=g;class w{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.Sequencer=w;class d{constructor(){this.a=new Map}queue(R,U){const Q=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(R)===Q&&this.a.delete(R)});return this.a.set(R,Q),Q}}e.SequencerByKey=d;const b=(fe,R)=>{let U=!0;const W=setTimeout(()=>{U=!1,R()},fe);return{isTriggered:()=>U,dispose:()=>{clearTimeout(W),U=!1}}},c=fe=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,fe())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,U=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((Q,se)=>{this.d=Q,this.f=se}).then(()=>{if(this.b=null,this.d=null,this.g){const Q=this.g;return this.g=null,Q()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=U===e.MicrotaskDelay?c(W):b(U,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=f;class u{constructor(R){this.a=new f(R),this.b=new g}trigger(R,U){return this.a.trigger(()=>this.b.queue(R),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=u;class i{constructor(){this.a=!1,this.b=new Promise((R,U)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class n extends i{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=n;function r(fe,R){return R?new Promise((U,W)=>{const Q=setTimeout(()=>{se.dispose(),U()},fe),se=R.onCancellationRequested(()=>{clearTimeout(Q),se.dispose(),W(new t.CancellationError)})}):E(U=>r(fe,U))}e.timeout=r;function o(fe,R=0){const U=setTimeout(fe,R);return(0,S.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=o;function a(fe){const R=[];let U=0;const W=fe.length;function Q(){return U<W?fe[U++]():null}function se(de){de!=null&&R.push(de);const z=Q();return z?z.then(se):Promise.resolve(R)}return Promise.resolve(null).then(se)}e.sequence=a;function l(fe,R=W=>!!W,U=null){let W=0;const Q=fe.length,se=()=>{if(W>=Q)return Promise.resolve(U);const de=fe[W++];return Promise.resolve(de()).then(Y=>R(Y)?Promise.resolve(Y):se())};return se()}e.first=l;function s(fe,R=W=>!!W,U=null){if(fe.length===0)return Promise.resolve(U);let W=fe.length;const Q=()=>{W=-1;for(const se of fe)se.cancel?.()};return new Promise((se,de)=>{for(const z of fe)z.then(Y=>{--W>=0&&R(Y)?(Q(),se(Y)):W===0&&se(U)}).catch(Y=>{--W>=0&&(Q(),de(Y))})})}e.firstParallel=s;class h{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new P.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((U,W)=>{this.f.push({factory:R,c:U,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const U=R.factory();U.then(R.c,R.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class T extends h{constructor(){super(1)}}e.Queue=T;class F{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const R=new L;return this.b.add(R),R.p}d(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,U=D.extUri){const W=U.getComparisonKey(R);let Q=this.a.get(W);return Q||(Q=new T,P.Event.once(Q.onDrained)(()=>{Q?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,Q)),Q}f(){!this.d()||this.g()}g(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.g()}}e.ResourceQueue=F;class Z{constructor(R,U){this.a=-1,typeof R=="function"&&typeof U=="number"&&this.setIfNotSet(R,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},U)}setIfNotSet(R,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},U))}}e.TimeoutTimer=Z;class ne{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,U){this.cancel(),this.a=setInterval(()=>{R()},U)}}e.IntervalTimer=ne;class ce{constructor(R,U){this.b=-1,this.a=R,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ce;class ie{constructor(R,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=R,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ie;class M extends ce{constructor(R,U){super(R,U),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=M;class J extends S.Disposable{constructor(R,U){super(),this.g=R,this.h=U,this.a=[],this.b=this.B(new S.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...R),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ce(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(R)return;const U=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.runWhenIdle=(fe,R)=>{const U=requestIdleCallback(fe,typeof R=="number"?{timeout:R}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(U))}}}}();class ${constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=$;async function V(fe,R,U){let W;for(let Q=0;Q<U;Q++)try{return await fe()}catch(se){W=se,await r(R)}throw W}e.retry=V;class X{hasPending(R){return this.a?typeof R=="number"?this.a.taskId===R:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(R,U,W){return this.a={taskId:R,cancel:()=>W?.(),promise:U},U.then(()=>this.d(R),()=>this.d(R)),U}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this.b)this.b.run=R;else{let U,W;const Q=new Promise((se,de)=>{U=se,W=de});this.b={run:R,promise:Q,promiseResolve:U,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class ue{constructor(R,U=()=>Date.now()){this.d=R,this.f=U,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.IntervalCounter=ue;class L{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((R,U)=>{this.a=R,this.b=U})}complete(R){return new Promise(U=>{this.a(R),this.f=!0,U()})}error(R){return new Promise(U=>{this.b(R),this.d=!0,U()})}cancel(){new Promise(R=>{this.b(new t.CancellationError),this.d=!0,R()})}}e.DeferredPromise=L;var N;(function(fe){async function R(W){let Q;const se=await Promise.all(W.map(de=>de.then(z=>z,z=>{Q||(Q=z)})));if(typeof Q<"u")throw Q;return se}fe.settled=R;function U(W){return new Promise(async(Q,se)=>{try{await W(Q,se)}catch(de){se(de)}})}fe.withAsyncBody=U})(N=e.Promises||(e.Promises={}));var H;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(H||(H={}));class ee{static fromArray(R){return new ee(U=>{U.emitMany(R)})}static fromPromise(R){return new ee(async U=>{U.emitMany(await R)})}static fromPromises(R){return new ee(async U=>{await Promise.all(R.map(async W=>U.emitOne(await W)))})}static merge(R){return new ee(async U=>{await Promise.all(R.map(async W=>{for await(const Q of W)U.emitOne(Q)}))})}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new P.Emitter,queueMicrotask(async()=>{const U={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(R(U)),this.j()}catch(W){this.k(W)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(R,U){return new ee(async W=>{for await(const Q of R)W.emitOne(U(Q))})}map(R){return ee.map(this,R)}static filter(R,U){return new ee(async W=>{for await(const Q of R)U(Q)&&W.emitOne(Q)})}filter(R){return ee.filter(this,R)}static coalesce(R){return ee.filter(R,U=>!!U)}coalesce(){return ee.coalesce(this)}static async toPromise(R){const U=[];for await(const W of R)U.push(W);return U}toPromise(){return ee.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class ae extends ee{constructor(R,U){super(U),this.l=R}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ae;function ge(fe){const R=new v.CancellationTokenSource,U=fe(R.token);return new ae(R,async W=>{const Q=R.token.onCancellationRequested(()=>{Q.dispose(),R.dispose(),W.reject(new t.CancellationError)});try{for await(const se of U){if(R.token.isCancellationRequested)return;W.emitOne(se)}Q.dispose(),R.dispose()}catch(se){Q.dispose(),R.dispose(),W.reject(se)}})}e.createCancelableAsyncIterable=ge}),define(be[71],ve([1,0,18,14,37,26,7,3,15]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",k="[^/\\\\]",C=/\//g;function p(L,N){switch(L){case 0:return"";case 1:return`${k}*?`;default:return`(?:${I}|${k}+${I}${N?`|${I}${k}+`:""})*?`}}function m(L,N){if(!L)return[];const H=[];let ee=!1,ae=!1,ge="";for(const fe of L){switch(fe){case N:if(!ee&&!ae){H.push(ge),ge="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}ge+=fe}return ge&&H.push(ge),H}e.splitGlobAware=m;function g(L){if(!L)return"";let N="";const H=m(L,e.GLOB_SPLIT);if(H.every(ee=>ee===e.GLOBSTAR))N=".*";else{let ee=!1;H.forEach((ae,ge)=>{if(ae===e.GLOBSTAR){if(ee)return;N+=p(2,ge===H.length-1)}else{let fe=!1,R="",U=!1,W="";for(const Q of ae){if(Q!=="}"&&fe){R+=Q;continue}if(U&&(Q!=="]"||!W)){let se;Q==="-"?se=Q:(Q==="^"||Q==="!")&&!W?se="^":Q===e.GLOB_SPLIT?se="":se=(0,y.escapeRegExpCharacters)(Q),W+=se;continue}switch(Q){case"{":fe=!0;continue;case"[":U=!0;continue;case"}":{N+=`(?:${m(R,",").map(z=>g(z)).join("|")})`,fe=!1,R="";break}case"]":{N+="["+W+"]",U=!1,W="";break}case"?":N+=k;continue;case"*":N+=p(1);continue;default:N+=(0,y.escapeRegExpCharacters)(Q)}}ge<H.length-1&&(H[ge+1]!==e.GLOBSTAR||ge+2<H.length)&&(N+=I)}ee=ae===e.GLOBSTAR})}return N}const w=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new S.LRUCache(1e4),n=function(){return!1},r=function(){return null};function o(L,N){if(!L)return r;let H;typeof L!="string"?H=L.pattern:H=L,H=H.trim();const ee=`${H}_${!!N.trimForExclusions}`;let ae=i.get(ee);if(ae)return a(ae,L);let ge;return w.test(H)?ae=s(H.substr(4),H):(ge=d.exec(l(H,N)))?ae=h(ge[1],H):(N.trimForExclusions?c:b).test(H)?ae=T(H,N):(ge=f.exec(l(H,N)))?ae=F(ge[1].substr(1),H,!0):(ge=u.exec(l(H,N)))?ae=F(ge[1],H,!1):ae=Z(H),i.set(ee,ae),a(ae,L)}function a(L,N){if(typeof N=="string")return L;const H=function(ee,ae){return(0,P.isEqualOrParent)(ee,N.base,!A.isLinux)?L((0,y.ltrim)(ee.substr(N.base.length),D.sep),ae):null};return H.allBasenames=L.allBasenames,H.allPaths=L.allPaths,H.basenames=L.basenames,H.patterns=L.patterns,H}function l(L,N){return N.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function s(L,N){return function(H,ee){return typeof H=="string"&&H.endsWith(L)?N:null}}function h(L,N){const H=`/${L}`,ee=`\\${L}`,ae=function(fe,R){return typeof fe!="string"?null:R?R===L?N:null:fe===L||fe.endsWith(H)||fe.endsWith(ee)?N:null},ge=[L];return ae.basenames=ge,ae.patterns=[N],ae.allBasenames=ge,ae}function T(L,N){const H=X(L.slice(1,-1).split(",").map(R=>o(R,N)).filter(R=>R!==r),L),ee=H.length;if(!ee)return r;if(ee===1)return H[0];const ae=function(R,U){for(let W=0,Q=H.length;W<Q;W++)if(H[W](R,U))return L;return null},ge=H.find(R=>!!R.allBasenames);ge&&(ae.allBasenames=ge.allBasenames);const fe=H.reduce((R,U)=>U.allPaths?R.concat(U.allPaths):R,[]);return fe.length&&(ae.allPaths=fe),ae}function F(L,N,H){const ee=D.sep===D.posix.sep,ae=ee?L:L.replace(C,D.sep),ge=D.sep+ae,fe=D.posix.sep+L;let R;return H?R=function(U,W){return typeof U=="string"&&(U===ae||U.endsWith(ge)||!ee&&(U===L||U.endsWith(fe)))?N:null}:R=function(U,W){return typeof U=="string"&&(U===ae||!ee&&U===L)?N:null},R.allPaths=[(H?"*/":"./")+L],R}function Z(L){try{const N=new RegExp(`^${g(L)}$`);return function(H){return N.lastIndex=0,typeof H=="string"&&N.test(H)?L:null}}catch{return r}}function ne(L,N,H){return!L||typeof N!="string"?!1:ce(L)(N,void 0,H)}e.match=ne;function ce(L,N={}){if(!L)return n;if(typeof L=="string"||ie(L)){const H=o(L,N);if(H===r)return n;const ee=function(ae,ge){return!!H(ae,ge)};return H.allBasenames&&(ee.allBasenames=H.allBasenames),H.allPaths&&(ee.allPaths=H.allPaths),ee}return $(L,N)}e.parse=ce;function ie(L){const N=L;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=ie;function M(L){return L.allBasenames||[]}e.getBasenameTerms=M;function J(L){return L.allPaths||[]}e.getPathTerms=J;function $(L,N){const H=X(Object.getOwnPropertyNames(L).map(R=>V(R,L[R],N)).filter(R=>R!==r)),ee=H.length;if(!ee)return r;if(!H.some(R=>!!R.requiresSiblings)){if(ee===1)return H[0];const R=function(Q,se){let de;for(let z=0,Y=H.length;z<Y;z++){const _=H[z](Q,se);if(typeof _=="string")return _;(0,t.isThenable)(_)&&(de||(de=[]),de.push(_))}return de?(async()=>{for(const z of de){const Y=await z;if(typeof Y=="string")return Y}return null})():null},U=H.find(Q=>!!Q.allBasenames);U&&(R.allBasenames=U.allBasenames);const W=H.reduce((Q,se)=>se.allPaths?Q.concat(se.allPaths):Q,[]);return W.length&&(R.allPaths=W),R}const ae=function(R,U,W){let Q,se;for(let de=0,z=H.length;de<z;de++){const Y=H[de];Y.requiresSiblings&&W&&(U||(U=(0,D.basename)(R)),Q||(Q=U.substr(0,U.length-(0,D.extname)(R).length)));const _=Y(R,U,Q,W);if(typeof _=="string")return _;(0,t.isThenable)(_)&&(se||(se=[]),se.push(_))}return se?(async()=>{for(const de of se){const z=await de;if(typeof z=="string")return z}return null})():null},ge=H.find(R=>!!R.allBasenames);ge&&(ae.allBasenames=ge.allBasenames);const fe=H.reduce((R,U)=>U.allPaths?R.concat(U.allPaths):R,[]);return fe.length&&(ae.allPaths=fe),ae}function V(L,N,H){if(N===!1)return r;const ee=o(L,H);if(ee===r)return r;if(typeof N=="boolean")return ee;if(N){const ae=N.when;if(typeof ae=="string"){const ge=(fe,R,U,W)=>{if(!W||!ee(fe,R))return null;const Q=ae.replace("$(basename)",U),se=W(Q);return(0,t.isThenable)(se)?se.then(de=>de?L:null):se?L:null};return ge.requiresSiblings=!0,ge}}return ee}function X(L,N){const H=L.filter(R=>!!R.basenames);if(H.length<2)return L;const ee=H.reduce((R,U)=>{const W=U.basenames;return W?R.concat(W):R},[]);let ae;if(N){ae=[];for(let R=0,U=ee.length;R<U;R++)ae.push(N)}else ae=H.reduce((R,U)=>{const W=U.patterns;return W?R.concat(W):R},[]);const ge=function(R,U){if(typeof R!="string")return null;if(!U){let Q;for(Q=R.length;Q>0;Q--){const se=R.charCodeAt(Q-1);if(se===47||se===92)break}U=R.substr(Q)}const W=ee.indexOf(U);return W!==-1?ae[W]:null};ge.basenames=ee,ge.patterns=ae,ge.allBasenames=ee;const fe=L.filter(R=>!R.basenames);return fe.push(ge),fe}function ue(L,N){return(0,v.equals)(L,N,(H,ee)=>typeof H=="string"&&typeof ee=="string"?H===ee:typeof H!="string"&&typeof ee!="string"?H.base===ee.base&&H.pattern===ee.pattern:!1)}e.patternsEquals=ue}),define(be[90],ve([1,0,8,142,20,15,4]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(w){w[w.Paragraph=0]="Paragraph",w[w.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",b=!1){if(this.value=d,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(d,b=0){return this.value+=C(this.supportThemeIcons?(0,t.escapeIcons)(d):d).replace(/([ \t]+)/g,(c,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,b){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(d,b,c){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(d),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(d,b){const c=new RegExp((0,S.escapeRegExpCharacters)(b),"g");return d.replace(c,(f,u)=>d.charAt(u-1)!=="\\"?`\\${f}`:f)}}e.MarkdownString=y;function E(w){return I(w)?!w.value:Array.isArray(w)?w.every(E):!0}e.isEmptyMarkdownString=E;function I(w){return w instanceof y?!0:w&&typeof w=="object"?typeof w.value=="string"&&(typeof w.isTrusted=="boolean"||w.isTrusted===void 0)&&(typeof w.supportThemeIcons=="boolean"||w.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function k(w,d){return w===d?!0:!w||!d?!1:w.value===d.value&&w.isTrusted===d.isTrusted&&w.supportThemeIcons===d.supportThemeIcons&&w.supportHtml===d.supportHtml&&(w.baseUri===d.baseUri||!!w.baseUri&&!!d.baseUri&&(0,P.isEqual)(D.URI.from(w.baseUri),D.URI.from(d.baseUri)))}e.markdownStringEqual=k;function C(w){return w.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function p(w){return w.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function m(w){return w&&w.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function g(w){const d=[],b=w.split("|").map(f=>f.trim());w=b[0];const c=b[1];if(c){const f=/height=(\d+)/.exec(c),u=/width=(\d+)/.exec(c),i=f?f[1]:"",n=u?u[1]:"",r=isFinite(parseInt(n)),o=isFinite(parseInt(i));r&&d.push(`width="${n}"`),o&&d.push(`height="${i}"`)}return{href:w,dimensions:d}}e.parseHrefAndDimensions=g}),define(be[144],ve([1,0,18,37,7,3,20,15]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,o){const{os:a,tildify:l,relative:s}=o;if(s){const F=E(r,s,a);if(typeof F=="string")return F}let h=r.fsPath;if(a===1&&!S.isWindows?h=h.replace(/\//g,"\\"):a!==1&&S.isWindows&&(h=h.replace(/\\/g,"/")),a!==1&&l?.userHome){const F=l.userHome.fsPath;let Z;r.scheme!==l.userHome.scheme&&r.path.startsWith(P.posix.sep)?Z=l.userHome.with({path:r.path}).fsPath:Z=r.fsPath,h=C(Z,F,a)}return(a===1?P.win32:P.posix).normalize(I(h,a===1))}e.getPathLabel=y;function E(r,o,a){const l=a===1?P.win32:P.posix,s=a===3?D.extUri:D.extUriIgnorePathCase,h=o.getWorkspace(),T=(0,v.firstOrDefault)(h.folders);if(!T)return;r.scheme!==T.uri.scheme&&r.path.startsWith(P.posix.sep)&&(r=T.uri.with({path:r.path}));const F=o.getWorkspaceFolder(r);if(!F)return;let Z;if(s.isEqual(F.uri,r)?Z="":Z=s.relativePath(F.uri,r)??"",Z&&(Z=l.normalize(Z)),h.folders.length>1&&!o.noPrefix){const ne=F.name?F.name:s.basenameOrAuthority(F.uri);Z=Z?`${ne} \u2022 ${Z}`:ne}return Z}function I(r,o=S.isWindows){return(0,t.hasDriveLetter)(r,o)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let k=Object.create(null);function C(r,o,a=S.OS){if(a===1||!r||!o)return r;let l=k.original===o?k.normalized:void 0;l||(l=o,S.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,A.rtrim)(l,P.posix.sep)}${P.posix.sep}`,k={original:o,normalized:l});let s=r;return S.isWindows&&(s=(0,t.toSlashes)(s)),(a===3?s.startsWith(l):(0,A.startsWithIgnoreCase)(s,l))?`~/${s.substr(l.length)}`:r}e.tildify=C;function p(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=p;const m="\u2026",g="\\\\",w="~";function d(r,o=P.sep){const a=new Array(r.length);let l=!1;for(let s=0;s<r.length;s++){const h=r[s];if(h===""){a[s]=`.${o}`;continue}if(!h){a[s]=h;continue}l=!0;let T="",F=h;F.indexOf(g)===0?(T=F.substr(0,F.indexOf(g)+g.length),F=F.substr(F.indexOf(g)+g.length)):F.indexOf(o)===0?(T=F.substr(0,F.indexOf(o)+o.length),F=F.substr(F.indexOf(o)+o.length)):F.indexOf(w)===0&&(T=F.substr(0,F.indexOf(w)+w.length),F=F.substr(F.indexOf(w)+w.length));const Z=F.split(o);for(let ne=1;l&&ne<=Z.length;ne++)for(let ce=Z.length-ne;l&&ce>=0;ce--){l=!1;let ie=Z.slice(ce,ce+ne).join(o);for(let M=0;!l&&M<r.length;M++)if(M!==s&&r[M]&&r[M].indexOf(ie)>-1){const J=ce+ne===Z.length,$=ce>0&&r[M].indexOf(o)>-1?o+ie:ie,V=r[M].endsWith($);l=!J||V}if(!l){let M="";(Z[0].endsWith(":")||T!=="")&&(ce===1&&(ce=0,ne++,ie=Z[0]+o+ie),ce>0&&(M=Z[0]+o),M=T+M),ce>0&&(M=M+m+o),M=M+ie,ce+ne<Z.length&&(M=M+o+m),a[s]=M}}l&&(a[s]=h)}return a}e.shorten=d;var b;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function c(r,o=Object.create(null)){const a=[];let l=!1,s="";for(const h of r)if(h==="$"||l&&h==="{")s&&a.push({value:s,type:b.TEXT}),s="",l=!0;else if(h==="}"&&l){const T=o[s];if(typeof T=="string")T.length&&a.push({value:T,type:b.VARIABLE});else if(T){const F=a[a.length-1];(!F||F.type!==b.SEPARATOR)&&a.push({value:T.label,type:b.SEPARATOR})}s="",l=!1}else s+=h;return s&&!l&&a.push({value:s,type:b.TEXT}),a.filter((h,T)=>{if(h.type===b.SEPARATOR){const F=a[T-1],Z=a[T+1];return[F,Z].every(ne=>ne&&(ne.type===b.VARIABLE||ne.type===b.TEXT)&&ne.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=c;function f(r,o){return S.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):r.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function u(r,o){return S.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):S.isWindows?r.replace(/&&|&/g,a=>a==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=u;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function n(r){const o=r.indexOf("/")!==-1?P.posix:P.win32,a=o.basename(r),l=o.dirname(r);return a.length?{name:a,parentPath:l}:{name:l,parentPath:""}}e.splitName=n}),define(be[72],ve([1,0,4]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class P{constructor(k){this.a=k}transformIncoming(k){const C=this.a.transformIncoming(k);return C===k?k:t(v.URI.from(C))}transformOutgoing(k){const C=this.a.transformOutgoing(k);return C===k?k:t(v.URI.from(C))}transformOutgoingURI(k){const C=this.a.transformOutgoing(k);return C===k?k:v.URI.from(C)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function S(I,k,C){if(!I||C>200)return null;if(typeof I=="object"){if(I instanceof v.URI)return k.transformOutgoing(I);for(const p in I)if(Object.hasOwnProperty.call(I,p)){const m=S(I[p],k,C+1);m!==null&&(I[p]=m)}}return null}function D(I,k){const C=S(I,k,0);return C===null?I:C}e.transformOutgoingURIs=D;function A(I,k,C,p){if(!I||p>200)return null;if(typeof I=="object"){if(I.$mid===1)return C?v.URI.revive(k.transformIncoming(I)):k.transformIncoming(I);for(const m in I)if(Object.hasOwnProperty.call(I,m)){const g=A(I[m],k,C,p+1);g!==null&&(I[m]=g)}}return null}function y(I,k){const C=A(I,k,!1,0);return C===null?I:C}e.transformIncomingURIs=y;function E(I,k){const C=A(I,k,!0,0);return C===null?I:C}e.transformAndReviveIncomingURIs=E}),define(be[21],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(P){return v.test(P)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const S=new Uint8Array(16),D=[];for(let A=0;A<256;A++)D.push(A.toString(16).padStart(2,"0"));return function(){P(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let y=0,E="";return E+=D[S[y++]],E+=D[S[y++]],E+=D[S[y++]],E+=D[S[y++]],E+="-",E+=D[S[y++]],E+=D[S[y++]],E+="-",E+=D[S[y++]],E+=D[S[y++]],E+="-",E+=D[S[y++]],E+=D[S[y++]],E+="-",E+=D[S[y++]],E+=D[S[y++]],E+=D[S[y++]],E+=D[S[y++]],E+=D[S[y++]],E+=D[S[y++]],E}}()}),define(be[145],ve([1,0,18,21]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function P(A){return{id:(0,t.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=P;function S(A,y,E){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:E}),value:void 0}}e.createFileDataTransferItem=S;class D{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,E){const I=this.a.get(y);I?I.push(E):this.a.set(this.b(y),[E])}replace(y,E){this.a.set(this.b(y),[E])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,E]of this.a.entries())for(const I of E)yield[y,I]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[E,I]of this.entries())y(I,E)}b(y){return y.toLowerCase()}}e.VSDataTransfer=D,e.UriList=Object.freeze({create:A=>(0,v.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),function(){"use strict";function re(e,v,t){function P(p){return new Promise(m=>v.exists(p,m))}function S(p){return new Promise((m,g)=>{const w=new Date;v.utimes(p,w,w,d=>d?g(d):m())})}function D(p){return new Promise((m,g)=>v.mkdir(p,{recursive:!0},w=>w&&w.code!=="EEXIST"?g(w):m(p)))}function A(p){return new Promise((m,g)=>v.rm(p,{recursive:!0,force:!0,maxRetries:3},w=>w?g(w):m()))}function y(p){return new Promise((m,g)=>v.readFile(p,"utf8",(w,d)=>w?g(w):m(d)))}function E(p,m){return new Promise((g,w)=>v.writeFile(p,m,"utf8",d=>d?w(d):g()))}async function I(p){const m=e.join(p,"languagepacks.json");try{return JSON.parse(await y(m))}catch{}}function k(p,m){try{for(;m;){if(p[m])return m;{const g=m.lastIndexOf("-");if(g>0)m=m.substring(0,g);else return}}}catch(g){console.error("Resolving language pack configuration failed.",g)}}function C(p,m,g,w){if(w==="pseudo")return Promise.resolve({locale:w,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:w,availableLanguages:{}});if(w&&(w==="en"||w==="en-us"))return Promise.resolve({locale:w,availableLanguages:{}});const d=w;t.mark("code/willGenerateNls");const b=function(c){return t.mark("code/didGenerateNls"),Promise.resolve({locale:c,availableLanguages:{}})};try{return p?I(m).then(c=>{if(!c||(w=k(c,w),!w))return b(d);const f=c[w];let u;return!f||typeof f.hash!="string"||!f.translations||typeof(u=f.translations.vscode)!="string"?b(d):P(u).then(i=>{if(!i)return b(d);const n=f.hash+"."+w,r=e.join(m,"clp",n),o=e.join(r,p),a=e.join(r,"tcf.json"),l=e.join(r,"corrupted.info"),s={locale:d,availableLanguages:{"*":w},_languagePackId:n,_translationsConfigFile:a,_cacheRoot:r,_resolvedLanguagePackCoreLocation:o,_corruptedFile:l};return P(l).then(h=>{let T;return h?T=A(r):T=Promise.resolve(void 0),T.then(()=>P(o).then(F=>F?(S(o).catch(()=>{}),t.mark("code/didGenerateNls"),s):D(o).then(()=>Promise.all([y(g),y(u)])).then(Z=>{const ne=JSON.parse(Z[0]),ce=JSON.parse(Z[1]).contents,ie=Object.keys(ne.bundles),M=[];for(const J of ie){const $=ne.bundles[J],V=Object.create(null);for(const X of $){const ue=ne.keys[X],L=ne.messages[X],N=ce[X];let H;if(N){H=[];for(let ee=0;ee<ue.length;ee++){const ae=ue[ee],ge=typeof ae=="string"?ae:ae.key;let fe=N[ge];fe===void 0&&(fe=L[ee]),H.push(fe)}}else H=L;V[X]=H}M.push(E(e.join(o,J.replace(/\//g,"!")+".nls.json"),JSON.stringify(V)))}return M.push(E(a,JSON.stringify(f.translations))),Promise.all(M)}).then(()=>(t.mark("code/didGenerateNls"),s)).catch(Z=>(console.error("Generating translation files failed.",Z),b(w)))))})})}):b(d)}catch(c){return console.error("Generating translation files failed.",c),b(w)}}return{getNLSConfiguration:C}}if(typeof define=="function")define(be[146],ve([91,29,46]),function(e,v,t){return re(e,v,t)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("fs"),t=require("../common/performance");module.exports=re(e,v,t)}else throw new Error("Unknown context")}(),define(be[147],ve([1,0,28]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(D){const A=D.replace(/\-/g,":").toLowerCase();return!t.has(A)}function S(){const D=(0,v.networkInterfaces)();for(const A in D){const y=D[A];if(y){for(const{mac:E}of y)if(P(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=S}),define(be[92],ve([1,0,28,8,58,21,147]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(I){return this.a||(this.a=P.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(I)}value(){if(this.b===void 0){let I=0,k=0;const C=(0,v.networkInterfaces)();for(const p in C){const m=C[p];if(m)for(const{mac:g,internal:w}of m)w||(k+=1,this.c(g.toUpperCase())&&(I+=1))}this.b=k>0?I/k:0}return this.b}};let A;async function y(){return A||(A=(async()=>await E()||S.generateUuid())()),A}e.getMachineId=y;async function E(){try{const I=await new Promise((C,p)=>{re(["crypto"],C,p)}),k=(0,D.getMac)();return I.createHash("sha256").update(k,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(be[22],ve([1,0,29,28,273,14,37,88,7,3,20,4]),function(re,e,v,t,P,S,D,A,y,E,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var C;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function p($,V=C.UNLINK){if((0,D.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return V===C.UNLINK?g($):m($)}async function m($){try{const V=(0,D.randomPath)((0,t.tmpdir)());try{await v.promises.rename($,V)}catch(X){return X.code==="ENOENT"?void 0:g($)}g(V).catch(X=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function g($){return(0,P.promisify)(v.rm)($,{recursive:!0,force:!0,maxRetries:3})}function w($){if((0,D.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function d($,V){return f(await(V?b($):(0,P.promisify)(v.readdir)($)))}async function b($){try{return await(0,P.promisify)(v.readdir)($,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const V=[],X=await d($);for(const ue of X){let L=!1,N=!1,H=!1;try{const ee=await e.Promises.lstat((0,y.join)($,ue));L=ee.isFile(),N=ee.isDirectory(),H=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}V.push({name:ue,isFile:()=>L,isDirectory:()=>N,isSymbolicLink:()=>H})}return V}function c($){return f(v.readdirSync($))}e.readdirSync=c;function f($){return $.map(V=>typeof V=="string"?E.isMacintosh?(0,A.normalizeNFC)(V):V:(V.name=E.isMacintosh?(0,A.normalizeNFC)(V.name):V.name,V))}async function u($){const V=await d($),X=[];for(const ue of V)await n.existsDirectory((0,y.join)($,ue))&&X.push(ue);return X}function i($,V=1e3){return new Promise(X=>{let ue=!1;const L=setInterval(()=>{ue||(ue=!0,v.access($,N=>{ue=!1,N&&(clearInterval(L),X(void 0))}))},V)})}e.whenDeleted=i;var n;(function($){async function V(L){let N;try{if(N=await e.Promises.lstat(L),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(L),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(E.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw ee}throw H}}$.stat=V;async function X(L){try{const{stat:N,symbolicLink:H}=await $.stat(L);return N.isFile()&&H?.dangling!==!0}catch{}return!1}$.existsFile=X;async function ue(L){try{const{stat:N,symbolicLink:H}=await $.stat(L);return N.isDirectory()&&H?.dangling!==!0}catch{}return!1}$.existsDirectory=ue})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new S.ResourceQueue;function o($,V,X){return r.queueFor(k.URI.file($),I.extUriBiasedIgnorePathCase).queue(()=>{const ue=T(X);return new Promise((L,N)=>s($,V,ue,H=>H?N(H):L()))})}let a=!0;function l($){a=$}e.configureFlushOnWrite=l;function s($,V,X,ue){if(!a)return v.writeFile($,V,{mode:X.mode,flag:X.flag},ue);v.open($,X.flag,X.mode,(L,N)=>{if(L)return ue(L);v.writeFile(N,V,H=>{if(H)return v.close(N,()=>ue(H));v.fdatasync(N,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),l(!1)),v.close(N,ae=>ue(ae))))})})}function h($,V,X){const ue=T(X);if(!a)return v.writeFileSync($,V,{mode:ue.mode,flag:ue.flag});const L=v.openSync($,ue.flag,ue.mode);try{v.writeFileSync(L,V);try{v.fdatasyncSync(L)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l(!1)}}finally{v.closeSync(L)}}e.writeFileSync=h;function T($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function F($,V){if($!==V)try{await e.Promises.rename($,V)}catch(X){if($.toLowerCase()!==V.toLowerCase()&&X.code==="EXDEV"||$.endsWith("."))await Z($,V,{preserveSymlinks:!1}),await p($,C.MOVE);else throw X}}async function Z($,V,X){return ce($,V,{root:{source:$,target:V},options:X,handledSourcePaths:new Set})}const ne=511;async function ce($,V,X){if(X.handledSourcePaths.has($))return;X.handledSourcePaths.add($);const{stat:ue,symbolicLink:L}=await n.stat($);if(L){if(X.options.preserveSymlinks)try{return await J($,V,X)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(L.dangling)return}return ue.isDirectory()?ie($,V,ue.mode&ne,X):M($,V,ue.mode&ne)}async function ie($,V,X,ue){await e.Promises.mkdir(V,{recursive:!0,mode:X});const L=await d($);for(const N of L)await ce((0,y.join)($,N),(0,y.join)(V,N),ue)}async function M($,V,X){await e.Promises.copyFile($,V),await e.Promises.chmod(V,X)}async function J($,V,X){let ue=await e.Promises.readlink($);(0,D.isEqualOrParent)(ue,X.root.source,!E.isLinux)&&(ue=(0,y.join)(X.root.target,ue.substr(X.root.source.length+1))),await e.Promises.symlink(ue,V)}e.Promises=new class{get access(){return(0,P.promisify)(v.access)}get stat(){return(0,P.promisify)(v.stat)}get lstat(){return(0,P.promisify)(v.lstat)}get utimes(){return(0,P.promisify)(v.utimes)}get read(){return($,V,X,ue,L)=>new Promise((N,H)=>{v.read($,V,X,ue,L,(ee,ae,ge)=>ee?H(ee):N({bytesRead:ae,buffer:ge}))})}get readFile(){return(0,P.promisify)(v.readFile)}get write(){return($,V,X,ue,L)=>new Promise((N,H)=>{v.write($,V,X,ue,L,(ee,ae,ge)=>ee?H(ee):N({bytesWritten:ae,buffer:ge}))})}get appendFile(){return(0,P.promisify)(v.appendFile)}get fdatasync(){return(0,P.promisify)(v.fdatasync)}get truncate(){return(0,P.promisify)(v.truncate)}get rename(){return(0,P.promisify)(v.rename)}get copyFile(){return(0,P.promisify)(v.copyFile)}get open(){return(0,P.promisify)(v.open)}get close(){return(0,P.promisify)(v.close)}get symlink(){return(0,P.promisify)(v.symlink)}get readlink(){return(0,P.promisify)(v.readlink)}get chmod(){return(0,P.promisify)(v.chmod)}get mkdir(){return(0,P.promisify)(v.mkdir)}get unlink(){return(0,P.promisify)(v.unlink)}get rmdir(){return(0,P.promisify)(v.rmdir)}get realpath(){return(0,P.promisify)(v.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return u}get writeFile(){return o}get rm(){return p}get move(){return F}get copy(){return Z}}}),define(be[148],ve([1,0,29,7,3,15,22]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(C){if(P.isLinux)return C;const p=(0,t.dirname)(C);if(C===p)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const w=(0,D.readdirSync)(p).filter(d=>d.toLowerCase()===m);if(w.length===1){const d=A(p);if(d)return(0,t.join)(d,w[0])}else if(w.length>1){const d=w.indexOf(m);if(d>=0){const b=A(p);if(b)return(0,t.join)(b,w[d])}}}catch{}return null}e.realcaseSync=A;async function y(C){if(P.isLinux)return C;const p=(0,t.dirname)(C);if(C===p)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const w=(await D.Promises.readdir(p)).filter(d=>d.toLowerCase()===m);if(w.length===1){const d=await y(p);if(d)return(0,t.join)(d,w[0])}else if(w.length>1){const d=w.indexOf(m);if(d>=0){const b=await y(p);if(b)return(0,t.join)(b,w[d])}}}catch{}return null}e.realcase=y;async function E(C){try{return await D.Promises.realpath(C)}catch{const m=k(C);return await D.Promises.access(m,v.constants.R_OK),m}}e.realpath=E;function I(C){try{return v.realpathSync(C)}catch{const m=k(C);return v.accessSync(m,v.constants.R_OK),m}}e.realpathSync=I;function k(C){return(0,S.rtrim)((0,t.normalize)(C),t.sep)}}),define(be[149],ve([1,0,93]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(A,y,E,I=1){let k=!1;return new Promise(C=>{const p=setTimeout(()=>{if(!k)return k=!0,C(0)},E);P(A,y,I,m=>{if(!k)return k=!0,clearTimeout(p),C(m)})})}e.findFreePort=t;function P(A,y,E,I){if(y===0)return I(0);const k=new v.Socket;k.once("connect",()=>(D(k),P(A+E,y-1,E,I))),k.once("data",()=>{}),k.once("error",C=>(D(k),C.code!=="ECONNREFUSED"?P(A+E,y-1,E,I):I(A))),k.connect(A,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function S(A,y,E,I="127.0.0.1"){let k=!1,C,p=1;const m=v.createServer({pauseOnConnect:!0});function g(w,d){k||(k=!0,m.removeAllListeners(),m.close(),C&&clearTimeout(C),d(w))}return new Promise(w=>{C=setTimeout(()=>{g(0,w)},E),m.on("listening",()=>{g(A,w)}),m.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&p<y?(A++,p++,m.listen(A,I)):g(0,w)}),m.on("close",()=>{g(0,w)}),m.listen(A,I)})}e.findFreePortFaster=S;function D(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(y){console.error(y)}}}),define(be[94],ve([1,0,28,7,22]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,D=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var y;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(y||(y={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class k{constructor(u,i,n){this.exePath=u,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function C({useAlternateBitness:f=!1}={}){return f?E===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:f=!1,findPreview:u=!1}={}){const i=C({useAlternateBitness:f});if(!i)return null;const n=t.join(i,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(n))return null;let r=-1,o=null;for(const s of await P.Promises.readdir(n)){let h=-1;if(u){const F=s.indexOf("-");if(F<0)continue;const Z=s.substring(0,F);if(!S.test(Z)||s.substring(F+1)!=="preview")continue;h=parseInt(Z,10)}else{if(!S.test(s))continue;h=parseInt(s,10)}if(h<=r)continue;const T=t.join(n,s,"pwsh.exe");!await P.SymlinkSupport.existsFile(T)||(o=T,r=h)}if(!o)return null;const a=i.includes("x86")?" (x86)":"",l=u?" Preview":"";return new k(o,`PowerShell${l}${a}`,!0)}async function m({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=f?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(u))if(i.test(r)){const o=t.join(u,r,"pwsh.exe");return new k(o,n)}return null}function g(){const f=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new k(f,".NET Core PowerShell Global Tool")}function w(){const f=t.join(process.env.windir,E===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(f,"Windows PowerShell",!0)}async function*d(){let f=await p();f&&(yield f),f=await p({useAlternateBitness:!0}),f&&(yield f),f=await m(),f&&(yield f),f=g(),f&&(yield f),f=await p({findPreview:!0}),f&&(yield f),f=await m({findPreview:!0}),f&&(yield f),f=await p({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=w(),f&&(yield f)}async function*b(){for await(const f of d())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=b;async function c(){for await(const f of b())return f;return null}e.getFirstAvailablePowerShellInstallation=c}),define(be[95],ve([1,0,7,3,27,57,9,22]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return S.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return S.TerminateResponseCode}});function y(k=P.env){return k.comspec||"cmd.exe"}e.getWindowsShell=y;function E(k){let C=[],p=!1;const m=function(g){if(p){C.push(g);return}(!k.send(g,d=>{if(d&&console.error(d),p=!1,C.length>0){const b=C.slice(0);C=[],b.forEach(c=>m(c))}})||t.isWindows)&&(p=!0)};return{send:m}}e.createQueuedSender=E;var I;(function(k){async function C(p,m,g){if(v.isAbsolute(p))return p;if(m===void 0&&(m=P.cwd()),v.dirname(p)!=="."||(g===void 0&&D.isString(P.env.PATH)&&(g=P.env.PATH.split(v.delimiter)),g===void 0||g.length===0))return v.join(m,p);async function d(b){if(await A.Promises.exists(b)){let c;try{c=await A.Promises.stat(b)}catch(f){f.message.startsWith("EACCES")&&(c=await A.Promises.lstat(b))}return c?!c.isDirectory():!1}return!1}for(const b of g){let c;if(v.isAbsolute(b)?c=v.join(b,p):c=v.join(m,b,p),await d(c))return c;let f=c+".com";if(await d(f)||(f=c+".exe",await d(f)))return f}return v.join(m,p)}k.findExecutable=C})(I=e.win32||(e.win32={}))}),define(be[96],ve([1,0,47,13]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(D){return new Promise((A,y)=>{let E;const I=new Map;function k(p,m,g,w,d){const b=I.get(m);if(p===D||b){const c={name:C(g),cmd:g,pid:p,ppid:m,load:w,mem:d};I.set(p,c),p===D&&(E=c),b&&(b.children||(b.children=[]),b.children.push(c),b.children.length>1&&(b.children=b.children.sort((f,u)=>f.pid-u.pid)))}}function C(p){const m=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,b=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,f=/\\pipe\\winpty-control/,u=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(c.exec(p))return"electron-crash-reporter";if(f.exec(p))return"winpty-process";if(u.exec(p))return"console-window-host (Windows internal process)";let n=i.exec(p);if(n&&n.length===2){if(n[1]==="renderer")return m.exec(p)?"shared-process":g.exec(p)?"issue-reporter":w.exec(p)?"process-explorer":"window";if(n[1]==="utility"){if(d.exec(p))return"utility-network-service";if(b.exec(p))return"extension-host"}return n[1]}const r=/[a-zA-Z-]+\.js/g;let o="";do n=r.exec(p),n&&(o+=n+" ");while(n);return o&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${o}`:p}if(process.platform==="win32"){const p=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,g)=>{re(["windows-process-tree"],m,g)}).then(m=>{m.getProcessList(D,g=>{if(!g){y(new Error(`Root process ${D} not found`));return}m.getProcessCpuUsage(g,w=>{const d=new Map;w.forEach(b=>{const c=p(b.commandLine||"");d.set(b.pid,{name:C(c),cmd:c,pid:b.pid,ppid:b.ppid,load:b.cpu||0,mem:b.memory||0})}),E=d.get(D),E?(d.forEach(b=>{const c=d.get(b.ppid);c&&(c.children||(c.children=[]),c.children.push(b))}),d.forEach(b=>{b.children&&(b.children=b.children.sort((c,f)=>c.pid-f.pid))}),A(E)):y(new Error(`Root process ${D} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let p=function(){let m=[E];const g=[];for(;m.length;){const d=m.shift();d&&(g.push(d.pid),d.children&&(m=m.concat(d.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+g.join(" "),(0,v.exec)(w,{},(d,b,c)=>{if(d||c)y(d||new Error(c.toString()));else{const f=b.toString().split(`
`);for(let u=0;u<g.length;u++){const i=I.get(g[u]);i.load=parseFloat(f[u])}if(!E){y(new Error(`Root process ${D} not found`));return}A(E)}})};(0,v.exec)("which ps",{},(m,g,w)=>{if(m||w)if(process.platform!=="linux")y(m||new Error(w.toString()));else{const d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,v.exec)(d,{},(b,c,f)=>{b||f?y(b||new Error(f.toString())):(S(c,k),p())})}else{const d=g.toString().trim(),b="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${d} ${b}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,f,u)=>{c||u&&!u.includes("screen size is bogus")?y(c||new Error(u.toString())):(S(f,k),process.platform==="linux"?p():E?A(E):y(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=P;function S(D,A){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=D.toString().split(`
`);for(const I of E){const k=y.exec(I.trim());k&&k.length===6&&A(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(be[150],ve([1,0,28,3,94,95]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(p,m){return p===1?t.isWindows?k():S.getWindowsShell(m):E(p,m)}e.getSystemShell=D;function A(p,m){return p===1?t.isWindows?C(m):S.getWindowsShell(m):E(p,m)}e.getSystemShellSync=A;let y=null;function E(p,m){if(t.isLinux&&p===2||t.isMacintosh&&p===3)return"/bin/bash";if(!y){let g;if(t.isWindows)g="/bin/bash";else{if(g=m.SHELL,!g)try{g=(0,v.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}y=g}return y}let I=null;async function k(){return I||(I=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),I}function C(p){if(I)return I;const m=t.isWindows&&parseFloat((0,v.release)())>=10,g=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${p.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return m?w:S.getWindowsShell(p)}});var Le=this&&this.__decorate||function(re,e,v,t){var P=arguments.length,S=P<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(re,e,v,t);else for(var A=re.length-1;A>=0;A--)(D=re[A])&&(S=(P<3?D(S):P>3?D(e,v,S):D(e,v))||S);return P>3&&S&&Object.defineProperty(e,v,S),S};define(be[42],ve([1,0,18,14,16,19,85,8,6,2,45,15,9]),function(re,e,v,t,P,S,D,A,y,E,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var p;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(p||(p={}));function m(L){switch(L){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(g||(g={}));function w(L){switch(L){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(d||(d={}));class b{constructor(N){this.b=N,this.a=0}read(N){const H=this.b.slice(this.a,this.a+N);return this.a+=H.byteLength,H}}class c{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(N){this.a.push(N)}}var f;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object"})(f||(f={}));function u(L){const N=P.VSBuffer.alloc(4);return N.writeUInt32BE(L,0),N}function i(L){return L.read(4).readUInt32BE(0)}function n(L){const N=P.VSBuffer.alloc(1);return N.writeUInt8(L,0),N}const r={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},o=typeof Buffer<"u";function a(L,N){if(typeof N>"u")L.write(r.Undefined);else if(typeof N=="string"){const H=P.VSBuffer.fromString(N);L.write(r.String),L.write(u(H.byteLength)),L.write(H)}else if(o&&Buffer.isBuffer(N)){const H=P.VSBuffer.wrap(N);L.write(r.Buffer),L.write(u(H.byteLength)),L.write(H)}else if(N instanceof P.VSBuffer)L.write(r.VSBuffer),L.write(u(N.byteLength)),L.write(N);else if(Array.isArray(N)){L.write(r.Array),L.write(u(N.length));for(const H of N)a(L,H)}else{const H=P.VSBuffer.fromString(JSON.stringify(N));L.write(r.Object),L.write(u(H.byteLength)),L.write(H)}}function l(L){switch(L.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return L.read(i(L)).toString();case f.Buffer:return L.read(i(L)).buffer;case f.VSBuffer:return L.read(i(L));case f.Array:{const H=i(L),ee=[];for(let ae=0;ae<H;ae++)ee.push(l(L));return ee}case f.Object:return JSON.parse(L.read(i(L)).toString())}}class s{constructor(N,H,ee=null,ae=1e3){this.h=N,this.j=H,this.k=ee,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ge=>this.p(ge)),this.m({type:200})}registerChannel(N,H){this.b.set(N,H),setTimeout(()=>this.v(N),0)}m(N){switch(N.type){case 200:{const H=this.n([N.type]);this.k?.logOutgoing(H,0,1,w(N.type));return}case 201:case 202:case 204:case 203:{const H=this.n([N.type,N.id],N.data);this.k?.logOutgoing(H,N.id,1,w(N.type),N.data);return}}}n(N,H=void 0){const ee=new c;return a(ee,N),a(ee,H),this.o(ee.buffer)}o(N){try{return this.h.send(N),N.byteLength}catch{return 0}}p(N){const H=new b(N),ee=l(H),ae=l(H),ge=ee[0];switch(ge){case 100:return this.k?.logIncoming(N.byteLength,ee[1],1,`${m(ge)}: ${ee[2]}.${ee[3]}`,ae),this.q({type:ge,id:ee[1],channelName:ee[2],name:ee[3],arg:ae});case 102:return this.k?.logIncoming(N.byteLength,ee[1],1,`${m(ge)}: ${ee[2]}.${ee[3]}`,ae),this.s({type:ge,id:ee[1],channelName:ee[2],name:ee[3],arg:ae});case 101:return this.k?.logIncoming(N.byteLength,ee[1],1,`${m(ge)}`),this.t({type:ge,id:ee[1]});case 103:return this.k?.logIncoming(N.byteLength,ee[1],1,`${m(ge)}`),this.t({type:ge,id:ee[1]})}}q(N){const H=this.b.get(N.channelName);if(!H){this.u(N);return}const ee=new S.CancellationTokenSource;let ae;try{ae=H.call(this.j,N.name,N.arg,ee.token)}catch(R){ae=Promise.reject(R)}const ge=N.id;ae.then(R=>{this.m({id:ge,data:R,type:201}),this.d.delete(N.id)},R=>{R instanceof Error?this.m({id:ge,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:ge,data:R,type:203}),this.d.delete(N.id)});const fe=(0,E.toDisposable)(()=>ee.cancel());this.d.set(N.id,fe)}s(N){const H=this.b.get(N.channelName);if(!H){this.u(N);return}const ee=N.id,ge=H.listen(this.j,N.name,N.arg)(fe=>this.m({id:ee,data:fe,type:204}));this.d.set(N.id,ge)}t(N){const H=this.d.get(N.id);H&&(H.dispose(),this.d.delete(N.id))}u(N){let H=this.g.get(N.channelName);H||(H=[],this.g.set(N.channelName,H));const ee=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.m({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:N,timeoutTimer:ee})}v(N){const H=this.g.get(N);if(H){for(const ee of H)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.q(ee.request);break;case 102:this.s(ee.request);break}this.g.delete(N)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=s;var h;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(N,H=null){this.l=N,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.r(ee)),this.j=H}getChannel(N){const H=this;return{call(ee,ae,ge){return H.a?Promise.reject(new A.CancellationError):H.m(N,ee,ae,ge)},listen(ee,ae){return H.a?y.Event.None:H.n(N,ee,ae)}}}m(N,H,ee,ae=S.CancellationToken.None){const ge=this.g++,R={id:ge,type:100,channelName:N,name:H,arg:ee};if(ae.isCancellationRequested)return Promise.reject(new A.CancellationError);let U;return new Promise((Q,se)=>{if(ae.isCancellationRequested)return se(new A.CancellationError);const de=()=>{const j=q=>{switch(q.type){case 201:this.f.delete(ge),Q(q.data);break;case 202:{this.f.delete(ge);const G=new Error(q.data.message);G.stack=Array.isArray(q.data.stack)?q.data.stack.join(`
`):q.data.stack,G.name=q.data.name,se(G);break}case 203:this.f.delete(ge),se(q.data);break}};this.f.set(ge,j),this.o(R)};let z=null;this.b===d.Idle?de():(z=(0,t.createCancelablePromise)(j=>this.t()),z.then(()=>{z=null,de()}));const Y=()=>{z?(z.cancel(),z=null):this.o({id:ge,type:101}),se(new A.CancellationError)},_=ae.onCancellationRequested(Y);U=(0,E.combinedDisposable)((0,E.toDisposable)(Y),_),this.d.add(U)}).finally(()=>{this.d.delete(U)})}n(N,H,ee){const ae=this.g++,fe={id:ae,type:102,channelName:N,name:H,arg:ee};let R=null;const U=new y.Emitter({onWillAddFirstListener:()=>{R=(0,t.createCancelablePromise)(Q=>this.t()),R.then(()=>{R=null,this.d.add(U),this.o(fe)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(U),this.o({id:ae,type:103}))}}),W=Q=>U.fire(Q.data);return this.f.set(ae,W),U.event}o(N){switch(N.type){case 100:case 102:{const H=this.p([N.type,N.id,N.channelName,N.name],N.arg);this.j?.logOutgoing(H,N.id,0,`${m(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const H=this.p([N.type,N.id]);this.j?.logOutgoing(H,N.id,0,m(N.type));return}}}p(N,H=void 0){const ee=new c;return a(ee,N),a(ee,H),this.q(ee.buffer)}q(N){try{return this.l.send(N),N.byteLength}catch{return 0}}r(N){const H=new b(N),ee=l(H),ae=l(H),ge=ee[0];switch(ge){case 200:return this.j?.logIncoming(N.byteLength,0,0,w(ge)),this.s({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(N.byteLength,ee[1],0,w(ge),ae),this.s({type:ee[0],id:ee[1],data:ae})}}s(N){if(N.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(N.id)?.(N)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}t(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.dispose)(this.d.values()),this.d.clear()}}Le([D.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class F{get connections(){const N=[];return this.f.forEach(H=>N.push(H)),N}constructor(N){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,N(({protocol:H,onDidClientDisconnect:ee})=>{y.Event.once(H.onMessage)(ge=>{const fe=new b(ge),R=l(fe),U=new s(H,R),W=new T(H);this.a.forEach((se,de)=>U.registerChannel(de,se));const Q={channelServer:U,channelClient:W,ctx:R};this.f.add(Q),this.g.fire(Q),ee(()=>{U.dispose(),W.dispose(),this.f.delete(Q),this.h.fire(Q)})})})}getChannel(N,H){const ee=this;return{call(ae,ge,fe){let R;if((0,C.isFunction)(H)){const W=(0,v.getRandomElement)(ee.connections.filter(H));R=W?Promise.resolve(W):y.Event.toPromise(y.Event.filter(ee.onDidAddConnection,H))}else R=H.routeCall(ee,ae,ge);const U=R.then(W=>W.channelClient.getChannel(N));return ne(U).call(ae,ge,fe)},listen(ae,ge){if((0,C.isFunction)(H))return ee.j(N,H,ae,ge);const fe=H.routeEvent(ee,ae,ge).then(R=>R.channelClient.getChannel(N));return ne(fe).listen(ae,ge)}}}j(N,H,ee,ae){const ge=this;let fe=new E.DisposableStore;const R=new y.Emitter({onWillAddFirstListener:()=>{fe=new E.DisposableStore;const U=new y.EventMultiplexer,W=new Map,Q=de=>{const Y=de.channelClient.getChannel(N).listen(ee,ae),_=U.add(Y);W.set(de,_)},se=de=>{const z=W.get(de);!z||(z.dispose(),W.delete(de))};ge.connections.filter(H).forEach(Q),y.Event.filter(ge.onDidAddConnection,H)(Q,void 0,fe),ge.onDidRemoveConnection(se,void 0,fe),U.event(R.fire,R,fe),fe.add(U)},onDidRemoveLastListener:()=>{fe.dispose()}});return R.event}registerChannel(N,H){this.a.set(N,H),this.f.forEach(ee=>{ee.channelServer.registerChannel(N,H)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class Z{constructor(N,H,ee=null){const ae=new c;a(ae,H),N.send(ae.buffer),this.a=new T(N,ee),this.d=new s(N,H,ee)}getChannel(N){return this.a.getChannel(N)}registerChannel(N,H){this.d.registerChannel(N,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Z;function ne(L){return{call(N,H,ee){return L.then(ae=>ae.call(N,H,ee))},listen(N,H){const ee=new y.Relay;return L.then(ae=>ee.input=ae.listen(N,H)),ee.event}}}e.getDelayedChannel=ne;function ce(L){let N=!1;return{call(H,ee,ae){return N?L.call(H,ee,ae):(0,t.timeout)(0).then(()=>N=!0).then(()=>L.call(H,ee,ae))},listen(H,ee){if(N)return L.listen(H,ee);const ae=new y.Relay;return(0,t.timeout)(0).then(()=>N=!0).then(()=>ae.input=L.listen(H,ee)),ae.event}}}e.getNextTickChannel=ce;class ie{constructor(N){this.a=N}routeCall(N){return this.b(N)}routeEvent(N){return this.b(N)}async b(N){for(const H of N.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await y.Event.toPromise(N.onDidAddConnection),await this.b(N)}}e.StaticRouter=ie;var M;(function(L){function N(ge,fe){const R=ge,U=fe&&fe.disableMarshalling,W=new Map;for(const Q in R)ee(Q)&&W.set(Q,y.Event.buffer(R[Q],!0));return new class{listen(Q,se,de){const z=W.get(se);if(z)return z;if(ae(se)){const Y=R[se];if(typeof Y=="function")return Y.call(R,de)}throw new Error(`Event not found: ${se}`)}call(Q,se,de){const z=R[se];if(typeof z=="function"){if(!U&&Array.isArray(de))for(let Y=0;Y<de.length;Y++)de[Y]=(0,I.revive)(de[Y]);return z.apply(R,de)}throw new Error(`Method not found: ${se}`)}}}L.fromService=N;function H(ge,fe){const R=fe&&fe.disableMarshalling;return new Proxy({},{get(U,W){if(typeof W=="string")return fe?.properties?.has(W)?fe.properties.get(W):ae(W)?function(Q){return ge.listen(W,Q)}:ee(W)?ge.listen(W):async function(...Q){let se;fe&&!(0,C.isUndefinedOrNull)(fe.context)?se=[fe.context,...Q]:se=Q;const de=await ge.call(W,se);return R?de:(0,I.revive)(de)};throw new Error(`Property not found: ${String(W)}`)}})}L.toService=H;function ee(ge){return ge[0]==="o"&&ge[1]==="n"&&k.isUpperAsciiLetter(ge.charCodeAt(2))}function ae(ge){return/^onDynamic/.test(ge)&&k.isUpperAsciiLetter(ge.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){const N=L.toString();if(N!=="[object Object]")return N}return L}function V(L){return Array.isArray(L)?L.map($):$(L)}function X(L,N,H,ee,ae,ge,fe){fe=V(fe);const R=J[ae],U=R[ee%R.length];let W=[`%c[${L}]%c[${String(N).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ge)?(W=W.concat(fe),W.push(")")):W.push(fe),console.log.apply(console,W)}class ue{constructor(N,H){this.d=N,this.f=H,this.a=0,this.b=0}logOutgoing(N,H,ee,ae,ge){this.b+=N,X(this.d,this.b,N,H,ee,ae,ge)}logIncoming(N,H,ee,ae,ge){this.a+=N,X(this.f,this.a,N,H,ee,ae,ge)}}e.IPCLogger=ue}),define(be[97],ve([1,0,16,6,2,42]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var A;(function(o){o.enableDiagnostics=!1,o.records=[];const a=new WeakMap;let l=0;function s(T,F){if(!a.has(T)){const Z=String(++l);a.set(T,Z)}return a.get(T)}function h(T,F,Z,ne){if(!o.enableDiagnostics)return;const ce=s(T,F);if(ne instanceof v.VSBuffer||ne instanceof Uint8Array||ne instanceof ArrayBuffer||ArrayBuffer.isView(ne)){const ie=v.VSBuffer.alloc(ne.byteLength);ie.set(ne),o.records.push({timestamp:Date.now(),id:ce,label:F,type:Z,buff:ie})}else o.records.push({timestamp:Date.now(),id:ce,label:F,type:Z,data:ne})}o.traceSocketEvent=h})(A=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function I(){return E||(E=v.VSBuffer.alloc(0)),E}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return I();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const F=this.a[0];return l&&(this.a.shift(),this.b-=a),F}if(this.a[0].byteLength>a){const F=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),F}const s=v.VSBuffer.alloc(a);let h=0,T=0;for(;a>0;){const F=this.a[T];if(F.byteLength>a){const Z=F.slice(0,a);s.set(Z,h),h+=a,l&&(this.a[T]=F.slice(a),this.b-=a),a-=a}else s.set(F,h),h+=F.byteLength,l?(this.a.shift(),this.b-=F.byteLength):T++,a-=F.byteLength}return s}}e.ChunkStream=k;var C;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(C||(C={}));function p(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(a,l,s,h){this.type=a,this.id=l,this.ack=s,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends P.Disposable{constructor(a){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new k,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const s=this.g.messageType,h=this.g.id,T=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new g(s,h,T,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=v.VSBuffer.alloc(13);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(l,a.data)}g(a,l){const s=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,s}h(){const a=v.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class b extends P.Disposable{constructor(a){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new d(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new g(1,0,0,a))}}e.Protocol=b;class c extends S.IPCClient{static fromSocket(a,l){return new c(new b(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,s=null){super(a,l,s),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.Client=c;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.BufferedEmitter=f;class u{constructor(a){this.data=a,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,s=this.a;for(;s;)a[l++]=s.data,s=s.next;return a}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new u(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<n.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=n.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+n.a)*1e3;let s=0;for(let h=0;h<n.a;h++)a-this.c[h]<=l&&s++;return 1-s/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;class r{get unacknowledgedCount(){return this.c-this.d}constructor(a,l=null,s=n.getInstance()){this.t=new f,this.onControlMessage=this.t.event,this.u=new f,this.onMessage=this.u.event,this.v=new f,this.onDidDispose=this.v.event,this.w=new f,this.onSocketClose=this.w.event,this.x=new f,this.onSocketTimeout=this.x.event,this.s=s,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=a,this.p=new d(this.o),this.r.push(this.p),this.q=new w(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(h=>this.y(h))),this.r.push(this.o.onClose(h=>this.w.fire(h))),l&&this.q.acceptChunk(l),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,P.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const a=new g(5,0,0,I());this.p.write(a),this.p.flush()}sendPause(){const a=new g(7,0,0,I());this.p.write(a)}sendResume(){const a=new g(8,0,0,I());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.r=(0,P.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=new d(this.o),this.r.push(this.p),this.q=new w(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(s=>this.y(s))),this.r.push(this.o.onClose(s=>this.w.fire(s))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new g(3,0,this.h,I());this.p.write(a);const l=this.b.toArray();for(let s=0,h=l.length;s<h;s++)this.p.write(l[s]);this.A()}acceptDisconnect(){this.v.fire()}y(a){if(a.ack>this.d){this.d=a.ack;do{const l=this.b.peek();if(l&&l.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new g(6,0,0,I())))}else this.g=a.id,this.j=Date.now(),this.z(),this.u.fire(a.data);break}case 2:{this.t.fire(a.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const l=this.b.toArray();for(let s=0,h=l.length;s<h;s++)this.p.write(l[s]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const l=++this.c;this.h=this.g;const s=new g(1,l,this.h,a);this.b.push(s),this.a||(this.p.write(s),this.A())}sendControl(a){const l=new g(2,0,0,a);this.p.write(l)}z(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-a+5)}A(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),l=Date.now()-a.writtenTime,s=Date.now()-this.q.lastReadTime,h=Date.now()-this.n;if(l>=2e4&&s>=2e4&&h>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:s});return}const T=Math.max(2e4-l,2e4-s,2e4-h,500);this.f=setTimeout(()=>{this.f=null,this.A()},T)}B(){if(this.g<=this.h)return;this.h=this.g;const a=new g(3,0,this.h,I());this.p.write(a)}C(){const a=new g(9,0,0,I());this.p.write(a)}}e.PersistentProtocol=r}),define(be[98],ve([1,0,47,14,16,19,143,8,6,2,23,95,57,42]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends p.ChannelServer{constructor(d){super({send:b=>{try{process.send?.(b.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",b=>P.VSBuffer.wrap(Buffer.from(b,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=m;class g{constructor(d,b){this.i=d,this.j=b,this.c=new Set,this.g=new Map,this.h=new y.Emitter,this.onDidProcessExit=this.h.event;const c=b&&b.timeout?b.timeout:6e4;this.b=new t.Delayer(c),this.d=null,this.f=null}getChannel(d){const b=this;return{call(c,f,u){return b.k(d,c,f,u)},listen(c,f){return b.l(d,c,f)}}}k(d,b,c,f=S.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(A.canceled());this.b.cancel();const u=this.n(d),i=(0,t.createCancelablePromise)(o=>u.call(b,c,o)),n=f.onCancellationRequested(()=>i.cancel()),r=(0,E.toDisposable)(()=>i.cancel());return this.c.add(r),i.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(d,b,c){if(!this.b)return y.Event.None;this.b.cancel();let f;const u=new y.Emitter({onWillAddFirstListener:()=>{f=this.n(d).listen(b,c)(u.fire,u),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],b=Object.create(null);b.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(b.env={...b.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(b.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,C.removeDangerousEnvVariables)(b.env),this.d=(0,v.fork)(this.i,d,b);const c=new y.Emitter;y.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,D.isRemoteConsoleLog)(a)){(0,D.log)(a,`IPC Library: ${this.j.serverName}`);return}c.fire(P.VSBuffer.wrap(Buffer.from(a,"base64")))});const u=this.j.useQueue?(0,k.createQueuedSender)(this.d):this.d,i=a=>this.d&&this.d.connected&&u.send(a.buffer.toString("base64")),n=c.event,r={send:i,onMessage:n};this.f=new p.ChannelClient(r);const o=()=>this.o();process.once("exit",o),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",o),this.c.forEach(s=>(0,E.dispose)(s)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(d){let b=this.g.get(d);return b||(b=this.m.getChannel(d),this.g.set(d,b)),b}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=g}),define(be[59],ve([1,0,16,8,6,2,7,3,21,42,97]),function(re,e,v,t,P,S,D,A,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class C{traceSocketEvent(s,h){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,h)}constructor(s,h=""){this.f=!0,this.debugLabel=h,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,t.onUnexpectedError)(T)}},this.socket.on("error",this.a),this.b=T=>{this.traceSocketEvent("close",{hadError:T}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const h=T=>{this.traceSocketEvent("read",T),s(v.VSBuffer.wrap(T))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(s){const h=T=>{s({type:0,hadError:T,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(s){const h=()=>{s()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=C;var p;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var m;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(m||(m={}));class g extends S.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,h){this.socket.traceSocketEvent(s,h)}constructor(s,h,T,F){super(),this.f=this.B(new P.Emitter),this.g=this.B(new P.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:T?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new w(this,h,T,F,this.f,(Z,ne)=>this.k(Z,ne))),this.B(this.a.onError(Z=>{console.error(Z),(0,t.onUnexpectedError)(Z),this.g.fire({type:0,hadError:!0,error:Z})})),this.b=new I.ChunkStream,this.B(this.socket.onData(Z=>this.l(Z))),this.B(this.socket.onClose(Z=>this.g.fire(Z)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let T=2;s.byteLength<126?T+=0:s.byteLength<2**16?T+=2:T+=8;const F=v.VSBuffer.alloc(T);if(h?F.writeUInt8(194,0):F.writeUInt8(130,0),s.byteLength<126)F.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){F.writeUInt8(126,1);let Z=1;F.writeUInt8(s.byteLength>>>8&255,++Z),F.writeUInt8(s.byteLength>>>0&255,++Z)}else{F.writeUInt8(127,1);let Z=1;F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(s.byteLength>>>24&255,++Z),F.writeUInt8(s.byteLength>>>16&255,++Z),F.writeUInt8(s.byteLength>>>8&255,++Z),F.writeUInt8(s.byteLength>>>0&255,++Z)}this.socket.write(v.VSBuffer.concat([F,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),T=h.readUInt8(0),F=(T&128)>>>7,Z=(T&64)>>>6,ne=h.readUInt8(1),ce=(ne&128)>>>7,ie=ne&127;this.j.state=2,this.j.readLen=2+(ce?4:0)+(ie===126?2:0)+(ie===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(Z)),this.j.firstFrameOfMessage=Boolean(F),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),T=h.readUInt8(1),F=(T&128)>>>7;let Z=T&127,ne=1;Z===126?Z=h.readUInt8(++ne)*2**8+h.readUInt8(++ne):Z===127&&(Z=h.readUInt8(++ne)*0+h.readUInt8(++ne)*0+h.readUInt8(++ne)*0+h.readUInt8(++ne)*0+h.readUInt8(++ne)*2**24+h.readUInt8(++ne)*2**16+h.readUInt8(++ne)*2**8+h.readUInt8(++ne));let ce=0;F&&(ce=h.readUInt8(++ne)*2**24+h.readUInt8(++ne)*2**16+h.readUInt8(++ne)*2**8+h.readUInt8(++ne)),this.j.state=3,this.j.readLen=Z,this.j.mask=ce,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),c(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class w extends S.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:v.VSBuffer.alloc(0)}constructor(s,h,T,F,Z,ne){super(),this.k=s,this.l=Z,this.m=ne,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,h?(this.b=this.B(new d(this.k,F,T,{windowBits:15})),this.f=this.B(new b(this.k,{windowBits:15})),this.B(this.b.onError(ce=>this.a.fire(ce))),this.B(this.f.onError(ce=>this.a.fire(ce)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const h=await this.r(this.f,s);this.m(h,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,h){return new Promise((T,F)=>{s.write(h),s.flush(Z=>T(Z))})}acceptFrame(s,h,T){this.h.push({data:s,isCompressed:h,isLastFrameOfMessage:T}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const h=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(h)}else this.l.fire(s.data)}this.s=!1}}u(s,h,T){return new Promise((F,Z)=>{s.write(h),T&&s.write(v.VSBuffer.fromByteArray([0,0,255,255])),s.flush(ne=>F(ne))})}}class d extends S.Disposable{get recordedInflateBytes(){return this.j?v.VSBuffer.concat(this.f):v.VSBuffer.alloc(0)}constructor(s,h,T,F){super(),this.h=s,this.j=h,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=k().zlib.createInflateRaw(F),this.b.on("error",Z=>{this.h.traceSocketEvent("zlibInflateError",{message:Z?.message,code:Z?.code}),this.a.fire(Z)}),this.b.on("data",Z=>{this.h.traceSocketEvent("zlibInflateData",Z),this.g.push(v.VSBuffer.wrap(Z))}),T&&(this.h.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this.b.write(T.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=v.VSBuffer.concat(this.g);this.g.length=0,s(h)})}}class b extends S.Disposable{constructor(s,h){super(),this.g=s,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.b=k().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",T=>{this.g.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.g.traceSocketEvent("zlibDeflateData",T),this.f.push(v.VSBuffer.wrap(T))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=v.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),s(h)})}}function c(l,s){if(s===0)return;const h=l.byteLength>>>2;for(let ie=0;ie<h;ie++){const M=l.readUInt32BE(ie*4);l.writeUInt32BE(M^s,ie*4)}const T=h*4,F=l.byteLength-T,Z=s>>>24&255,ne=s>>>16&255,ce=s>>>8&255;F>=1&&l.writeUInt8(l.readUInt8(T)^Z,T),F>=2&&l.writeUInt8(l.readUInt8(T+1)^ne,T+1),F>=3&&l.writeUInt8(l.readUInt8(T+2)^ce,T+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function u(){const l=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):s=(0,D.join)(k().os.tmpdir(),`vscode-ipc-${l}.sock`),n(s),s}e.createRandomIPCHandle=u;function i(l,s,h){const T=k().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${h}-${s}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${h}-${s}.sock`):F=(0,D.join)(l,`${h}-${s}.sock`),n(F),F}e.createStaticIPCHandle=i;function n(l){const s=f[A.platform];typeof s=="number"&&l.length>=s&&console.warn(`WARNING: IPC handle "${l}" is longer than ${s} chars, try a shorter --user-data-dir`)}class r extends E.IPCServer{static b(s){const h=P.Event.fromNodeEventEmitter(s,"connection");return P.Event.map(h,T=>({protocol:new I.Protocol(new C(T,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(T,"close"))}))}constructor(s){super(r.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function o(l){return new Promise((s,h)=>{const T=k().net.createServer();T.on("error",h),T.listen(l,()=>{T.removeListener("error",h),s(new r(T))})})}e.serve=o;function a(l,s){return new Promise((h,T)=>{const F=k().net.createConnection(l,()=>{F.removeListener("error",T),h(I.Client.fromSocket(new C(F,`ipc-client${s}`),s))});F.once("error",T)})}e.connect=a}),define(be[151],ve([1,0,14,6,2,9]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function A(k){const C=k;return C?.changed instanceof Map||C?.deleted instanceof Set}e.isStorageItemsChangeEvent=A;var y;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(y=e.StorageState||(e.StorageState={}));class E extends P.Disposable{constructor(C,p=Object.create(null)){super(),this.m=C,this.n=p,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=new v.ThrottledDelayer(E.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(C=>this.r(C)))}r(C){C.changed?.forEach((p,m)=>this.s(m,p)),C.deleted?.forEach(p=>this.s(p,void 0))}s(C,p){if(this.c===y.Closed)return;let m=!1;(0,S.isUndefinedOrNull)(p)?m=this.f.delete(C):this.f.get(C)!==p&&(this.f.set(C,p),m=!0),m&&this.b.fire(C)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(C,p){const m=this.f.get(C);return(0,S.isUndefinedOrNull)(m)?p:m}getBoolean(C,p){const m=this.get(C);return(0,S.isUndefinedOrNull)(m)?p:m==="true"}getNumber(C,p){const m=this.get(C);return(0,S.isUndefinedOrNull)(m)?p:parseInt(m,10)}async set(C,p){if(this.c===y.Closed)return;if((0,S.isUndefinedOrNull)(p))return this.delete(C);const m=String(p);if(this.f.get(C)!==m)return this.f.set(C,m),this.j.set(C,m),this.h.delete(C),this.b.fire(C),this.w()}async delete(C){if(!(this.c===y.Closed||!this.f.delete(C)))return this.h.has(C)||this.h.add(C),this.j.delete(C),this.b.fire(C),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=y.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const C={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(C).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(C){if(!!this.u)return this.w(C)}async w(C){return this.g.trigger(()=>this.v(),C)}async whenFlushed(){if(!!this.u)return new Promise(C=>this.l.push(C))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=E,E.a=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(C){C.insert?.forEach((p,m)=>this.a.set(m,p)),C.delete?.forEach(p=>this.a.delete(p))}async close(){}}e.InMemoryStorageDatabase=I}),define(be[99],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(P,S){this.lineNumber=P,this.column=S}with(P=this.lineNumber,S=this.column){return P===this.lineNumber&&S===this.column?this:new v(P,S)}delta(P=0,S=0){return this.with(this.lineNumber+P,this.column+S)}equals(P){return v.equals(this,P)}static equals(P,S){return!P&&!S?!0:!!P&&!!S&&P.lineNumber===S.lineNumber&&P.column===S.column}isBefore(P){return v.isBefore(this,P)}static isBefore(P,S){return P.lineNumber<S.lineNumber?!0:S.lineNumber<P.lineNumber?!1:P.column<S.column}isBeforeOrEqual(P){return v.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,S){return P.lineNumber<S.lineNumber?!0:S.lineNumber<P.lineNumber?!1:P.column<=S.column}static compare(P,S){const D=P.lineNumber|0,A=S.lineNumber|0;if(D===A){const y=P.column|0,E=S.column|0;return y-E}return D-A}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new v(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=v}),define(be[48],ve([1,0,99]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(S,D,A,y){S>A||S===A&&D>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=S,this.endColumn=D):(this.startLineNumber=S,this.startColumn=D,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return t.containsPosition(this,S)}static containsPosition(S,D){return!(D.lineNumber<S.startLineNumber||D.lineNumber>S.endLineNumber||D.lineNumber===S.startLineNumber&&D.column<S.startColumn||D.lineNumber===S.endLineNumber&&D.column>S.endColumn)}static strictContainsPosition(S,D){return!(D.lineNumber<S.startLineNumber||D.lineNumber>S.endLineNumber||D.lineNumber===S.startLineNumber&&D.column<=S.startColumn||D.lineNumber===S.endLineNumber&&D.column>=S.endColumn)}containsRange(S){return t.containsRange(this,S)}static containsRange(S,D){return!(D.startLineNumber<S.startLineNumber||D.endLineNumber<S.startLineNumber||D.startLineNumber>S.endLineNumber||D.endLineNumber>S.endLineNumber||D.startLineNumber===S.startLineNumber&&D.startColumn<S.startColumn||D.endLineNumber===S.endLineNumber&&D.endColumn>S.endColumn)}strictContainsRange(S){return t.strictContainsRange(this,S)}static strictContainsRange(S,D){return!(D.startLineNumber<S.startLineNumber||D.endLineNumber<S.startLineNumber||D.startLineNumber>S.endLineNumber||D.endLineNumber>S.endLineNumber||D.startLineNumber===S.startLineNumber&&D.startColumn<=S.startColumn||D.endLineNumber===S.endLineNumber&&D.endColumn>=S.endColumn)}plusRange(S){return t.plusRange(this,S)}static plusRange(S,D){let A,y,E,I;return D.startLineNumber<S.startLineNumber?(A=D.startLineNumber,y=D.startColumn):D.startLineNumber===S.startLineNumber?(A=D.startLineNumber,y=Math.min(D.startColumn,S.startColumn)):(A=S.startLineNumber,y=S.startColumn),D.endLineNumber>S.endLineNumber?(E=D.endLineNumber,I=D.endColumn):D.endLineNumber===S.endLineNumber?(E=D.endLineNumber,I=Math.max(D.endColumn,S.endColumn)):(E=S.endLineNumber,I=S.endColumn),new t(A,y,E,I)}intersectRanges(S){return t.intersectRanges(this,S)}static intersectRanges(S,D){let A=S.startLineNumber,y=S.startColumn,E=S.endLineNumber,I=S.endColumn;const k=D.startLineNumber,C=D.startColumn,p=D.endLineNumber,m=D.endColumn;return A<k?(A=k,y=C):A===k&&(y=Math.max(y,C)),E>p?(E=p,I=m):E===p&&(I=Math.min(I,m)),A>E||A===E&&y>I?null:new t(A,y,E,I)}equalsRange(S){return t.equalsRange(this,S)}static equalsRange(S,D){return!S&&!D?!0:!!S&&!!D&&S.startLineNumber===D.startLineNumber&&S.startColumn===D.startColumn&&S.endLineNumber===D.endLineNumber&&S.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(S){return new v.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(S){return new v.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,D){return new t(this.startLineNumber,this.startColumn,S,D)}setStartPosition(S,D){return new t(S,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(S){return new t(this.startLineNumber+S,this.startColumn,this.endLineNumber+S,this.endColumn)}static collapseToStart(S){return new t(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,D=S){return new t(S.lineNumber,S.column,D.lineNumber,D.column)}static lift(S){return S?new t(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,D){return!(S.endLineNumber<D.startLineNumber||S.endLineNumber===D.startLineNumber&&S.endColumn<D.startColumn||D.endLineNumber<S.startLineNumber||D.endLineNumber===S.startLineNumber&&D.endColumn<S.startColumn)}static areIntersecting(S,D){return!(S.endLineNumber<D.startLineNumber||S.endLineNumber===D.startLineNumber&&S.endColumn<=D.startColumn||D.endLineNumber<S.startLineNumber||D.endLineNumber===S.startLineNumber&&D.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,D){if(S&&D){const E=S.startLineNumber|0,I=D.startLineNumber|0;if(E===I){const k=S.startColumn|0,C=D.startColumn|0;if(k===C){const p=S.endLineNumber|0,m=D.endLineNumber|0;if(p===m){const g=S.endColumn|0,w=D.endColumn|0;return g-w}return p-m}return k-C}return E-I}return(S?1:0)-(D?1:0)}static compareRangesUsingEnds(S,D){return S.endLineNumber===D.endLineNumber?S.endColumn===D.endColumn?S.startLineNumber===D.startLineNumber?S.startColumn-D.startColumn:S.startLineNumber-D.startLineNumber:S.endColumn-D.endColumn:S.endLineNumber-D.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}toJSON(){return this}}e.Range=t}),define(be[152],ve([1,0,6,2]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class P{constructor(){this.a=new Map,this.b=new Map,this.c=new v.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,t.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const E=new S(this,A,y);return this.b.set(A,E),(0,t.toDisposable)(()=>{const I=this.b.get(A);!I||I!==E||(this.b.delete(A),I.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const E=this.b.get(A);return!E||E.isResolved?null:(await E.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const E=this.b.get(A);return!!(!E||E.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=P;class S extends t.Disposable{get isResolved(){return this.c}constructor(A,y,E){super(),this.f=A,this.g=y,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(be[153],ve([1,0,41,4,48,152]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(T,F,Z){this._tokenBrand=void 0,this.offset=T,this.type=F,this.language=Z}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class A{constructor(T,F){this._tokenizationResultBrand=void 0,this.tokens=T,this.endState=F}}e.TokenizationResult=A;class y{constructor(T,F){this._encodedTokenizationResultBrand=void 0,this.tokens=T,this.endState=F}}e.EncodedTokenizationResult=y;var E;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={}));var I;(function(h){const T=new Map;T.set(0,v.Codicon.symbolMethod),T.set(1,v.Codicon.symbolFunction),T.set(2,v.Codicon.symbolConstructor),T.set(3,v.Codicon.symbolField),T.set(4,v.Codicon.symbolVariable),T.set(5,v.Codicon.symbolClass),T.set(6,v.Codicon.symbolStruct),T.set(7,v.Codicon.symbolInterface),T.set(8,v.Codicon.symbolModule),T.set(9,v.Codicon.symbolProperty),T.set(10,v.Codicon.symbolEvent),T.set(11,v.Codicon.symbolOperator),T.set(12,v.Codicon.symbolUnit),T.set(13,v.Codicon.symbolValue),T.set(15,v.Codicon.symbolEnum),T.set(14,v.Codicon.symbolConstant),T.set(15,v.Codicon.symbolEnum),T.set(16,v.Codicon.symbolEnumMember),T.set(17,v.Codicon.symbolKeyword),T.set(27,v.Codicon.symbolSnippet),T.set(18,v.Codicon.symbolText),T.set(19,v.Codicon.symbolColor),T.set(20,v.Codicon.symbolFile),T.set(21,v.Codicon.symbolReference),T.set(22,v.Codicon.symbolCustomColor),T.set(23,v.Codicon.symbolFolder),T.set(24,v.Codicon.symbolTypeParameter),T.set(25,v.Codicon.account),T.set(26,v.Codicon.issues);function F(ce){let ie=T.get(ce);return ie||(console.info("No codicon found for CompletionItemKind "+ce),ie=v.Codicon.symbolProperty),ie}h.toIcon=F;const Z=new Map;Z.set("method",0),Z.set("function",1),Z.set("constructor",2),Z.set("field",3),Z.set("variable",4),Z.set("class",5),Z.set("struct",6),Z.set("interface",7),Z.set("module",8),Z.set("property",9),Z.set("event",10),Z.set("operator",11),Z.set("unit",12),Z.set("value",13),Z.set("constant",14),Z.set("enum",15),Z.set("enum-member",16),Z.set("enumMember",16),Z.set("keyword",17),Z.set("snippet",27),Z.set("text",18),Z.set("color",19),Z.set("file",20),Z.set("reference",21),Z.set("customcolor",22),Z.set("folder",23),Z.set("type-parameter",24),Z.set("typeParameter",24),Z.set("account",25),Z.set("issue",26);function ne(ce,ie){let M=Z.get(ce);return typeof M>"u"&&!ie&&(M=9),M}h.fromString=ne})(I=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(h){h[h.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var C;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(C=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var m;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(m=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var w;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(w=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(h){return h&&t.URI.isUri(h.uri)&&P.Range.isIRange(h.range)&&(P.Range.isIRange(h.originSelectionRange)||P.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=b;var c;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(c=e.SymbolKind||(e.SymbolKind={}));var f;(function(h){h[h.Deprecated=1]="Deprecated"})(f=e.SymbolTag||(e.SymbolTag={}));var u;(function(h){const T=new Map;T.set(0,v.Codicon.symbolFile),T.set(1,v.Codicon.symbolModule),T.set(2,v.Codicon.symbolNamespace),T.set(3,v.Codicon.symbolPackage),T.set(4,v.Codicon.symbolClass),T.set(5,v.Codicon.symbolMethod),T.set(6,v.Codicon.symbolProperty),T.set(7,v.Codicon.symbolField),T.set(8,v.Codicon.symbolConstructor),T.set(9,v.Codicon.symbolEnum),T.set(10,v.Codicon.symbolInterface),T.set(11,v.Codicon.symbolFunction),T.set(12,v.Codicon.symbolVariable),T.set(13,v.Codicon.symbolConstant),T.set(14,v.Codicon.symbolString),T.set(15,v.Codicon.symbolNumber),T.set(16,v.Codicon.symbolBoolean),T.set(17,v.Codicon.symbolArray),T.set(18,v.Codicon.symbolObject),T.set(19,v.Codicon.symbolKey),T.set(20,v.Codicon.symbolNull),T.set(21,v.Codicon.symbolEnumMember),T.set(22,v.Codicon.symbolStruct),T.set(23,v.Codicon.symbolEvent),T.set(24,v.Codicon.symbolOperator),T.set(25,v.Codicon.symbolTypeParameter);function F(Z){let ne=T.get(Z);return ne||(console.info("No codicon found for SymbolKind "+Z),ne=v.Codicon.symbolProperty),ne}h.toIcon=F})(u=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(T){this.value=T}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var n;(function(h){function T(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}h.is=T})(n=e.Command||(e.Command={}));var r;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(h){h[h.Unresolved=0]="Unresolved",h[h.Resolved=1]="Resolved"})(o=e.CommentThreadState||(e.CommentThreadState={}));var a;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var l;(function(h){h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(l=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new S.TokenizationRegistry;var s;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(s=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[154],ve([10,11]),function(re,e){return re.create("vs/base/common/date",e)}),define(be[155],ve([1,0,154]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,P=t*60,S=P*24,D=S*7,A=S*30,y=S*365;function E(k,C,p){typeof k!="number"&&(k=k.getTime());const m=Math.round((new Date().getTime()-k)/1e3);if(m<-30)return(0,v.localize)(0,null,E(new Date().getTime()+m*1e3,!1));if(m<30)return(0,v.localize)(1,null);let g;return m<t?(g=m,C?g===1?p?(0,v.localize)(2,null,g):(0,v.localize)(3,null,g):p?(0,v.localize)(4,null,g):(0,v.localize)(5,null,g):g===1?p?(0,v.localize)(6,null,g):(0,v.localize)(7,null,g):p?(0,v.localize)(8,null,g):(0,v.localize)(9,null,g)):m<P?(g=Math.floor(m/t),C?g===1?p?(0,v.localize)(10,null,g):(0,v.localize)(11,null,g):p?(0,v.localize)(12,null,g):(0,v.localize)(13,null,g):g===1?p?(0,v.localize)(14,null,g):(0,v.localize)(15,null,g):p?(0,v.localize)(16,null,g):(0,v.localize)(17,null,g)):m<S?(g=Math.floor(m/P),C?g===1?p?(0,v.localize)(18,null,g):(0,v.localize)(19,null,g):p?(0,v.localize)(20,null,g):(0,v.localize)(21,null,g):g===1?p?(0,v.localize)(22,null,g):(0,v.localize)(23,null,g):p?(0,v.localize)(24,null,g):(0,v.localize)(25,null,g)):m<D?(g=Math.floor(m/S),C?g===1?(0,v.localize)(26,null,g):(0,v.localize)(27,null,g):g===1?(0,v.localize)(28,null,g):(0,v.localize)(29,null,g)):m<A?(g=Math.floor(m/D),C?g===1?p?(0,v.localize)(30,null,g):(0,v.localize)(31,null,g):p?(0,v.localize)(32,null,g):(0,v.localize)(33,null,g):g===1?p?(0,v.localize)(34,null,g):(0,v.localize)(35,null,g):p?(0,v.localize)(36,null,g):(0,v.localize)(37,null,g)):m<y?(g=Math.floor(m/A),C?g===1?p?(0,v.localize)(38,null,g):(0,v.localize)(39,null,g):p?(0,v.localize)(40,null,g):(0,v.localize)(41,null,g):g===1?p?(0,v.localize)(42,null,g):(0,v.localize)(43,null,g):p?(0,v.localize)(44,null,g):(0,v.localize)(45,null,g)):(g=Math.floor(m/y),C?g===1?p?(0,v.localize)(46,null,g):(0,v.localize)(47,null,g):p?(0,v.localize)(48,null,g):(0,v.localize)(49,null,g):g===1?p?(0,v.localize)(50,null,g):(0,v.localize)(51,null,g):p?(0,v.localize)(52,null,g):(0,v.localize)(53,null,g))}e.fromNow=E;function I(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(be[156],ve([10,11]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(be[39],ve([1,0,18,9,156]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function S(k,C){return C&&(k.stack||k.stacktrace)?P.localize(0,null,A(k),D(k.stack)||D(k.stacktrace)):A(k)}function D(k){return Array.isArray(k)?k.join(`
`):k}function A(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?P.localize(1,null,k.message):k.message||P.localize(2,null)}function y(k=null,C=!1){if(!k)return P.localize(3,null);if(Array.isArray(k)){const p=v.coalesce(k),m=y(p[0],C);return p.length>1?P.localize(4,null,m,p.length):m}if(t.isString(k))return k;if(k.detail){const p=k.detail;if(p.error)return S(p.error,C);if(p.exception)return S(p.exception,C)}return k.stack?S(k,C):k.message?k.message:P.localize(5,null)}e.toErrorMessage=y;function E(k){const C=k;return C instanceof Error&&Array.isArray(C.actions)}e.isErrorWithActions=E;function I(k,C){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=C,p}e.createErrorWithActions=I}),define(be[157],ve([10,11]),function(re,e){return re.create("vs/base/common/jsonErrorMessages",e)}),define(be[158],ve([1,0,157]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(P){switch(P){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(be[159],ve([10,11]),function(re,e){return re.create("vs/base/node/zip",e)}),define(be[160],ve([10,11]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[161],ve([10,11]),function(re,e){return re.create("vs/platform/environment/node/argv",e)}),define(be[162],ve([10,11]),function(re,e){return re.create("vs/platform/environment/node/argvHelper",e)}),define(be[163],ve([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(be[164],ve([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[165],ve([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(be[166],ve([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(be[167],ve([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(be[168],ve([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(be[169],ve([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(be[170],ve([10,11]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[171],ve([10,11]),function(re,e){return re.create("vs/platform/files/common/fileService",e)}),define(be[172],ve([10,11]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(be[173],ve([10,11]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(be[174],ve([10,11]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(be[175],ve([10,11]),function(re,e){return re.create("vs/platform/languagePacks/common/languagePacks",e)}),define(be[176],ve([10,11]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(be[177],ve([10,11]),function(re,e){return re.create("vs/platform/request/common/request",e)}),define(be[178],ve([10,11]),function(re,e){return re.create("vs/platform/shell/node/shellEnv",e)}),define(be[179],ve([10,11]),function(re,e){return re.create("vs/platform/telemetry/common/telemetryService",e)}),define(be[180],ve([10,11]),function(re,e){return re.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(be[181],ve([10,11]),function(re,e){return re.create("vs/platform/terminal/common/terminalProfiles",e)}),define(be[182],ve([10,11]),function(re,e){return re.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(be[183],ve([10,11]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(be[184],ve([10,11]),function(re,e){return re.create("vs/server/node/serverEnvironmentService",e)}),define(be[185],ve([10,11]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(be[186],ve([10,11]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[187],ve([10,11]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(be[188],ve([1,0,6,2]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class P{constructor(){this.a=new v.Emitter,this.b=new v.Emitter,this.c=new v.Emitter,this.d=new v.Emitter}call(A,y,E){switch(y){case"close":return Promise.resolve(this.a.fire({sessionId:E[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:E[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:E[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:E[0],port:E[1],subId:E[2]}))}throw new Error("Method not implemented.")}listen(A,y,E){switch(y){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=P,P.ChannelName="extensionhostdebugservice";class S extends t.Disposable{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,y,E){this.b.call("attach",[A,y,E])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,y){this.b.call("terminate",[A,y])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,y){return this.b.call("openExtensionDevelopmentHostWindow",[A,y])}}e.ExtensionHostDebugChannelClient=S}),define(be[189],ve([1,0,4]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(D){this.a=D}listen(D,A,y){throw new Error("Invalid listen")}call(D,A,y){switch(A){case"download":return this.a.download(v.URI.revive(y[0]),v.URI.revive(y[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class P{constructor(D,A){this.a=D,this.b=A}async download(D,A){const y=this.b();y&&(D=y.transformOutgoingURI(D),A=y.transformOutgoingURI(A)),await this.a.call("download",[D,A])}}e.DownloadServiceChannelClient=P}),define(be[100],ve([1,0,155,85,13,7,27,20,4]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class E{get appRoot(){return(0,S.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return y.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return y.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.b.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get stateResource(){return(0,A.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return y.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return y.URI.file((0,S.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(y.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=D.env.VSCODE_PORTABLE;return g?y.URI.file((0,S.join)(g,"argv.json")):(0,A.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,S.resolve)(g):(0,S.normalize)((0,S.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?y.URI.file((0,S.resolve)(g)):y.URI.file((0,S.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,S.resolve)(g);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const d=D.env.VSCODE_PORTABLE;return d?(0,S.join)(d,"extensions"):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(w=>/^[^:/?#]+?:\/\//.test(w)?y.URI.parse(w):y.URI.file((0,S.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?y.URI.parse(g):y.URI.file((0,S.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const w of this.args.log||[]){const d=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);d&&d[1]&&d[2]&&g.push([d[1],d[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,A.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return y.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=D.env.VSCODE_PORTABLE;return g?y.URI.file((0,S.join)(g,"policy.json")):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,w,d){this.a=g,this.b=w,this.c=d,this.editSessionId=this.args.editSessionId}}Le([t.memoize],E.prototype,"appRoot",null),Le([t.memoize],E.prototype,"userHome",null),Le([t.memoize],E.prototype,"userDataPath",null),Le([t.memoize],E.prototype,"appSettingsHome",null),Le([t.memoize],E.prototype,"tmpDir",null),Le([t.memoize],E.prototype,"cacheHome",null),Le([t.memoize],E.prototype,"stateResource",null),Le([t.memoize],E.prototype,"userRoamingDataHome",null),Le([t.memoize],E.prototype,"userDataSyncHome",null),Le([t.memoize],E.prototype,"userDataSyncLogResource",null),Le([t.memoize],E.prototype,"editSessionsLogResource",null),Le([t.memoize],E.prototype,"sync",null),Le([t.memoize],E.prototype,"machineSettingsResource",null),Le([t.memoize],E.prototype,"workspaceStorageHome",null),Le([t.memoize],E.prototype,"localHistoryHome",null),Le([t.memoize],E.prototype,"keyboardLayoutResource",null),Le([t.memoize],E.prototype,"argvResource",null),Le([t.memoize],E.prototype,"isExtensionDevelopment",null),Le([t.memoize],E.prototype,"untitledWorkspacesHome",null),Le([t.memoize],E.prototype,"installSourcePath",null),Le([t.memoize],E.prototype,"builtinExtensionsPath",null),Le([t.memoize],E.prototype,"extensionsPath",null),Le([t.memoize],E.prototype,"extensionDevelopmentLocationURI",null),Le([t.memoize],E.prototype,"extensionDevelopmentKind",null),Le([t.memoize],E.prototype,"extensionTestsLocationURI",null),Le([t.memoize],E.prototype,"debugExtensionHost",null),Le([t.memoize],E.prototype,"logLevel",null),Le([t.memoize],E.prototype,"extensionLogLevel",null),Le([t.memoize],E.prototype,"serviceMachineIdResource",null),Le([t.memoize],E.prototype,"telemetryLogResource",null),Le([t.memoize],E.prototype,"disableWorkspaceTrust",null),Le([t.memoize],E.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=E;function I(m,g){return p(m["inspect-extensions"],m["inspect-brk-extensions"],5870,g,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=I;function k(m,g){return p(m["inspect-search"],m["inspect-brk-search"],5876,g,m.extensionEnvironment)}e.parseSearchPort=k;function C(m,g){return p(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,g,m.extensionEnvironment)}e.parsePtyHostPort=C;function p(m,g,w,d,b,c){const u=Number(g||m)||(d?null:w),i=u?Boolean(!!g):!1;let n;if(c)try{n=JSON.parse(c)}catch{}return{port:u,break:i,debugId:b,env:n}}}),define(be[60],ve([1,0,274,3,161]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},category:{type:"string",cat:"e",description:(0,P.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(g,w,d=D){const b=g.find(l=>l.length>0&&l[0]!=="-"),c={},f=["_"],u=[],i={};let n;for(const l in w){const s=w[l];s.type==="subcommand"?l===b&&(n=s):(s.alias&&(c[l]=s.alias),s.type==="string"||s.type==="string[]"?(f.push(l),s.deprecates&&f.push(...s.deprecates)):s.type==="boolean"&&(u.push(l),s.deprecates&&u.push(...s.deprecates)),s.global&&(i[l]=s))}if(n&&b){const l=i;for(const F in n.options)l[F]=n.options[F];const s=g.filter(F=>F!==b),h=d.getSubcommandReporter?d.getSubcommandReporter(b):void 0,T=A(s,l,h);return{[b]:T,_:[]}}const r=v(g,{string:f,boolean:u,alias:c}),o={},a=r;o._=r._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in w){const s=w[l];if(s.type==="subcommand")continue;s.alias&&delete a[s.alias];let h=a[l];if(s.deprecates)for(const T of s.deprecates)a.hasOwnProperty(T)&&(h||(h=a[T],h&&d.onDeprecatedOption(T,s.deprecationMessage||(0,P.localize)(36,null,l))),delete a[T]);if(typeof h<"u"){if(s.type==="string[]"){if(Array.isArray(h)||(h=[h]),!s.allowEmptyValue){const T=h.filter(F=>F.length>0);T.length!==h.length&&(d.onEmptyValue(l),h=T.length>0?T:void 0)}}else s.type==="string"&&(Array.isArray(h)?(h=h.pop(),d.onMultipleValues(l,h)):!h&&!s.allowEmptyValue&&(d.onEmptyValue(l),h=void 0));o[l]=h,s.deprecationMessage&&d.onDeprecatedOption(l,s.deprecationMessage)}delete a[l]}for(const l in a)d.onUnknownOption(l);return o}e.parseArgs=A;function y(g,w){let d="";return w.args&&(Array.isArray(w.args)?d=` <${w.args.join("> <")}>`:d=` <${w.args}>`),w.alias?`-${w.alias} --${g}${d}`:`--${g}${d}`}function E(g,w){const d=[];for(const b in g){const c=g[b],f=y(b,c);d.push([f,c.description])}return I(d,w)}e.formatOptions=E;function I(g,w){const b=g.reduce((u,i)=>Math.max(u,i[0].length),12)+2+1;if(w-b<25)return g.reduce((u,i)=>u.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const c=w-b-1,f=[];for(const u of g){const i=u[0],n=C(u[1],c),r=k(b-i.length-2);f.push("  "+i+r+n[0]);for(let o=1;o<n.length;o++)f.push(k(b)+n[o])}return f}function k(g){return" ".repeat(g)}function C(g,w){const d=[];for(;g.length;){const b=g.length<w?g.length:g.lastIndexOf(" ",w),c=g.slice(0,b).trim();g=g.slice(b),d.push(c)}return d}function p(g,w,d,b,c){const f=process.stdout.isTTY&&process.stdout.columns||80,u=c?.noInputFiles!==!0?`[${(0,P.localize)(37,null)}...]`:"",i=[`${g} ${d}`];i.push(""),i.push(`${(0,P.localize)(38,null)}: ${w} [${(0,P.localize)(39,null)}]${u}`),i.push(""),c?.noPipe!==!0&&(t.isWindows?i.push((0,P.localize)(40,null,w)):i.push((0,P.localize)(41,null,w)),i.push(""));const n={},r=[];for(const o in b){const a=b[o];if(a.type==="subcommand")a.description&&r.push({command:o,description:a.description});else if(a.description&&a.cat){let l=n[a.cat];l||(n[a.cat]=l={}),l[o]=a}}for(const o in n){const a=o,l=n[a];l&&(i.push(S[a]),i.push(...E(l,f)),i.push(""))}return r.length&&(i.push((0,P.localize)(42,null)),i.push(...I(r.map(o=>[o.command,o.description]),f)),i.push("")),i.join(`
`)}e.buildHelpMessage=p;function m(g,w){return`${g||(0,P.localize)(43,null)}
${w||(0,P.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(be[190],ve([1,0,275,162,60]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const S=2048;function D(C,p){const m=(f,u)=>{console.warn((0,t.localize)(0,null,f,u))},g=f=>{console.warn((0,t.localize)(1,null,f))},w=(f,u)=>{console.warn((0,t.localize)(2,null,f,u))},d=f=>({onUnknownOption:u=>{f!=="tunnel"&&console.warn((0,t.localize)(3,null,u,f))},onMultipleValues:m,onEmptyValue:g,onDeprecatedOption:w,getSubcommandReporter:f!=="tunnel"?d:void 0}),b={onUnknownOption:f=>{console.warn((0,t.localize)(4,null,f))},onMultipleValues:m,onEmptyValue:g,onDeprecatedOption:w,getSubcommandReporter:d},c=(0,P.parseArgs)(C,P.OPTIONS,p?b:void 0);return c.goto&&c._.forEach(f=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,t.localize)(5,null))),c["max-memory"]&&v(parseInt(c["max-memory"])>=S,`The max-memory argument cannot be specified lower than ${S} MB.`),c}function A(C){const p=C.findIndex(m=>!/^-/.test(m));if(p>-1)return[...C.slice(0,p),...C.slice(p+1)]}function y(C){let[,...p]=C;process.env.VSCODE_DEV&&(p=A(p)||[]);const m=!k(process.env);return D(p,m)}e.parseMainProcessArgv=y;function E(C){let[,,...p]=C;return process.env.VSCODE_DEV&&(p=A(p)||[]),D(p,!0)}e.parseCLIProcessArgv=E;function I(C,...p){const m=C.indexOf("--");return m===-1?C.push(...p):C.splice(m,0,...p),C}e.addArg=I;function k(C){return C.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function re(e,v,t){function P(D,A){const y=S(D,A),E=[y];return e.isAbsolute(y)||E.unshift(t),e.resolve(...E)}function S(D,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,A);const I=D["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(k,"AppData","Roaming")}break;case"darwin":E=e.join(v.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,A)}return{getUserDataPath:P}}if(typeof define=="function")define(be[191],ve([91,28,27]),function(e,v,t){return re(e,v,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("os");module.exports=re(e,v,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(be[192],ve([1,0,28,100,191]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends t.AbstractNativeEnvironmentService{constructor(A,y){super(A,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,P.getUserDataPath)(A,y.nameShort)},y)}}e.NativeEnvironmentService=S}),define(be[193],ve([1,0,9,166]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(D,A,y){try{S(D,A,y)}catch(E){console.error(E?.message??E)}return D}e.localizeManifest=P;function S(D,A,y){const E=(I,k,C)=>{const p=I[k];if((0,v.isString)(p)){const m=p,g=m.length;if(g>1&&m[0]==="%"&&m[g-1]==="%"){const w=m.substr(1,g-2);let d=A[w];d===void 0&&y&&(d=y[w]);const b=typeof d=="string"?d:d?.message,c=y?.[w],f=typeof c=="string"?c:c?.message;if(!b){f||console.warn(`[${D.name}]: ${(0,t.localize)(0,null,w)}`);return}if(C&&(k==="title"||k==="category")&&f&&f!==b){const u={value:b,original:f};I[k]=u}else I[k]=b}}else if((0,v.isObject)(p))for(const m in p)p.hasOwnProperty(m)&&(m==="commands"?E(p,m,!0):E(p,m,C));else if(Array.isArray(p))for(let m=0;m<p.length;m++)E(p,m,C)};for(const I in D)D.hasOwnProperty(I)&&E(D,I)}}),define(be[194],ve([1,0,8]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(S,D){this.a.set(S,D)}updateManifest(S){if(!(typeof S.main>"u"&&typeof S.browser>"u")&&(S.activationEvents===void 0&&Object.assign(S,{activationEvents:[]}),!(!Array.isArray(S.activationEvents)||!S.contributes)))for(const D in S.contributes){const A=this.a.get(D);if(!A)continue;const y=S.contributes[D],E=Array.isArray(y)?y:[y];try{A(E,S.activationEvents)}catch(I){(0,v.onUnexpectedError)(I)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(be[73],ve([1,0,20,70,170,49]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(d){return d=d.trim(),d==="*"||D.test(d)}e.isValidVersionStr=y;function E(d){if(!y(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=d.match(D);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=E;function I(d){if(!d)return null;const b=d.majorBase,c=d.majorMustEqual,f=d.minorBase;let u=d.minorMustEqual;const i=d.patchBase;let n=d.patchMustEqual;d.hasCaret&&(b===0||(u=!1),n=!1);let r=0;if(d.preRelease){const o=A.exec(d.preRelease);if(o){const[,a,l,s]=o;r=Date.UTC(Number(a),Number(l)-1,Number(s))}}return{majorBase:b,majorMustEqual:c,minorBase:f,minorMustEqual:u,patchBase:i,patchMustEqual:n,isMinimum:d.hasGreaterEquals,notBefore:r}}e.normalizeVersion=I;function k(d,b,c){let f;typeof d=="string"?f=I(E(d)):f=d;let u;b instanceof Date?u=b.getTime():typeof b=="string"&&(u=new Date(b).getTime());let i;if(typeof c=="string"?i=I(E(c)):i=c,!f||!i)return!1;const n=f.majorBase,r=f.minorBase,o=f.patchBase;let a=i.majorBase,l=i.minorBase,s=i.patchBase;const h=i.notBefore;let T=i.majorMustEqual,F=i.minorMustEqual,Z=i.patchMustEqual;return i.isMinimum?n>a?!0:n<a?!1:r>l?!0:r<l||u&&u<h?!1:o>=s:(n===1&&a===0&&(!T||!F||!Z)&&(a=1,l=0,s=0,T=!0,F=!1,Z=!1),n<a?!1:n>a?!T:r<l?!1:r>l?!F:o<s?!1:o>s?!Z:!(u&&u<h))}e.isValidVersion=k;function C(d,b,c,f,u){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([t.default.Error,P.localize(0,null)]),i;if(typeof f.name!="string")return i.push([t.default.Error,P.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([t.default.Error,P.localize(2,null,"version")]),i;if(!f.engines)return i.push([t.default.Error,P.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([t.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!w(f.extensionDependencies))return i.push([t.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!w(f.activationEvents))return i.push([t.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([t.default.Error,P.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([t.default.Warning,P.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([t.default.Error,P.localize(9,null,"main")]),i;{const o=(0,v.joinPath)(c,f.main);(0,v.isEqualOrParent)(o,c)||i.push([t.default.Warning,P.localize(10,null,o.path,c.path)])}if(typeof f.activationEvents>"u")return i.push([t.default.Error,P.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([t.default.Error,P.localize(12,null,"browser")]),i;{const o=(0,v.joinPath)(c,f.browser);(0,v.isEqualOrParent)(o,c)||i.push([t.default.Warning,P.localize(13,null,o.path,c.path)])}if(typeof f.activationEvents>"u")return i.push([t.default.Error,P.localize(14,null,"activationEvents","browser")]),i}if(!S.valid(f.version))return i.push([t.default.Error,P.localize(15,null)]),i;const n=[];if(!p(d,b,f,u,n))for(const o of n)i.push([t.default.Error,o]);return i}e.validateExtensionManifest=C;function p(d,b,c,f,u){return f||typeof c.main>"u"&&typeof c.browser>"u"?!0:g(d,b,c.engines.vscode,u)}e.isValidExtensionVersion=p;function m(d,b,c){return d==="*"||g(b,c,d)}e.isEngineValid=m;function g(d,b,c,f=[]){const u=I(E(c));if(!u)return f.push(P.localize(16,null,c)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return f.push(P.localize(17,null,c)),!1}else if(!u.majorMustEqual)return f.push(P.localize(18,null,c)),!1;return k(d,b,u)?!0:(f.push(P.localize(19,null,d,c)),!1)}function w(d){if(!Array.isArray(d))return!1;for(let b=0,c=d.length;b<c;b++)if(typeof d[b]!="string")return!1;return!0}}),define(be[195],ve([1,0,16,21]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(S,D,A){let y=A&&A.get("storage.serviceMachineId",-1)||null;if(y)return y;try{const I=(await D.readFile(S.serviceMachineIdResource)).value.toString();y=(0,t.isUUID)(I)?I:null}catch{y=null}if(!y){y=(0,t.generateUuid)();try{await D.writeFile(S.serviceMachineIdResource,v.VSBuffer.fromString(y))}catch{}}return A?.store("storage.serviceMachineId",y,-1,1),y}e.getServiceMachineId=P}),define(be[61],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(P,S=[],D=!1){this.ctor=P,this.staticArguments=S,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=v}),define(be[196],ve([1,0,61]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var P;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function S(A,y,E){y instanceof v.SyncDescriptor||(y=new v.SyncDescriptor(y,[],Boolean(E))),t.push([A,y])}e.registerSingleton=S;function D(){return t}e.getSingletonServiceDescriptors=D}),define(be[197],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(S,D){this.key=S,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=v;class t{constructor(S){this.b=S,this.a=new Map}roots(){const S=[];for(const D of this.a.values())D.outgoing.size===0&&S.push(D);return S}insertEdge(S,D){const A=this.lookupOrInsertNode(S),y=this.lookupOrInsertNode(D);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(S){const D=this.b(S);this.a.delete(D);for(const A of this.a.values())A.outgoing.delete(D),A.incoming.delete(D)}lookupOrInsertNode(S){const D=this.b(S);let A=this.a.get(D);return A||(A=new v(D,S),this.a.set(D,A)),A}lookup(S){return this.a.get(this.b(S))}isEmpty(){return this.a.size===0}toString(){const S=[];for(const[D,A]of this.a)S.push(`${D}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return S.join(`
`)}findCycleSlow(){for(const[S,D]of this.a){const A=new Set([S]),y=this.c(D,A);if(y)return y}}c(S,D){for(const[A,y]of S.outgoing){if(D.has(A))return[...D,A].join(" -> ");D.add(A);const E=this.c(y,D);if(E)return E;D.delete(A)}}}e.Graph=t}),define(be[5],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=A})(v=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function t(D,A,y){A[v.DI_TARGET]===A?A[v.DI_DEPENDENCIES].push({id:D,index:y}):(A[v.DI_DEPENDENCIES]=[{id:D,index:y}],A[v.DI_TARGET]=A)}function P(D){if(v.serviceIds.has(D))return v.serviceIds.get(D);const A=function(y,E,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,y,I)};return A.toString=()=>D,v.serviceIds.set(D,A),A}e.createDecorator=P;function S(D){return D}e.refineServiceDecorator=S}),define(be[24],ve([1,0,9,4,5]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function S(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=S;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function E(d,b){const c=Object.create(null);for(const f in d)I(c,f,d[f],b);return c}e.toValuesTree=E;function I(d,b,c,f){const u=b.split("."),i=u.pop();let n=d;for(let r=0;r<u.length;r++){const o=u[r];let a=n[o];switch(typeof a){case"undefined":a=n[o]=Object.create(null);break;case"object":break;default:f(`Ignoring ${b} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[i]=c}catch{f(`Ignoring ${b} as ${u.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${b} as ${u.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=I;function k(d,b){const c=b.split(".");C(d,c)}e.removeFromValueTree=k;function C(d,b){const c=b.shift();if(b.length===0){delete d[c];return}if(Object.keys(d).indexOf(c)!==-1){const f=d[c];typeof f=="object"&&!Array.isArray(f)&&(C(f,b),Object.keys(f).length===0&&delete d[c])}}function p(d,b,c){function f(n,r){let o=n;for(const a of r){if(typeof o!="object"||o===null)return;o=o[a]}return o}const u=b.split("."),i=f(d,u);return typeof i>"u"?c:i}e.getConfigurationValue=p;function m(d,b,c){Object.keys(b).forEach(f=>{f!=="__proto__"&&(f in d?v.isObject(d[f])&&v.isObject(b[f])?m(d[f],b[f],c):c&&(d[f]=b[f]):d[f]=b[f])})}e.merge=m;function g(d,b,c){const f=d.inspect(b),u=d.inspect(c);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:f.defaultValue}e.getMigratedSettingValue=g;function w(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(be[101],ve([1,0,3,15,5]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",v.isMacintosh),S.set("isLinux",v.isLinux),S.set("isWindows",v.isWindows),S.set("isWeb",v.isWeb),S.set("isMacNative",v.isMacintosh&&!v.isWeb),S.set("isEdge",v.isEdge),S.set("isFirefox",v.isFirefox),S.set("isChrome",v.isChrome),S.set("isSafari",v.isSafari);const D=Object.prototype.hasOwnProperty;var A;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return k.INSTANCE}static true(){return C.INSTANCE}static has(M){return p.create(M)}static equals(M,J){return m.create(M,J)}static notEquals(M,J){return d.create(M,J)}static regex(M,J){return r.create(M,J)}static in(M,J){return g.create(M,J)}static notIn(M,J){return w.create(M,J)}static not(M){return b.create(M)}static and(...M){return l.create(M,null,!0)}static or(...M){return s.create(M,null,!0)}static greater(M,J){return f.create(M,J)}static greaterEquals(M,J){return u.create(M,J)}static smaller(M,J){return i.create(M,J)}static smallerEquals(M,J){return n.create(M,J)}static deserialize(M,J=!1){if(!!M)return this.c(M,J)}static c(M,J){const $=M.split("||");return s.create($.map(V=>this.d(V,J)),null,!0)}static d(M,J){const $=M.split("&&");return l.create($.map(V=>this.f(V,J)),null,!0)}static f(M,J){if(M=M.trim(),M.indexOf("!=")>=0){const $=M.split("!=");return d.create($[0].trim(),this.g($[1],J))}if(M.indexOf("==")>=0){const $=M.split("==");return m.create($[0].trim(),this.g($[1],J))}if(M.indexOf("=~")>=0){const $=M.split("=~");return r.create($[0].trim(),this.h($[1],J))}if(M.indexOf(" not in ")>=0){const $=M.split(" not in ");return w.create($[0].trim(),this.g($[1],J))}if(M.indexOf(" in ")>=0){const $=M.split(" in ");return g.create($[0].trim(),this.g($[1],J))}if(/^[^<=>]+>=[^<=>]+$/.test(M)){const $=M.split(">=");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(M)){const $=M.split(">");return f.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(M)){const $=M.split("<=");return n.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(M)){const $=M.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(M)?b.create(M.substr(1).trim()):p.create(M)}static g(M,J){if(M=M.trim(),M==="true")return!0;if(M==="false")return!1;const $=/^'([^']*)'$/.exec(M);return $?$[1].trim():M}static h(M,J){if((0,t.isFalsyOrWhitespace)(M)){if(J)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=M.indexOf("/"),V=M.lastIndexOf("/");if($===V||$<0){if(J)throw new Error(`bad regexp-value '${M}', missing /-enclosure`);return console.warn(`bad regexp-value '${M}', missing /-enclosure`),null}const X=M.slice($+1,V),ue=M[V+1]==="i"?"i":"";try{return new RegExp(X,ue)}catch(L){if(J)throw new Error(`bad regexp-value '${M}', parse error: ${L}`);return console.warn(`bad regexp-value '${M}', parse error: ${L}`),null}}}e.ContextKeyExpr=y;function E(ie,M){const J=ie?ie.substituteConstants():void 0,$=M?M.substituteConstants():void 0;return!J&&!$?!0:!J||!$?!1:J.equals($)}e.expressionsAreEqualWithConstantSubstitution=E;function I(ie,M){return ie.cmp(M)}class k{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return C.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class C{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=C,C.INSTANCE=new C;class p{static create(M,J=null){const $=S.get(M);return typeof $=="boolean"?$?C.INSTANCE:k.INSTANCE:new p(M,J)}constructor(M,J){this.key=M,this.c=J,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:T(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=S.get(this.key);return typeof M=="boolean"?M?C.INSTANCE:k.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class m{static create(M,J,$=null){if(typeof J=="boolean")return J?p.create(M,$):b.create(M,$);const V=S.get(M);return typeof V=="boolean"?J===(V?"true":"false")?C.INSTANCE:k.INSTANCE:new m(M,J,$)}constructor(M,J,$){this.c=M,this.d=J,this.f=$,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:F(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=S.get(this.c);if(typeof M=="boolean"){const J=M?"true":"false";return this.d===J?C.INSTANCE:k.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class g{static create(M,J){return new g(M,J)}constructor(M,J){this.d=M,this.f=J,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:F(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const J=M.getValue(this.f),$=M.getValue(this.d);return Array.isArray(J)?J.includes($):typeof $=="string"&&typeof J=="object"&&J!==null?D.call(J,$):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class w{static create(M,J){return new w(M,J)}constructor(M,J){this.d=M,this.f=J,this.type=11,this.c=g.create(M,J)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=w;class d{static create(M,J,$=null){if(typeof J=="boolean")return J?b.create(M,$):p.create(M,$);const V=S.get(M);return typeof V=="boolean"?J===(V?"true":"false")?k.INSTANCE:C.INSTANCE:new d(M,J,$)}constructor(M,J,$){this.c=M,this.d=J,this.f=$,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:F(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=S.get(this.c);if(typeof M=="boolean"){const J=M?"true":"false";return this.d===J?k.INSTANCE:C.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=d;class b{static create(M,J=null){const $=S.get(M);return typeof $=="boolean"?$?k.INSTANCE:C.INSTANCE:new b(M,J)}constructor(M,J){this.c=M,this.d=J,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:T(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=S.get(this.c);return typeof M=="boolean"?M?k.INSTANCE:C.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function c(ie,M){if(typeof ie=="string"){const J=parseFloat(ie);isNaN(J)||(ie=J)}return typeof ie=="string"||typeof ie=="number"?M(ie):k.INSTANCE}class f{static create(M,J,$=null){return c(J,V=>new f(M,V,$))}constructor(M,J,$){this.c=M,this.d=J,this.f=$,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:F(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=f;class u{static create(M,J,$=null){return c(J,V=>new u(M,V,$))}constructor(M,J,$){this.c=M,this.d=J,this.f=$,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:F(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=u;class i{static create(M,J,$=null){return c(J,V=>new i(M,V,$))}constructor(M,J,$){this.c=M,this.d=J,this.f=$,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:F(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class n{static create(M,J,$=null){return c(J,V=>new n(M,V,$))}constructor(M,J,$){this.c=M,this.d=J,this.f=$,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:F(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=n;class r{static create(M,J){return new r(M,J)}constructor(M,J){this.d=M,this.f=J,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const J=this.f?this.f.source:"",$=M.f?M.f.source:"";return J<$?-1:J>$?1:0}equals(M){if(M.type===this.type){const J=this.f?this.f.source:"",$=M.f?M.f.source:"";return this.d===M.d&&J===$}return!1}substituteConstants(){return this}evaluate(M){const J=M.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=o.create(this)),this.c}}e.ContextKeyRegexExpr=r;class o{static create(M){return new o(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(M){return new o(this.c.map(M))}negate(){return this.c}}e.ContextKeyNotRegexExpr=o;function a(ie){let M=null;for(let J=0,$=ie.length;J<$;J++){const V=ie[J].substituteConstants();if(ie[J]!==V&&M===null){M=[];for(let X=0;X<J;X++)M[X]=ie[X]}M!==null&&(M[J]=V)}return M===null?ie:M}class l{static create(M,J,$){return l.d(M,J,$)}constructor(M,J){this.expr=M,this.c=J,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let J=0,$=this.expr.length;J<$;J++){const V=I(this.expr[J],M.expr[J]);if(V!==0)return V}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let J=0,$=this.expr.length;J<$;J++)if(!this.expr[J].equals(M.expr[J]))return!1;return!0}return!1}substituteConstants(){const M=a(this.expr);return M===this.expr?this:l.create(M,this.c,!1)}evaluate(M){for(let J=0,$=this.expr.length;J<$;J++)if(!this.expr[J].evaluate(M))return!1;return!0}static d(M,J,$){const V=[];let X=!1;for(const ue of M)if(!!ue){if(ue.type===1){X=!0;continue}if(ue.type===0)return k.INSTANCE;if(ue.type===6){V.push(...ue.expr);continue}V.push(ue)}if(V.length===0&&X)return C.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(I);for(let ue=1;ue<V.length;ue++)V[ue-1].equals(V[ue])&&(V.splice(ue,1),ue--);if(V.length===1)return V[0];for(;V.length>1;){const ue=V[V.length-1];if(ue.type!==9)break;V.pop();const L=V.pop(),N=V.length===0,H=s.create(ue.expr.map(ee=>l.create([ee,L],null,$)),null,N);H&&(V.push(H),V.sort(I))}if(V.length===1)return V[0];if($){for(let ue=0;ue<V.length;ue++)for(let L=ue+1;L<V.length;L++)if(V[ue].negate().equals(V[L]))return k.INSTANCE;if(V.length===1)return V[0]}return new l(V,J)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const J of this.expr)M.push(...J.keys());return M}map(M){return new l(this.expr.map(J=>J.map(M)),null)}negate(){if(!this.c){const M=[];for(const J of this.expr)M.push(J.negate());this.c=s.create(M,this,!0)}return this.c}}class s{static create(M,J,$){return s.d(M,J,$)}constructor(M,J){this.expr=M,this.c=J,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let J=0,$=this.expr.length;J<$;J++){const V=I(this.expr[J],M.expr[J]);if(V!==0)return V}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let J=0,$=this.expr.length;J<$;J++)if(!this.expr[J].equals(M.expr[J]))return!1;return!0}return!1}substituteConstants(){const M=a(this.expr);return M===this.expr?this:s.create(M,this.c,!1)}evaluate(M){for(let J=0,$=this.expr.length;J<$;J++)if(this.expr[J].evaluate(M))return!0;return!1}static d(M,J,$){let V=[],X=!1;if(M){for(let ue=0,L=M.length;ue<L;ue++){const N=M[ue];if(!!N){if(N.type===0){X=!0;continue}if(N.type===1)return C.INSTANCE;if(N.type===9){V=V.concat(N.expr);continue}V.push(N)}}if(V.length===0&&X)return k.INSTANCE;V.sort(I)}if(V.length!==0){if(V.length===1)return V[0];for(let ue=1;ue<V.length;ue++)V[ue-1].equals(V[ue])&&(V.splice(ue,1),ue--);if(V.length===1)return V[0];if($){for(let ue=0;ue<V.length;ue++)for(let L=ue+1;L<V.length;L++)if(V[ue].negate().equals(V[L]))return C.INSTANCE;if(V.length===1)return V[0]}return new s(V,J)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const J of this.expr)M.push(...J.keys());return M}map(M){return new s(this.expr.map(J=>J.map(M)),null)}negate(){if(!this.c){const M=[];for(const J of this.expr)M.push(J.negate());for(;M.length>1;){const J=M.shift(),$=M.shift(),V=[];for(const X of ce(J))for(const ue of ce($))V.push(l.create([X,ue],null,!1));M.unshift(s.create(V,null,!1))}this.c=s.create(M,this,!0)}return this.c}}class h extends p{static all(){return h.d.values()}constructor(M,J,$){super(M,null),this.f=J,typeof $=="object"?h.d.push({...$,key:M}):$!==!0&&h.d.push({key:M,description:$,type:J!=null?typeof J:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return m.create(this.key,M)}notEqualsTo(M){return d.create(this.key,M)}}e.RawContextKey=h,h.d=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function T(ie,M){return ie<M?-1:ie>M?1:0}function F(ie,M,J,$){return ie<J?-1:ie>J?1:M<$?-1:M>$?1:0}function Z(ie,M){if(ie.type===0||M.type===1)return!0;if(ie.type===9)return M.type===9?ne(ie.expr,M.expr):!1;if(M.type===9){for(const J of M.expr)if(Z(ie,J))return!0;return!1}if(ie.type===6){if(M.type===6)return ne(M.expr,ie.expr);for(const J of ie.expr)if(Z(J,M))return!0;return!1}return ie.equals(M)}e.implies=Z;function ne(ie,M){let J=0,$=0;for(;J<ie.length&&$<M.length;){const V=ie[J].cmp(M[$]);if(V<0)return!1;V===0&&J++,$++}return J===ie.length}function ce(ie){return ie.type===9?ie.expr:[ie]}}),define(be[74],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(S,D){return this.a[S]?.[D]??null}async setPassword(S,D,A){this.a[S]=this.a[S]??{},this.a[S][D]=A}async deletePassword(S,D){return this.a[S]?.[D]?(delete this.a[S][D],Object.keys(this.a[S]).length===0&&delete this.a[S],!0):!1}async findPassword(S){return JSON.stringify(this.a[S])??null}async findCredentials(S){const D=[];for(const A of Object.keys(this.a[S]||{}))D.push({account:A,password:this.a[S][A]});return D}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(be[198],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(S){return!!S.hostName&&!!S.errorMessage}e.isRemoteDiagnosticError=t;class P{async getPerformanceInfo(D,A){return{}}async getSystemInfo(D,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,A){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=P}),define(be[75],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,v.createDecorator)("downloadService")}),define(be[199],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(be[30],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(be[31],ve([1,0,164,5]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function P(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function S(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=S;function D(d,b){switch(d){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function A(d,b){return b==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(d,b,c){return A(b,c)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===c?!0:E(c).includes(d)}e.isTargetPlatformCompatible=y;function E(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function I(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=I;var k;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var C;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var p;(function(d){d.Install="install",d.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var m;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(b,c){super(b),this.code=c,this.name=c}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(be[200],ve([1,0,6,2,45,23,4,72,31]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(w,d){return D.URI.revive(d?d.transformIncoming(w):w)}function I(w,d){return d?d.transformOutgoingURI(w):w}function k(w,d){d=d||A.DefaultURITransformer;const b=w.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...w,manifest:void 0},d),manifest:b}}function C(w,d){return d?(0,S.cloneAndChange)(w,b=>b instanceof D.URI?d.transformOutgoingURI(b):void 0):w}class p{constructor(d,b){this.a=d,this.b=b,this.onInstallExtension=v.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=v.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=v.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,b){const c=this.b(d);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return v.Event.map(this.onDidInstallExtensions,f=>f.map(u=>({...u,local:u.local?C(u.local,c):u.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,b,c){const f=this.b(d);switch(b){case"zip":return this.a.zip(k(c[0],f)).then(u=>I(u,f));case"unzip":return this.a.unzip(E(c[0],f));case"install":return this.a.install(E(c[0],f),(0,P.revive)(c[1]));case"installFromLocation":return this.a.installFromLocation(E(c[0],f),D.URI.revive(c[1]));case"getManifest":return this.a.getManifest(E(c[0],f));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(c[0]);case"installFromGallery":return this.a.installFromGallery(c[0],(0,P.revive)(c[1]));case"uninstall":return this.a.uninstall(k(c[0],f),(0,P.revive)(c[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(k(c[0],f));case"getInstalled":return this.a.getInstalled(c[0],D.URI.revive(c[1])).then(u=>u.map(i=>C(i,f)));case"getMetadata":return this.a.getMetadata(k(c[0],f));case"updateMetadata":return this.a.updateMetadata(k(c[0],f),c[1]).then(u=>C(u,f));case"updateExtensionScope":return this.a.updateExtensionScope(k(c[0],f),c[1]).then(u=>C(u,f));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(c[0],c[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class m extends t.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(d){super(),this.j=d,this.c=this.B(new v.Emitter),this.f=this.B(new v.Emitter),this.g=this.B(new v.Emitter),this.h=this.B(new v.Emitter),this.B(this.j.listen("onInstallExtension")(b=>this.c.fire({identifier:b.identifier,source:this.k(b.source)?D.URI.revive(b.source):b.source,profileLocation:D.URI.revive(b.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(b=>this.f.fire(b.map(c=>({...c,local:c.local?k(c.local,null):c.local,source:this.k(c.source)?D.URI.revive(c.source):c.source,profileLocation:D.URI.revive(c.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(b=>this.g.fire({identifier:b.identifier,profileLocation:D.URI.revive(b.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(b=>this.h.fire({...b,profileLocation:D.URI.revive(b.profileLocation)})))}k(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(d){const b=await this.getTargetPlatform();return d.allTargetPlatforms.some(c=>(0,y.isTargetPlatformCompatible)(c,d.allTargetPlatforms,b))}zip(d){return Promise.resolve(this.j.call("zip",[d]).then(b=>D.URI.revive(b)))}unzip(d){return Promise.resolve(this.j.call("unzip",[d]))}install(d,b){return Promise.resolve(this.j.call("install",[d,b])).then(c=>k(c,null))}installFromLocation(d,b){return Promise.resolve(this.j.call("installFromLocation",[d,b])).then(c=>k(c,null))}getManifest(d){return Promise.resolve(this.j.call("getManifest",[d]))}installFromGallery(d,b){return Promise.resolve(this.j.call("installFromGallery",[d,b])).then(c=>k(c,null))}uninstall(d,b){return Promise.resolve(this.j.call("uninstall",[d,b]))}reinstallFromGallery(d){return Promise.resolve(this.j.call("reinstallFromGallery",[d]))}getInstalled(d=null,b){return Promise.resolve(this.j.call("getInstalled",[d,b])).then(c=>c.map(f=>k(f,null)))}getMetadata(d){return Promise.resolve(this.j.call("getMetadata",[d]))}updateMetadata(d,b){return Promise.resolve(this.j.call("updateMetadata",[d,b])).then(c=>k(c,null))}updateExtensionScope(d,b){return Promise.resolve(this.j.call("updateExtensionScope",[d,b])).then(c=>k(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(d,b){const c=await this.j.call("download",[d,b]);return D.URI.revive(c)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class g{constructor(d){this.a=d}listen(d,b){throw new Error("Invalid listen")}call(d,b,c){switch(b){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(be[76],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,v.createDecorator)("IExtensionSignatureVerificationService");class t{b(){return this.a||(this.a=new Promise((S,D)=>re(["node-vsce-sign"],async A=>S(A),D))),this.a}async verify(S,D){let A;try{A=await this.b()}catch{return!1}return A.verify(S,D)}}e.ExtensionSignatureVerificationService=t}),define(be[17],ve([1,0,58,7,15,9,4,172,5]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function E(X){return X.create===!0}e.isFileOpenForWriteOptions=E;var I;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var k;(function(X){X[X.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var C;(function(X){X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(X){return!!(X.capabilities&2)}e.hasReadWriteCapability=p;function m(X){return!!(X.capabilities&8)}e.hasFileFolderCopyCapability=m;function g(X){return!!(X.capabilities&32768)}e.hasFileCloneCapability=g;function w(X){return!!(X.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function d(X){return!!(X.capabilities&16)}e.hasFileReadStreamCapability=d;function b(X){return p(X)?!!(X.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var c;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(ue,L){super(ue),this.code=L}}e.FileSystemProviderError=f;function u(X,ue){const L=new f(X.toString(),ue);return n(L,ue),L}e.createFileSystemProviderError=u;function i(X){return X||u((0,A.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=i;function n(X,ue){return X.name=ue?`${ue} (FileSystemError)`:"FileSystemError",X}e.markAsFileSystemProviderError=n;function r(X){if(!X)return c.Unknown;if(X instanceof f)return X.code;const ue=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!ue)return c.Unknown;switch(ue[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=r;function o(X){if(X instanceof F)return X.fileOperationResult;switch(r(X)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var a;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class l{constructor(ue,L,N){this.resource=ue,this.operation=L,this.target=N}isOperation(ue){return this.operation===ue}}e.FileOperationEvent=l;var s;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class h{constructor(ue,L){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ue;const N=new Map;for(const H of ue){const ee=N.get(H.type);switch(ee?ee.push([H.resource,H]):N.set(H.type,[[H.resource,H]]),H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}}for(const[H,ee]of N)switch(H){case 1:this.a=v.TernarySearchTree.forUris(()=>L),this.a.fill(ee);break;case 0:this.b=v.TernarySearchTree.forUris(()=>L),this.b.fill(ee);break;case 2:this.c=v.TernarySearchTree.forUris(()=>L),this.c.fill(ee);break}}contains(ue,...L){return this.d(ue,{includeChildren:!1},...L)}affects(ue,...L){return this.d(ue,{includeChildren:!0},...L)}d(ue,L,...N){if(!ue)return!1;const H=N.length>0;return!!((!H||N.includes(1))&&(this.a?.get(ue)||L.includeChildren&&this.a?.findSuperstr(ue))||(!H||N.includes(0))&&(this.b?.get(ue)||L.includeChildren&&this.b?.findSuperstr(ue))||(!H||N.includes(2))&&(this.c?.findSubstr(ue)||L.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=h;function T(X,ue,L){return!X||!ue||X===ue||ue.length>X.length?!1:(ue.charAt(ue.length-1)!==t.sep&&(ue+=t.sep),L?(0,P.startsWithIgnoreCase)(X,ue):X.indexOf(ue)===0)}e.isParent=T;class F extends Error{constructor(ue,L,N){super(ue),this.fileOperationResult=L,this.options=N}}e.FileOperationError=F;class Z extends F{constructor(ue,L,N){super(ue,2,N),this.stat=L}}e.NotModifiedSinceFileOperationError=Z;var ne;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",X[X.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ne=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ce;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ie(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.etag=ie;async function M(X,ue){if(!ue.hasProvider(D.URI.from({scheme:X.scheme})))return new Promise(L=>{const N=ue.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===X.scheme&&H.added&&(N.dispose(),L())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(ue){return(0,S.isNumber)(ue)||(ue=0),ue<J.KB?(0,A.localize)(1,null,ue.toFixed(0)):ue<J.MB?(0,A.localize)(2,null,(ue/J.KB).toFixed(2)):ue<J.GB?(0,A.localize)(3,null,(ue/J.MB).toFixed(2)):ue<J.TB?(0,A.localize)(4,null,(ue/J.GB).toFixed(2)):(0,A.localize)(5,null,(ue/J.TB).toFixed(2))}}e.ByteSize=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;var $;(function(X){X[X.IA32=0]="IA32",X[X.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function V(X){return{maxFileSize:X===0?300*J.MB:16*J.GB,maxHeapSize:X===0?700*J.MB:2*700*J.MB}}e.getPlatformLimits=V}),define(be[201],ve([1,0,16,39,8,6,2,44,4,21,17]),function(re,e,v,t,P,S,D,A,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends D.Disposable{constructor(p,m){super(),this.a=p,this.b=m,this.onDidChangeCapabilities=S.Event.None,this.f=this.B(new S.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new S.Emitter),this.onDidWatchError=this.g.event,this.h=(0,E.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,m){const{buffer:g}=await this.a.call("readFile",[p,m]);return g}readFileStream(p,m,g){const w=(0,A.newWriteableStream)(b=>v.VSBuffer.concat(b.map(c=>v.VSBuffer.wrap(c))).buffer),d=this.a.listen("readFileStream",[p,m])(b=>{if(b instanceof v.VSBuffer)w.write(b.buffer);else{if(b==="end")w.end();else{let c=b;c instanceof Error||(c=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(c),I.FileSystemProviderErrorCode.Unknown)),w.error(c),w.end()}d.dispose()}});return g.onCancellationRequested(()=>{w.error((0,P.canceled)()),w.end(),d.dispose()}),w}writeFile(p,m,g){return this.a.call("writeFile",[p,v.VSBuffer.wrap(m),g])}open(p,m){return this.a.call("open",[p,m])}close(p){return this.a.call("close",[p])}async read(p,m,g,w,d){const[b,c]=await this.a.call("read",[p,m,d]);return g.set(b.buffer.slice(0,c),w),c}write(p,m,g,w,d){return this.a.call("write",[p,m,v.VSBuffer.wrap(g),w,d])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,m){return this.a.call("delete",[p,m])}rename(p,m,g){return this.a.call("rename",[p,m,g])}copy(p,m,g){return this.a.call("copy",[p,m,g])}cloneFile(p,m){return this.a.call("cloneFile",[p,m])}i(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const m=p;this.f.fire(m.map(g=>({resource:y.URI.revive(g.resource),type:g.type})))}else{const m=p;this.g.fire(m)}}))}watch(p,m){const g=(0,E.generateUuid)();return this.a.call("watch",[this.h,g,p,m]),(0,D.toDisposable)(()=>this.a.call("unwatch",[this.h,g]))}}e.DiskFileSystemProviderClient=k}),define(be[102],ve([1,0,16,8,173,17]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,k,C,p,m,g){let w;try{await A(I,k,C,p,m,g)}catch(d){w=d}finally{w&&m.errorTransformer&&(w=m.errorTransformer(w)),typeof w<"u"&&C.error(w),C.end()}}e.readFileIntoStream=D;async function A(I,k,C,p,m,g){y(g);const w=await I.open(k,{create:!1});try{y(g);let d=0,b=0,c=m&&typeof m.length=="number"?m.length:void 0,f=v.VSBuffer.alloc(Math.min(m.bufferSize,typeof c=="number"?c:m.bufferSize)),u=m&&typeof m.position=="number"?m.position:0,i=0;do b=await I.read(w,u,f.buffer,i,f.byteLength-i),u+=b,i+=b,d+=b,typeof c=="number"&&(c-=b),i===f.byteLength&&(await C.write(p(f)),f=v.VSBuffer.alloc(Math.min(m.bufferSize,typeof c=="number"?c:m.bufferSize)),i=0);while(b>0&&(typeof c!="number"||c>0)&&y(g)&&E(d,m));if(i>0){let n=i;typeof c=="number"&&(n=Math.min(i,c)),C.write(p(f.slice(0,n)))}}catch(d){throw(0,S.ensureFileSystemProviderError)(d)}finally{await I.close(w)}}function y(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function E(I,k){if(k?.limits){if(typeof k.limits.memory=="number"&&I>k.limits.memory)throw(0,S.createFileSystemProviderError)((0,P.localize)(0,null),S.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&I>k.limits.size)throw(0,S.createFileSystemProviderError)((0,P.localize)(1,null),S.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(be[62],ve([1,0,71,2,7,3,4,17]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function y(d){return d.recursive===!0}e.isRecursiveWatchRequest=y;class E extends t.Disposable{constructor(b,c,f,u){super(),this.h=b,this.i=c,this.j=f,this.k=u,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const b=new t.DisposableStore;this.c.value=b,this.b=this.l(b),this.b.setVerboseLogging(this.j),b.add(this.b.onDidChangeFile(c=>this.h(c))),b.add(this.b.onDidLogMessage(c=>this.i(c))),b.add(this.b.onDidError(c=>this.n(c)))}n(b){this.k.restartOnError?this.g<E.a&&this.f?(this.r(`restarting watcher after error: ${b}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${b}`):this.r(b)}p(b){this.g++,this.m(),this.watch(b)}async watch(b){this.f=b,await this.b?.watch(b)}async setVerboseLogging(b){this.j=b,await this.b?.setVerboseLogging(b)}r(b){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${b}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.a=5;class I extends E{constructor(b,c,f){super(b,c,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class k extends E{constructor(b,c,f){super(b,c,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function C(d){return d.map(b=>({type:b.type,resource:D.URI.file(b.path)}))}e.toFileChanges=C;function p(d){const b=new w;for(const c of d)b.processEvent(c);return b.coalesce()}e.coalesceEvents=p;function m(d,b){return typeof b=="string"&&!b.startsWith(v.GLOBSTAR)&&!(0,P.isAbsolute)(b)?{base:d,pattern:b}:b}e.normalizeWatcherPattern=m;function g(d,b){const c=[];for(const f of b)c.push((0,v.parse)(m(d,f)));return c}e.parseWatcherPatterns=g;class w{constructor(){this.a=new Set,this.b=new Map}c(b){return S.isLinux?b.path:b.path.toLowerCase()}processEvent(b){const c=this.b.get(this.c(b));let f=!1;if(c){const u=c.type,i=b.type;c.path!==b.path&&(b.type===2||b.type===1)?f=!0:u===1&&i===2?(this.b.delete(this.c(b)),this.a.delete(c)):u===2&&i===1?c.type=0:u===1&&i===0||(c.type=i)}else f=!0;f&&(this.a.add(b),this.b.set(this.c(b),b))}coalesce(){const b=[],c=[];return Array.from(this.a).filter(f=>f.type!==2?(b.push(f),!1):!0).sort((f,u)=>f.path.length-u.path.length).filter(f=>c.some(u=>(0,A.isParent)(f.path,u,!S.isLinux))?!1:(c.push(f.path),!0)).concat(b)}}}),define(be[202],ve([1,0,29,14,19,37,2,88,7,3,148,22,62]),function(re,e,v,t,P,S,D,A,y,E,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends D.Disposable{constructor(w,d,b,c){super(),this.k=w,this.l=d,this.m=b,this.n=c,this.c=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.l(f)),this.f=this.B(new t.ThrottledDelayer(p.b)),this.g=[],this.h=(0,C.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,C.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new P.CancellationTokenSource,this.ready=this.r()}async r(){try{const w=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const d=await k.Promises.stat(w);this.B(await this.t(w,d.isDirectory()))}catch(w){w.code!=="ENOENT"?this.w(w):this.z(w)}}async s(w){let d=w.path;try{d=await k.Promises.realpath(w.path),w.path===d&&(d=await(0,I.realcase)(w.path)??w.path),w.path!==d&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${d})`)}catch{}return d}async t(w,d){if(E.isMacintosh&&(0,S.isEqualOrParent)(w,"/Volumes/",!0))return this.w(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const b=new P.CancellationTokenSource(this.j.token),c=new D.DisposableStore;try{const f=(0,y.basename)(w),u=(0,v.watch)(w);c.add((0,D.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.z(`Started watching: '${w}'`);const i=new Set;if(d)try{for(const r of await k.Promises.readdir(w))i.add(r)}catch(r){this.w(r)}const n=new Map;c.add((0,D.toDisposable)(()=>{for(const[,r]of n)r.dispose();n.clear()})),u.on("error",(r,o)=>{this.w(`Failed to watch ${w} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),u.on("change",(r,o)=>{if(b.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${o}`);let a="";if(o&&(a=o.toString(),E.isMacintosh&&(a=(0,A.normalizeNFC)(a))),!(!a||r!=="change"&&r!=="rename"))if(d)if(r==="rename"){n.get(a)?.dispose();const l=setTimeout(async()=>{if(n.delete(a),a===f&&!await k.Promises.exists(w)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,y.join)(w,a));if(b.token.isCancellationRequested)return;let h;s?i.has(a)?h=0:(h=1,i.add(a)):(i.delete(a),h=2),this.u({path:(0,y.join)(this.k.path,a),type:h})},p.a);n.set(a,(0,D.toDisposable)(()=>clearTimeout(l)))}else{let l;i.has(a)?l=0:(l=1,i.add(a)),this.u({path:(0,y.join)(this.k.path,a),type:l})}else if(r==="rename"||a!==f){const l=setTimeout(async()=>{const s=await k.Promises.exists(w);b.token.isCancellationRequested||(s?(this.u({path:this.k.path,type:0},!0),c.add(await this.t(w,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},p.a);c.clear(),c.add((0,D.toDisposable)(()=>clearTimeout(l)))}else this.u({path:this.k.path,type:0},!0)})}catch(f){await k.Promises.exists(w)&&!b.token.isCancellationRequested&&this.w(`Failed to watch ${w} for changes using fs.watch() (${f.toString()})`)}return(0,D.toDisposable)(()=>{b.dispose(!0),c.dispose()})}async u(w,d=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!d&&this.h.some(b=>b(w.path))?this.n&&this.z(` >> ignored (excluded) ${w.path}`):!d&&this.i&&this.i.length>0&&!this.i.some(b=>b(w.path))?this.n&&this.z(` >> ignored (not included) ${w.path}`):this.g.push(w);try{await this.f.trigger(async()=>{const b=this.g;this.g=[];const c=(0,C.coalesceEvents)(b);if(c.length>0){if(this.n)for(const u of c)this.z(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.c.work(c)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(w){if(E.isLinux)return k.Promises.exists(w);try{const d=(0,y.basename)(w);return(await k.Promises.readdir((0,y.dirname)(w))).some(c=>c===d)}catch(d){return this.z(d),!1}}setVerboseLogging(w){this.n=w}w(w){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}y(w){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}z(w){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p,p.a=100,p.b=50;async function m(g,w,d,b,c=512){const f=await k.Promises.open(g,"r"),u=Buffer.allocUnsafe(c),i=new P.CancellationTokenSource(b);let n,r=!1;const o={path:g,excludes:[],recursive:!1},a=new p(o,l=>{(async()=>{for(const{type:s}of l)if(s===0){if(r)return;r=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:h}=await k.Promises.read(f,u,0,c,null);if(!h||i.token.isCancellationRequested)break;w(u.slice(0,h))}}catch(h){n=new Error(h),i.dispose(!0)}finally{r=!1}}})()});return await a.ready,d(),new Promise((l,s)=>{i.token.onCancellationRequested(async()=>{a.dispose();try{await k.Promises.close(f)}catch(h){n=new Error(h)}n?s(n):l()})})}e.watchFileContents=m}),define(be[203],ve([1,0,6,71,2,3,202]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class A extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new v.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new v.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=v.Event.None,this.c=new Map,this.f=!1}async watch(E){const I=this.i(E),k=I.filter(p=>{const m=this.c.get(p.path);return m?!(0,t.patternsEquals)(m.request.excludes,p.excludes)||!(0,t.patternsEquals)(m.request.includes,p.includes):!0}),C=Array.from(this.c.values()).filter(({request:p})=>!I.find(m=>m.path===p.path&&(0,t.patternsEquals)(m.excludes,p.excludes)&&(0,t.patternsEquals)(m.includes,p.includes))).map(({request:p})=>p.path);k.length&&this.j(`Request to start watching: ${k.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"})`).join(",")}`),C.length&&this.j(`Request to stop watching: ${C.join(",")}`);for(const p of C)this.h(p);for(const p of k)this.g(p)}g(E){const I=new D.NodeJSFileWatcherLibrary(E,C=>this.a.fire(C),C=>this.b.fire(C),this.f),k={request:E,instance:I};this.c.set(E.path,k)}async stop(){for(const[E]of this.c)this.h(E);this.c.clear()}h(E){const I=this.c.get(E);I&&(this.c.delete(E),I.instance.dispose())}i(E){const I=new Map;for(const k of E){const C=S.isLinux?k.path:k.path.toLowerCase();I.set(C,k)}return Array.from(I.values())}async setVerboseLogging(E){this.f=E;for(const[,I]of this.c)I.instance.setVerboseLogging(E)}j(E){this.f&&this.b.fire({type:"trace",message:this.k(E)})}k(E,I){return I?`[File Watcher (node.js)] ${E} (path: ${I.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=A}),define(be[204],ve([1,0,62,203]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends v.AbstractNonRecursiveWatcherClient{constructor(D,A,y){super(D,A,y),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(be[205],ve([1,0,13,42,98,62]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends S.AbstractUniversalWatcherClient{constructor(y,E,I){super(y,E,I),this.m()}l(y){const E=y.add(new P.Client(v.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(E.onDidProcessExit(({code:I,signal:k})=>this.n(`terminated by itself with code ${I}, signal: ${k}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(be[77],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...P){this.a=new Map;for(const[S,D]of P)this.set(S,D)}set(P,S){const D=this.a.get(P);return this.a.set(P,S),D}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=v}),define(be[103],ve([1,0,14,8,2,61,197,5,77,87]),function(re,e,v,t,P,S,D,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class k extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class C{constructor(w=new y.ServiceCollection,d=!1,b,c=I){this.f=w,this.g=d,this.h=b,this.i=c,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=c?b?._globalGraph??new D.Graph(f=>f):void 0}createChild(w){return new C(w,this.g,this,this.i)}invokeFunction(w,...d){const b=m.traceInvocation(this.i,w);let c=!1;try{return w({get:u=>{if(c)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(u,b);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...d)}finally{c=!0,b.stop()}}createInstance(w,...d){let b,c;return w instanceof S.SyncDescriptor?(b=m.traceCreation(this.i,w.ctor),c=this.j(w.ctor,w.staticArguments.concat(d),b)):(b=m.traceCreation(this.i,w),c=this.j(w,d,b)),b.stop(),c}j(w,d=[],b){const c=A._util.getServiceDependencies(w).sort((i,n)=>i.index-n.index),f=[];for(const i of c){const n=this.m(i.id,b);n||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(n)}const u=c.length>0?c[0].index:d.length;if(d.length!==u){console.trace(`[createInstance] First service dependency of ${w.name} at position ${u+1} conflicts with ${d.length} static arguments`);const i=u-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,u)}return Reflect.construct(w,d.concat(f))}k(w,d){if(this.f.get(w)instanceof S.SyncDescriptor)this.f.set(w,d);else if(this.h)this.h.k(w,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const d=this.f.get(w);return!d&&this.h?this.h.l(w):d}m(w,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const b=this.l(w);return b instanceof S.SyncDescriptor?this.q(w,b,d.branch(w,!0)):(d.branch(w,!1),b)}q(w,d,b){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,d,b)}finally{this.o.delete(w)}}r(w,d,b){const c=new D.Graph(i=>i.id.toString());let f=0;const u=[{id:w,desc:d,_trace:b}];for(;u.length;){const i=u.pop();if(c.lookupOrInsertNode(i),f++>1e3)throw new k(c);for(const n of A._util.getServiceDependencies(i.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${w} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),r instanceof S.SyncDescriptor){const o={id:n.id,desc:r,_trace:i._trace.branch(n.id,!0)};c.insertEdge(i,o),u.push(o)}}}for(;;){const i=c.roots();if(i.length===0){if(!c.isEmpty())throw new k(c);break}for(const{data:n}of i){if(this.l(n.id)instanceof S.SyncDescriptor){const o=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,o)}c.removeNode(n)}}return this.l(w)}s(w,d,b=[],c,f){if(this.f.get(w)instanceof S.SyncDescriptor)return this.t(w,d,b,c,f);if(this.h)return this.h.s(w,d,b,c,f);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(w,d,b=[],c,f){if(c){const u=new C(void 0,this.g,this,this.i);u.c=String(w);const i=new Map,n=new v.IdleValue(()=>{const r=u.j(d,b,f);for(const[o,a]of i){const l=r[o];if(typeof l=="function")for(const s of a)l.apply(r,s)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,o){if(!n.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let s=i.get(o);return s||(s=new E.LinkedList,i.set(o,s)),(T,F,Z)=>{const ne=s.push([T,F,Z]);return(0,P.toDisposable)(ne)}}if(o in r)return r[o];const a=n.value;let l=a[o];return typeof l!="function"||(l=l.bind(a),r[o]=l),l},set(r,o,a){return n.value[o]=a,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,b,f)}u(w,d){if(d&&console.warn(w),this.g)throw new Error(w)}}e.InstantiationService=C;var p;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(p||(p={}));class m{static traceInvocation(w,d){return w?new m(1,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(w,d){return w?new m(0,d.name):m.c}constructor(w,d){this.type=w,this.name=d,this.g=Date.now(),this.h=[]}branch(w,d){const b=new m(2,w.toString());return this.h.push([w,d,b]),b}stop(){const w=Date.now()-this.g;m.f+=w;let d=!1;function b(f,u){const i=[],n=new Array(f+1).join("	");for(const[r,o,a]of u.h)if(o&&a){d=!0,i.push(`${n}CREATES -> ${r}`);const l=b(f+1,a);l&&i.push(l)}else i.push(`${n}uses -> ${r}`);return i.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(w>2||d)&&m.all.add(c.join(`
`))}}e.Trace=m,m.all=new Set,m.c=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m.f=0}),define(be[206],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,v.createDecorator)("labelService")});var Oe=this&&this.__param||function(re,e){return function(v,t){e(v,t,re)}};define(be[78],ve([1,0,19,2,3,175,31,5]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function y(I){return I.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=y,e.ILanguagePackService=(0,A.createDecorator)("languagePackService");let E=class extends t.Disposable{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new v.CancellationTokenSource;setTimeout(()=>k.cancel(),1e3);let C;try{C=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const m=C.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(w=>w.startsWith("lp-"))).map(g=>{const w=g.properties.localizedLanguages?.[0],d=y(g);return{...this.f(d,w,g),extensionId:g.identifier.id,galleryExtension:g}});return m.push({...this.f("en","English"),extensionId:"default"}),m}f(k,C,p){const m=C??k;let g;if(m!==k&&(g=`(${k})`),k.toLowerCase()===P.language.toLowerCase()&&(g??="",g+=(0,S.localize)(0,null)),p?.installCount){g??="";const w=p.installCount;let d;w>1e6?d=`${Math.floor(w/1e5)/10}M`:w>1e3?d=`${Math.floor(w/1e3)}K`:d=String(w),g+=` $(cloud-download) ${d}`}return{id:k,label:m,description:g}}};E=Le([Oe(0,D.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(be[12],ve([1,0,39,6,2,26,3,4,5]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function E(){return new Date().toISOString()}var I;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(I=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=I.Info;function k(l,s,h){switch(s){case I.Trace:l.trace(h);break;case I.Debug:l.debug(h);break;case I.Info:l.info(h);break;case I.Warning:l.warn(h);break;case I.Error:l.error(h);break;case I.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=k;function C(l){let s="";for(let h=0;h<l.length;h++){let T=l[h];if(typeof T=="object")try{T=JSON.stringify(T)}catch{}s+=(h>0?" ":"")+T}return s}e.format=C;class p extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==I.Off&&this.b<=s}}e.AbstractLogger=p;class m extends p{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...h){this.f(I.Trace)&&this.g(I.Trace,C([s,...h]))}debug(s,...h){this.f(I.Debug)&&this.g(I.Debug,C([s,...h]))}info(s,...h){this.f(I.Info)&&this.g(I.Info,C([s,...h]))}warn(s,...h){this.f(I.Warning)&&this.g(I.Warning,C([s,...h]))}error(s,...h){if(this.f(I.Error))if(s instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=s.stack,this.g(I.Error,C(T))}else this.g(I.Error,C([s,...h]))}flush(){}}e.AbstractMessageLogger=m;class g extends p{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!D.isWindows}trace(s,...h){this.f(I.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,s,...h):console.log(`[main ${E()}]`,s,...h))}debug(s,...h){this.f(I.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,s,...h):console.log(`[main ${E()}]`,s,...h))}info(s,...h){this.f(I.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,s,...h):console.log(`[main ${E()}]`,s,...h))}warn(s,...h){this.f(I.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,s,...h):console.warn(`[main ${E()}]`,s,...h))}error(s,...h){this.f(I.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,s,...h):console.error(`[main ${E()}]`,s,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class w extends p{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...h){this.f(I.Trace)&&console.log("%cTRACE","color: #888",s,...h)}debug(s,...h){this.f(I.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...h)}info(s,...h){this.f(I.Info)&&console.log("%c INFO","color: #33f",s,...h)}warn(s,...h){this.f(I.Warning)&&console.log("%c WARN","color: #993",s,...h)}error(s,...h){this.f(I.Error)&&console.log("%c  ERR","color: #f33",s,...h)}dispose(){}flush(){}}e.ConsoleLogger=w;class d extends p{constructor(s,h=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(h)}trace(s,...h){this.f(I.Trace)&&this.g.log(I.Trace,[this.h(s),...h])}debug(s,...h){this.f(I.Debug)&&this.g.log(I.Debug,[this.h(s),...h])}info(s,...h){this.f(I.Info)&&this.g.log(I.Info,[this.h(s),...h])}warn(s,...h){this.f(I.Warning)&&this.g.log(I.Warning,[this.h(s),...h])}error(s,...h){this.f(I.Error)&&this.g.log(I.Error,[this.h(s),...h])}h(s){return typeof s=="string"?s:(0,v.toErrorMessage)(s,this.f(I.Trace))}dispose(){}flush(){}}e.AdapterLogger=d;class b extends p{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const h of this.g)h.setLevel(s);super.setLevel(s)}trace(s,...h){for(const T of this.g)T.trace(s,...h)}debug(s,...h){for(const T of this.g)T.debug(s,...h)}info(s,...h){for(const T of this.g)T.info(s,...h)}warn(s,...h){for(const T of this.g)T.warn(s,...h)}error(s,...h){for(const T of this.g)T.error(s,...h)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogService=b;class c extends P.Disposable{constructor(s){super(),this.b=s,this.B(s)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(s){this.b.setLevel(s)}getLevel(){return this.b.getLevel()}trace(s,...h){this.b.trace(s,...h)}debug(s,...h){this.b.debug(s,...h)}info(s,...h){this.b.info(s,...h)}warn(s,...h){this.b.warn(s,...h)}error(s,...h){this.b.error(s,...h)}flush(){this.b.flush()}}e.LogService=c;class f extends P.Disposable{constructor(s,h){super(),this.c=s,this.b=new S.ResourceMap,this.B(h(T=>this.setLevel(T)))}getLoggers(){return[...this.b.values()].map(({logger:s})=>s)}getLogger(s){return this.b.get(s)?.logger}createLogger(s,h,T){let F=this.b.get(s)?.logger;return F||(T=h?.always?I.Trace:T,F=this.f(s,T??this.c,h),this.b.set(s,{logger:F,logLevel:T})),F}setLevel(s,h){const T=A.URI.isUri(s)?s:void 0,F=T?h:s;if(T){const Z=this.b.get(T);Z&&Z.logLevel!==F&&(Z.logLevel=F,Z.logger.setLevel(F))}else this.c=F,this.b.forEach(({logLevel:Z,logger:ne})=>{Z===void 0&&ne.setLevel(this.c)})}getLogLevel(s){return this.b.get(s)?.logLevel}dispose(){this.b.forEach(({logger:s})=>s.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class u{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return I.Info}trace(s,...h){}debug(s,...h){}info(s,...h){}warn(s,...h){}error(s,...h){}critical(s,...h){}dispose(){}flush(){}}e.NullLogger=u;class i extends u{}e.NullLogService=i;class n extends f{constructor(){super(I.Info,t.Event.None)}f(s,h,T){return new u}}e.NullLoggerService=n;function r(l){if(l.verbose)return I.Trace;if(typeof l.logLevel=="string"){const s=a(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function o(l){switch(l){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Off:return"off"}}e.LogLevelToString=o;function a(l){switch(l){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Error;case"off":return I.Off}}e.parseLogLevel=a}),define(be[207],ve([1,0,74,6,2,12,3,14]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let y=class Ht extends P.Disposable{constructor(I){super(),this.g=I,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(I,k){this.g.trace("Getting password from keytar:",I,k);let C;try{C=await this.h()}catch{return null}const p=await(0,A.retry)(()=>C.getPassword(I,k),50,3);if(!p)return this.g.trace("Did not get a password from keytar for account:",k),p;let m,g;try{const w=JSON.parse(p);m=w.content,g=w.hasNextChunk}catch{}if(!m||!g)return this.g.trace("Got password from keytar for account:",k),p;try{let w=1;for(;g;){const d=await(0,A.retry)(()=>C.getPassword(I,`${k}-${w}`),50,3),b=JSON.parse(d);m+=b.content,g=b.hasNextChunk,w++}return this.g.trace(`Got ${w}-chunked password from keytar for account:`,k),m}catch(w){return this.g.error(w),p}}async setPassword(I,k,C){this.g.trace("Setting password using keytar:",I,k);let p;try{p=await this.h()}catch(m){throw this.i?.(m),m}if(D.isWindows&&C.length>Ht.a){let m=0,g=0,w=!0;for(;w;){const d=C.substring(m,m+Ht.b);m+=Ht.b,w=C.length-m>0;const b={content:d,hasNextChunk:w};await(0,A.retry)(()=>p.setPassword(I,g?`${k}-${g}`:k,JSON.stringify(b)),50,3),g++}this.g.trace(`Got${g?` ${g}-chunked`:""} password from keytar for account:`,k)}else await(0,A.retry)(()=>p.setPassword(I,k,C),50,3),this.g.trace("Got password from keytar for account:",k);this.c.fire({service:I,account:k})}async deletePassword(I,k){this.g.trace("Deleting password using keytar:",I,k);let C;try{C=await this.h()}catch(d){throw this.i?.(d),d}const p=await C.getPassword(I,k);if(!p)return this.g.trace("Did not get a password to delete from keytar for account:",k),!1;let m,g;try{const d=JSON.parse(p);m=d.content,g=d.hasNextChunk}catch{}let w=0;if(m&&g)try{for(w++;g;){const d=`${k}-${w}`,b=await C.getPassword(I,d);await C.deletePassword(I,d),g=JSON.parse(b).hasNextChunk,w++}}catch(d){this.g.error(d)}return await C.deletePassword(I,k)?(this.c.fire({service:I,account:k}),this.g.trace(`Deleted${w?` ${w}-chunked`:""} password from keytar for account:`,k),!0):(this.g.trace(`Keytar failed to delete${w?` ${w}-chunked`:""} password for account:`,k),!1)}async findPassword(I){let k;try{k=await this.h()}catch{return null}return await k.findPassword(I)}async findCredentials(I){let k;try{k=await this.h()}catch{return[]}return await k.findCredentials(I)}clear(){return this.f instanceof v.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};y.a=2500,y.b=y.a-100,y=Le([Oe(0,S.ILogService)],y),e.BaseCredentialsMainService=y}),define(be[208],ve([1,0,12]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(S,D){this.a=S,this.b=D}c(){return new Promise((S,D)=>re(["vscode-encrypt"],S,D))}async encrypt(S){let D;try{D=await this.c()}catch{return S}try{return D.encrypt(this.a,S)}catch(A){return this.b.error(A),S}}async decrypt(S){let D;try{D=await this.c()}catch{return S}try{return D.decrypt(this.a,S)}catch(A){return this.b.error(A),S}}};t=Le([Oe(1,v.ILogService)],t),e.EncryptionMainService=t}),define(be[209],ve([1,0,18,14,8,6,2,7,62,12]),function(re,e,v,t,P,S,D,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(C,p){super(),this.a=C,this.b=p,this.c=this.B(new S.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new S.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(C,p){return p.recursive||this.b?.watcher?.forceUniversal?this.l(C,p):this.u(C,p)}l(C,p){const m={path:this.C(C),excludes:p.excludes,includes:p.includes,recursive:p.recursive},g=(0,v.insert)(this.j,m);return this.m(),(0,D.toDisposable)(()=>{g(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(C=>(0,P.onUnexpectedError)(C))}n(){this.h||(this.h=this.B(this.p(p=>this.c.fire((0,y.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const C=this.b?.watcher?.recursive?.usePolling;if(C===!0)for(const p of this.j)(0,y.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const p of this.j)(0,y.isRecursiveWatchRequest)(p)&&C.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(C,p){const m={path:this.C(C),excludes:p.excludes,includes:p.includes,recursive:!1},g=(0,v.insert)(this.s,m);return this.v(),(0,D.toDisposable)(()=>{g(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(C=>(0,P.onUnexpectedError)(C))}w(){return this.r||(this.r=this.B(this.y(C=>this.c.fire((0,y.toFileChanges)(C)),C=>this.z(C),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.r.watch(this.s)}z(C){C.type==="error"&&this.g.fire(C.message),this.a[C.type](C.message)}C(C){return(0,A.normalize)(C.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(be[104],ve([1,0,18,14,16,19,6,89,55,2,58,13,46,20,44,171,17,102,12]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends E.Disposable{constructor(u){super(),this.b=u,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new D.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new D.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new t.ResourceQueue)}registerProvider(u,i){if(this.h.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${u}`);const n=new E.DisposableStore;return this.h.set(u,i),this.c.fire({added:!0,scheme:u,provider:i}),n.add(i.onDidChangeFile(r=>this.Q.fire(new w.FileChangesEvent(r,!this.N(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(r=>this.R.fire(new Error(r)))),n.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:u}))),(0,E.toDisposable)(()=>{this.c.fire({added:!1,scheme:u,provider:i}),this.h.delete(u),(0,E.dispose)(n)})}getProvider(u){return this.h.get(u)}async activateProvider(u){const i=[];this.f.fire({scheme:u,join(n){i.push(n)}}),!this.h.has(u)&&await t.Promises.settled(i)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.h.has(u.scheme)}hasCapability(u,i){const n=this.h.get(u.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return y.Iterable.map(this.h,([u,i])=>({scheme:u,capabilities:i.capabilities}))}async j(u){if(!(0,p.isAbsolutePath)(u))throw new w.FileOperationError((0,g.localize)(0,null,this.mb(u)),8);await this.activateProvider(u.scheme);const i=this.h.get(u.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,g.localize)(1,null,u.toString()),n}return i}async k(u){const i=await this.j(u);if((0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)||(0,w.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(u){const i=await this.j(u);if((0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,i){try{return await this.n(u,i)}catch(n){throw(0,w.toFileSystemProviderErrorCode)(n)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,g.localize)(2,null,this.mb(u)),1):(0,w.ensureFileSystemProviderError)(n)}}async n(u,i){const n=await this.j(u),r=this.N(n),o=i?.resolveTo,a=i?.resolveSingleChildDescendants,l=i?.resolveMetadata,s=await n.stat(u);let h;return this.p(n,u,s,void 0,!!l,(T,F)=>(h||(h=I.TernarySearchTree.forUris(()=>!r),h.set(u,!0),o&&h.fill(!0,o)),h.get(T.resource)||h.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&a?F===1:!1))}async p(u,i,n,r,o,a){const{providerExtUri:l}=this.M(u),s={resource:i,name:l.basename(i),isFile:(n.type&w.FileType.File)!==0,isDirectory:(n.type&w.FileType.Directory)!==0,isSymbolicLink:(n.type&w.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&w.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,w.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(s.isDirectory&&a(s,r)){try{const h=await u.readdir(i),T=await t.Promises.settled(h.map(async([F,Z])=>{try{const ne=l.joinPath(i,F),ce=o?await u.stat(ne):{type:Z};return await this.p(u,ne,ce,h.length,o,a)}catch(ne){return this.b.trace(ne),null}}));s.children=(0,v.coalesce)(T)}catch(h){this.b.trace(h),s.children=[]}return s}return s}async resolveAll(u){return t.Promises.settled(u.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(u){const i=await this.j(u),n=await i.stat(u);return this.p(i,u,n,void 0,!0,()=>!1)}async exists(u){const i=await this.j(u);try{return!!await i.stat(u)}catch{return!1}}async canCreateFile(u,i){try{await this.r(u,i)}catch(n){return n}return!0}async r(u,i){if(!i?.overwrite&&await this.exists(u))throw new w.FileOperationError((0,g.localize)(3,null,this.mb(u)),3,i)}async createFile(u,i=P.VSBuffer.fromString(""),n){await this.r(u,n);const r=await this.writeFile(u,i);return this.m.fire(new w.FileOperationEvent(u,0,r)),r}async writeFile(u,i,n){const r=this.kb(await this.l(u),u),{providerExtUri:o}=this.M(r);try{await this.s(r,u,n)||await this.O(r,o.dirname(u));let l;if((0,w.hasReadWriteCapability)(r)&&!(i instanceof P.VSBuffer))if((0,m.isReadableStream)(i)){const s=await(0,m.peekStream)(i,3);s.ended?l=P.VSBuffer.concat(s.buffer):l=s}else l=(0,m.peekReadable)(i,s=>P.VSBuffer.concat(s),3);else l=i;!(0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)&&l instanceof P.VSBuffer?await this.bb(r,u,n,l):await this.X(r,u,n,l instanceof P.VSBuffer?(0,P.bufferToReadable)(l):l),this.m.fire(new w.FileOperationEvent(u,4))}catch(a){throw new w.FileOperationError((0,g.localize)(4,null,this.mb(u),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),n)}return this.resolve(u,{resolveMetadata:!0})}async s(u,i,n){if(!!n?.unlock&&!(u.capabilities&8192))throw new Error((0,g.localize)(5,null,this.mb(i)));let o;try{o=await u.stat(i)}catch{return}if((o.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,g.localize)(6,null,this.mb(i)),0,n);if(this.lb(i,o),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==w.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&n.mtime<o.mtime&&n.etag!==(0,w.etag)({mtime:n.mtime,size:o.size}))throw new w.FileOperationError((0,g.localize)(7,null),3,n);return o}async readFile(u,i,n){const r=await this.k(u);return i?.atomic?this.t(r,u,i,n):this.u(r,u,i,n)}async t(u,i,n,r){return new Promise((o,a)=>{this.W.queueFor(i,this.M(u).providerExtUri).queue(async()=>{try{const l=await this.u(u,i,n,r);o(l)}catch(l){a(l)}})})}async u(u,i,n,r){const o=await this.v(u,i,{...n,preferUnbuffered:!0},r);return{...o,value:await(0,P.streamToBuffer)(o.value)}}async readFileStream(u,i,n){const r=await this.k(u);return this.v(r,u,i,n)}async v(u,i,n,r){const o=new S.CancellationTokenSource(r),a=this.D(i,n).then(s=>s,s=>{throw o.cancel(),s});let l;try{return typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&await a,n?.atomic&&(0,w.hasFileAtomicReadCapability)(u)||!((0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasFileReadStreamCapability)(u))||(0,w.hasReadWriteCapability)(u)&&n?.preferUnbuffered?l=this.C(u,i,n):(0,w.hasFileReadStreamCapability)(u)?l=this.w(u,i,o.token,n):l=this.z(u,i,o.token,n),{...await a,value:l}}catch(s){l&&await(0,m.consumeStream)(l);const h=(0,g.localize)(8,null,this.mb(i),(0,w.ensureFileSystemProviderError)(s).toString());throw s instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(h,s.stat,n):new w.FileOperationError(h,(0,w.toFileOperationResult)(s),n)}}w(u,i,n,r=Object.create(null)){const o=u.readFileStream(i,r,n);return(0,m.transform)(o,{data:a=>a instanceof P.VSBuffer?a:P.VSBuffer.wrap(a),error:a=>new w.FileOperationError((0,g.localize)(9,null,this.mb(i),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),r)},a=>P.VSBuffer.concat(a))}z(u,i,n,r=Object.create(null)){const o=(0,P.newWriteableBufferStream)();return(0,d.readFileIntoStream)(u,i,o,a=>a,{...r,bufferSize:this.a,errorTransformer:a=>new w.FileOperationError((0,g.localize)(10,null,this.mb(i),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),r)},n),o}C(u,i,n){const r=(0,m.newWriteableStream)(o=>P.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,w.hasFileAtomicReadCapability)(u)?o=await u.readFile(i,{atomic:!0}):o=await u.readFile(i),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.F(i,o.byteLength,n),r.end(P.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async D(u,i){const n=await this.resolve(u,{resolveMetadata:!0});if(n.isDirectory)throw new w.FileOperationError((0,g.localize)(11,null,this.mb(u)),0,i);if(typeof i?.etag=="string"&&i.etag!==w.ETAG_DISABLED&&i.etag===n.etag)throw new w.NotModifiedSinceFileOperationError((0,g.localize)(12,null),n,i);return this.F(u,n.size,i),n}F(u,i,n){if(n?.limits){let r;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(r=9),typeof n.limits.size=="number"&&i>n.limits.size&&(r=7),typeof r=="number")throw new w.FileOperationError((0,g.localize)(13,null,this.mb(u)),r)}}async canMove(u,i,n){return this.G(u,i,"move",n)}async canCopy(u,i,n){return this.G(u,i,"copy",n)}async G(u,i,n,r){if(u.toString()!==i.toString())try{const o=n==="move"?this.kb(await this.l(u),u):await this.k(u),a=this.kb(await this.l(i),i);await this.L(o,u,a,i,n,r)}catch(o){return o}return!0}async move(u,i,n){const r=this.kb(await this.l(u),u),o=this.kb(await this.l(i),i),a=await this.H(r,u,o,i,"move",!!n),l=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(u,a==="move"?2:3,l)),l}async copy(u,i,n){const r=await this.k(u),o=this.kb(await this.l(i),i),a=await this.H(r,u,o,i,"copy",!!n),l=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(u,a==="copy"?3:2,l)),l}async H(u,i,n,r,o,a){if(i.toString()===r.toString())return o;const{exists:l,isSameResourceWithDifferentPathCase:s}=await this.L(u,i,n,r,o,a);if(l&&!s&&a&&await this.del(r,{recursive:!0}),await this.O(n,this.M(n).providerExtUri.dirname(r)),o==="copy"){if(u===n&&(0,w.hasFileFolderCopyCapability)(u))await u.copy(i,r,{overwrite:a});else{const h=await this.resolve(i);h.isDirectory?await this.J(u,h,n,r):await this.I(u,i,n,r)}return o}else return u===n?(await u.rename(i,r,{overwrite:a}),o):(await this.H(u,i,n,r,"copy",a),await this.del(i,{recursive:!0}),"copy")}async I(u,i,n,r){if((0,w.hasOpenReadWriteCloseCapability)(u)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.db(u,i,n,r);if((0,w.hasOpenReadWriteCloseCapability)(u)&&(0,w.hasReadWriteCapability)(n))return this.jb(u,i,n,r);if((0,w.hasReadWriteCapability)(u)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.hb(u,i,n,r);if((0,w.hasReadWriteCapability)(u)&&(0,w.hasReadWriteCapability)(n))return this.fb(u,i,n,r)}async J(u,i,n,r){await n.mkdir(r),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async o=>{const a=this.M(n).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.J(u,await this.resolve(o.resource),n,a):this.I(u,o.resource,n,a)}))}async L(u,i,n,r,o,a){let l=!1;if(u===n){const{providerExtUri:h,isPathCaseSensitive:T}=this.M(u);if(T||(l=h.isEqual(i,r)),l&&o==="copy")throw new Error((0,g.localize)(14,null,this.mb(i),this.mb(r)));if(!l&&h.isEqualOrParent(r,i))throw new Error((0,g.localize)(15,null,this.mb(i),this.mb(r)))}const s=await this.exists(r);if(s&&!l){if(!a)throw new w.FileOperationError((0,g.localize)(16,null,this.mb(i),this.mb(r)),4);if(u===n){const{providerExtUri:h}=this.M(u);if(h.isEqualOrParent(i,r))throw new Error((0,g.localize)(17,null,this.mb(i),this.mb(r)))}}return{exists:s,isSameResourceWithDifferentPathCase:l}}M(u){const i=this.N(u);return{providerExtUri:i?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:i}}N(u){return!!(u.capabilities&1024)}async createFolder(u){const i=this.kb(await this.j(u),u);await this.O(i,u);const n=await this.resolve(u,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(u,0,n)),n}async O(u,i){const n=[],{providerExtUri:r}=this.M(u);for(;!r.isEqual(i,r.dirname(i));)try{if(((await u.stat(i)).type&w.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.mb(i)));break}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(r.basename(i)),i=r.dirname(i)}for(let o=n.length-1;o>=0;o--){i=r.joinPath(i,n[o]);try{await u.mkdir(i)}catch(a){if((0,w.toFileSystemProviderErrorCode)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(u,i){try{await this.P(u,i)}catch(n){return n}return!0}async P(u,i){const n=this.kb(await this.j(u),u);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,g.localize)(19,null,this.mb(u)));let o;try{o=await n.stat(u)}catch{}if(o)this.lb(u,o);else throw new w.FileOperationError((0,g.localize)(20,null,this.mb(u)),1);if(!!!i?.recursive){const l=await this.resolve(u);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,g.localize)(21,null,this.mb(u)))}return n}async del(u,i){const n=await this.P(u,i),r=!!i?.useTrash,o=!!i?.recursive;await n.delete(u,{recursive:o,useTrash:r}),this.m.fire(new w.FileOperationEvent(u,1))}async cloneFile(u,i){const n=await this.j(u),r=this.kb(await this.l(i),i);if(n===r&&this.M(n).providerExtUri.isEqual(u,i))return;if(n===r&&(0,w.hasFileCloneCapability)(n))return n.cloneFile(u,i);await this.O(r,this.M(r).providerExtUri.dirname(i));const o=this.W.queueFor(u,this.M(n).providerExtUri);return n===r&&(0,w.hasFileFolderCopyCapability)(n)?o.queue(()=>n.copy(u,i,{overwrite:!0})):o.queue(()=>this.I(n,u,r,i))}watch(u,i={recursive:!1,excludes:[]}){const n=new E.DisposableStore;let r=!1,o=()=>{r=!0};return n.add((0,E.toDisposable)(()=>o())),(async()=>{try{const a=await this.U(u,i);r?(0,E.dispose)(a):o=()=>(0,E.dispose)(a)}catch(a){this.b.error(a)}})(),n}async U(u,i){const n=await this.j(u),r=(0,A.hash)([this.M(n).providerExtUri.getComparisonKey(u),i]);let o=this.S.get(r);return o||(o={count:0,disposable:n.watch(u,i)},this.S.set(r,o)),o.count+=1,(0,E.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,E.dispose)(o.disposable),this.S.delete(r)))})}dispose(){super.dispose();for(const[,u]of this.S)(0,E.dispose)(u.disposable);this.S.clear()}async X(u,i,n,r){return this.W.queueFor(i,this.M(u).providerExtUri).queue(async()=>{const o=await u.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.Y(u,o,r):await this.Z(u,o,r)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await u.close(o)}})}async Y(u,i,n){let r=0,o;if((0,m.isReadableBufferedStream)(n)){if(n.buffer.length>0){const a=P.VSBuffer.concat(n.buffer);await this.ab(u,i,a,a.byteLength,r,0),r+=a.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((a,l)=>{(0,m.listenStream)(o,{onData:async s=>{o.pause();try{await this.ab(u,i,s,s.byteLength,r,0)}catch(h){return l(h)}r+=s.byteLength,setTimeout(()=>o.resume())},onError:s=>l(s),onEnd:()=>a()})})}async Z(u,i,n){let r=0,o;for(;(o=n.read())!==null;)await this.ab(u,i,o,o.byteLength,r,0),r+=o.byteLength}async ab(u,i,n,r,o,a){let l=0;for(;l<r;)l+=await u.write(i,o+l,n.buffer,a+l,r-l)}async bb(u,i,n,r){return this.W.queueFor(i,this.M(u).providerExtUri).queue(()=>this.cb(u,i,n,r))}async cb(u,i,n,r){let o;r instanceof P.VSBuffer?o=r:(0,m.isReadableStream)(r)?o=await(0,P.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?o=await(0,P.bufferedStreamToBuffer)(r):o=(0,P.readableToBuffer)(r),await u.writeFile(i,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async db(u,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.eb(u,i,n,r))}async eb(u,i,n,r){let o,a;try{o=await u.open(i,{create:!1}),a=await n.open(r,{create:!0,unlock:!1});const l=P.VSBuffer.alloc(this.a);let s=0,h=0,T=0;do T=await u.read(o,s,l.buffer,h,l.byteLength-h),await this.ab(n,a,l,T,s,h),s+=T,h+=T,h===l.byteLength&&(h=0);while(T>0)}catch(l){throw(0,w.ensureFileSystemProviderError)(l)}finally{await t.Promises.settled([typeof o=="number"?u.close(o):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async fb(u,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.gb(u,i,n,r))}async gb(u,i,n,r){return n.writeFile(r,await u.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async hb(u,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.ib(u,i,n,r))}async ib(u,i,n,r){const o=await n.open(r,{create:!0,unlock:!1});try{const a=await u.readFile(i);await this.ab(n,o,P.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await n.close(o)}}async jb(u,i,n,r){const o=await(0,P.streamToBuffer)(this.z(u,i,S.CancellationToken.None));await this.bb(n,r,void 0,o)}kb(u,i){if(u.capabilities&2048)throw new w.FileOperationError((0,g.localize)(22,null,this.mb(i)),6);return u}lb(u,i){if((i.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,g.localize)(23,null,this.mb(u)),6)}mb(u){return u.scheme===k.Schemas.file?u.fsPath:u.toString(!0)}};c=Le([Oe(0,b.ILogService)],c),e.FileService=c}),define(be[63],ve([1,0,29,276,14,26,16,6,37,2,7,3,20,44,22,174,17,102,209,39,205,204]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(n){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(n)}`)}})();class i extends b.AbstractDiskFileSystemProvider{constructor(r,o){super(r,o),this.onDidChangeCapabilities=A.Event.None,this.H=new S.ResourceMap(a=>C.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,k.isLinux&&(this.F|=1024)),this.F}async stat(r){try{const{stat:o,symbolicLink:a}=await m.SymlinkSupport.stat(this.C(r));return{type:this.G(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.Y(o)}}async readdir(r){try{const o=await m.Promises.readdir(this.C(r),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async l=>{try{let s;l.isSymbolicLink()?s=(await this.stat((0,C.joinPath)(r,l.name))).type:s=this.G(l),a.push([l.name,s])}catch(s){this.a.trace(s)}})),a}catch(o){throw this.Y(o)}}G(r,o){let a;return o?.dangling?a=w.FileType.Unknown:r.isFile()?a=w.FileType.File:r.isDirectory()?a=w.FileType.Directory:a=w.FileType.Unknown,o&&(a|=w.FileType.SymbolicLink),a}async I(r){const o=this.C(r);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let a;for(;a=this.H.get(r);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await a.wait();const l=new P.Barrier;return this.H.set(r,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,E.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.H.get(r)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.H.delete(r)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),l.open()})}async readFile(r,o){let a;try{o?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),a=await this.I(r));const l=this.C(r);return await m.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{a?.dispose()}}J(r){i.D&&this.a.trace(r)}readFileStream(r,o,a){const l=(0,p.newWriteableStream)(s=>D.VSBuffer.concat(s.map(h=>D.VSBuffer.wrap(h))).buffer);return(0,d.readFileIntoStream)(this,r,l,s=>s.buffer,{...o,bufferSize:256*1024},a),l}async writeFile(r,o,a){let l;try{const s=this.C(r);if(!a.create||!a.overwrite){if(await m.Promises.exists(s)){if(!a.overwrite)throw(0,w.createFileSystemProviderError)((0,g.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,w.createFileSystemProviderError)((0,g.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(r,{create:!0,unlock:a.unlock}),await this.write(l,0,o,0,o.byteLength)}catch(s){throw await this.Z(r,s)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(r){i.O=r}async open(r,o){const a=this.C(r);let l;(0,w.isFileOpenForWriteOptions)(o)&&(l=await this.I(r));let s;try{if((0,w.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:T}=await m.SymlinkSupport.stat(a);T.mode&128||await m.Promises.chmod(a,T.mode|128)}catch(T){this.a.trace(T)}let h;if((0,w.isFileOpenForWriteOptions)(o)){if(k.isWindows)try{await m.Promises.truncate(a,0),h="r+"}catch(T){T.code!=="ENOENT"&&this.a.trace(T)}h||(h="w")}else h="r";s=await m.Promises.open(a,h)}catch(h){throw l?.dispose(),(0,w.isFileOpenForWriteOptions)(o)?await this.Z(r,h):this.Y(h)}if(this.L.set(s,0),(0,w.isFileOpenForWriteOptions)(o)&&this.N.set(s,r),l){const h=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${a})`),this.M.set(s,l),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${a})`),h.dispose())}return s}async close(r){const o=this.M.get(r);try{if(this.L.delete(r),this.N.delete(r)&&i.O)try{await m.Promises.fdatasync(r)}catch(a){i.configureFlushOnWrite(!1),this.a.error(a)}return await m.Promises.close(r)}catch(a){throw this.Y(a)}finally{o&&(this.M.get(r)===o&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.M.delete(r)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),o.dispose())}}async read(r,o,a,l,s){const h=this.P(r,o);let T=null;try{T=(await m.Promises.read(r,a,l,s,h)).bytesRead}catch(F){throw this.Y(F)}finally{this.Q(r,h,T)}return T}P(r,o){return o===this.L.get(r)?null:o}Q(r,o,a){const l=this.L.get(r);typeof l=="number"&&(typeof o=="number"||(typeof a=="number"?this.L.set(r,l+a):this.L.delete(r)))}async write(r,o,a,l,s){return(0,P.retry)(()=>this.R(r,o,a,l,s),100,3)}async R(r,o,a,l,s){const h=this.P(r,o);let T=null;try{T=(await m.Promises.write(r,a,l,s,h)).bytesWritten}catch(F){throw await this.Z(this.N.get(r),F)}finally{this.Q(r,h,T)}return T}async mkdir(r){try{await m.Promises.mkdir(this.C(r))}catch(o){throw this.Y(o)}}async delete(r,o){try{const a=this.C(r);o.recursive?await m.Promises.rm(a,m.RimRafMode.MOVE):await m.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(r,o,a){const l=this.C(r),s=this.C(o);if(l!==s)try{await this.S(r,o,"move",a.overwrite),await m.Promises.move(l,s)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(2,null,(0,I.basename)(l),(0,I.basename)((0,I.dirname)(s)),h.toString()))),this.Y(h)}}async copy(r,o,a){const l=this.C(r),s=this.C(o);if(l!==s)try{await this.S(r,o,"copy",a.overwrite),await m.Promises.copy(l,s,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(3,null,(0,I.basename)(l),(0,I.basename)((0,I.dirname)(s)),h.toString()))),this.Y(h)}}async S(r,o,a,l){const s=this.C(r),h=this.C(o);let T=!1;if(!!(this.capabilities&1024)||(T=(0,y.isEqual)(s,h,!0)),T&&a==="copy")throw(0,w.createFileSystemProviderError)((0,g.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!T&&await m.Promises.exists(h)){if(!l)throw(0,w.createFileSystemProviderError)((0,g.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(r,o){return this.U(r,o,!1)}async U(r,o,a){const l=this.C(r),s=this.C(o),h=!!(this.capabilities&1024);if((0,y.isEqual)(l,s,!h))return;const T=new E.DisposableStore;try{const[F,Z]=await Promise.all([this.I(r),this.I(o)]);T.add(F),T.add(Z),a&&await m.Promises.mkdir((0,I.dirname)(s),{recursive:!0}),await m.Promises.copyFile(l,s)}catch(F){if(F.code==="ENOENT"&&!a)return this.U(r,o,!0);throw this.Y(F)}finally{T.dispose()}}p(r,o,a){return new f.UniversalWatcherClient(l=>r(l),l=>o(l),a)}y(r,o,a){return new u.NodeJSWatcherClient(l=>r(l),l=>o(l),a)}Y(r){if(r instanceof w.FileSystemProviderError)return r;let o;switch(r.code){case"ENOENT":o=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=w.FileSystemProviderErrorCode.NoPermissions;break;default:o=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(r,o)}async Z(r,o){let a=this.Y(o);if(r&&a.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await m.SymlinkSupport.stat(this.C(r));l.mode&128||(a=(0,w.createFileSystemProviderError)(o,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(be[210],ve([1,0,6,63,2,16,44,19]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class y extends P.Disposable{constructor(k,C){super(),this.a=k,this.b=C,this.w=new Map,this.y=new Map}call(k,C,p){const m=this.c(k);switch(C){case"stat":return this.g(m,p[0]);case"readdir":return this.h(m,p[0]);case"open":return this.l(m,p[0],p[1]);case"close":return this.m(p[0]);case"read":return this.n(p[0],p[1],p[2]);case"readFile":return this.i(m,p[0],p[1]);case"write":return this.p(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.k(m,p[0],p[1],p[2]);case"rename":return this.t(m,p[0],p[1],p[2]);case"copy":return this.u(m,p[0],p[1],p[2]);case"cloneFile":return this.v(m,p[0],p[1]);case"mkdir":return this.r(m,p[0]);case"delete":return this.s(m,p[0],p[1]);case"watch":return this.C(m,p[0],p[1],p[2],p[3]);case"unwatch":return this.D(p[0],p[1])}throw new Error(`IPC Command ${C} not found`)}listen(k,C,p){const m=this.c(k);switch(C){case"fileChange":return this.z(m,p[0]);case"readFileStream":return this.j(m,p[0],p[1])}throw new Error(`Unknown event ${C}`)}g(k,C){const p=this.f(k,C,!0);return this.a.stat(p)}h(k,C){const p=this.f(k,C);return this.a.readdir(p)}async i(k,C,p){const m=this.f(k,C,!0),g=await this.a.readFile(m,p);return S.VSBuffer.wrap(g)}j(k,C,p){const m=this.f(k,C,!0),g=new A.CancellationTokenSource,w=new v.Emitter({onDidRemoveLastListener:()=>{g.cancel()}}),d=this.a.readFileStream(m,p,g.token);return(0,D.listenStream)(d,{onData:b=>w.fire(S.VSBuffer.wrap(b)),onError:b=>w.fire(b),onEnd:()=>{w.fire("end"),w.dispose(),g.dispose()}}),w.event}k(k,C,p,m){const g=this.f(k,C);return this.a.writeFile(g,p.buffer,m)}l(k,C,p){const m=this.f(k,C,!0);return this.a.open(m,p)}m(k){return this.a.close(k)}async n(k,C,p){const m=S.VSBuffer.alloc(p),g=0,w=await this.a.read(k,C,m.buffer,g,p);return[m,w]}p(k,C,p,m,g){return this.a.write(k,C,p.buffer,m,g)}r(k,C){const p=this.f(k,C);return this.a.mkdir(p)}s(k,C,p){const m=this.f(k,C);return this.a.delete(m,p)}t(k,C,p,m){const g=this.f(k,C),w=this.f(k,p);return this.a.rename(g,w,m)}u(k,C,p,m){const g=this.f(k,C),w=this.f(k,p);return this.a.copy(g,w,m)}v(k,C,p){const m=this.f(k,C),g=this.f(k,p);return this.a.cloneFile(m,g)}z(k,C){const p=new v.Emitter({onWillAddFirstListener:()=>{this.w.set(C,this.F(k,p))},onDidRemoveLastListener:()=>{(0,P.dispose)(this.w.get(C)),this.w.delete(C)}});return p.event}async C(k,C,p,m,g){const w=this.w.get(C);if(w){const d=this.f(k,m),b=w.watch(p,d,g);this.y.set(C+p,b)}}async D(k,C){const p=k+C,m=this.y.get(p);m&&((0,P.dispose)(m),this.y.delete(p))}dispose(){super.dispose();for(const[,k]of this.y)k.dispose();this.y.clear();for(const[,k]of this.w)k.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=y;class E extends P.Disposable{constructor(k,C,p,m){super(),this.c=k,this.f=p,this.g=m,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(C)}h(k){const C=this.B(new v.Emitter);this.B(C.event(p=>{k.fire(p.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type})))})),this.B(this.b.onDidChangeFile(p=>C.fire(p))),this.B(this.b.onDidWatchError(p=>k.fire(p)))}i(k){}j(k){}watch(k,C,p){const m=this.j(this.g);return Array.isArray(m)&&(p.excludes=[...p.excludes,...m]),this.a.set(k,this.b.watch(C,p)),(0,P.toDisposable)(()=>{(0,P.dispose)(this.a.get(k)),this.a.delete(k)})}dispose(){super.dispose();for(const[,k]of this.a)k.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=E}),define(be[211],ve([1,0,12]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends v.AbstractMessageLogger{constructor(S=v.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(S),this.B(this.onDidChangeLogLevel(D=>{this.l?.setLevel(D)}))}set logger(S){this.l=S;for(const{level:D,message:A}of this.k)(0,v.log)(S,D,A);this.k=[]}g(S,D){this.l?(0,v.log)(this.l,S,D):this.getLevel()<=S&&this.k.push({level:S,message:D})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(be[105],ve([1,0,6,4,12]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(C,p){this.a=C,this.b=p,this.onDidChangeLogLevel=v.Event.buffer(C.onDidChangeLogLevel,!0)}listen(C,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(C,p,m){switch(p){case"setLevel":return m[1]?this.b.setLevel(t.URI.revive(m[1]),m[0]):this.a.setLevel(m[0])}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=S;class D{constructor(C){this.a=C}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(C,p){D.setLevel(this.a,C,p)}static setLevel(C,p,m){return C.call("setLevel",[p,m])}}e.LogLevelChannelClient=D;class A{constructor(C){this.b=C,this.a=new Map}listen(C,p){throw new Error(`Event not found: ${p}`)}async call(C,p,m){switch(p){case"createLogger":this.c(t.URI.revive(m[0]),m[1]);return;case"log":return this.e(t.URI.revive(m[0]),m[1]);case"consoleLog":return this.d(m[0],m[1])}throw new Error(`Call not found: ${p}`)}c(C,p){this.a.set(C.toString(),this.b.createLogger(C,p))}d(C,p){let m=console.log;switch(C){case P.LogLevel.Error:m=console.error;break;case P.LogLevel.Warning:m=console.warn;break;case P.LogLevel.Info:m=console.info;break}m.call(console,...p)}e(C,p){const m=this.a.get(C.toString());if(!m)throw new Error("Create the logger before logging");for(const[g,w]of p)(0,P.log)(m,g,w)}}e.LoggerChannel=A;class y extends P.AbstractLoggerService{constructor(C,p,m){super(C,p),this.g=m}createConsoleMainLogger(){return new P.AdapterLogger({log:(C,p)=>{this.g.call("consoleLog",[C,p])}})}f(C,p,m){return new E(this.g,C,p,m)}}e.LoggerChannelClient=y;class E extends P.AbstractMessageLogger{constructor(C,p,m,g){super(g?.always),this.m=C,this.n=p,this.k=!1,this.l=[],this.setLevel(m),this.m.call("createLogger",[p,g]).then(()=>{this.r(this.l),this.k=!0})}g(C,p){const m=[[C,p]];this.k?this.r(m):this.l.push(...m)}r(C){this.m.call("log",[this.n,C])}}class I extends P.LogService{constructor(C,p){super(p),this.c=C,this.B(C.onDidChangeLogLevel(m=>p.setLevel(m)))}setLevel(C){super.setLevel(C),this.c.setLevel(C)}}e.FollowerLogService=I}),define(be[106],ve([1,0,17,12]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(P||(P={}));async function S(E,I,k,C,p){try{const m=await new Promise((w,d)=>{re(["spdlog"],w,d)});m.setFlushOn(P.Trace);const g=await m.createAsyncRotatingLogger(E,I,k,C);return p?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(m){console.error(m)}return null}function D(E,I,k){switch(I){case t.LogLevel.Trace:E.trace(k);break;case t.LogLevel.Debug:E.debug(k);break;case t.LogLevel.Info:E.info(k);break;case t.LogLevel.Warning:E.warn(k);break;case t.LogLevel.Error:E.error(k);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function A(E,I){switch(I){case t.LogLevel.Trace:E.setLevel(P.Trace);break;case t.LogLevel.Debug:E.setLevel(P.Debug);break;case t.LogLevel.Info:E.setLevel(P.Info);break;case t.LogLevel.Warning:E.setLevel(P.Warning);break;case t.LogLevel.Error:E.setLevel(P.Error);break;case t.LogLevel.Off:E.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class y extends t.AbstractMessageLogger{constructor(I,k,C,p,m){super(),this.k=[],this.setLevel(m),this.l=this.n(I,k,C,p),this.B(this.onDidChangeLogLevel(g=>{this.m&&A(this.m,g)}))}async n(I,k,C,p){const m=C?6:1,g=30/m*v.ByteSize.MB,w=await S(I,k,g,m,p);if(w){this.m=w,A(this.m,this.getLevel());for(const{level:d,message:b}of this.k)D(this.m,d,b);this.k=[]}}g(I,k){this.m?D(this.m,I,k):this.getLevel()<=I&&this.k.push({level:I,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(be[212],ve([1,0,21,12,106]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let S=class extends t.AbstractLoggerService{constructor(A){super(A.getLevel(),A.onDidChangeLogLevel)}f(A,y,E){return new P.SpdLogLogger(E?.name||(0,v.generateUuid)(),A.fsPath,!E?.donotRotate,!!E?.donotUseFormatters,y)}};S=Le([Oe(0,t.ILogService)],S),e.LoggerService=S}),define(be[213],ve([1,0,70,176,5]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function E(m,g){return g-m}y.compare=E;const I=Object.create(null);I[y.Error]=(0,t.localize)(0,null),I[y.Warning]=(0,t.localize)(1,null),I[y.Info]=(0,t.localize)(2,null);function k(m){return I[m]||""}y.toString=k;function C(m){switch(m){case v.default.Error:return y.Error;case v.default.Warning:return y.Warning;case v.default.Info:return y.Info;case v.default.Ignore:return y.Hint}}y.fromSeverity=C;function p(m){switch(m){case y.Error:return v.default.Error;case y.Warning:return v.default.Warning;case y.Info:return v.default.Info;case y.Hint:return v.default.Ignore}}y.toSeverity=p}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const E="";function I(C){return k(C,!0)}y.makeKey=I;function k(C,p){const m=[E];return C.source?m.push(C.source.replace("\xA6","\\\xA6")):m.push(E),C.code?typeof C.code=="string"?m.push(C.code.replace("\xA6","\\\xA6")):m.push(C.code.value.replace("\xA6","\\\xA6")):m.push(E),C.severity!==void 0&&C.severity!==null?m.push(D.toString(C.severity)):m.push(E),C.message&&p?m.push(C.message.replace("\xA6","\\\xA6")):m.push(E),C.startLineNumber!==void 0&&C.startLineNumber!==null?m.push(C.startLineNumber.toString()):m.push(E),C.startColumn!==void 0&&C.startColumn!==null?m.push(C.startColumn.toString()):m.push(E),C.endLineNumber!==void 0&&C.endLineNumber!==null?m.push(C.endLineNumber.toString()):m.push(E),C.endColumn!==void 0&&C.endColumn!==null?m.push(C.endColumn.toString()):m.push(E),m.push(E),m.join("\xA6")}y.makeKeyOptionalMessage=k})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,P.createDecorator)("markerService")}),define(be[64],ve([1,0,6,55,2,5]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,S.createDecorator)("policy");class D extends P.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new v.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(E){const I=Object.keys(this.f).length;return this.f={...E,...this.f},I!==Object.keys(this.f).length&&await this.i(E),t.Iterable.reduce(this.g.entries(),(k,[C,p])=>({...k,[C]:p}),{})}getPolicyValue(E){return this.g.get(E)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(E,[I,k])=>({...E,[I]:{definition:k,value:this.g.get(I)}}),{})}}e.AbstractPolicyService=D;class A{constructor(){this.onDidChange=v.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=A}),define(be[50],ve([1,0,3,27]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.context<"u"){const S=v.globals.vscode.context.configuration();if(S)P=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(P=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`,serverDataFolderName:P.serverDataFolderName?`${P.serverDataFolderName}-dev`:void 0}),!P.version){const S=globalThis._VSCODE_PACKAGE_JSON;Object.assign(P,{version:S.version})}Object.assign(P,{extensionsGallery:t.env.EXTENSIONS_GALLERY?JSON.parse(t.env.EXTENSIONS_GALLERY):P.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else P={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.74.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.74.1",commit:"1ad8d514439d5077d2b0b7ee64d2ce82a9308e5a",date:"2022-12-22T17:30:42.591Z"},Object.keys(P).length===0&&Object.assign(P,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=P}),define(be[25],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(be[35],ve([1,0,86,9]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(D,A){v.ok(t.isString(D)),v.ok(t.isObject(A)),v.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,A)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new P}),define(be[214],ve([1,0,6,35]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class S{constructor(){this.b=new v.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,E){this.a[P(y)]=E,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const D=new S;t.Registry.add(e.Extensions.JSONContribution,D)}),define(be[51],ve([1,0,18,6,9,160,24,214,35]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=y.Registry.as(A.Extensions.JSONContribution);class C{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const r=this.k(i,n);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const n=this.l(i);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:i,remove:n}){const r=[];r.push(...this.l(n)),r.push(...this.k(i,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,v.distinct)(r)})}registerDefaultConfigurations(i){const n=[],r=[];for(const{overrides:o,source:a}of i)for(const l in o)if(n.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const s=this.a.get(l),h=s?.valuesSources??new Map;if(a)for(const ne of Object.keys(o[l]))h.set(ne,a);const T={...s?.value||{},...o[l]};this.a.set(l,{source:a,value:T,valuesSources:h});const F=(0,D.getLanguageTagSettingPlainKey)(l),Z={type:"object",default:T,description:S.localize(1,null,F),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:T,source:P.isString(a)?void 0:a,defaultValueSource:a};r.push(...g(l)),this.d[l]=Z,this.b.properties[l]=Z}else{this.a.set(l,{value:o[l],source:a});const s=this.d[l];s&&(this.s(l,s),this.o(l,s))}this.registerOverrideIdentifiers(r),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:r,source:o}of i)for(const a in r){const l=this.a.get(a),s=P.isString(o)?o:o?.id,h=P.isString(l?.source)?l?.source:l?.source?.id;if(s===h)if(n.push(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const T=this.d[a];T&&(this.s(a,T),this.o(a,T))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const n of i)this.h.add(n);this.q()}k(i,n){const r=[];return i.forEach(o=>{r.push(...this.m(o,n,o.extensionInfo,o.restrictedProperties)),this.c.push(o),this.n(o)}),r}l(i){const n=[],r=o=>{if(o.properties)for(const a in o.properties){n.push(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.p(a,o.properties[a])}o.allOf?.forEach(a=>r(a))};for(const o of i){r(o);const a=this.c.indexOf(o);a!==-1&&this.c.splice(a,1)}return n}m(i,n=!0,r,o,a=3){a=P.isUndefinedOrNull(i.scope)?a:i.scope;const l=[],s=i.properties;if(s)for(const T in s){const F=s[T];if(n&&c(T,F)){delete s[T];continue}if(F.source=r,F.defaultDefaultValue=s[T].default,this.s(T,F),e.OVERRIDE_PROPERTY_REGEX.test(T)?F.scope=void 0:(F.scope=P.isUndefinedOrNull(F.scope)?a:F.scope,F.restricted=P.isUndefinedOrNull(F.restricted)?!!o?.includes(T):F.restricted),s[T].hasOwnProperty("included")&&!s[T].included){this.f[T]=s[T],delete s[T];continue}else this.d[T]=s[T],s[T].policy?.name&&this.e.set(s[T].policy.name,T);!s[T].deprecationMessage&&s[T].markdownDeprecationMessage&&(s[T].deprecationMessage=s[T].markdownDeprecationMessage),l.push(T)}const h=i.allOf;if(h)for(const T of h)l.push(...this.m(T,n,r,o,a));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const n=r=>{const o=r.properties;if(o)for(const l in o)this.o(l,o[l]);r.allOf?.forEach(n)};n(i)}o(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.g.properties[i]=n;break}}p(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const n=`[${i}]`,r={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,r),e.allSettings.properties[n]=r,e.applicationSettings.properties[n]=r,e.machineSettings.properties[n]=r,e.machineOverridableSettings.properties[n]=r,e.windowSettings.properties[n]=r,e.resourceSettings.properties[n]=r}this.i.fire()}r(){const i={type:"object",description:S.localize(4,null),errorMessage:S.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,n){const r=this.a.get(i);let o=r?.value,a=r?.source;P.isUndefined(o)&&(o=n.defaultDefaultValue,a=void 0),P.isUndefined(o)&&(o=d(n.type)),n.default=o,n.defaultValueSource=a}}const p="\\[([^\\]]+)\\]",m=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(u){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let n=m.exec(u);for(;n?.length;){const r=n[1].trim();r&&i.push(r),n=m.exec(u)}}return(0,v.distinct)(i)}e.overrideIdentifiersFromKey=g;function w(u){return u.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=w;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const b=new C;y.Registry.add(e.Extensions.Configuration,b);function c(u,i){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?S.localize(7,null,u):b.getConfigurationProperties()[u]!==void 0?S.localize(8,null,u):i.policy?.name&&b.getPolicyConfigurations().get(i.policy?.name)!==void 0?S.localize(9,null,u,i.policy?.name,b.getPolicyConfigurations().get(i.policy?.name)):null:S.localize(6,null)}e.validateProperty=c;function f(){const u=[],i=b.getConfigurationProperties();for(const n of Object.keys(i))u.push([n,i[n].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=f}),define(be[107],ve([1,0,18,6,69,2,26,23,9,4,24,51,35]),function(re,e,v,t,P,S,D,A,y,E,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(n={},r=[],o=[],a){this.c=n,this.d=r,this.f=o,this.raw=a,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(r=>{if(r instanceof p)return r;const o=new m("");return o.parseRaw(r),o.configurationModel});this.g=n.reduce((r,o)=>o===r?o:r.merge(o),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}inspect(n,r){const o=this.rawConfiguration.getValue(n),a=r?this.rawConfiguration.getOverrideValue(n,r):void 0,l=r?this.rawConfiguration.override(r).getValue(n):o;return{value:o,override:a,merged:l}}getOverrideValue(n,r){const o=this.l(r);return o?n?(0,I.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const r=[];for(const o of this.overrides)o.identifiers.includes(n)&&r.push(...o.keys);return v.distinct(r)}getAllOverrideIdentifiers(){const n=[];for(const r of this.overrides)n.push(...r.identifiers);return v.distinct(n)}override(n){let r=this.b.get(n);return r||(r=this.h(n),this.b.set(n,r)),r}merge(...n){const r=A.deepClone(this.contents),o=A.deepClone(this.overrides),a=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const s of n)if(l.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.j(r,s.contents);for(const h of s.overrides){const[T]=o.filter(F=>v.equals(F.identifiers,h.identifiers));T?(this.j(T.contents,h.contents),T.keys.push(...h.keys),T.keys=v.distinct(T.keys)):o.push(A.deepClone(h))}for(const h of s.keys)a.indexOf(h)===-1&&a.push(h)}return new p(r,a,o,l.every(s=>s instanceof p)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new p(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}h(n){const r=this.l(n);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const o={};for(const a of v.distinct([...Object.keys(this.contents),...Object.keys(r)])){let l=this.contents[a];const s=r[a];s&&(typeof l=="object"&&typeof s=="object"?(l=A.deepClone(l),this.j(l,s)):l=s),o[a]=l}return new p(o,this.keys,this.overrides)}j(n,r){for(const o of Object.keys(r)){if(o in n&&y.isObject(n[o])&&y.isObject(r[o])){this.j(n[o],r[o]);continue}n[o]=A.deepClone(r[o])}}k(n){return this.a&&!Object.isFrozen(n)?A.deepFreeze(n):n}l(n){let r=null,o=null;const a=l=>{l&&(o?this.j(o,l):o=A.deepClone(l))};for(const l of this.overrides)v.equals(l.identifiers,[n])?r=l.contents:l.identifiers.includes(n)&&a(l.contents);return a(r),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,r){this.m(n),(0,I.addToValueTree)(this.contents,n,r,o=>{throw new Error(o)})}removeValue(n){this.n(n)&&(0,I.removeFromValueTree)(this.contents,n)}m(n){let r=this.keys.length;for(let o=0;o<r;o++)n.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,n)}n(n){const r=this.keys.indexOf(n);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class m{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,r){if(!y.isUndefinedOrNull(n)){const o=this.g(n);this.parseRaw(o,r)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,r){this.a=n;const{contents:o,keys:a,overrides:l,restricted:s,hasExcludedProperties:h}=this.h(n,r);this.b=new p(o,a,l,h?[n]:void 0),this.c=s||[]}g(n){let r={},o=null,a=[];const l=[],s=[];function h(F){Array.isArray(a)?a.push(F):o!==null&&(a[o]=F)}const T={onObjectBegin:()=>{const F={};h(F),l.push(a),a=F,o=null},onObjectProperty:F=>{o=F},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const F=[];h(F),l.push(a),a=F,o=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:h,onError:(F,Z,ne)=>{s.push({error:F,offset:Z,length:ne})}};if(n)try{P.visit(n,T),r=a[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return r}h(n,r){const o=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),a=this.j(n,o,!0,r);n=a.raw;const l=(0,I.toValuesTree)(n,T=>console.error(`Conflict in settings file ${this.f}: ${T}`)),s=Object.keys(n),h=this.l(n,T=>console.error(`Conflict in settings file ${this.f}: ${T}`));return{contents:l,keys:s,overrides:h,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(n,r,o,a){let l=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:l};const s={},h=[];for(const T in n)if(k.OVERRIDE_PROPERTY_REGEX.test(T)&&o){const F=this.j(n[T],r,!1,a);s[T]=F.raw,l=l||F.hasExcludedProperties,h.push(...F.restricted)}else{const F=r[T],Z=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&h.push(T),(Z===void 0||a.scopes===void 0||a.scopes.includes(Z))&&!(a.skipRestricted&&F?.restricted)?s[T]=n[T]:l=!0}return{raw:s,restricted:h,hasExcludedProperties:l}}l(n,r){const o=[];for(const a of Object.keys(n))if(k.OVERRIDE_PROPERTY_REGEX.test(a)){const l={};for(const s in n[a])l[s]=n[a][s];o.push({identifiers:(0,k.overrideIdentifiersFromKey)(a),keys:Object.keys(l),contents:(0,I.toValuesTree)(l,r)})}return o}}e.ConfigurationModelParser=m;class g extends S.Disposable{constructor(n,r,o,a){super(),this.f=n,this.g=r,this.h=a,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new m(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&o.isEqual(l.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=g;class w{constructor(n,r,o,a,l,s,h,T,F,Z,ne,ce,ie){this.a=n,this.b=r,this.value=o,this.overrideIdentifiers=a,this.c=l,this.d=s,this.f=h,this.g=T,this.h=F,this.j=Z,this.k=ne,this.l=ce,this.m=ie}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class d{constructor(n,r,o,a,l=new p,s=new p,h=new D.ResourceMap,T=new p,F=new D.ResourceMap,Z=!0){this.c=n,this.d=r,this.f=o,this.g=a,this.h=l,this.j=s,this.l=h,this.m=T,this.n=F,this.p=Z,this.a=null,this.b=new D.ResourceMap,this.q=null}getValue(n,r,o){return this.s(n,r,o).getValue(n)}updateValue(n,r,o={}){let a;o.resource?(a=this.n.get(o.resource),a||(a=new p,this.n.set(o.resource,a))):a=this.m,r===void 0?a.removeValue(n):a.setValue(n,r),o.resource||(this.a=null)}inspect(n,r,o){const a=this.s(n,r,o),l=v.distinct(a.overrides.map(T=>T.identifiers).flat()).filter(T=>a.getOverrideValue(n,T)!==void 0),s=this.w(r.resource,o),h=r.resource?this.n.get(r.resource)||this.m:this.m;return new w(n,r,a.getValue(n),l.length?l:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this.j.freeze():void 0,s?s.freeze():void 0,h.inspect(n,r.overrideIdentifier))}keys(n){const r=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,r){this.l.set(n,r),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,r){const o=[];if(!r){const{added:a,updated:l,removed:s}=f(this.c,n);r=[...a,...l,...s]}for(const a of r)for(const l of(0,k.overrideIdentifiersFromKey)(a)){const s=this.c.getKeysForOverrideIdentifier(l),h=n.getKeysForOverrideIdentifier(l),T=[...h.filter(F=>s.indexOf(F)===-1),...s.filter(F=>h.indexOf(F)===-1),...s.filter(F=>!A.equals(this.c.override(l).getValue(F),n.override(l).getValue(F)))];o.push([l,T])}return this.updateDefaultConfiguration(n),{keys:r,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:r,updated:o,removed:a}=f(this.d,n),l=[...r,...o,...a];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:r,updated:o,removed:a,overrides:l}=f(this.applicationConfiguration,n),s=[...r,...o,...a];return s.length&&this.updateApplicationConfiguration(n),{keys:s,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:r,updated:o,removed:a,overrides:l}=f(this.localUserConfiguration,n),s=[...r,...o,...a];return s.length&&this.updateLocalUserConfiguration(n),{keys:s,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:r,updated:o,removed:a,overrides:l}=f(this.remoteUserConfiguration,n),s=[...r,...o,...a];return s.length&&this.updateRemoteUserConfiguration(n),{keys:s,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:r,updated:o,removed:a,overrides:l}=f(this.workspaceConfiguration,n),s=[...r,...o,...a];return s.length&&this.updateWorkspaceConfiguration(n),{keys:s,overrides:l}}compareAndUpdateFolderConfiguration(n,r){const o=this.r.get(n),{added:a,updated:l,removed:s,overrides:h}=f(o,r),T=[...a,...l,...s];return(T.length||!o)&&this.updateFolderConfiguration(n,r),{keys:T,overrides:h}}compareAndDeleteFolderConfiguration(n){const r=this.r.get(n);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:a,removed:l,overrides:s}=f(r,void 0);return{keys:[...o,...a,...l],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,r,o){let a=this.t(r,o);return r.overrideIdentifier&&(a=a.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(a=a.merge(this.d)),a}t({resource:n},r){let o=this.u();if(r&&n){const a=r.getFolder(n);a&&(o=this.v(a.uri)||o);const l=this.n.get(n);l&&(o=o.merge(l))}return o}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let r=this.b.get(n);if(!r){const o=this.u(),a=this.l.get(n);a?(r=o.merge(a),this.p&&(r=r.freeze()),this.b.set(n,r)):r=o}return r}w(n,r){if(r&&n){const o=r.getFolder(n);if(o)return this.l.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,r)=>{const{contents:o,overrides:a,keys:l}=this.l.get(r);return n.push([r,{contents:o,overrides:a,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(r=>n.add(r)),this.userConfiguration.freeze().keys.forEach(r=>n.add(r)),this.j.freeze().keys.forEach(r=>n.add(r)),this.l.forEach(r=>r.freeze().keys.forEach(o=>n.add(o))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.j.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.l.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}y(n){const r=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>r.add(o)),this.j.getKeysForOverrideIdentifier(n).forEach(o=>r.add(o)),this.l.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(a=>r.add(a))),[...r.values()]}static parse(n){const r=this.z(n.defaults),o=this.z(n.policy),a=this.z(n.application),l=this.z(n.user),s=this.z(n.workspace),h=n.folders.reduce((T,F)=>(T.set(E.URI.revive(F[0]),this.z(F[1])),T),new D.ResourceMap);return new d(r,o,a,l,new p,s,h,new p,new D.ResourceMap,!1)}static z(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=d;function b(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,r=new Map;for(const a of i)a.keys.forEach(l=>n.add(l)),a.overrides.forEach(([l,s])=>{const h=(0,D.getOrSet)(r,l,new Set);s.forEach(T=>h.add(T))});const o=[];return r.forEach((a,l)=>o.push([l,[...a.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=b;class c{constructor(n,r,o,a){this.change=n,this.b=r,this.c=o,this.d=a,this.f=void 0;const l=new Set;n.keys.forEach(h=>l.add(h)),n.overrides.forEach(([,h])=>h.forEach(T=>l.add(T))),this.affectedKeys=[...l.values()];const s=new p;this.affectedKeys.forEach(h=>s.setValue(h,{})),this.a=s.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=d.parse(this.b.data)),this.f}affectsConfiguration(n,r){if(this.g(this.a,n)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(n,r,this.b?.workspace):void 0,a=this.c.getValue(n,r,this.d);return!A.equals(o,a)}return!0}return!1}g(n,r){let o=(0,I.toValuesTree)({[r]:!0},()=>{}),a;for(;typeof o=="object"&&(a=Object.keys(o)[0]);){if(n=n[a],!n)return!1;o=o[a]}return!0}}e.ConfigurationChangeEvent=c;function f(i,n){const{added:r,removed:o,updated:a}=u(n?.rawConfiguration,i?.rawConfiguration),l=[],s=i?.getAllOverrideIdentifiers()||[],h=n?.getAllOverrideIdentifiers()||[];if(n){const T=h.filter(F=>!s.includes(F));for(const F of T)l.push([F,n.getKeysForOverrideIdentifier(F)])}if(i){const T=s.filter(F=>!h.includes(F));for(const F of T)l.push([F,i.getKeysForOverrideIdentifier(F)])}if(n&&i){for(const T of s)if(h.includes(T)){const F=u({contents:i.getOverrideValue(void 0,T)||{},keys:i.getKeysForOverrideIdentifier(T)},{contents:n.getOverrideValue(void 0,T)||{},keys:n.getKeysForOverrideIdentifier(T)});l.push([T,[...F.added,...F.removed,...F.updated]])}}return{added:r,removed:o,updated:a,overrides:l}}function u(i,n){const r=i?n?i.keys.filter(l=>n.keys.indexOf(l)===-1):[...i.keys]:[],o=n?i?n.keys.filter(l=>i.keys.indexOf(l)===-1):[...n.keys]:[],a=[];if(i&&n){for(const l of n.keys)if(i.keys.indexOf(l)!==-1){const s=(0,I.getConfigurationValue)(n.contents,l),h=(0,I.getConfigurationValue)(i.contents,l);A.equals(s,h)||a.push(l)}}return{added:r,removed:o,updated:a}}}),define(be[215],ve([1,0,18,6,2,23,9,24,107,51,12,64,35]),function(re,e,v,t,P,S,D,A,y,E,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class p extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new m(this.f())),this.b}async initialize(){return this.b=void 0,this.B(C.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:c})=>this.c(b,c))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(b,c){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}}e.DefaultConfiguration=p;class m extends y.ConfigurationModel{constructor(b={}){const c=C.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(c),u=Object.create(null),i=[];for(const n in c){const r=b[n],o=r!==void 0?r:c[n].default;(0,A.addToValueTree)(u,n,o,a=>console.error(`Conflict in default settings: ${a}`))}for(const n of Object.keys(u))E.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(u[n]),contents:(0,A.toValuesTree)(u[n],r=>console.error(`Conflict in default settings file: ${r}`))});super(u,f,i)}}e.DefaultConfigurationModel=m;class g{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new y.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let w=class extends P.Disposable{get configurationModel(){return this.b}constructor(b,c,f){super(),this.c=b,this.f=c,this.g=f,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new y.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.i(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.j(await this.h(b),!0))),this.b}async h(b){const c={},f=[],u=C.Registry.as(E.Extensions.Configuration).getConfigurationProperties();for(const i of b){const n=u[i];if(!n){f.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(i),c[n.policy.name]={type:n.type}}}return(0,D.isEmptyObject)(c)||await this.f.updatePolicyDefinitions(c),f}i(b){const c=C.Registry.as(E.Extensions.Configuration).getPolicyConfigurations(),f=(0,v.coalesce)(b.map(u=>c.get(u)));this.j(f,!0)}j(b,c){const f=C.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),u=[],i=this.b.isEmpty();for(const n of b){const r=f[n]?.policy?.name;if(r){const o=this.f.getPolicyValue(r);(i?o!==void 0:!(0,S.equals)(this.b.getValue(n),o))&&u.push([n,o])}else this.b.getValue(n)!==void 0&&u.push([n,void 0])}if(u.length){const n=this.b;this.b=new y.ConfigurationModel;for(const r of n.keys)this.b.setValue(r,n.getValue(r));for(const[r,o]of u)o===void 0?this.b.removeValue(r):this.b.setValue(r,o);c&&this.a.fire(this.b)}}};w=Le([Oe(1,k.IPolicyService),Oe(2,I.ILogService)],w),e.PolicyConfiguration=w}),define(be[108],ve([1,0,14,6,2,20,24,107,215,64]),function(re,e,v,t,P,S,D,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends P.Disposable{constructor(C,p,m,g){super(),this.i=C,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new y.DefaultConfiguration),this.c=m instanceof E.NullPolicyService?new y.NullPolicyConfiguration:this.B(new y.PolicyConfiguration(this.b,m,g)),this.f=this.B(new A.UserSettings(this.i,void 0,S.extUriBiasedIgnorePathCase,p)),this.a=new A.Configuration(this.b.configurationModel,this.c.configurationModel,new A.ConfigurationModel,new A.ConfigurationModel),this.g=this.B(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:d})=>this.k(w,d))),this.B(this.c.onDidChangeConfiguration(w=>this.l(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[C,p,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new A.Configuration(C,p,new A.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(C,p){const m=typeof C=="string"?C:void 0,g=(0,D.isConfigurationOverrides)(C)?C:(0,D.isConfigurationOverrides)(p)?p:{};return this.a.getValue(m,g,void 0)}updateValue(C,p,m,g){return Promise.reject(new Error("not supported"))}inspect(C){return this.a.inspect(C,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const C=await this.f.loadConfiguration();this.j(C)}j(C){const p=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(C);this.m(m,p,2)}k(C,p){const m=this.a.toData(),g=this.a.compareAndUpdateDefaultConfiguration(C,p);this.m(g,m,7)}l(C){const p=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(C);this.m(m,p,7)}m(C,p,m){const g=new A.ConfigurationChangeEvent(C,{data:p},this.a);g.source=m,g.sourceConfig=this.n(m),this.h.fire(g)}n(C){switch(C){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(be[109],ve([1,0,8,5]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var P;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends v.ErrorNoTelemetry{static isNotAvailable(A){return A instanceof S&&A._code===P.NotAvailable}static isTemporarilyNotAvailable(A){return A instanceof S&&A._code===P.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof S&&A._code===P.NoResolverFound}static isHandled(A){return A instanceof S&&A.isHandled}constructor(A,y=P.Unknown,E){super(A),this._message=A,this._code=y,this._detail=E,this.isHandled=y===P.NotAvailable&&E===!0,Object.setPrototypeOf(this,S.prototype)}}e.RemoteAuthorityResolverError=S}),define(be[65],ve([1,0,13]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(E){return E.scheme===v.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=t;function P(E){if(!E)return;const I=E.indexOf("+");return I<0?E:E.substr(0,I)}e.getRemoteName=P;function S(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=S;function D(E){const{host:I,port:k}=y(E);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:k}}e.parseAuthorityWithPort=D;function A(E,I){let{host:k,port:C}=y(E);return typeof C>"u"&&(C=I),{host:k,port:C}}e.parseAuthorityWithOptionalPort=A;function y(E){const I=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const k=E.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const C=E.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:E,port:void 0}}}),define(be[32],ve([1,0,15,5,65]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=S;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(g){this.value=g,this.c=g.toLowerCase()}static equals(g,w){if(typeof g>"u"||g===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof g=="string"||typeof w=="string"){const d=typeof g=="string"?g:g.value,b=typeof w=="string"?w:w.value;return v.equalsIgnoreCase(d,b)}return g.c===w.c}static toKey(g){return typeof g=="string"?g.toLowerCase():g.c}}e.ExtensionIdentifier=E;function I(m){return k(m)}e.isApplicationScopedExtension=I;function k(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function C(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=C;function p(m,g){if(g){const w=`onResolveRemoteAuthority:${(0,P.getRemoteName)(g)}`;return m.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[33],ve([1,0,15,31,32,3,4,8,27]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(n,r){return n.uuid&&r.uuid?n.uuid===r.uuid:n.id===r.id?!0:(0,v.compareIgnoreCase)(n.id,r.id)===0}e.areSameExtensions=E;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(r){const o=r.manifest?r.manifest.version:r.version,a=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new k(r.identifier,o,a)}static parse(r){const o=I.exec(r);return o&&o[1]&&o[2]?new k({id:o[1]},o[2],o[4]||void 0):null}constructor(r,o,a="undefined"){this.version=o,this.targetPlatform=a,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof k?E(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=k;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const r=C.exec(n);return r&&r[1]?[g(r[1]),r[2]]:[g(n),void 0]}e.getIdAndVersion=p;function m(n,r){return`${n}.${r}`}e.getExtensionId=m;function g(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function w(n,r){return g(m(n,r))}e.getGalleryExtensionId=w;function d(n,r){const o=[],a=l=>{for(const s of o)if(s.some(h=>E(r(h),r(l))))return s;return null};for(const l of n){const s=a(l);s?s.push(l):o.push([l])}return o}e.groupByExtension=d;function b(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function c(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function f(n,r){const o=[],a=r.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const l=a.shift();if(l&&o.every(s=>!E(s.identifier,{id:l}))){const s=n.filter(h=>E(h.identifier,{id:l}));s.length===1&&(o.push(s[0]),a.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=f;async function u(n,r){if(!S.isLinux)return!1;let o;try{o=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){r.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(l))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=u;async function i(n,r){const o=await u(n,r),a=(0,t.getTargetPlatform)(o?"alpine":S.platform,y.arch);return r.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=i}),define(be[110],ve([1,0,19,8,13,20,49,4,165,31,33,32]),function(re,e,v,t,P,S,D,A,y,E,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const C=w=>(0,y.localize)(0,null,w),p=(0,y.localize)(1,null,"ms-dotnettools.csharp");function m(w,d){return d?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}let g=class{constructor(d,b){this.a=d,this.b=b}get d(){}async listExtensions(d,b,c,f=console){let u=await this.a.getInstalled(1,c);const i=k.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(b&&b!==""){if(i.indexOf(b.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}u=u.filter(r=>r.manifest.categories?r.manifest.categories.map(a=>a.toLowerCase()).indexOf(b.toLowerCase())>-1:!1)}else if(b===""){f.log("Possible Categories: "),i.forEach(r=>{f.log(r)});return}this.d&&f.log((0,y.localize)(2,null,this.d)),u=u.sort((r,o)=>r.identifier.id.localeCompare(o.identifier.id));let n;for(const r of u)n!==r.identifier.id&&(n=r.identifier.id,f.log(m(r.manifest,d)))}async installExtensions(d,b,c,f,u=console){const i=[],n=[];d.length&&u.log(this.d?(0,y.localize)(3,null,this.d):(0,y.localize)(4,null));const r=await this.a.getInstalled(1,c.profileLocation),o=(h,T)=>{const F=r.find(Z=>(0,I.areSameExtensions)(Z.identifier,{id:h}));if(F){if(!f&&(!T||T==="prerelease"&&F.preRelease))return u.log((0,y.localize)(5,null,h,F.manifest.version,h)),!1;if(T&&F.manifest.version===T)return u.log((0,y.localize)(6,null,`${h}@${T}`)),!1}return!0},a=(h,T,F)=>{s.push({id:h,version:T!=="prerelease"?T:void 0,installOptions:{...c,isBuiltin:F,installPreReleaseVersion:T==="prerelease"||c.installPreReleaseVersion}})},l=[],s=[];for(const h of d)if(h instanceof A.URI)l.push(h);else{const[T,F]=(0,I.getIdAndVersion)(h);o(T,F)&&a(T,F,!1)}for(const h of b){const[T,F]=(0,I.getIdAndVersion)(h);o(T,F)&&a(T,F,!0)}if(l.length&&await Promise.all(l.map(async h=>{try{const T=await this.f(h,{...c,isBuiltin:!1},f,u);T&&n.push(T)}catch(T){u.error(T.message||T.stack||T),i.push(h.toString())}})),s.length){const h=await this.g(s);await Promise.all(s.map(async T=>{const F=h.get(T.id.toLowerCase());if(F)try{const Z=await this.h(T,F,r,f,u);Z&&n.push(Z)}catch(Z){u.error(Z.message||Z.stack||Z),i.push(T.id)}else u.error(`${C(T.version?`${T.id}@${T.version}`:T.id)}
${p}`),i.push(T.id)}))}if(i.length)throw new Error((0,y.localize)(7,null,i.join(", ")))}async f(d,b,c,f){const u=await this.a.getManifest(d);if(!u)throw new Error("Invalid vsix");if(await this.k(u,c,b.profileLocation,f))try{return await this.a.install(d,b),f.log((0,y.localize)(8,null,(0,S.basename)(d))),u}catch(n){if((0,t.isCancellationError)(n))return f.log((0,y.localize)(9,null,(0,S.basename)(d))),null;throw n}return null}async g(d){const b=new Map,c=d.some(u=>u.installOptions.installPreReleaseVersion),f=await this.b.getExtensions(d.map(u=>({...u,preRelease:c})),v.CancellationToken.None);for(const u of f)b.set(u.identifier.id.toLowerCase(),u);return b}async h({id:d,version:b,installOptions:c},f,u,i,n){const r=await this.b.getManifest(f,v.CancellationToken.None);if(r&&!this.j(r,n))return null;const o=u.find(a=>(0,I.areSameExtensions)(a.identifier,f.identifier));if(o){if(f.version===o.manifest.version)return n.log((0,y.localize)(10,null,b?`${d}@${b}`:d)),null;n.log((0,y.localize)(11,null,d,f.version))}try{c.isBuiltin?n.log(b?(0,y.localize)(12,null,d,b):(0,y.localize)(13,null,d)):n.log(b?(0,y.localize)(14,null,d,b):(0,y.localize)(15,null,d));const a=await this.a.installFromGallery(f,{...c,installGivenVersion:!!b});return n.log((0,y.localize)(16,null,d,a.manifest.version)),r}catch(a){if((0,t.isCancellationError)(a))return n.log((0,y.localize)(17,null,d)),null;throw a}}j(d,b){return!0}async k(d,b,c,f){const u={id:(0,I.getGalleryExtensionId)(d.publisher,d.name)},n=(await this.a.getInstalled(1,c)).find(r=>(0,I.areSameExtensions)(u,r.identifier)&&(0,D.gt)(r.manifest.version,d.version));return n&&!b?(f.log((0,y.localize)(18,null,n.identifier.id,n.manifest.version,d.version)),!1):this.j(d,f)}async uninstallExtensions(d,b,c,f=console){const u=async n=>{if(n instanceof A.URI){const r=await this.a.getManifest(n);return m(r)}return n},i=[];for(const n of d){const r=await u(n),a=(await this.a.getInstalled(void 0,c)).filter(l=>(0,I.areSameExtensions)(l.identifier,{id:r}));if(!a.length)throw new Error(`${this.l(r)}
${p}`);if(a.some(l=>l.type===0)){f.log((0,y.localize)(19,null,r));return}if(!b&&a.some(l=>l.isBuiltin)){f.log((0,y.localize)(20,null,r));return}f.log((0,y.localize)(21,null,r));for(const l of a)await this.a.uninstall(l,{profileLocation:c}),i.push(l);this.d?f.log((0,y.localize)(22,null,r,this.d)):f.log((0,y.localize)(23,null,r))}}async locateExtension(d,b=console){const c=await this.a.getInstalled();d.forEach(f=>{c.forEach(u=>{if(u.identifier.id===f&&u.location.scheme===P.Schemas.file){b.log(u.location.fsPath);return}})})}l(d){return this.d?(0,y.localize)(24,null,d,this.d):(0,y.localize)(25,null,d)}};g=Le([Oe(0,E.IExtensionManagementService),Oe(1,E.IExtensionGalleryService)],g),e.ExtensionManagementCLI=g}),define(be[216],ve([1,0,14,8,2,13,3,20,49,9,21,22,24,30,31,33,76,17,12,25]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class Cn extends P.Disposable{constructor(i,n,r,o,a,l,s,h){super(),this.h=i,this.i=r,this.j=o,this.k=a,this.l=l,this.m=s,this.n=h,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(i,n){await this.g;const r=(0,A.joinPath)(this.extensionsDownloadDir,this.y(i));try{await this.u(i,r,a=>this.j.download(i,a,n))}catch(a){throw new m.ExtensionManagementError(a.message,m.ExtensionManagementErrorCode.Download)}let o=!1;if(await this.r(i)){const a=await this.t(i);try{o=await this.m.verify(r.fsPath,a.fsPath),this.n.info(`Verified extension: ${i.identifier.id}`,o)}catch(l){throw await this.delete(a),await this.delete(r),new m.ExtensionManagementError(l.code,m.ExtensionManagementErrorCode.Signature)}}return{location:r,verified:o}}async r(i){if(!i.isSigned||await this.h==="linux-armhf")return!1;const r=this.k.getValue("extensions.verifySignature");return(0,E.isBoolean)(r)?r:this.l.quality!=="stable"}async t(i){await this.g;const n=(0,A.joinPath)(this.extensionsDownloadDir,`${this.y(i)}${Cn.c}`);return await this.u(i,n,r=>this.j.downloadSignatureArchive(i,r)),n}async u(i,n,r){if(await this.i.exists(n))return;if(n.scheme!==S.Schemas.file){await r(n);return}const o=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.i.exists(o)||await r(o);try{await this.v(o,n,Date.now()+2*60*1e3)}catch(a){try{await this.i.del(o)}catch{}if(a.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.n.info(`Rename failed because of ${(0,t.getErrorMessage)(a)}. Deleted the file from downloaded location`,o.path),a}}async delete(i){await this.g,await this.i.del(i)}async v(i,n,r){try{await k.Promises.rename(i.fsPath,n.fsPath)}catch(o){if(D.isWindows&&o&&o.code==="EPERM"&&Date.now()<r)return this.n.info(`Failed renaming ${i} to ${n} with 'EPERM' error. Trying again...`),this.v(i,n,r);throw o}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],r=[],o=[];for(const s of i.children)if(s.name.endsWith(Cn.c))o.push(s.resource);else{const h=g.ExtensionKey.parse(s.name);h&&r.push([h,s])}const a=(0,g.groupByExtension)(r,([s])=>s),l=[];for(const s of a)s.sort((h,T)=>y.rcompare(h[0].version,T[0].version)),n.push(...s.slice(1).map(h=>h[1].resource)),l.push(s[0][1]);l.sort((s,h)=>s.mtime-h.mtime),n.push(...l.slice(0,Math.max(0,l.length-this.f)).map(s=>s.resource)),n.push(...o),await v.Promises.settled(n.map(s=>(this.n.trace("Deleting from cache",s.path),this.i.del(s))))}}catch(i){this.n.error(i)}}y(i){return this.f?g.ExtensionKey.create(i).toString().toLowerCase():(0,I.generateUuid)()}};f.c=".sigzip",f=Le([Oe(1,p.INativeEnvironmentService),Oe(2,d.IFileService),Oe(3,m.IExtensionGalleryService),Oe(4,C.IConfigurationService),Oe(5,c.IProductService),Oe(6,w.IExtensionSignatureVerificationService),Oe(7,b.ILogService)],f),e.ExtensionsDownloader=f}),define(be[217],ve([1,0,2,7,22,32]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends v.Disposable{constructor(y,E){super(),this.b=y,this.a=(0,t.join)(this.b.userDataPath,S.MANIFEST_CACHE_FOLDER,S.USER_MANIFEST_CACHE_FILE),this.B(E.onDidInstallExtensions(I=>this.c(I))),this.B(E.onDidUninstallExtension(I=>this.f(I)))}c(y){y.some(E=>!!E.local)&&this.invalidate()}f(y){y.error||this.invalidate()}invalidate(){P.Promises.rm(this.a,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(be[218],ve([1,0,6,2,26,33,32]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class A extends t.Disposable{constructor(E,I,k,C,p,m,g){super(),this.f=E,this.g=I,this.h=k,this.i=C,this.j=p,this.k=m,this.l=g,this.a=this.B(new v.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new t.DisposableMap),this.m().then(null,w=>g.error(w))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(E=>this.p(E.added,E.removed))),this.B(this.i.onAddExtensions(E=>this.r(E))),this.B(this.i.onDidAddExtensions(E=>this.s(E))),this.B(this.i.onRemoveExtensions(E=>this.t(E))),this.B(this.i.onDidRemoveExtensions(E=>this.u(E))),this.B(this.k.onDidFilesChange(E=>this.v(E)))}async p(E,I){try{await Promise.all(I.map(k=>(this.c.deleteAndDispose(k.id),this.z(k.extensionsResource)))),E.length&&await Promise.all(E.map(k=>(this.c.set(k.id,(0,t.combinedDisposable)(this.k.watch(this.j.extUri.dirname(k.extensionsResource)),this.k.watch(k.extensionsResource))),this.y(k.extensionsResource))))}catch(k){throw this.l.error(k),k}}async r(E){for(const I of E.extensions)this.D(this.G(I.identifier,I.version),E.profileLocation)}async s(E){for(const I of E.extensions){const k=this.G(I.identifier,I.version);E.error?this.F(k,E.profileLocation):this.D(k,E.profileLocation)}}async t(E){for(const I of E.extensions)this.F(this.G(I.identifier,I.version),E.profileLocation)}async u(E){let I=!1;for(const k of E.extensions){const C=this.G(k.identifier,k.version);E.error?this.D(C,E.profileLocation):(this.F(C,E.profileLocation),I=I||!this.b.has(C))}I&&await this.C()}v(E){for(const I of this.h.profiles)E.contains(I.extensionsResource,0,1)&&this.w(I.extensionsResource)}async w(E){const I=[],k=[],C=await this.i.scanProfileExtensions(E),p=new Set,m=new Set;for(const[g,w]of this.b)w.has(E)&&m.add(g);for(const g of C){const w=this.G(g.identifier,g.version);p.add(w),m.has(w)||(I.push(g.identifier),this.D(w,E))}for(const g of m)if(!p.has(g)){const w=this.H(g);w&&(k.push(w.identifier),this.F(g,E))}(I.length||k.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:E}:void 0,removed:k.length?{extensions:k,profileLocation:E}:void 0})}async y(E){const I=await this.i.scanProfileExtensions(E);for(const k of I)this.D(this.G(k.identifier,k.version),E)}async z(E){for(const I of[...this.b.keys()])this.F(I,E);await this.C()}async C(){const I=(await this.f.getAllUserInstalled()).filter(k=>k.installedTimestamp&&!this.b.has(this.G(k.identifier,k.manifest.version)));I.length&&await this.f.markAsUninstalled(...I)}D(E,I){let k=this.b.get(E);k||this.b.set(E,k=new P.ResourceSet(C=>this.j.extUri.getComparisonKey(C))),k.add(I)}F(E,I){const k=this.b.get(E);k&&k.delete(I),k?.size||this.b.delete(E)}G(E,I){return`${D.ExtensionIdentifier.toKey(E.id)}@${I}`}H(E){const[I,k]=(0,S.getIdAndVersion)(E);return k?{identifier:{id:I},version:k}:void 0}}e.ExtensionsWatcher=A}),define(be[111],ve([1,0,112,18,14,2,13,7,22,30,31,33,12,78,3,4]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let w=class extends p.LanguagePackBaseService{constructor(f,u,i,n){super(i),this.h=f,this.i=n,this.g=this.B(new d(u,n)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(f){const i=(await this.g.getLanguagePacks())[m.Language.value()];if(!i){this.i.warn(`No language pack found for ${m.Language.value()}`);return}const n=i.translations[f];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),u=Object.keys(f).map(i=>{const n=f[i];return{...this.f(i,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return u.push({...this.f("en","English"),extensionId:"default"}),u.sort((i,n)=>i.label.localeCompare(n.label)),u}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const u=await this.g.getLanguagePacks();Object.keys(u).some(i=>u[i]&&u[i].extensions.some(n=>(0,k.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,u]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(u);return!(0,t.equals)(Object.keys(f),Object.keys(i))}};w=Le([Oe(0,I.IExtensionManagementService),Oe(1,E.INativeEnvironmentService),Oe(2,I.IExtensionGalleryService),Oe(3,C.ILogService)],w),e.NativeLanguagePackService=w;let d=class extends S.Disposable{constructor(f,u){super(),this.i=u,this.c={},this.f=(0,A.join)(f.userDataPath,"languagepacks.json"),this.g=new P.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(u=>{Object.keys(u).forEach(i=>delete u[i]),this.j(u,...f)}).then(()=>this.c)}j(f,...u){for(const i of u)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(f,i);Object.keys(f).forEach(i=>this.l(f[i]))}k(f,u){const i=u.identifier,n=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const r of n)if(u.location.scheme===D.Schemas.file&&b(r)){let o=f[r.languageId];o||(o={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},f[r.languageId]=o);const a=o.extensions.filter(l=>(0,k.areSameExtensions)(l.extensionIdentifier,i))[0];a?a.version=u.manifest.version:o.extensions.push({extensionIdentifier:i,version:u.manifest.version});for(const l of r.translations)o.translations[l.id]=(0,A.join)(u.location.fsPath,l.path)}}l(f){if(f){const u=(0,v.createHash)("md5");for(const i of f.extensions)u.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);f.hash=u.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let u=null;return y.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(u=f(i),i)).then(i=>{for(const r of Object.keys(i))i[r]||delete i[r];this.c=i,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),y.Promises.writeFile(this.f,n)}).then(()=>u,i=>this.i.error(i))})}};d=Le([Oe(0,E.INativeEnvironmentService),Oe(1,C.ILogService)],d);function b(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const f of c.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(be[52],ve([1,0,16,177,51,5,35]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,S.createDecorator)("requestService");function A(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=A;function y(g){return g.res.statusCode===204}async function E(g){return y(g)?null:(await(0,v.streamToBuffer)(g.stream)).toString()}e.asText=E;async function I(g){if(!A(g))throw new Error("Server returned "+g.res.statusCode);return E(g)}e.asTextOrError=I;async function k(g){if(!A(g))throw new Error("Server returned "+g.res.statusCode);if(y(g))return null;const d=(await(0,v.streamToBuffer)(g.stream)).toString();try{return JSON.parse(d)}catch(b){throw b.message+=`:
`+d,b}}e.asJson=k;function C(g){m(g)}e.updateProxyConfigurationsScope=C;let p;function m(g){const w=D.Registry.as(P.Extensions.Configuration),d=p;p={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[p],remove:d?[d]:[]})}m(2)}),define(be[219],ve([1,0,19,13,17,52]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(y,E){this.a=y,this.b=E}async download(y,E,I=v.CancellationToken.None){if(y.scheme===t.Schemas.file||y.scheme===t.Schemas.vscodeRemote){await this.b.copy(y,E);return}const k={type:"GET",url:y.toString(!0)},C=await this.a.request(k,I);if(C.res.statusCode===200)await this.b.writeFile(E,C.stream);else{const p=await(0,S.asTextOrError)(C);throw new Error(`Expected 200, got back ${C.res.statusCode} instead.

${p}`)}}};D=Le([Oe(0,S.IRequestService),Oe(1,P.IFileService)],D),e.DownloadService=D}),define(be[220],ve([1,0,16,19]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class P{constructor(A){this.a=A}listen(A,y){throw new Error("Invalid listen")}call(A,y,E,I=t.CancellationToken.None){switch(y){case"request":return this.a.request(E[0],I).then(async({res:k,stream:C})=>{const p=await(0,v.streamToBuffer)(C);return[{statusCode:k.statusCode,headers:k.headers},p]});case"resolveProxy":return this.a.resolveProxy(E[0])}throw new Error("Invalid call")}}e.RequestChannel=P;class S{constructor(A){this.a=A}async request(A,y){const[E,I]=await this.a.call("request",[A],y);return{res:E,stream:(0,v.bufferToStream)(I)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}}e.RequestChannelClient=S}),define(be[221],ve([1,0,79,9]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(D,A){return D.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:D.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function S(D,A,y={}){const E=(0,v.parse)(D),I=y.proxyUrl||P(E,A);if(!I)return null;const k=(0,v.parse)(I);if(!/^https?:$/.test(k.protocol||""))return null;const C={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,t.isBoolean)(y.strictSSL)?y.strictSSL:!0};return E.protocol==="http:"?new(await new Promise((p,m)=>{re(["http-proxy-agent"],p,m)}))(C):new(await new Promise((p,m)=>{re(["https-proxy-agent"],p,m)}))(C)}e.getProxyAgent=S}),define(be[80],ve([1,0,47,7,178,19,39,8,3,21,150,190,14]),function(re,e,v,t,P,S,D,A,y,E,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let m;async function g(d,b,c){return b["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(c)&&!b["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(c)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=C.Promises.withAsyncBody(async(f,u)=>{const i=new S.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),u(new Error((0,P.localize)(0,null)))},p);try{f(await w(d,i.token))}catch(r){!(0,A.isCancellationError)(r)&&!i.token.isCancellationRequested?u(new Error((0,P.localize)(1,null,(0,D.toErrorMessage)(r)))):f({})}finally{clearTimeout(n),i.dispose()}})),m)}e.getResolvedShellEnv=g;async function w(d,b){const c=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",c);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",f);const u=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"(.*)"+u),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",n);const r=await(0,I.getSystemShell)(y.OS,n);return d.trace("getUnixShellEnvironment#shell",r),new Promise((o,a)=>{if(b.isCancellationRequested)return a((0,A.canceled)());const l=(0,t.basename)(r);let s,h;const T=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(s=`& '${process.execPath}' ${T} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,h=["-Login","-Command"]):(s=`'${process.execPath}' ${T} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,l==="tcsh"?h=["-ic"]:h=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),s);const F=(0,v.spawn)(r,[...h,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});b.onCancellationRequested(()=>(F.kill(),a((0,A.canceled)()))),F.on("error",ce=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ce)),a(ce)});const Z=[];F.stdout.on("data",ce=>Z.push(ce));const ne=[];F.stderr.on("data",ce=>ne.push(ce)),F.on("close",(ce,ie)=>{const M=Buffer.concat(Z).toString("utf8");d.trace("getUnixShellEnvironment#raw",M);const J=Buffer.concat(ne).toString("utf8");if(J.trim()&&d.trace("getUnixShellEnvironment#stderr",J),ce||ie)return a(new Error((0,P.localize)(2,null,ce,ie)));const $=i.exec(M),V=$?$[1]:"{}";try{const X=JSON.parse(V);c?X.ELECTRON_RUN_AS_NODE=c:delete X.ELECTRON_RUN_AS_NODE,f?X.ELECTRON_NO_ATTACH_CONSOLE=f:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",X),o(X)}catch(X){d.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(X)),a(X)}})})}}),define(be[113],ve([1,0,3,27,4,21]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(E){if(v.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function A(E,I,k,C,p,m,g,w,d,b){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,S.generateUuid)()+Date.now(),c.commitHash=p,c.version=m,c["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.PlatformToString)(v.platform),c["common.nodePlatform"]=t.platform,c["common.nodeArch"]=C,c["common.product"]=b||"desktop",w&&(c["common.msftInternal"]=w);let f=0;const u=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),v.isLinuxSnap&&(c["common.snap"]="true");const i=D(k);i&&(c["common.platformDetail"]=i);try{const n=await E.readFile(P.URI.file(d));c["common.source"]=n.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=A;function y(E){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const k=I.toLowerCase();return E.some(C=>k===C)}e.verifyMicrosoftInternalDomain=y}),define(be[222],ve([1,0,18,8,2,23,17]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(E){function I(k,C){return k.callstack<C.callstack?-1:k.callstack>C.callstack?1:0}E.compare=I})(A=e.ErrorEvent||(e.ErrorEvent={}));class y{constructor(I,k=y.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new P.DisposableStore,this.c=I,this.d=k;const C=t.errorHandler.addListener(p=>this.j(p));this.h.add((0,P.toDisposable)(C)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(I){if(!I||(I.detail&&I.detail.stack&&(I=I.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(I)||I instanceof D.FileOperationError))return;const k=Array.isArray(I.stack)?I.stack.join(`
`):I.stack,C=I.message?I.message:(0,S.safeStringify)(I);!k||this.k({msg:C,callstack:k})}k(I){const k=(0,v.binarySearch)(this.g,I,A.compare);k<0?(I.count=1,this.g.splice(~k,0,I)):(this.g[k].count||(this.g[k].count=0),this.g[k].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const I of this.g)this.c.publicLogError2("UnhandledError",I);this.g.length=0}}e.default=y,y.ERROR_FLUSH_TIMEOUT=5*1e3}),define(be[223],ve([1,0,2]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends v.Disposable{constructor(S,D){super(),this.a=S,this.b=D}async call(S,D,A){switch(D){case"updateTelemetryLevel":{const{telemetryLevel:y}=A;return this.a.updateInjectedTelemetryLevel(y)}case"logTelemetry":{const{eventName:y,data:E}=A;return this.b?this.b.log(y,E):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${D} not found`)}listen(S,D,A){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(be[34],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(S){S[S.NONE=0]="NONE",S[S.CRASH=1]="CRASH",S[S.ERROR=2]="ERROR",S[S.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(S){S.OFF="off",S.CRASH="crash",S.ERROR="error",S.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(be[224],ve([1,0,28,14,69,13,7,3,4,92,22,96,198,17,25,34]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const w=new Map;async function d(i,n){const r=`${i}::${n.join(":")}`,o=w.get(r);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,s=new Map,h=2e4;function T(Z,ne,ce,ie){const M=ne.substring(Z.length+1);return t.Promises.withAsyncBody(async J=>{let $;try{$=await I.Promises.readdir(ne,{withFileTypes:!0})}catch{J();return}if(ie.count>=h){ie.count+=$.length,ie.maxReached=!0,J();return}let V=$.length;if(V===0){J();return}let X=$;ie.count+$.length>h&&(ie.maxReached=!0,V=h-ie.count,X=$.slice(0,V)),ie.count+=$.length;for(const ue of X)if(ue.isDirectory()){if(ce.includes(ue.name)||await T(Z,(0,D.join)(ne,ue.name),ce,ie),--V===0){J();return}}else{const L=ue.name.lastIndexOf(".");if(L>=0){const N=ue.name.substring(L+1);N&&l.set(N,(l.get(N)??0)+1)}for(const N of a)N.relativePathPattern?.test(M)!==!1&&N.filePattern.test(ue.name)&&s.set(N.tag,(s.get(N.tag)??0)+1);if(--V===0){J();return}}})}const F=t.Promises.withAsyncBody(async Z=>{const ne={count:0,maxReached:!1};await T(i,i,n,ne);const ce=await f(i);Z({configFiles:b(s),fileTypes:b(l),fileCount:ne.count,maxFilesReached:ne.maxReached,launchConfigFiles:ce})});return w.set(r,F),F}e.collectWorkspaceStats=d;function b(i){return Array.from(i.entries(),([n,r])=>({name:n,count:r})).sort((n,r)=>r.count-n.count)}function c(){const i={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},n=v.cpus();return n&&n.length>0&&(i.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),i}e.getMachineInfo=c;async function f(i){try{const n=new Map,r=(0,D.join)(i,".vscode","launch.json"),o=await I.Promises.readFile(r),a=[],l=(0,P.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,P.getNodeType)(l)==="object"&&l.configurations)for(const s of l.configurations){const h=s.type;h&&(n.has(h)?n.set(h,n.get(h)+1):n.set(h,1))}return b(n)}catch{return[]}}e.collectLaunchConfigs=f;let u=class{constructor(n,r){this.c=n,this.d=r}f(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}g(n){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const o=v.cpus();return o&&o.length>0&&r.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),A.isWindows||r.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,k.listProcesses)(n.mainPID),this.k(n)]).then(async o=>{let[a,l]=o,s=this.m(n,a);return r.forEach(h=>{if((0,C.isRemoteDiagnosticError)(h))s+=`
${h.errorMessage}`,l+=`
${h.errorMessage}`;else if(s+=`

Remote: ${h.hostName}`,h.processes&&(s+=`
${this.m(n,h.processes)}`),h.workspaceMetadata){l+=`
|  Remote: ${h.hostName}`;for(const T of Object.keys(h.workspaceMetadata)){const F=h.workspaceMetadata[T];let Z=`${F.fileCount} files`;F.maxFilesReached&&(Z=`more than ${Z}`),l+=`|    Folder (${T}): ${Z}`,l+=this.h(F)}}}),{processInfo:s,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:o,vmHint:a,os:l,cpus:s}=c(),h={os:l,memory:o,cpus:s,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return A.isWindows||(h.load=`${v.loadavg().map(T=>Math.round(T)).join(", ")}`),A.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(n,r){const o=[];return(0,k.listProcesses)(n.mainPID).then(async a=>(o.push(""),o.push(this.g(n)),o.push(""),o.push(this.m(n,a)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.k(n))),r.forEach(l=>{if((0,C.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.f(l.machineInfo)),l.processes&&o.push(this.m(n,l.processes)),l.workspaceMetadata)for(const s of Object.keys(l.workspaceMetadata)){const h=l.workspaceMetadata[s];let T=`${h.fileCount} files`;h.maxFilesReached&&(T=`more than ${T}`),o.push(`Folder (${s}): ${T}`),o.push(this.h(h))}}),o.push(""),o.push(""),o.join(`
`)))}h(n){const r=[];let a=0;const l=(F,Z)=>{const ne=` ${F}(${Z})`;a+ne.length>60?(r.push(s),s="|                 ",a=s.length):a+=ne.length,s+=ne};let s="|      File types:";const h=10,T=n.fileTypes.length>h?h:n.fileTypes.length;for(let F=0;F<T;F++){const Z=n.fileTypes[F];l(Z.name,Z.count)}if(r.push(s),n.configFiles.length>=0&&(s="|      Conf files:",a=0,n.configFiles.forEach(F=>{l(F.name,F.count)}),r.push(s)),n.launchConfigFiles.length>0){let F="|      Launch Configs:";n.launchConfigFiles.forEach(Z=>{F+=Z.count>1?` ${Z.name}(${Z.count})`:` ${Z.name}`}),r.push(F)}return r.join(`
`)}j(n){const r=Math.max(...Object.keys(n).map(o=>o.length));return Object.keys(n).map(o=>`${o}:  ${" ".repeat(r-o.length)}  ${n[o]}`).join(`
                  `)}k(n){const r=[],o=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const s=y.URI.revive(l);if(s.scheme===S.Schemas.file){const h=s.fsPath;o.push(d(h,["node_modules",".git"]).then(T=>{let F=`${T.fileCount} files`;T.maxFilesReached&&(F=`more than ${F}`),r.push(`|    Folder (${(0,D.basename)(h)}): ${F}`),r.push(this.h(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${h} (${T.toString()})`)}))}else r.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(n,r){const o=new Map;n.windows.forEach(l=>o.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.n(n.mainPID,o,a,r,0),a.join(`
`)}n(n,r,o,a,l){const s=l===0;let h;s?h=a.pid===n?`${this.d.applicationName} main`:"remote agent":(h=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(h=`${h} (${r.get(a.pid)})`));const T=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(T/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(a.children)&&a.children.forEach(F=>this.n(n,r,o,F,l+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:o}of n.folders){const a=y.URI.revive(o);if(a.scheme!==S.Schemas.file)continue;const l=a.fsPath;try{(await d(l,["node_modules",".git"])).fileTypes.forEach(h=>r.add(h.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const o=y.URI.revive(r);if(o.scheme!==S.Schemas.file)continue;const a=o.fsPath;try{const l=await d(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})}),l.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})}),l.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};u=Le([Oe(0,g.ITelemetryService),Oe(1,m.IProductService)],u),e.DiagnosticsService=u}),define(be[43],ve([1,0,23,9,24,65,113,34]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class y{constructor(l){this.value=l}}e.TrustedTelemetryValue=y;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,s){return Promise.resolve(void 0)}publicLog2(l,s){return this.publicLog(l,s)}publicLogError(l,s){return Promise.resolve(void 0)}publicLogError2(l,s){return this.publicLogError(l,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class I{async publicLog(l,s,h){}async publicLogError(l,s,h){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function k(a,l){return l.onDidChangeConfiguration(s=>{s.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(s.source),configurationKeys:c(s.sourceConfig)})})}e.configurationTelemetry=k;function C(a,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!a.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=C;function p(a,l){return!(l.isBuilt||l.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=p;function m(a){const l=a.getValue(A.TELEMETRY_SETTING_ID),s=a.getValue("telemetry.enableCrashReporter");if(a.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function g(a){const l={},s={},h={};b(a,h);for(let T in h){T=T.length>150?T.substr(T.length-149):T;const F=h[T];typeof F=="number"?s[T]=F:typeof F=="boolean"?s[T]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${T} has been trimmed to 8192, the original length is ${F.length}`),l[T]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(l[T]=F)}return{properties:l,measurements:s}}e.validateTelemetryData=g;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(a){if(!a)return"none";const l=(0,S.getRemoteName)(a);return w.has(l)?l:"other"}e.cleanRemoteAuthority=d;function b(a,l,s=0,h){if(!!a)for(const T of Object.getOwnPropertyNames(a)){const F=a[T],Z=h?h+T:T;Array.isArray(F)?l[Z]=(0,v.safeStringify)(F):F instanceof Date?l[Z]=F.toISOString():(0,t.isObject)(F)?s<2?b(F,l,s+1,Z+"."):l[Z]=(0,v.safeStringify)(F):l[Z]=F}}function c(a){if(!a)return[];const l=[];return f(l,"",a),l}function f(a,l,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(h=>f(a,l?`${l}.${h}`:h,s[h])):a.push(l)}function u(a,l){const s=a.msftInternalDomains||[],h=l.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(s)||h}e.isInternalTelemetry=u;function i(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=i;function n(a,l){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let s=a;const h=[];for(const ne of l)for(;;){const ce=ne.exec(a);if(!ce)break;h.push([ce.index,ne.lastIndex])}const T=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Z=0;for(s="";;){const ne=F.exec(a);if(!ne)break;const ce=h.some(([ie,M])=>ne.index<M&&ie<F.lastIndex);!T.test(ne[0])&&!ce&&(s+=a.substring(Z,ne.index)+"<REDACTED: user-file-path>",Z=F.lastIndex)}return Z<a.length&&(s+=a.substr(Z)),s}function r(a){if(!a)return a;const l=a.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of s)if(h.regex.test(l))return`<REDACTED: ${h.label}>`;return a}function o(a,l){return(0,v.cloneAndChange)(a,s=>{if(s instanceof y)return s.value;if(typeof s=="string"){let h=s.replaceAll("%20"," ");h=n(h,l);for(const T of l)h=h.replace(T,"");return h=r(h),h}})}e.cleanData=o}),define(be[225],ve([1,0,195,43]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(S,D,A,y,E,I,k){const C={"X-Market-Client-Id":`VSCode ${S}`,"User-Agent":`VSCode ${S} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,A)&&(0,t.getTelemetryLevel)(y)===3){const p=await(0,v.getServiceMachineId)(A,E,I),{machineId:m}=await k.getTelemetryInfo();C["X-Market-User-Id"]=p,C["VSCode-SessionId"]=m||p}return C}e.resolveMarketplaceHeaders=P}),define(be[226],ve([1,0,8,23,43]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const S="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function D(y,E,I){const k=await new Promise((w,d)=>{re(["@microsoft/1ds-core-js"],w,d)}),C=await new Promise((w,d)=>{re(["@microsoft/1ds-post-js"],w,d)}),p=new k.AppInsightsCore,m=new C.PostChannel,g={instrumentationKey:y,endpointUrl:S,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(I){g.extensionConfig={};const w={alwaysUseXhrOverride:!0,httpXHROverride:I};g.extensionConfig[m.identifier]=w}return p.initialize(g,[]),p.addTelemetryInitializer(w=>{E&&(w.ext=w.ext??{},w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),p}class A{constructor(E,I,k,C,p){this.d=E,this.e=I,this.f=k,this.g=p,this.c=S,this.f||(this.f={}),typeof C=="function"?this.a=C():this.a=C,this.b=null}h(E){if(!!this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=D(this.a,this.d,this.g)),this.b.then(I=>{E(I)},I=>{(0,v.onUnexpectedError)(I),console.error(I)})}}log(E,I){if(!this.a)return;I=(0,t.mixin)(I,this.f),I=(0,P.validateTelemetryData)(I);const k=this.e+"/"+E;try{this.h(C=>{C.pluginVersionString=I?.properties.version??"Unknown",C.track({name:k,baseData:{name:k,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.h(I=>{I.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=A}),define(be[227],ve([1,0,2,23,3,15,179,24,51,50,25,35,34,43]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(d,b,c){this.k=b,this.l=c,this.d={},this.i=new v.DisposableStore,this.j=[],this.b=d.appenders,this.c=d.commonProperties||Promise.resolve({}),this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,S.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,S.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(d,b){this.d[d]=b}m(){let d=(0,p.getTelemetryLevel)(this.k);const b=this.l.enabledTelemetryLevels;if(b){this.h=this.sendErrorTelemetry?b.error:!1;const c=b.usage?3:b.error?2:0;d=Math.min(d,c)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const d=await this.c,b=d.sessionID,c=d["common.machineId"],f=d["common.firstSessionDate"],u=d["common.msftInternal"];return{sessionId:b,machineId:c,firstSessionDate:f,msftInternal:u}}dispose(){this.i.dispose()}n(d,b,c){return this.g<b?Promise.resolve(void 0):this.c.then(f=>{c=(0,t.mixin)(c,this.d),c=(0,p.cleanData)(c,this.j),c=(0,t.mixin)(c,f),this.b.forEach(u=>u.log(d,c))},f=>{console.error(f)})}publicLog(d,b){return this.n(d,3,b)}publicLog2(d,b){return this.publicLog(d,b)}publicLogError(d,b){return this.h?this.n(d,2,b):Promise.resolve(void 0)}publicLogError2(d,b){return this.publicLogError(d,b)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=Le([Oe(1,A.IConfigurationService),Oe(2,I.IProductService)],m),e.TelemetryService=m;function g(){const w=(0,D.localize)(0,null,E.default.nameLong),d=E.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=P.isWeb?"":(0,D.localize)(3,null),c=(0,D.localize)(4,null),f=(0,D.localize)(5,null),u=(0,D.localize)(6,null),i=(0,D.localize)(7,null),n=`
|       | ${c} | ${f} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${w} ${d} ${b}

&nbsp;

${i}
${n}

&nbsp;

${r}
`}k.Registry.as(y.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:g(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.Registry.as(y.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,D.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,D.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(be[228],ve([1,0,24,5,25,34,227,43]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let y=class extends D.TelemetryService{constructor(I,k,C,p){super(I,C,p),this.e=k}publicLog(I,k){return this.e<3?Promise.resolve(void 0):super.publicLog(I,k)}publicLog2(I,k){return this.publicLog(I,k)}publicLogError(I,k){return this.e<2?Promise.resolve(void 0):super.publicLogError(I,k)}publicLogError2(I,k){return this.publicLogError(I,k)}async updateInjectedTelemetryLevel(I){if(I===void 0)throw this.e=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.e=this.e?Math.min(this.e,I):I,this.e===0&&this.dispose()}};y=Le([Oe(2,v.IConfigurationService),Oe(3,P.IProductService)],y),e.ServerTelemetryService=y,e.ServerNullTelemetryService=new class extends A.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(S.ITelemetryService)}),define(be[229],ve([1,0,230,226]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends t.AbstractOneDataSystemAppender{constructor(D,A,y,E){const I={sendPOST:(k,C)=>{const p={method:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data)}};try{const m=v.request(k.urlString,p,g=>{g.on("data",function(w){C(g.statusCode??200,g.headers,w.toString())}),g.on("error",function(w){C(0,{})})});m.write(k.data),m.end()}catch{C(0,{})}}};super(D,A,y,E,I)}}e.OneDataSystemAppender=P}),define(be[231],ve([1,0,8,222]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class P extends t.default{i(){(0,v.setUnexpectedErrorHandler)(A=>console.error(A));const D=[];process.on("unhandledRejection",(A,y)=>{D.push(y),setTimeout(()=>{const E=D.indexOf(y);E>=0&&y.catch(I=>{D.splice(E,1),(0,v.isCancellationError)(I)||(console.warn(`rejected promise not handled within 1 second: ${I}`),I.stack&&console.warn(`stack trace: ${I.stack}`),A&&(0,v.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const y=D.indexOf(A);y>=0&&D.splice(y,1)}),process.on("uncaughtException",A=>{(0,v.onUnexpectedError)(A)})}}e.default=P}),define(be[232],ve([1,0,14,19,6,2,12]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let A=class extends S.Disposable{constructor(E,I){super(),this.h=I,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.Emitter),this.onCreateRequest=this.g.event,this.b=E===void 0?15e3:E}createRequest(E){return new Promise((I,k)=>{const C=++this.a;this.c.set(C,I),this.g.fire({requestId:C,...E});const p=new t.CancellationTokenSource;(0,v.timeout)(this.b,p.token).then(()=>k(`Request ${C} timed out (${this.b}ms)`)),this.f.set(C,[(0,S.toDisposable)(()=>p.cancel())])})}acceptReply(E,I){const k=this.c.get(E);k?(this.c.delete(E),(0,S.dispose)(this.f.get(E)||[]),this.f.delete(E),k(I)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};A=Le([Oe(1,D.ILogService)],A),e.RequestStore=A}),define(be[114],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var P;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var S;(function(c){c.FileName="ptyhost"})(S=e.TerminalLogConstants||(e.TerminalLogConstants={}));var D;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(D=e.PosixShellType||(e.PosixShellType={}));var A;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var y;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(y=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,v.createDecorator)("ptyService");var I;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var k;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k=e.HeartbeatConstants||(e.HeartbeatConstants={}));var C;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(C=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(c){c.TerminalView="view",c.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(m=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}));var d;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(d=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var b;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(b=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(be[233],ve([1,0,3]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function t(D){let A=D;A.indexOf("\\")!==0&&(A=A.replace(/\\/g,"\\\\"));const y=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return A=A.replace(y,""),`'${A}'`}e.escapeNonWindowsPath=t;function P(D,A,y){if(!D)return"";if(!A)return D;A.match(/[\/\\]$/)&&(A=A.slice(0,A.length-1));const E=D.replace(/\\/g,"/").toLowerCase(),I=A.replace(/\\/g,"/").toLowerCase();return E.includes(I)?`~${y}${D.slice(A.length+1)}`:D}e.collapseTildePath=P;function S(D){return D.match(/^['"].*['"]$/)&&(D=D.substring(1,D.length-1)),v.OS===1&&D&&D[1]===":"?D[0].toUpperCase()+D.substring(1):D}e.sanitizeCwd=S}),define(be[234],ve([1,0,28,13,23,7,3,27,15,9,22]),function(re,e,v,t,P,S,D,A,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function k(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let u=0;return f&&f.length===4&&(u=parseInt(f[3])),u}e.getWindowsBuildNumber=k;async function C(f,u,i,n=A.env,r=I.Promises.exists){if(S.isAbsolute(f))return await r(f)?f:void 0;if(u===void 0&&(u=A.cwd()),S.dirname(f)!=="."){const s=S.join(u,f);return await r(s)?s:void 0}const a=(0,P.getCaseInsensitive)(n,"PATH");if(i===void 0&&(0,E.isString)(a)&&(i=a.split(S.delimiter)),i===void 0||i.length===0){const s=S.join(u,f);return await r(s)?s:void 0}for(const s of i){let h;if(S.isAbsolute(s)?h=S.join(s,f):h=S.join(u,s,f),await r(h))return h;if(D.isWindows){let T=h+".com";if(await r(T)||(T=h+".exe",await r(T)))return T}}const l=S.join(u,f);return await r(l)?l:void 0}e.findExecutable=C;function p(f,u,i,n,r){if(!u.shellIntegration.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration||D.isWindows&&!u.windowsEnableConpty)return;const o=f.args,a=A.platform==="win32"?S.basename(f.executable).toLowerCase():S.basename(f.executable),l=S.dirname(t.FileAccess.asFileUri("").fsPath);let s;const h={VSCODE_INJECTION:"1"};if(D.isWindows){if(a==="pwsh.exe"||a==="powershell.exe")return!o||b(o)?s=e.shellIntegrationArgs.get(m.WindowsPwsh):d(o)&&(s=e.shellIntegrationArgs.get(m.WindowsPwshLogin)),s?(s=[...s],s[s.length-1]=(0,y.format)(s[s.length-1],l,""),{newArgs:s,envMixin:h}):void 0;n.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(a){case"bash":return!o||o.length===0?s=e.shellIntegrationArgs.get(m.Bash):c(o)&&(h.VSCODE_SHELL_LOGIN="1",s=e.shellIntegrationArgs.get(m.Bash)),s?(s=[...s],s[s.length-1]=(0,y.format)(s[s.length-1],l),{newArgs:s,envMixin:h}):void 0;case"pwsh":return!o||b(o)?s=e.shellIntegrationArgs.get(m.Pwsh):d(o)&&(s=e.shellIntegrationArgs.get(m.PwshLogin)),s?(s=[...s],s[s.length-1]=(0,y.format)(s[s.length-1],l,""),{newArgs:s,envMixin:h}):void 0;case"zsh":{if(!o||o.length===0?s=e.shellIntegrationArgs.get(m.Zsh):c(o)?s=e.shellIntegrationArgs.get(m.ZshLogin):(o===e.shellIntegrationArgs.get(m.Zsh)||o===e.shellIntegrationArgs.get(m.ZshLogin))&&(s=o),!s)return;s=[...s],s[s.length-1]=(0,y.format)(s[s.length-1],l);const T=S.join(v.tmpdir(),`${v.userInfo().username}-${r.applicationName}-zsh`);h.ZDOTDIR=T;const F=i?.ZDOTDIR??v.homedir()??"~";h.USER_ZDOTDIR=F;const Z=[];return Z.push({source:S.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:S.join(T,".zshrc")}),Z.push({source:S.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:S.join(T,".zprofile")}),Z.push({source:S.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:S.join(T,".zshenv")}),Z.push({source:S.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:S.join(T,".zlogin")}),{newArgs:s,envMixin:h,filesToCopy:Z}}}n.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=p;var m;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(m=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(m.Zsh,["-i"]),e.shellIntegrationArgs.set(m.ZshLogin,["-il"]),e.shellIntegrationArgs.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],w=["-nol","-nologo"];function d(f){return typeof f=="string"?g.includes(f.toLowerCase()):f.length===1&&g.includes(f[0].toLowerCase())||f.length===2&&(g.includes(f[0].toLowerCase())||g.includes(f[1].toLowerCase()))&&(w.includes(f[0].toLowerCase())||w.includes(f[1].toLowerCase()))}function b(f){return typeof f=="string"?w.includes(f.toLowerCase()):f.length===0||f?.length===1&&w.includes(f[0].toLowerCase())}function c(f){return f==="string"&&g.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&g.includes(f[0].toLowerCase())}}),define(be[235],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(S){S.DARK="dark",S.LIGHT="light",S.HIGH_CONTRAST_DARK="hcDark",S.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(S){return S===v.HIGH_CONTRAST_DARK||S===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function P(S){return S===v.DARK||S===v.HIGH_CONTRAST_DARK}e.isDark=P}),define(be[115],ve([1,0,41,6,2,5,35,235]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var y;(function(w){function d(b){return b&&typeof b=="object"&&typeof b.id=="string"}w.isThemeColor=d})(y=e.ThemeColor||(e.ThemeColor={}));function E(w){return{id:w}}e.themeColorFromId=E;var I;(function(w){function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||y.isThemeColor(o.color))}w.isThemeIcon=d;const b=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function c(o){const a=b.exec(o);if(!a)return;const[,l]=a;return{id:l}}w.fromString=c;function f(o){return{id:o}}w.fromId=f;function u(o,a){let l=o.id;const s=l.lastIndexOf("~");return s!==-1&&(l=l.substring(0,s)),a&&(l=`${l}~${a}`),{id:l}}w.modify=u;function i(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}w.getModifier=i;function n(o,a){return o.id===a.id&&o.color?.id===a.color?.id}w.isEqual=n;function r(o,a){return{id:o.id,color:a?E(a):void 0}}w.asThemeIcon=r,w.asClassNameArray=v.CSSIcon.asClassNameArray,w.asClassName=v.CSSIcon.asClassName,w.asCSSSelector=v.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function k(w){switch(w){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class C{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(d){return this.a.push(d),this.b.fire(d),(0,P.toDisposable)(()=>{const b=this.a.indexOf(d);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new C;D.Registry.add(e.Extensions.ThemingContribution,p);function m(w){return p.onColorThemeChange(w)}e.registerThemingParticipant=m;class g extends P.Disposable{constructor(d){super(),this.k=d,this.h=d.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(d){this.h=d,this.updateStyles()}updateStyles(){}w(d,b){let c=this.h.getColor(d);return c&&b&&(c=b(c,this.h)),c?c.toString():null}}e.Themable=g}),define(be[236],ve([1,0,41,4,181,115]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function D(C,p){const m=[{name:null,description:(0,P.localize)(0,null)}];return m.push(...C.map(g=>({name:g.profileName,description:A(g)}))),p&&m.push(...p.map(g=>({name:g.title,description:y(g)}))),{values:m.map(g=>g.name),markdownDescriptions:m.map(g=>g.description)}}e.createProfileSchemaEnums=D;function A(C){let p=`$(${S.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:v.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?p+=`
- args: "${C.args}"`:p+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(p+=`
- overrideName: ${C.overrideName}`),C.color&&(p+=`
- color: ${C.color}`),C.env&&(p+=`
- env: ${JSON.stringify(C.env)}`),p}function y(C){return`$(${S.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:v.Codicon.terminal.id}) ${C.title}
- extensionIdentifier: ${C.extensionIdentifier}`}function E(C,p){if(!C&&!p)return!0;if(typeof C=="string"&&typeof p=="string")return C===p;if(Array.isArray(C)&&Array.isArray(p)){if(C.length!==p.length)return!1;for(let m=0;m<C.length;m++)if(C[m]!==p[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function I(C,p){if(!C&&!p)return!0;if(!C||!p)return!1;if(S.ThemeIcon.isThemeIcon(C)&&S.ThemeIcon.isThemeIcon(p))return C.id===p.id&&C.color===p.color;if(typeof C=="object"&&"light"in C&&"dark"in C&&typeof p=="object"&&"light"in p&&"dark"in p){const m=C,g=p;if((t.URI.isUri(m.light)||k(m.light))&&(t.URI.isUri(m.dark)||k(m.dark))&&(t.URI.isUri(g.light)||k(g.light))&&(t.URI.isUri(g.dark)||k(g.dark)))return m.light.path===g.light.path&&m.dark.path===g.dark.path}if(t.URI.isUri(C)&&t.URI.isUri(p)||k(C)||k(p)){const m=C,g=p;return m.path===g.path&&m.scheme===g.scheme}return!1}e.terminalIconsEqual=I;function k(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=k}),define(be[237],ve([1,0,41,180,51,35,236]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(v.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(v.Codicon.getAll(),f=>`$(${f.id})`)};const A={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...A}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...A}},I=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),k=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),g=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:k},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:k},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...A}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...A}},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...A}},{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...A}},{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){S.Registry.as(P.Extensions.Configuration).registerConfiguration(w),c()}e.registerTerminalPlatformConfiguration=d;let b;function c(f,u){const i=S.Registry.as(P.Extensions.Configuration);let n;f&&(n=(0,D.createProfileSchemaEnums)(f?.profiles,u));const r=b;b={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?n?.values:void 0,markdownEnumDescriptions:f?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?n?.values:void 0,markdownEnumDescriptions:f?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?n?.values:void 0,markdownEnumDescriptions:f?.os===1?n?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[b],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(be[238],ve([1,0,47,41,7,3,22,94,234,115]),function(re,e,v,t,P,S,D,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,k=!0;function C(n,r,o,a,l=process.env,s,h,T,F){return s=s||{existsFile:D.SymlinkSupport.existsFile,readFile:D.Promises.readFile},S.isWindows?p(o,s,l,h,a.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),F,T):f(s,h,o,n&&typeof n=="object"?{...n}:a.getValue(S.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(S.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,T,l)}e.detectAvailableProfiles=C;async function p(n,r,o,a,l,s,h,T,F){const Z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${Z?"Sysnative":"System32"}`;let ce=!1;(0,y.getWindowsBuildNumber)()>=16299&&(ce=!0),await w(T);const ie=new Map;n&&(ie.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),ie.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),ie.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ie.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(s,ie);const M=await m(ie.entries(),h,r,o,a,F);if(n||l)try{const J=await b(`${ne}\\${ce?"wsl":"bash"}.exe`,h);for(const $ of J)(!s||!($.profileName in s))&&M.push($)}catch{k&&(a?.info("WSL is not installed, so could not detect WSL profiles"),k=!1)}return M}async function m(n,r,o,a=process.env,l,s){const h=[];for(const[T,F]of n){if(F===null)continue;let Z,ne,ce;if("source"in F){const J=I?.get(F.source);if(!J)continue;Z=J.paths,ne=F.args||J.args,F.icon?ce=g(F.icon):J.icon&&(ce=J.icon)}else Z=Array.isArray(F.path)?F.path:[F.path],ne=S.isWindows||Array.isArray(F.args)?F.args:void 0,ce=g(F.icon);const ie=await s?.(Z)||Z.slice(),M=await i(T,r,ie,o,a,ne,F.env,F.overrideName,F.isAutoDetected,l);M?(M.isAutoDetected=F.isAutoDetected,M.icon=ce,M.color=F.color,h.push(M)):l?.debug("Terminal profile not validated",T,Z)}return l?.debug("Validated terminal profiles",h),h}function g(n){return typeof n=="string"?{id:n}:n}async function w(n){I&&!n||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),I.set("PowerShell",{profileName:"PowerShell",paths:n||await d(),icon:E.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function d(){const n=[];for await(const r of(0,A.enumeratePowerShellInstallations)())n.push(r.exePath);return n}async function b(n,r){const o=[],a=await new Promise((h,T)=>{v.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,Z)=>{if(F)return T("Problem occurred when getting wsl distros");h(Z)})});if(!a)return[];const l=new RegExp(/[\r?\n]/),s=a.split(l).filter(h=>h.trim().length>0&&h!=="");for(const h of s){if(h===""||h.startsWith("docker-desktop"))continue;const T=`${h} (WSL)`,F={profileName:T,path:n,args:["-d",`${h}`],isDefault:T===r,icon:c(h),isAutoDetected:!1};o.push(F)}return o}function c(n){return n.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):n.includes("Debian")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function f(n,r,o,a,l,s,h,T){const F=new Map;if(o){const Z=(await n.readFile("/etc/shells")).toString(),ne=s||Z.split(`
`).filter(ie=>ie.trim().indexOf("#")!==0&&ie.trim().length>0),ce=new Map;for(const ie of ne){let M=(0,P.basename)(ie),J=ce.get(M)||0;J++,J>1&&(M=`${M} (${J})`),ce.set(M,J),F.set(M,{path:ie,isAutoDetected:!0})}}return u(a,F),await m(F.entries(),l,n,T,r,h)}function u(n,r){if(!!n)for(const[o,a]of Object.entries(n))a===null||!("path"in a)&&!("source"in a)?r.delete(o):(a.icon=a.icon||r.get(o)?.icon,r.set(o,a))}async function i(n,r,o,a,l,s,h,T,F,Z){if(o.length===0)return Promise.resolve(void 0);const ne=o.shift();if(ne==="")return i(n,r,o,a,l,s,h,T,F);const ce={profileName:n,path:ne,args:s,env:h,overrideName:T,isAutoDetected:F,isDefault:n===r};if((0,P.basename)(ne)===ne){const M=l.PATH?l.PATH.split(P.delimiter):void 0,J=await(0,y.findExecutable)(ne,void 0,M,void 0,a.existsFile);return J?(ce.path=J,ce.isFromPath=!0,ce):i(n,r,o,a,l,s)}return await a.existsFile((0,P.normalize)(ne))?ce:i(n,r,o,a,l,s,h,T,F)}}),define(be[239],ve([1,0,6,2,13,3,42,98,24,30,100,80,12,105,232,114,237,238]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var b;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let c=0,f=class extends t.Disposable{constructor(i,n,r,o){super(),this.C=i,this.D=n,this.F=r,this.G=o,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new v.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new v.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new v.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new v.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new v.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new v.Emitter),this.onProcessData=this.s.event,this.t=this.B(new v.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new v.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new v.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new v.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new v.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new v.Emitter),this.onProcessExit=this.z.event,(0,w.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,t.toDisposable)(()=>this.M())),this.f=this.B(new m.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(S.isWindows)return process.env;try{return await(0,k.getResolvedShellEnv)(this.G,{_:[]},process.env)}catch(i){return this.G.error("ptyHost was unable to resolve shell environment",i),{}}}L(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},n=(0,I.parsePtyHostPort)(this.F.args,this.F.isBuilt);n&&(n.break&&n.port?i.debugBrk=n.port:!n.break&&n.port&&(i.debug=n.port));const r=new A.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),D.ProxyChannel.toService(r.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(r.onDidProcessExit(s=>{this.l.fire(s.code),this.i||(this.g<=b.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${s.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const a=r.getChannel(g.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(a,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(a,this.G.getLevel())}));const l=D.ProxyChannel.toService(r.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(s=>this.s.fire(s))),this.B(l.onProcessReady(s=>this.t.fire(s))),this.B(l.onProcessExit(s=>this.z.fire(s))),this.B(l.onDidChangeProperty(s=>this.y.fire(s))),this.B(l.onProcessReplay(s=>this.u.fire(s))),this.B(l.onProcessOrphanQuestion(s=>this.v.fire(s))),this.B(l.onDidRequestDetach(s=>this.w.fire(s))),[r,l]}dispose(){this.i=!0,super.dispose()}async createProcess(i,n,r,o,a,l,s,h,T,F,Z){const ne=setTimeout(()=>this.Q(),g.HeartbeatConstants.CreateProcessTimeout),ce=await this.b.createProcess(i,n,r,o,a,l,s,h,T,F,Z);return clearTimeout(ne),c=Math.max(c,ce),ce}updateTitle(i,n,r){return this.b.updateTitle(i,n,r)}updateIcon(i,n,r,o){return this.b.updateIcon(i,n,r,o)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,n){return this.b.detachFromProcess(i,n)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,n){return this.b.shutdown(i,n)}input(i,n){return this.b.input(i,n)}processBinary(i,n){return this.b.processBinary(i,n)}resize(i,n,r){return this.b.resize(i,n,r)}acknowledgeDataEvent(i,n){return this.b.acknowledgeDataEvent(i,n)}setUnicodeVersion(i,n){return this.b.setUnicodeVersion(i,n)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,n){return this.b.installAutoReply(i,n)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,n,r,o=!1){const a=await this.c;return(0,d.detectAvailableProfiles)(n,r,o,this.D,a,void 0,this.G,this.S.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i){return this.b.getWslPath(i)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,n){return this.b.requestDetachInstance(i,n)}async acceptDetachInstanceReply(i,n){return this.b.acceptDetachInstanceReply(i,n)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,n){return this.b.reviveTerminalProcesses(i,n)}async refreshProperty(i,n){return this.b.refreshProperty(i,n)}async updateProperty(i,n,r){return this.b.updateProperty(i,n,r)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(i,n){return this.f.createRequest({workspaceId:i,originalText:n})}async acceptPtyHostResolvedVariables(i,n){this.f.acceptReply(i,n)}};f=Le([Oe(1,y.IConfigurationService),Oe(2,E.IEnvironmentService),Oe(3,C.ILogService)],f),e.PtyHostService=f}),define(be[38],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(be[116],ve([1,0,38,196,17,20,138,6,2]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(C){this.uri=C,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let I=class{constructor(C){this.g=C,this.c=new y.DisposableStore,this.f=2**16;const p=new Map,m=g=>{let w=p.get(g.scheme);return w===void 0&&(w=C.hasProvider(g)&&!this.g.hasCapability(g,1024),p.set(g.scheme,w)),w};this.c.add(A.Event.any(C.onDidChangeFileSystemProviderRegistrations,C.onDidChangeFileSystemProviderCapabilities)(g=>{p.delete(g.scheme)})),this.extUri=new S.ExtUri(m),this.d=new D.SkipList((g,w)=>this.extUri.compare(g,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(C){this.g.hasProvider(C)&&(C=(0,S.normalizePath)(C));const p=this.d.get(C);return p?p.touch().uri.with({fragment:C.fragment}):(this.d.set(C,new E(C)),this.h(),C)}h(){if(this.d.size<this.f)return;const C=[...this.d.entries()].sort((m,g)=>m[1].touch<g[1].touch?1:m[1].touch>g[1].touch?-1:0);E._clock=0,this.d.clear();const p=this.f*.5;for(let m=0;m<p;m++)this.d.set(C[m][0],C[m][1].touch())}};I=Le([Oe(0,P.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(v.IUriIdentityService,I,1)}),define(be[81],ve([1,0,183,7,58,20,4,5,13]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function E(n){const r=n;return typeof r?.id=="string"&&D.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=E,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const o=n;if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=I;function k(n){const r=n;return typeof r?.id=="string"&&D.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=k;function C(n){const r=n;if(r?.uri)return{id:r.id,uri:D.URI.revive(r.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=C;var p;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function m(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=m;function g(n){const r=n;return!!(r&&typeof r=="object"&&D.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=g;class w{constructor(r,o,a,l,s){this.h=r,this.j=a,this.k=l,this.l=s,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class d{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,S.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function b(n){return new d({uri:n,index:0,name:(0,S.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(n,r){return S.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function f(n){let r;return D.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=f;function u(n,r){return!c(n,r)&&!f(n)}e.isSavedWorkspace=u;function i(n){return(typeof n=="string"?(0,t.extname)(n):(0,S.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(be[36],ve([1,0,89,6,2,20,4,182,30,17,5,12,81,26,38,14,21,15,9]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function c(r){const o=r;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&D.URI.isUri(o.location)&&D.URI.isUri(o.globalStorageHome)&&D.URI.isUri(o.settingsResource)&&D.URI.isUri(o.keybindingsResource)&&D.URI.isUri(o.tasksResource)&&D.URI.isUri(o.snippetsHome)&&D.URI.isUri(o.extensionsResource))}e.isUserDataProfile=c,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function f(r,o){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:D.URI.revive(r.location).with({scheme:o}),globalStorageHome:D.URI.revive(r.globalStorageHome).with({scheme:o}),settingsResource:D.URI.revive(r.settingsResource).with({scheme:o}),keybindingsResource:D.URI.revive(r.keybindingsResource).with({scheme:o}),tasksResource:D.URI.revive(r.tasksResource).with({scheme:o}),snippetsHome:D.URI.revive(r.snippetsHome).with({scheme:o}),extensionsResource:D.URI.revive(r.extensionsResource)?.with({scheme:o}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=f;function u(r,o,a,l){return{id:r,name:o,location:a,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,S.joinPath)(a,"globalStorage"),settingsResource:(0,S.joinPath)(a,"settings.json"),keybindingsResource:(0,S.joinPath)(a,"keybindings.json"),tasksResource:(0,S.joinPath)(a,"tasks.json"),snippetsHome:(0,S.joinPath)(a,"snippets"),extensionsResource:(0,S.joinPath)(a,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=u;let i=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(o,a,l,s){super(),this.m=o,this.n=a,this.r=l,this.s=s,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new p.ResourceMap},this.profilesHome=(0,S.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(o){this.f!==o&&(this.t=void 0,this.f=o)}isEnabled(){return this.f}get u(){if(!this.t){const o=[];if(this.f)for(const h of this.H()){if(!h.name||!(0,b.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}o.push(u((0,S.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}let a;const l=new p.ResourceMap,s=u((0,v.hash)(this.m.userRoamingDataHome.path).toString(16),(0,A.localize)(0,null),this.m.userRoamingDataHome);if(o.unshift({...s,extensionsResource:this.M()??s.extensionsResource,isDefault:!0}),o.length){const h=this.J();if(h.workspaces)for(const[T,F]of Object.entries(h.workspaces)){const Z=D.URI.parse(T),ne=D.URI.parse(F),ce=o.find(ie=>this.r.extUri.isEqual(ie.location,ne));ce&&l.set(Z,ce)}if(h.emptyWindow){const T=D.URI.parse(h.emptyWindow);a=o.find(F=>this.r.extUri.isEqual(F.location,T))}}this.t={profiles:o,workspaces:l,emptyWindow:a}}return this.t}async createTransientProfile(o){const a="Temp",l=new RegExp(`${(0,d.escapeRegExpCharacters)(a)}\\s(\\d+)`);let s=0;for(const T of this.profiles){const F=l.exec(T.name),Z=F?parseInt(F[1]):0;s=Z>s?Z:s}const h=`${a} ${s+1}`;return this.createProfile((0,v.hash)((0,w.generateUuid)()).toString(16),h,{transient:!0},o)}async createNamedProfile(o,a,l){return this.createProfile((0,v.hash)((0,w.generateUuid)()).toString(16),o,a,l)}async createProfile(o,a,l,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.v(o,a,l);return s&&await this.setProfileForWorkspace(s,h),h}async v(o,a,l){if(!(0,b.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(a);return s||(s=(async()=>{try{const h=this.profiles.find(Z=>Z.name===a||Z.id===o);if(h)return h;const T=u(o,a,(0,S.joinPath)(this.profilesHome,o),l);await this.n.createFolder(T.location);const F=[];return this.h.fire({profile:T,join(Z){F.push(Z)}}),await g.Promises.settled(F),this.C([T],[],[]),T}finally{this.k.delete(a)}})(),this.k.set(a,s)),s}async updateProfile(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(s=>s.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);return l=u(l.id,a.name??l.name,l.location,{shortName:a.shortName??l.shortName,transient:a.transient??l.isTransient,useDefaultFlags:a.useDefaultFlags??l.useDefaultFlags}),this.C([],[],[l]),l}async removeProfile(o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(s=>s.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);const l=[];this.i.fire({profile:a,join(s){l.push(s)}});try{await Promise.allSettled(l)}catch(s){this.s.error(s)}a.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const s of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.G(),this.C([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(s){this.s.error(s)}}getOrSetProfileForWorkspace(o,a=this.defaultProfile){if(!this.f)return this.defaultProfile;let l=this.w(o);return l||(l=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(o,l)),l}async setProfileForWorkspace(o,a){this.setProfileForWorkspaceSync(o,a)}setProfileForWorkspaceSync(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=this.profiles.find(s=>s.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);this.F(o,l)}unsetWorkspace(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(o,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const o=await this.n.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(a=>a.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.l.profiles.filter(a=>!this.z(a));await Promise.allSettled(o.map(a=>this.removeProfile(a)))}w(o){const a=this.y(o);return D.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindow??this.u.emptyWindow}y(o){return(0,C.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,C.isWorkspaceIdentifier)(o)?o.configPath:"empty-window"}z(o){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,o.location)||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,o.location)||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location)))}C(o,a,l){const s=[...this.profiles,...o],h=[];this.l.profiles=[];for(let T of s)T.isDefault||a.some(F=>T.id===F.id)||(T=l.find(F=>T.id===F.id)??T,T.isTransient?this.l.profiles.push(T):h.push({location:T.location,name:T.name,shortName:T.shortName,useDefaultFlags:T.useDefaultFlags}));this.I(h),this.t=void 0,this.D(o,a,l)}D(o,a,l){this.g.fire({added:o,removed:a,updated:l,all:this.profiles})}F(o,a,l){l=a?.isTransient?!0:l,l||this.F(o,void 0,!0);const s=this.y(o),h=l?this.l:this.u;D.URI.isUri(s)?(h.workspaces.delete(s),a&&h.workspaces.set(s,a)):h.emptyWindow=a,l||this.G()}G(){const o={};for(const[l,s]of this.u.workspaces.entries())o[l.toString()]=s.location.toString();const a=this.u.emptyWindow?.location.toString();this.L({workspaces:o,emptyWindow:a}),this.t=void 0}H(){return[]}I(o){throw new Error("not implemented")}J(){return{}}L(o){throw new Error("not implemented")}M(){}};i.b="userDataProfiles",i.c="profileAssociations",i=Le([Oe(0,y.IEnvironmentService),Oe(1,E.IFileService),Oe(2,m.IUriIdentityService),Oe(3,k.ILogService)],i),e.UserDataProfilesService=i;class n extends i{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(o){this.a=o}J(){return this.P}L(o){this.P=o}}e.InMemoryUserDataProfilesService=n}),define(be[240],ve([1,0,18,14,19,8,6,2,3,4,163,31,33,32,12,25,34,36]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let b=class extends A.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(r,o,a,l,s){super(),this.t=r,this.u=o,this.v=a,this.w=l,this.y=s,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new D.Emitter),this.m=this.B(new D.Emitter),this.n=this.B(new D.Emitter),this.p=this.B(new D.Emitter),this.s=[],this.B((0,A.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(a=>(0,k.isTargetPlatformCompatible)(a,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{if(!this.t.isEnabled())throw new k.ExtensionManagementError(I.localize(0,null),k.ExtensionManagementErrorCode.Internal);const a=await this.G(r,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(a.manifest,a.extension,o)}catch(a){throw u(this.u,"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(r),error:a}),this.v.error("Failed to install extension.",r.identifier.id),this.v.error(a),f(a)}}async uninstall(r,o={}){return this.v.trace("ExtensionManagementService#uninstall",r.identifier.id),this.I(r,o)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.O(),this.h=r),this.g}registerParticipant(r){this.s.push(r)}async z(r,o,a){const l={...a,installOnlyNewlyAddedFromExtensionPack:E.URI.isUri(o)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,p.isApplicationScopedExtension)(r)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},s=ce=>`${C.ExtensionKey.create(ce).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!E.URI.isUri(o)){const ce=this.j.get(s(o));if(ce){this.v.info("Extensions is already requested to install",o.identifier.id);const{local:ie}=await ce.task.waitUntilTaskIsFinished();return ie}}const h=[],T=[],F=[],Z=this.Q(r,o,l);E.URI.isUri(o)||this.j.set(s(o),{task:Z,waitingTasks:[]}),this.l.fire({identifier:Z.identifier,source:o,profileLocation:l.profileLocation}),this.v.info("Installing extension:",Z.identifier.id),h.push({task:Z,manifest:r});let ne=!1;try{if(l.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Z.identifier.id);else try{const ie=await this.F(Z.identifier,r,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),M=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:J,manifest:$}of(0,v.distinct)(ie,({gallery:V})=>V.identifier.id)){ne=ne||!!$.extensionDependencies?.some(ue=>(0,C.areSameExtensions)({id:ue},Z.identifier));const V=s(J),X=this.j.get(V);if(X){if(this.C(Z,X.task)){const ue=X.task.identifier;this.v.info("Waiting for already requested installing extension",ue.id,Z.identifier.id),X.waitingTasks.push(Z),T.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,L=>L.some(N=>(0,C.areSameExtensions)(N.identifier,ue)))).then(L=>{if(this.v.info("Finished waiting for already requested installing extension",ue.id,Z.identifier.id),!L.find(H=>(0,C.areSameExtensions)(H.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else if(!M.some(({identifier:ue})=>(0,C.areSameExtensions)(ue,J.identifier))){const ue=this.Q($,J,{...l,donotIncludePackAndDependencies:!0});this.j.set(V,{task:ue,waitingTasks:[Z]}),this.l.fire({identifier:ue.identifier,source:J,profileLocation:l.profileLocation}),this.v.info("Installing extension:",ue.identifier.id,Z.identifier.id),h.push({task:ue,manifest:$})}}}catch(ie){if(E.URI.isUri(Z.source))(0,v.isNonEmptyArray)(r.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Z.identifier.id,ie.message),(0,v.isNonEmptyArray)(r.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Z.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Z.identifier.id),ie}const ce=h.reduce((ie,{task:M,manifest:J})=>(ie.set(M.identifier.id.toLowerCase(),{task:M,manifest:J}),ie),new Map);for(;ce.size;){let ie;const M=[...ce.values()].filter(({manifest:J})=>!J.extensionDependencies?.some($=>ce.has($.toLowerCase())));M.length?ie=ce.size===1?M:M.filter(({task:J})=>!(J===Z&&!ne)):(this.v.info("Found extensions with circular dependencies",M.map(({task:J})=>J.identifier.id)),ie=[...ce.values()]),await this.D(ie.map(async({task:J})=>{const $=new Date().getTime();try{const{local:V}=await J.run();if(await this.D(this.s.map(X=>X.postInstall(V,J.source,l,P.CancellationToken.None))),!E.URI.isUri(J.source)){const X=J.operation===3,ue=X?void 0:(new Date().getTime()-J.source.lastUpdated)/1e3;if(u(this.u,X?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(J.source),wasVerified:J.wasVerified,duration:new Date().getTime()-$,durationSinceUpdate:ue}),y.isWeb&&J.operation!==3)try{await this.t.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}F.push({local:V,identifier:J.identifier,operation:J.operation,source:J.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw E.URI.isUri(J.source)||u(this.u,J.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(J.source),wasVerified:J.wasVerified,duration:new Date().getTime()-$,error:V}),this.v.error("Error while installing the extension:",J.identifier.id),V}finally{ce.delete(J.identifier.id.toLowerCase())}}))}return T.length&&await this.D(T),F.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(F),F.filter(({identifier:ie})=>(0,C.areSameExtensions)(ie,Z.identifier))[0].local}catch(ce){if(h.forEach(({task:ie})=>ie.cancel()),F.length)try{const ie=await Promise.allSettled(F.map(({local:M})=>this.R(M,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let M=0;M<ie.length;M++){const J=ie[M],{identifier:$}=F[M];J.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",$.id):this.v.warn("Rollback: Error while uninstalling extension",$.id,(0,S.getErrorMessage)(J.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,S.getErrorMessage)(ie),F.map(({identifier:M})=>M.id))}throw this.m.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:l.context,profileLocation:l.profileLocation}))),ce}finally{for(const{task:ce}of h)ce.source&&!E.URI.isUri(ce.source)&&this.j.delete(s(ce.source))}}C(r,o){for(const[,{task:a,waitingTasks:l}]of this.j.entries())if(a===r&&(l.includes(o)||l.some(s=>this.C(s,o)))||a===o&&l[0]&&!this.C(r,l[0]))return!1;return!0}async D(r){const o=[],a=[],l=await Promise.allSettled(r);for(const s of l)s.status==="fulfilled"?o.push(s.value):a.push(s.reason);if(a.length)throw c(a);return o}async F(r,o,a,l,s){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,s),T=[],F=[],Z=async(ne,ce)=>{T.push(ne);const ie=ce.extensionDependencies||[],M=[...ie];if(ce.extensionPack){const J=a?h.find($=>(0,C.areSameExtensions)($.identifier,ne)):void 0;for(const $ of ce.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(V=>(0,C.areSameExtensions)({id:V},{id:$}))||M.every(V=>!(0,C.areSameExtensions)({id:V},{id:$}))&&M.push($)}if(M.length){const J=M.filter($=>T.every(V=>!(0,C.areSameExtensions)(V,{id:$})));if(J.length){const $=await this.t.getExtensions(J.map(V=>({id:V,preRelease:l})),P.CancellationToken.None);for(const V of $){if(T.find(L=>(0,C.areSameExtensions)(L,V.identifier)))continue;const X=ie.some(L=>(0,C.areSameExtensions)({id:L},V.identifier));let ue;try{ue=await this.G(V,!1,l)}catch(L){if(L instanceof k.ExtensionManagementError&&L.code===k.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.v.info("Skipping the packed extension as it cannot be installed",V.identifier.id);continue}else throw L}F.push({gallery:ue.extension,manifest:ue.manifest}),await Z(ue.extension.identifier,ue.manifest)}}}};return await Z(r,o),F}async G(r,o,a){if((await this.getExtensionsControlManifest()).malicious.some(T=>(0,C.areSameExtensions)(r.identifier,T)))throw new k.ExtensionManagementError(I.localize(1,null,r.identifier.id),k.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(r)){const T=await this.getTargetPlatform();throw new k.ExtensionManagementError(I.localize(2,null,r.identifier.id,this.w.nameLong,(0,k.TargetPlatformToString)(T)),k.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.H(r,o,a);if(s){if(a&&!o&&r.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new k.ExtensionManagementError(I.localize(3,null,r.identifier.id,this.w.nameLong,this.w.version),k.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&r.properties.isPreReleaseVersion&&(await this.t.getExtensions([r.identifier],P.CancellationToken.None))[0]?new k.ExtensionManagementError(I.localize(4,null,r.identifier.id),k.ExtensionManagementErrorCode.ReleaseVersionNotFound):new k.ExtensionManagementError(I.localize(5,null,r.identifier.id,this.w.nameLong,this.w.version),k.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",s.identifier.id);const h=await this.t.getManifest(s,P.CancellationToken.None);if(h===null)throw new k.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,k.ExtensionManagementErrorCode.Invalid);if(h.version!==s.version)throw new k.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,k.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:h}}async H(r,o,a){const l=await this.getTargetPlatform();let s=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==a&&(s=(await this.t.getExtensions([{...r.identifier,preRelease:a}],{targetPlatform:l,compatible:!0},P.CancellationToken.None))[0]||null),!s&&await this.t.isExtensionCompatible(r,a,l)&&(s=r),s||(o?s=(await this.t.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:l,compatible:!0},P.CancellationToken.None))[0]||null:s=await this.t.getCompatibleExtension(r,a,l)),s}async I(r,o){const a={...o,profileLocation:r.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},l=ne=>`${ne.id.toLowerCase()}${a.versionOnly?`-${r.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,s=this.k.get(l(r.identifier));if(s)return this.v.info("Extensions is already requested to uninstall",r.identifier.id),s.waitUntilTaskIsFinished();const h=ne=>{const ce=this.R(ne,a);return this.k.set(l(ce.extension.identifier),ce),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ne.identifier.id}@${ne.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ne.identifier.id}@${ne.manifest.version}`),this.n.fire({identifier:ne.identifier,profileLocation:a.profileLocation,applicationScoped:ne.isApplicationScoped}),ce},T=(ne,ce)=>{ce?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ne.identifier.id}@${ne.manifest.version}`,a.profileLocation.toString(),ce.message):this.v.error("Failed to uninstall extension:",`${ne.identifier.id}@${ne.manifest.version}`,ce.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ne.identifier.id}@${ne.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ne.identifier.id}@${ne.manifest.version}`),u(this.u,"extensionGallery:uninstall",{extensionData:(0,C.getLocalExtensionTelemetryData)(ne),error:ce}),this.p.fire({identifier:ne.identifier,error:ce?.code,profileLocation:a.profileLocation,applicationScoped:ne.isApplicationScoped})},F=[],Z=[];try{F.push(h(r));const ne=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${r.identifier.id}@${r.manifest.version}`);else{const ce=this.M(r,ne);for(const ie of ce)this.k.has(l(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(h(ie))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${r.identifier.id}@${r.manifest.version}`):this.J(F.map(ce=>ce.extension),ne,r),await this.D(F.map(async ce=>{try{if(await ce.run(),await this.D(this.s.map(ie=>ie.postUninstall(ce.extension,a,P.CancellationToken.None))),ce.extension.identifier.uuid)try{await this.t.reportStatistic(ce.extension.manifest.publisher,ce.extension.manifest.name,ce.extension.manifest.version,"uninstall")}catch{}T(ce.extension)}catch(ie){const M=ie instanceof k.ExtensionManagementError?ie:new k.ExtensionManagementError((0,S.getErrorMessage)(ie),k.ExtensionManagementErrorCode.Internal);throw T(ce.extension,M),M}finally{Z.push(ce)}}))}catch(ne){const ce=ne instanceof k.ExtensionManagementError?ne:new k.ExtensionManagementError((0,S.getErrorMessage)(ne),k.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}Z.includes(ie)||T(ie.extension,ce)}throw ce}finally{for(const ne of F)this.k.delete(l(ne.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ne.extension.identifier.id)}}J(r,o,a){for(const l of r){const s=this.N(l,o);if(s.length){const h=s.filter(T=>!r.some(F=>(0,C.areSameExtensions)(F.identifier,T.identifier)));if(h.length)throw new Error(this.L(l,h,a))}}}L(r,o,a){return a===r?o.length===1?I.localize(6,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(7,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(8,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?I.localize(9,null,a.manifest.displayName||a.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(10,null,a.manifest.displayName||a.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(11,null,a.manifest.displayName||a.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(r,o,a=[]){if(a.indexOf(r)!==-1)return[];a.push(r);const l=r.manifest.extensionPack?r.manifest.extensionPack:[];if(l.length){const s=o.filter(T=>!T.isBuiltin&&l.some(F=>(0,C.areSameExtensions)({id:F},T.identifier))),h=[];for(const T of s)h.push(...this.M(T,o,a));return[...s,...h]}return[]}N(r,o){return o.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(l=>(0,C.areSameExtensions)({id:l},r.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const r=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};b=Le([Oe(0,k.IExtensionGalleryService),Oe(1,w.ITelemetryService),Oe(2,m.ILogService),Oe(3,g.IProductService),Oe(4,d.IUserDataProfilesService)],b),e.AbstractExtensionManagementService=b;function c(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,a)=>new Error(`${o.message}${o.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=c;function f(n){if(n instanceof k.ExtensionManagementError)return n;const r=new k.ExtensionManagementError(n.message,k.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}function u(n,r,{extensionData:o,wasVerified:a,duration:l,error:s,durationSinceUpdate:h}){let T,F;s&&(s instanceof k.ExtensionManagementError?(T=s.code,s.code===k.ExtensionManagementErrorCode.Signature&&(F=s.message)):T=k.ExtensionManagementErrorCode.Internal),n.publicLog(r,{...o,wasVerified:a,success:!s,duration:l,errorcode:T,errorcodeDetail:F,durationSinceUpdate:h})}e.reportTelemetry=u;class i{constructor(){this.d=new t.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,t.createCancelablePromise)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,t.createCancelablePromise)(r=>new Promise((o,a)=>{const l=r.onCancellationRequested(()=>{l.dispose(),a(new S.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=i}),define(be[53],ve([1,0,14,16,2,6,26,4,33,32,17,5,12,36,38]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,k.createDecorator)("IExtensionsProfileScannerService");let g=class extends P.Disposable{constructor(b,c,f,u){super(),this.h=b,this.i=c,this.j=f,this.k=u,this.a=this.B(new S.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new S.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new S.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new S.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new D.ResourceMap}scanProfileExtensions(b){return this.l(b)}async addExtensionsToProfile(b,c){const f=[],u=[];try{return await this.l(c,i=>{const n=[];for(const r of i)b.some(([o])=>(0,y.areSameExtensions)(o.identifier,r.identifier)&&o.manifest.version!==r.version)?f.push(r):n.push(r);for(const[r,o]of b)if(!n.some(a=>(0,y.areSameExtensions)(a.identifier,r.identifier)&&a.version===r.manifest.version)){const a={identifier:r.identifier,version:r.manifest.version,location:r.location,metadata:o};u.push(a),n.push(a)}return u.length&&this.a.fire({extensions:u,profileLocation:c}),f.length&&this.c.fire({extensions:f,profileLocation:c}),n}),u.length&&this.b.fire({extensions:u,profileLocation:c}),f.length&&this.f.fire({extensions:f,profileLocation:c}),u}catch(i){throw u.length&&this.b.fire({extensions:u,error:i,profileLocation:c}),f.length&&this.f.fire({extensions:f,error:i,profileLocation:c}),i}}async removeExtensionFromProfile(b,c){const f=[];this.c.fire({extensions:f,profileLocation:c});try{await this.l(c,u=>{const i=[];for(const n of u)(0,y.areSameExtensions)(n.identifier,b.identifier)?f.push(n):i.push(n);return f.length&&this.c.fire({extensions:f,profileLocation:c}),i}),f.length&&this.f.fire({extensions:f,profileLocation:c})}catch(u){throw f.length&&this.f.fire({extensions:f,error:u,profileLocation:c}),u}}async l(b,c){return this.p(b).queue(async()=>{let f=[],u;try{const i=await this.h.readFile(b);u=JSON.parse(i.value.toString())}catch(i){if((0,I.toFileOperationResult)(i)!==1)throw i;this.j.extUri.isEqual(b,this.i.defaultProfile.extensionsResource)&&(u=await this.n())}if(u)for(const i of u){if(!i.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",i);continue}if(!i.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",i);continue}if(!i.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",i);continue}f.push({identifier:i.identifier,location:A.URI.revive(i.location),version:i.version,metadata:i.metadata})}if(c){f=c(f);const i=f.map(n=>({identifier:n.identifier,version:n.version,location:n.location.toJSON(),metadata:n.metadata}));await this.h.writeFile(b,t.VSBuffer.fromString(JSON.stringify(i)))}return f})}async n(){return this.m||(this.m=(async()=>{const b=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let c;try{c=(await this.h.readFile(b)).value.toString()}catch(u){if((0,I.toFileOperationResult)(u)===1)return;throw u}this.k.info("Migrating extensions from old default profile location",b.toString());let f;try{const u=JSON.parse(c);Array.isArray(u)&&u.every(i=>!!(i&&typeof i=="object"&&(0,E.isIExtensionIdentifier)(i.identifier)&&w(i.location)&&i.version&&typeof i.version=="string"))?f=u:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.k.error(u)}if(f)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(f)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",b.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(u){if((0,I.toFileOperationResult)(u)===3)this.k.info("Migration from old default profile location to new location is done by another window",b.toString(),this.i.defaultProfile.extensionsResource.toString());else throw u}try{await this.h.del(b)}catch(u){(0,I.toFileOperationResult)(u)!==1&&this.k.error(u)}return f})()),this.m}p(b){let c=this.g.get(b);return c||(c=new v.Queue,this.g.set(b,c)),c}};g=Le([Oe(0,I.IFileService),Oe(1,p.IUserDataProfilesService),Oe(2,m.IUriIdentityService),Oe(3,C.ILogService)],g),e.ExtensionsProfileScannerService=g;function w(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}}),define(be[54],ve([1,0,18,14,23,16,8,69,158,2,13,7,3,20,49,70,9,4,167,30,33,32,73,17,5,12,25,6,45,53,36,38,193,194]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f,u,i,n,r,o,a,l,s,h,T,F,Z,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ce;(function(ue){function L(N,H){if(N===H)return!0;const ee=Object.keys(N),ae=new Set;for(const ge of Object.keys(H))ae.add(ge);if(ee.length!==ae.size)return!1;for(const ge of ee){if(N[ge]!==H[ge])return!1;ae.delete(ge)}return ae.size===0}ue.equals=L})(ce=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let ie=class extends E.Disposable{constructor(L,N,H,ee,ae,ge,fe,R,U,W,Q,se){super(),this.systemExtensionsLocation=L,this.userExtensionsLocation=N,this.l=H,this.m=ee,this.n=ae,this.p=ge,this.r=fe,this.s=R,this.t=U,this.u=W,this.v=Q,this.w=se,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance($,(0,p.joinPath)(this.m,u.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance($,(0,p.joinPath)(this.m,u.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(J,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(L,N,H){const[ee,ae]=await Promise.all([this.scanSystemExtensions(L),this.scanUserExtensions(N)]),ge=H?await this.scanExtensionsUnderDevelopment(L,[...ee,...ae]):[];return this.D(ee,ae,ge,await this.getTargetPlatform(),!0)}async scanSystemExtensions(L){const N=[];N.push(this.F(!!L.useCache,L.language)),N.push(this.G(L.language,!!L.checkControlFile));const[H,ee]=await Promise.all(N);return this.C([...H,...ee],0,L,!1)}async scanUserExtensions(L){const N=L.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",N);const H=await this.I(N,!!L.profileLocation,1,!L.includeUninstalled,L.language);let ae=await(L.useCache&&!H.devMode&&H.excludeObsolete?this.j:this.k).scanExtensions(H);return ae=await this.C(ae,1,L,!0),this.s.trace("Scanned user extensions:",ae.length),ae}async scanExtensionsUnderDevelopment(L,N){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const H=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(ee=>ee.scheme===I.Schemas.file).map(async ee=>{const ae=await this.I(ee,!1,1,!0,L.language,!1);return(await this.k.scanOneOrMultipleExtensions(ae)).map(fe=>(fe.type=N.find(R=>(0,f.areSameExtensions)(R.identifier,fe.identifier))?.type??fe.type,this.k.validate(fe,ae)))}))).flat();return this.C(H,"development",L,!0)}return[]}async scanExistingExtension(L,N,H){const ee=await this.I(L,!1,N,!0,H.language),ae=await this.k.scanExtension(ee);return!ae||!H.includeInvalid&&!ae.isValid?null:ae}async scanOneOrMultipleExtensions(L,N,H){const ee=await this.I(L,!1,N,!0,H.language),ae=await this.k.scanOneOrMultipleExtensions(ee);return this.C(ae,N,H,!0)}async scanMetadata(L){const N=(0,p.joinPath)(L,"package.json"),H=(await this.r.readFile(N)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(L,N){const H=(0,p.joinPath)(L,"package.json"),ee=(await this.r.readFile(H)).value.toString(),ae=JSON.parse(ee);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,ae.__metadata={...ae.__metadata,...N},await this.r.writeFile((0,p.joinPath)(L,"package.json"),S.VSBuffer.fromString(JSON.stringify(ae,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const L=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(L))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const N=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(N.map(H=>[H,H.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(L,S.VSBuffer.fromString(""))}catch(N){(0,n.toFileOperationResult)(N)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(N))}}catch(L){throw this.s.error(L),L}})()),this.z}async C(L,N,H,ee){return H.includeAllVersions||(L=this.D(N===0?L:void 0,N===1?L:void 0,N==="development"?L:void 0,await this.getTargetPlatform(),ee)),H.includeInvalid||(L=L.filter(ae=>ae.isValid)),L.sort((ae,ge)=>{const fe=k.basename(ae.location.fsPath),R=k.basename(ge.location.fsPath);return fe<R?-1:fe>R?1:0})}D(L,N,H,ee,ae){const ge=(R,U,W)=>{if(R.isValid&&!U.isValid)return!1;if(R.isValid===U.isValid){if(ae&&m.gt(R.manifest.version,U.manifest.version))return this.s.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${R.location.path} with version ${R.manifest.version}`),!1;if(m.eq(R.manifest.version,U.manifest.version)){if(R.type===0)return this.s.debug(`Skipping extension ${U.location.path} in favour of system extension ${R.location.path} with same version`),!1;if(R.targetPlatform===ee)return this.s.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${R.location.path} with ${U.location.path}.`):this.s.debug(`Overwriting user extension ${R.location.path} with ${U.location.path}.`),!0},fe=new Map;return L?.forEach(R=>{const U=u.ExtensionIdentifier.toKey(R.identifier.id),W=fe.get(U);(!W||ge(W,R,!1))&&fe.set(U,R)}),N?.forEach(R=>{const U=u.ExtensionIdentifier.toKey(R.identifier.id),W=fe.get(U);if(!W&&L&&R.type===0){this.s.debug(`Skipping obsolete system extension ${R.location.path}.`);return}(!W||ge(W,R,!1))&&fe.set(U,R)}),H?.forEach(R=>{const U=u.ExtensionIdentifier.toKey(R.identifier.id),W=fe.get(U);(!W||ge(W,R,!0))&&fe.set(U,R),fe.set(U,R)}),[...fe.values()]}async F(L,N){this.s.trace("Started scanning system extensions");const H=await this.I(this.systemExtensionsLocation,!1,0,!0,N),ae=await(L&&!H.devMode?this.i:this.k).scanExtensions(H);return this.s.trace("Scanned system extensions:",ae.length),ae}async G(L,N){const H=this.t.isBuilt?[]:this.u.builtInExtensions;if(!H?.length)return[];this.s.trace("Started scanning dev system extensions");const ee=N?await this.H():{},ae=[],ge=d.URI.file(k.normalize(k.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const R of H){const U=ee[R.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":ae.push((0,p.joinPath)(ge,R.name));break;default:ae.push(d.URI.file(U));break}}const fe=await Promise.all(ae.map(async R=>this.k.scanExtension(await this.I(R,!1,0,!0,L))));return this.s.trace("Scanned dev system extensions:",fe.length),(0,v.coalesce)(fe)}async H(){try{const L=await this.r.readFile(this.l);return JSON.parse(L.value.toString())}catch{return{}}}async I(L,N,H,ee,ae,ge=!0){const fe=await this.f(ae??C.language),R=await this.J(L),U=N&&!this.v.extUri.isEqual(L,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,W=U?await this.J(U):void 0;return new M(L,R,U,W,N,H,ee,ge,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ae,fe)}async J(L){try{const N=await this.r.stat(L);if(typeof N.mtime=="number")return N.mtime}catch{}}};ie=Le([Oe(4,T.IUserDataProfilesService),Oe(5,h.IExtensionsProfileScannerService),Oe(6,n.IFileService),Oe(7,o.ILogService),Oe(8,c.IEnvironmentService),Oe(9,a.IProductService),Oe(10,F.IUriIdentityService),Oe(11,r.IInstantiationService)],ie),e.AbstractExtensionsScannerService=ie;class M{constructor(L,N,H,ee,ae,ge,fe,R,U,W,Q,se,de,z){this.location=L,this.mtime=N,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=ee,this.profile=ae,this.type=ge,this.excludeObsolete=fe,this.validate=R,this.productVersion=U,this.productDate=W,this.productCommit=Q,this.devMode=se,this.language=de,this.translations=z}static createNlsConfiguration(L){return{language:L.language,pseudo:L.language==="pseudo",devMode:L.devMode,translations:L.translations}}static equals(L,N){return(0,p.isEqual)(L.location,N.location)&&L.mtime===N.mtime&&(0,p.isEqual)(L.applicationExtensionslocation,N.applicationExtensionslocation)&&L.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&L.profile===N.profile&&L.type===N.type&&L.excludeObsolete===N.excludeObsolete&&L.validate===N.validate&&L.productVersion===N.productVersion&&L.productDate===N.productDate&&L.productCommit===N.productCommit&&L.devMode===N.devMode&&L.language===N.language&&ce.equals(L.translations,N.translations)}}let J=class extends E.Disposable{constructor(L,N,H,ee,ae){super(),this.f=L,this.g=N,this.h=H,this.i=ee,this.j=ae}async scanExtensions(L){const N=L.profile?await this.l(L):await this.k(L);let H={};if(L.excludeObsolete&&L.type===1)try{const ee=(await this.i.readFile(this.f)).value.toString();H=JSON.parse(ee)}catch{}return(0,w.isEmptyObject)(H)?N:N.filter(ee=>!H[f.ExtensionKey.create(ee).toString()])}async k(L){const N=await this.i.resolve(L.location);if(!N.children?.length)return[];const H=await Promise.all(N.children.map(async ee=>{if(!ee.isDirectory||L.type===1&&(0,p.basename)(ee.resource).indexOf(".")===0)return null;const ae=new M(ee.resource,L.mtime,L.applicationExtensionslocation,L.applicationExtensionslocationMtime,L.profile,L.type,L.excludeObsolete,L.validate,L.productVersion,L.productDate,L.productCommit,L.devMode,L.language,L.translations);return this.scanExtension(ae)}));return(0,v.coalesce)(H).sort((ee,ae)=>ee.location.path<ae.location.path?-1:1)}async l(L){let N=await this.m(L.location,()=>!0,L);if(L.applicationExtensionslocation&&!this.h.extUri.isEqual(L.location,L.applicationExtensionslocation)){N=N.filter(ee=>!ee.metadata?.isApplicationScoped);const H=await this.m(L.applicationExtensionslocation,ee=>!!ee.metadata?.isApplicationScoped,L);N.push(...H)}return N}async m(L,N,H){const ee=await this.g.scanProfileExtensions(L);if(!ee.length)return[];const ae=await Promise.all(ee.map(async ge=>{if(N(ge)){const fe=new M(ge.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(fe,ge.metadata)}return null}));return(0,v.coalesce)(ae)}async scanOneOrMultipleExtensions(L){try{if(await this.i.exists((0,p.joinPath)(L.location,"package.json"))){const N=await this.scanExtension(L);return N?[N]:[]}else return await this.scanExtensions(L)}catch(N){return this.j.error(`Error scanning extensions at ${L.location.path}:`,(0,D.getErrorMessage)(N)),[]}}async scanExtension(L,N){try{let H=await this.scanExtensionManifest(L.location);if(H){H.publisher||(H.publisher=u.UNDEFINED_PUBLISHER),N=N??H.__metadata,delete H.__metadata;const ee=(0,f.getGalleryExtensionId)(H.publisher,H.name),ae=N?.id?{id:ee,uuid:N.id}:{id:ee},ge=N?.isSystem?0:L.type,fe=ge===0||!!N?.isBuiltin;ne.ImplicitActivationEvents.updateManifest(H),H=await this.n(L.location,H,M.createNlsConfiguration(L));const R={type:ge,identifier:ae,manifest:H,location:L.location,isBuiltin:fe,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return L.validate?this.validate(R,L):R}}catch(H){L.type!==0&&this.j.error(H)}return null}validate(L,N){let H=!0;const ee=(0,i.validateExtensionManifest)(N.productVersion,N.productDate,N.location,L.manifest,L.isBuiltin);for(const[ae,ge]of ee)ae===g.default.Error&&(H=!1,this.j.error(this.t(N.location,ge)));return L.isValid=H,L.validations=ee,L}async scanExtensionManifest(L){const N=(0,p.joinPath)(L,"package.json");let H;try{H=(await this.i.readFile(N)).value.toString()}catch(ae){return(0,n.toFileOperationResult)(ae)!==1&&this.j.error(this.t(L,(0,b.localize)(0,null,N.path,ae.message))),null}let ee;try{ee=JSON.parse(H)}catch{const ge=[];(0,A.parse)(H,ge);for(const fe of ge)this.j.error(this.t(L,(0,b.localize)(1,null,N.path,fe.offset,fe.length,(0,y.getParseErrorMessage)(fe.error))));return null}return(0,A.getNodeType)(ee)!=="object"?(this.j.error(this.t(L,(0,b.localize)(2,null,N.path))),null):ee}async n(L,N,H){const ee=await this.p(L,N,H);if(ee)try{const ae=[],ge=await this.r(ee.default,ae);if(ae.length>0)return ae.forEach(R=>{this.j.error(this.t(L,(0,b.localize)(3,null,ee.default?.path,(0,y.getParseErrorMessage)(R.error))))}),N;if((0,A.getNodeType)(ee)!=="object")return this.j.error(this.t(L,(0,b.localize)(4,null,ee.default?.path))),N;const fe=ee.values||Object.create(null);return(0,Z.localizeManifest)(N,fe,ge)}catch{}return N}async p(L,N,H){const ee=(0,p.joinPath)(L,"package.nls.json"),ae=(U,W)=>{W.forEach(Q=>{this.j.error(this.t(L,(0,b.localize)(5,null,U?.path,(0,y.getParseErrorMessage)(Q.error))))})},ge=U=>{this.j.error(this.t(L,(0,b.localize)(6,null,U?.path)))},fe=`${N.publisher}.${N.name}`,R=H.translations[fe];if(R)try{const U=d.URI.file(R),W=(await this.i.readFile(U)).value.toString(),Q=[],se=(0,A.parse)(W,Q);return Q.length>0?(ae(U,Q),{values:void 0,default:ee}):(0,A.getNodeType)(se)!=="object"?(ge(U),{values:void 0,default:ee}):{values:se.contents?se.contents.package:void 0,default:ee}}catch{return{values:void 0,default:ee}}else{if(!await this.i.exists(ee))return;let W;try{W=await this.s(L,H)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const Q=(await this.i.readFile(W.localized)).value.toString(),se=[],de=(0,A.parse)(Q,se);return se.length>0?(ae(W.localized,se),{values:void 0,default:W.original}):(0,A.getNodeType)(de)!=="object"?(ge(W.localized),{values:void 0,default:W.original}):{values:de,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(L,N){if(L)try{const H=(await this.i.readFile(L)).value.toString();return(0,A.parse)(H,N)}catch{}}s(L,N){return new Promise((H,ee)=>{const ae=ge=>{const fe=(0,p.joinPath)(L,`package.nls.${ge}.json`);this.i.exists(fe).then(R=>{R&&H({localized:fe,original:(0,p.joinPath)(L,"package.nls.json")});const U=ge.lastIndexOf("-");U===-1?H({localized:(0,p.joinPath)(L,"package.nls.json"),original:null}):(ge=ge.substring(0,U),ae(ge))})};if(N.devMode||N.pseudo||!N.language)return H({localized:(0,p.joinPath)(L,"package.nls.json"),original:null});ae(N.language)})}t(L,N){return`[${L.path}]: ${N}`}};J=Le([Oe(1,h.IExtensionsProfileScannerService),Oe(2,F.IUriIdentityService),Oe(3,n.IFileService),Oe(4,o.ILogService)],J);let $=class extends J{constructor(L,N,H,ee,ae,ge){super(N,H,ee,ae,ge),this.y=L,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(L){const N=await this.z();if(this.u=L,N&&N.input&&M.equals(N.input,this.u))return this.v.trigger(()=>this.D()),N.result.map(ee=>(ee.location=d.URI.revive(ee.location),ee));const H=await super.scanExtensions(L);return await this.C({input:L,result:H}),H}async z(){try{const L=await this.i.readFile(this.y),N=JSON.parse(L.value.toString());return{result:N.result,input:(0,s.revive)(N.input)}}catch(L){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(L))}return null}async C(L){try{await this.i.writeFile(this.y,S.VSBuffer.fromString(JSON.stringify(L)))}catch(N){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(N))}}async D(){if(!this.u)return;const L=await this.z();if(!L)return;const N=L.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!P.equals(H,N))try{await this.i.del(this.y),this.w.fire()}catch(ee){this.j.error(ee)}}};$=Le([Oe(2,h.IExtensionsProfileScannerService),Oe(3,F.IUriIdentityService),Oe(4,n.IFileService),Oe(5,o.ILogService)],$);function V(ue,L){const N=(0,f.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:N,identifier:new u.ExtensionIdentifier(N),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:L,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=V;class X extends ie{constructor(L,N,H,ee,ae,ge,fe,R,U,W,Q,se){super(L,N,(0,p.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,p.joinPath)(ee,u.MANIFEST_CACHE_FOLDER),ae,ge,fe,R,U,W,Q,se),this.L=(async()=>{if(C.translationsConfigFile)try{const de=await this.r.readFile(d.URI.file(C.translationsConfigFile));return JSON.parse(de.value.toString())}catch{}return Object.create(null)})()}f(L){return this.L}}e.NativeExtensionsScannerService=X}),define(be[241],ve([1,0,47,14,39,6,2,13,7,22,12,36]),function(re,e,v,t,P,S,D,A,y,E,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let C=class extends D.Disposable{constructor(m,g){super(),this.b=m,this.f=g,this.a=new t.Limiter(5)}async postUninstall(m){const g=this.g(m,"uninstall");return g&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(g.script,"uninstall",g.args,!0,m).then(()=>this.f.info(m.identifier.id,m.manifest.version,"Finished running post uninstall script"),w=>this.f.error(m.identifier.id,m.manifest.version,`Failed to run post uninstall script: ${w}`)))),E.Promises.rm(this.j(m)).then(void 0,w=>this.f.error("Error while removing extension storage path",w))}g(m,g){const w=`vscode:${g}`;if(m.location.scheme===A.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[w]=="string"){const d=m.manifest.scripts[w].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${w} should be a node script`),null):{script:(0,y.join)(m.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(m,g,w,d,b){return new Promise((c,f)=>{const u=this.i(m,g,w,b);let i;const n=r=>{i&&(clearTimeout(i),i=null),r?f(r):c(void 0)};u.on("error",r=>{n((0,P.toErrorMessage)(r)||"Unknown")}),u.on("exit",(r,o)=>{n(r?`post-${g} process exited with code ${r}`:void 0)}),d&&(i=setTimeout(()=>{i=null,u.kill(),f("timed out")},5e3))})}i(m,g,w,d){const b={silent:!0,execArgv:void 0},c=(0,v.fork)(m,[`--type=extension-post-${g}`,...w],b);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const f=S.Event.fromNodeEventEmitter(c.stdout,"data"),u=S.Event.fromNodeEventEmitter(c.stderr,"data");f(r=>this.f.info(d.identifier.id,d.manifest.version,`post-${g}`,r)),u(r=>this.f.error(d.identifier.id,d.manifest.version,`post-${g}`,r));const i=S.Event.any(S.Event.map(f,r=>({data:`%c${r}`,format:[""]})),S.Event.map(u,r=>({data:`%c${r}`,format:["color: red"]})));return S.Event.debounce(i,(r,o)=>r?{data:r.data+o.data,format:[...r.format,...o.format]}:{data:o.data,format:o.format},100)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),c}j(m){return(0,y.join)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};C=Le([Oe(0,k.IUserDataProfilesService),Oe(1,I.ILogService)],C),e.ExtensionsLifecycle=C}),define(be[242],ve([1,0,14,6,2,46,9,151,5,36]),function(re,e,v,t,P,S,D,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,y.createDecorator)("storageService");var I;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(b){b[b.APPLICATION=-1]="APPLICATION",b[b.PROFILE=0]="PROFILE",b[b.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var C;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));function p(b){const c=b.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=p;class m extends P.Disposable{constructor(c={flushInterval:m.a}){super(),this.j=c,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new v.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new P.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,v.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,P.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,S.mark)("code/willInitStorage");try{await this.J()}finally{(0,S.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(c,f){if(f===e.TARGET_KEY){switch(c){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:f,target:this.F(c)[f]})}r(c){this.f.fire({reason:c})}get(c,f,u){return this.L(f)?.get(c,u)}getBoolean(c,f,u){return this.L(f)?.getBoolean(c,u)}getNumber(c,f,u){return this.L(f)?.getNumber(c,u)}store(c,f,u,i){if((0,D.isUndefinedOrNull)(f)){this.remove(c,u);return}this.t(()=>{this.u(c,u,i),this.L(u)?.set(c,f)})}remove(c,f){this.t(()=>{this.u(c,f,void 0),this.L(f)?.delete(c)})}t(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,f){const u=[],i=this.F(c);for(const n of Object.keys(i))i[n]===f&&u.push(n);return u}u(c,f,u){const i=this.F(f);typeof u=="number"?i[c]!==u&&(i[c]=u,this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[c]=="number"&&(delete i[c],this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(c){switch(c){case-1:return this.D;case 0:return this.z;default:return this.w}}G(c){const f=this.L(c);return f?p(f):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=I.NONE){this.f.fire({reason:c});const f=this.L(-1),u=this.L(0),i=this.L(1);switch(c){case I.NONE:await v.Promises.settled([f?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([f?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.L(-1)?.items??new Map,f=this.L(0)?.items??new Map,u=this.L(1)?.items??new Map;return d(c,f,u,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(c,f){return this.r(I.NONE),(0,E.isUserDataProfile)(c)?this.N(c,f):this.O(c,f)}H(c,f){return!(c.id===f.id||g(f)&&g(c))}I(c,f,u,i){this.t(()=>{if(i)for(const[n,r]of c)f.set(n,r);else{const n=new Set;for(const[r,o]of c)n.add(r),f.get(r)!==o&&this.n(u,r);for(const[r]of f.items)n.has(r)||this.n(u,r)}})}}e.AbstractStorageService=m,m.a=60*1e3;function g(b){return b.isDefault||!!b.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class w extends m{constructor(){super(),this.p=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(c=>this.n(1,c))),this.B(this.P.onDidChangeStorage(c=>this.n(0,c))),this.B(this.p.onDidChangeStorage(c=>this.n(-1,c)))}L(c){switch(c){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(c){return!1}}e.InMemoryStorageService=w;async function d(b,c,f,u,i,n){const r=ne=>{try{return JSON.parse(ne)}catch{return ne}},o=new Map,a=new Map;b.forEach((ne,ce)=>{o.set(ce,ne),a.set(ce,r(ne))});const l=new Map,s=new Map;c.forEach((ne,ce)=>{l.set(ce,ne),s.set(ce,r(ne))});const h=new Map,T=new Map;f.forEach((ne,ce)=>{h.set(ce,ne),T.set(ce,r(ne))}),console.group(u!==i?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const F=[];if(o.forEach((ne,ce)=>{F.push({key:ce,value:ne})}),console.table(F),console.groupEnd(),console.log(a),u!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const ne=[];l.forEach((ce,ie)=>{ne.push({key:ie,value:ce})}),console.table(ne),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${n})`);const Z=[];h.forEach((ne,ce)=>{Z.push({key:ce,value:ne})}),console.table(Z),console.groupEnd(),console.log(T)}e.logStorage=d}),define(be[117],ve([1,0,18,19,8,3,27,9,4,24,30,31,33,73,17,12,25,52,225,242,34]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=S.isWeb?"web":(0,k.getTargetPlatform)(S.platform,D.arch);var i;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...R){return String(R.reduce((U,W)=>U|W,0))}var r;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class h{constructor(U=s){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,W=this.d.pageSize){return new h({...this.d,pageNumber:U,pageSize:W})}withFilter(U,...W){const Q=[...this.d.criteria,...W.length?W.map(se=>({filterType:U,value:se})):[{filterType:U}]];return new h({...this.d,criteria:Q})}withSortBy(U){return new h({...this.d,sortBy:U})}withSortOrder(U){return new h({...this.d,sortOrder:U})}withFlags(...U){return new h({...this.d,flags:U.reduce((W,Q)=>W|Q,0)})}withAssetTypes(...U){return new h({...this.d,assetTypes:U})}withSource(U){return new h({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:W,pageSize:Q,sortBy:se,sortOrder:de,flags:z,assetTypes:Y}=this.d;return{filters:[{criteria:U,pageNumber:W,pageSize:Q,sortBy:se,sortOrder:de}],assetTypes:Y,flags:z}}get searchText(){const U=this.d.criteria.filter(W=>W.filterType===r.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function T(R,U){const W=(R||[]).filter(Q=>Q.statisticName===U)[0];return W?W.value:0}function F(R){const U="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(Q=>Q.assetType.indexOf(U)===0).reduce((Q,se)=>{const de=ce(R,se.assetType);return de&&Q.push([se.assetType.substring(U.length),de]),Q},[])}function Z(R){if(R.properties){const U=R.properties.filter(se=>se.key===o.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=U.filter(se=>W.test(se.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return ce(R,o.Repository)}function ne(R){return{uri:`${R.fallbackAssetUri}/${o.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${o.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function ce(R,U){return R.files.filter(Q=>Q.assetType===U)[0]?{uri:`${R.assetUri}/${U}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${U}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ie(R,U){const W=R.properties?R.properties.filter(se=>se.key===U):[],Q=W.length>0&&W[0].value;return Q?Q.split(",").map(se=>(0,C.adoptToGalleryExtensionId)(se)):[]}function M(R){const U=R.properties?R.properties.filter(W=>W.key===a.Engine):[];return U.length>0&&U[0].value||""}function J(R){const U=R.properties?R.properties.filter(W=>W.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function $(R){const U=R.properties?R.properties.filter(Q=>Q.key===a.LocalizedLanguages):[],W=U.length>0&&U[0].value||"";return W?W.split(","):[]}function V(R){return R.properties?.find(U=>U.key===a.SponsorLink)?.value}function X(R){return R.indexOf("preview")!==-1}function ue(R){return R.targetPlatform?(0,k.toTargetPlatform)(R.targetPlatform):"undefined"}function L(R){const U=(0,v.distinct)(R.versions.map(ue)),W=!!R.tags?.includes(k.WEB_EXTENSION_TAG),Q=U.indexOf("web");return W?Q===-1&&U.push("web"):Q!==-1&&U.splice(Q,1),U}function N(R,U){const W=(0,k.getFallbackTargetPlarforms)(U);for(let Q=0;Q<R.length;Q++){const se=R[Q];if(se.version===R[Q-1]?.version){let de=Q;const z=ue(se);if(z===U)for(;de>0&&R[de-1].version===se.version;)de--;else if(W.includes(z))for(;de>0&&R[de-1].version===se.version&&ue(R[de-1])!==U;)de--;de!==Q&&(R.splice(Q,1),R.splice(de,0,se))}}return R}e.sortExtensionVersions=N;function H(R,U,W){R.telemetryData={index:U,querySource:W}}function ee(R,U,W){const Q=R.versions[0],se={manifest:ce(U,o.Manifest),readme:ce(U,o.Details),changelog:ce(U,o.Changelog),license:ce(U,o.License),repository:Z(U),download:ne(U),icon:ce(U,o.Icon),signature:ce(U,o.Signature),coreTranslations:F(U)};return{identifier:{id:(0,C.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:U.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(Q),description:R.shortDescription||"",installCount:T(R.statistics,"install"),rating:T(R.statistics,"averagerating"),ratingCount:T(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:W,assets:se,properties:{dependencies:ie(U,a.Dependency),extensionPack:ie(U,a.ExtensionPack),engine:M(U),localizedLanguages:$(U),targetPlatform:ue(U),isPreReleaseVersion:J(U)},hasPreReleaseVersion:J(Q),hasReleaseVersion:!0,preview:X(R.flags),isSigned:!!se.signature}}let ae=class{constructor(U,W,Q,se,de,z,Y,_){this.k=W,this.l=Q,this.n=se,this.o=de,this.q=z,this.u=Y,this.w=_;const j=Y.extensionsGallery,q=j?.servicePPEUrl&&_.getValue("_extensionsGallery.enablePPE");this.d=q?j.servicePPEUrl:j?.serviceUrl,this.g=q?void 0:j?.searchUrl,this.h=j?.controlUrl,this.j=(0,b.resolveMarketplaceHeaders)(Y.version,Y,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,W,Q){const se=t.CancellationToken.isCancellationToken(W)?{}:W,de=t.CancellationToken.isCancellationToken(W)?W:Q,z=[],Y=[],_=[],j=[];let q=!0;for(const oe of U){oe.uuid?Y.push(oe.uuid):z.push(oe.id);const pe=!!(oe.version||oe.preRelease);_.push({id:oe.id,uuid:oe.uuid,includePreRelease:pe}),oe.version&&j.push({id:oe.id,uuid:oe.uuid,version:oe.version}),q=q&&!!oe.hasPreRelease&&!pe}if(!Y.length&&!z.length)return[];let G=new h().withPage(1,U.length);Y.length&&(G=G.withFilter(r.ExtensionId,...Y)),z.length&&(G=G.withFilter(r.ExtensionName,...z)),(se.queryAllVersions||q)&&(G=G.withFlags(G.flags,i.IncludeVersions)),se.source&&(G=G.withSource(se.source));const{extensions:x}=await this.z(G,{targetPlatform:se.targetPlatform??u,includePreRelease:_,versions:j,compatible:!!se.compatible},de);return se.source&&x.forEach((oe,pe)=>H(oe,pe,se.source)),x}async getCompatibleExtension(U,W,Q){if((0,k.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(U,W,Q))return U;const se=new h().withFlags(i.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,U.identifier.uuid),{extensions:de}=await this.z(se,{targetPlatform:Q,compatible:!0,includePreRelease:W},t.CancellationToken.None);return de[0]||null}async isExtensionCompatible(U,W,Q){if(!(0,k.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,Q)||!W&&U.properties.isPreReleaseVersion)return!1;let se=U.properties.engine;if(!se){const de=await this.getManifest(U,t.CancellationToken.None);if(!de)throw new Error("Manifest was not found");se=de.engines.vscode}return(0,p.isEngineValid)(se,this.u.version,this.u.date)}async y(U,W,Q,se,de){if(!(0,k.isTargetPlatformCompatible)(ue(U),se,de)||W!=="any"&&J(U)!==(W==="prerelease"))return!1;if(Q)try{const z=await this.E(U);if(!(0,p.isEngineValid)(z,this.u.version,this.u.date))return!1}catch(z){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,P.getErrorMessage)(z)),!1}return!0}async query(U,W){let Q=U.text||"";const se=U.pageSize??50;let de=new h().withPage(1,se);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(q,G,x)=>(de=de.withFilter(r.Category,x||G),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(q,G,x)=>(de=de.withFilter(r.Tag,x||G),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(r.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),de=de.withFilter(r.SearchText,Q)),de=de.withSortBy(0)):U.ids?de=de.withFilter(r.ExtensionId,...U.ids):U.names?de=de.withFilter(r.ExtensionName,...U.names):de=de.withSortBy(4),typeof U.sortBy=="number"&&(de=de.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(de=de.withSortOrder(U.sortOrder)),U.source&&(de=de.withSource(U.source));const z=async(q,G)=>{const{extensions:x,total:oe}=await this.z(q,{targetPlatform:u,compatible:!1,includePreRelease:!!U.includePreRelease},G);return x.forEach((pe,ke)=>H(pe,(q.pageNumber-1)*q.pageSize+ke,U.source)),{extensions:x,total:oe}},{extensions:Y,total:_}=await z(de,W),j=async(q,G)=>{if(G.isCancellationRequested)throw new P.CancellationError;const{extensions:x}=await z(de.withPage(q+1),G);return x};return{firstPage:Y,total:_,pageSize:de.pageSize,getPage:j}}async z(U,W,Q){const se=U.flags;!!(U.flags&i.IncludeLatestVersionOnly)&&!!(U.flags&i.IncludeVersions)&&(U=U.withFlags(U.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(U.flags&i.IncludeLatestVersionOnly)&&!(U.flags&i.IncludeVersions)&&(U=U.withFlags(U.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(U=U.withFlags(U.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),U=U.withFlags(U.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:de,total:z}=await this.B(U,Q);if(!(U.flags&i.IncludeLatestVersionOnly)){const q=[];for(const G of de){const x=await this.A(G,W);x&&q.push(x)}return{extensions:q,total:z}}const _=[],j=new Map;for(let q=0;q<de.length;q++){const G=de[q],x={id:(0,C.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},oe=(0,A.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(ke=>(0,C.areSameExtensions)(ke,x))?.includePreRelease;if(W.compatible&&(0,k.isNotWebExtensionInWebTargetPlatform)(L(G),W.targetPlatform))continue;const pe=await this.A(G,W);!pe||pe.properties.isPreReleaseVersion&&(!oe||!pe.hasReleaseVersion)||!pe.properties.isPreReleaseVersion&&pe.properties.targetPlatform!==W.targetPlatform&&pe.hasPreReleaseVersion?j.set(G.extensionId,q):_.push([q,pe])}if(j.size){const q=new Date().getTime(),G=new h().withFlags(se&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,j.size).withFilter(r.ExtensionId,...j.keys()),{extensions:x}=await this.z(G,W,Q);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-q,count:j.size});for(const oe of x){const pe=j.get(oe.identifier.uuid);_.push([pe,oe])}}return{extensions:_.sort((q,G)=>q[0]-G[0]).map(([,q])=>q),total:z}}async A(U,W){const Q={id:(0,C.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},se=W.versions?.find(_=>(0,C.areSameExtensions)(_,Q))?.version,de=(0,A.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(_=>(0,C.areSameExtensions)(_,Q))?.includePreRelease,z=L(U),Y=N(U.versions,W.targetPlatform);if(W.compatible&&(0,k.isNotWebExtensionInWebTargetPlatform)(z,W.targetPlatform))return null;for(let _=0;_<Y.length;_++){const j=Y[_];if(!(se&&j.version!==se)){if(await this.y(j,de?"any":"release",W.compatible,z,W.targetPlatform))return ee(U,j,z);if(se&&j.version===se)return null}}return se||W.compatible?null:ee(U,U.versions[0],z)}async B(U,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,i.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(i.Unpublished));const Q=await this.j,se=JSON.stringify(U.raw),de={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},z=new Date().getTime();let Y,_,j=0;try{if(Y=await this.k.request({type:"POST",url:this.g&&U.criteria.some(G=>G.filterType===r.SearchText)?this.g:this.x("/extensionquery"),data:se,headers:de},W),Y.res.statusCode&&Y.res.statusCode>=400&&Y.res.statusCode<500)return{galleryExtensions:[],total:j};const q=await(0,d.asJson)(Y);if(q){const G=q.results[0],x=G.extensions,oe=G.resultMetadata&&G.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return j=oe&&oe.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:x,total:j}}return{galleryExtensions:[],total:j}}catch(q){throw _=q,q}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(se.length),duration:new Date().getTime()-z,success:!!Y&&(0,d.isSuccess)(Y),responseBodySize:Y?.res.headers["Content-Length"],statusCode:Y?String(Y.res.statusCode):void 0,errorCode:_?(0,P.isCancellationError)(_)?"canceled":(0,P.getErrorMessage)(_).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(U,W,Q,se){if(!this.isEnabled())return;const de=S.isWeb?this.x(`/itemName/${U}.${W}/version/${Q}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${W}/${Q}/stats?statType=${se}`),z=S.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",_={...await this.j,Accept:z};try{await this.k.request({type:"POST",url:de,headers:_},t.CancellationToken.None)}catch{}}async download(U,W,Q){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const se=(0,C.getGalleryExtensionTelemetryData)(U),de=new Date().getTime(),z=q=>this.o.publicLog("galleryService:downloadVSIX",{...se,duration:q}),Y=Q===2?"install":Q===3?"update":"",_=Y?{uri:`${U.assets.download.uri}${y.URI.parse(U.assets.download.uri).query?"&":"?"}${Y}=true`,fallbackUri:`${U.assets.download.fallbackUri}${y.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${Y}=true`}:U.assets.download,j=await this.D(_);await this.q.writeFile(W,j.stream),z(new Date().getTime()-de)}async downloadSignatureArchive(U,W){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const Q=await this.D(U.assets.signature);await this.q.writeFile(W,Q.stream)}async getReadme(U,W){if(U.assets.readme){const Q=await this.D(U.assets.readme,{},W);return await(0,d.asTextOrError)(Q)||""}return""}async getManifest(U,W){if(U.assets.manifest){const Q=await this.D(U.assets.manifest,{},W),se=await(0,d.asTextOrError)(Q);return se?JSON.parse(se):null}return null}async C(U,W){const Q=ce(U,o.Manifest);if(!Q)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},de=await this.D(Q,{headers:se});return await(0,d.asJson)(de)}async getCoreTranslation(U,W){const Q=U.assets.coreTranslations.filter(se=>se[0]===W.toUpperCase())[0];if(Q){const se=await this.D(Q[1]),de=await(0,d.asTextOrError)(se);return de?JSON.parse(de):null}return null}async getChangelog(U,W){if(U.assets.changelog){const Q=await this.D(U.assets.changelog,{},W);return await(0,d.asTextOrError)(Q)||""}return""}async getAllCompatibleVersions(U,W,Q){let se=new h().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?se=se.withFilter(r.ExtensionId,U.identifier.uuid):se=se.withFilter(r.ExtensionName,U.identifier.id);const{galleryExtensions:de}=await this.B(se,t.CancellationToken.None);if(!de.length)return[];const z=L(de[0]);if((0,k.isNotWebExtensionInWebTargetPlatform)(z,Q))return[];const Y=[];await Promise.all(de[0].versions.map(async q=>{try{await this.y(q,W?"any":"release",!0,z,Q)&&Y.push(q)}catch{}}));const _=[],j=new Set;for(const q of N(Y,Q))j.has(q.version)||(j.add(q.version),_.push({version:q.version,date:q.lastUpdated,isPreReleaseVersion:J(q)}));return _}async D(U,W={},Q=t.CancellationToken.None){const se=await this.j,de={type:"GET"},z={...se,...W.headers||{}};W={...W,...de,headers:z};const Y=U.uri,_=U.fallbackUri,j={...W,url:Y};try{const q=await this.k.request(j,Q);if(q.res.statusCode===200)return q;const G=await(0,d.asTextOrError)(q);throw new Error(`Expected 200, got back ${q.res.statusCode} instead.

${G}`)}catch(q){if((0,P.isCancellationError)(q))throw q;const G=(0,P.getErrorMessage)(q);this.o.publicLog2("galleryService:cdnFallback",{url:Y,message:G});const x={...W,url:_};return this.k.request(x,Q)}}async E(U){let W=M(U);if(!W){const Q=await this.C(U,t.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");W=Q.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const U=await this.k.request({type:"GET",url:this.h},t.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,d.asJson)(U),Q=[],se={};if(W){for(const de of W.malicious)Q.push({id:de});if(W.migrateToPreRelease)for(const[de,z]of Object.entries(W.migrateToPreRelease))(!z.engine||(0,p.isEngineValid)(z.engine,this.u.version,this.u.date))&&(se[de.toLowerCase()]={disallowInstall:!0,extension:{id:z.id,displayName:z.displayName,autoMigrate:{storage:!!z.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[de,z]of Object.entries(W.deprecated))z&&(se[de.toLowerCase()]=(0,A.isBoolean)(z)?{}:z)}return{malicious:Q,deprecated:se}}};ae=Le([Oe(1,d.IRequestService),Oe(2,g.ILogService),Oe(3,I.IEnvironmentService),Oe(4,f.ITelemetryService),Oe(5,m.IFileService),Oe(6,w.IProductService),Oe(7,E.IConfigurationService)],ae);let ge=class extends ae{constructor(U,W,Q,se,de,z,Y,_){super(U,W,Q,se,de,z,Y,_)}};ge=Le([Oe(0,c.IStorageService),Oe(1,d.IRequestService),Oe(2,g.ILogService),Oe(3,I.IEnvironmentService),Oe(4,f.ITelemetryService),Oe(5,m.IFileService),Oe(6,w.IProductService),Oe(7,E.IConfigurationService)],ge),e.ExtensionGalleryService=ge;let fe=class extends ae{constructor(U,W,Q,se,de,z,Y){super(void 0,U,W,Q,se,de,z,Y)}};fe=Le([Oe(0,d.IRequestService),Oe(1,g.ILogService),Oe(2,I.IEnvironmentService),Oe(3,f.ITelemetryService),Oe(4,m.IFileService),Oe(5,w.IProductService),Oe(6,E.IConfigurationService)],fe),e.ExtensionGalleryServiceWithNoStorageService=fe}),define(be[118],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,v.createDecorator)("extensionHostStatusService");class t{constructor(){this.a=new Map}setExitInfo(S,D){this.a.set(S,D)}getExitInfo(S){return this.a.get(S)||null}}e.ExtensionHostStatusService=t}),define(be[243],ve([1,0,6,14]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function P(D){let A=0,y=0,E=0;D>=1e3&&(E=Math.floor(D/1e3),D-=E*1e3),E>=60&&(y=Math.floor(E/60),E-=y*60),y>=60&&(A=Math.floor(y/60),y-=A*60);const I=A?`${A}h`:"",k=y?`${y}m`:"",C=E?`${E}s`:"",p=D?`${D}ms`:"";return`${I}${k}${C}${p}`}class S{constructor(A,y,E,I){this.i=A,this.j=y,this.a=new v.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=E,this.protocol=I,this.e=!1,this.f=new t.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${P(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new t.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${P(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${P(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(A){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${A}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${P(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const A=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),A.end(),this.a.fire(void 0)}acceptReconnection(A,y,E){this.d=A,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(y,E),this.protocol.endAcceptReconnection()}}e.ManagementConnection=S}),define(be[82],ve([1,0,29,13,7,146,50]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const A=P.join(t.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),y=new Map;function E(m){return new Promise(g=>v.exists(m,g))}function I(m,g){return E(A).then(w=>{if(!w||!D.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const d=`${m}||${g}`;let b=y.get(d);return b||(b=S.getNLSConfiguration(D.default.commit,g,A,m).then(c=>(k.is(c)&&(c._languagePackSupport=!0),c.locale!=="en"&&c.locale!=="en-us"&&Object.keys(c.availableLanguages).length===0&&y.delete(d),c)),y.set(d,b)),b})}e.getNLSConfiguration=I;var k;(function(m){function g(w){const d=w;return d&&typeof d._languagePackId=="string"}m.is=g})(k=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const C=async m=>{try{const g=p(await v.promises.readFile(m,"utf8"));return JSON.parse(g).locale}catch(g){return g.code!=="ENOENT"&&console.warn(g),"en"}};e.getLocaleFromConfig=C;const p=m=>{const g=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return m.replace(g,(w,d,b,c,f)=>{if(c)return"";if(f){const u=f.length;return u>2&&f[u-1]===`
`?f[u-2]==="\r"?`\r
`:`
`:""}else return w})}}),define(be[119],ve([1,0,20,4,30,53,54,32,17,5,12,25,38,36,82]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends D.AbstractExtensionsScannerService{constructor(d,b,c,f,u,i,n,r){super(t.URI.file(u.builtinExtensionsPath),t.URI.file(u.extensionsPath),(0,v.joinPath)(u.userHome,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(t.URI.file(u.userDataPath),A.MANIFEST_CACHE_FOLDER),d,b,c,f,u,i,n,r),this.L=u}async f(d){const b=await(0,m.getNLSConfiguration)(d,this.L.userDataPath);if(m.InternalNLSConfiguration.is(b))try{const c=await this.r.readFile(t.URI.file(b._translationsConfigFile));return JSON.parse(c.value.toString())}catch{}return Object.create(null)}};g=Le([Oe(0,p.IUserDataProfilesService),Oe(1,S.IExtensionsProfileScannerService),Oe(2,y.IFileService),Oe(3,I.ILogService),Oe(4,P.INativeEnvironmentService),Oe(5,k.IProductService),Oe(6,C.IUriIdentityService),Oe(7,E.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(be[244],ve([1,0,245,29,7,21,13,22]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const y=/^[0-9A-Za-z_-]+$/;var E;(function(d){d[d.None=0]="None",d[d.Optional=1]="Optional",d[d.Mandatory=2]="Mandatory"})(E=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class I{constructor(){this.type=0}validate(b){return!0}}e.NoneServerConnectionToken=I;class k{constructor(b){this.value=b,this.type=1}validate(b){return b===this.value}}e.OptionalServerConnectionToken=k;class C{constructor(b){this.value=b,this.type=2}validate(b){return b===this.value}}e.MandatoryServerConnectionToken=C;class p{constructor(b){this.message=b}}e.ServerConnectionTokenParseError=p;async function m(d,b){const c=d["without-connection-token"],f=d["connection-token"],u=d["connection-token-file"],i=d.compatibility==="1.63";if(c)return typeof f<"u"||typeof u<"u"?new p("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new I;if(typeof u<"u"){if(typeof f<"u")return new p("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let n;try{n=t.readFileSync(u).toString().replace(/\r?\n$/,"")}catch{return new p(`Unable to read the connection token file at '${u}'.`)}return y.test(n)?new C(n):new p(`The connection token defined in '${u} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof f<"u"?y.test(f)?i?new k(f):new C(f):new p(`The connection token '${f} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`):i?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new k(await b())):new C(await b())}e.parseServerConnectionToken=m;async function g(d){return m(d,async()=>{if(!d["user-data-dir"])return(0,S.generateUuid)();const c=P.join(d["user-data-dir"],"token");try{const i=(await A.Promises.readFile(c)).toString().replace(/\r?\n$/,"");if(y.test(i))return i}catch{}const f=(0,S.generateUuid)();try{await A.Promises.writeFile(c,f,{mode:384})}catch{}return f})}e.determineServerConnectionToken=g;function w(d,b,c){if(d.validate(c.query[D.connectionTokenQueryName]))return!0;const f=v.parse(b.headers.cookie||"");return d.validate(f[D.connectionTokenCookieName])}e.requestHasValidConnectionToken=w}),define(be[40],ve([1,0,184,192,60,5,30]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:v.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:v.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:v.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:v.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:v.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:v.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:v.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:v.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:v.localize(8,null)},"user-data-dir":P.OPTIONS["user-data-dir"],"enable-smoke-test-driver":P.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":P.OPTIONS["disable-telemetry"],"disable-workspace-trust":P.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:P.OPTIONS.log,logsPath:P.OPTIONS.logsPath,"force-disable-user-env":P.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:v.localize(9,null)},"default-workspace":{type:"string",description:v.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":P.OPTIONS["extensions-dir"],"extensions-download-dir":P.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":P.OPTIONS["builtin-extensions-dir"],"install-extension":P.OPTIONS["install-extension"],"install-builtin-extension":P.OPTIONS["install-builtin-extension"],"uninstall-extension":P.OPTIONS["uninstall-extension"],"list-extensions":P.OPTIONS["list-extensions"],"locate-extension":P.OPTIONS["locate-extension"],"show-versions":P.OPTIONS["show-versions"],category:P.OPTIONS.category,force:P.OPTIONS.force,"do-not-sync":P.OPTIONS["do-not-sync"],"pre-release":P.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:v.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:P.OPTIONS.help,version:P.OPTIONS.version,"locate-shell-integration-path":P.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:P.OPTIONS._},e.IServerEnvironmentService=(0,S.refineServiceDecorator)(D.IEnvironmentService);class A extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=A}),define(be[246],ve([1,0,74,12,40,25,207,21,18]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let E=class extends D.BaseCredentialsMainService{constructor(k,C,p){super(k),this.k=C,this.l=p,this.k.args["github-auth"]&&this.n(this.k.args["github-auth"]).catch(m=>{this.g.error("Failed to store provided GitHub token",m)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.l.urlProtocol}-server`)}async h(){if(this.f)return this.f;if(this.k.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new v.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((k,C)=>{re(["keytar"],k,C)}),await this.f.findCredentials("test-keytar-loads")}catch(k){this.g.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${k.message??k}`),this.f=new v.InMemoryCredentialsProvider}return this.f}async n(k){const C="vscode.github-authentication",p=`${await this.getSecretStoragePrefix()}${C}`,m="github.auth",w=[["read:user","user:email","repo"]].map(c=>({id:(0,A.generateUuid)(),scopes:c.sort(),accessToken:k})),d=await this.getPassword(p,m);let b;if(d)try{const c=JSON.parse(d);c.content=JSON.parse(c.content),b=c}catch(c){this.g.error("Failed to parse existing GitHub credentials",c)}return b?.content&&(b.content=b.content.filter(c=>{const f=c.scopes.sort();return!w.find(u=>(0,y.equals)(f,u.scopes)&&u.account?.label===c.account?.label)})),this.setPassword(p,m,JSON.stringify({extensionId:C,...b||{},content:JSON.stringify([...w,...b?.content||[]])}))}};E=Le([Oe(0,t.ILogService),Oe(1,P.IServerEnvironmentService),Oe(2,S.IProductService)],E),e.CredentialsWebMainService=E}),define(be[247],ve([1,0,277,230,248,28]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class D extends v.AppInsightsCore{constructor(y){super(),this.a=y}track(y){const E=y.baseData||{};E.properties||(E.properties={}),E.measurements||(E.measurements={});try{const I=S.cpus();E.measurements.cores=I.length,E.properties["common.cpuModel"]=I[0].model}catch{}try{E.measurements.memoryFree=S.freemem(),E.measurements.memoryTotal=S.totalmem()}catch{}try{E.properties["common.shell"]=S.userInfo().shell,E.properties["common.release"]=S.release(),E.properties["common.arch"]=S.arch()}catch{}try{const I=(/^http:/.test(this.a)?P:t).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});I.on("error",()=>{}),I.write(JSON.stringify(E)),I.end()}catch{}}}e.TelemetryClient=D}),define(be[249],ve([1,0,29,91,79,245,112,37,56,3,12,40,7,13,21,25,52,19,4,16,9,82,65]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const n={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(ne,ce,ie,M){ce.writeHead(ie,{"Content-Type":"text/plain"}),ce.end(M)}e.serveError=r;var o;(function(ne){ne[ne.NO_CACHING=0]="NO_CACHING",ne[ne.ETAG=1]="ETAG",ne[ne.NO_EXPIRY=2]="NO_EXPIRY"})(o=e.CacheControl||(e.CacheControl={}));async function a(ne,ce,ie,M,J,$){try{const V=await v.promises.stat(ne);if(ce===1){const X=`W/"${[V.ino,V.size,V.mtime.getTime()].join("-")}"`;if(M.headers["if-none-match"]===X)return J.writeHead(304),void J.end();$.Etag=X}else ce===2?$["Cache-Control"]="public, max-age=31536000":ce===0&&($["Cache-Control"]="no-store");$["Content-Type"]=n[(0,C.extname)(ne)]||(0,y.getMediaMime)(ne)||"text/plain",J.writeHead(200,$),(0,v.createReadStream)(ne).pipe(J)}catch(V){return V.code!=="ENOENT"?(ie.error(V),console.error(V.toString())):console.error(`File not found: ${ne}`),J.writeHead(404,{"Content-Type":"text/plain"}),void J.end("Not found")}}e.serveFile=a;const l=(0,C.dirname)(p.FileAccess.asFileUri("").fsPath);let s=class{constructor(ce,ie,M,J,$){this.f=ce,this.g=ie,this.h=M,this.i=J,this.j=$,this.a=this.j.extensionsGallery?.resourceUrlTemplate?b.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const V=(0,i.getRemoteServerRootPath)($);this.b=`${V}/static`,this.c=`${V}/callback`,this.d="/web-extension-resource"}async handle(ce,ie,M){try{const J=M.pathname;return J.startsWith(this.b)&&J.charCodeAt(this.b.length)===47?this.k(ce,ie,M):J==="/"?this.n(ce,ie,M):J===this.c?this.p(ie):J.startsWith(this.d)&&J.charCodeAt(this.d.length)===47?this.m(ce,ie,M):r(ce,ie,404,"Not found.")}catch(J){return this.h.error(J),console.error(J.toString()),r(ce,ie,500,"Internal Server Error.")}}async k(ce,ie,M){const J=Object.create(null),V=decodeURIComponent(M.pathname).substring(this.b.length+1),X=(0,C.join)(l,V);return(0,A.isEqualOrParent)(X,l,!E.isLinux)?a(X,this.g.isBuilt?2:1,this.h,ce,ie,J):r(ce,ie,400,"Bad request.")}l(ce){const ie=ce.authority.indexOf(".");return ie!==-1?ce.authority.substring(ie+1):void 0}async m(ce,ie,M){if(!this.a)return r(ce,ie,500,"No extension gallery service configured.");const J=decodeURIComponent(M.pathname),$=(0,C.normalize)(J.substring(this.d.length+1)),V=b.URI.parse($).with({scheme:this.a.scheme,authority:$.substring(0,$.indexOf("/")),path:$.substring($.indexOf("/")+1)});if(this.l(this.a)!==this.l(V))return r(ce,ie,403,"Request Forbidden");const X={},ue=ge=>{const fe=ce.headers[ge];fe&&((0,f.isString)(fe)||fe[0])?X[ge]=(0,f.isString)(fe)?fe:fe[0]:ge!==ge.toLowerCase()&&ue(ge.toLowerCase())};ue("X-Client-Name"),ue("X-Client-Version"),ue("X-Machine-Id"),ue("X-Client-Commit");const L=await this.i.request({type:"GET",url:V.toString(!0),headers:X},d.CancellationToken.None),N=L.res.statusCode||500;if(N!==200){let ge=null;try{ge=await(0,w.asTextOrError)(L)}catch{}return r(ce,ie,N,ge||`Request failed with status ${N}`)}const H=Object.create(null),ee=ge=>{const fe=L.res.headers[ge];fe?H[ge]=fe:ge!==ge.toLowerCase()&&ee(ge.toLowerCase())};ee("Cache-Control"),ee("Content-Type"),ie.writeHead(200,H);const ae=await(0,c.streamToBuffer)(L.stream);return void ie.end(ae.buffer)}async n(ce,ie,M){const J=M.query[p.connectionTokenQueryName];if(typeof J=="string"){const de=Object.create(null);de["Set-Cookie"]=S.serialize(p.connectionTokenCookieName,J,{sameSite:"lax",maxAge:60*60*24*7});const z=Object.create(null);for(const _ in M.query)_!==p.connectionTokenQueryName&&(z[_]=M.query[_]);const Y=P.format({pathname:"/",query:z});return de.Location=Y,ie.writeHead(302,de),void ie.end()}const $="remote";if(!$)return r(ce,ie,400,"Bad request.");function V(de){return JSON.stringify(de).replace(/"/g,"&quot;")}let X;this.g.args["enable-smoke-test-driver"]&&(X=!1);const ue=de=>de&&b.URI.file(t.resolve(de)).with({scheme:p.Schemas.vscodeRemote,authority:$}),L=p.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,N=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,H=(0,e.relativeRoot)((0,e.getOriginalUrl)(ce)),ee=(0,e.relativePath)((0,e.getOriginalUrl)(ce)),ae=this.g.args.locale||await(0,u.getLocaleFromConfig)(this.g.argvResource.fsPath),ge=await(0,u.getNLSConfiguration)(ae,this.g.userDataPath),fe={remoteAuthority:$,webviewEndpoint:ee+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:X,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:ue(this.g.args["default-folder"]),workspaceUri:ue(this.g.args["default-workspace"]),productConfiguration:{codeServerVersion:this.j.codeServerVersion,rootEndpoint:H,updateEndpoint:this.g.args["disable-update-check"]?void 0:H+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?H+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??H+"/proxy/{{port}}/",serviceWorker:{scope:ee+"/",path:H+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery},callbackRoute:this.c},R=this.j.extensionsGallery?.nlsBaseUrl,U={WORKBENCH_WEB_CONFIGURATION:V(fe),WORKBENCH_AUTH_SESSION:N?V(N):"",WORKBENCH_WEB_BASE_URL:ee+this.b,WORKBENCH_NLS_BASE_URL:ee+(R?`${R}${R.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:H,VS_BASE:ee,NLS_CONFIGURATION:V(ge)};let W;try{W=(await v.promises.readFile(L)).toString().replace(/\{\{([^}]+)\}\}/g,(z,Y)=>U[Y]??"undefined")}catch{return ie.writeHead(404,{"Content-Type":"text/plain"}),void ie.end("Not found")}const Q=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(W).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),se={"Content-Type":"text/html","Content-Security-Policy":Q};return this.f.type!==0&&(se["Set-Cookie"]=S.serialize(p.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),ie.writeHead(200,se),void ie.end(W)}o(ce){const ie=/<script>([\s\S]+?)<\/script>/img,M=[];let J;for(;J=ie.exec(ce);){const $=D.createHash("sha256"),V=J[1].replace(/\r\n/g,`
`),X=$.update(Buffer.from(V)).digest().toString("base64");M.push(`'sha256-${X}'`)}return M}async p(ce){const ie=p.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,M=(await v.promises.readFile(ie)).toString(),J=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(M).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return ce.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":J}),void ce.end(M)}};s=Le([Oe(1,k.IServerEnvironmentService),Oe(2,I.ILogService),Oe(3,w.IRequestService),Oe(4,g.IProductService)],s),e.WebClientServer=s;const h=(ne,ce=!1)=>ne.replace(/\/\/+/g,"/").replace(/\/+$/,ce?"/":"");e.normalizeUrlPath=h;const T=ne=>{const ce=(ne.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(ce>1?"../".repeat(ce-1):""))};e.relativeRoot=T;const F=ne=>{const ce=ne.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+ce[ce.length-1])};e.relativePath=F;const Z=ne=>ne.originalUrl||ne.url;e.getOriginalUrl=Z}),define(be[250],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class t{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.dispose=S.dispose.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=t}),define(be[66],ve([1,0,72]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(S){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:S,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function P(S){return new v.URITransformer(t(S))}e.createURITransformer=P}),define(be[251],ve([1,0,4,66,63,7,210]),function(re,e,v,t,P,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class A extends D.AbstractDiskFileSystemProviderChannel{constructor(I,k){super(new P.DiskFileSystemProvider(I),I),this.H=k,this.G=new Map,this.B(this.a)}c(I){let k=this.G.get(I.remoteAuthority);return k||(k=(0,t.createURITransformer)(I.remoteAuthority),this.G.set(I.remoteAuthority,k)),k}f(I,k,C=!1){if(C&&k.path==="/vscode-resource"&&k.query){const p=JSON.parse(k.query).requestResourcePath;return v.URI.from({scheme:"file",path:p})}return v.URI.revive(I.transformIncoming(k))}F(I,k){return new y(I,k,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=A;class y extends D.AbstractSessionFileWatcher{constructor(I,k,C,p){super(I,k,C,p)}i(I){const k=I.args["file-watcher-polling"];if(k){const C=k.split(S.delimiter),p=Number(C[0]);if(p>0)return{usePolling:C.length>1?C.slice(1):!0,pollingInterval:p}}}j(I){if(I.extensionsPath)return[S.posix.join(I.extensionsPath,"**")]}}}),define(be[83],ve([1,0,185,9,4,2,5,35,17,13]),function(re,e,v,t,P,S,D,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(L){L[L.PROGRAMMATIC=1]="PROGRAMMATIC",L[L.USER=2]="USER",L[L.EDIT=3]="EDIT",L[L.NAVIGATION=4]="NAVIGATION",L[L.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var k;(function(L){L[L.IDENTICAL=1]="IDENTICAL",L[L.SIMILAR=2]="SIMILAR",L[L.DIFFERENT=3]="DIFFERENT"})(k=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function C(L){const N=L;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}e.isEditorPaneWithSelection=C;function p(L,N,H){for(const ee of H.visibleEditorPanes)if(ee.group.id===N&&L.matches(ee.input))return ee.getViewState()}e.findViewStateForEditor=p;function m(L){if(a(L))return!1;const N=L;return P.URI.isUri(N?.resource)}e.isResourceEditorInput=m;function g(L){if(a(L))return!1;const N=L;return N?.original!==void 0&&N.modified!==void 0}e.isResourceDiffEditorInput=g;function w(L){if(a(L)||g(L))return!1;const N=L;return N?.primary!==void 0&&N.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function d(L){if(a(L))return!1;const N=L;return N?N.resource===void 0||N.resource.scheme===E.Schemas.untitled||N.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;const b=/Untitled-\d+/;function c(L){return L.scheme===E.Schemas.untitled&&L.path.length>1&&!b.test(L.path)}e.isUntitledWithAssociatedResource=c;function f(L){if(a(L))return!1;const N=L;return P.URI.isUri(N?.base?.resource)&&P.URI.isUri(N?.input1?.resource)&&P.URI.isUri(N?.input2?.resource)&&P.URI.isUri(N?.result?.resource)}e.isResourceMergeEditorInput=f;var u;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(u=e.Verbosity||(e.Verbosity={}));var i;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class n{constructor(){this.a=new Map}registerSource(N,H){let ee=this.a.get(N);return ee||(ee={source:N,label:H},this.a.set(N,ee)),ee.source}getSourceLabel(N){return this.a.get(N)?.label??N}}e.SaveSourceRegistry=new n;var r;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription",L[L.CanDropIntoEditor=128]="CanDropIntoEditor",L[L.MultipleEditors=256]="MultipleEditors"})(r=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends S.Disposable{}e.AbstractEditorInput=o;function a(L){return L instanceof o}e.isEditorInput=a;function l(L){const N=L;return P.URI.isUri(N?.preferredResource)}function s(L){const N=L;return a(N?.primary)&&a(N?.secondary)}e.isSideBySideEditorInput=s;function h(L){const N=L;return a(N?.modified)&&a(N?.original)}e.isDiffEditorInput=h;function T(L){return a(L?.editor)}e.isEditorInputWithOptions=T;function F(L){const N=L;return T(L)&&N?.group!==void 0}e.isEditorInputWithOptionsAndGroup=F;function Z(L){const N=L;return typeof N?.groupId=="number"&&a(N.editor)}e.isEditorIdentifier=Z;var ne;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(ne=e.EditorCloseContext||(e.EditorCloseContext={}));var ce;(function(L){L[L.GROUP_ACTIVE=0]="GROUP_ACTIVE",L[L.GROUP_INDEX=1]="GROUP_INDEX",L[L.GROUP_LOCKED=2]="GROUP_LOCKED",L[L.EDITOR_OPEN=3]="EDITOR_OPEN",L[L.EDITOR_CLOSE=4]="EDITOR_CLOSE",L[L.EDITOR_MOVE=5]="EDITOR_MOVE",L[L.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",L[L.EDITOR_LABEL=7]="EDITOR_LABEL",L[L.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",L[L.EDITOR_PIN=9]="EDITOR_PIN",L[L.EDITOR_STICKY=10]="EDITOR_STICKY",L[L.EDITOR_DIRTY=11]="EDITOR_DIRTY",L[L.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(ce=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var ie;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(ie=e.SideBySideEditor||(e.SideBySideEditor={}));class M{getOriginalUri(N,H){if(!N)return;if(f(N))return e.EditorResourceAccessor.getOriginalUri(N.result,H);if(H?.supportSideBySide){const{primary:ae,secondary:ge}=this.a(N);if(ae&&ge){if(H?.supportSideBySide===ie.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===ie.ANY)return this.getOriginalUri(ae,{filterByScheme:H.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:H.filterByScheme});N=H.supportSideBySide===ie.PRIMARY?ae:ge}}if(g(N)||w(N)||f(N))return;const ee=l(N)?N.preferredResource:N.resource;return!ee||!H||!H.filterByScheme?ee:this.b(ee,H.filterByScheme)}a(N){return s(N)||w(N)?{primary:N.primary,secondary:N.secondary}:h(N)||g(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,H){if(!N)return;if(f(N))return e.EditorResourceAccessor.getCanonicalUri(N.result,H);if(H?.supportSideBySide){const{primary:ae,secondary:ge}=this.a(N);if(ae&&ge){if(H?.supportSideBySide===ie.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===ie.ANY)return this.getCanonicalUri(ae,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:H.filterByScheme});N=H.supportSideBySide===ie.PRIMARY?ae:ge}}if(g(N)||w(N)||f(N))return;const ee=N.resource;return!ee||!H||!H.filterByScheme?ee:this.b(ee,H.filterByScheme)}b(N,H){if(Array.isArray(H)){if(H.some(ee=>N.scheme===ee))return N}else if(H===N.scheme)return N}}e.EditorResourceAccessor=new M;var J;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(J=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.c=new Map,this.d=new Map}start(N){const H=this.a=N.get(D.IInstantiationService);for(const[ee,ae]of this.c)this.e(ee,ae,H);this.c.clear()}e(N,H,ee){const ae=ee.createInstance(H);this.d.set(N,ae)}registerFileEditorFactory(N){if(this.b)throw new Error("Can only register one file editor factory.");this.b=N}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(N,H){if(this.c.has(N)||this.d.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.a?this.e(N,H,this.a):this.c.set(N,H),(0,S.toDisposable)(()=>{this.c.delete(N),this.d.delete(N)})}getEditorSerializer(N){return this.d.get(typeof N=="string"?N:N.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new $);async function V(L,N,H){return!L||!L.length?[]:await Promise.all(L.map(async ee=>{const ae=P.URI.revive(ee.fileUri);if(!ae){H.info("Cannot resolve the path because it is not valid.",ee);return}if(!await N.canHandleResource(ae)){H.info("Cannot resolve the path because it cannot be handled",ee);return}let fe=ee.exists,R=ee.type;if(typeof fe!="boolean"||typeof R!="number")try{R=(await N.stat(ae)).isDirectory?y.FileType.Directory:y.FileType.Unknown,fe=!0}catch(W){H.error(W),fe=!1}if(!fe&&ee.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",ee);return}if(R===y.FileType.Directory){H.info("Cannot resolve the path because it is a directory",ee);return}const U={...ee.options,pinned:!0};return fe?{resource:ae,options:U}:{resource:ae,options:U,forceUntitled:!0}}))}e.pathsToEditors=V;var X;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(X=e.EditorsOrder||(e.EditorsOrder={}));function ue(L){const N=L;if(!N)return!1;const H=N;if(H.modified)return ue(H.modified);const ee=N;return!!(ee.contributionsState&&ee.viewState&&Array.isArray(ee.cursorState))}e.isTextEditorViewState=ue}),define(be[120],ve([1,0,16,71,55,56,13,7,3,101]),function(re,e,v,t,P,S,D,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var I;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",S.Mimes.latex,S.Mimes.markdown,"image/png","image/jpeg",S.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[S.Mimes.latex,S.Mimes.markdown,"application/json",S.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var C;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var b;(function(V){V.scheme=D.Schemas.vscodeNotebookCell;const X=["W","X","Y","Z","a","b","c","d","e","f"],ue=new RegExp(`^[${X.join("")}]+`),L=7;function N(R,U){const W=U.toString(L),se=`${W.length<X.length?X[W.length-1]:"z"}${W}s${(0,v.encodeBase64)(v.VSBuffer.fromString(R.scheme),!0,!0)}`;return R.with({scheme:V.scheme,fragment:se})}V.generate=N;function H(R){if(R.scheme!==V.scheme)return;const U=R.fragment.indexOf("s");if(U<0)return;const W=parseInt(R.fragment.substring(0,U).replace(ue,""),L),Q=(0,v.decodeBase64)(R.fragment.substring(U+1)).toString();if(!isNaN(W))return{handle:W,notebook:R.with({scheme:Q,fragment:null})}}V.parse=H;function ee(R,U){return R.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${U??""},${R.scheme!==D.Schemas.file?R.scheme:""}`})}V.generateCellOutputUri=ee;function ae(R){if(R.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const U=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!U)return;const W=U[1]&&U[1]!==""?U[1]:void 0,Q=U[2];return{outputId:W,notebook:R.with({scheme:Q||D.Schemas.file,fragment:null})}}V.parseCellOutputUri=ae;function ge(R,U,W){return V.generate(R,U).with({scheme:W})}V.generateCellPropertyUri=ge;function fe(R,U){if(R.scheme===U)return V.parse(R.with({scheme:V.scheme}))}V.parseCellPropertyUri=fe})(b=e.CellUri||(e.CellUri={}));const c=V=>y.isWindows?V.replace(/\//g,"\\"):V;class f{constructor(X=[],ue=e.NOTEBOOK_DISPLAY_ORDER){this.e=ue,this.d=[...new Set(X)].map(L=>({pattern:L,matches:t.parse(c(L))}))}sort(X){const ue=new Map(P.Iterable.map(X,N=>[N,c(N)]));let L=[];for(const{matches:N}of this.d)for(const[H,ee]of ue)if(N(ee)){L.push(H),ue.delete(H);break}return ue.size&&(L=L.concat([...ue.keys()].sort((N,H)=>this.e.indexOf(N)-this.e.indexOf(H)))),L}prioritize(X,ue){const L=this.f(X);if(L===-1){this.d.unshift({pattern:X,matches:t.parse(c(X))});return}const N=new Set(ue.map(ee=>this.f(ee,L)));N.delete(-1);const H=Array.from(N).sort();this.d.splice(L+1,0,...H.map(ee=>this.d[ee]));for(let ee=H.length-1;ee>=0;ee--)this.d.splice(H[ee],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,ue=this.d.length){const L=c(X);for(let N=0;N<ue;N++)if(this.d[N].matches(L))return N;return-1}}e.MimeTypeDisplayOrder=f;function u(V,X,ue,L=(N,H)=>N===H){const N=[];function H(ge,fe,R){if(fe===0&&R.length===0)return;const U=N[N.length-1];U&&U.start+U.deleteCount===ge?(U.deleteCount+=fe,U.toInsert.push(...R)):N.push({start:ge,deleteCount:fe,toInsert:R})}let ee=0,ae=0;for(;;){if(ee===V.length){H(ee,0,X.slice(ae));break}if(ae===X.length){H(ee,V.length-ee,[]);break}const ge=V[ee],fe=X[ae];if(L(ge,fe)){ee+=1,ae+=1;continue}ue(fe)?(H(ee,1,[]),ee+=1):(H(ee,0,[fe]),ae+=1)}return N}e.diff=u,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(V){V.default="default",V.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(V){const X=V;return!!((typeof X.include=="string"||t.isRelativePattern(X.include))&&(typeof X.exclude=="string"||t.isRelativePattern(X.exclude)))}e.isDocumentExcludePattern=n;function r(V,X,ue){if(Array.isArray(V.viewType)&&V.viewType.indexOf(X)>=0||V.viewType===X)return!0;if(V.filenamePattern){const L=n(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,N=n(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(t.match(L,(0,A.basename)(ue.fsPath).toLowerCase()))return!(N&&t.match(N,(0,A.basename)(ue.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var o;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(o=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(X){return`${a.d}${X}`}static parse(X){if(X.startsWith(a.d))return X.substring(a.d.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a.d="notebook/";function l(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}e.isTextStreamMime=l;const s=new TextDecoder;function h(V){const X=[];let ue=!1;for(const L of V)(X.length===0||ue)&&(X.push(L),ue=!0);return ne(X),$(v.VSBuffer.concat(X.map(L=>v.VSBuffer.wrap(L))))}e.compressOutputItemStreams=h;const T=`${String.fromCharCode(27)}[A`,F=T.split("").map(V=>V.charCodeAt(0)),Z=10;function ne(V){V.forEach((X,ue)=>{if(ue===0||X.length<T.length)return;const L=V[ue-1],N=X.subarray(0,T.length);if(N[0]===F[0]&&N[1]===F[1]&&N[2]===F[2]){const H=L.lastIndexOf(Z);if(H===-1)return;V[ue-1]=L.subarray(0,H),V[ue]=X.subarray(T.length)}})}function ce(V){let X=V;do V=X,X=V.replace(/[^\n]\x08/gm,"");while(X.length<V.length);return V}function ie(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const X=V.match(/^(.*)\r+/m)[1];let ue=V.match(/\r+(.*)$/m)[1];ue=ue+X.slice(ue.length,X.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return V}const M="\b".charCodeAt(0),J="\r".charCodeAt(0);function $(V){return!V.buffer.includes(M)&&!V.buffer.includes(J)?V:v.VSBuffer.fromString(ie(ce(s.decode(V.buffer))))}}),define(be[121],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,v.createDecorator)("environmentVariableService");var t;(function(P){P[P.Replace=1]="Replace",P[P.Append=2]="Append",P[P.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(be[252],ve([1,0,3,121]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class P{constructor(y){this.collections=y,this.map=new Map,y.forEach((E,I)=>{const k=E.map.entries();let C=k.next();for(;!C.done;){const p=C.value[0];let m=this.map.get(p);if(m||(m=[],this.map.set(p,m)),m.length>0&&m[0].type===t.EnvironmentVariableMutatorType.Replace){C=k.next();continue}const g=C.value[1];m.unshift({extensionIdentifier:I,value:g.value,type:g.type}),C=k.next()}})}async applyToProcessEnvironment(y,E){let I;v.isWindows&&(I={},Object.keys(y).forEach(k=>I[k.toLowerCase()]=k));for(const[k,C]of this.map){const p=v.isWindows&&I[k.toLowerCase()]||k;for(const m of C){const g=E?await E(m.value):m.value;switch(m.type){case t.EnvironmentVariableMutatorType.Append:y[p]=(y[p]||"")+g;break;case t.EnvironmentVariableMutatorType.Prepend:y[p]=g+(y[p]||"");break;case t.EnvironmentVariableMutatorType.Replace:y[p]=g;break}}}}diff(y){const E=new Map,I=new Map,k=new Map;if(y.map.forEach((C,p)=>{const m=this.map.get(p),g=S(C,m);g&&E.set(p,g)}),this.map.forEach((C,p)=>{const m=y.map.get(p),g=S(C,m);g&&k.set(p,g)}),this.map.forEach((C,p)=>{const m=y.map.get(p),g=D(C,m);g&&I.set(p,g)}),!(E.size===0&&I.size===0&&k.size===0))return{added:E,changed:I,removed:k}}}e.MergedEnvironmentVariableCollection=P;function S(A,y){if(!y)return A;const E=new Set;y.forEach(k=>E.add(k.extensionIdentifier));const I=[];return A.forEach(k=>{E.has(k.extensionIdentifier)||I.push(k)}),I.length===0?void 0:I}function D(A,y){if(!y)return;const E=new Map;y.forEach(k=>E.set(k.extensionIdentifier,k));const I=[];return A.forEach(k=>{const C=E.get(k.extensionIdentifier);C&&(k.type!==C.type||k.value!==C.value)&&I.push(C)}),I.length===0?void 0:I}}),define(be[122],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=v;function t(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=t;function P(D){return Array.from(D.entries()).map(A=>[A[0],v(A[1].map)])}e.serializeEnvironmentVariableCollections=P;function S(D){return new Map(D.map(A=>[A[0],{map:t(A[1])}]))}e.deserializeEnvironmentVariableCollections=S}),define(be[253],ve([1,0,7,57,3,233]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function D(f,u){if(!!u)if(P.isWindows)for(const i in u){let n=i;for(const o in f)if(i.toLowerCase()===o.toLowerCase()){n=o;break}const r=u[i];r!==void 0&&A(f,n,r)}else Object.keys(u).forEach(i=>{const n=u[i];n!==void 0&&A(f,i,n)})}e.mergeEnvironments=D;function A(f,u,i){typeof i=="string"?f[u]=i:delete f[u]}function y(f,u,i,n){f.TERM_PROGRAM="vscode",u&&(f.TERM_PROGRAM_VERSION=u),k(f,n)&&(f.LANG=C(i)),f.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=y;function E(f,u){if(!!u)for(const i of Object.keys(u)){const n=u[i];n&&(f[i]=n)}}async function I(f,u){return await Promise.all(Object.entries(u).map(async([i,n])=>{if(typeof n=="string")try{u[i]=await f(n)}catch{u[i]=n}})),u}function k(f,u){if(u==="on")return!0;if(u==="auto"){const i=f.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=k;function C(f){const u=f?f.split("-"):[],i=u.length;if(i===0)return"en_US.UTF-8";if(i===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};u[0]in n&&u.push(n[u[0]])}else u[1]=u[1].toUpperCase();return u.join("_")+".UTF-8"}e.getLangEnvVariable=C;async function p(f,u,i,n,r,o){if(f.cwd){const l=typeof f.cwd=="object"?f.cwd.fsPath:f.cwd,s=await m(l,i);return(0,S.sanitizeCwd)(s||l)}let a;return!f.ignoreConfigurationCwd&&r&&(i&&(r=await m(r,i,o)),r&&(v.isAbsolute(r)?a=r:n&&(a=v.join(n.fsPath,r)))),a||(a=n?n.fsPath:u||""),(0,S.sanitizeCwd)(a)}e.getCwd=p;async function m(f,u,i){if(u)try{return await u(f)}catch(n){i?.error("Could not resolve terminal cwd",n);return}return f}function g(f,u,i){if(!!i)return n=>i.resolveWithEnvironment(u,f,n)}e.createVariableResolver=g;async function w(f,u,i,n,r,o,a,l=P.platform){let s;a&&(s=b(f,"automationShell",l)),s||(s=b(f,"shell",l));let h=s||u;if(l===3&&!i&&n){const T=v.join(n,"Sysnative").replace(/\//g,"\\").toLowerCase();h&&h.toLowerCase().indexOf(T)===0&&(h=v.join(n,"System32",h.substr(T.length+1)))}if(h&&l===3&&(h=h.replace(/\//g,"\\")),r)try{h=await r(h)}catch(T){o.error("Could not resolve shell",T)}return h}e.getDefaultShell=w;async function d(f,u,i,n,r=P.platform){if(u&&b(f,"automationShell",r))return[];const o=r===3?"windows":r===1?"osx":"linux";let a=f(`terminal.integrated.shellArgs.${o}`);if(!a)return[];if(typeof a=="string"&&r===3)return i?await i(a):a;if(i){const l=[];for(const s of a)try{l.push(await i(s))}catch(h){n.error(`Could not resolve terminal.integrated.shellArgs.${o}`,h),l.push(s)}a=l}return a}e.getDefaultShellArgs=d;function b(f,u,i=P.platform){return f(`terminal.integrated.${u}.${i===3?"windows":i===1?"osx":"linux"}`)}async function c(f,u,i,n,r,o){const a={};if(f.strictEnv)E(a,f.env);else{E(a,o);const l={...u};i&&(l&&await I(i,l),f.env&&await I(i,f.env)),(0,t.sanitizeProcessEnvironment)(a,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),D(a,l),D(a,f.env),y(a,n,P.locale,r)}return a}e.createTerminalEnvironment=c}),define(be[67],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(S){S.Delimiter="\0"})(v=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class P{static fromExtHostTestItem(D,A,y=D.parent){if(D._isRoot)return new P([A]);const E=[D.id];for(let I=y;I&&I.id!==A;I=I.parent)E.push(I.id);return E.push(A),new P(E.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const A=D.indexOf("\0");return A===-1?D:D.slice(0,A)}static fromString(D){return new P(D.split("\0"))}static join(D,A){return new P([...D.path,A])}static joinToString(D,A){return D.toString()+"\0"+A}static parentId(D){const A=D.lastIndexOf("\0");return A===-1?void 0:D.slice(0,A)}static compare(D,A){return D===A?0:A.startsWith(D+"\0")?2:D.startsWith(A+"\0")?3:1}constructor(D,A=D.length){if(this.path=D,this.d=A,D.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new P(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new P(this.path,D)}compare(D){if(typeof D=="string")return P.compare(this.toString(),D);for(let A=0;A<D.d&&A<this.d;A++)if(D.path[A]!==this.path[A])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=P}),define(be[84],ve([1,0,4,48,67]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var S;(function(l){l[l.Unset=0]="Unset",l[l.Queued=1]="Queued",l[l.Running=2]="Running",l[l.Passed=3]="Passed",l[l.Failed=4]="Failed",l[l.Skipped=5]="Skipped",l[l.Errored=6]="Errored"})(S=e.TestResultState||(e.TestResultState={}));var D;(function(l){l[l.Run=2]="Run",l[l.Debug=4]="Debug",l[l.Coverage=8]="Coverage",l[l.HasNonDefaultProfile=16]="HasNonDefaultProfile",l[l.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(l){l.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),l.deserialize=s=>({range:t.Range.lift(s.range),uri:v.URI.revive(s.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(l){l[l.Error=0]="Error",l[l.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var E;(function(l){l.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&A.serialize(s.location)}),l.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&A.deserialize(s.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));const I=(l,s)=>`${s?"s":"e"}${l}`;e.getMarkId=I;var k;(function(l){l.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&A.serialize(s.location)}),l.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&A.deserialize(s.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var C;(function(l){l.serialize=s=>s.type===0?E.serialize(s):k.serialize(s),l.deserialize=s=>s.type===0?E.deserialize(s):k.deserialize(s)})(C=e.ITestMessage||(e.ITestMessage={}));var p;(function(l){l.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),l.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(C.serialize)}),l.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(C.deserialize)})})(p=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",g=(l,s)=>l+m+s;e.namespaceTestTag=g;const w=l=>{const s=l.indexOf(m);return{ctrlId:l.slice(0,s),tagId:l.slice(s+1)}};e.denamespaceTestTag=w;var d;(function(l){l.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),l.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?v.URI.revive(s.uri):void 0,range:s.range?t.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(d=e.ITestItem||(e.ITestItem={}));var b;(function(l){l[l.NotExpandable=0]="NotExpandable",l[l.Expandable=1]="Expandable",l[l.BusyExpanding=2]="BusyExpanding",l[l.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var c;(function(l){l.serialize=s=>({expand:s.expand,item:d.serialize(s.item)}),l.deserialize=s=>({controllerId:P.TestId.root(s.item.extId),expand:s.expand,item:d.deserialize(s.item)})})(c=e.InternalTestItem||(e.InternalTestItem={}));var f;(function(l){l.serialize=s=>{let h;return s.item&&(h={},s.item.label!==void 0&&(h.label=s.item.label),s.item.tags!==void 0&&(h.tags=s.item.tags),s.item.busy!==void 0&&(h.busy=s.item.busy),s.item.uri!==void 0&&(h.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(h.range=s.item.range?.toJSON()),s.item.description!==void 0&&(h.description=s.item.description),s.item.error!==void 0&&(h.error=s.item.error),s.item.sortText!==void 0&&(h.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:h}},l.deserialize=s=>{let h;return s.item&&(h={},s.item.label!==void 0&&(h.label=s.item.label),s.item.tags!==void 0&&(h.tags=s.item.tags),s.item.busy!==void 0&&(h.busy=s.item.busy),s.item.range!==void 0&&(h.range=s.item.range?t.Range.lift(s.item.range):null),s.item.description!==void 0&&(h.description=s.item.description),s.item.error!==void 0&&(h.error=s.item.error),s.item.sortText!==void 0&&(h.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:h}}})(f=e.ITestItemUpdate||(e.ITestItemUpdate={}));const u=(l,s)=>{s.expand!==void 0&&(l.expand=s.expand),s.item!==void 0&&(l.item=l.item?Object.assign(l.item,s.item):s.item)};e.applyTestItemUpdate=u;var i;(function(l){l.serializeWithoutMessages=s=>({...c.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(p.serializeWithoutMessages),retired:s.retired}),l.serialize=s=>({...c.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(p.serialize),retired:s.retired}),l.deserialize=s=>({...c.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(p.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var n;(function(l){l[l.Function=0]="Function",l[l.Statement=1]="Statement"})(n=e.DetailType||(e.DetailType={}));var r;(function(l){l[l.Add=0]="Add",l[l.Update=1]="Update",l[l.DocumentSynced=2]="DocumentSynced",l[l.Remove=3]="Remove",l[l.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",l[l.Retire=5]="Retire",l[l.AddTag=6]="AddTag",l[l.RemoveTag=7]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(l){l.deserialize=s=>s.op===0?{op:s.op,item:c.deserialize(s.item)}:s.op===1?{op:s.op,item:f.deserialize(s.item)}:s.op===2?{op:s.op,uri:v.URI.revive(s.uri),docv:s.docv}:s,l.serialize=s=>s.op===0?{op:s.op,item:c.serialize(s.item)}:s.op===1?{op:s.op,item:f.serialize(s.item)}:s})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class a{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(s){const h=this.o();for(const T of s)switch(T.op){case 0:this.j(c.deserialize(T.item),h);break;case 1:this.k(f.deserialize(T.item),h);break;case 3:this.l(T.itemId,h);break;case 5:this.m(T.itemId);break;case 4:this.updatePendingRoots(T.amount);break;case 6:this.c.set(T.tag.id,T.tag);break;case 7:this.c.delete(T.id);break}h.complete?.()}j(s,h){const T=P.TestId.parentId(s.item.extId)?.toString();let F;if(!T)F=this.p(s),this.f.add(F),this.d.set(s.item.extId,F);else if(this.d.has(T)){const Z=this.d.get(T);Z.children.add(s.item.extId),F=this.p(s,Z),this.d.set(s.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return h.add?.(F),s.expand===2&&this.g++,F}k(s,h){const T=this.d.get(s.extId);if(!!T)return s.expand!==void 0&&(T.expand===2&&this.g--,s.expand===2&&this.g++),(0,e.applyTestItemUpdate)(T,s),h.update?.(T),T}l(s,h){const T=this.d.get(s);if(!T)return;const F=P.TestId.parentId(T.item.extId)?.toString();F?this.d.get(F).children.delete(T.item.extId):this.f.delete(T);const Z=[[s]];for(;Z.length;)for(const ne of Z.pop()){const ce=this.d.get(ne);ce&&(Z.push(ce.children),this.d.delete(ne),h.remove?.(ce,ce!==T),ce.expand===2&&this.g--)}}m(s){}updatePendingRoots(s){this.h+=s}o(){return{}}}e.AbstractIncrementalTestCollection=a}),define(be[123],ve([1,0,14,6,2,86,84,67]),function(re,e,v,t,P,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const E=(b,c)=>b===c,k=Object.entries({range:(b,c)=>b===c?!0:!b||!c?!1:b.equalsRange(c),busy:E,label:E,description:E,error:E,sortText:E,tags:(b,c)=>!(b.length!==c.length||b.some(f=>!c.includes(f)))}),C=(b,c)=>{let f;for(const[u,i]of k)i(b[u],c[u])||(f?f[u]=c[u]:f={[u]:c[u]});return f};class p extends P.Disposable{get root(){return this.m.root}constructor(c){super(),this.m=c,this.f=this.B(new v.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(c){this.h=c;for(const f of this.tree.values())this.G(f)}collectDiff(){const c=this.k;return this.k=[],c}pushDiff(c){switch(c.op){case 2:{for(const f of this.k)if(f.op===2&&f.uri===c.uri){f.docv=c.docv;return}break}case 1:{const f=this.k[this.k.length-1];if(f){if(f.op===1&&f.item.extId===c.item.extId){(0,D.applyTestItemUpdate)(f.item,c.item);return}if(f.op===0&&f.item.item.extId===c.item.extId){(0,D.applyTestItemUpdate)(f.item,c.item);return}}break}}this.k.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,f){const u=this.tree.get(c);if(!!u){if((u.expandLevels===void 0||f>u.expandLevels)&&(u.expandLevels=f),u.expand===1){const i=this.I(u);return i.isOpen()?this.H(u,f-1):i.wait().then(()=>this.H(u,f-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.H(u,f-1)):this.H(u,f-1)}}dispose(){for(const c of this.tree.values())this.m.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(c,f){switch(f.op){case 3:this.L(A.TestId.joinToString(c.fullId,f.id));break;case 0:this.u(f.item,c);break;case 5:for(const u of f.ops)this.p(c,u);break;case 1:this.w(f.new,f.old,c.fullId.toString());break;case 2:this.G(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:f.update}});break;case 6:this.s(c.actual.uri);break;default:(0,S.assertNever)(f)}}s(c){c&&this.pushDiff({op:2,uri:c,docv:this.m.getDocumentVersion(c)})}u(c,f){const u=A.TestId.fromExtHostTestItem(c,this.root.id,f?.actual),i=this.m.getApiFor(c);i.parent&&i.parent!==f?.actual&&this.m.getChildren(i.parent).delete(c.id);let n=this.tree.get(u.toString());if(!n){n={fullId:u,actual:c,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},c.tags.forEach(this.y,this),this.tree.set(n.fullId.toString(),n),this.C(c,f),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:n.expand,item:this.m.toITestItem(c)}}),this.F(c,n,f);return}if(n.actual===c){this.D(c,n,f);return}if(n.actual.uri?.toString()!==c.uri?.toString())return this.L(u.toString()),this.u(c,f);const r=this.m.getChildren(n.actual),o=n.actual,a=C(this.m.toITestItem(o),this.m.toITestItem(c));this.m.getApiFor(o).listener=void 0,n.actual=c,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(c.tags,o.tags,u.toString()),delete a.tags),this.p(n,{op:4,update:a})),this.F(c,n,f);for(const[l,s]of r)this.m.getChildren(c).get(s.id)||this.L(A.TestId.joinToString(u,s.id));this.s(n.actual.uri)}w(c,f,u){const i=new Set(f.map(n=>n.id));for(const n of c)i.delete(n.id)||this.y(n);this.pushDiff({op:1,item:{extId:u,item:{tags:c.map(n=>(0,D.namespaceTestTag)(this.m.controllerId,n.id))}}}),i.forEach(this.z,this)}y(c){const f=this.j.get(c.id);f?f.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,c.id)}}))}z(c){const f=this.j.get(c);f&&!--f.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,c)}))}C(c,f){this.m.getApiFor(c).parent=f&&f.actual!==this.root?f.actual:void 0}D(c,f,u){this.C(c,u);const i=this.m.getApiFor(c);i.parent=u?.actual,i.listener=n=>this.p(f,n),this.G(f)}F(c,f,u){this.D(c,f,u);for(const[i,n]of this.m.getChildren(c))this.u(n,f)}G(c){let f;this.h?c.resolveBarrier?f=c.resolveBarrier.isOpen()?3:2:f=c.actual.canResolveChildren?1:0:f=0,f!==c.expand&&(c.expand=f,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:f}}),f===1&&c.expandLevels!==void 0&&this.I(c))}H(c,f){if(f<0)return;const u=[];for(const[i,n]of this.m.getChildren(c.actual)){const r=this.expand(A.TestId.joinToString(c.fullId,n.id),f);(0,v.isThenable)(r)&&u.push(r)}if(u.length)return Promise.all(u).then(()=>{})}I(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const n=new v.Barrier;return n.open(),n}c.expand=2,this.J(c);const f=c.resolveBarrier=new v.Barrier,u=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,n)};let i;try{i=this.h(c.actual===this.root?void 0:c.actual)}catch(n){u(n)}return(0,v.isThenable)(i)?i.catch(u).then(()=>{f.open(),this.G(c)}):(f.open(),this.G(c)),c.resolveBarrier}J(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}L(c){const f=this.tree.get(c);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const u=[f];for(;u.length;){const i=u.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const n of i.actual.tags)this.z(n.id);this.tree.delete(i.fullId.toString());for(const[n,r]of this.m.getChildren(i.actual))u.push(this.tree.get(A.TestId.joinToString(i.fullId,r.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.TestItemCollection=p;class m extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=m;class g extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class w extends Error{constructor(c,f,u){super(`TestItem with ID "${c}" is from controller "${f}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=w;const d=(b,c,f)=>{let u=new Map;return{get size(){return u.size},forEach(i,n){for(const r of u.values())i.call(n,r,this)},[Symbol.iterator](){return u.entries()},replace(i){const n=new Map,r=new Set(u.keys()),o={op:5,ops:[]};for(const a of i){if(!(a instanceof f))throw new g(a.id);const l=c(a).controllerId;if(l!==b.controllerId)throw new w(a.id,l,b.controllerId);if(n.has(a.id))throw new m(a.id);n.set(a.id,a),r.delete(a.id),o.ops.push({op:0,item:a})}for(const a of r.keys())o.ops.push({op:3,id:a});b.listener?.(o),u=n},add(i){if(!(i instanceof f))throw new g(i.id);u.set(i.id,i),b.listener?.({op:0,item:i})},delete(i){u.delete(i)&&b.listener?.({op:3,id:i})},get(i){return u.get(i)},toJSON(){return Array.from(u.values())}}};e.createTestItemChildren=d}),define(be[124],ve([1,0,123]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,P=(D,A)=>{const y={controllerId:A};return t.set(D,y),y};e.createPrivateApiFor=P;const S=D=>{const A=t.get(D);if(!A)throw new v.InvalidTestItemError(D?.id||"<unknown>");return A};e.getPrivateApiFor=S}),define(be[254],ve([1,0,24,5]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(v.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(be[125],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,v.createDecorator)("configurationResolverService");var t;(function(S){S.Unknown="unknown",S.Env="env",S.Config="config",S.Command="command",S.Input="input",S.ExtensionInstallFolder="extensionInstallFolder",S.WorkspaceFolder="workspaceFolder",S.Cwd="cwd",S.WorkspaceFolderBasename="workspaceFolderBasename",S.UserHome="userHome",S.LineNumber="lineNumber",S.SelectedText="selectedText",S.File="file",S.FileWorkspaceFolder="fileWorkspaceFolder",S.RelativeFile="relativeFile",S.RelativeFileDirname="relativeFileDirname",S.FileDirname="fileDirname",S.FileExtname="fileExtname",S.FileBasename="fileBasename",S.FileBasenameNoExtension="fileBasenameNoExtension",S.FileDirnameBasename="fileDirnameBasename",S.ExecPath="execPath",S.ExecInstallFolder="execInstallFolder",S.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class P extends Error{constructor(D,A){super(A),this.variable=D}}e.VariableError=P}),define(be[255],ve([1,0,7,27,9,23,3,144,186,125,15]),function(re,e,v,t,P,S,D,A,y,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(p,m,g,w){this.g=new Map,this.a=p,this.b=m,this.d=g,w&&(this.c=w.then(d=>this.h(d)))}h(p){if(D.isWindows){const m=Object.create(null);return Object.keys(p).forEach(g=>{m[g.toLowerCase()]=p[g]}),m}return p}resolveWithEnvironment(p,m,g){return this.j({env:this.h(p),userHome:void 0},m?m.uri:void 0,g)}async resolveAsync(p,m){const g={env:await this.c,userHome:await this.d};return this.j(g,p?p.uri:void 0,m)}async i(p,m,g,w){const d=S.deepClone(m);D.isWindows&&d.windows?Object.keys(d.windows).forEach(c=>d[c]=d.windows[c]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(c=>d[c]=d.osx[c]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(c=>d[c]=d.linux[c]),delete d.windows,delete d.osx,delete d.linux;const b={env:await this.c,userHome:await this.d};return this.j(b,p?p.uri:void 0,d,g,w)}async resolveAnyAsync(p,m,g){return this.i(p,m,g)}async resolveAnyMap(p,m,g){const w=new Map;return{newConfig:await this.i(p,m,g,w),resolvedVariables:w}}resolveWithInteractionReplace(p,m,g,w){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,m,g,w){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,m){if(this.g.has(p))throw new Error("Variable "+p+" is contributed twice.");this.g.set(p,m)}async j(p,m,g,w,d){if(P.isString(g))return this.l(p,m,g,w,d);if(Array.isArray(g))return Promise.all(g.map(b=>this.j(p,m,b,w,d)));if(P.isObject(g)){const b=Object.create(null),c=await Promise.all(Object.keys(g).map(async f=>[await this.l(p,m,f,w,d),await this.j(p,m,g[f],w,d)]));for(const[f,u]of c)b[f]=u;return b}return g}l(p,m,g,w,d){return(0,I.replaceAsync)(g,k.VARIABLE_REGEXP,async(b,c)=>{if(c.includes(k.VARIABLE_LHS))return b;let f=await this.n(p,b,c,m,w);return d?.set(c,f),f!==b&&P.isString(f)&&f.match(k.VARIABLE_REGEXP)&&(f=await this.l(p,m,f,w,d)),f})}m(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async n(p,m,g,w,d){let b;const c=g.split(":");c.length>1&&(g=c[0],b=c[1]);const f=n=>{const r=this.a.getFilePath();if(r)return r;throw new E.VariableError(n,(0,y.localize)(0,null,m))},u=n=>{const r=f(n);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return o}throw new E.VariableError(n,(0,y.localize)(1,null,m,v.basename(r)))},i=n=>{if(b){const r=this.a.getFolderUri(b);if(r)return r;throw new E.VariableError(n,(0,y.localize)(2,null,m,b))}if(w)return w;throw this.a.getWorkspaceFolderCount()>1?new E.VariableError(n,(0,y.localize)(3,null,m)):new E.VariableError(n,(0,y.localize)(4,null,m))};switch(g){case"env":if(b){if(p.env){const n=p.env[D.isWindows?b.toLowerCase():b];if(P.isString(n))return n}return""}throw new E.VariableError(E.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(b){const n=this.a.getConfigurationValue(w,b);if(P.isUndefinedOrNull(n))throw new E.VariableError(E.VariableKind.Config,(0,y.localize)(6,null,m,b));if(P.isObject(n))throw new E.VariableError(E.VariableKind.Config,(0,y.localize)(7,null,m,b));return n}throw new E.VariableError(E.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.o(E.VariableKind.Command,m,b,d,"command");case"input":return this.o(E.VariableKind.Input,m,b,d,"input");case"extensionInstallFolder":if(b){const n=await this.a.getExtension(b);if(!n)throw new E.VariableError(E.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,b));return this.m(n.extensionLocation)}throw new E.VariableError(E.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(E.VariableKind.WorkspaceFolder)));case"cwd":return w||b?(0,A.normalizeDriveLetter)(this.m(i(E.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.m(i(E.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(p.userHome)return p.userHome;throw new E.VariableError(E.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new E.VariableError(E.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new E.VariableError(E.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return f(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"relativeFile":return w||b?v.relative(this.m(i(E.VariableKind.RelativeFile)),f(E.VariableKind.RelativeFile)):f(E.VariableKind.RelativeFile);case"relativeFileDirname":{const n=v.dirname(f(E.VariableKind.RelativeFileDirname));if(w||b){const r=v.relative(this.m(i(E.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return v.dirname(f(E.VariableKind.FileDirname));case"fileExtname":return v.extname(f(E.VariableKind.FileExtname));case"fileBasename":return v.basename(f(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=v.basename(f(E.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-v.extname(n).length)}case"fileDirnameBasename":return v.basename(v.dirname(f(E.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||m}case"execInstallFolder":{const n=this.a.getAppRoot();return n||m}case"pathSeparator":return v.sep;default:try{const n=b?`${g}:${b}`:g;return this.o(E.VariableKind.Unknown,m,n,d,void 0)}catch{return m}}}}o(p,m,g,w,d){if(g&&w){const b=d===void 0?w[g]:w[d+":"+g];if(typeof b=="string")return b;throw new E.VariableError(p,(0,y.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[256],ve([1,0,5,83]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var P;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(P=e.GroupDirection||(e.GroupDirection={}));var S;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var A;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function E(m){const g=m;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=E;var I;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function C(m){const g=m;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=C;function p(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(be[126],ve([1,0,5,256]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function P(S){const D=S;return typeof S=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=P}),define(be[257],ve([1,0,9,254,12,109,81,122,125,83,126,13,206,121]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let m=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(w,d,b,c,f,u,i,n,r,o){this.a=w,this.b=d,this.c=b,this.d=c,this.e=f,this.f=u,this.g=i,this.h=n,this.i=r,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(w,d,b,c,f,u,i,n){await this.c.whenRemoteConfigurationLoaded();const r=Object.create(null),o=b?(0,v.withNullAsUndefined)(this.d.getWorkspaceFolder(b)):void 0;let a;try{a=(await this.e.resolveAnyMap(o,{shellLaunchConfig:w,configuration:d})).resolvedVariables}catch(ie){this.h.error(ie)}if(a)for(const[ie,M]of a.entries())(/^config:/.test(ie)||ie==="selectedText"||ie==="lineNumber")&&(r[ie]=M);const l=[];for(const[ie,M]of this.f.collections.entries())l.push([ie,(0,A.serializeEnvironmentVariableCollection)(M.map)]);const s=await this.g.resolveAuthority(this.a),h=s.options&&s.options.extensionHostEnv,T=this.d.getWorkspace(),F=T.folders,Z=b?this.d.getWorkspaceFolder(b):null,ne=E.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:E.SideBySideEditor.PRIMARY,filterByScheme:[k.Schemas.file,k.Schemas.vscodeUserData,k.Schemas.vscodeRemote]}),ce={configuration:d,resolvedVariables:r,envVariableCollections:l,shellLaunchConfig:w,workspaceId:T.id,workspaceName:this.j.getWorkspaceLabel(T),workspaceFolders:F,activeWorkspaceFolder:Z,activeFileResource:ne,shouldPersistTerminal:f,options:c,cols:u,rows:i,unicodeVersion:n,resolverEnv:h};return await this.b.call("$createProcess",ce)}requestDetachInstance(w,d){return this.b.call("$requestDetachInstance",[w,d])}acceptDetachInstanceReply(w,d){return this.b.call("$acceptDetachInstanceReply",[w,d])}attachToProcess(w){return this.b.call("$attachToProcess",[w])}detachFromProcess(w,d){return this.b.call("$detachFromProcess",[w,d])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(w,d){return this.b.call("$processBinary",[w,d])}start(w){return this.b.call("$start",[w])}input(w,d){return this.b.call("$input",[w,d])}acknowledgeDataEvent(w,d){return this.b.call("$acknowledgeDataEvent",[w,d])}setUnicodeVersion(w,d){return this.b.call("$setUnicodeVersion",[w,d])}shutdown(w,d){return this.b.call("$shutdown",[w,d])}resize(w,d,b){return this.b.call("$resize",[w,d,b])}getInitialCwd(w){return this.b.call("$getInitialCwd",[w])}getCwd(w){return this.b.call("$getCwd",[w])}orphanQuestionReply(w){return this.b.call("$orphanQuestionReply",[w])}sendCommandResult(w,d,b){return this.b.call("$sendCommandResult",[w,d,b])}freePortKillProcess(w){return this.b.call("$freePortKillProcess",[w])}installAutoReply(w,d){return this.b.call("$installAutoReply",[w,d])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(w){return this.b.call("$getDefaultSystemShell",[w])}getProfiles(w,d,b){return this.b.call("$getProfiles",[this.d.getWorkspace().id,w,d,b])}acceptPtyHostResolvedVariables(w,d){return this.b.call("$acceptPtyHostResolvedVariables",[w,d])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(w){return this.b.call("$getWslPath",[w])}setTerminalLayoutInfo(w){const b={workspaceId:this.d.getWorkspace().id,tabs:w?w.tabs:[]};return this.b.call("$setTerminalLayoutInfo",b)}updateTitle(w,d,b){return this.b.call("$updateTitle",[w,d,b])}updateIcon(w,d,b,c){return this.b.call("$updateIcon",[w,d,b,c])}refreshProperty(w,d){return this.b.call("$refreshProperty",[w,d])}updateProperty(w,d,b){return this.b.call("$updateProperty",[w,d,b])}getTerminalLayoutInfo(){const d={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",d)}reviveTerminalProcesses(w,d){return this.b.call("$reviveTerminalProcesses",[w,d])}getRevivedPtyNewId(w){return this.b.call("$getRevivedPtyNewId",[w])}serializeTerminalState(w){return this.b.call("$serializeTerminalState",[w])}};m=Le([Oe(2,t.IWorkbenchConfigurationService),Oe(3,D.IWorkspaceContextService),Oe(4,y.IConfigurationResolverService),Oe(5,p.IEnvironmentVariableService),Oe(6,S.IRemoteAuthorityResolverService),Oe(7,P.ILogService),Oe(8,I.IEditorService),Oe(9,C.ILabelService)],m),e.RemoteTerminalChannelClient=m}),define(be[258],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var v;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(v=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class P{constructor(){this.type=2}serialize(k){k[P.ENV_KEY]="1"}}e.SocketExtHostConnection=P,P.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class S{constructor(){this.type=3}serialize(k){k[S.ENV_KEY]="1"}}e.MessagePortExtHostConnection=S,S.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(I){delete I[t.ENV_KEY],delete I[P.ENV_KEY],delete I[S.ENV_KEY]}function A(I,k){D(k),I.serialize(k)}e.writeExtHostConnection=A;function y(I){if(I[t.ENV_KEY])return E(I,new t(I[t.ENV_KEY]));if(I[P.ENV_KEY])return E(I,new P);if(I[S.ENV_KEY])return E(I,new S);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function E(I,k){return D(I),k}}),define(be[127],ve([1,0,47,93,82,13,7,16,6,59,80,12,40,3,57,118,2,258]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function b(r={},o,a,l,s){const h=await(0,P.getNLSConfiguration)(a,l.userDataPath);let T={};if(o)try{T=await(0,I.getResolvedShellEnv)(s,l.args,process.env)}catch(M){s.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",M)}const Z={...process.env,...T,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(h,void 0,0),...r},ne=l.isBuilt?(0,D.join)(l.appRoot,"bin"):(0,D.join)(l.appRoot,"resources","server","bin-dev"),ce=(0,D.join)(ne,"remote-cli");let ie=u(Z,"PATH");return ie?ie=ce+D.delimiter+ie:ie=ce,i(Z,"PATH",ie),l.args["without-browser-env-var"]||(Z.BROWSER=(0,D.join)(ne,"helpers",p.isWindows?"browser.cmd":"browser.sh")),n(Z),Z}e.buildUserEnvironment=b;class c{constructor(o,a){this.socket=o,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let o,a,l;return this.socket instanceof E.NodeSocket?(o=!0,a=!1,l=A.VSBuffer.alloc(0)):(o=!1,a=this.socket.permessageDeflate,l=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:o,permessageDeflate:a,inflateBytes:l.buffer.toString("base64")}}}let f=class{constructor(o,a,l,s,h,T,F){this.i=o,this.j=h,this.l=T,this.m=F,this.b=new y.Emitter,this.onClose=this.b.event,this.c=!p.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new c(l,s),this.o("New connection established.")}get n(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}o(o){this.l.info(`${this.n}${o}`)}p(o){this.l.error(`${this.n}${o}`)}async q(o,a){const l=new w.DisposableStore;l.add(a.socket),l.add((0,w.toDisposable)(()=>{o.destroy()}));const s=()=>{l.dispose()};l.add(a.socket.onEnd(s)),l.add(a.socket.onClose(s)),l.add(y.Event.fromNodeEventEmitter(o,"end")(s)),l.add(y.Event.fromNodeEventEmitter(o,"close")(s)),l.add(y.Event.fromNodeEventEmitter(o,"error")(s)),l.add(a.socket.onData(h=>o.write(h.buffer))),l.add(y.Event.fromNodeEventEmitter(o,"data")(h=>{a.socket.write(A.VSBuffer.wrap(h))})),a.initialDataChunk.byteLength>0&&o.write(a.initialDataChunk.buffer)}async r(o,a){await a.socketDrain();const l=a.toIExtHostSocketMessage();let s;a.socket instanceof E.NodeSocket?s=a.socket.socket:s=a.socket.socket.socket,o.send(l,s)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const o={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(o)}acceptReconnection(o,a,l){this.f=o,this.o("The client has reconnected.");const s=new c(a,l);if(!this.g){this.h=s;return}this.r(this.g,s)}s(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(o){try{let a=process.execArgv?process.execArgv.filter(ie=>!/^--inspect(-brk)?=/.test(ie)):[];o.port&&!process.pkg&&(a=[`--inspect${o.break?"-brk":""}=${o.port}`]);const l=await b(o.env,!0,o.language,this.j,this.l);(0,m.removeDangerousEnvVariables)(l);let s;if(this.c)(0,d.writeExtHostConnection)(new d.SocketExtHostConnection,l),s=null;else{const{namedPipeServer:ie,pipeName:M}=await this.t();(0,d.writeExtHostConnection)(new d.IPCExtHostConnection(M),l),s=ie}const h={env:l,execArgv:a,silent:!0},T=["--type=extensionHost","--transformURIs"],F=this.j.args["use-host-proxy"];T.push(`--useHostProxy=${F?"true":"false"}`),this.g=v.fork(S.FileAccess.asFileUri("bootstrap-fork").fsPath,T,h);const Z=this.g.pid;this.o(`<${Z}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const ne=y.Event.fromNodeEventEmitter(this.g.stdout,"data"),ce=y.Event.fromNodeEventEmitter(this.g.stderr,"data");if(ne(ie=>this.o(`<${Z}> ${ie}`)),ce(ie=>this.o(`<${Z}><stderr> ${ie}`)),this.g.on("error",ie=>{this.p(`<${Z}> Extension Host Process had an error`),this.l.error(ie),this.s()}),this.g.on("exit",(ie,M)=>{this.m.setExitInfo(this.i,{code:ie,signal:M}),this.o(`<${Z}> Extension Host Process exited with code: ${ie}, signal: ${M}.`),this.s()}),s)s.on("connection",ie=>{s.close(),this.q(ie,this.h)});else{const ie=M=>{M.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",ie),this.r(this.g,this.h),this.h=null)};this.g.on("message",ie)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}t(){return new Promise((o,a)=>{const l=(0,E.createRandomIPCHandle)(),s=t.createServer();s.on("error",a),s.listen(l,()=>{s?.removeListener("error",a),o({pipeName:l,namedPipeServer:s})})})}};f=Le([Oe(4,C.IServerEnvironmentService),Oe(5,k.ILogService),Oe(6,g.IExtensionHostStatusService)],f),e.ExtensionHostConnection=f;function u(r,o){const a=Object.keys(r).filter(s=>s.toLowerCase()===o.toLowerCase()),l=a.length>0?a[0]:o;return r[l]}function i(r,o,a){const l=Object.keys(r).filter(h=>h.toLowerCase()===o.toLowerCase()),s=l.length>0?l[0]:o;r[s]=a}function n(r){for(const o of Object.keys(r))r[o]===null&&delete r[o]}}),define(be[259],ve([1,0,6,4,5,32,33]),function(re,e,v,t,P,S,D){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class y{constructor(l){this.affinity=l,this.kind=1}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class E{constructor(l){this.affinity=l,this.kind=2}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=E;class I{constructor(){this.kind=3,this.affinity=0}equals(l){return this.kind===l.kind}asString(){return"Remote"}}e.RemoteRunningLocation=I;class k{constructor(l){this.dependency=l}}e.MissingExtensionDependency=k;var C;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(C=e.ExtensionHostKind||(e.ExtensionHostKind={}));function p(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=p;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(l,s){const h=[],T=[],F=[],Z=[],ne=d(this.c),ce=d(l),ie=(V,X)=>V.extensionLocation.toString()===X.extensionLocation.toString()||V.isBuiltin===X.isBuiltin||V.isUserBuiltin===X.isUserBuiltin||V.isUnderDevelopment===X.isUnderDevelopment;for(const V of this.c){const X=ce.get(S.ExtensionIdentifier.toKey(V.identifier));if(!X){h.push(V.identifier),ne.delete(S.ExtensionIdentifier.toKey(V.identifier));continue}if(!ie(V,X)){h.push(V.identifier),ne.delete(S.ExtensionIdentifier.toKey(V.identifier));continue}}for(const V of l){const X=ne.get(S.ExtensionIdentifier.toKey(V.identifier));if(!X){T.push(V);continue}if(!ie(X,V)){h.push(X.identifier),ne.delete(S.ExtensionIdentifier.toKey(X.identifier));continue}}const M=w(this.d),J=w(s);for(const V of this.d)J.has(S.ExtensionIdentifier.toKey(V))||F.push(V);for(const V of s)M.has(S.ExtensionIdentifier.toKey(V))||Z.push(V);const $={toRemove:h,toAdd:T,myToRemove:F,myToAdd:Z};return this.delta($),$}delta(l){const{toRemove:s,toAdd:h,myToRemove:T,myToAdd:F}=l,Z=w(s),ne=w(T);for(let ce=0;ce<this.c.length;ce++)Z.has(S.ExtensionIdentifier.toKey(this.c[ce].identifier))&&(this.c.splice(ce,1),ce--);for(let ce=0;ce<this.d.length;ce++)ne.has(S.ExtensionIdentifier.toKey(this.d[ce]))&&(this.d.splice(ce,1),ce--);for(const ce of h)this.c.push(ce);for(const ce of F)this.d.push(ce)}containsExtension(l){for(const s of this.d)if(S.ExtensionIdentifier.equals(s,l))return!0;return!1}}e.ExtensionHostExtensions=m;class g{constructor(l){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=S.ExtensionIdentifier.toKey,l)for(const s of l)this.add(s)}get size(){return this.c.size}add(l){return this.c.set(this.d(l),l),this}clear(){this.c.clear()}delete(l){return this.c.delete(this.d(l))}has(l){return this.c.has(this.d(l))}forEach(l,s){this.c.forEach(h=>l.call(s,h,h,this))}*entries(){for(const[l,s]of this.c)yield[s,s]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=g;function w(a){const l=new Set;for(const s of a)l.add(S.ExtensionIdentifier.toKey(s));return l}e.extensionIdentifiersArrayToSet=w;function d(a){const l=new Map;for(const s of a)l.set(S.ExtensionIdentifier.toKey(s.identifier),s);return l}function b(a,l){return!0}e.isProposedApiEnabled=b;function c(a,l){if(!b(a,l))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=c;class f{constructor(l,s,h,T){this.codeLoadingTime=l,this.activateCallTime=s,this.activateResolvedTime=h,this.activationReason=T}}e.ActivationTimes=f;class u{constructor(l,s){this.description=l,this.value=s}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function n(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=n;function r(a,l){return{identifier:new S.ExtensionIdentifier((0,D.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!l,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=r;class o{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(l,s){return Promise.resolve(0)}getInspectPorts(l,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=o});var Ot=this&&this.__classPrivateFieldSet||function(re,e,v,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(re,v):P?P.value=v:e.set(re,v),v},it=this&&this.__classPrivateFieldGet||function(re,e,v,t){if(v==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?t:v==="a"?t.call(re):t?t.value:e.get(re)};define(be[128],ve([1,0,18,8,90,26,56,15,9,4,21,17,109,120,259]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m){"use strict";var g,w,d,b,c,f,u,i,n,r,o,a,l,s,h,T,F,Z,ne,ce,ie,M,J;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function $(B){return Object.assign(B,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(B,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[te,...we]=arguments;return Reflect.construct(B,we,te.constructor)}}})}var V;(function(B){B.top="top",B.bottom="bottom"})(V=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var X;(function(B){B.command="command",B.opener="opener"})(X=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let ue=f=class{static from(...O){let te=O;return new f(function(){if(te){for(const we of te)we&&typeof we.dispose=="function"&&we.dispose();te=void 0}})}constructor(O){g.set(this,void 0),Ot(this,g,O,"f")}dispose(){typeof it(this,g,"f")=="function"&&(it(this,g,"f").call(this),Ot(this,g,void 0,"f"))}};g=new WeakMap,ue=f=Le([$],ue),e.Disposable=ue;let L=u=class{static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let we=1;we<O.length;we++){const Ue=O[we];Ue.isBefore(te)&&(te=Ue)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let we=1;we<O.length;we++){const Ue=O[we];Ue.isAfter(te)&&(te=Ue)}return te}static isPosition(O){if(!O)return!1;if(O instanceof u)return!0;const{line:te,character:we}=O;return typeof te=="number"&&typeof we=="number"}static of(O){if(O instanceof u)return O;if(this.isPosition(O))return new u(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,te){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(te<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=O,this.e=te}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,te=0){if(O===null||te===null)throw(0,t.illegalArgument)();let we;return typeof O>"u"?we=0:typeof O=="number"?we=O:(we=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),we===0&&te===0?this:new u(this.line+we,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,t.illegalArgument)();let we;return typeof O>"u"?we=this.line:typeof O=="number"?we=O:(we=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),we===this.line&&te===this.character?this:new u(we,te)}toJSON(){return{line:this.line,character:this.character}}};L=u=Le([$],L),e.Position=L;let N=i=class{static isRange(O){return O instanceof i?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}static of(O){if(O instanceof i)return O;if(this.isRange(O))return new i(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,te,we,Ue){let We,Ze;if(typeof O=="number"&&typeof te=="number"&&typeof we=="number"&&typeof Ue=="number"?(We=new L(O,te),Ze=new L(we,Ue)):L.isPosition(O)&&L.isPosition(te)&&(We=L.of(O),Ze=L.of(te)),!We||!Ze)throw new Error("Invalid arguments");We.isBefore(Ze)?(this.c=We,this.e=Ze):(this.c=Ze,this.e=We)}contains(O){return i.isRange(O)?this.contains(O.start)&&this.contains(O.end):L.isPosition(O)?!(L.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const te=L.Max(O.start,this.c),we=L.Min(O.end,this.e);if(!te.isAfter(we))return new i(te,we)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=L.Min(O.start,this.c),we=L.Max(O.end,this.end);return new i(te,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,te=this.end){if(O===null||te===null)throw(0,t.illegalArgument)();let we;return O?L.isPosition(O)?we=O:(we=O.start||this.start,te=O.end||this.end):we=this.start,we.isEqual(this.c)&&te.isEqual(this.end)?this:new i(we,te)}toJSON(){return[this.start,this.end]}};N=i=Le([$],N),e.Range=N;let H=n=class extends N{static isSelection(O){return O instanceof n?!0:O?N.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,te,we,Ue){let We,Ze;if(typeof O=="number"&&typeof te=="number"&&typeof we=="number"&&typeof Ue=="number"?(We=new L(O,te),Ze=new L(we,Ue)):L.isPosition(O)&&L.isPosition(te)&&(We=L.of(O),Ze=L.of(te)),!We||!Ze)throw new Error("Invalid arguments");super(We,Ze),this.f=We,this.g=Ze}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};H=n=Le([$],H),e.Selection=H;class ee{constructor(O,te,we){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,t.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(te),this.connectionToken=we}}e.ResolvedAuthority=ee;class ae extends Error{static NotAvailable(O,te){return new ae(O,C.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new ae(O,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,te=C.RemoteAuthorityResolverErrorCode.Unknown,we){super(O),this._message=O,this._code=te,this._detail=we,Object.setPrototypeOf(this,ae.prototype)}}e.RemoteAuthorityResolverError=ae;var ge;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var fe;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(fe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let R=r=class{static isTextEdit(O){return O instanceof r?!0:O?N.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new r(O,te)}static insert(O,te){return r.replace(new N(O,O),te)}static delete(O){return r.replace(O,"")}static setEndOfLine(O){const te=new r(new N(new L(0,0),new L(0,0)),"");return te.newEol=O,te}get range(){return this.c}set range(O){if(O&&!N.isRange(O))throw(0,t.illegalArgument)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this.f=O}constructor(O,te){this.c=O,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};R=r=Le([$],R),e.TextEdit=R;let U=o=class{static isNotebookCellEdit(O){return O instanceof o?!0:O?Tt.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,te){return new o(O,te)}static insertCells(O,te){return new o(new Tt(O,O),te)}static deleteCells(O){return new o(O,[])}static updateCellMetadata(O,te){const we=new o(new Tt(O,O),[]);return we.newCellMetadata=te,we}static updateNotebookMetadata(O){const te=new o(new Tt(0,0),[]);return te.newNotebookMetadata=O,te}constructor(O,te){this.range=O,this.newCells=te}};U=o=Le([$],U),e.NotebookEdit=U;class W{static isSnippetTextEdit(O){return O instanceof W?!0:O?N.isRange(O.range)&&de.isSnippetString(O.snippet):!1}static replace(O,te){return new W(O,te)}static insert(O,te){return W.replace(new N(O,O),te)}constructor(O,te){this.range=O,this.snippet=te}}e.SnippetTextEdit=W;var Q;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Q=e.FileEditType||(e.FileEditType={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,te,we,Ue){this.c.push({_type:1,from:O,to:te,options:we,metadata:Ue})}createFile(O,te,we){this.c.push({_type:1,from:void 0,to:O,options:te,metadata:we})}deleteFile(O,te,we){this.c.push({_type:1,from:O,to:void 0,options:te,metadata:we})}e(O,te,we){this.c.push({_type:3,metadata:we,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}f(O,te,we,Ue){const We=te.start,Ze=te.end;(We!==Ze||we.length>0)&&this.c.push({_type:5,uri:O,index:We,count:Ze-We,cells:we,metadata:Ue})}g(O,te,we,Ue){this.c.push({_type:3,metadata:Ue,uri:O,edit:{editType:8,index:te,metadata:we}})}replace(O,te,we,Ue){this.c.push({_type:2,uri:O,edit:new R(te,we),metadata:Ue})}insert(O,te,we,Ue){this.replace(O,new N(te,te),we,Ue)}delete(O,te,we){this.replace(O,te,"",we)}has(O){return this.c.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const we of te){if(!we)continue;let Ue,We;Array.isArray(we)?(Ue=we[0],We=we[1]):Ue=we,U.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(O,Ue.range.start,Ue.newCellMetadata,We):Ue.newNotebookMetadata?this.e(O,Ue.newNotebookMetadata,We):this.f(O,Ue.range,Ue.newCells,We):W.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:O,range:Ue.range,edit:Ue.snippet,metadata:We}):this.c.push({_type:2,uri:O,edit:Ue,metadata:We})}else{for(let we=0;we<this.c.length;we++){const Ue=this.c[we];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===O.toString()&&(this.c[we]=void 0);break}}(0,v.coalesceInPlace)(this.c)}}get(O){const te=[];for(const we of this.c)we._type===2&&we.uri.toString()===O.toString()&&te.push(we.edit);return te}entries(){const O=new S.ResourceMap;for(const te of this.c)if(te._type===2){let we=O.get(te.uri);we||(we=[te.uri,[]],O.set(te.uri,we)),we[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};se=Le([$],se),e.WorkspaceEdit=se;let de=a=class{static isSnippetString(O){return O instanceof a?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=a.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this.e++){if(typeof O=="function"){const we=new a;we.e=this.e,O(we),this.e=we.e,O=we.value}else O=a.c(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this.e++){const we=O.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const we=new a;we.e=this.e,te(we),this.e=we.e,te=we.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};de=a=Le([$],de),e.SnippetString=de;var z;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(z=e.DiagnosticTag||(e.DiagnosticTag={}));var Y;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(Y=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let _=l=class{static isLocation(O){return O instanceof l?!0:O?N.isRange(O.range)&&E.URI.isUri(O.uri):!1}constructor(O,te){if(this.uri=O,te)if(N.isRange(te))this.range=N.of(te);else if(L.isPosition(te))this.range=new N(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};_=l=Le([$],_),e.Location=_;let j=class{static is(O){return O?typeof O.message=="string"&&O.location&&N.isRange(O.location.range)&&E.URI.isUri(O.location.uri):!1}constructor(O,te){this.location=O,this.message=te}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};j=Le([$],j),e.DiagnosticRelatedInformation=j;let q=class{constructor(O,te,we=Y.Error){if(!N.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=we}toJSON(){return{severity:Y[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,v.equals)(O.tags,te.tags)&&(0,v.equals)(O.relatedInformation,te.relatedInformation,j.isEqual)}};q=Le([$],q),e.Diagnostic=q;let G=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};G=Le([$],G),e.Hover=G;var x;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(x=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let oe=class{constructor(O,te=x.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:x[this.kind]}}};oe=Le([$],oe),e.DocumentHighlight=oe;var pe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(pe=e.SymbolKind||(e.SymbolKind={}));var ke;(function(B){B[B.Deprecated=1]="Deprecated"})(ke=e.SymbolTag||(e.SymbolTag={}));let Ae=s=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,te,we,Ue,We){this.name=O,this.kind=te,this.containerName=We,typeof we=="string"&&(this.containerName=we),Ue instanceof _?this.location=Ue:we instanceof N&&(this.location=new _(Ue,we)),s.validate(this)}toJSON(){return{name:this.name,kind:pe[this.kind],location:this.location,containerName:this.containerName}}};Ae=s=Le([$],Ae),e.SymbolInformation=Ae;let Fe=h=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(h.validate)}constructor(O,te,we,Ue,We){this.name=O,this.detail=te,this.kind=we,this.range=Ue,this.selectionRange=We,this.children=[],h.validate(this)}};Fe=h=Le([$],Fe),e.DocumentSymbol=Fe;var je;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let me=class{constructor(O,te){this.title=O,this.kind=te}};me=Le([$],me),e.CodeAction=me;let ye=T=class{constructor(O){this.value=O}append(O){return new T(this.value?this.value+T.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+T.c)}};ye.c=".",ye=T=Le([$],ye),e.CodeActionKind=ye,ye.Empty=new ye(""),ye.QuickFix=ye.Empty.append("quickfix"),ye.Refactor=ye.Empty.append("refactor"),ye.RefactorExtract=ye.Refactor.append("extract"),ye.RefactorInline=ye.Refactor.append("inline"),ye.RefactorMove=ye.Refactor.append("move"),ye.RefactorRewrite=ye.Refactor.append("rewrite"),ye.Source=ye.Empty.append("source"),ye.SourceOrganizeImports=ye.Source.append("organizeImports"),ye.SourceFixAll=ye.Source.append("fixAll");let Ee=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=Le([$],Ee),e.SelectionRange=Ee;class Me{constructor(O,te,we,Ue,We,Ze){this.kind=O,this.name=te,this.detail=we,this.uri=Ue,this.range=We,this.selectionRange=Ze}}e.CallHierarchyItem=Me;class Be{constructor(O,te){this.fromRanges=te,this.from=O}}e.CallHierarchyIncomingCall=Be;class Je{constructor(O,te){this.fromRanges=te,this.to=O}}e.CallHierarchyOutgoingCall=Je;var He;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Xe=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};Xe=Le([$],Xe),e.CodeLens=Xe;let Ke=F=class{static isMarkdownString(O){return O instanceof F?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,te=!1){w.set(this,void 0),Ot(this,w,new P.MarkdownString(O,{supportThemeIcons:te}),"f")}get value(){return it(this,w,"f").value}set value(O){it(this,w,"f").value=O}get isTrusted(){return it(this,w,"f").isTrusted}set isTrusted(O){it(this,w,"f").isTrusted=O}get supportThemeIcons(){return it(this,w,"f").supportThemeIcons}set supportThemeIcons(O){it(this,w,"f").supportThemeIcons=O}get supportHtml(){return it(this,w,"f").supportHtml}set supportHtml(O){it(this,w,"f").supportHtml=O}get baseUri(){return it(this,w,"f").baseUri}set baseUri(O){it(this,w,"f").baseUri=O}appendText(O){return it(this,w,"f").appendText(O),this}appendMarkdown(O){return it(this,w,"f").appendMarkdown(O),this}appendCodeblock(O,te){return it(this,w,"f").appendCodeblock(te??"",O),this}};w=new WeakMap,Ke=F=Le([$],Ke),e.MarkdownString=Ke;let nt=class{constructor(O,te){this.label=O,this.documentation=te}};nt=Le([$],nt),e.ParameterInformation=nt;let Qe=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};Qe=Le([$],Qe),e.SignatureInformation=Qe;let Ve=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ve=Le([$],Ve),e.SignatureHelp=Ve;var Ge;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Ge=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var le;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(le=e.InlayHintKind||(e.InlayHintKind={}));let De=class{constructor(O){this.value=O}};De=Le([$],De),e.InlayHintLabelPart=De;let Ce=class{constructor(O,te,we){this.position=O,this.label=te,this.kind=we}};Ce=Le([$],Ce),e.InlayHint=Ce;var Te;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=Le([$],Ye),e.CompletionItem=Ye;let tt=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};tt=Le([$],tt),e.CompletionList=tt;let rt=class{constructor(O,te,we){this.insertText=O,this.range=te,this.command=we}};rt=Le([$],rt),e.InlineSuggestion=rt;let xe=class{constructor(O){this.commands=void 0,this.items=O}};xe=Le([$],xe),e.InlineSuggestionList=xe;var st;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(st=e.ViewColumn||(e.ViewColumn={}));var lt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var gt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(gt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var wt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(wt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var St;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(St=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Rt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Rt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function O(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(wt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Lt=class{constructor(O,te){if(te&&!E.URI.isUri(te))throw(0,t.illegalArgument)("target");if(!N.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=te}};Lt=Le([$],Lt),e.DocumentLink=Lt;let ht=class{constructor(O,te,we,Ue){this.red=O,this.green=te,this.blue=we,this.alpha=Ue}};ht=Le([$],ht),e.Color=ht;let At=class{constructor(O,te){if(te&&!(te instanceof ht))throw(0,t.illegalArgument)("color");if(!N.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=te}};At=Le([$],At),e.ColorInformation=At;let ot=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};ot=Le([$],ot),e.ColorPresentation=ot;var Ct;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Ct=e.ColorFormat||(e.ColorFormat={}));var dt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(dt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var pt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(pt=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(O,te,we){if(this.startIndex=O,this.length=te,this.tooltip=we,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,t.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Se;var Ie;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Ie=e.TerminalLocation||(e.TerminalLocation={}));class he{constructor(O){if(this.options=O,typeof O!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=he;var K;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(K=e.TaskRevealKind||(e.TaskRevealKind={}));var Pe;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Pe=e.TaskPanelKind||(e.TaskPanelKind={}));let Re=Z=class{static from(O){switch(O){case"clean":return Z.Clean;case"build":return Z.Build;case"rebuild":return Z.Rebuild;case"test":return Z.Test;default:return}}constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,t.illegalArgument)("name");this.c=O}get id(){return this.c}};Re.Clean=new Z("clean","Clean"),Re.Build=new Z("build","Build"),Re.Rebuild=new Z("rebuild","Rebuild"),Re.Test=new Z("test","Test"),Re=Z=Le([$],Re),e.TaskGroup=Re;function qe(B){let O="";for(let te=0;te<B.length;te++)O+=B[te].replace(/,/g,",,")+",";return O}let $e=class{constructor(O,te,we){if(typeof O!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=O,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=we):this.f=te)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const te of this.e)O.push(te);return qe(O)}};$e=Le([$],$e),e.ProcessExecution=$e;let et=class{constructor(O,te,we){if(this.f=[],Array.isArray(te)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this.e=O,this.f=te,this.g=we}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this.c=O,this.g=te}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)O.push(typeof te=="string"?te:te.value);return qe(O)}};et=Le([$],et),e.ShellExecution=et;var ut;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var It;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(It=e.TaskScope||(e.TaskScope={}));class Et{constructor(O){this.c=O}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(O){this.c=O}get callback(){return this.c}}e.CustomExecution=Et;let at=ne=class{constructor(O,te,we,Ue,We,Ze){this.j=!1,this.k=this.definition=O;let _e;typeof te=="string"?(this.m=this.name=te,this.t=this.source=we,this.execution=Ue,_e=We,this.j=!0):te===It.Global||te===It.Workspace?(this.target=te,this.m=this.name=we,this.t=this.source=Ue,this.execution=We,_e=Ze):(this.target=te,this.m=this.name=we,this.t=this.source=Ue,this.execution=We,_e=Ze),typeof _e=="string"?(this.o=[_e],this.q=!0):Array.isArray(_e)?(this.o=_e,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(O){this.h=O}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof $e?this.k={type:ne.e,id:this.n.computeId()}:this.n instanceof et?this.k={type:ne.f,id:this.n.computeId()}:this.n instanceof Et?this.k={type:ne.c,id:this.n.computeId()}:this.k={type:ne.g,id:(0,I.generateUuid)()}}get definition(){return this.k}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=O}get scope(){return this.l}set target(O){this.y(),this.l=O}get name(){return this.m}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=O}get execution(){return this.n}set execution(O){O===null&&(O=void 0),this.y(),this.n=O;const te=this.k.type;(ne.g===te||ne.e===te||ne.f===te||ne.c===te)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(O){if(Array.isArray(O))this.y(),this.o=O,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.y(),this.r=O}get source(){return this.t}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=O}get group(){return this.u}set group(O){O===null&&(O=void 0),this.y(),this.u=O}get detail(){return this.x}set detail(O){O===null&&(O=void 0),this.x=O}get presentationOptions(){return this.v}set presentationOptions(O){O==null&&(O=Object.create(null)),this.y(),this.v=O}get runOptions(){return this.w}set runOptions(O){O==null&&(O=Object.create(null)),this.y(),this.w=O}};at.c="customExecution",at.e="process",at.f="shell",at.g="$empty",at=ne=Le([$],at),e.Task=at;var Dt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Dt=e.ProgressLocation||(e.ProgressLocation={}));var Dn;(function(B){function O(te){const we=te;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}B.isViewBadge=O})(Dn=e.ViewBadge||(e.ViewBadge={}));let Vt=ce=class{static isTreeItem(O,te){if(O instanceof ce)return!0;const we=O;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!E.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const Ue=we.iconPath;if(!Ue||!(0,y.isString)(Ue.light)&&!E.URI.isUri(Ue.light)&&!(0,y.isString)(Ue.dark)&&!E.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!E.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof Ke))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<$t.None&&we.collapsibleState>$t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ue=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,We=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==qt.Checked&&Ue!==qt.Unchecked||We!==void 0&&!(0,y.isString)(We))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(O,te=$t.None){this.collapsibleState=te,E.URI.isUri(O)?this.resourceUri=O:this.label=O}};Vt=ce=Le([$],Vt),e.TreeItem=Vt;var $t;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var qt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(qt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O,te){this.value=O,this.id=te??(0,I.generateUuid)()}};Gt=Le([$],Gt),e.DataTransferItem=Gt;let Kt=class{constructor(O){d.set(this,new Map);for(const[te,we]of O??[]){const Ue=it(this,d,"f").get(te);Ue?Ue.push(we):it(this,d,"f").set(te,[we])}}get(O){return it(this,d,"f").get(O)?.[0]}set(O,te){it(this,d,"f").set(O,[te])}forEach(O,te){for(const[we,Ue]of it(this,d,"f"))for(const We of Ue)O.call(te,We,we,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[O,te]of it(this,d,"f"))for(const we of te)yield[O,we]}};Kt=Le([$],Kt),e.DataTransfer=Kt;let Yt=class{constructor(O){this.insertText=O}};Yt=Le([$],Yt),e.DocumentDropEdit=Yt;let Jt=class{constructor(O){this.insertText=O}};Jt=Le([$],Jt),e.DocumentPasteEdit=Jt;let Pt=class{constructor(O,te){this.id=O,this.color=te}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};Pt=Le([$],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Xt=class{constructor(O){this.id=O}};Xt=Le([$],Xt),e.ThemeColor=Xt;var Pn;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Pn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Qt=class{get base(){return this.c}set base(O){this.c=O,this.e=E.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,te){if(typeof O!="string"&&(!O||!E.URI.isUri(O)&&!E.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof te!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?this.baseUri=E.URI.file(O):E.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Qt=Le([$],Qt),e.RelativePattern=Qt;let Ft=class{constructor(O,te,we,Ue){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof we=="string"&&(this.hitCondition=we),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=(0,I.generateUuid)()),this.c}};Ft=Le([$],Ft),e.Breakpoint=Ft;let Zt=class extends Ft{constructor(O,te,we,Ue,We){if(super(te,we,Ue,We),O===null)throw(0,t.illegalArgument)("location");this.location=O}};Zt=Le([$],Zt),e.SourceBreakpoint=Zt;let xt=class extends Ft{constructor(O,te,we,Ue,We){super(te,we,Ue,We),this.functionName=O}};xt=Le([$],xt),e.FunctionBreakpoint=xt;let _t=class extends Ft{constructor(O,te,we,Ue,We,Ze,_e){if(super(Ue,We,Ze,_e),!te)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=te,this.canPersist=we}};_t=Le([$],_t),e.DataBreakpoint=_t;let en=class{constructor(O,te,we){this.command=O,this.args=te||[],this.options=we}};en=Le([$],en),e.DebugAdapterExecutable=en;let tn=class{constructor(O,te){this.port=O,this.host=te}};tn=Le([$],tn),e.DebugAdapterServer=tn;let nn=class{constructor(O){this.path=O}};nn=Le([$],nn),e.DebugAdapterNamedPipeServer=nn;let rn=class{constructor(O){this.implementation=O}};rn=Le([$],rn),e.DebugAdapterInlineImplementation=rn;let sn=class{constructor(O,te){this.range=O,this.expression=te}};sn=Le([$],sn),e.EvaluatableExpression=sn;var kn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let on=class{constructor(O,te){this.range=O,this.text=te}};on=Le([$],on),e.InlineValueText=on;let an=class{constructor(O,te,we=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=we}};an=Le([$],an),e.InlineValueVariableLookup=an;let ln=class{constructor(O,te){this.range=O,this.expression=te}};ln=Le([$],ln),e.InlineValueEvaluatableExpression=ln;let cn=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};cn=Le([$],cn),e.InlineValueContext=cn;var An;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(An=e.FileChangeType||(e.FileChangeType={}));let un=ie=class extends Error{static FileExists(O){return new ie(O,k.FileSystemProviderErrorCode.FileExists,ie.FileExists)}static FileNotFound(O){return new ie(O,k.FileSystemProviderErrorCode.FileNotFound,ie.FileNotFound)}static FileNotADirectory(O){return new ie(O,k.FileSystemProviderErrorCode.FileNotADirectory,ie.FileNotADirectory)}static FileIsADirectory(O){return new ie(O,k.FileSystemProviderErrorCode.FileIsADirectory,ie.FileIsADirectory)}static NoPermissions(O){return new ie(O,k.FileSystemProviderErrorCode.NoPermissions,ie.NoPermissions)}static Unavailable(O){return new ie(O,k.FileSystemProviderErrorCode.Unavailable,ie.Unavailable)}constructor(O,te=k.FileSystemProviderErrorCode.Unknown,we){super(E.URI.isUri(O)?O.toString(!0):O),this.code=we?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,ie.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};un=ie=Le([$],un),e.FileSystemError=un;let fn=class{constructor(O,te,we){this.start=O,this.end=te,this.kind=we}};fn=Le([$],fn),e.FoldingRange=fn;var Tn;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Tn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rn;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Rn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ln;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ln=e.CommentMode||(e.CommentMode={}));var On;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(On=e.CommentThreadState||(e.CommentThreadState={}));class Nn{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.SemanticTokensLegend=Nn;function Fn(B){return typeof B>"u"||(0,y.isStringArray)(B)}class hn{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,O){this.l=!0;for(let te=0,we=O.tokenTypes.length;te<we;te++)this.j.set(O.tokenTypes[te],te);for(let te=0,we=O.tokenModifiers.length;te<we;te++)this.k.set(O.tokenModifiers[te],te)}}push(O,te,we,Ue,We){if(typeof O=="number"&&typeof te=="number"&&typeof we=="number"&&typeof Ue=="number"&&(typeof We=="number"||typeof We>"u"))return typeof We>"u"&&(We=0),this.n(O,te,we,Ue,We);if(N.isRange(O)&&typeof te=="string"&&Fn(we))return this.m(O,te,we);throw(0,t.illegalArgument)()}m(O,te,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(te))throw new Error("`tokenType` is not in the provided legend");const Ue=O.start.line,We=O.start.character,Ze=O.end.character-O.start.character,_e=this.j.get(te);let ct=0;if(we)for(const mt of we){if(!this.k.has(mt))throw new Error("`tokenModifier` is not in the provided legend");const vt=this.k.get(mt);ct|=1<<vt>>>0}this.n(Ue,We,Ze,_e,ct)}n(O,te,we,Ue,We){if(this.f&&(O<this.c||O===this.c&&te<this.e)){this.f=!1;const ct=this.g.length/5|0;let mt=0,vt=0;for(let yt=0;yt<ct;yt++){let kt=this.g[5*yt],Ut=this.g[5*yt+1];kt===0?(kt=mt,Ut+=vt):kt+=mt,this.g[5*yt]=kt,this.g[5*yt+1]=Ut,mt=kt,vt=Ut}}let Ze=O,_e=te;this.f&&this.h>0&&(Ze-=this.c,Ze===0&&(_e-=this.e)),this.g[this.h++]=Ze,this.g[this.h++]=_e,this.g[this.h++]=we,this.g[this.h++]=Ue,this.g[this.h++]=We,this.c=O,this.e=te}static o(O){const te=[],we=O.length/5|0;for(let _e=0;_e<we;_e++)te[_e]=_e;te.sort((_e,ct)=>{const mt=O[5*_e],vt=O[5*ct];if(mt===vt){const yt=O[5*_e+1],kt=O[5*ct+1];return yt-kt}return mt-vt});const Ue=new Uint32Array(O.length);let We=0,Ze=0;for(let _e=0;_e<we;_e++){const ct=5*te[_e],mt=O[ct+0],vt=O[ct+1],yt=O[ct+2],kt=O[ct+3],Ut=O[ct+4],In=mt-We,vi=In===0?vt-Ze:vt,Bt=5*_e;Ue[Bt+0]=In,Ue[Bt+1]=vi,Ue[Bt+2]=yt,Ue[Bt+3]=kt,Ue[Bt+4]=Ut,We=mt,Ze=vt}return Ue}build(O){return this.f?new dn(new Uint32Array(this.g),O):new dn(hn.o(this.g),O)}}e.SemanticTokensBuilder=hn;class dn{constructor(O,te){this.resultId=te,this.data=O}}e.SemanticTokens=dn;class Mn{constructor(O,te,we){this.start=O,this.deleteCount=te,this.data=we}}e.SemanticTokensEdit=Mn;class Un{constructor(O,te){this.resultId=te,this.edits=O}}e.SemanticTokensEdits=Un;var Bn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Bn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let jt=class{constructor(){}};jt.Back={iconPath:new Pt("arrow-left")},jt=Le([$],jt),e.QuickInputButtons=jt;var $n;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})($n=e.QuickPickItemKind||(e.QuickPickItemKind={}));var jn;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(jn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(zn=e.ExtensionKind||(e.ExtensionKind={}));class Wn{static validate(O){if(typeof O.badge=="string"){let te=(0,A.nextCharLength)(O.badge,0);if(te<O.badge.length&&(te+=(0,A.nextCharLength)(O.badge,te)),O.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!Pt.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,te,we){this.badge=O,this.tooltip=te,this.color=we}}e.FileDecoration=Wn;let mn=class{constructor(O){this.kind=O}};mn=Le([$],mn),e.ColorTheme=mn;var Hn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Hn=e.ColorThemeKind||(e.ColorThemeKind={}));class Tt{static isNotebookRange(O){return O instanceof Tt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,te){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(te<0)throw(0,t.illegalArgument)("end must be positive");O<=te?(this.c=O,this.e=te):(this.c=te,this.e=O)}with(O){let te=this.c,we=this.e;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(we=O.end),te===this.c&&we===this.e?this:new Tt(te,we)}}e.NotebookRange=Tt;class zt{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>zt.isNotebookCellData(te))}static isNotebookCellData(O){return!0}constructor(O,te,we,Ue,We,Ze,_e){this.kind=O,this.value=te,this.languageId=we,this.mime=Ue,this.outputs=We??[],this.metadata=Ze,this.executionSummary=_e,zt.validate(this)}}e.NotebookCellData=zt;class Vn{constructor(O){this.cells=O}}e.NotebookData=Vn;class bt{static isNotebookCellOutputItem(O){return O instanceof bt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return bt.json(te,"application/vnd.code.notebook.error")}static stdout(O){return bt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return bt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new bt(O,te)}static text(O,te=D.Mimes.text){const we=it(bt,b,"f",c).encode(String(O));return new bt(we,te)}static json(O,te="text/x-json"){const we=JSON.stringify(O,void 0,"	");return bt.text(we,te)}constructor(O,te){this.data=O,this.mime=te;const we=(0,D.normalizeMimeType)(te,!0);if(!we)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=bt,b=bt,c={value:new TextEncoder};class Wt{static isNotebookCellOutput(O){return O instanceof Wt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,te=!1){const we=new Set,Ue=new Set;for(let We=0;We<O.length;We++){const Ze=O[We],_e=(0,D.normalizeMimeType)(Ze.mime);if(!we.has(_e)||(0,p.isTextStreamMime)(_e)){we.add(_e);continue}Ue.add(We),te&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Ue.size===0?O:O.filter((We,Ze)=>!Ue.has(Ze))}constructor(O,te,we){this.items=Wt.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=we):(this.id=(0,I.generateUuid)(),this.metadata=te??we)}}e.NotebookCellOutput=Wt;var qn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(qn=e.NotebookCellKind||(e.NotebookCellKind={}));var Gn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Gn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Kn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Yn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Yn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Jn{constructor(O,te){this.text=O,this.alignment=te}}e.NotebookCellStatusBarItem=Jn;var Xn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Xn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Qn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Qn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Zn{constructor(O,te=[]){this.uri=O,this.provides=(0,v.asArray)(te)}}e.NotebookRendererScript=Zn;class xn{constructor(O){this.label=O}}e.NotebookKernelSourceAction=xn;let gn=class{constructor(O,te){this.label=O,this.timestamp=te}};gn=Le([$],gn),e.TimelineItem=gn;var _n;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(_n=e.ExtensionMode||(e.ExtensionMode={}));var ei;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ei=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ti;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(ti=e.StandardTokenType||(e.StandardTokenType={}));class ni{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.LinkedEditingRanges=ni;class ii{constructor(O,te){this.c=O,this.e=te}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=ii;var ri;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(ri=e.TestResultState||(e.TestResultState={}));var si;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(si=e.TestRunProfileKind||(e.TestRunProfileKind={}));let wn=class{constructor(O=void 0,te=void 0,we=void 0){this.include=O,this.exclude=te,this.profile=we}};wn=Le([$],wn),e.TestRunRequest=wn;let pn=M=class{static diff(O,te,we){const Ue=new M(O);return Ue.expectedOutput=te,Ue.actualOutput=we,Ue}constructor(O){this.message=O}};pn=M=Le([$],pn),e.TestMessage=pn;let bn=class{constructor(O){this.id=O}};bn=Le([$],bn),e.TestTag=bn;let Mt=class{constructor(O,te){this.covered=O,this.total=te}};Mt=Le([$],Mt),e.CoveredCount=Mt;let vn=J=class{static fromDetails(O,te){const we=new Mt(0,0),Ue=new Mt(0,0),We=new Mt(0,0);for(const _e of te)if("branches"in _e){we.total+=1,we.covered+=_e.executionCount>0?1:0;for(const ct of _e.branches)Ue.total+=1,Ue.covered+=ct.executionCount>0?1:0}else We.total+=1,We.covered+=_e.executionCount>0?1:0;const Ze=new J(O,we,Ue.total>0?Ue:void 0,We.total>0?We:void 0);return Ze.detailedCoverage=te,Ze}constructor(O,te,we,Ue){this.uri=O,this.statementCoverage=te,this.branchCoverage=we,this.functionCoverage=Ue}};vn=J=Le([$],vn),e.FileCoverage=vn;let En=class{constructor(O,te,we=[]){this.executionCount=O,this.location=te,this.branches=we}};En=Le([$],En),e.StatementCoverage=En;let yn=class{constructor(O,te){this.executionCount=O,this.location=te}};yn=Le([$],yn),e.BranchCoverage=yn;let Sn=class{constructor(O,te){this.executionCount=O,this.location=te}};Sn=Le([$],Sn),e.FunctionCoverage=Sn;var oi;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(oi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ai;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ai=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var li;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(li=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ci{constructor(O,te,we,Ue,We,Ze){this.kind=O,this.name=te,this.detail=we,this.uri=Ue,this.range=We,this.selectionRange=Ze}}e.TypeHierarchyItem=ci;class ui{constructor(O){this.uri=O}}e.TextTabInput=ui;class fi{constructor(O,te){this.original=O,this.modified=te}}e.TextDiffTabInput=fi;class hi{constructor(O,te,we,Ue){this.base=O,this.input1=te,this.input2=we,this.result=Ue}}e.TextMergeTabInput=hi;class di{constructor(O,te){this.uri=O,this.viewType=te}}e.CustomEditorTabInput=di;class mi{constructor(O){this.viewType=O}}e.WebviewEditorTabInput=mi;class gi{constructor(O,te){this.uri=O,this.notebookType=te}}e.NotebookEditorTabInput=gi;class wi{constructor(O,te,we){this.original=O,this.modified=te,this.notebookType=we}}e.NotebookDiffEditorTabInput=wi;class pi{constructor(){}}e.TerminalEditorTabInput=pi;class bi{constructor(O,te){this.uri=O,this.inputBoxUri=te}}e.InteractiveWindowInput=bi}),define(be[129],ve([1,0,18,16,145,68,90,26,137,45,56,23,9,4,48,153,213,124,83,120,67,84,126,128]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f,u,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Se){function Ie(K){const{selectionStartLineNumber:Pe,selectionStartColumn:Re,positionLineNumber:qe,positionColumn:$e}=K,et=new n.Position(Pe-1,Re-1),ut=new n.Position(qe-1,$e-1);return new n.Selection(et,ut)}Se.to=Ie;function he(K){const{anchor:Pe,active:Re}=K;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}Se.from=he})(r=e.Selection||(e.Selection={}));var o;(function(Se){function Ie(K){if(!K)return;const{start:Pe,end:Re}=K;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}Se.from=Ie;function he(K){if(!K)return;const{startLineNumber:Pe,startColumn:Re,endLineNumber:qe,endColumn:$e}=K;return new n.Range(Pe-1,Re-1,qe-1,$e-1)}Se.to=he})(o=e.Range||(e.Range={}));var a;(function(Se){function Ie(he){switch(he){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Se.to=Ie})(a=e.TokenType||(e.TokenType={}));var l;(function(Se){function Ie(K){return new n.Position(K.lineNumber-1,K.column-1)}Se.to=Ie;function he(K){return{lineNumber:K.line+1,column:K.character+1}}Se.from=he})(l=e.Position||(e.Position={}));var s;(function(Se){function Ie(Pe,Re){return(0,v.coalesce)((0,v.asArray)(Pe).map(qe=>he(qe,Re)))}Se.from=Ie;function he(Pe,Re){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:K(Pe.scheme,Re),pattern:le.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function K(Pe,Re){return Re&&typeof Pe=="string"?Re.transformOutgoingScheme(Pe):Pe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var h;(function(Se){function Ie(K){switch(K){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function he(K){switch(K){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Se.to=he})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var T;(function(Se){function Ie(K){let Pe;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?Pe=String(K.code):Pe={value:String(K.code.value),target:K.code.target}),{...o.from(K.range),message:K.message,source:K.source,code:Pe,severity:Z.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(F.from),tags:Array.isArray(K.tags)?(0,v.coalesce)(K.tags.map(h.from)):void 0}}Se.from=Ie;function he(K){const Pe=new n.Diagnostic(o.to(K),K.message,Z.to(K.severity));return Pe.source=K.source,Pe.code=(0,C.isString)(K.code)?K.code:K.code?.value,Pe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(F.to),Pe.tags=K.tags&&(0,v.coalesce)(K.tags.map(h.to)),Pe}Se.to=he})(T=e.Diagnostic||(e.Diagnostic={}));var F;(function(Se){function Ie(K){return{...o.from(K.location.range),message:K.message,resource:K.location.uri}}Se.from=Ie;function he(K){return new n.DiagnosticRelatedInformation(new n.Location(K.resource,o.to(K)),K.message)}Se.to=he})(F=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var Z;(function(Se){function Ie(K){switch(K){case n.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}Se.from=Ie;function he(K){switch(K){case w.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Se.to=he})(Z=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var ne;(function(Se){function Ie(K){return typeof K=="number"&&K>=n.ViewColumn.One?K-1:K===n.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Se.from=Ie;function he(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=he})(ne=e.ViewColumn||(e.ViewColumn={}));function ce(Se){return typeof Se.range<"u"}function ie(Se){return Se.length===0?!0:!!ce(Se[0])}e.isDecorationOptionsArr=ie;var M;(function(Se){function Ie($e){return $e.map(Se.from)}Se.fromMany=Ie;function he($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function K($e){let et;if(he($e)){const{language:at,value:Dt}=$e;et={value:"```"+at+`
`+Dt+"\n```\n"}}else n.MarkdownString.isMarkdownString($e)?et={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml,baseUri:$e.baseUri}:typeof $e=="string"?et={value:$e}:et={value:""};const ut=Object.create(null);et.uris=ut;const It=at=>{try{let Dt=p.URI.parse(at,!0);Dt=Dt.with({query:Pe(Dt.query,ut)}),ut[at]=Dt}catch{}return""},Et=new y.marked.Renderer;return Et.link=It,Et.image=at=>typeof at=="string"?It(D.parseHrefAndDimensions(at).href):"",(0,y.marked)(et.value,{renderer:Et}),et}Se.from=K;function Pe($e,et){if(!$e)return $e;let ut;try{ut=(0,E.parse)($e)}catch{}if(!ut)return $e;let It=!1;return ut=(0,k.cloneAndChange)(ut,Et=>{if(p.URI.isUri(Et)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[at]=Et,It=!0,at}else return}),It?JSON.stringify(ut):$e}function Re($e){const et=new n.MarkdownString($e.value,$e.supportThemeIcons);return et.isTrusted=$e.isTrusted,et.supportHtml=$e.supportHtml,et.baseUri=$e.baseUri?p.URI.from($e.baseUri):void 0,et}Se.to=Re;function qe($e){if(!!$e)return typeof $e=="string"?$e:Se.from($e)}Se.fromStrict=qe})(M=e.MarkdownString||(e.MarkdownString={}));function J(Se){return ie(Se)?Se.map(Ie=>({range:o.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?M.fromMany(Ie.hoverMessage):Ie.hoverMessage?M.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:o.from(Ie)}))}e.fromRangeOrRangeWithMessage=J;function $(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.pathOrURIToURI=$;var V;(function(Se){function Ie(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?$(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Se.from=Ie})(V=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var X;(function(Se){function Ie(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?$(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?V.from(he.before):void 0,after:he.after?V.from(he.after):void 0}}Se.from=Ie})(X=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var ue;(function(Se){function Ie(he){if(typeof he>"u")return he;switch(he){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(Se){function Ie(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?ue.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?X.from(he.light):void 0,dark:he.dark?X.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?$(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?V.from(he.before):void 0,after:he.after?V.from(he.after):void 0}}Se.from=Ie})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(Se){function Ie(K){return{text:K.newText,eol:K.newEol&&Ke.from(K.newEol),range:o.from(K.range)}}Se.from=Ie;function he(K){const Pe=new n.TextEdit(o.to(K.range),K.text);return Pe.newEol=typeof K.eol>"u"?void 0:Ke.to(K.eol),Pe}Se.to=he})(N=e.TextEdit||(e.TextEdit={}));var H;(function(Se){function Ie(K,Pe){const Re={edits:[]};if(K instanceof n.WorkspaceEdit){const qe=new A.ResourceSet;for(const $e of K._allEntries())$e._type===1&&p.URI.isUri($e.to)&&$e.from===void 0&&qe.add($e.to);for(const $e of K._allEntries())$e._type===1?Re.edits.push({oldResource:$e.from,newResource:$e.to,options:{...$e.options,contentsBase64:$e.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap($e.options.contents))},metadata:$e.metadata}):$e._type===2?Re.edits.push({resource:$e.uri,textEdit:N.from($e.edit),versionId:qe.has($e.uri)?void 0:Pe?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===6?Re.edits.push({resource:$e.uri,textEdit:{range:o.from($e.range),text:$e.edit.value,insertAsSnippet:!0},versionId:qe.has($e.uri)?void 0:Pe?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Re.edits.push({metadata:$e.metadata,resource:$e.uri,cellEdit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Re.edits.push({metadata:$e.metadata,resource:$e.uri,notebookVersionId:Pe?.getNotebookDocumentVersion($e.uri),cellEdit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(tt.from)}})}return Re}Se.from=Ie;function he(K){const Pe=new n.WorkspaceEdit;for(const Re of K.edits)Re.textEdit?Pe.replace(p.URI.revive(Re.resource),o.to(Re.textEdit.range),Re.textEdit.text):Pe.renameFile(p.URI.revive(Re.oldResource),p.URI.revive(Re.newResource),Re.options);return Pe}Se.to=he})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ee;(function(Se){const Ie=Object.create(null);Ie[n.SymbolKind.File]=0,Ie[n.SymbolKind.Module]=1,Ie[n.SymbolKind.Namespace]=2,Ie[n.SymbolKind.Package]=3,Ie[n.SymbolKind.Class]=4,Ie[n.SymbolKind.Method]=5,Ie[n.SymbolKind.Property]=6,Ie[n.SymbolKind.Field]=7,Ie[n.SymbolKind.Constructor]=8,Ie[n.SymbolKind.Enum]=9,Ie[n.SymbolKind.Interface]=10,Ie[n.SymbolKind.Function]=11,Ie[n.SymbolKind.Variable]=12,Ie[n.SymbolKind.Constant]=13,Ie[n.SymbolKind.String]=14,Ie[n.SymbolKind.Number]=15,Ie[n.SymbolKind.Boolean]=16,Ie[n.SymbolKind.Array]=17,Ie[n.SymbolKind.Object]=18,Ie[n.SymbolKind.Key]=19,Ie[n.SymbolKind.Null]=20,Ie[n.SymbolKind.EnumMember]=21,Ie[n.SymbolKind.Struct]=22,Ie[n.SymbolKind.Event]=23,Ie[n.SymbolKind.Operator]=24,Ie[n.SymbolKind.TypeParameter]=25;function he(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}Se.from=he;function K(Pe){for(const Re in Ie)if(Ie[Re]===Pe)return Number(Re);return n.SymbolKind.Property}Se.to=K})(ee=e.SymbolKind||(e.SymbolKind={}));var ae;(function(Se){function Ie(K){switch(K){case n.SymbolTag.Deprecated:return 1}}Se.from=Ie;function he(K){switch(K){case 1:return n.SymbolTag.Deprecated}}Se.to=he})(ae=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Se){function Ie(K){return{name:K.name,kind:ee.from(K.kind),tags:K.tags&&K.tags.map(ae.from),containerName:K.containerName,location:Q.from(K.location)}}Se.from=Ie;function he(K){const Pe=new n.SymbolInformation(K.name,ee.to(K.kind),K.containerName,Q.to(K.location));return Pe.tags=K.tags&&K.tags.map(ae.to),Pe}Se.to=he})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(Se){function Ie(K){const Pe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:o.from(K.range),selectionRange:o.from(K.selectionRange),kind:ee.from(K.kind),tags:K.tags?.map(ae.from)??[]};return K.children&&(Pe.children=K.children.map(Ie)),Pe}Se.from=Ie;function he(K){const Pe=new n.DocumentSymbol(K.name,K.detail,ee.to(K.kind),o.to(K.range),o.to(K.selectionRange));return(0,v.isNonEmptyArray)(K.tags)&&(Pe.tags=K.tags.map(ae.to)),K.children&&(Pe.children=K.children.map(he)),Pe}Se.to=he})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(Se){function Ie(K){const Pe=new n.CallHierarchyItem(ee.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),o.to(K.range),o.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}Se.to=Ie;function he(K,Pe,Re){if(Pe=Pe??K._sessionId,Re=Re??K._itemId,Pe===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Re,name:K.name,detail:K.detail,kind:ee.from(K.kind),uri:K.uri,range:o.from(K.range),selectionRange:o.from(K.selectionRange),tags:K.tags?.map(ae.from)}}Se.from=he})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var U;(function(Se){function Ie(he){return new n.CallHierarchyIncomingCall(R.to(he.from),he.fromRanges.map(K=>o.to(K)))}Se.to=Ie})(U=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var W;(function(Se){function Ie(he){return new n.CallHierarchyOutgoingCall(R.to(he.to),he.fromRanges.map(K=>o.to(K)))}Se.to=Ie})(W=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(Se){function Ie(K){return{range:K.range&&o.from(K.range),uri:K.uri}}Se.from=Ie;function he(K){return new n.Location(p.URI.revive(K.uri),o.to(K.range))}Se.to=he})(Q=e.location||(e.location={}));var se;(function(Se){function Ie(K){const Pe=K,Re=K;return{originSelectionRange:Pe.originSelectionRange?o.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Re.uri,range:o.from(Pe.targetRange?Pe.targetRange:Re.range),targetSelectionRange:Pe.targetSelectionRange?o.from(Pe.targetSelectionRange):void 0}}Se.from=Ie;function he(K){return{targetUri:p.URI.revive(K.uri),targetRange:o.to(K.range),targetSelectionRange:K.targetSelectionRange?o.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?o.to(K.originSelectionRange):void 0}}Se.to=he})(se=e.DefinitionLink||(e.DefinitionLink={}));var de;(function(Se){function Ie(K){return{range:o.from(K.range),contents:M.fromMany(K.contents)}}Se.from=Ie;function he(K){return new n.Hover(K.contents.map(M.to),o.to(K.range))}Se.to=he})(de=e.Hover||(e.Hover={}));var z;(function(Se){function Ie(K){return{range:o.from(K.range),expression:K.expression}}Se.from=Ie;function he(K){return new n.EvaluatableExpression(o.to(K.range),K.expression)}Se.to=he})(z=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Y;(function(Se){function Ie(K){if(K instanceof n.InlineValueText)return{type:"text",range:o.from(K.range),text:K.text};if(K instanceof n.InlineValueVariableLookup)return{type:"variable",range:o.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function he(K){switch(K.type){case"text":return{range:o.to(K.range),text:K.text};case"variable":return{range:o.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:o.to(K.range),expression:K.expression}}}Se.to=he})(Y=e.InlineValue||(e.InlineValue={}));var _;(function(Se){function Ie(K){return{frameId:K.frameId,stoppedLocation:o.from(K.stoppedLocation)}}Se.from=Ie;function he(K){return new n.InlineValueContext(K.frameId,o.to(K.stoppedLocation))}Se.to=he})(_=e.InlineValueContext||(e.InlineValueContext={}));var j;(function(Se){function Ie(K){return{range:o.from(K.range),kind:K.kind}}Se.from=Ie;function he(K){return new n.DocumentHighlight(o.to(K.range),K.kind)}Se.to=he})(j=e.DocumentHighlight||(e.DocumentHighlight={}));var q;(function(Se){function Ie(he){switch(he){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Se.to=Ie})(q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(Se){function Ie(he){return{triggerKind:q.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Se.to=Ie})(G=e.CompletionContext||(e.CompletionContext={}));var x;(function(Se){function Ie(K){switch(K){case n.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function he(K){switch(K){case 1:return n.CompletionItemTag.Deprecated}}Se.to=he})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var oe;(function(Se){const Ie=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function he(Re){return Ie.get(Re)??9}Se.from=he;const K=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Re){return K.get(Re)??n.CompletionItemKind.Property}Se.to=Pe})(oe=e.CompletionItemKind||(e.CompletionItemKind={}));var pe;(function(Se){function Ie(he,K){const Pe=new n.CompletionItem(he.label);return Pe.insertText=he.insertText,Pe.kind=oe.to(he.kind),Pe.tags=he.tags?.map(x.to),Pe.detail=he.detail,Pe.documentation=D.isMarkdownString(he.documentation)?M.to(he.documentation):he.documentation,Pe.sortText=he.sortText,Pe.filterText=he.filterText,Pe.preselect=he.preselect,Pe.commitCharacters=he.commitCharacters,m.Range.isIRange(he.range)?Pe.range=o.to(he.range):typeof he.range=="object"&&(Pe.range={inserting:o.to(he.range.insert),replacing:o.to(he.range.replace)}),Pe.keepWhitespace=typeof he.insertTextRules>"u"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?Pe.insertText=new n.SnippetString(he.insertText):(Pe.insertText=he.insertText,Pe.textEdit=Pe.range instanceof n.Range?new n.TextEdit(Pe.range,Pe.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Pe.additionalTextEdits=he.additionalTextEdits.map(Re=>N.to(Re))),Pe.command=K&&he.command?K.fromInternal(he.command):void 0,Pe}Se.to=Ie})(pe=e.CompletionItem||(e.CompletionItem={}));var ke;(function(Se){function Ie(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:M.fromStrict(K.documentation)}}Se.from=Ie;function he(K){return{label:K.label,documentation:D.isMarkdownString(K.documentation)?M.to(K.documentation):K.documentation}}Se.to=he})(ke=e.ParameterInformation||(e.ParameterInformation={}));var Ae;(function(Se){function Ie(K){return{label:K.label,documentation:M.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(ke.from):[],activeParameter:K.activeParameter}}Se.from=Ie;function he(K){return{label:K.label,documentation:D.isMarkdownString(K.documentation)?M.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(ke.to):[],activeParameter:K.activeParameter}}Se.to=he})(Ae=e.SignatureInformation||(e.SignatureInformation={}));var Fe;(function(Se){function Ie(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Ae.from):[]}}Se.from=Ie;function he(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Ae.to):[]}}Se.to=he})(Fe=e.SignatureHelp||(e.SignatureHelp={}));var je;(function(Se){function Ie(he,K){const Pe=new n.InlayHint(l.to(K.position),typeof K.label=="string"?K.label:K.label.map(me.to.bind(void 0,he)),K.kind&&ye.to(K.kind));return Pe.textEdits=K.textEdits&&K.textEdits.map(N.to),Pe.tooltip=D.isMarkdownString(K.tooltip)?M.to(K.tooltip):K.tooltip,Pe.paddingLeft=K.paddingLeft,Pe.paddingRight=K.paddingRight,Pe}Se.to=Ie})(je=e.InlayHint||(e.InlayHint={}));var me;(function(Se){function Ie(he,K){const Pe=new n.InlayHintLabelPart(K.label);return Pe.tooltip=D.isMarkdownString(K.tooltip)?M.to(K.tooltip):K.tooltip,g.Command.is(K.command)&&(Pe.command=he.fromInternal(K.command)),K.location&&(Pe.location=Q.to(K.location)),Pe}Se.to=Ie})(me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ye;(function(Se){function Ie(K){return K}Se.from=Ie;function he(K){return K}Se.to=he})(ye=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(Se){function Ie(K){return{range:o.from(K.range),url:K.target,tooltip:K.tooltip}}Se.from=Ie;function he(K){let Pe;if(K.url)try{Pe=typeof K.url=="string"?p.URI.parse(K.url,!0):p.URI.revive(K.url)}catch{}return new n.DocumentLink(o.to(K.range),Pe)}Se.to=he})(Ee=e.DocumentLink||(e.DocumentLink={}));var Me;(function(Se){function Ie(K){const Pe=new n.ColorPresentation(K.label);return K.textEdit&&(Pe.textEdit=N.to(K.textEdit)),K.additionalTextEdits&&(Pe.additionalTextEdits=K.additionalTextEdits.map(Re=>N.to(Re))),Pe}Se.to=Ie;function he(K){return{label:K.label,textEdit:K.textEdit?N.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Pe=>N.from(Pe)):void 0}}Se.from=he})(Me=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(Se){function Ie(K){return new n.Color(K[0],K[1],K[2],K[3])}Se.to=Ie;function he(K){return[K.red,K.green,K.blue,K.alpha]}Se.from=he})(Be=e.Color||(e.Color={}));var Je;(function(Se){function Ie(K){return{range:o.from(K.range)}}Se.from=Ie;function he(K){return new n.SelectionRange(o.to(K.range))}Se.to=he})(Je=e.SelectionRange||(e.SelectionRange={}));var He;(function(Se){function Ie(he){switch(he){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(He=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Xe;(function(Se){function Ie(K){switch(K){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function he(K){switch(K){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Se.to=he})(Xe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ke;(function(Se){function Ie(K){if(K===n.EndOfLine.CRLF)return 1;if(K===n.EndOfLine.LF)return 0}Se.from=Ie;function he(K){if(K===1)return n.EndOfLine.CRLF;if(K===0)return n.EndOfLine.LF}Se.to=he})(Ke=e.EndOfLine||(e.EndOfLine={}));var nt;(function(Se){function Ie(he){if(typeof he=="object")return he.viewId;switch(he){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(nt=e.ProgressLocation||(e.ProgressLocation={}));var Qe;(function(Se){function Ie(he){const K={start:he.start+1,end:he.end+1};return he.kind&&(K.kind=Ve.from(he.kind)),K}Se.from=Ie})(Qe=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(Se){function Ie(he){if(he)switch(he){case n.FoldingRangeKind.Comment:return g.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return g.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return g.FoldingRangeKind.Region}}Se.from=Ie})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ge;(function(Se){function Ie(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?o.from(he.selection):void 0,override:typeof he.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Ie})(Ge=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(Se){function Ie(Re){return Re instanceof n.RelativePattern?Re.toJSON():typeof Re=="string"?Re:he(Re)||K(Re)?new n.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}Se.from=Ie;function he(Re){const qe=Re;return qe?p.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function K(Re){const qe=Re;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function Pe(Re){return typeof Re=="string"?Re:new n.RelativePattern(p.URI.revive(Re.baseUri),Re.pattern)}Se.to=Pe})(le=e.GlobPattern||(e.GlobPattern={}));var De;(function(Se){function Ie(he){if(he){if(Array.isArray(he))return he.map(Ie);if(typeof he=="string")return he;{const K=he;return{language:K.language,scheme:K.scheme,pattern:le.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Se.from=Ie})(De=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(Se){function Ie(K){return{start:K.start,end:K.end}}Se.from=Ie;function he(K){return new n.NotebookRange(K.start,K.end)}Se.to=he})(Ce=e.NotebookRange||(e.NotebookRange={}));var Te;(function(Se){function Ie(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Se.to=Ie;function he(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Se.from=he})(Te=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ne;(function(Se){function Ie(he){if(he===c.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(he===c.NotebookCellExecutionState.Pending)return;if(he===c.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Se.to=Ie})(Ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(Se){function Ie(K){switch(K){case n.NotebookCellKind.Markup:return c.CellKind.Markup;case n.NotebookCellKind.Code:default:return c.CellKind.Code}}Se.from=Ie;function he(K){switch(K){case c.CellKind.Markup:return n.NotebookCellKind.Markup;case c.CellKind.Code:default:return n.NotebookCellKind.Code}}Se.to=he})(ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(Se){function Ie(K){const Pe={metadata:K.metadata??Object.create(null),cells:[]};for(const Re of K.cells)n.NotebookCellData.validate(Re),Pe.cells.push(tt.from(Re));return Pe}Se.from=Ie;function he(K){const Pe=new n.NotebookData(K.cells.map(tt.to));return(0,C.isEmptyObject)(K.metadata)||(Pe.metadata=K.metadata),Pe}Se.to=he})(Ye=e.NotebookData||(e.NotebookData={}));var tt;(function(Se){function Ie(K){return{cellKind:ze.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Te.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(xe.from):[]}}Se.from=Ie;function he(K){return new n.NotebookCellData(ze.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(xe.to):void 0,K.metadata,K.internalMetadata?Te.to(K.internalMetadata):void 0)}Se.to=he})(tt=e.NotebookCellData||(e.NotebookCellData={}));var rt;(function(Se){function Ie(K){return{mime:K.mime,valueBytes:t.VSBuffer.wrap(K.data)}}Se.from=Ie;function he(K){return new n.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Se.to=he})(rt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var xe;(function(Se){function Ie(K){return{outputId:K.id,items:K.items.map(rt.from),metadata:K.metadata}}Se.from=Ie;function he(K){const Pe=K.items.map(rt.to);return new n.NotebookCellOutput(Pe,K.outputId,K.metadata)}Se.to=he})(xe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(Se){function Ie(Pe){return K(Pe)?{include:(0,C.withNullAsUndefined)(le.from(Pe.include)),exclude:(0,C.withNullAsUndefined)(le.from(Pe.exclude))}:(0,C.withNullAsUndefined)(le.from(Pe))}Se.from=Ie;function he(Pe){return K(Pe)?{include:le.to(Pe.include),exclude:le.to(Pe.exclude)}:le.to(Pe)}Se.to=he;function K(Pe){const Re=Pe;return Re?!(0,C.isUndefinedOrNull)(Re.include)&&!(0,C.isUndefinedOrNull)(Re.exclude):!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Se){function Ie(he,K,Pe){const Re=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Re,Pe),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Se.from=Ie})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var gt;(function(Se){function Ie(he,K,Pe){const Re=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:K.toInternal(Re,Pe),label:he.label,description:he.description,detail:he.detail}}Se.from=Ie})(gt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var ft;(function(Se){function Ie(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}Se.from=Ie})(ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(Se){function Ie(K){return{uri:K.uri,provides:K.provides}}Se.from=Ie;function he(K){return new n.NotebookRendererScript(p.URI.revive(K.uri),K.provides)}Se.to=he})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var wt;(function(Se){function Ie(K){return{message:M.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:o.from(K.location.range),uri:K.location.uri}}}Se.from=Ie;function he(K){const Pe=new n.TestMessage(typeof K.message=="string"?K.message:M.to(K.message));return Pe.actualOutput=K.actual,Pe.expectedOutput=K.expected,Pe.location=K.location?Q.to(K.location):void 0,Pe}Se.to=he})(wt=e.TestMessage||(e.TestMessage={}));var St;(function(Se){Se.namespace=u.namespaceTestTag,Se.denamespace=u.denamespaceTestTag})(St=e.TestTag||(e.TestTag={}));var Rt;(function(Se){function Ie(K){const Pe=(0,d.getPrivateApiFor)(K).controllerId;return{extId:f.TestId.fromExtHostTestItem(K,Pe).toString(),label:K.label,uri:p.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Re=>St.namespace(Pe,Re.id)),range:m.Range.lift(o.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&M.fromStrict(K.error)||null}}Se.from=Ie;function he(K){return{parent:void 0,error:void 0,id:f.TestId.fromString(K.extId).localId,label:K.label,uri:p.URI.revive(K.uri),tags:(K.tags||[]).map(Pe=>{const{tagId:Re}=St.denamespace(Pe);return new n.TestTag(Re)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Se.toPlain=he})(Rt=e.TestItem||(e.TestItem={})),function(Se){function Ie(K){return{id:K.id}}Se.from=Ie;function he(K){return new n.TestTag(K.id)}Se.to=he}(St=e.TestTag||(e.TestTag={}));var Lt;(function(Se){const Ie=(K,Pe)=>{const Re=[];for(const[$e,et]of Pe)f.TestId.compare(et.item.extId,$e)===2&&(Pe.delete($e),Re.push(et));const qe={...Rt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(et=>et.type===0).map(wt.to)})),children:Re.map($e=>Ie($e,Pe))};for(const $e of qe.children)$e.parent=qe;return qe};function he(K){const Pe=[],Re=new Map;for(const qe of K.items){Re.set(qe.item.extId,qe);const $e=f.TestId.root(qe.item.extId);K.request.targets.some(et=>et.controllerId===$e&&et.testIds.includes(qe.item.extId))&&Pe.push(qe)}return{completedAt:K.completedAt,results:Pe.map(qe=>Ie(qe,Re))}}Se.to=he})(Lt=e.TestResults||(e.TestResults={}));var ht;(function(Se){function Ie(Re){return{covered:Re.covered,total:Re.covered}}function he(Re){return"line"in Re?l.from(Re):o.from(Re)}function K(Re){return"branches"in Re?{count:Re.executionCount,location:he(Re.location),type:1,branches:Re.branches.length?Re.branches.map(qe=>({count:qe.executionCount,location:qe.location&&he(qe.location)})):void 0}:{type:0,count:Re.executionCount,location:he(Re.location)}}Se.fromDetailed=K;function Pe(Re){return{uri:Re.uri,statement:Ie(Re.statementCoverage),branch:Re.branchCoverage&&Ie(Re.branchCoverage),function:Re.functionCoverage&&Ie(Re.functionCoverage),details:Re.detailedCoverage?.map(K)}}Se.fromFile=Pe})(ht=e.TestCoverage||(e.TestCoverage={}));var At;(function(Se){function Ie(he){switch(he){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Se.to=Ie})(At=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(Se){function Ie(K){const Pe=new n.TypeHierarchyItem(ee.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),o.to(K.range),o.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}Se.to=Ie;function he(K,Pe,Re){if(Pe=Pe??K._sessionId,Re=Re??K._itemId,Pe===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Re,kind:ee.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:o.from(K.range),selectionRange:o.from(K.selectionRange),tags:K.tags?.map(ae.from)}}Se.from=he})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ct;(function(Se){function Ie(he){if(!!he)return{value:he.value,tooltip:he.tooltip}}Se.from=Ie})(Ct=e.ViewBadge||(e.ViewBadge={}));var dt;(function(Se){function Ie(Re,qe,$e){const et=qe.fileData;return et?new class extends n.DataTransferItem{asFile(){return{name:et.name,uri:p.URI.revive(et.uri),data:(0,S.once)(()=>$e())}}}("",qe.id):Re===I.Mimes.uriList&&qe.uriListData?new n.DataTransferItem(Pe(qe.uriListData)):new n.DataTransferItem(qe.asString)}Se.to=Ie;async function he(Re,qe){const $e=await qe.asString();if(Re===I.Mimes.uriList)return{id:qe.id,asString:"",fileData:void 0,uriListData:K($e)};const et=qe.asFile();return{id:qe.id,asString:$e,fileData:et?{name:et.name,uri:et.uri}:void 0}}Se.from=he;function K(Re){return P.UriList.split(Re).map(qe=>{if(qe.startsWith("#"))return qe;try{return p.URI.parse(qe)}catch{}return qe})}function Pe(Re){return P.UriList.create(Re.map(qe=>typeof qe=="string"?qe:p.URI.revive(qe)))}})(dt=e.DataTransferItem||(e.DataTransferItem={}));var pt;(function(Se){function Ie(K,Pe){const Re=K.items.map(([qe,$e])=>[qe,dt.to(qe,$e,()=>Pe($e.id))]);return new n.DataTransfer(Re)}Se.toDataTransfer=Ie;async function he(K){const Pe={items:[]},Re=[];return K.forEach((qe,$e)=>{Re.push((async()=>{Pe.items.push([$e,await dt.from($e,qe)])})())}),await Promise.all(Re),Pe}Se.toDataTransferDTO=he})(pt=e.DataTransfer||(e.DataTransfer={}))}),define(be[260],ve([1,0,48,124,67,123,84,129,4]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const E=(c,f,u,i)=>{let n=f;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!u(n,r)){const o=n;n=r,c.listener?.(i(r,o))}}}},I=(c,f)=>c===f,k={range:(c,f)=>c===f?!0:!c||!f?!1:c.isEqual(f),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(c,f)=>!(c.length!==f.length||c.some(u=>!f.find(i=>u.id===i.id)))},C=c=>f=>({op:4,update:c(f)}),p=(c,f)=>({range:(()=>{let u;const i=C(n=>({range:v.Range.lift(A.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return u},set(n){c.listener?.({op:6}),k.range(u,n)||(u=n,c.listener?.(i(n)))}}})(),label:E(c,f,k.label,C(u=>({label:u}))),description:E(c,void 0,k.description,C(u=>({description:u}))),sortText:E(c,void 0,k.sortText,C(u=>({sortText:u}))),canResolveChildren:E(c,!1,k.canResolveChildren,u=>({op:2,state:u})),busy:E(c,!1,k.busy,C(u=>({busy:u}))),error:E(c,void 0,k.error,C(u=>({error:A.MarkdownString.fromStrict(u)||null}))),tags:E(c,[],k.tags,(u,i)=>({op:1,new:u.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),m=c=>{const f=P.TestId.fromString(c.extId),u=new w(f.controllerId,f.localId,c.label,y.URI.revive(c.uri)||void 0);return u.range=A.Range.to(c.range||void 0),u.description=c.description||void 0,u.sortText=c.sortText||void 0,u.tags=c.tags.map(i=>A.TestTag.to({id:(0,D.denamespaceTestTag)(i).tagId})),u},g=c=>{let f;for(const u of c.tests){const i=m(u.item);(0,t.getPrivateApiFor)(i).parent=f,f=i}return f};e.toItemFromContext=g;class w{constructor(f,u,i,n){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const r=(0,t.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:(0,S.createTestItemChildren)(r,t.getPrivateApiFor,w),enumerable:!0,writable:!1},...p(r,i)})}}e.TestItemImpl=w;class d extends w{constructor(f,u){super(f,f,u,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class b extends S.TestItemCollection{constructor(f,u,i){super({controllerId:f,getDocumentVersion:n=>n&&i.getDocument(n)?.version,getApiFor:t.getPrivateApiFor,getChildren:n=>n.children,root:new d(f,u),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(be[261],ve([1,0,32,187,49]),function(re,e,v,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function S(D,A,y,E){const I=new Map;D.forEach(C=>{const p=v.ExtensionIdentifier.toKey(C.identifier),m=I.get(p);m&&E.warn((0,t.localize)(0,null,m.extensionLocation.fsPath,C.extensionLocation.fsPath)),I.set(p,C)}),A.forEach(C=>{const p=v.ExtensionIdentifier.toKey(C.identifier),m=I.get(p);if(m)if(m.isBuiltin){if(P.gte(m.version,C.version)){E.warn(`Skipping extension ${C.extensionLocation.path} in favour of the builtin extension ${m.extensionLocation.path}.`);return}C.isBuiltin=!0}else E.warn((0,t.localize)(1,null,m.extensionLocation.fsPath,C.extensionLocation.fsPath));else if(C.isBuiltin){E.warn(`Skipping obsolete builtin extension ${C.extensionLocation.path}`);return}I.set(p,C)}),y.forEach(C=>{E.info((0,t.localize)(2,null,C.extensionLocation.fsPath));const p=v.ExtensionIdentifier.toKey(C.identifier),m=I.get(p);m&&m.isBuiltin&&(C.isBuiltin=!0),I.set(p,C)});const k=[];return I.forEach(C=>k.push(C)),k}e.dedupExtensions=S}),define(be[262],ve([1,0,3,46,4,66,13,72,101,96,224,7,27,54,261]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class g{constructor(d,b,c,f,u,i,n){if(this.c=d,this.d=b,this.f=c,this.g=u,this.h=i,this.i=n,b.args["install-builtin-extension"]){const o={isMachineScoped:!!b.args["do-not-sync"],installPreReleaseVersion:!!b.args["pre-release"]};this.b=f.installExtensions([],b.args["install-builtin-extension"],o,!!b.args.force).then(null,a=>{u.error(a)})}else this.b=Promise.resolve();const r=b.args["install-extension"];if(r){const o=r.map(a=>/\.vsix$/i.test(a)?P.URI.file((0,k.isAbsolute)(a)?a:(0,k.join)((0,C.cwd)(),a)):a);this.b.then(()=>f.installExtensions(o,[],{isMachineScoped:!!b.args["do-not-sync"],installPreReleaseVersion:!!b.args["pre-release"]},!!b.args.force)).then(null,a=>{u.error(a)})}}async call(d,b,c){switch(b){case"getEnvironmentData":{const f=c,u=(0,S.createURITransformer)(f.remoteAuthority);let i=await this.k();return i=(0,A.transformOutgoingURIs)(i,u),i}case"getExtensionHostExitInfo":{const f=c;return this.h.getExitInfo(f.reconnectionToken)}case"whenExtensionsReady":{await this.b;return}case"scanExtensions":{await this.b;const f=c,u=f.language;this.g.trace(`Scanning extensions using UI language: ${u}`);const i=(0,S.createURITransformer)(f.remoteAuthority),n=f.extensionDevelopmentPath&&f.extensionDevelopmentPath.map(a=>P.URI.revive(i.transformIncoming(a))),r=n?n.filter(a=>a.scheme===D.Schemas.file).map(a=>a.fsPath):void 0;let o=await this.l(u,r);return o=(0,A.transformOutgoingURIs)(o,i),this.g.trace("Scanned Extensions",o),g.j(o),o}case"scanSingleExtension":{await this.b;const f=c,u=f.language,i=f.isBuiltin,n=(0,S.createURITransformer)(f.remoteAuthority),r=P.URI.revive(n.transformIncoming(f.extensionLocation)),o=r.scheme===D.Schemas.file?r.fsPath:null;if(!o)return null;let a=await this.p(o,i,u);return a?(a=(0,A.transformOutgoingURIs)(a,n),g.j([a]),a):null}case"getDiagnosticInfo":{const f=c,u={machineInfo:(0,I.getMachineInfo)()},i=f.includeProcesses?(0,E.listProcesses)(process.pid):Promise.resolve();let n=[];const r={};if(f.folders){const o=(0,S.createURITransformer)("");n=f.folders.map(l=>P.URI.revive(o.transformIncoming(l))).filter(l=>l.scheme==="file").map(l=>(0,I.collectWorkspaceStats)(l.fsPath,["node_modules",".git"]).then(s=>{r[(0,k.basename)(l.fsPath)]=s}))}return Promise.all([i,...n]).then(([o,a])=>(u.processes=o||void 0,u.workspaceMetadata=f.folders?r:void 0,u))}}throw new Error(`IPC Command ${b} not found`)}listen(d,b,c){throw new Error("Not supported")}static j(d){const b=(r,o)=>r.replace(/file/g,"vscode-remote"),c=r=>{let o="";return o+=r.global?"g":"",o+=r.ignoreCase?"i":"",o+=r.multiline?"m":"",new RegExp(b(r.source,!0),o)},f=new class{mapDefined(r){return y.ContextKeyDefinedExpr.create(r)}mapNot(r){return y.ContextKeyNotExpr.create(r)}mapEquals(r,o){return r==="resourceScheme"&&typeof o=="string"?y.ContextKeyEqualsExpr.create(r,b(o,!1)):y.ContextKeyEqualsExpr.create(r,o)}mapNotEquals(r,o){return r==="resourceScheme"&&typeof o=="string"?y.ContextKeyNotEqualsExpr.create(r,b(o,!1)):y.ContextKeyNotEqualsExpr.create(r,o)}mapGreater(r,o){return y.ContextKeyGreaterExpr.create(r,o)}mapGreaterEquals(r,o){return y.ContextKeyGreaterEqualsExpr.create(r,o)}mapSmaller(r,o){return y.ContextKeySmallerExpr.create(r,o)}mapSmallerEquals(r,o){return y.ContextKeySmallerEqualsExpr.create(r,o)}mapRegex(r,o){return r==="resourceScheme"&&o?y.ContextKeyRegexExpr.create(r,c(o)):y.ContextKeyRegexExpr.create(r,o)}mapIn(r,o){return y.ContextKeyInExpr.create(r,o)}mapNotIn(r,o){return y.ContextKeyNotInExpr.create(r,o)}},u=r=>{if(!r||!r.when||!/resourceScheme/.test(r.when))return;const o=y.ContextKeyExpr.deserialize(r.when);if(!o)return;const a=o.map(f);r.when=a.serialize()},i=r=>{if(Array.isArray(r))for(const o of r)u(o);else u(r)},n=r=>{for(const o in r)i(r[o])};d.forEach(r=>{r.contributes&&(r.contributes.menus&&n(r.contributes.menus),r.contributes.keybindings&&i(r.contributes.keybindings),r.contributes.views&&n(r.contributes.views))})}async k(){return{pid:process.pid,connectionToken:this.c.type!==0?this.c.value:"",appRoot:P.URI.file(this.d.appRoot),settingsPath:this.d.machineSettingsResource,logsPath:P.URI.file(this.d.logsPath),extensionsPath:P.URI.file(this.d.extensionsPath),extensionHostLogsPath:P.URI.file((0,k.join)(this.d.logsPath,`exthost${g.a++}`)),globalStorageHome:this.f.defaultProfile.globalStorageHome,workspaceStorageHome:this.d.workspaceStorageHome,localHistoryHome:this.d.localHistoryHome,userHome:this.d.userHome,os:v.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this.d.args["use-host-proxy"]}}async l(d,b){const[c,f,u]=await Promise.all([this.n(d),this.o(d),this.m(d,b)]);return(0,m.dedupExtensions)(c,f,u,this.g)}async m(d,b){return b?(await Promise.all(b.map(c=>this.i.scanOneOrMultipleExtensions(P.URI.file((0,k.resolve)(c)),1,{language:d})))).flat().map(c=>(0,p.toExtensionDescription)(c,!0)):[]}async n(d){return(await this.i.scanSystemExtensions({language:d,useCache:!0})).map(c=>(0,p.toExtensionDescription)(c,!1))}async o(d){return await this.i.initializeDefaultProfileExtensions(),(await this.i.scanUserExtensions({language:d,useCache:!0})).map(c=>(0,p.toExtensionDescription)(c,!1))}async p(d,b,c){const f=P.URI.file((0,k.resolve)(d)),u=b?0:1,i=await this.i.scanExistingExtension(f,u,{language:c});return i?(0,p.toExtensionDescription)(i,!1):null}}e.RemoteAgentEnvironmentChannel=g,g.a=1}),define(be[130],ve([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const t=[];function P(A){const y=new v(A);return t[y.nid]=y,y}e.createProxyIdentifier=P;function S(A){return t[A].sid}e.getStringIdentifierForProxy=S;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(be[263],ve([1,0,130]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(P=e.TabInputKind||(e.TabInputKind={}));var S;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(S=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var E;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(E=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(w){return w._id=k.a++,w}}e.IdObject=k,k.a=0;var C;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(C=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,v.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,v.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,v.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,v.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,v.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,v.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,v.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,v.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,v.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,v.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,v.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,v.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,v.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,v.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,v.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,v.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,v.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,v.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,v.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,v.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,v.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,v.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,v.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,v.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,v.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,v.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,v.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,v.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,v.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,v.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,v.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,v.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,v.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,v.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,v.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,v.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,v.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,v.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,v.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,v.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,v.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,v.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,v.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,v.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,v.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,v.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,v.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,v.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,v.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,v.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,v.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,v.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,v.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,v.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,v.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,v.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,v.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,v.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,v.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,v.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,v.createProxyIdentifier)("ExtHostLocalization")}});var Ot=this&&this.__classPrivateFieldSet||function(re,e,v,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(re,v):P?P.value=v:e.set(re,v),v},it=this&&this.__classPrivateFieldGet||function(re,e,v,t){if(v==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?t:v==="a"?t.call(re):t?t.value:e.get(re)};define(be[264],ve([1,0,9,128,129,23,263,18,12,45,48,99,4,2,5,250,260,16,130,39]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c){"use strict";var f,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(s,h){f.set(this,void 0),this.b=new Map,this.c=new Map,u.set(this,void 0),Ot(this,f,s.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=h,Ot(this,u,s.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new n(this,T=>{const F=this.c.get(T);return F?.result===o.Void?F:void 0},h),this.f=[{processArgument(T){return(0,E.revive)(T)}},{processArgument(T){return(0,S.cloneAndChange)(T,function(F){if(I.Range.isIRange(F))return P.Range.to(F);if(k.Position.isIPosition(F))return P.Position.to(F);if(I.Range.isIRange(F.range)&&C.URI.isUri(F.uri))return P.location.to(F);if(F instanceof d.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(s){this.f.push(s)}registerApiCommand(s){const h=this.registerCommand(!1,s.id,async(...T)=>{const F=s.args.map((ne,ce)=>{if(!ne.validate(T[ce]))throw new Error(`Invalid argument '${ne.name}' when running '${s.id}', received: ${T[ce]}`);return ne.convert(T[ce])}),Z=await this.executeCommand(s.internalId,...F);return s.result.convert(Z,T,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this.c.set(s.id,s),new t.Disposable(()=>{h.dispose(),this.c.delete(s.id)})}registerCommand(s,h,T,F,Z,ne){if(this.d.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this.b.has(h))throw new Error(`command '${h}' already exists`);return this.b.set(h,{callback:T,thisArg:F,description:Z,extension:ne}),s&&it(this,f,"f").$registerCommand(h),new t.Disposable(()=>{this.b.delete(h)&&s&&it(this,f,"f").$unregisterCommand(h)})}executeCommand(s,...h){return this.d.trace("ExtHostCommands#executeCommand",s),this.g(s,h,!0)}async g(s,h,T){if(this.b.has(s))return it(this,f,"f").$fireCommandActivationEvent(s),this.h(s,h,!1);{let F=!1;const Z=(0,S.cloneAndChange)(h,function(ne){if(ne instanceof t.Position)return P.Position.from(ne);if(ne instanceof t.Range)return P.Range.from(ne);if(ne instanceof t.Location)return P.location.from(ne);if(t.NotebookRange.isNotebookRange(ne))return P.NotebookRange.from(ne);if(ne instanceof ArrayBuffer)return F=!0,d.VSBuffer.wrap(new Uint8Array(ne));if(ne instanceof Uint8Array)return F=!0,d.VSBuffer.wrap(ne);if(ne instanceof d.VSBuffer)return F=!0,ne;if(!Array.isArray(ne))return ne});try{const ne=await it(this,f,"f").$executeCommand(s,F?new b.SerializableObjectWithBuffers(Z):Z,T);return(0,E.revive)(ne)}catch(ne){if(ne instanceof Error&&ne.message==="$executeCommand:retry")return this.g(s,h,!1);throw ne}}}async h(s,h,T){const F=this.b.get(s);if(!F)throw new Error("Unknown command");const{callback:Z,thisArg:ne,description:ce}=F;if(ce)for(let M=0;M<ce.args.length;M++)try{(0,v.validateConstraint)(h[M],ce.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${ce.args[M].name}' - ${ce.args[M].description}`)}const ie=Date.now();try{return await Z.apply(ne,h)}catch(M){if(s===this.converter.delegatingCommandId){const J=this.converter.getActualCommand(...h);J&&(s=J.command)}throw this.d.error(M,s,F.extension?.identifier),T?new class extends Error{constructor(){super((0,c.toErrorMessage)(M)),this.id=s,this.source=F.extension?.displayName??F.extension?.name}}:M}finally{this.j(F,s,Date.now()-ie)}}j(s,h,T){!s.extension||s.extension.isBuiltin||it(this,u,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:h,duration:T})}$executeContributedCommand(s,...h){return this.d.trace("ExtHostCommands#$executeContributedCommand",s),this.b.has(s)?(h=h.map(T=>this.f.reduce((F,Z)=>Z.processArgument(F),T)),this.h(s,h,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this.d.trace("ExtHostCommands#getCommands",s),it(this,f,"f").$getCommands().then(h=>(s&&(h=h.filter(T=>T[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[h,T]of this.b){const{description:F}=T;F&&(s[h]=F)}return Promise.resolve(s)}};f=new WeakMap,u=new WeakMap,i=Le([Oe(0,g.IExtHostRpcService),Oe(1,y.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class n{constructor(s,h,T){this.d=s,this.f=h,this.g=T,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(s,h){if(!s)return;const T={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return T;const F=this.f(s.command);if(F)T.id=F.internalId,T.arguments=F.args.map((Z,ne)=>Z.convert(s.arguments&&s.arguments[ne]));else if((0,A.isNonEmptyArray)(s.arguments)){const Z=`${s.command}/${++this.c}`;this.b.set(Z,s),h.add((0,p.toDisposable)(()=>{this.b.delete(Z),this.g.trace("CommandsConverter#DISPOSE",Z)})),T.$ident=Z,T.id=this.delegatingCommandId,T.arguments=[Z],this.g.trace("CommandsConverter#CREATE",s.command,Z)}return T}fromInternal(s){return typeof s.$ident=="string"?this.b.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this.b.get(s[0])}h(...s){const h=this.getActualCommand(...s);return this.g.trace("CommandsConverter#EXECUTE",s[0],h?h.command:"MISSING"),h?this.d.executeCommand(h.command,...h.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${s[0]}`)}}e.CommandsConverter=n;class r{constructor(s,h,T,F){this.name=s,this.description=h,this.validate=T,this.convert=F}optional(){return new r(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,h){return new r(s??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",l=>C.URI.isUri(l),l=>l),r.Position=new r("position","A position in a text document",l=>t.Position.isPosition(l),P.Position.from),r.Range=new r("range","A range in a text document",l=>t.Range.isRange(l),P.Range.from),r.Selection=new r("selection","A selection in a text document",l=>t.Selection.isSelection(l),P.Selection.from),r.Number=new r("number","",l=>typeof l=="number",l=>l),r.String=new r("string","",l=>typeof l=="string",l=>l),r.CallHierarchyItem=new r("item","A call hierarchy item",l=>l instanceof t.CallHierarchyItem,P.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",l=>l instanceof t.TypeHierarchyItem,P.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",l=>l instanceof w.TestItemImpl,P.TestItem.from);class o{constructor(s,h){this.description=s,this.convert=h}}e.ApiCommandResult=o,o.Void=new o("no result",l=>l);class a{constructor(s,h,T,F,Z){this.id=s,this.internalId=h,this.description=T,this.args=F,this.result=Z}}e.ApiCommand=a}),define(be[265],ve([1,0,59,248,29,264,4,12,81]),function(re,e,v,t,P,S,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class E{constructor(C,p,m){this.b=C,this.c=p,this.f=m,this.a=t.createServer((g,w)=>this.h(g,w)),this.g().catch(g=>(p.error(g),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",C=>this.c.error(C))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(C,p){const m=(w,d)=>{p.writeHead(w,{"content-type":"application/json"}),p.end(JSON.stringify(d||null),b=>b&&this.c.error(b))},g=[];C.setEncoding("utf8"),C.on("data",w=>g.push(w)),C.on("end",async()=>{try{const w=JSON.parse(g.join(""));let d;switch(w.type){case"open":d=await this.i(w);break;case"openExternal":d=await this.j(w);break;case"status":d=await this.l(w);break;case"extensionManagement":d=await this.k(w);break;default:m(404,`Unknown message type: ${w.type}`);break}m(200,d)}catch(w){const d=w instanceof Error?w.message:JSON.stringify(w);m(500,d),this.c.error("Error while processing pipe request",w)}})}async i(C){const{fileURIs:p,folderURIs:m,forceNewWindow:g,diffMode:w,mergeMode:d,addMode:b,forceReuseWindow:c,gotoLineMode:f,waitMarkerFilePath:u,remoteAuthority:i}=C,n=[];if(Array.isArray(m))for(const l of m)try{n.push({folderUri:D.URI.parse(l)})}catch{}if(Array.isArray(p))for(const l of p)try{(0,y.hasWorkspaceFileExtension)(l)?n.push({workspaceUri:D.URI.parse(l)}):n.push({fileUri:D.URI.parse(l)})}catch{}const r=u?D.URI.file(u):void 0,a={forceNewWindow:g,diffMode:w,mergeMode:d,addMode:b,gotoLineMode:f,forceReuseWindow:c,preferNewWindow:!c&&!r&&!b,waitMarkerFileURI:r,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",n,a),""}async j(C){for(const p of C.uris){const m=D.URI.parse(p),g=m.scheme==="file"?m:p;await this.b.executeCommand("_remoteCLI.openExternal",g)}}async k(C){const p=g=>g?.map(w=>/\.vsix$/i.test(w)?D.URI.parse(w):w),m={list:C.list,install:p(C.install),uninstall:p(C.uninstall),force:C.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",m)}async l(C){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&P.existsSync(this.f)&&P.unlinkSync(this.f)}}e.CLIServerBase=E;let I=class extends E{constructor(C,p){super(C,p,(0,v.createRandomIPCHandle)())}};I=Le([Oe(0,S.IExtHostCommands),Oe(1,A.ILogService)],I),e.CLIServer=I}),define(be[266],ve([1,0,28,6,23,2,7,3,4,59,66,265,252,122,253,255,127]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class d extends g.AbstractVariableResolverService{constructor(f,u,i,n,r){super({getFolderUri:o=>{const a=u.filter(l=>l.name===o);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(o,a)=>n[`config:${a}`],getExecPath:()=>f.VSCODE_EXEC_PATH,getAppRoot:()=>f.VSCODE_CWD,getFilePath:()=>{if(i)return D.normalize(i.fsPath)},getSelectedText:()=>n.selectedText,getLineNumber:()=>n.lineNumber,getExtension:async o=>{const l=(await r.getInstalled()).find(s=>s.identifier.id===o);return l&&{extensionLocation:l.location}}},void 0,Promise.resolve(v.homedir()),Promise.resolve(f))}}class b extends S.Disposable{constructor(f,u,i,n,r){super(),this.g=f,this.h=u,this.i=i,this.j=n,this.l=r,this.a=0,this.b=new Map,this.c=this.B(new t.Emitter),this.onExecuteCommand=this.c.event}async call(f,u,i){switch(u){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,i);case"$createProcess":{const n=(0,I.createURITransformer)(f.remoteAuthority);return this.m(n,i)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,i);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,i);case"$listProcesses":return this.i.listProcesses.apply(this.i,i);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,i);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,i);case"$start":return this.i.start.apply(this.i,i);case"$input":return this.i.input.apply(this.i,i);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,i);case"$shutdown":return this.i.shutdown.apply(this.i,i);case"$resize":return this.i.resize.apply(this.i,i);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,i);case"$getCwd":return this.i.getCwd.apply(this.i,i);case"$processBinary":return this.i.processBinary.apply(this.i,i);case"$sendCommandResult":return this.p(i[0],i[1],i[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,i);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,i);case"$getDefaultSystemShell":return this.r.apply(this,i);case"$getProfiles":return this.s.apply(this,i);case"$getEnvironment":return this.t();case"$getWslPath":return this.u(i[0]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(i);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(i);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,i);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,i);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,i);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,i);case"$reduceConnectionGraceTime":return this.w();case"$updateIcon":return this.i.updateIcon.apply(this.i,i);case"$updateTitle":return this.i.updateTitle.apply(this.i,i);case"$updateProperty":return this.i.updateProperty.apply(this.i,i);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,i);case"$requestDetachInstance":return this.i.requestDetachInstance(i[0],i[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(i[0],i[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,i)}throw new Error(`IPC Command ${u} not found`)}listen(f,u,i){switch(u){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async m(f,u){const i={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd>"u"?u.shellLaunchConfig.cwd:y.URI.revive(f.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment,reconnectionProperties:u.shellLaunchConfig.reconnectionProperties,type:u.shellLaunchConfig.type,isFeatureTerminal:u.shellLaunchConfig.isFeatureTerminal},n=await(0,w.buildUserEnvironment)(u.resolverEnv,!!u.shellLaunchConfig.useShellEnvironment,A.language,this.g,this.h);this.h.trace("baseEnv",n);const r=$=>({uri:y.URI.revive(f.transformIncoming($.uri)),name:$.name,index:$.index,toResource:()=>{throw new Error("Not implemented")}}),o=u.workspaceFolders.map(r),a=u.activeWorkspaceFolder?r(u.activeWorkspaceFolder):void 0,l=u.activeFileResource?y.URI.revive(f.transformIncoming(u.activeFileResource)):void 0,s=new d(n,o,l,u.resolvedVariables,this.l),h=m.createVariableResolver(a,process.env,s),T=await m.getCwd(i,v.homedir(),h,a?.uri,u.configuration["terminal.integrated.cwd"],this.h);i.cwd=T;const F=A.isWindows?"terminal.integrated.env.windows":A.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",Z=u.configuration[F],ne=await m.createTerminalEnvironment(i,Z,h,this.j.version,u.configuration["terminal.integrated.detectLocale"],n);if(!i.strictEnv){const $=[];for(const[ue,L]of u.envVariableCollections)$.push([ue,{map:(0,p.deserializeEnvironmentVariableCollection)(L)}]);const V=new Map($);await new C.MergedEnvironmentVariableCollection(V).applyToProcessEnvironment(ne,h)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:T,cols:u.cols,rows:u.rows,env:ne});const ce=(0,E.createRandomIPCHandle)();ne.VSCODE_IPC_HOOK_CLI=ce;const ie=await this.i.createProcess(i,T,u.cols,u.rows,u.unicodeVersion,ne,n,u.options,u.shouldPersistTerminal,u.workspaceId,u.workspaceName),M={executeCommand:($,...V)=>this.n(ie,$,V,f)},J=new k.CLIServerBase(M,this.h,ce);return this.i.onProcessExit($=>$.id===ie&&J.dispose()),{persistentTerminalId:ie,resolvedShellLaunchConfig:i}}n(f,u,i,n){let r,o;const a=new Promise((h,T)=>{r=h,o=T}),l=++this.a;this.b.set(l,{resolve:r,reject:o,uriTransformer:n});const s=(0,P.cloneAndChange)(i,h=>{if(h&&h.$mid===1)return n.transformOutgoing(h);if(h&&h instanceof y.URI)return n.transformOutgoingURI(h)});return this.c.fire({reqId:l,persistentProcessId:f,commandId:u,commandArgs:s}),a}p(f,u,i){const n=this.b.get(f);if(!n)return;this.b.delete(f);const r=(0,P.cloneAndChange)(i,o=>{if(o&&o.$mid===1)return n.uriTransformer.transformIncoming(o)});u?n.reject(r):n.resolve(r)}r(f){return this.i.getDefaultSystemShell(f)}async s(f,u,i,n){return this.i.getProfiles?.(f,u,i,n)||[]}t(){return{...process.env}}u(f){return this.i.getWslPath(f)}w(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=b}),define(be[131],ve([1,0,5]),function(re,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(be[267],ve([1,0,8,2,13,201]),function(re,e,v,t,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class D extends S.DiskFileSystemProviderClient{static register(y,E,I){const k=y.getConnection();if(!k)return t.Disposable.None;const C=new t.DisposableStore,p=(async()=>{try{const m=await y.getRawEnvironment();m?E.registerProvider(P.Schemas.vscodeRemote,C.add(new D(m,k))):I.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(m){I.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,v.getErrorMessage)(m))}})();return C.add(E.onWillActivateFileSystemProvider(m=>{m.scheme===P.Schemas.vscodeRemote&&m.join(p)})),C}constructor(y,E){super(E.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:y.os===3})}}e.RemoteFileSystemProviderClient=D}),define(be[132],ve([1,0,29,14,7,9,22,159,278,279]),function(re,e,v,t,P,S,D,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(i,n){let r=n.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=i,this.cause=n}}e.ExtractError=I;function k(u){const i=u.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,r)=>n+r,i&61440)}function C(u){if(u instanceof I)return u;let i;return/end of central directory record signature not found/.test(u.message)&&(i="CorruptZip"),new I(i,u)}function p(u,i,n,r,o,a){const l=P.dirname(i),s=P.join(r,l);if(!s.startsWith(r))return Promise.reject(new Error(A.localize(0,null,i)));const h=P.join(r,i);let T;return a.onCancellationRequested(()=>{T?.destroy()}),Promise.resolve(D.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((F,Z)=>{if(!a.isCancellationRequested)try{T=(0,v.createWriteStream)(h,{mode:n}),T.once("close",()=>F()),T.once("error",Z),u.once("error",Z),u.pipe(T)}catch(ne){Z(ne)}}))}function m(u,i,n,r){let o=(0,t.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{o.cancel(),u.close()}),new Promise((l,s)=>{const h=new t.Sequencer,T=F=>{F.isCancellationRequested||(a++,u.readEntry())};u.once("error",s),u.once("close",()=>o.then(()=>{r.isCancellationRequested||u.entryCount===a?l():s(new I("Incomplete",new Error(A.localize(1,null,a,u.entryCount))))},s)),u.readEntry(),u.on("entry",F=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(F.fileName)){T(r);return}const Z=F.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(Z)){const ie=P.join(i,Z);o=(0,t.createCancelablePromise)(M=>D.Promises.mkdir(ie,{recursive:!0}).then(()=>T(M)).then(void 0,s));return}const ne=w(u,F),ce=k(F);o=(0,t.createCancelablePromise)(ie=>h.queue(()=>ne.then(M=>p(M,Z,ce,i,n,ie).then(()=>T(ie)))).then(null,s))})})}function g(u,i=!1){return new Promise((n,r)=>{(0,y.open)(u,i?{lazyEntries:!0}:void 0,(o,a)=>{o?r(C(o)):n((0,S.assertIsDefined)(a))})})}function w(u,i){return new Promise((n,r)=>{u.openReadStream(i,(o,a)=>{o?r(C(o)):n((0,S.assertIsDefined)(a))})})}function d(u,i){return new Promise((n,r)=>{const o=new E.ZipFile;i.forEach(l=>{l.contents?o.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&o.addFile(l.localPath,l.path)}),o.end();const a=(0,v.createWriteStream)(u);o.outputStream.pipe(a),o.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>n(u))})}e.zip=d;function b(u,i,n={},r){const o=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=g(u,!0);return n.overwrite&&(a=a.then(l=>D.Promises.rm(i).then(()=>l))),a.then(l=>m(l,i,{sourcePathRegex:o},r))}e.extract=b;function c(u,i){return g(u).then(n=>new Promise((r,o)=>{n.on("entry",a=>{a.fileName===i&&w(n,a).then(l=>r(l),l=>o(l))}),n.once("close",()=>o(new Error(A.localize(2,null,i))))}))}function f(u,i){return c(u,i).then(n=>new Promise((r,o)=>{const a=[];n.once("error",o),n.on("data",l=>a.push(l)),n.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=f}),define(be[268],ve([1,0,132,169]),function(re,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(S){return(0,v.buffer)(S,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=P}),define(be[133],ve([1,0,14,19,39,8,6,2,26,13,7,3,20,49,9,4,21,22,132,168,75,30,240,31,33,53,54,216,241,268,217,218,32,73,17,5,12,25,34,38,36]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f,u,i,n,r,o,a,l,s,h,T,F,Z,ne,ce,ie,M,J,$,V,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(n.IExtensionManagementService);let ue=class extends i.AbstractExtensionManagementService{constructor(R,U,W,Q,se,de,z,Y,_,j,q,G){super(R,U,W,j,G),this.Y=se,this.Z=de,this.ab=z,this.bb=_,this.cb=q,this.X=new Map,this.kb=new y.ResourceSet;const x=this.B(Y.createInstance(s.ExtensionsLifecycle));this.S=this.B(Y.createInstance(L,pe=>x.postUninstall(pe))),this.U=this.B(new T.ExtensionsManifestCache(Q,this)),this.W=this.B(Y.createInstance(l.ExtensionsDownloader,this.getTargetPlatform()));const oe=this.B(new F.ExtensionsWatcher(this,this.Y,G,de,q,_,W));this.B(oe.onDidChangeExtensionsByAnotherSource(pe=>this.jb(pe))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,r.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(R){this.v.trace("ExtensionManagementService#zip",R.identifier.id);const U=await this.ib(R),W=await(0,b.zip)((0,C.joinPath)(this.W.extensionsDownloadDir,(0,w.generateUuid)()).fsPath,U);return g.URI.file(W)}async unzip(R){return this.v.trace("ExtensionManagementService#unzip",R.toString()),(await this.install(R)).identifier}async getManifest(R){const{location:U,cleanup:W}=await this.eb(R),Q=I.resolve(U.fsPath);try{return await(0,h.getManifest)(Q)}finally{await W()}}getInstalled(R,U){return this.S.scanExtensions(R??null,U)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(R,U={}){this.v.trace("ExtensionManagementService#install",R.toString());const{location:W,cleanup:Q}=await this.eb(R);try{const se=await(0,h.getManifest)(I.resolve(W.fsPath));if(se.engines&&se.engines.vscode&&!(0,ne.isEngineValid)(se.engines.vscode,this.w.version,this.w.date))throw new Error(c.localize(0,null,(0,r.getGalleryExtensionId)(se.publisher,se.name),this.w.version));return await this.z(se,W,U)}finally{await Q()}}async installFromLocation(R,U){this.v.trace("ExtensionManagementService#installFromLocation",R.toString());const W=await this.S.scanUserExtensionAtLocation(R);if(!W)throw new Error(`Cannot find a valid extension from the location ${R.toString()}`);return await this.nb([W],U),this.v.info("Successfully installed extension",W.identifier.id,U.toString()),W}getMetadata(R){return this.Y.scanMetadata(R.location)}async updateMetadata(R,U){this.v.trace("ExtensionManagementService#updateMetadata",R.identifier.id);const W={...U};return U.isPreReleaseVersion&&(W.preRelease=!0),R=await this.S.updateMetadata(R,W),this.U.invalidate(),R}async updateExtensionScope(R,U){return this.v.trace("ExtensionManagementService#updateExtensionScope",R.identifier.id),R=await this.S.updateMetadata(R,{isMachineScoped:U}),this.U.invalidate(),R}async reinstallFromGallery(R){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",R.identifier.id),!this.t.isEnabled())throw new Error(c.localize(1,null));const U=await this.getTargetPlatform(),[W]=await this.t.getExtensions([{...R.identifier,preRelease:R.preRelease}],{targetPlatform:U,compatible:!0},t.CancellationToken.None);if(!W)throw new Error(c.localize(2,null));await this.S.setUninstalled(R);try{await this.S.removeUninstalledExtension(R)}catch(Q){throw new Error(c.localize(3,null,(0,P.toErrorMessage)(Q)))}await this.installFromGallery(W)}markAsUninstalled(...R){return this.S.setUninstalled(...R)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(R,U){const{location:W}=await this.W.download(R,U);return W}async eb(R){if(R.scheme===E.Schemas.file)return{location:R,async cleanup(){}};this.v.trace("Downloading extension from",R.toString());const U=(0,C.joinPath)(this.W.extensionsDownloadDir,(0,w.generateUuid)());return await this.ab.download(R,U),this.v.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.bb.del(U)}catch(Q){this.v.error(Q)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(R,U,W){let Q;if(g.URI.isUri(U))Q=new ee(R,U,W,this.t,this.S,this.v);else{const se=r.ExtensionKey.create(U).toString();Q=this.X.get(se),Q||(this.X.set(se,Q=new H(R,U,W,this.W,this.S,this.v)),Q.waitUntilTaskIsFinished().then(()=>this.X.delete(se)))}return new ae(Q,W.profileLocation,this.Z)}R(R,U){return new ge(R,U.profileLocation,this.Z)}async ib(R){const U=async Q=>{let se=await d.Promises.readdir(Q);se=se.map(Y=>I.join(Q,Y));const de=await Promise.all(se.map(Y=>d.Promises.stat(Y)));let z=Promise.resolve([]);return de.forEach((Y,_)=>{const j=se[_];Y.isFile()&&(z=z.then(q=>[...q,j])),Y.isDirectory()&&(z=z.then(q=>U(j).then(G=>[...q,...G])))}),z};return(await U(R.location.fsPath)).map(Q=>({path:`extension/${I.relative(R.location.fsPath,Q)}`,localPath:Q}))}async jb({added:R,removed:U}){if(U)for(const W of U.extensions)this.v.info("Extensions removed from another source",W.id,U.profileLocation.toString()),this.p.fire({identifier:W,profileLocation:U.profileLocation});if(R){const Q=(await this.S.scanExtensions(1,R.profileLocation)).filter(se=>R.extensions.some(de=>(0,r.areSameExtensions)(de,se.identifier)));this.m.fire(Q.map(se=>(this.v.info("Extensions added from another source",se.identifier.id,R.profileLocation.toString()),{identifier:se.identifier,local:se,profileLocation:R.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(U=>this.kb.add(U)));const R=await this.bb.resolve(this.Y.userExtensionsLocation);for(const U of R.children??[])U.isDirectory&&this.kb.add(U.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(U=>this.mb(U)))}async mb(R){const U=[];for(const W of R.rawAdded){if(this.kb.has(W)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(W),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(W,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(W).startsWith(".")||!(await this.bb.stat(W)).isDirectory)continue;const Q=await this.S.scanUserExtensionAtLocation(W);Q&&Q.installedTimestamp===void 0&&(this.kb.add(W),U.push(Q))}U.length&&(await this.nb(U,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",U.map(W=>W.identifier.id)))}async nb(R,U){await this.Z.addExtensionsToProfile(R.map(W=>[W,void 0]),U),this.m.fire(R.map(W=>({local:W,identifier:W.identifier,operation:1,profileLocation:U})))}};ue=Le([Oe(0,n.IExtensionGalleryService),Oe(1,$.ITelemetryService),Oe(2,M.ILogService),Oe(3,u.INativeEnvironmentService),Oe(4,a.IExtensionsScannerService),Oe(5,o.IExtensionsProfileScannerService),Oe(6,f.IDownloadService),Oe(7,ie.IInstantiationService),Oe(8,ce.IFileService),Oe(9,J.IProductService),Oe(10,V.IUriIdentityService),Oe(11,X.IUserDataProfilesService)],ue),e.ExtensionManagementService=ue;let L=class extends A.Disposable{constructor(R,U,W,Q){super(),this.j=R,this.k=U,this.l=W,this.m=Q,this.h=this.B(new D.Emitter),this.onExtract=this.h.event,this.c=(0,C.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new v.Queue}async cleanUp(){await this.v()}async scanExtensions(R,U){await this.l.initializeDefaultProfileExtensions();const W={includeInvalid:!0,profileLocation:U};let Q=[];return R===null||R===0?Q.push(...await this.l.scanAllExtensions({includeInvalid:!0},W,!1)):R===1&&Q.push(...await this.l.scanUserExtensions(W)),Q=R!==null?Q.filter(se=>se.type===R):Q,Promise.all(Q.map(se=>this.u(se)))}async scanAllUserExtensions(R){const U=await this.l.scanUserExtensions({includeAllVersions:!R,includeInvalid:!0});return Promise.all(U.map(W=>this.u(W)))}async scanUserExtensionAtLocation(R){try{const U=await this.l.scanExistingExtension(R,1,{includeInvalid:!0});if(U)return await this.u(U)}catch(U){this.m.error(U)}return null}async extractUserExtension(R,U,W,Q){await this.l.initializeDefaultProfileExtensions();const se=R.toString(),de=I.join(this.l.userExtensionsLocation.fsPath,`.${(0,w.generateUuid)()}`),z=I.join(this.l.userExtensionsLocation.fsPath,se);try{await d.Promises.rm(z)}catch{throw new n.ExtensionManagementError(c.localize(4,null,z,R.id),n.ExtensionManagementErrorCode.Delete)}await this.p(R,U,de,Q),await this.l.updateMetadata(g.URI.file(de),W);try{this.h.fire(g.URI.file(z)),await this.s(R,de,z,Date.now()+2*60*1e3),this.m.info("Renamed to",z)}catch(Y){try{await d.Promises.rm(de)}catch{}if(Y.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",R.id);else throw this.m.info(`Rename failed because of ${(0,S.getErrorMessage)(Y)}. Deleted from extracted location`,de),Y}return this.t(g.URI.file(z),1)}async updateMetadata(R,U){return await this.l.updateMetadata(R.location,U),this.t(R.location,R.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...R){const U=R.map(W=>r.ExtensionKey.create(W));await this.n(W=>U.forEach(Q=>{W[Q.toString()]=!0,this.m.info("Marked extension as uninstalled",Q.toString())}))}async setInstalled(R){await this.n(Q=>delete Q[R.toString()]);const W=(await this.scanAllUserExtensions(!0)).find(Q=>r.ExtensionKey.create(Q).equals(R))||null;return W?this.updateMetadata(W,{installedTimestamp:Date.now()}):null}async removeExtension(R,U){this.m.trace(`Deleting ${U} extension from disk`,R.identifier.id,R.location.fsPath),await d.Promises.rm(R.location.fsPath),this.m.info("Deleted from disk",R.identifier.id,R.location.fsPath)}async removeUninstalledExtension(R){await this.removeExtension(R,"uninstalled"),await this.n(U=>delete U[r.ExtensionKey.create(R).toString()])}async n(R){return this.g.queue(async()=>{let U;try{U=await d.Promises.readFile(this.c,"utf8")}catch(Q){if(Q.code!=="ENOENT")throw Q}let W={};if(U)try{W=JSON.parse(U)}catch{}return R&&(R(W),Object.keys(W).length?await d.Promises.writeFile(this.c,JSON.stringify(W)):await d.Promises.rm(this.c)),W})}async p(R,U,W,Q){this.m.trace(`Started extracting the extension from ${U} to ${W}`);try{await d.Promises.rm(W)}catch(se){throw new n.ExtensionManagementError(this.w(se).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,b.extract)(U,W,{sourcePath:"extension",overwrite:!0},Q),this.m.info(`Extracted extension to ${W}:`,R.id)}catch(se){try{await d.Promises.rm(W)}catch{}let de=n.ExtensionManagementErrorCode.Extract;throw se instanceof b.ExtractError&&(se.type==="CorruptZip"?de=n.ExtensionManagementErrorCode.CorruptZip:se.type==="Incomplete"&&(de=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(se.message,de)}}async s(R,U,W,Q){try{await d.Promises.rename(U,W)}catch(se){if(k.isWindows&&se&&se.code==="EPERM"&&Date.now()<Q)return this.m.info(`Failed renaming ${U} to ${W} with 'EPERM' error. Trying again...`,R.id),this.s(R,U,W,Q);throw new n.ExtensionManagementError(se.message||c.localize(5,null,U,W),se.code||n.ExtensionManagementErrorCode.Rename)}}async t(R,U){const W=await this.l.scanExistingExtension(R,U,{includeInvalid:!0});if(W)return this.u(W);throw new Error(c.localize(6,null,R.path))}async u(R){const U=await this.k.resolve(R.location);let W,Q;return U.children&&(W=U.children.find(({name:se})=>/^readme(\.txt|\.md|)$/i.test(se))?.resource,Q=U.children.find(({name:se})=>/^changelog(\.txt|\.md|)$/i.test(se))?.resource),{identifier:R.identifier,type:R.type,isBuiltin:R.isBuiltin||!!R.metadata?.isBuiltin,location:R.location,manifest:R.manifest,targetPlatform:R.targetPlatform,validations:R.validations,isValid:R.isValid,readmeUrl:W,changelogUrl:Q,publisherDisplayName:R.metadata?.publisherDisplayName||null,publisherId:R.metadata?.publisherId||null,isApplicationScoped:!!R.metadata?.isApplicationScoped,isMachineScoped:!!R.metadata?.isMachineScoped,isPreReleaseVersion:!!R.metadata?.isPreReleaseVersion,preRelease:!!R.metadata?.preRelease,installedTimestamp:R.metadata?.installedTimestamp,updated:!!R.metadata?.updated}}async v(){const R=await this.getUninstalledExtensions(),U=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const de of U)R[r.ExtensionKey.create(de).toString()]||W.add(de.identifier.id.toLowerCase());const Q=(0,r.groupByExtension)(U,de=>de.identifier);await v.Promises.settled(Q.map(async de=>{const z=de.sort((Y,_)=>p.rcompare(Y.manifest.version,_.manifest.version))[0];W.has(z.identifier.id.toLowerCase())||await this.j(await this.u(z))}));const se=U.filter(de=>de.metadata&&R[r.ExtensionKey.create(de).toString()]);await v.Promises.settled(se.map(de=>this.removeUninstalledExtension(de)))}w(R){const U=Array.isArray(R)?R:[R];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((W,Q)=>new Error(`${W.message}${W.message?",":""}${Q instanceof Error?Q.message:Q}`),new Error(""))}};L=Le([Oe(1,ce.IFileService),Oe(2,a.IExtensionsScannerService),Oe(3,M.ILogService)],L),e.ExtensionsScanner=L;class N extends i.AbstractExtensionTask{get operation(){return(0,m.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(R,U,W,Q,se){super(),this.identifier=R,this.source=U,this.k=W,this.l=Q,this.m=se,this.wasVerified=!1,this.j=2}async n(R,U){try{const W=await this.o(R.key);if(W)return this.l.updateMetadata(W,R.metadata)}catch{throw k.isMacintosh?new n.ExtensionManagementError(c.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(c.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.q(R,U)}async o(R){if(!await this.p(R))return null;this.m.trace("Removing the extension from uninstalled list:",R.id);const W=await this.l.setInstalled(R);return this.m.info("Removed the extension from uninstalled list:",R.id),W}async p(R){return!!(await this.l.getUninstalledExtensions())[R.toString()]}async q({zipPath:R,key:U,metadata:W},Q){const se=await this.l.extractUserExtension(U,R,W,Q);return this.m.info("Extracting completed.",U.id),se}}class H extends N{constructor(R,U,W,Q,se,de){super(U.identifier,U,W,se,de),this.s=R,this.t=U,this.u=Q}async h(R){const W=(await this.l.scanExtensions(null,void 0)).find(z=>(0,r.areSameExtensions)(z.identifier,this.t.identifier));W&&(this.j=3);const Q={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,Z.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||W?.isMachineScoped,isBuiltin:this.k.isBuiltin||W?.isBuiltin,isSystem:W?.type===0?!0:void 0,updated:!!W,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,m.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:W?.preRelease)};if(W?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(W,Q),metadata:Q};const{location:se,verified:de}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!de,this.w(se.fsPath),{local:await this.n({zipPath:se.fsPath,key:r.ExtensionKey.create(this.t),metadata:Q},R),metadata:Q}}catch(z){try{await this.u.delete(se)}catch(Y){this.m.warn("Error while deleting the downloaded file",se.toString(),(0,S.getErrorMessage)(Y))}throw z}}async w(R){try{await(0,h.getManifest)(R)}catch(U){throw new n.ExtensionManagementError((0,i.joinErrors)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=H;class ee extends N{constructor(R,U,W,Q,se,de){super({id:(0,r.getGalleryExtensionId)(R.publisher,R.name)},U,W,se,de),this.s=R,this.t=U,this.u=Q}async h(R){const U=new r.ExtensionKey(this.identifier,this.s.version),Q=(await this.l.scanExtensions(1,void 0)).find(z=>(0,r.areSameExtensions)(this.identifier,z.identifier)),se=await this.w(this.identifier.id,this.s.version,R);if(se.isApplicationScoped=(0,Z.isApplicationScopedExtension)(this.s),se.isMachineScoped=this.k.isMachineScoped||Q?.isMachineScoped,se.isBuiltin=this.k.isBuiltin||Q?.isBuiltin,se.installedTimestamp=Date.now(),Q)if(this.j=3,U.equals(new r.ExtensionKey(Q.identifier,Q.manifest.version)))try{await this.l.removeExtension(Q,"existing")}catch{throw new Error(c.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&p.gt(Q.manifest.version,this.s.version)&&await this.l.setUninstalled(Q);else{const z=await this.o(U);if(z)try{await this.l.removeExtension(z,"existing")}catch{throw new Error(c.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:I.resolve(this.t.fsPath),key:U,metadata:se},R),metadata:se}}async w(R,U,W){try{let[Q]=await this.u.getExtensions([{id:R,version:U}],W);if(Q||([Q]=await this.u.getExtensions([{id:R}],W)),Q)return{id:Q.identifier.uuid,publisherDisplayName:Q.publisherDisplayName,publisherId:Q.publisherId,isPreReleaseVersion:Q.properties.isPreReleaseVersion,preRelease:Q.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class ae{constructor(R,U,W){this.d=R,this.g=U,this.h=W,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const R=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[R.local,R.metadata]],this.g),R}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class ge extends i.AbstractExtensionTask{constructor(R,U,W){super(),this.extension=R,this.j=U,this.k=W}async h(R){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(be[134],ve([1,0,79,14,16,8,2,9,24,30,80,12,221,280]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends D.Disposable{constructor(w,d,b){super(),this.h=d,this.i=b,this.j(w.getValue()),this.B(w.onDidChangeConfiguration(()=>this.j(w.getValue()),this))}j(w){this.a=w.http&&w.http.proxy,this.b=!!(w.http&&w.http.proxyStrictSSL),this.f=w.http&&w.http.proxyAuthorization}async request(w,d){this.i.trace("RequestService#request (node) - begin",w.url);const{a:b,b:c}=this;let f;try{f=await(0,I.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const u={...process.env,...f},i=w.agent?w.agent:await(0,C.getProxyAgent)(w.url||"",u,{proxyUrl:b,strictSSL:c});w.agent=i,w.strictSSL=c,this.f&&(w.headers={...w.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(w,d);return this.i.trace("RequestService#request (node) - success",w.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",w.url,n),n}}async k(w){return((0,v.parse)(w.url).protocol==="https:"?await new Promise((c,f)=>{re(["https"],c,f)}):await new Promise((c,f)=>{re(["http"],c,f)})).request}l(w,d){return t.Promises.withAsyncBody(async(b,c)=>{const f=(0,v.parse)(w.url),u=w.getRawRequest?w.getRawRequest(w):await this.k(w),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,A.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(i.auth=w.user+":"+w.password);const n=u(i,r=>{const o=(0,A.isNumber)(w.followRedirects)?w.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&o>0&&r.headers.location)this.l({...w,url:r.headers.location,followRedirects:o-1},d).then(b,c);else{let a=r;!w.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(a=r.pipe((0,p.createGunzip)())),b({res:r,stream:(0,P.streamToBufferReadableStream)(a)})}});n.on("error",c),w.timeout&&n.setTimeout(w.timeout),w.isChromiumNetwork&&n.removeHeader("Content-Length"),w.data&&typeof w.data=="string"&&n.write(w.data),n.end(),d.onCancellationRequested(()=>{n.abort(),c(new S.CancellationError)})})}async resolveProxy(w){}};m=Le([Oe(0,y.IConfigurationService),Oe(1,E.INativeEnvironmentService),Oe(2,k.ILogService)],m),e.RequestService=m}),define(be[269],ve([1,0,77,12,61,108,24,52,134,43,34,31,117,133,76,103,50,2,104,63,13,17,25,106,131,40,110,78,111,8,4,7,27,219,75,38,116,60,3,54,119,36,53,64]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f,u,i,n,r,o,a,l,s,h,T,F,Z,ne,ce,ie,M,J,$,V,X,ue,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class H extends d.Disposable{constructor(fe,R){super(),this.a=fe,this.b=R,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const fe=await this.f();await fe.invokeFunction(async R=>{const U=R.get(t.ILogService);try{await this.g(fe.createInstance(a.ExtensionManagementCLI))}catch(W){throw U.error(W),console.error((0,h.getErrorMessage)(W)),W}})}async f(){const fe=new v.ServiceCollection,R={_serviceBrand:void 0,...w.default};fe.set(i.IProductService,R);const U=new o.ServerEnvironmentService(this.a,R);fe.set(o.IServerEnvironmentService,U);const W=new t.LogService(new n.SpdLogLogger(r.RemoteExtensionLogFileName,(0,F.join)(U.logsPath,`${r.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(U)));fe.set(t.ILogService,W),W.trace(`Remote configuration data at ${this.b}`),W.trace("process arguments:",this.a);const Q=this.B(new b.FileService(W));fe.set(u.IFileService,Q),Q.registerProvider(f.Schemas.file,this.B(new c.DiskFileSystemProvider(W)));const se=new M.UriIdentityService(Q);fe.set(ie.IUriIdentityService,se);const de=this.B(new ue.UserDataProfilesService(U,Q,se,W));fe.set(ue.IUserDataProfilesService,de);const z=this.B(new S.ConfigurationService(de.defaultProfile.settingsResource,Q,new N.NullPolicyService,W));return await z.initialize(),fe.set(D.IConfigurationService,z),fe.set(A.IRequestService,new P.SyncDescriptor(y.RequestService)),fe.set(ce.IDownloadService,new P.SyncDescriptor(ne.DownloadService)),fe.set(I.ITelemetryService,E.NullTelemetryService),fe.set(k.IExtensionGalleryService,new P.SyncDescriptor(C.ExtensionGalleryServiceWithNoStorageService)),fe.set(L.IExtensionsProfileScannerService,new P.SyncDescriptor(L.ExtensionsProfileScannerService)),fe.set(V.IExtensionsScannerService,new P.SyncDescriptor(X.ExtensionsScannerService)),fe.set(m.IExtensionSignatureVerificationService,new P.SyncDescriptor(m.ExtensionSignatureVerificationService)),fe.set(p.INativeServerExtensionManagementService,new P.SyncDescriptor(p.ExtensionManagementService)),fe.set(l.ILanguagePackService,new P.SyncDescriptor(s.NativeLanguagePackService)),new g.InstantiationService(fe)}async g(fe){if(this.a["list-extensions"])return fe.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const R={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return fe.installExtensions(this.h(this.a["install-extension"]||[]),this.a["install-builtin-extension"]||[],R,!!this.a.force)}else{if(this.a["uninstall-extension"])return fe.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return fe.locateExtension(this.a["locate-extension"])}}h(fe){return fe.map(R=>/\.vsix$/i.test(R)?T.URI.file((0,F.isAbsolute)(R)?R:(0,F.join)((0,Z.cwd)(),R)):R)}}function ee(ge){setTimeout(()=>process.exit(ge),0)}async function ae(ge,fe,R){if(ge.help){const W=w.default.serverApplicationName+($.isWindows?".cmd":"");console.log((0,J.buildHelpMessage)(w.default.nameLong,W,w.default.version,R,{noInputFiles:!0,noPipe:!0}));return}if(ge.version){console.log((0,J.buildVersionMessage)(w.default.version,w.default.commit));return}const U=new H(ge,fe);try{await U.run(),ee(0)}catch{ee(1)}finally{U.dispose()}}e.run=ae}),define(be[270],ve([1,0,28,6,2,13,7,92,22,42,24,108,74,246,188,75,189,199,208,30,117,31,76,110,200,133,17,104,63,61,103,77,78,111,12,105,50,25,52,220,134,113,34,43,231,114,239,38,116,262,251,223,228,266,66,40,257,131,267,118,54,119,53,36,247,64,229,212,4,211]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f,u,i,n,r,o,a,l,s,h,T,F,Z,ne,ce,ie,M,J,$,V,X,ue,L,N,H,ee,ae,ge,fe,R,U,W,Q,se,de,z,Y,_,j,q,G,x,oe,pe,ke,Ae,Fe,je,me,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ee="monacoworkbench";async function Me(Ve,Ge,le,De){const Ce=new F.ServiceCollection,Te=new He,Ne={_serviceBrand:void 0,...M.default};Ce.set(J.IProductService,Ne);const ze=new z.ServerEnvironmentService(Ge,Ne);Ce.set(c.IEnvironmentService,ze),Ce.set(c.INativeEnvironmentService,ze);const Ye=new ye.BufferLogService,tt=new ce.MultiplexLogService([new Xe((0,ce.getLogLevel)(ze)),Ye]);Ce.set(ce.ILogService,tt),setTimeout(()=>Qe(ze.logsPath).then(null,ot=>tt.error(ot)),1e4);const rt=new je.LoggerService(tt);Ye.logger=rt.createLogger(me.URI.file(D.join(ze.logsPath,`${_.RemoteExtensionLogFileName}.log`)),{name:_.RemoteExtensionLogFileName}),tt.trace(`Remote configuration data at ${le}`),tt.trace("process arguments:",ze.args),Array.isArray(Ne.serverGreeting)&&tt.info(`

${Ne.serverGreeting.join(`
`)}

`),Te.registerChannel(m.ExtensionHostDebugBroadcastChannel.ChannelName,new m.ExtensionHostDebugBroadcastChannel);const xe=new E.StaticRouter(ot=>ot.clientId==="renderer");Te.registerChannel("logger",new ie.LogLevelChannel(tt,rt));const st=De.add(new l.FileService(tt));Ce.set(a.IFileService,st),st.registerProvider(S.Schemas.file,De.add(new s.DiskFileSystemProvider(tt)));const lt=new fe.UriIdentityService(st);Ce.set(ge.IUriIdentityService,lt);const gt=new pe.UserDataProfilesService(ze,st,lt,tt);Ce.set(pe.IUserDataProfilesService,gt);const ft=new k.ConfigurationService(ze.machineSettingsResource,st,new Ae.NullPolicyService,tt);Ce.set(I.IConfigurationService,ft),await ft.initialize();const Nt=new q.ExtensionHostStatusService;Ce.set(q.IExtensionHostStatusService,Nt),Ce.set($.IRequestService,new h.SyncDescriptor(X.RequestService));let wt=N.NullAppender;const St=await(0,A.getMachineId)(),Rt=(0,N.isInternalTelemetry)(Ne,ft);if((0,N.supportsTelemetry)(Ne,ze)){const ot=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";ot?wt=new Fe.OneDataSystemAppender(!1,Ee,null,()=>new ke.TelemetryClient(ot)):Ne.aiConfig&&Ne.aiConfig.ariaKey&&(wt=new Fe.OneDataSystemAppender(Rt,Ee,null,Ne.aiConfig.ariaKey)),De.add((0,P.toDisposable)(()=>wt?.flush()));const Ct={appenders:[wt],commonProperties:(0,ue.resolveCommonProperties)(st,(0,v.release)(),(0,v.hostname)(),process.arch,Ne.commit,Ne.version+"-remote",St,Rt,ze.installSourcePath,"remoteAgent"),piiPaths:(0,N.getPiiPathsFromEnvironment)(ze)},dt=ze.args["telemetry-level"];let pt=3;dt==="all"?pt=3:dt==="error"?pt=2:dt==="crash"?pt=1:dt!==void 0&&(pt=0),Ce.set(Q.IServerTelemetryService,new h.SyncDescriptor(Q.ServerTelemetryService,[Ct,pt]))}else Ce.set(Q.IServerTelemetryService,Q.ServerNullTelemetryService);Ce.set(u.IExtensionGalleryService,new h.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService));const Lt=Te.getChannel("download",xe);Ce.set(g.IDownloadService,new w.DownloadServiceChannelClient(Lt,()=>Je("renderer"))),Ce.set(oe.IExtensionsProfileScannerService,new h.SyncDescriptor(oe.ExtensionsProfileScannerService)),Ce.set(G.IExtensionsScannerService,new h.SyncDescriptor(x.ExtensionsScannerService)),Ce.set(i.IExtensionSignatureVerificationService,new h.SyncDescriptor(i.ExtensionSignatureVerificationService)),Ce.set(o.INativeServerExtensionManagementService,new h.SyncDescriptor(o.ExtensionManagementService));const ht=new T.InstantiationService(Ce);Ce.set(Z.ILanguagePackService,ht.createInstance(ne.NativeLanguagePackService));const At=ht.createInstance(ae.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:ft.getValue("terminal.integrated.persistentSessionScrollback")??100});return Ce.set(ee.IPtyService,At),Ce.set(d.IEncryptionMainService,new h.SyncDescriptor(b.EncryptionMainService,[St])),Ce.set(C.ICredentialsMainService,new h.SyncDescriptor(p.CredentialsWebMainService)),ht.invokeFunction(ot=>{const Ct=ot.get(o.INativeServerExtensionManagementService),dt=ot.get(G.IExtensionsScannerService),pt=new R.RemoteAgentEnvironmentChannel(Ve,ze,gt,ht.createInstance(n.ExtensionManagementCLI),tt,Nt,dt);Te.registerChannel("remoteextensionsenvironment",pt);const Se=new W.ServerTelemetryChannel(ot.get(Q.IServerTelemetryService),wt);Te.registerChannel("telemetry",Se),Te.registerChannel(Y.REMOTE_TERMINAL_CHANNEL_NAME,new se.RemoteTerminalChannel(ze,tt,At,Ne,Ct));const Ie=new U.RemoteAgentFileSystemProviderChannel(tt,ze);Te.registerChannel(j.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Ie),Te.registerChannel("request",new V.RequestChannel(ot.get($.IRequestService)));const he=new r.ExtensionManagementChannel(Ct,qe=>Je(qe.remoteAuthority));Te.registerChannel("extensions",he);const K=E.ProxyChannel.fromService(ot.get(Z.ILanguagePackService));Te.registerChannel("languagePacks",K);const Pe=E.ProxyChannel.fromService(ot.get(d.IEncryptionMainService));Te.registerChannel("encryption",Pe);const Re=E.ProxyChannel.fromService(ot.get(C.ICredentialsMainService));return Te.registerChannel("credentials",Re),Ct.removeUninstalledExtensions(),De.add(new H.default(ot.get(L.ITelemetryService))),{telemetryService:ot.get(L.ITelemetryService)}}),{socketServer:Te,instantiationService:ht}}e.setupServerServices=Me;const Be=Object.create(null);function Je(Ve){return Be[Ve]||(Be[Ve]=(0,de.createURITransformer)(Ve)),Be[Ve]}class He extends E.IPCServer{constructor(){const Ge=new t.Emitter;super(Ge.event),this.b=Ge}acceptConnection(Ge,le){this.b.fire({protocol:Ge,onDidClientDisconnect:le})}}e.SocketServer=He;class Xe extends ce.AbstractLogger{constructor(Ge=ce.DEFAULT_LOG_LEVEL){super(),this.setLevel(Ge),this.g=Boolean(process.stdout.isTTY)}trace(Ge,...le){this.f(ce.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,Ge,...le):console.log(`[${Ke()}]`,Ge,...le))}debug(Ge,...le){this.f(ce.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,Ge,...le):console.log(`[${Ke()}]`,Ge,...le))}info(Ge,...le){this.f(ce.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,Ge,...le):console.log(`[${Ke()}]`,Ge,...le))}warn(Ge,...le){this.f(ce.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ke()}]\x1B[0m`,Ge,...le):console.warn(`[${Ke()}]`,Ge,...le))}error(Ge,...le){this.f(ce.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ke()}]\x1B[0m`,Ge,...le):console.error(`[${Ke()}]`,Ge,...le))}dispose(){}flush(){}}function Ke(){const Ve=new Date;return`${nt(Ve.getHours())}:${nt(Ve.getMinutes())}:${nt(Ve.getSeconds())}`}function nt(Ve){return Ve<10?`0${Ve}`:String(Ve)}async function Qe(Ve){const Ge=D.basename(Ve),le=D.dirname(Ve),Te=(await y.Promises.readdir(le)).filter(ze=>/^\d{8}T\d{6}$/.test(ze)).sort().filter(ze=>ze!==Ge),Ne=Te.slice(0,Math.max(0,Te.length-9));await Promise.all(Ne.map(ze=>y.Promises.rm(D.join(le,ze))))}}),define(be[271],ve([1,0,112,29,93,272,79,135,16,8,37,2,13,7,46,3,15,4,21,149,97,59,5,12,25,65,34,127,243,244,40,270,249]),function(re,e,v,t,P,S,D,A,y,E,I,k,C,p,m,g,w,d,b,c,f,u,i,n,r,o,a,l,s,h,T,F,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const ne=5*60*1e3;let ce=class extends k.Disposable{constructor($,V,X,ue,L,N,H,ee){super(),this.k=$,this.l=V,this.m=X,this.n=L,this.p=N,this.r=H,this.s=ee,this.h=M.create(this.p),this.i=(0,o.getRemoteServerRootPath)(N),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=ue?this.s.createInstance(Z.WebClientServer,this.l):null,this.r.info("Extension host agent started.")}async handleRequest($,V){if($.method!=="GET")return(0,Z.serveError)($,V,405,`Unsupported method ${$.method}`);if(!$.url)return(0,Z.serveError)($,V,400,"Bad request.");const X=D.parse($.url,!0);let ue=X.pathname;if(!ue)return(0,Z.serveError)($,V,400,"Bad request.");if(ue.startsWith(this.i)&&ue.charCodeAt(this.i.length)===47&&(ue=ue.substring(this.i.length)),ue==="/version")return V.writeHead(200,{"Content-Type":"text/plain"}),void V.end(this.p.commit||"");if(ue==="/delay-shutdown")return this.H(),V.writeHead(200),void V.end("OK");if(!(0,h.requestHasValidConnectionToken)(this.l,$,X))return(0,Z.serveError)($,V,403,"Forbidden.");if(ue==="/vscode-remote-resource"){const L=X.query.path;if(typeof L!="string")return(0,Z.serveError)($,V,400,"Bad request.");let N;try{N=d.URI.from({scheme:C.Schemas.file,path:L}).fsPath}catch{return(0,Z.serveError)($,V,400,"Bad request.")}const H=Object.create(null);this.n.isBuilt&&((0,I.isEqualOrParent)(N,this.n.builtinExtensionsPath,!g.isLinux)||(0,I.isEqualOrParent)(N,this.n.extensionsPath,!g.isLinux))&&(H["Cache-Control"]="public, max-age=31536000"),H.Vary="Origin";const ee=$.headers.origin;return ee&&this.h.matches(ee)&&(H["Access-Control-Allow-Origin"]=ee),(0,Z.serveFile)(N,1,this.r,$,V,H)}if(this.g){this.g.handle($,V,X);return}return V.writeHead(404,{"Content-Type":"text/plain"}),void V.end("Not found")}handleUpgrade($,V){let X=(0,b.generateUuid)(),ue=!1,L=!1;if($.url){const fe=D.parse($.url,!0).query;typeof fe.reconnectionToken=="string"&&(X=fe.reconnectionToken),fe.reconnection==="true"&&(ue=!0),fe.skipWebSocketFrames==="true"&&(L=!0)}if($.headers.upgrade===void 0||$.headers.upgrade.toLowerCase()!=="websocket"){V.end("HTTP/1.1 400 Bad Request");return}const N=$.headers["sec-websocket-key"],H=v.createHash("sha1");H.update(N+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ee=H.digest("base64"),ae=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ee}`];let ge=!1;if(!L&&!this.n.args["disable-websocket-compression"]&&$.headers["sec-websocket-extensions"]){const fe=Array.isArray($.headers["sec-websocket-extensions"])?$.headers["sec-websocket-extensions"]:[$.headers["sec-websocket-extensions"]];for(const R of fe)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(R)){if(/\b(permessage-deflate)\b/.test(R)){ge=!0,ae.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(R)){ge=!0,ae.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}V.write(ae.join(`\r
`)+`\r
\r
`),V.setTimeout(0),V.setNoDelay(!0),L?this.v(new u.NodeSocket(V,`server-connection-${X}`),ue,X):this.v(new u.WebSocketNodeSocket(new u.NodeSocket(V,`server-connection-${X}`),ge,null,!0),ue,X)}handleServerError($){this.r.error("Error occurred in server"),this.r.error($)}t($){let V;return $ instanceof u.NodeSocket?V=$.socket:V=$.socket.socket,V.remoteAddress||"<unknown>"}async u($,V,X){const ue=V.getSocket();this.r.error(`${$} ${X}.`);const L={type:"error",reason:X};V.sendControl(y.VSBuffer.fromString(JSON.stringify(L))),V.dispose(),await ue.drain(),ue.dispose()}v($,V,X){const ue=this.t($),L=`[${ue}][${X.substr(0,8)}]`,N=new f.PersistentProtocol($),H=this.m?new this.m.validator:null,ee=this.m?new this.m.signer:null;let ae;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})(ae||(ae={}));let ge=0;const fe=U=>{ge=3,R.dispose(),this.u(L,N,U)},R=N.onControlMessage(U=>{if(ge===0){let W;try{W=JSON.parse(U.toString())}catch{return fe("Malformed first message")}if(W.type!=="auth")return fe("Invalid first message");if(this.l.type===2&&!this.l.validate(W.auth))return fe("Unauthorized client refused: auth mismatch");let Q=(0,b.generateUuid)();if(ee)try{Q=ee.sign(W.data)}catch{}let se=(0,b.generateUuid)();if(H)try{se=H.createNewMessage(se)}catch{}const de={type:"sign",data:se,signedData:Q};N.sendControl(y.VSBuffer.fromString(JSON.stringify(de))),ge=1}else if(ge===1){let W;try{W=JSON.parse(U.toString())}catch{return fe("Malformed second message")}if(W.type!=="connectionType")return fe("Invalid second message");if(typeof W.signedData!="string")return fe("Invalid second message field type");const Q=W.commit,se=this.p.commit;if(Q&&se&&Q!==se)return fe("Client refused: version mismatch");let de=!1;if(!H)de=!0;else if(this.l.validate(W.signedData))de=!0;else try{de=H.validate(W.signedData)==="ok"}catch{}if(!de){if(this.n.isBuilt)return fe("Unauthorized client refused");this.r.error(`${L} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const z in this.b)this.b[z].shortenReconnectionGraceTimeIfNecessary();for(const z in this.a)this.a[z].shortenReconnectionGraceTimeIfNecessary();ge=2,R.dispose(),this.w(ue,L,N,$,V,X,W)}})}async w($,V,X,ue,L,N,H){const ee=H.desiredConnectionType===1?`${V}[ManagementConnection]`:H.desiredConnectionType===2?`${V}[ExtensionHostConnection]`:V;if(H.desiredConnectionType===1)if(L){if(!this.b[N])return this.f.has(N)?this.u(ee,X,"Unknown reconnection token (seen before)"):this.u(ee,X,"Unknown reconnection token (never seen)");X.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ae=X.readEntireBuffer();X.dispose(),this.b[N].acceptReconnection($,ue,ae)}else{if(this.b[N])return this.u(ee,X,"Duplicate reconnection token");X.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ae=new s.ManagementConnection(this.r,N,$,X);this.k.acceptConnection(ae.protocol,ae.onClose),this.b[N]=ae,this.f.add(N),ae.onClose(()=>{delete this.b[N]})}else if(H.desiredConnectionType===2){const ae=H.args||{language:"en"},ge=await this.C(ae);if(ge.port&&this.r.trace(`${ee} - startParams debug port ${ge.port}`),this.r.trace(`${ee} - startParams language: ${ge.language}`),this.r.trace(`${ee} - startParams env: ${JSON.stringify(ge.env)}`),L){if(!this.a[N])return this.f.has(N)?this.u(ee,X,"Unknown reconnection token (seen before)"):this.u(ee,X,"Unknown reconnection token (never seen)");X.sendPause(),X.sendControl(y.VSBuffer.fromString(JSON.stringify(ge.port?{debugPort:ge.port}:{})));const fe=X.readEntireBuffer();X.dispose(),this.a[N].acceptReconnection($,ue,fe)}else{if(this.a[N])return this.u(ee,X,"Duplicate reconnection token");X.sendPause(),X.sendControl(y.VSBuffer.fromString(JSON.stringify(ge.port?{debugPort:ge.port}:{})));const fe=X.readEntireBuffer();X.dispose();const R=this.s.createInstance(l.ExtensionHostConnection,N,$,ue,fe);this.a[N]=R,this.f.add(N),R.onClose(()=>{delete this.a[N],this.D()}),R.start(ge)}}else if(H.desiredConnectionType===3){const ae=H.args;this.y(X,ae)}else return this.u(ee,X,"Unknown initial data received")}async y($,V){const X=$.getSocket().socket,ue=$.readEntireBuffer();$.dispose(),X.pause();const L=await this.z(V.host,V.port);ue.byteLength>0&&L.write(ue.buffer),L.on("end",()=>X.end()),L.on("close",()=>X.end()),L.on("error",()=>X.destroy()),X.on("end",()=>L.end()),X.on("close",()=>L.end()),X.on("error",()=>L.destroy()),L.pipe(X),X.pipe(L)}z($,V){return new Promise((X,ue)=>{const L=P.createConnection({host:$,port:V},()=>{L.removeListener("error",ue),L.pause(),X(L)});L.once("error",ue)})}C($){return typeof $.port=="number"?(0,c.findFreePort)($.port,10,5e3).then(V=>($.port=V,$)):($.debugId=void 0,$.port=void 0,$.break=void 0,Promise.resolve($))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(){!this.n.args["enable-remote-auto-shutdown"]||(this.n.args["remote-auto-shutdown-without-delay"]?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},ne))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};ce=Le([Oe(4,T.IServerEnvironmentService),Oe(5,r.IProductService),Oe(6,n.ILogService),Oe(7,i.IInstantiationService)],ce);async function ie(J,$,V){const X=await(0,h.determineServerConnectionToken)($);X instanceof h.ServerConnectionTokenParseError&&(console.warn(X.message),process.exit(1));const ue=new k.DisposableStore,{socketServer:L,instantiationService:N}=await(0,F.setupServerServices)(X,$,V,ue);N.invokeFunction(W=>{const Q=W.get(n.ILogService);(0,E.setUnexpectedErrorHandler)(se=>{se&&se.code==="EPIPE"&&se.syscall==="write"&&se.stack&&/unexpectedErrorHandler/.test(se.stack)||Q.error(se)}),process.on("SIGPIPE",()=>{(0,E.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),N.invokeFunction(W=>{const Q=W.get(n.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const se=(0,p.join)(process.env.HOMEDRIVE,"node_modules"),de=(0,p.dirname)((0,p.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),z=(0,p.join)(de,"node_modules");if(t.existsSync(se)||t.existsSync(z)){const Y=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${se}
* ${z}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;Q.warn(Y),console.warn(Y),process.exit(0)}}});const H=N.invokeFunction(W=>{const Q=W.get(n.ILogService);if(t.existsSync((0,p.join)(C.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(de){Q.error(de)}return null}),ee=t.existsSync(C.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(ee&&J&&typeof J!="string"){const W=X.type!==0?`?${C.connectionTokenQueryName}=${X.value}`:"";console.log(`Web UI available at http://localhost${J.port===80?"":`:${J.port}`}/${W}`)}const ae=N.createInstance(ce,L,X,H,ee);m.mark("code/server/ready");const ge=S.performance.now(),fe=global.vscodeServerStartTime,R=global.vscodeServerListenTime,U=global.vscodeServerCodeLoadedTime;if(N.invokeFunction(W=>{W.get(a.ITelemetryService).publicLog2("serverStart",{startTime:fe,startedTime:R,codeLoadedTime:U,readyTime:ge})}),$["print-startup-performance"]){const W=A.LoaderStats.get();let Q="";Q+=`

### Load AMD-module
`,Q+=A.LoaderStats.toMarkdownTable(["Module","Duration"],W.amdLoad),Q+=`

### Load commonjs-module
`,Q+=A.LoaderStats.toMarkdownTable(["Module","Duration"],W.nodeRequire),Q+=`

### Invoke AMD-module factory
`,Q+=A.LoaderStats.toMarkdownTable(["Module","Duration"],W.amdInvoke),Q+=`

### Invoke commonjs-module
`,Q+=A.LoaderStats.toMarkdownTable(["Module","Duration"],W.nodeEval),Q+=`Start-up time: ${R-fe}
`,Q+=`Code loading time: ${U-fe}
`,Q+=`Initialized time: ${ge-fe}
`,Q+=`
`,console.log(Q)}return ae}e.createServer=ie;class M{static create($){const V=$.webEndpointUrlTemplate,X=$.commit,ue=$.quality;if(!V||!X||!ue)return new M(null);const L=(0,b.generateUuid)(),H=new URL(V.replace("{{uuid}}",L).replace("{{commit}}",X).replace("{{quality}}",ue)).origin,ee=(0,w.escapeRegExpCharacters)(H).replace(L,"[a-zA-Z0-9\\-]+");try{const ae=(0,w.createRegExp)(`^${ee}$`,!0,{matchCase:!1});return new M(ae)}catch{return new M(null)}}constructor($){this.a=$}matches($){return this.a?this.a.test($):!1}}}),define(be[281],ve([1,0,28,29,13,269,271,60,7,272,40,50,46]),function(re,e,v,t,P,S,D,A,y,E,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,C.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=E.performance.now();const p={onMultipleValues:(b,c)=>{console.error(`Option '${b}' can only be defined once. Using value ${c}.`)},onEmptyValue:b=>{console.error(`Ignoring option '${b}': Value must not be empty.`)},onUnknownOption:b=>{console.error(`Ignoring option '${b}': not supported for server.`)},onDeprecatedOption:(b,c)=>{console.warn(`Option '${b}' is deprecated: ${c}`)}};function m(){return(0,A.parseArgs)(process.argv.slice(2),I.serverOptions,p)}function g(b){const c=b["server-data-dir"]||b["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,y.join)(v.homedir(),k.default.serverDataFolderName||".vscode-remote"),f=b["user-data-dir"]||(0,y.join)(c,"data"),u=(0,y.join)(f,"User"),i=(0,y.join)(u,"globalStorage"),n=(0,y.join)(u,"History"),r=(0,y.join)(f,"Machine");b["user-data-dir"]=f;const o=(0,y.dirname)(P.FileAccess.asFileUri("").fsPath),a=b["builtin-extensions-dir"]||(0,y.join)(o,"extensions");return b["builtin-extensions-dir"]=a,b["extensions-dir"]=b["extensions-dir"]||(0,y.join)(c,"extensions"),[c,b["extensions-dir"],f,u,r,i,n].forEach(l=>{try{t.existsSync(l)||t.mkdirSync(l,{mode:448})}catch(s){console.error(s)}}),c}function w(b=m()){return(0,S.run)(b,g(b),I.serverOptions)}e.spawnCli=w;function d(b,c=m()){return(0,D.createServer)(b,c,g(c))}e.createServer=d})}).call(this);

//# sourceMappingURL=server.main.js.map
