"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/glob","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/stopwatch","fs","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","os","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(ee){for(var e=[],a=0,t=ee.length;a<t;a++)e[a]=Se[ee[a]];return e};define(Se[80],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function a(A){return A?A.replace(/\$\((.*?)\)/g,(D,T)=>` ${T} `).trim():""}e.getCodiconAriaLabel=a;class t{constructor(D,T,S){this.id=D,this.definition=T,this.description=S,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var I;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function T(R){if(R instanceof t)return["codicon","codicon-"+R.id];const P=D.exec(R.id);if(!P)return T(t.error);const[,E,y]=P,v=["codicon","codicon-"+E];return y&&v.push("codicon-modifier-"+y.substring(1)),v}A.asClassNameArray=T;function S(R){return T(R).join(" ")}A.asClassName=S;function C(R){return"."+T(R).join(".")}A.asCSSSelector=C})(I=e.CSSIcon||(e.CSSIcon={}))}),define(Se[81],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(D,T){const S=Object.create(null);for(const C of D){const R=T(C);let P=S[R];P||(P=S[R]=[]),P.push(C)}return S}e.groupBy=a;function t(D,T){const S=[],C=[];for(const R of D)T.has(R)||S.push(R);for(const R of T)D.has(R)||C.push(R);return{removed:S,added:C}}e.diffSets=t;function I(D,T){const S=[],C=[];for(const[R,P]of D)T.has(R)||S.push(P);for(const[R,P]of T)D.has(R)||C.push(P);return{removed:S,added:C}}e.diffMaps=I;class A{constructor(){this.a=new Map}add(T,S){let C=this.a.get(T);C||(C=new Set,this.a.set(T,C)),C.add(S)}delete(T,S){const C=this.a.get(T);!C||(C.delete(S),C.size===0&&this.a.delete(T))}forEach(T,S){const C=this.a.get(T);!C||C.forEach(S)}}e.SetMap=A}),define(Se[61],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(D){return(T,S,C)=>{let R=null,P=null;if(typeof C.value=="function"?(R="value",P=C.value):typeof C.get=="function"&&(R="get",P=C.get),!P)throw new Error("not supported");C[R]=D(P,S)}}function t(D,T,S){let C=null,R=null;if(typeof S.value=="function"?(C="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",R=S.get),!R)throw new Error("not supported");const P=`$memoize$${T}`;S[C]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,E)}),this[P]}}e.memoize=t;function I(D,T,S){return a((C,R)=>{const P=`$debounce$${R}`,E=`$debounce$result$${R}`;return function(...y){this[E]||(this[E]=S?S():void 0),clearTimeout(this[P]),T&&(this[E]=T(this[E],...y),y=[this[E]]),this[P]=setTimeout(()=>{C.apply(this,y),this[E]=S?S():void 0},D)}})}e.debounce=I;function A(D,T,S){return a((C,R)=>{const P=`$throttle$timer$${R}`,E=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...d){if(this[E]||(this[E]=S?S():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),T&&(this[E]=T(this[E],...d)),this[v])return;const g=this[y]+D;g<=Date.now()?(this[y]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0},g-Date.now()))}})}e.throttle=A}),define(Se[10],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?f.isErrorNoTelemetry(o)?new f(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(r=>{r(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=a,e.errorHandler=new a;function t(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=t;function I(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=I;function A(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=A;function D(b){if(b instanceof Error){const{name:o,message:r}=b,c=b.stacktrace||b.stack;return{$isError:!0,name:o,message:r,stack:c,noTelemetry:f.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=D;const T="Canceled";function S(b){return b instanceof C?!0:b instanceof Error&&b.name===T&&b.message===T}e.isCancellationError=S;class C extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=C;function R(){const b=new Error(T);return b.name=b.message,b}e.canceled=R;function P(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=P;function E(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=E;function y(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function v(b){const o=new Error(`${b} has been disposed`);return o.name="DISPOSED",o}e.disposed=v;function d(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=d;class g extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=g;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class f extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof f)return o;const r=new f;return r.message=o.message,r.stack=o.stack,r}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class h extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(Se[17],ye([1,0,10]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(re,ue=0){return re[re.length-(1+ue)]}e.tail=t;function I(re){if(re.length===0)throw new Error("Invalid tail call");return[re.slice(0,re.length-1),re[re.length-1]]}e.tail2=I;function A(re,ue,de=(Z,se)=>Z===se){if(re===ue)return!0;if(!re||!ue||re.length!==ue.length)return!1;for(let Z=0,se=re.length;Z<se;Z++)if(!de(re[Z],ue[Z]))return!1;return!0}e.equals=A;function D(re,ue){const de=re.length-1;ue<de&&(re[ue]=re[de]),re.pop()}e.removeFastWithoutKeepingOrder=D;function T(re,ue,de){return S(re.length,Z=>de(re[Z],ue))}e.binarySearch=T;function S(re,ue){let de=0,Z=re-1;for(;de<=Z;){const se=(de+Z)/2|0,ne=ue(se);if(ne<0)de=se+1;else if(ne>0)Z=se-1;else return se}return-(de+1)}e.binarySearch2=S;function C(re,ue){let de=0,Z=re.length;if(Z===0)return 0;for(;de<Z;){const se=Math.floor((de+Z)/2);ue(re[se])?Z=se:de=se+1}return de}e.findFirstInSorted=C;function R(re,ue,de){if(re=re|0,re>=ue.length)throw new TypeError("invalid index");const Z=ue[Math.floor(ue.length*Math.random())],se=[],ne=[],N=[];for(const $ of ue){const x=de($,Z);x<0?se.push($):x>0?ne.push($):N.push($)}return re<se.length?R(re,se,de):re<se.length+N.length?N[0]:R(re-(se.length+N.length),ne,de)}e.quickSelect=R;function P(re,ue){const de=[];let Z;for(const se of re.slice(0).sort(ue))!Z||ue(Z[0],se)!==0?(Z=[se],de.push(Z)):Z.push(se);return de}e.groupBy=P;function E(re,ue,de){const Z=[];function se($,x,_){if(x===0&&_.length===0)return;const le=Z[Z.length-1];le&&le.start+le.deleteCount===$?(le.deleteCount+=x,le.toInsert.push(..._)):Z.push({start:$,deleteCount:x,toInsert:_})}let ne=0,N=0;for(;;){if(ne===re.length){se(ne,0,ue.slice(N));break}if(N===ue.length){se(ne,re.length-ne,[]);break}const $=re[ne],x=ue[N],_=de($,x);_===0?(ne+=1,N+=1):_<0?(se(ne,1,[]),ne+=1):_>0&&(se(ne,0,[x]),N+=1)}return Z}e.sortedDiff=E;function y(re,ue,de){const Z=E(re,ue,de),se=[],ne=[];for(const N of Z)se.push(...re.slice(N.start,N.start+N.deleteCount)),ne.push(...N.toInsert);return{removed:se,added:ne}}e.delta=y;function v(re,ue,de){if(de===0)return[];const Z=re.slice(0,de).sort(ue);return g(re,ue,Z,de,re.length),Z}e.top=v;function d(re,ue,de,Z,se){return de===0?Promise.resolve([]):new Promise((ne,N)=>{(async()=>{const $=re.length,x=re.slice(0,de).sort(ue);for(let _=de,le=Math.min(de+Z,$);_<$;_=le,le=Math.min(le+Z,$)){if(_>de&&await new Promise(be=>setTimeout(be)),se&&se.isCancellationRequested)throw new a.CancellationError;g(re,ue,x,_,le)}return x})().then(ne,N)})}e.topAsync=d;function g(re,ue,de,Z,se){for(const ne=de.length;Z<se;Z++){const N=re[Z];if(ue(N,de[ne-1])<0){de.pop();const $=C(de,x=>ue(N,x)<0);de.splice($,0,N)}}}function m(re){return re.filter(ue=>!!ue)}e.coalesce=m;function w(re){let ue=0;for(let de=0;de<re.length;de++)re[de]&&(re[ue]=re[de],ue+=1);re.length=ue}e.coalesceInPlace=w;function f(re,ue,de){re.splice(de,0,re.splice(ue,1)[0])}e.move=f;function h(re){return!Array.isArray(re)||re.length===0}e.isFalsyOrEmpty=h;function b(re){return Array.isArray(re)&&re.length>0}e.isNonEmptyArray=b;function o(re,ue=de=>de){const de=new Set;return re.filter(Z=>{const se=ue(Z);return de.has(se)?!1:(de.add(se),!0)})}e.distinct=o;function r(re){const ue=new Set;return de=>{const Z=re(de);return ue.has(Z)?!1:(ue.add(Z),!0)}}e.uniqueFilter=r;function c(re,ue){const de=u(re,ue);if(de!==-1)return re[de]}e.findLast=c;function u(re,ue){for(let de=re.length-1;de>=0;de--){const Z=re[de];if(ue(Z))return de}return-1}e.lastIndex=u;function i(re,ue){return re.length>0?re[0]:ue}e.firstOrDefault=i;function s(re,ue){return re.length>0?re[re.length-1]:ue}e.lastOrDefault=s;function n(re,ue,de=(Z,se)=>Z===se){let Z=0;for(let se=0,ne=Math.min(re.length,ue.length);se<ne&&de(re[se],ue[se]);se++)Z++;return Z}e.commonPrefixLength=n;function l(re){return[].concat(...re)}e.flatten=l;function p(re,ue){let de=typeof ue=="number"?re:0;typeof ue=="number"?de=re:(de=0,ue=re);const Z=[];if(de<=ue)for(let se=de;se<ue;se++)Z.push(se);else for(let se=de;se>ue;se--)Z.push(se);return Z}e.range=p;function k(re,ue,de){return re.reduce((Z,se)=>(Z[ue(se)]=de?de(se):se,Z),Object.create(null))}e.index=k;function L(re,ue){return re.push(ue),()=>B(re,ue)}e.insert=L;function B(re,ue){const de=re.indexOf(ue);if(de>-1)return re.splice(de,1),ue}e.remove=B;function K(re,ue,de){const Z=re.slice(0,ue),se=re.slice(ue);return Z.concat(de,se)}e.arrayInsert=K;function G(re,ue){let de;if(typeof ue=="number"){let Z=ue;de=()=>{const se=Math.sin(Z++)*179426549;return se-Math.floor(se)}}else de=Math.random;for(let Z=re.length-1;Z>0;Z-=1){const se=Math.floor(de()*(Z+1)),ne=re[Z];re[Z]=re[se],re[se]=ne}}e.shuffle=G;function O(re,ue){const de=re.indexOf(ue);de>-1&&(re.splice(de,1),re.unshift(ue))}e.pushToStart=O;function U(re,ue){const de=re.indexOf(ue);de>-1&&(re.splice(de,1),re.push(ue))}e.pushToEnd=U;function F(re,ue){for(const de of ue)re.push(de)}e.pushMany=F;function z(re,ue){return Array.isArray(re)?re.map(ue):ue(re)}e.mapArrayOrNot=z;function M(re){return Array.isArray(re)?re:[re]}e.asArray=M;function V(re){return re[Math.floor(Math.random()*re.length)]}e.getRandomElement=V;function q(re,ue){for(const de of re){const Z=ue(de);if(Z!==void 0)return Z}}e.mapFind=q;function H(re,ue,de){const Z=Y(re,ue),se=re.length,ne=de.length;re.length=se+ne;for(let N=se-1;N>=Z;N--)re[N+ne]=re[N];for(let N=0;N<ne;N++)re[N+Z]=de[N]}e.insertInto=H;function Q(re,ue,de,Z){const se=Y(re,ue),ne=re.splice(se,de);return H(re,se,Z),ne}e.splice=Q;function Y(re,ue){return ue<0?Math.max(ue+re.length,0):Math.min(ue,re.length)}var ce;(function(re){function ue(se){return se<0}re.isLessThan=ue;function de(se){return se>0}re.isGreaterThan=de;function Z(se){return se===0}re.isNeitherLessOrGreaterThan=Z,re.greaterThan=1,re.lessThan=-1,re.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function ie(re,ue){return(de,Z)=>ue(re(de),re(Z))}e.compareBy=ie;function fe(...re){return(ue,de)=>{for(const Z of re){const se=Z(ue,de);if(!ce.isNeitherLessOrGreaterThan(se))return se}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=fe;const J=(re,ue)=>re-ue;e.numberComparator=J;function pe(re,ue){if(re.length===0)return;let de=re[0];for(let Z=1;Z<re.length;Z++){const se=re[Z];ue(se,de)>0&&(de=se)}return de}e.findMaxBy=pe;function we(re,ue){if(re.length===0)return;let de=re[0];for(let Z=1;Z<re.length;Z++){const se=re[Z];ue(se,de)>=0&&(de=se)}return de}e.findLastMaxBy=we;function Ie(re,ue){return pe(re,(de,Z)=>-ue(de,Z))}e.findMinBy=Ie;class Re{constructor(ue){this.f=ue,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let de=this.c;for(;de<this.f.length&&ue(this.f[de]);)de++;const Z=de===this.c?null:this.f.slice(this.c,de);return this.c=de,Z}takeFromEndWhile(ue){let de=this.d;for(;de>=0&&ue(this.f[de]);)de--;const Z=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,Z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ue=this.f[this.c];return this.c++,ue}removeLast(){const ue=this.f[this.d];return this.d--,ue}takeCount(ue){const de=this.f.slice(this.c,this.c+ue);return this.c+=ue,de}}e.ArrayQueue=Re;class ze{constructor(ue){this.iterate=ue}forEach(ue){this.iterate(de=>(ue(de),!0))}toArray(){const ue=[];return this.iterate(de=>(ue.push(de),!0)),ue}filter(ue){return new ze(de=>this.iterate(Z=>ue(Z)?de(Z):!0))}map(ue){return new ze(de=>this.iterate(Z=>de(ue(Z))))}some(ue){let de=!1;return this.iterate(Z=>(de=ue(Z),!de)),de}findFirst(ue){let de;return this.iterate(Z=>ue(Z)?(de=Z,!1):!0),de}findLast(ue){let de;return this.iterate(Z=>(ue(Z)&&(de=Z),!0)),de}findLastMaxBy(ue){let de,Z=!0;return this.iterate(se=>((Z||ce.isGreaterThan(ue(se,de)))&&(Z=!1,de=se),!0)),de}}e.CallbackIterable=ze,ze.empty=new ze(re=>{})}),define(Se[48],ye([1,0,10]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,C){if(!S)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function I(S,C="Unreachable"){throw new Error(C)}e.assertNever=I;function A(S){if(!S)throw new a.BugIndicatingError("Assertion Failed")}e.assert=A;function D(S){if(!S()){debugger;S(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function T(S,C){let R=0;for(;R<S.length-1;){const P=S[R],E=S[R+1];if(!C(P,E))return!1;R++}return!0}e.checkAdjacentItems=T}),define(Se[62],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(t){const I=this;let A=!1,D;return function(){return A||(A=!0,D=t.apply(I,arguments)),D}}e.once=a}),define(Se[99],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Se[63],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function I(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}t.is=I;const A=Object.freeze([]);function D(){return A}t.empty=D;function*T(h){yield h}t.single=T;function S(h){return I(h)?h:T(h)}t.wrap=S;function C(h){return h||A}t.from=C;function R(h){return!h||h[Symbol.iterator]().next().done===!0}t.isEmpty=R;function P(h){return h[Symbol.iterator]().next().value}t.first=P;function E(h,b){for(const o of h)if(b(o))return!0;return!1}t.some=E;function y(h,b){for(const o of h)if(b(o))return o}t.find=y;function*v(h,b){for(const o of h)b(o)&&(yield o)}t.filter=v;function*d(h,b){let o=0;for(const r of h)yield b(r,o++)}t.map=d;function*g(...h){for(const b of h)for(const o of b)yield o}t.concat=g;function m(h,b,o){let r=o;for(const c of h)r=b(r,c);return r}t.reduce=m;function*w(h,b,o=h.length){for(b<0&&(b+=h.length),o<0?o+=h.length:o>h.length&&(o=h.length);b<o;b++)yield h[b]}t.slice=w;function f(h,b=Number.POSITIVE_INFINITY){const o=[];if(b===0)return[o,h];const r=h[Symbol.iterator]();for(let c=0;c<b;c++){const u=r.next();if(u.done)return[o,t.empty()];o.push(u.value)}return[o,{[Symbol.iterator](){return r}}]}t.consume=f})(a=e.Iterable||(e.Iterable={}))}),define(Se[145],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(o,r=!1){let c=0;const u=o.length;let i="",s=0,n=16,l=0;function p(U){let F=0,z=0;for(;F<U;){const M=o.charCodeAt(c);if(M>=48&&M<=57)z=z*16+M-48;else if(M>=65&&M<=70)z=z*16+M-65+10;else if(M>=97&&M<=102)z=z*16+M-97+10;else break;c++,F++}return F<U&&(z=-1),z}function k(U){c=U,i="",s=0,n=16,l=0}function L(){const U=c;if(o.charCodeAt(c)===48)c++;else for(c++;c<o.length&&C(o.charCodeAt(c));)c++;if(c<o.length&&o.charCodeAt(c)===46)if(c++,c<o.length&&C(o.charCodeAt(c)))for(c++;c<o.length&&C(o.charCodeAt(c));)c++;else return l=3,o.substring(U,c);let F=c;if(c<o.length&&(o.charCodeAt(c)===69||o.charCodeAt(c)===101))if(c++,(c<o.length&&o.charCodeAt(c)===43||o.charCodeAt(c)===45)&&c++,c<o.length&&C(o.charCodeAt(c))){for(c++;c<o.length&&C(o.charCodeAt(c));)c++;F=c}else l=3;return o.substring(U,F)}function B(){let U="",F=c;for(;;){if(c>=u){U+=o.substring(F,c),l=2;break}const z=o.charCodeAt(c);if(z===34){U+=o.substring(F,c),c++;break}if(z===92){if(U+=o.substring(F,c),c++,c>=u){l=2;break}switch(o.charCodeAt(c++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const V=p(4);V>=0?U+=String.fromCharCode(V):l=4;break}default:l=5}F=c;continue}if(z>=0&&z<=31)if(S(z)){U+=o.substring(F,c),l=2;break}else l=6;c++}return U}function K(){if(i="",l=0,s=c,c>=u)return s=u,n=17;let U=o.charCodeAt(c);if(T(U)){do c++,i+=String.fromCharCode(U),U=o.charCodeAt(c);while(T(U));return n=15}if(S(U))return c++,i+=String.fromCharCode(U),U===13&&o.charCodeAt(c)===10&&(c++,i+=`
`),n=14;switch(U){case 123:return c++,n=1;case 125:return c++,n=2;case 91:return c++,n=3;case 93:return c++,n=4;case 58:return c++,n=6;case 44:return c++,n=5;case 34:return c++,i=B(),n=10;case 47:{const F=c-1;if(o.charCodeAt(c+1)===47){for(c+=2;c<u&&!S(o.charCodeAt(c));)c++;return i=o.substring(F,c),n=12}if(o.charCodeAt(c+1)===42){c+=2;const z=u-1;let M=!1;for(;c<z;){if(o.charCodeAt(c)===42&&o.charCodeAt(c+1)===47){c+=2,M=!0;break}c++}return M||(c++,l=1),i=o.substring(F,c),n=13}return i+=String.fromCharCode(U),c++,n=16}case 45:if(i+=String.fromCharCode(U),c++,c===u||!C(o.charCodeAt(c)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=L(),n=11;default:for(;c<u&&G(U);)c++,U=o.charCodeAt(c);if(s!==c){switch(i=o.substring(s,c),i){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return i+=String.fromCharCode(U),c++,n=16}}function G(U){if(T(U)||S(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let U;do U=K();while(U>=12&&U<=15);return U}return{setPosition:k,getPosition:()=>c,scan:r?O:K,getToken:()=>n,getTokenValue:()=>i,getTokenOffset:()=>s,getTokenLength:()=>c-s,getTokenError:()=>l}}e.createScanner=D;function T(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function S(o){return o===10||o===13||o===8232||o===8233}function C(o){return o>=48&&o<=57}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function P(o,r){const c=[],u=new Object;let i;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function l(p,k,L,B){s.value=p,s.offset=k,s.length=L,s.type=B,s.colonOffset=void 0,i=s}try{f(o,{onObjectBegin:(p,k)=>{if(r<=p)throw u;i=void 0,n=r>p,c.push("")},onObjectProperty:(p,k,L)=>{if(r<k||(l(p,k,L,"property"),c[c.length-1]=p,r<=k+L))throw u},onObjectEnd:(p,k)=>{if(r<=p)throw u;i=void 0,c.pop()},onArrayBegin:(p,k)=>{if(r<=p)throw u;i=void 0,c.push(0)},onArrayEnd:(p,k)=>{if(r<=p)throw u;i=void 0,c.pop()},onLiteralValue:(p,k,L)=>{if(r<k||(l(p,k,L,b(p)),r<=k+L))throw u},onSeparator:(p,k,L)=>{if(r<=k)throw u;if(p===":"&&i&&i.type==="property")i.colonOffset=k,n=!1,i=void 0;else if(p===","){const B=c[c.length-1];typeof B=="number"?c[c.length-1]=B+1:(n=!0,c[c.length-1]=""),i=void 0}}})}catch(p){if(p!==u)throw p}return{path:c,previousNode:i,isAtPropertyKey:n,matches:p=>{let k=0;for(let L=0;k<p.length&&L<c.length;L++)if(p[k]===c[L]||p[k]==="*")k++;else if(p[k]!=="**")return!1;return k===p.length}}}e.getLocation=P;function E(o,r=[],c=A.DEFAULT){let u=null,i=[];const s=[];function n(p){Array.isArray(i)?i.push(p):u!==null&&(i[u]=p)}return f(o,{onObjectBegin:()=>{const p={};n(p),s.push(i),i=p,u=null},onObjectProperty:p=>{u=p},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const p=[];n(p),s.push(i),i=p,u=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:n,onError:(p,k,L)=>{r.push({error:p,offset:k,length:L})}},c),i[0]}e.parse=E;function y(o,r=[],c=A.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(p){u.type==="property"&&(u.length=p-u.offset,u=u.parent)}function s(p){return u.children.push(p),p}f(o,{onObjectBegin:p=>{u=s({type:"object",offset:p,length:-1,parent:u,children:[]})},onObjectProperty:(p,k,L)=>{u=s({type:"property",offset:k,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:p,offset:k,length:L,parent:u})},onObjectEnd:(p,k)=>{u.length=p+k-u.offset,u=u.parent,i(p+k)},onArrayBegin:(p,k)=>{u=s({type:"array",offset:p,length:-1,parent:u,children:[]})},onArrayEnd:(p,k)=>{u.length=p+k-u.offset,u=u.parent,i(p+k)},onLiteralValue:(p,k,L)=>{s({type:b(p),offset:k,length:L,parent:u,value:p}),i(k+L)},onSeparator:(p,k,L)=>{u.type==="property"&&(p===":"?u.colonOffset=k:p===","&&i(k))},onError:(p,k,L)=>{r.push({error:p,offset:k,length:L})}},c);const l=u.children[0];return l&&delete l.parent,l}e.parseTree=y;function v(o,r){if(!o)return;let c=o;for(const u of r)if(typeof u=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let i=!1;for(const s of c.children)if(Array.isArray(s.children)&&s.children[0].value===u){c=s.children[1],i=!0;break}if(!i)return}else{const i=u;if(c.type!=="array"||i<0||!Array.isArray(c.children)||i>=c.children.length)return;c=c.children[i]}return c}e.findNodeAtLocation=v;function d(o){if(!o.parent||!o.parent.children)return[];const r=d(o.parent);if(o.parent.type==="property"){const c=o.parent.children[0].value;r.push(c)}else if(o.parent.type==="array"){const c=o.parent.children.indexOf(o);c!==-1&&r.push(c)}return r}e.getNodePath=d;function g(o){switch(o.type){case"array":return o.children.map(g);case"object":{const r=Object.create(null);for(const c of o.children){const u=c.children[1];u&&(r[c.children[0].value]=g(u))}return r}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=g;function m(o,r,c=!1){return r>=o.offset&&r<o.offset+o.length||c&&r===o.offset+o.length}e.contains=m;function w(o,r,c=!1){if(m(o,r,c)){const u=o.children;if(Array.isArray(u))for(let i=0;i<u.length&&u[i].offset<=r;i++){const s=w(u[i],r,c);if(s)return s}return o}}e.findNodeAtOffset=w;function f(o,r,c=A.DEFAULT){const u=D(o,!1);function i(ie){return ie?()=>ie(u.getTokenOffset(),u.getTokenLength()):()=>!0}function s(ie){return ie?fe=>ie(fe,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=i(r.onObjectBegin),l=s(r.onObjectProperty),p=i(r.onObjectEnd),k=i(r.onArrayBegin),L=i(r.onArrayEnd),B=s(r.onLiteralValue),K=s(r.onSeparator),G=i(r.onComment),O=s(r.onError),U=c&&c.disallowComments,F=c&&c.allowTrailingComma;function z(){for(;;){const ie=u.scan();switch(u.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:U||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(ie){case 12:case 13:U?M(10):G();break;case 16:M(1);break;case 15:case 14:break;default:return ie}}}function M(ie,fe=[],J=[]){if(O(ie),fe.length+J.length>0){let pe=u.getToken();for(;pe!==17;){if(fe.indexOf(pe)!==-1){z();break}else if(J.indexOf(pe)!==-1)break;pe=z()}}}function V(ie){const fe=u.getTokenValue();return ie?B(fe):l(fe),z(),!0}function q(){switch(u.getToken()){case 11:{let ie=0;try{ie=JSON.parse(u.getTokenValue()),typeof ie!="number"&&(M(2),ie=0)}catch{M(2)}B(ie);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return z(),!0}function H(){return u.getToken()!==10?(M(3,[],[2,5]),!1):(V(!1),u.getToken()===6?(K(":"),z(),ce()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function Q(){n(),z();let ie=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(ie||M(4,[],[]),K(","),z(),u.getToken()===2&&F)break}else ie&&M(6,[],[]);H()||M(4,[],[2,5]),ie=!0}return p(),u.getToken()!==2?M(7,[2],[]):z(),!0}function Y(){k(),z();let ie=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(ie||M(4,[],[]),K(","),z(),u.getToken()===4&&F)break}else ie&&M(6,[],[]);ce()||M(4,[],[4,5]),ie=!0}return L(),u.getToken()!==4?M(8,[4],[]):z(),!0}function ce(){switch(u.getToken()){case 3:return Y();case 1:return Q();case 10:return V(!0);default:return q()}}return z(),u.getToken()===17?c.allowEmptyContent?!0:(M(4,[],[]),!1):ce()?(u.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=f;function h(o,r){const c=D(o),u=[];let i,s=0,n;do switch(n=c.getPosition(),i=c.scan(),i){case 12:case 13:case 17:s!==n&&u.push(o.substring(s,n)),r!==void 0&&u.push(c.getTokenValue().replace(/[^\r\n]/g,r)),s=c.getPosition();break}while(i!==17);return u.join("")}e.stripComments=h;function b(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(Se[82],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(I){this.d=I,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(I){this.c=I}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(I){return new a(()=>I(this.getValue()))}}e.Lazy=a}),define(Se[6],ye([1,0,62,63]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let A=null;function D(s){A=s}if(e.setDisposableTracker=D,I){const s="__is_disposable_tracked__";D(new class{trackDisposable(n){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[s]||console.log(l)},3e3)}setParent(n,l){if(n&&n!==w.None)try{n[s]=!0}catch{}}markAsDisposed(n){if(n&&n!==w.None)try{n[s]=!0}catch{}}markAsSingleton(n){}})}function T(s){return A?.trackDisposable(s),s}function S(s){A?.markAsDisposed(s)}function C(s,n){A?.setParent(s,n)}function R(s,n){if(!!A)for(const l of s)A.setParent(l,n)}function P(s){return A?.markAsSingleton(s),s}e.markAsSingleton=P;function E(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=E;function y(s){if(t.Iterable.is(s)){const n=[];for(const l of s)if(l)try{l.dispose()}catch(p){n.push(p)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=y;function v(s){for(const n of s)E(n)&&n.dispose();return[]}e.disposeIfDisposable=v;function d(...s){const n=g(()=>y(s));return R(s,n),n}e.combinedDisposable=d;function g(s){const n=T({dispose:(0,a.once)(()=>{S(n),s()})});return n}e.toDisposable=g;class m{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{y(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return C(n,this),this.f?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this.q=new m,T(this),C(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class f{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&C(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&C(n,null),n}}e.MutableDisposable=f;class h{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=h;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let l=n;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,S(this))},this}}e.SafeDisposable=b;class o{constructor(){this.a=new Map}acquire(n,...l){let p=this.a.get(n);p||(p={counter:0,object:this.b(n,...l)},this.a.set(n,p));const{object:k}=p,L=(0,a.once)(()=>{--p.counter===0&&(this.c(n,p.object),this.a.delete(n))});return p.counter++,{object:k,dispose:L}}}e.ReferenceCollection=o;class r{constructor(n){this.a=n}async acquire(n,...l){const p=this.a.acquire(n,...l);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(k){throw p.dispose(),k}}}e.AsyncReferenceCollection=r;class c{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=c;function u(s){const n=new m;try{s(n)}finally{n.dispose()}}e.disposeOnReturn=u;class i{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,l,p=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this.a.get(n)?.dispose(),this.a.set(n,l)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=i}),define(Se[64],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(A){this.element=A,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let A=this.a;for(;A!==a.Undefined;){const D=A.next;A.prev=a.Undefined,A.next=a.Undefined,A=D}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,D){const T=new a(A);if(this.a===a.Undefined)this.a=T,this.b=T;else if(D){const C=this.b;this.b=T,T.prev=C,C.next=T}else{const C=this.a;this.a=T,T.next=C,C.prev=T}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(T))}}shift(){if(this.a!==a.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==a.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==a.Undefined&&A.next!==a.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===a.Undefined&&A.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):A.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):A.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==a.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),define(Se[28],ye([1,0]),function(ee,e){"use strict";var a,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,d,g){let m=v.get(d);return m===void 0&&(m=g,v.set(d,m)),m}e.getOrSet=A;function D(v){const d=[];return v.forEach((g,m)=>{d.push(`${m} => ${g}`)}),`Map(${v.size}) {${d.join(", ")}}`}e.mapToString=D;function T(v){const d=[];return v.forEach(g=>{d.push(g)}),`Set(${v.size}) {${d.join(", ")}}`}e.setToString=T;class S{constructor(d,g){this.uri=d,this.value=g}}class C{constructor(d,g){this[a]="ResourceMap",d instanceof C?(this.b=new Map(d.b),this.c=g??C.a):(this.b=new Map,this.c=d??C.a)}set(d,g){return this.b.set(this.c(d),new S(d,g)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,g){typeof g<"u"&&(d=d.bind(g));for(const[m,w]of this.b)d(w.value,w.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=C,C.a=v=>v.toString();class R{constructor(d,g){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new C(d):(this.a=new C(g),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,g){this.a.forEach((m,w)=>d.call(g,w,w,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var P;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class E{constructor(){this[I]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,g=0){const m=this.a.get(d);if(!!m)return g!==0&&this.j(m,g),m.value}set(d,g,m=0){let w=this.a.get(d);if(w)w.value=g,m!==0&&this.j(w,m);else{switch(w={key:d,value:g,next:void 0,previous:void 0},m){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(d,w),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const g=this.a.get(d);if(!!g)return this.a.delete(d),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,g){const m=this.e;let w=this.b;for(;w;){if(g?d.bind(g)(w.value,w.key,this):d(w.value,w.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const d=this,g=this.e;let m=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:m.key,done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return w}values(){const d=this,g=this.e;let m=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:m.value,done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return w}entries(){const d=this,g=this.e;let m=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:[m.key,m.value],done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return w}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let g=this.b,m=this.size;for(;g&&m>d;)this.a.delete(g.key),g=g.next,m--;this.b=g,this.d=m,g&&(g.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const g=d.next,m=d.previous;if(!g||!m)throw new Error("Invalid list");g.previous=m,m.next=g}d.next=void 0,d.previous=void 0,this.e++}j(d,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(d===this.b)return;const m=d.next,w=d.previous;d===this.c?(w.next=void 0,this.c=w):(m.previous=w,w.next=m),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(g===2){if(d===this.c)return;const m=d.next,w=d.previous;d===this.b?(m.previous=void 0,this.b=m):(m.previous=w,w.next=m),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((g,m)=>{d.push([m,g])}),d}fromJSON(d){this.clear();for(const[g,m]of d)this.set(g,m)}}e.LinkedMap=E;class y extends E{constructor(d,g=1){super(),this.k=d,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,g=2){return super.get(d,g)}peek(d){return super.get(d,0)}set(d,g){return super.set(d,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=y}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Se[146],ye([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(re,ue){for(var de=0;de<ue.length;de++){var Z=ue[de];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(re,Z.key,Z)}}function a(re,ue,de){return ue&&e(re.prototype,ue),de&&e(re,de),Object.defineProperty(re,"prototype",{writable:!1}),re}function t(re,ue){if(!!re){if(typeof re=="string")return I(re,ue);var de=Object.prototype.toString.call(re).slice(8,-1);if(de==="Object"&&re.constructor&&(de=re.constructor.name),de==="Map"||de==="Set")return Array.from(re);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return I(re,ue)}}function I(re,ue){(ue==null||ue>re.length)&&(ue=re.length);for(var de=0,Z=new Array(ue);de<ue;de++)Z[de]=re[de];return Z}function A(re,ue){var de=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(de)return(de=de.call(re)).next.bind(de);if(Array.isArray(re)||(de=t(re))||ue&&re&&typeof re.length=="number"){de&&(re=de);var Z=0;return function(){return Z>=re.length?{done:!0}:{done:!1,value:re[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=D();function T(re){ee.defaults=re}var S=/[&<>"']/,C=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(ue){return E[ue]};function v(re,ue){if(ue){if(S.test(re))return re.replace(C,y)}else if(R.test(re))return re.replace(P,y);return re}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(re){return re.replace(d,function(ue,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var m=/(^|[^\[])\^/g;function w(re,ue){re=typeof re=="string"?re:re.source,ue=ue||"";var de={replace:function(se,ne){return ne=ne.source||ne,ne=ne.replace(m,"$1"),re=re.replace(se,ne),de},getRegex:function(){return new RegExp(re,ue)}};return de}var f=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(re,ue,de){if(re){var Z;try{Z=decodeURIComponent(g(de)).replace(f,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ue&&!h.test(de)&&(de=i(ue,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var o={},r=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(re,ue){o[" "+re]||(r.test(re)?o[" "+re]=re+"/":o[" "+re]=p(re,"/",!0)),re=o[" "+re];var de=re.indexOf(":")===-1;return ue.substring(0,2)==="//"?de?ue:re.replace(c,"$1")+ue:ue.charAt(0)==="/"?de?ue:re.replace(u,"$1")+ue:re+ue}var s={exec:function(){}};function n(re){for(var ue=1,de,Z;ue<arguments.length;ue++){de=arguments[ue];for(Z in de)Object.prototype.hasOwnProperty.call(de,Z)&&(re[Z]=de[Z])}return re}function l(re,ue){var de=re.replace(/\|/g,function(ne,N,$){for(var x=!1,_=N;--_>=0&&$[_]==="\\";)x=!x;return x?"|":" |"}),Z=de.split(/ \|/),se=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ue)Z.splice(ue);else for(;Z.length<ue;)Z.push("");for(;se<Z.length;se++)Z[se]=Z[se].trim().replace(/\\\|/g,"|");return Z}function p(re,ue,de){var Z=re.length;if(Z===0)return"";for(var se=0;se<Z;){var ne=re.charAt(Z-se-1);if(ne===ue&&!de)se++;else if(ne!==ue&&de)se++;else break}return re.slice(0,Z-se)}function k(re,ue){if(re.indexOf(ue[1])===-1)return-1;for(var de=re.length,Z=0,se=0;se<de;se++)if(re[se]==="\\")se++;else if(re[se]===ue[0])Z++;else if(re[se]===ue[1]&&(Z--,Z<0))return se;return-1}function L(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(re,ue){if(ue<1)return"";for(var de="";ue>1;)ue&1&&(de+=re),ue>>=1,re+=re;return de+re}function K(re,ue,de,Z){var se=ue.href,ne=ue.title?v(ue.title):null,N=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){Z.state.inLink=!0;var $={type:"link",raw:de,href:se,title:ne,text:N,tokens:Z.inlineTokens(N)};return Z.state.inLink=!1,$}return{type:"image",raw:de,href:se,title:ne,text:v(N)}}function G(re,ue){var de=re.match(/^(\s+)(?:```)/);if(de===null)return ue;var Z=de[1];return ue.split(`
`).map(function(se){var ne=se.match(/^\s+/);if(ne===null)return se;var N=ne[0];return N.length>=Z.length?se.slice(Z.length):se}).join(`
`)}var O=function(){function re(de){this.options=de||ee.defaults}var ue=re.prototype;return ue.space=function(Z){var se=this.rules.block.newline.exec(Z);if(se&&se[0].length>0)return{type:"space",raw:se[0]}},ue.code=function(Z){var se=this.rules.block.code.exec(Z);if(se){var ne=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:p(ne,`
`)}}},ue.fences=function(Z){var se=this.rules.block.fences.exec(Z);if(se){var ne=se[0],N=G(ne,se[3]||"");return{type:"code",raw:ne,lang:se[2]?se[2].trim():se[2],text:N}}},ue.heading=function(Z){var se=this.rules.block.heading.exec(Z);if(se){var ne=se[2].trim();if(/#$/.test(ne)){var N=p(ne,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ne=N.trim())}return{type:"heading",raw:se[0],depth:se[1].length,text:ne,tokens:this.lexer.inline(ne)}}},ue.hr=function(Z){var se=this.rules.block.hr.exec(Z);if(se)return{type:"hr",raw:se[0]}},ue.blockquote=function(Z){var se=this.rules.block.blockquote.exec(Z);if(se){var ne=se[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},ue.list=function(Z){var se=this.rules.block.list.exec(Z);if(se){var ne,N,$,x,_,le,be,Pe,ge,Ce,ke,je,Ge=se[1].trim(),et=Ge.length>1,_e={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(je=!1,!(!(se=nt.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=se[0],Z=Z.substring(ne.length),Pe=se[2].split(`
`,1)[0],ge=Z.split(`
`,1)[0],this.options.pedantic?(x=2,ke=Pe.trimLeft()):(x=se[2].search(/[^ ]/),x=x>4?1:x,ke=Pe.slice(x),x+=se[1].length),le=!1,!Pe&&/^ *$/.test(ge)&&(ne+=ge+`
`,Z=Z.substring(ge.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,x-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,x-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],Pe=Ce,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Pe)||it.test(Pe)||st.test(Pe)||ht.test(Z)));){if(Pe.search(/[^ ]/)>=x||!Pe.trim())ke+=`
`+Pe.slice(x);else if(!le)ke+=`
`+Pe;else break;!le&&!Pe.trim()&&(le=!0),ne+=Ce+`
`,Z=Z.substring(Ce.length+1)}_e.loose||(be?_e.loose=!0:/\n *\n *$/.test(ne)&&(be=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(ke),N&&($=N[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:ne,task:!!N,checked:$,loose:!1,text:ke}),_e.raw+=ne}_e.items[_e.items.length-1].raw=ne.trimRight(),_e.items[_e.items.length-1].text=ke.trimRight(),_e.raw=_e.raw.trimRight();var oe=_e.items.length;for(_=0;_<oe;_++){this.lexer.state.top=!1,_e.items[_].tokens=this.lexer.blockTokens(_e.items[_].text,[]);var W=_e.items[_].tokens.filter(function(De){return De.type==="space"}),ae=W.every(function(De){for(var Le=De.raw.split(""),Be=0,xe=A(Le),Ze;!(Ze=xe()).done;){var mt=Ze.value;if(mt===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&W.length&&ae&&(_e.loose=!0,_e.items[_].loose=!0)}return _e}},ue.html=function(Z){var se=this.rules.block.html.exec(Z);if(se){var ne={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]);ne.type="paragraph",ne.text=N,ne.tokens=this.lexer.inline(N)}return ne}},ue.def=function(Z){var se=this.rules.block.def.exec(Z);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var ne=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:se[0],href:se[2],title:se[3]}}},ue.table=function(Z){var se=this.rules.block.table.exec(Z);if(se){var ne={type:"table",header:l(se[1]).map(function(be){return{text:be}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]&&se[3].trim()?se[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=se[0];var N=ne.align.length,$,x,_,le;for($=0;$<N;$++)/^ *-+: *$/.test(ne.align[$])?ne.align[$]="right":/^ *:-+: *$/.test(ne.align[$])?ne.align[$]="center":/^ *:-+ *$/.test(ne.align[$])?ne.align[$]="left":ne.align[$]=null;for(N=ne.rows.length,$=0;$<N;$++)ne.rows[$]=l(ne.rows[$],ne.header.length).map(function(be){return{text:be}});for(N=ne.header.length,x=0;x<N;x++)ne.header[x].tokens=this.lexer.inline(ne.header[x].text);for(N=ne.rows.length,x=0;x<N;x++)for(le=ne.rows[x],_=0;_<le.length;_++)le[_].tokens=this.lexer.inline(le[_].text);return ne}}},ue.lheading=function(Z){var se=this.rules.block.lheading.exec(Z);if(se)return{type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:this.lexer.inline(se[1])}},ue.paragraph=function(Z){var se=this.rules.block.paragraph.exec(Z);if(se){var ne=se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1];return{type:"paragraph",raw:se[0],text:ne,tokens:this.lexer.inline(ne)}}},ue.text=function(Z){var se=this.rules.block.text.exec(Z);if(se)return{type:"text",raw:se[0],text:se[0],tokens:this.lexer.inline(se[0])}},ue.escape=function(Z){var se=this.rules.inline.escape.exec(Z);if(se)return{type:"escape",raw:se[0],text:v(se[1])}},ue.tag=function(Z){var se=this.rules.inline.tag.exec(Z);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]):se[0]}},ue.link=function(Z){var se=this.rules.inline.link.exec(Z);if(se){var ne=se[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var N=p(ne.slice(0,-1),"\\");if((ne.length-N.length)%2===0)return}else{var $=k(se[2],"()");if($>-1){var x=se[0].indexOf("!")===0?5:4,_=x+se[1].length+$;se[2]=se[2].substring(0,$),se[0]=se[0].substring(0,_).trim(),se[3]=""}}var le=se[2],be="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(le);Pe&&(le=Pe[1],be=Pe[3])}else be=se[3]?se[3].slice(1,-1):"";return le=le.trim(),/^</.test(le)&&(this.options.pedantic&&!/>$/.test(ne)?le=le.slice(1):le=le.slice(1,-1)),K(se,{href:le&&le.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},ue.reflink=function(Z,se){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var N=(ne[2]||ne[1]).replace(/\s+/g," ");if(N=se[N.toLowerCase()],!N||!N.href){var $=ne[0].charAt(0);return{type:"text",raw:$,text:$}}return K(ne,N,ne[0],this.lexer)}},ue.emStrong=function(Z,se,ne){ne===void 0&&(ne="");var N=this.rules.inline.emStrong.lDelim.exec(Z);if(!!N&&!(N[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=N[1]||N[2]||"";if(!$||$&&(ne===""||this.rules.inline.punctuation.exec(ne))){var x=N[0].length-1,_,le,be=x,Pe=0,ge=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,se=se.slice(-1*Z.length+x);(N=ge.exec(se))!=null;)if(_=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!_){if(le=_.length,N[3]||N[4]){be+=le;continue}else if((N[5]||N[6])&&x%3&&!((x+le)%3)){Pe+=le;continue}if(be-=le,!(be>0)){if(le=Math.min(le,le+be+Pe),Math.min(x,le)%2){var Ce=Z.slice(1,x+N.index+le);return{type:"em",raw:Z.slice(0,x+N.index+le+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=Z.slice(2,x+N.index+le-1);return{type:"strong",raw:Z.slice(0,x+N.index+le+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ue.codespan=function(Z){var se=this.rules.inline.code.exec(Z);if(se){var ne=se[2].replace(/\n/g," "),N=/[^ ]/.test(ne),$=/^ /.test(ne)&&/ $/.test(ne);return N&&$&&(ne=ne.substring(1,ne.length-1)),ne=v(ne,!0),{type:"codespan",raw:se[0],text:ne}}},ue.br=function(Z){var se=this.rules.inline.br.exec(Z);if(se)return{type:"br",raw:se[0]}},ue.del=function(Z){var se=this.rules.inline.del.exec(Z);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2])}},ue.autolink=function(Z,se){var ne=this.rules.inline.autolink.exec(Z);if(ne){var N,$;return ne[2]==="@"?(N=v(this.options.mangle?se(ne[1]):ne[1]),$="mailto:"+N):(N=v(ne[1]),$=N),{type:"link",raw:ne[0],text:N,href:$,tokens:[{type:"text",raw:N,text:N}]}}},ue.url=function(Z,se){var ne;if(ne=this.rules.inline.url.exec(Z)){var N,$;if(ne[2]==="@")N=v(this.options.mangle?se(ne[0]):ne[0]),$="mailto:"+N;else{var x;do x=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(x!==ne[0]);N=v(ne[0]),ne[1]==="www."?$="http://"+N:$=N}return{type:"link",raw:ne[0],text:N,href:$,tokens:[{type:"text",raw:N,text:N}]}}},ue.inlineText=function(Z,se){var ne=this.rules.inline.text.exec(Z);if(ne){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):v(ne[0]):ne[0]:N=v(this.options.smartypants?se(ne[0]):ne[0]),{type:"text",raw:ne[0],text:N}}},re}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:s,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=w(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=w(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=w(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=w(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=w(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=w(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=n({},U),U.gfm=n({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=w(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=w(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=n({},U.normal,{html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:s,paragraph:w(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:s,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:s,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=w(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=w(U._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=w(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=w(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=w(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=w(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=w(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=w(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=w(F.reflink).replace("label",F._label).replace("ref",U._label).getRegex(),F.nolink=w(F.nolink).replace("ref",U._label).getRegex(),F.reflinkSearch=w(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:w(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=w(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:w(F.br).replace("{2,}","*").getRegex(),text:w(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function M(re){var ue="",de,Z,se=re.length;for(de=0;de<se;de++)Z=re.charCodeAt(de),Math.random()>.5&&(Z="x"+Z.toString(16)),ue+="&#"+Z+";";return ue}var V=function(){function re(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ee.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:U.normal,inline:F.normal};this.options.pedantic?(Z.block=U.pedantic,Z.inline=F.pedantic):this.options.gfm&&(Z.block=U.gfm,this.options.breaks?Z.inline=F.breaks:Z.inline=F.gfm),this.tokenizer.rules=Z}re.lex=function(Z,se){var ne=new re(se);return ne.lex(Z)},re.lexInline=function(Z,se){var ne=new re(se);return ne.inlineTokens(Z)};var ue=re.prototype;return ue.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},ue.blockTokens=function(Z,se){var ne=this;se===void 0&&(se=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(be,Pe,ge){return Pe+"    ".repeat(ge.length)});for(var N,$,x,_;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(N=be.call({lexer:ne},Z,se))?(Z=Z.substring(N.raw.length),se.push(N),!0):!1}))){if(N=this.tokenizer.space(Z)){Z=Z.substring(N.raw.length),N.raw.length===1&&se.length>0?se[se.length-1].raw+=`
`:se.push(N);continue}if(N=this.tokenizer.code(Z)){Z=Z.substring(N.raw.length),$=se[se.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+N.raw,$.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):se.push(N);continue}if(N=this.tokenizer.fences(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.heading(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.hr(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.blockquote(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.list(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.html(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.def(Z)){Z=Z.substring(N.raw.length),$=se[se.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+N.raw,$.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.lheading(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(x=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,Pe=Z.slice(1),ge=void 0;ne.options.extensions.startBlock.forEach(function(Ce){ge=Ce.call({lexer:this},Pe),typeof ge=="number"&&ge>=0&&(be=Math.min(be,ge))}),be<1/0&&be>=0&&(x=Z.substring(0,be+1))}(),this.state.top&&(N=this.tokenizer.paragraph(x))){$=se[se.length-1],_&&$.type==="paragraph"?($.raw+=`
`+N.raw,$.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):se.push(N),_=x.length!==Z.length,Z=Z.substring(N.raw.length);continue}if(N=this.tokenizer.text(Z)){Z=Z.substring(N.raw.length),$=se[se.length-1],$&&$.type==="text"?($.raw+=`
`+N.raw,$.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):se.push(N);continue}if(Z){var le="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(le);break}else throw new Error(le)}}return this.state.top=!0,se},ue.inline=function(Z,se){return se===void 0&&(se=[]),this.inlineQueue.push({src:Z,tokens:se}),se},ue.inlineTokens=function(Z,se){var ne=this;se===void 0&&(se=[]);var N,$,x,_=Z,le,be,Pe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(le=this.tokenizer.rules.inline.reflinkSearch.exec(_))!=null;)ge.includes(le[0].slice(le[0].lastIndexOf("[")+1,-1))&&(_=_.slice(0,le.index)+"["+B("a",le[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(le=this.tokenizer.rules.inline.blockSkip.exec(_))!=null;)_=_.slice(0,le.index)+"["+B("a",le[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(le=this.tokenizer.rules.inline.escapedEmSt.exec(_))!=null;)_=_.slice(0,le.index)+"++"+_.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(be||(Pe=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(N=ke.call({lexer:ne},Z,se))?(Z=Z.substring(N.raw.length),se.push(N),!0):!1}))){if(N=this.tokenizer.escape(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.tag(Z)){Z=Z.substring(N.raw.length),$=se[se.length-1],$&&N.type==="text"&&$.type==="text"?($.raw+=N.raw,$.text+=N.text):se.push(N);continue}if(N=this.tokenizer.link(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(N.raw.length),$=se[se.length-1],$&&N.type==="text"&&$.type==="text"?($.raw+=N.raw,$.text+=N.text):se.push(N);continue}if(N=this.tokenizer.emStrong(Z,_,Pe)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.codespan(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.br(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.del(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.autolink(Z,M)){Z=Z.substring(N.raw.length),se.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(Z,M))){Z=Z.substring(N.raw.length),se.push(N);continue}if(x=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=Z.slice(1),Ge=void 0;ne.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(x=Z.substring(0,ke+1))}(),N=this.tokenizer.inlineText(x,z)){Z=Z.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Pe=N.raw.slice(-1)),be=!0,$=se[se.length-1],$&&$.type==="text"?($.raw+=N.raw,$.text+=N.text):se.push(N);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return se},a(re,null,[{key:"rules",get:function(){return{block:U,inline:F}}}]),re}(),q=function(){function re(de){this.options=de||ee.defaults}var ue=re.prototype;return ue.code=function(Z,se,ne){var N=(se||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(Z,N);$!=null&&$!==Z&&(ne=!0,Z=$)}return Z=Z.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+v(N,!0)+'">'+(ne?Z:v(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:v(Z,!0))+`</code></pre>
`},ue.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ue.html=function(Z){return Z},ue.heading=function(Z,se,ne,N){if(this.options.headerIds){var $=this.options.headerPrefix+N.slug(ne);return"<h"+se+' id="'+$+'">'+Z+"</h"+se+`>
`}return"<h"+se+">"+Z+"</h"+se+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(Z,se,ne){var N=se?"ol":"ul",$=se&&ne!==1?' start="'+ne+'"':"";return"<"+N+$+`>
`+Z+"</"+N+`>
`},ue.listitem=function(Z){return"<li>"+Z+`</li>
`},ue.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(Z){return"<p>"+Z+`</p>
`},ue.table=function(Z,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+se+`</table>
`},ue.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ue.tablecell=function(Z,se){var ne=se.header?"th":"td",N=se.align?"<"+ne+' align="'+se.align+'">':"<"+ne+">";return N+Z+("</"+ne+`>
`)},ue.strong=function(Z){return"<strong>"+Z+"</strong>"},ue.em=function(Z){return"<em>"+Z+"</em>"},ue.codespan=function(Z){return"<code>"+Z+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(Z){return"<del>"+Z+"</del>"},ue.link=function(Z,se,ne){if(Z=b(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var N='<a href="'+v(Z)+'"';return se&&(N+=' title="'+se+'"'),N+=">"+ne+"</a>",N},ue.image=function(Z,se,ne){if(Z=b(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var N='<img src="'+Z+'" alt="'+ne+'"';return se&&(N+=' title="'+se+'"'),N+=this.options.xhtml?"/>":">",N},ue.text=function(Z){return Z},re}(),H=function(){function re(){}var ue=re.prototype;return ue.strong=function(Z){return Z},ue.em=function(Z){return Z},ue.codespan=function(Z){return Z},ue.del=function(Z){return Z},ue.html=function(Z){return Z},ue.text=function(Z){return Z},ue.link=function(Z,se,ne){return""+ne},ue.image=function(Z,se,ne){return""+ne},ue.br=function(){return""},re}(),Q=function(){function re(){this.seen={}}var ue=re.prototype;return ue.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(Z,se){var ne=Z,N=0;if(this.seen.hasOwnProperty(ne)){N=this.seen[Z];do N++,ne=Z+"-"+N;while(this.seen.hasOwnProperty(ne))}return se||(this.seen[Z]=N,this.seen[ne]=0),ne},ue.slug=function(Z,se){se===void 0&&(se={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,se.dryrun)},re}(),Y=function(){function re(de){this.options=de||ee.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new Q}re.parse=function(Z,se){var ne=new re(se);return ne.parse(Z)},re.parseInline=function(Z,se){var ne=new re(se);return ne.parseInline(Z)};var ue=re.prototype;return ue.parse=function(Z,se){se===void 0&&(se=!0);var ne="",N,$,x,_,le,be,Pe,ge,Ce,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe=Z.length;for(N=0;N<oe;N++){if(ke=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ne+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,g(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(ge="",Pe="",_=ke.header.length,$=0;$<_;$++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[$].tokens),{header:!0,align:ke.align[$]});for(ge+=this.renderer.tablerow(Pe),Ce="",_=ke.rows.length,$=0;$<_;$++){for(be=ke.rows[$],Pe="",le=be.length,x=0;x<le;x++)Pe+=this.renderer.tablecell(this.parseInline(be[x].tokens),{header:!1,align:ke.align[x]});Ce+=this.renderer.tablerow(Pe)}ne+=this.renderer.table(ge,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),ne+=this.renderer.blockquote(Ce);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,_=ke.items.length,Ce="",$=0;$<_;$++)nt=ke.items[$],st=nt.checked,ht=nt.task,_e="",nt.task&&(Me=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Me+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Me+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Me}):_e+=Me),_e+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(_e,ht,st);ne+=this.renderer.list(Ce,je,Ge);continue}case"html":{ne+=this.renderer.html(ke.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;N+1<oe&&Z[N+1].type==="text";)ke=Z[++N],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ne+=se?this.renderer.paragraph(Ce):Ce;continue}default:{var W='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return ne},ue.parseInline=function(Z,se){se=se||this.renderer;var ne="",N,$,x,_=Z.length;for(N=0;N<_;N++){if($=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(x=this.options.extensions.renderers[$.type].call({parser:this},$),x!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){ne+=x||"";continue}switch($.type){case"escape":{ne+=se.text($.text);break}case"html":{ne+=se.html($.text);break}case"link":{ne+=se.link($.href,$.title,this.parseInline($.tokens,se));break}case"image":{ne+=se.image($.href,$.title,$.text);break}case"strong":{ne+=se.strong(this.parseInline($.tokens,se));break}case"em":{ne+=se.em(this.parseInline($.tokens,se));break}case"codespan":{ne+=se.codespan($.text);break}case"br":{ne+=se.br();break}case"del":{ne+=se.del(this.parseInline($.tokens,se));break}case"text":{ne+=se.text($.text);break}default:{var le='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(le);return}else throw new Error(le)}}}return ne},re}();function ce(re,ue,de){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof ue=="function"&&(de=ue,ue=null),ue=n({},ce.defaults,ue||{}),L(ue),de){var Z=ue.highlight,se;try{se=V.lex(re,ue)}catch(_){return de(_)}var ne=function(le){var be;if(!le)try{ue.walkTokens&&ce.walkTokens(se,ue.walkTokens),be=Y.parse(se,ue)}catch(Pe){le=Pe}return ue.highlight=Z,le?de(le):de(null,be)};if(!Z||Z.length<3||(delete ue.highlight,!se.length))return ne();var N=0;ce.walkTokens(se,function(_){_.type==="code"&&(N++,setTimeout(function(){Z(_.text,_.lang,function(le,be){if(le)return ne(le);be!=null&&be!==_.text&&(_.text=be,_.escaped=!0),N--,N===0&&ne()})},0))}),N===0&&ne();return}function $(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(_.message+"",!0)+"</pre>";throw _}try{var x=V.lex(re,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ce.walkTokens(x,ue.walkTokens)).then(function(){return Y.parse(x,ue)}).catch($);ce.walkTokens(x,ue.walkTokens)}return Y.parse(x,ue)}catch(_){$(_)}}ce.options=ce.setOptions=function(re){return n(ce.defaults,re),T(ce.defaults),ce},ce.getDefaults=D,ce.defaults=ee.defaults,ce.use=function(){for(var re=arguments.length,ue=new Array(re),de=0;de<re;de++)ue[de]=arguments[de];var Z=n.apply(void 0,[{}].concat(ue)),se=ce.defaults.extensions||{renderers:{},childTokens:{}},ne;ue.forEach(function(N){if(N.extensions&&(ne=!0,N.extensions.forEach(function(x){if(!x.name)throw new Error("extension name required");if(x.renderer){var _=se.renderers?se.renderers[x.name]:null;_?se.renderers[x.name]=function(){for(var le=arguments.length,be=new Array(le),Pe=0;Pe<le;Pe++)be[Pe]=arguments[Pe];var ge=x.renderer.apply(this,be);return ge===!1&&(ge=_.apply(this,be)),ge}:se.renderers[x.name]=x.renderer}if(x.tokenizer){if(!x.level||x.level!=="block"&&x.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");se[x.level]?se[x.level].unshift(x.tokenizer):se[x.level]=[x.tokenizer],x.start&&(x.level==="block"?se.startBlock?se.startBlock.push(x.start):se.startBlock=[x.start]:x.level==="inline"&&(se.startInline?se.startInline.push(x.start):se.startInline=[x.start]))}x.childTokens&&(se.childTokens[x.name]=x.childTokens)})),N.renderer&&function(){var x=ce.defaults.renderer||new q,_=function(Pe){var ge=x[Pe];x[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),je=0;je<Ce;je++)ke[je]=arguments[je];var Ge=N.renderer[Pe].apply(x,ke);return Ge===!1&&(Ge=ge.apply(x,ke)),Ge}};for(var le in N.renderer)_(le);Z.renderer=x}(),N.tokenizer&&function(){var x=ce.defaults.tokenizer||new O,_=function(Pe){var ge=x[Pe];x[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),je=0;je<Ce;je++)ke[je]=arguments[je];var Ge=N.tokenizer[Pe].apply(x,ke);return Ge===!1&&(Ge=ge.apply(x,ke)),Ge}};for(var le in N.tokenizer)_(le);Z.tokenizer=x}(),N.walkTokens){var $=ce.defaults.walkTokens;Z.walkTokens=function(x){var _=[];return _.push(N.walkTokens.call(this,x)),$&&(_=_.concat($.call(this,x))),_}}ne&&(Z.extensions=se),ce.setOptions(Z)})},ce.walkTokens=function(re,ue){for(var de=[],Z=function(){var $=ne.value;switch(de=de.concat(ue.call(ce,$)),$.type){case"table":{for(var x=A($.header),_;!(_=x()).done;){var le=_.value;de=de.concat(ce.walkTokens(le.tokens,ue))}for(var be=A($.rows),Pe;!(Pe=be()).done;)for(var ge=Pe.value,Ce=A(ge),ke;!(ke=Ce()).done;){var je=ke.value;de=de.concat(ce.walkTokens(je.tokens,ue))}break}case"list":{de=de.concat(ce.walkTokens($.items,ue));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[$.type]?ce.defaults.extensions.childTokens[$.type].forEach(function(Ge){de=de.concat(ce.walkTokens($[Ge],ue))}):$.tokens&&(de=de.concat(ce.walkTokens($.tokens,ue)))}},se=A(re),ne;!(ne=se()).done;)Z();return de},ce.parseInline=function(re,ue){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");ue=n({},ce.defaults,ue||{}),L(ue);try{var de=V.lexInline(re,ue);return ue.walkTokens&&ce.walkTokens(de,ue.walkTokens),Y.parseInline(de,ue)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(Z.message+"",!0)+"</pre>";throw Z}},ce.Parser=Y,ce.parser=Y.parse,ce.Renderer=q,ce.TextRenderer=H,ce.Lexer=V,ce.lexer=V.lex,ce.Tokenizer=O,ce.Slugger=Q,ce.parse=ce;var ie=ce.options,fe=ce.setOptions,J=ce.use,pe=ce.walkTokens,we=ce.parseInline,Ie=ce,Re=Y.parse,ze=V.lex;ee.Lexer=V,ee.Parser=Y,ee.Renderer=q,ee.Slugger=Q,ee.TextRenderer=H,ee.Tokenizer=O,ee.getDefaults=D,ee.lexer=ze,ee.marked=ce,ee.options=ie,ee.parse=Ie,ee.parseInline=we,ee.parser=Re,ee.setOptions=fe,ee.use=J,ee.walkTokens=pe,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Se[83],ye([1,0,28]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new a.LRUCache(1e4);function I(C){return S(C,"NFC",t)}e.normalizeNFC=I;const A=new a.LRUCache(1e4);function D(C){return S(C,"NFD",A)}e.normalizeNFD=D;const T=/[^\u0000-\u0080]/;function S(C,R,P){if(!C)return C;const E=P.get(C);if(E)return E;let y;return T.test(C)?y=C.normalize(R):y=C,P.set(C,y),y}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(R){return D(R).replace(C,"")}}()}),define(Se[100],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(T,S,C){return Math.min(Math.max(T,S),C)}e.clamp=a;function t(T,S){return(S+T%S)%S}e.rot=t;class I{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=I;class A{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class D{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const C=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function ee(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function D(S){A.push(S,Date.now())}function T(){const S=[];for(let C=0;C<A.length;C+=2)S.push({name:A[C],startTime:A[C+1]});return S}return{mark:D,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(I+D.startTime)});return A}};if(typeof process=="object"){const I=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function a(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),define(Se[11],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let a=!1,t=!1,I=!1,A=!1,D=!1,T=!1,S=!1,C=!1,R=!1,P=!1,E,y=e.LANGUAGE_DEFAULT,v,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?g=e.globals.vscode.process:typeof process<"u"&&(g=process);const m=typeof g?.versions?.electron=="string",w=m&&g?.type==="renderer";if(typeof navigator=="object"&&!w){d=navigator.userAgent,a=d.indexOf("Windows")>=0,t=d.indexOf("Macintosh")>=0,C=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=d.indexOf("Linux")>=0,P=d?.indexOf("Mobi")>=0,T=!0,E=e.LANGUAGE_DEFAULT,y=E;const s=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),n=s&&s.getAttribute("data-settings");if(n)try{const l=JSON.parse(n);E=l.locale,v=l._translationsConfigFile,y=l.availableLanguages["*"]||e.LANGUAGE_DEFAULT}catch{}}else if(typeof g=="object"){a=g.platform==="win32",t=g.platform==="darwin",I=g.platform==="linux",A=I&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,S=m,R=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const s=g.env.VSCODE_NLS_CONFIG;if(s)try{const n=JSON.parse(s),l=n.availableLanguages["*"];E=n.locale,y=l||e.LANGUAGE_DEFAULT,v=n._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var f;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function h(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let b=0;t?b=1:a?b=3:I&&(b=2),e.isWindows=a,e.isMacintosh=t,e.isLinux=I,e.isLinuxSnap=A,e.isNative=D,e.isElectron=S,e.isWeb=T,e.isWebWorker=T&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=P,e.isCI=R,e.platform=b,e.userAgent=d,e.language=y;var o;(function(s){function n(){return e.language}s.value=n;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function p(){return e.language==="en"}s.isDefault=p})(o=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let p=0,k=s.length;p<k;p++){const L=s[p];if(L.id===l.data.vscodeScheduleAsyncWork){s.splice(p,1),L.callback();return}}});let n=0;return l=>{const p=++n;s.push({id:p,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:p},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=t||C?2:a?1:3;let c=!0,u=!1;function i(){if(!u){u=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,c=new Uint16Array(s.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Se[35],ye([1,0,11]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const I=a.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Se[9],ye([1,0,35]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,A=90,D=122,T=46,S=47,C=92,R=58,P=63;class E extends Error{constructor(h,b,o){let r;typeof b=="string"&&b.indexOf("not ")===0?(r="must not be",b=b.replace(/^not /,"")):r="must be";const c=h.indexOf(".")!==-1?"property":"argument";let u=`The "${h}" ${c} ${r} of type ${b}`;u+=`. Received type ${typeof o}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function y(f,h){if(typeof f!="string")throw new E(h,"string",f)}function v(f){return f===S||f===C}function d(f){return f===S}function g(f){return f>=t&&f<=A||f>=I&&f<=D}function m(f,h,b,o){let r="",c=0,u=-1,i=0,s=0;for(let n=0;n<=f.length;++n){if(n<f.length)s=f.charCodeAt(n);else{if(o(s))break;s=S}if(o(s)){if(!(u===n-1||i===1))if(i===2){if(r.length<2||c!==2||r.charCodeAt(r.length-1)!==T||r.charCodeAt(r.length-2)!==T){if(r.length>2){const l=r.lastIndexOf(b);l===-1?(r="",c=0):(r=r.slice(0,l),c=r.length-1-r.lastIndexOf(b)),u=n,i=0;continue}else if(r.length!==0){r="",c=0,u=n,i=0;continue}}h&&(r+=r.length>0?`${b}..`:"..",c=2)}else r.length>0?r+=`${b}${f.slice(u+1,n)}`:r=f.slice(u+1,n),c=n-u-1;u=n,i=0}else s===T&&i!==-1?++i:i=-1}return r}function w(f,h){if(h===null||typeof h!="object")throw new E("pathObject","Object",h);const b=h.dir||h.root,o=h.base||`${h.name||""}${h.ext||""}`;return b?b===h.root?`${b}${o}`:`${b}${f}${o}`:o}e.win32={resolve(...f){let h="",b="",o=!1;for(let r=f.length-1;r>=-1;r--){let c;if(r>=0){if(c=f[r],y(c,"path"),c.length===0)continue}else h.length===0?c=a.cwd():(c=a.env[`=${h}`]||a.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==h.toLowerCase()&&c.charCodeAt(2)===C)&&(c=`${h}\\`));const u=c.length;let i=0,s="",n=!1;const l=c.charCodeAt(0);if(u===1)v(l)&&(i=1,n=!0);else if(v(l))if(n=!0,v(c.charCodeAt(1))){let p=2,k=p;for(;p<u&&!v(c.charCodeAt(p));)p++;if(p<u&&p!==k){const L=c.slice(k,p);for(k=p;p<u&&v(c.charCodeAt(p));)p++;if(p<u&&p!==k){for(k=p;p<u&&!v(c.charCodeAt(p));)p++;(p===u||p!==k)&&(s=`\\\\${L}\\${c.slice(k,p)}`,i=p)}}}else i=1;else g(l)&&c.charCodeAt(1)===R&&(s=c.slice(0,2),i=2,u>2&&v(c.charCodeAt(2))&&(n=!0,i=3));if(s.length>0)if(h.length>0){if(s.toLowerCase()!==h.toLowerCase())continue}else h=s;if(o){if(h.length>0)break}else if(b=`${c.slice(i)}\\${b}`,o=n,n&&h.length>0)break}return b=m(b,!o,"\\",v),o?`${h}\\${b}`:`${h}${b}`||"."},normalize(f){y(f,"path");const h=f.length;if(h===0)return".";let b=0,o,r=!1;const c=f.charCodeAt(0);if(h===1)return d(c)?"\\":f;if(v(c))if(r=!0,v(f.charCodeAt(1))){let i=2,s=i;for(;i<h&&!v(f.charCodeAt(i));)i++;if(i<h&&i!==s){const n=f.slice(s,i);for(s=i;i<h&&v(f.charCodeAt(i));)i++;if(i<h&&i!==s){for(s=i;i<h&&!v(f.charCodeAt(i));)i++;if(i===h)return`\\\\${n}\\${f.slice(s)}\\`;i!==s&&(o=`\\\\${n}\\${f.slice(s,i)}`,b=i)}}}else b=1;else g(c)&&f.charCodeAt(1)===R&&(o=f.slice(0,2),b=2,h>2&&v(f.charCodeAt(2))&&(r=!0,b=3));let u=b<h?m(f.slice(b),!r,"\\",v):"";return u.length===0&&!r&&(u="."),u.length>0&&v(f.charCodeAt(h-1))&&(u+="\\"),o===void 0?r?`\\${u}`:u:r?`${o}\\${u}`:`${o}${u}`},isAbsolute(f){y(f,"path");const h=f.length;if(h===0)return!1;const b=f.charCodeAt(0);return v(b)||h>2&&g(b)&&f.charCodeAt(1)===R&&v(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let h,b;for(let c=0;c<f.length;++c){const u=f[c];y(u,"path"),u.length>0&&(h===void 0?h=b=u:h+=`\\${u}`)}if(h===void 0)return".";let o=!0,r=0;if(typeof b=="string"&&v(b.charCodeAt(0))){++r;const c=b.length;c>1&&v(b.charCodeAt(1))&&(++r,c>2&&(v(b.charCodeAt(2))?++r:o=!1))}if(o){for(;r<h.length&&v(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(f,h){if(y(f,"from"),y(h,"to"),f===h)return"";const b=e.win32.resolve(f),o=e.win32.resolve(h);if(b===o||(f=b.toLowerCase(),h=o.toLowerCase(),f===h))return"";let r=0;for(;r<f.length&&f.charCodeAt(r)===C;)r++;let c=f.length;for(;c-1>r&&f.charCodeAt(c-1)===C;)c--;const u=c-r;let i=0;for(;i<h.length&&h.charCodeAt(i)===C;)i++;let s=h.length;for(;s-1>i&&h.charCodeAt(s-1)===C;)s--;const n=s-i,l=u<n?u:n;let p=-1,k=0;for(;k<l;k++){const B=f.charCodeAt(r+k);if(B!==h.charCodeAt(i+k))break;B===C&&(p=k)}if(k!==l){if(p===-1)return o}else{if(n>l){if(h.charCodeAt(i+k)===C)return o.slice(i+k+1);if(k===2)return o.slice(i+k)}u>l&&(f.charCodeAt(r+k)===C?p=k:k===2&&(p=3)),p===-1&&(p=0)}let L="";for(k=r+p+1;k<=c;++k)(k===c||f.charCodeAt(k)===C)&&(L+=L.length===0?"..":"\\..");return i+=p,L.length>0?`${L}${o.slice(i,s)}`:(o.charCodeAt(i)===C&&++i,o.slice(i,s))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const h=e.win32.resolve(f);if(h.length<=2)return f;if(h.charCodeAt(0)===C){if(h.charCodeAt(1)===C){const b=h.charCodeAt(2);if(b!==P&&b!==T)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(g(h.charCodeAt(0))&&h.charCodeAt(1)===R&&h.charCodeAt(2)===C)return`\\\\?\\${h}`;return f},dirname(f){y(f,"path");const h=f.length;if(h===0)return".";let b=-1,o=0;const r=f.charCodeAt(0);if(h===1)return v(r)?f:".";if(v(r)){if(b=o=1,v(f.charCodeAt(1))){let i=2,s=i;for(;i<h&&!v(f.charCodeAt(i));)i++;if(i<h&&i!==s){for(s=i;i<h&&v(f.charCodeAt(i));)i++;if(i<h&&i!==s){for(s=i;i<h&&!v(f.charCodeAt(i));)i++;if(i===h)return f;i!==s&&(b=o=i+1)}}}}else g(r)&&f.charCodeAt(1)===R&&(b=h>2&&v(f.charCodeAt(2))?3:2,o=b);let c=-1,u=!0;for(let i=h-1;i>=o;--i)if(v(f.charCodeAt(i))){if(!u){c=i;break}}else u=!1;if(c===-1){if(b===-1)return".";c=b}return f.slice(0,c)},basename(f,h){h!==void 0&&y(h,"ext"),y(f,"path");let b=0,o=-1,r=!0,c;if(f.length>=2&&g(f.charCodeAt(0))&&f.charCodeAt(1)===R&&(b=2),h!==void 0&&h.length>0&&h.length<=f.length){if(h===f)return"";let u=h.length-1,i=-1;for(c=f.length-1;c>=b;--c){const s=f.charCodeAt(c);if(v(s)){if(!r){b=c+1;break}}else i===-1&&(r=!1,i=c+1),u>=0&&(s===h.charCodeAt(u)?--u===-1&&(o=c):(u=-1,o=i))}return b===o?o=i:o===-1&&(o=f.length),f.slice(b,o)}for(c=f.length-1;c>=b;--c)if(v(f.charCodeAt(c))){if(!r){b=c+1;break}}else o===-1&&(r=!1,o=c+1);return o===-1?"":f.slice(b,o)},extname(f){y(f,"path");let h=0,b=-1,o=0,r=-1,c=!0,u=0;f.length>=2&&f.charCodeAt(1)===R&&g(f.charCodeAt(0))&&(h=o=2);for(let i=f.length-1;i>=h;--i){const s=f.charCodeAt(i);if(v(s)){if(!c){o=i+1;break}continue}r===-1&&(c=!1,r=i+1),s===T?b===-1?b=i:u!==1&&(u=1):b!==-1&&(u=-1)}return b===-1||r===-1||u===0||u===1&&b===r-1&&b===o+1?"":f.slice(b,r)},format:w.bind(null,"\\"),parse(f){y(f,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return h;const b=f.length;let o=0,r=f.charCodeAt(0);if(b===1)return v(r)?(h.root=h.dir=f,h):(h.base=h.name=f,h);if(v(r)){if(o=1,v(f.charCodeAt(1))){let p=2,k=p;for(;p<b&&!v(f.charCodeAt(p));)p++;if(p<b&&p!==k){for(k=p;p<b&&v(f.charCodeAt(p));)p++;if(p<b&&p!==k){for(k=p;p<b&&!v(f.charCodeAt(p));)p++;p===b?o=p:p!==k&&(o=p+1)}}}}else if(g(r)&&f.charCodeAt(1)===R){if(b<=2)return h.root=h.dir=f,h;if(o=2,v(f.charCodeAt(2))){if(b===3)return h.root=h.dir=f,h;o=3}}o>0&&(h.root=f.slice(0,o));let c=-1,u=o,i=-1,s=!0,n=f.length-1,l=0;for(;n>=o;--n){if(r=f.charCodeAt(n),v(r)){if(!s){u=n+1;break}continue}i===-1&&(s=!1,i=n+1),r===T?c===-1?c=n:l!==1&&(l=1):c!==-1&&(l=-1)}return i!==-1&&(c===-1||l===0||l===1&&c===i-1&&c===u+1?h.base=h.name=f.slice(u,i):(h.name=f.slice(u,c),h.base=f.slice(u,i),h.ext=f.slice(c,i))),u>0&&u!==o?h.dir=f.slice(0,u-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let h="",b=!1;for(let o=f.length-1;o>=-1&&!b;o--){const r=o>=0?f[o]:a.cwd();y(r,"path"),r.length!==0&&(h=`${r}/${h}`,b=r.charCodeAt(0)===S)}return h=m(h,!b,"/",d),b?`/${h}`:h.length>0?h:"."},normalize(f){if(y(f,"path"),f.length===0)return".";const h=f.charCodeAt(0)===S,b=f.charCodeAt(f.length-1)===S;return f=m(f,!h,"/",d),f.length===0?h?"/":b?"./":".":(b&&(f+="/"),h?`/${f}`:f)},isAbsolute(f){return y(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let h;for(let b=0;b<f.length;++b){const o=f[b];y(o,"path"),o.length>0&&(h===void 0?h=o:h+=`/${o}`)}return h===void 0?".":e.posix.normalize(h)},relative(f,h){if(y(f,"from"),y(h,"to"),f===h||(f=e.posix.resolve(f),h=e.posix.resolve(h),f===h))return"";const b=1,o=f.length,r=o-b,c=1,u=h.length-c,i=r<u?r:u;let s=-1,n=0;for(;n<i;n++){const p=f.charCodeAt(b+n);if(p!==h.charCodeAt(c+n))break;p===S&&(s=n)}if(n===i)if(u>i){if(h.charCodeAt(c+n)===S)return h.slice(c+n+1);if(n===0)return h.slice(c+n)}else r>i&&(f.charCodeAt(b+n)===S?s=n:n===0&&(s=0));let l="";for(n=b+s+1;n<=o;++n)(n===o||f.charCodeAt(n)===S)&&(l+=l.length===0?"..":"/..");return`${l}${h.slice(c+s)}`},toNamespacedPath(f){return f},dirname(f){if(y(f,"path"),f.length===0)return".";const h=f.charCodeAt(0)===S;let b=-1,o=!0;for(let r=f.length-1;r>=1;--r)if(f.charCodeAt(r)===S){if(!o){b=r;break}}else o=!1;return b===-1?h?"/":".":h&&b===1?"//":f.slice(0,b)},basename(f,h){h!==void 0&&y(h,"ext"),y(f,"path");let b=0,o=-1,r=!0,c;if(h!==void 0&&h.length>0&&h.length<=f.length){if(h===f)return"";let u=h.length-1,i=-1;for(c=f.length-1;c>=0;--c){const s=f.charCodeAt(c);if(s===S){if(!r){b=c+1;break}}else i===-1&&(r=!1,i=c+1),u>=0&&(s===h.charCodeAt(u)?--u===-1&&(o=c):(u=-1,o=i))}return b===o?o=i:o===-1&&(o=f.length),f.slice(b,o)}for(c=f.length-1;c>=0;--c)if(f.charCodeAt(c)===S){if(!r){b=c+1;break}}else o===-1&&(r=!1,o=c+1);return o===-1?"":f.slice(b,o)},extname(f){y(f,"path");let h=-1,b=0,o=-1,r=!0,c=0;for(let u=f.length-1;u>=0;--u){const i=f.charCodeAt(u);if(i===S){if(!r){b=u+1;break}continue}o===-1&&(r=!1,o=u+1),i===T?h===-1?h=u:c!==1&&(c=1):h!==-1&&(c=-1)}return h===-1||o===-1||c===0||c===1&&h===o-1&&h===b+1?"":f.slice(h,o)},format:w.bind(null,"/"),parse(f){y(f,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return h;const b=f.charCodeAt(0)===S;let o;b?(h.root="/",o=1):o=0;let r=-1,c=0,u=-1,i=!0,s=f.length-1,n=0;for(;s>=o;--s){const l=f.charCodeAt(s);if(l===S){if(!i){c=s+1;break}continue}u===-1&&(i=!1,u=s+1),l===T?r===-1?r=s:n!==1&&(n=1):r!==-1&&(n=-1)}if(u!==-1){const l=c===0&&b?1:c;r===-1||n===0||n===1&&r===u-1&&r===c+1?h.base=h.name=f.slice(l,u):(h.name=f.slice(l,r),h.base=f.slice(l,u),h.ext=f.slice(r,u))}return c>0?h.dir=f.slice(0,c-1):b&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=a.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=a.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=a.platform==="win32"?e.win32.join:e.posix.join,e.resolve=a.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=a.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=a.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=a.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=a.platform==="win32"?e.win32.extname:e.posix.extname,e.format=a.platform==="win32"?e.win32.format:e.posix.format,e.parse=a.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=a.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=a.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=a.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Se[84],ye([1,0,9]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const P=(0,a.extname)(R),E=t[P.toLowerCase()];return E!==void 0?E:D(R)}e.getMediaOrTextMime=A;function D(R){const P=(0,a.extname)(R);return I[P.toLowerCase()]}e.getMediaMime=D;function T(R){for(const P in I)if(I[P]===R)return P}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function C(R,P){const E=S.exec(R);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:P?void 0:R}e.normalizeMimeType=C}),define(Se[101],ye([1,0,11]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var I;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...S){const C=S.reduce((E,y)=>(E[y]=!0,E),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(T).filter(E=>!C[E]).forEach(E=>{for(let y=0;y<R.length;y++)if(E.search(R[y])!==-1){delete T[E];break}})}e.sanitizeProcessEnvironment=A;function D(T){!T||(delete T.DEBUG,a.isMacintosh&&delete T.DYLD_LIBRARY_PATH,a.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var t in a)(typeof exports=="object"?exports:ee)[t]=a[t]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function a(t){if(e[t])return e[t].exports;var I=e[t]={i:t,l:!1,exports:{}};return ee[t].call(I.exports,I,I.exports,a),I.l=!0,I.exports}return a.m=ee,a.c=e,a.d=function(t,I,A){a.o(t,I)||Object.defineProperty(t,I,{enumerable:!0,get:A})},a.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},a.t=function(t,I){if(1&I&&(t=a(t)),8&I||4&I&&typeof t=="object"&&t&&t.__esModule)return t;var A=Object.create(null);if(a.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:t}),2&I&&typeof t!="string")for(var D in t)a.d(A,D,function(T){return t[T]}.bind(null,D));return A},a.n=function(t){var I=t&&t.__esModule?function(){return t.default}:function(){return t};return a.d(I,"a",I),I},a.o=function(t,I){return Object.prototype.hasOwnProperty.call(t,I)},a.p="",a(a.s=0)}([function(ee,e,a){(function(t){var I;e=ee.exports=J,I=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],C=0,R=C++;S[R]="0|[1-9]\\d*";var P=C++;S[P]="[0-9]+";var E=C++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=C++;S[y]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var v=C++;S[v]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var d=C++;S[d]="(?:"+S[R]+"|"+S[E]+")";var g=C++;S[g]="(?:"+S[P]+"|"+S[E]+")";var m=C++;S[m]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var w=C++;S[w]="(?:-?("+S[g]+"(?:\\."+S[g]+")*))";var f=C++;S[f]="[0-9A-Za-z-]+";var h=C++;S[h]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var b=C++,o="v?"+S[y]+S[m]+"?"+S[h]+"?";S[b]="^"+o+"$";var r="[v=\\s]*"+S[v]+S[w]+"?"+S[h]+"?",c=C++;S[c]="^"+r+"$";var u=C++;S[u]="((?:<|>)?=?)";var i=C++;S[i]=S[P]+"|x|X|\\*";var s=C++;S[s]=S[R]+"|x|X|\\*";var n=C++;S[n]="[v=\\s]*("+S[s]+")(?:\\.("+S[s]+")(?:\\.("+S[s]+")(?:"+S[m]+")?"+S[h]+"?)?)?";var l=C++;S[l]="[v=\\s]*("+S[i]+")(?:\\.("+S[i]+")(?:\\.("+S[i]+")(?:"+S[w]+")?"+S[h]+"?)?)?";var p=C++;S[p]="^"+S[u]+"\\s*"+S[n]+"$";var k=C++;S[k]="^"+S[u]+"\\s*"+S[l]+"$";var L=C++;S[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=C++;S[B]="(?:~>?)";var K=C++;S[K]="(\\s*)"+S[B]+"\\s+",T[K]=new RegExp(S[K],"g");var G=C++;S[G]="^"+S[B]+S[n]+"$";var O=C++;S[O]="^"+S[B]+S[l]+"$";var U=C++;S[U]="(?:\\^)";var F=C++;S[F]="(\\s*)"+S[U]+"\\s+",T[F]=new RegExp(S[F],"g");var z=C++;S[z]="^"+S[U]+S[n]+"$";var M=C++;S[M]="^"+S[U]+S[l]+"$";var V=C++;S[V]="^"+S[u]+"\\s*("+r+")$|^$";var q=C++;S[q]="^"+S[u]+"\\s*("+o+")$|^$";var H=C++;S[H]="(\\s*)"+S[u]+"\\s*("+r+"|"+S[n]+")",T[H]=new RegExp(S[H],"g");var Q=C++;S[Q]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Y=C++;S[Y]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var ce=C++;S[ce]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)I(ie,S[ie]),T[ie]||(T[ie]=new RegExp(S[ie]));function fe(ge,Ce){if(ge instanceof J)return ge;if(typeof ge!="string"||ge.length>A||!(Ce?T[c]:T[b]).test(ge))return null;try{return new J(ge,Ce)}catch{return null}}function J(ge,Ce){if(ge instanceof J){if(ge.loose===Ce)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof J))return new J(ge,Ce);I("SemVer",ge,Ce),this.loose=Ce;var ke=ge.trim().match(Ce?T[c]:T[b]);if(!ke)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<D)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=fe,e.valid=function(ge,Ce){var ke=fe(ge,Ce);return ke?ke.version:null},e.clean=function(ge,Ce){var ke=fe(ge.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(ge){return I("SemVer.compare",this.version,this.loose,ge),ge instanceof J||(ge=new J(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},J.prototype.compareMain=function(ge){return ge instanceof J||(ge=new J(ge,this.loose)),we(this.major,ge.major)||we(this.minor,ge.minor)||we(this.patch,ge.patch)},J.prototype.comparePre=function(ge){if(ge instanceof J||(ge=new J(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],je=ge.prerelease[Ce];if(I("prerelease compare",Ce,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return we(ke,je)}while(++Ce)},J.prototype.inc=function(ge,Ce){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Ce,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new J(ge,ke).inc(Ce,je).version}catch{return null}},e.diff=function(ge,Ce){if(re(ge,Ce))return null;var ke=fe(ge),je=fe(Ce);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=we;var pe=/^[0-9]+$/;function we(ge,Ce){var ke=pe.test(ge),je=pe.test(Ce);return ke&&je&&(ge=+ge,Ce=+Ce),ke&&!je?-1:je&&!ke?1:ge<Ce?-1:ge>Ce?1:0}function Ie(ge,Ce,ke){return new J(ge,ke).compare(new J(Ce,ke))}function Re(ge,Ce,ke){return Ie(ge,Ce,ke)>0}function ze(ge,Ce,ke){return Ie(ge,Ce,ke)<0}function re(ge,Ce,ke){return Ie(ge,Ce,ke)===0}function ue(ge,Ce,ke){return Ie(ge,Ce,ke)!==0}function de(ge,Ce,ke){return Ie(ge,Ce,ke)>=0}function Z(ge,Ce,ke){return Ie(ge,Ce,ke)<=0}function se(ge,Ce,ke,je){var Ge;switch(Ce){case"===":typeof ge=="object"&&(ge=ge.version),typeof ke=="object"&&(ke=ke.version),Ge=ge===ke;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof ke=="object"&&(ke=ke.version),Ge=ge!==ke;break;case"":case"=":case"==":Ge=re(ge,ke,je);break;case"!=":Ge=ue(ge,ke,je);break;case">":Ge=Re(ge,ke,je);break;case">=":Ge=de(ge,ke,je);break;case"<":Ge=ze(ge,ke,je);break;case"<=":Ge=Z(ge,ke,je);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ge}function ne(ge,Ce){if(ge instanceof ne){if(ge.loose===Ce)return ge;ge=ge.value}if(!(this instanceof ne))return new ne(ge,Ce);I("comparator",ge,Ce),this.loose=Ce,this.parse(ge),this.semver===N?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ge,Ce){return we(Ce,ge)},e.major=function(ge,Ce){return new J(ge,Ce).major},e.minor=function(ge,Ce){return new J(ge,Ce).minor},e.patch=function(ge,Ce){return new J(ge,Ce).patch},e.compare=Ie,e.compareLoose=function(ge,Ce){return Ie(ge,Ce,!0)},e.rcompare=function(ge,Ce,ke){return Ie(Ce,ge,ke)},e.sort=function(ge,Ce){return ge.sort(function(ke,je){return e.compare(ke,je,Ce)})},e.rsort=function(ge,Ce){return ge.sort(function(ke,je){return e.rcompare(ke,je,Ce)})},e.gt=Re,e.lt=ze,e.eq=re,e.neq=ue,e.gte=de,e.lte=Z,e.cmp=se,e.Comparator=ne;var N={};function $(ge,Ce){if(ge instanceof $)return ge.loose===Ce?ge:new $(ge.raw,Ce);if(ge instanceof ne)return new $(ge.value,Ce);if(!(this instanceof $))return new $(ge,Ce);if(this.loose=Ce,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function x(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function _(ge,Ce,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe){return((Ce=x(ke)?"":x(je)?">="+ke+".0.0":x(Ge)?">="+ke+"."+je+".0":">="+Ce)+" "+(nt=x(st)?"":x(ht)?"<"+(+st+1)+".0.0":x(Me)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Me+"-"+it:"<="+nt)).trim()}function le(ge,Ce){for(var ke=0;ke<ge.length;ke++)if(!ge[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<ge.length;ke++)if(I(ge[ke].semver),ge[ke].semver!==N&&ge[ke].semver.prerelease.length>0){var je=ge[ke].semver;if(je.major===Ce.major&&je.minor===Ce.minor&&je.patch===Ce.patch)return!0}return!1}return!0}function be(ge,Ce,ke){try{Ce=new $(Ce,ke)}catch{return!1}return Ce.test(ge)}function Pe(ge,Ce,ke,je){var Ge,et,_e,nt,st;switch(ge=new J(ge,je),Ce=new $(Ce,je),ke){case">":Ge=Re,et=Z,_e=ze,nt=">",st=">=";break;case"<":Ge=ze,et=de,_e=Re,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(ge,Ce,je))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Me=Ce.set[ht],it=null,oe=null;if(Me.forEach(function(W){W.semver===N&&(W=new ne(">=0.0.0")),it=it||W,oe=oe||W,Ge(W.semver,it.semver,je)?it=W:_e(W.semver,oe.semver,je)&&(oe=W)}),it.operator===nt||it.operator===st||(!oe.operator||oe.operator===nt)&&et(ge,oe.semver)||oe.operator===st&&_e(ge,oe.semver))return!1}return!0}ne.prototype.parse=function(ge){var Ce=this.loose?T[V]:T[q],ke=ge.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+ge);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new J(ke[2],this.loose):this.semver=N},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ge){return I("Comparator.test",ge,this.loose),this.semver===N||(typeof ge=="string"&&(ge=new J(ge,this.loose)),se(ge,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ge,Ce){if(!(ge instanceof ne))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new $(ge.value,Ce),be(this.value,ke,Ce);if(ge.operator==="")return ke=new $(this.value,Ce),be(ge.semver,ke,Ce);var je=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),et=this.semver.version===ge.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),nt=se(this.semver,"<",ge.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),st=se(this.semver,">",ge.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return je||Ge||et&&_e||nt||st},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ge){var Ce=this.loose;ge=ge.trim(),I("range",ge,Ce);var ke=Ce?T[Y]:T[Q];ge=ge.replace(ke,_),I("hyphen replace",ge),ge=ge.replace(T[H],"$1$2$3"),I("comparator trim",ge,T[H]),ge=(ge=(ge=ge.replace(T[K],"$1~")).replace(T[F],"$1^")).split(/\s+/).join(" ");var je=Ce?T[V]:T[q],Ge=ge.split(" ").map(function(et){return function(_e,nt){return I("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){I("caret",it,oe);var W=oe?T[M]:T[z];return it.replace(W,function(ae,De,Le,Be,xe){var Ze;return I("caret",it,ae,De,Le,Be,xe),x(De)?Ze="":x(Le)?Ze=">="+De+".0.0 <"+(+De+1)+".0.0":x(Be)?Ze=De==="0"?">="+De+"."+Le+".0 <"+De+"."+(+Le+1)+".0":">="+De+"."+Le+".0 <"+(+De+1)+".0.0":xe?(I("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=De==="0"?Le==="0"?">="+De+"."+Le+"."+Be+xe+" <"+De+"."+Le+"."+(+Be+1):">="+De+"."+Le+"."+Be+xe+" <"+De+"."+(+Le+1)+".0":">="+De+"."+Le+"."+Be+xe+" <"+(+De+1)+".0.0"):(I("no pr"),Ze=De==="0"?Le==="0"?">="+De+"."+Le+"."+Be+" <"+De+"."+Le+"."+(+Be+1):">="+De+"."+Le+"."+Be+" <"+De+"."+(+Le+1)+".0":">="+De+"."+Le+"."+Be+" <"+(+De+1)+".0.0"),I("caret return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),I("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){var W=oe?T[O]:T[G];return it.replace(W,function(ae,De,Le,Be,xe){var Ze;return I("tilde",it,ae,De,Le,Be,xe),x(De)?Ze="":x(Le)?Ze=">="+De+".0.0 <"+(+De+1)+".0.0":x(Be)?Ze=">="+De+"."+Le+".0 <"+De+"."+(+Le+1)+".0":xe?(I("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=">="+De+"."+Le+"."+Be+xe+" <"+De+"."+(+Le+1)+".0"):Ze=">="+De+"."+Le+"."+Be+" <"+De+"."+(+Le+1)+".0",I("tilde return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),I("tildes",_e),_e=function(st,ht){return I("replaceXRanges",st,ht),st.split(/\s+/).map(function(Me){return function(it,oe){it=it.trim();var W=oe?T[k]:T[p];return it.replace(W,function(ae,De,Le,Be,xe,Ze){I("xRange",it,ae,De,Le,Be,xe,Ze);var mt=x(Le),ft=mt||x(Be),lt=ft||x(xe);return De==="="&&lt&&(De=""),mt?ae=De===">"||De==="<"?"<0.0.0":"*":De&&lt?(ft&&(Be=0),lt&&(xe=0),De===">"?(De=">=",ft?(Le=+Le+1,Be=0,xe=0):lt&&(Be=+Be+1,xe=0)):De==="<="&&(De="<",ft?Le=+Le+1:Be=+Be+1),ae=De+Le+"."+Be+"."+xe):ft?ae=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ae=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),I("xRange return",ae),ae})}(Me,ht)}).join(" ")}(_e,nt),I("xrange",_e),_e=function(st,ht){return I("replaceStars",st,ht),st.trim().replace(T[ce],"")}(_e,nt),I("stars",_e),_e}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new ne(et,Ce)})},$.prototype.intersects=function(ge,Ce){if(!(ge instanceof $))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return ge.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,Ce)})})})})},e.toComparators=function(ge,Ce){return new $(ge,Ce).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new J(ge,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(le(this.set[Ce],ge))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(ge,Ce,ke){var je=null,Ge=null;try{var et=new $(Ce,ke)}catch{return null}return ge.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==-1||(Ge=new J(je=_e,ke)))}),je},e.minSatisfying=function(ge,Ce,ke){var je=null,Ge=null;try{var et=new $(Ce,ke)}catch{return null}return ge.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==1||(Ge=new J(je=_e,ke)))}),je},e.validRange=function(ge,Ce){try{return new $(ge,Ce).range||"*"}catch{return null}},e.ltr=function(ge,Ce,ke){return Pe(ge,Ce,"<",ke)},e.gtr=function(ge,Ce,ke){return Pe(ge,Ce,">",ke)},e.outside=Pe,e.prerelease=function(ge,Ce){var ke=fe(ge,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(ge,Ce,ke){return ge=new $(ge,ke),Ce=new $(Ce,ke),ge.intersects(Ce)},e.coerce=function(ge){if(ge instanceof J)return ge;if(typeof ge!="string")return null;var Ce=ge.match(T[L]);return Ce==null?null:fe((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,a(1))},function(ee,e){var a,t,I=ee.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(g){if(a===setTimeout)return setTimeout(g,0);if((a===A||!a)&&setTimeout)return a=setTimeout,setTimeout(g,0);try{return a(g,0)}catch{try{return a.call(null,g,0)}catch{return a.call(this,g,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:A}catch{a=A}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var S,C=[],R=!1,P=-1;function E(){R&&S&&(R=!1,S.length?C=S.concat(C):P=-1,C.length&&y())}function y(){if(!R){var g=T(E);R=!0;for(var m=C.length;m;){for(S=C,C=[];++P<m;)S&&S[P].run();P=-1,m=C.length}S=null,R=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(g)}}function v(g,m){this.fun=g,this.array=m}function d(){}I.nextTick=function(g){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];C.push(new v(g,m)),C.length!==1||R||T(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=d,I.addListener=d,I.once=d,I.off=d,I.removeListener=d,I.removeAllListeners=d,I.emit=d,I.prependListener=d,I.prependOnceListener=d,I.listeners=function(g){return[]},I.binding=function(g){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(g){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Se[49],ye([1,0,11]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=a.globals.performance&&typeof a.globals.performance.now=="function";class I{static create(D=!0){return new I(D)}constructor(D){this.a=t&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=I}),define(Se[4],ye([1,0,10,62,6,64,49]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var C;(function(s){s.None=()=>I.Disposable.None;function n(Ie){if(S){const{onDidAddListener:Re}=Ie,ze=v.create();let re=0;Ie.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ze.print()),Re?.()}}}function l(Ie,Re){return F(Ie,()=>{},0,void 0,void 0,Re)}s.defer=l;function p(Ie){return(Re,ze=null,re)=>{let ue=!1,de;return de=Ie(Z=>{if(!ue)return de?de.dispose():ue=!0,Re.call(ze,Z)},null,re),ue&&de.dispose(),de}}s.once=p;function k(Ie,Re,ze){return U((re,ue=null,de)=>Ie(Z=>re.call(ue,Re(Z)),null,de),ze)}s.map=k;function L(Ie,Re,ze){return U((re,ue=null,de)=>Ie(Z=>{Re(Z),re.call(ue,Z)},null,de),ze)}s.forEach=L;function B(Ie,Re,ze){return U((re,ue=null,de)=>Ie(Z=>Re(Z)&&re.call(ue,Z),null,de),ze)}s.filter=B;function K(Ie){return Ie}s.signal=K;function G(...Ie){return(Re,ze=null,re)=>(0,I.combinedDisposable)(...Ie.map(ue=>ue(de=>Re.call(ze,de),null,re)))}s.any=G;function O(Ie,Re,ze,re){let ue=ze;return k(Ie,de=>(ue=Re(ue,de),ue),re)}s.reduce=O;function U(Ie,Re){let ze;const re={onWillAddFirstListener(){ze=Ie(ue.fire,ue)},onDidRemoveLastListener(){ze?.dispose()}};Re||n(re);const ue=new g(re);return Re?.add(ue),ue.event}function F(Ie,Re,ze=100,re=!1,ue,de){let Z,se,ne,N=0;const $={leakWarningThreshold:ue,onWillAddFirstListener(){Z=Ie(_=>{N++,se=Re(se,_),re&&!ne&&(x.fire(se),se=void 0),clearTimeout(ne),ne=setTimeout(()=>{const le=se;se=void 0,ne=void 0,(!re||N>1)&&x.fire(le),N=0},ze)})},onDidRemoveLastListener(){Z.dispose()}};de||n($);const x=new g($);return de?.add(x),x.event}s.debounce=F;function z(Ie,Re=0,ze){return s.debounce(Ie,(re,ue)=>re?(re.push(ue),re):[ue],Re,void 0,void 0,ze)}s.accumulate=z;function M(Ie,Re=(re,ue)=>re===ue,ze){let re=!0,ue;return B(Ie,de=>{const Z=re||!Re(de,ue);return re=!1,ue=de,Z},ze)}s.latch=M;function V(Ie,Re,ze){return[s.filter(Ie,Re,ze),s.filter(Ie,re=>!Re(re),ze)]}s.split=V;function q(Ie,Re=!1,ze=[]){let re=ze.slice(),ue=Ie(se=>{re?re.push(se):Z.fire(se)});const de=()=>{re?.forEach(se=>Z.fire(se)),re=null},Z=new g({onWillAddFirstListener(){ue||(ue=Ie(se=>Z.fire(se)))},onDidAddFirstListener(){re&&(Re?setTimeout(de):de())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return Z.event}s.buffer=q;class H{constructor(Re){this.event=Re,this.c=new I.DisposableStore}map(Re){return new H(k(this.event,Re,this.c))}forEach(Re){return new H(L(this.event,Re,this.c))}filter(Re){return new H(B(this.event,Re,this.c))}reduce(Re,ze){return new H(O(this.event,Re,ze,this.c))}latch(){return new H(M(this.event,void 0,this.c))}debounce(Re,ze=100,re=!1,ue){return new H(F(this.event,Re,ze,re,ue,this.c))}on(Re,ze,re){return this.event(Re,ze,re)}once(Re,ze,re){return p(this.event)(Re,ze,re)}dispose(){this.c.dispose()}}function Q(Ie){return new H(Ie)}s.chain=Q;function Y(Ie,Re,ze=re=>re){const re=(...se)=>Z.fire(ze(...se)),ue=()=>Ie.on(Re,re),de=()=>Ie.removeListener(Re,re),Z=new g({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return Z.event}s.fromNodeEventEmitter=Y;function ce(Ie,Re,ze=re=>re){const re=(...se)=>Z.fire(ze(...se)),ue=()=>Ie.addEventListener(Re,re),de=()=>Ie.removeEventListener(Re,re),Z=new g({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return Z.event}s.fromDOMEventEmitter=ce;function ie(Ie){return new Promise(Re=>p(Ie)(Re))}s.toPromise=ie;function fe(Ie,Re){return Re(void 0),Ie(ze=>Re(ze))}s.runAndSubscribe=fe;function J(Ie,Re){let ze=null;function re(de){ze?.dispose(),ze=new I.DisposableStore,Re(de,ze)}re(void 0);const ue=Ie(de=>re(de));return(0,I.toDisposable)(()=>{ue.dispose(),ze?.dispose()})}s.runAndSubscribeWithStore=J;class pe{constructor(Re,ze){this.obs=Re,this.c=0,this.d=!1;const re={onWillAddFirstListener:()=>{Re.addObserver(this)},onDidRemoveLastListener:()=>{Re.removeObserver(this)}};ze||n(re),this.emitter=new g(re),ze&&ze.add(this.emitter)}beginUpdate(Re){this.c++}handleChange(Re,ze){this.d=!0}endUpdate(Re){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function we(Ie,Re){return new pe(Ie,Re).emitter.event}s.fromObservable=we})(C=e.Event||(e.Event={}));class R{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${R.c++}`,R.all.add(this)}start(n){this.d=new D.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=R,R.all=new Set,R.c=0;let P=-1;function E(s){const n=P;return P=s,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=E;class y{constructor(n,l=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=l,this.d=0}dispose(){this.c?.clear()}check(n,l){const p=this.threshold;if(p<=0||l<p)return;this.c||(this.c=new Map);const k=this.c.get(n.value)||0;if(this.c.set(n.value,k+1),this.d-=1,this.d<=0){this.d=p*.5;let L,B=0;for(const[K,G]of this.c)(!L||B<G)&&(L=K,B=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${B}):`),console.warn(L)}return()=>{const L=this.c.get(n.value)||0;this.c.set(n.value,L-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(n,l,p){this.callback=n,this.callbackThis=l,this.stack=p,this.subscription=new I.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class g{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new y(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const n=Array.from(this.q);queueMicrotask(()=>{for(const l of n)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,l,p)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.Disposable.None;const k=this.q.isEmpty();k&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,B;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(B=v.create(),L=this.f.check(B,this.q.size+1)),T&&(B=B??v.create());const K=new d(n,l,B),G=this.q.push(K);k&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,l);const O=K.subscription.set(()=>{L?.(),this.j||(G(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return p instanceof I.DisposableStore?p.add(O):Array.isArray(p)&&p.push(O),O}),this.l}fire(n){if(this.q){this.m||(this.m=new w);for(const l of this.q)this.m.push(this,l,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=g;class m{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(n,l,p){this.c.push(new f(n,l,p))}clear(n){const l=new A.LinkedList;for(const p of this.c)p.emitter!==n&&l.push(p);this.c=l}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(l){(0,a.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=m;class w extends m{clear(n){this.c.clear()}}class f{constructor(n,l,p){this.emitter=n,this.listener=l,this.event=p}}class h extends g{async fireAsync(n,l,p){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const k of this.q)this.c.push([k,n]);for(;this.c.size>0&&!l.isCancellationRequested;){const[k,L]=this.c.shift(),B=[],K={...L,token:l,waitUntil:G=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");p&&(G=p(G,k.callback)),B.push(G)}};try{k.invoke(K)}catch(G){(0,a.onUnexpectedError)(G);continue}Object.freeze(B),await Promise.allSettled(B).then(G=>{for(const O of G)O.status==="rejected"&&(0,a.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=h;class b extends g{constructor(n){super(n),this.h=0,this.s=new A.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=b;class o extends b{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=o;class r extends g{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(l=>super.fire(l)),this.c=[]}))}}e.MicrotaskEmitter=r;class c{constructor(){this.d=!1,this.f=[],this.c=new g({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const l={event:n,listener:null};this.f.push(l),this.d&&this.j(l);const p=()=>{this.d&&this.k(l);const k=this.f.indexOf(l);this.f.splice(k,1)};return(0,I.toDisposable)((0,t.once)(p))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(l=>this.c.fire(l))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=c;class u{constructor(){this.c=[]}wrapEvent(n){return(l,p,k)=>n(L=>{const B=this.c[this.c.length-1];B?B.push(()=>l.call(p,L)):l.call(p,L)},void 0,k)}bufferEvents(n){const l=[];this.c.push(l);const p=n();return this.c.pop(),l.forEach(k=>k()),p}}e.EventBufferer=u;class i{constructor(){this.c=!1,this.d=C.None,this.f=I.Disposable.None,this.g=new g({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=i}),define(Se[21],ye([1,0,4]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const C=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(C)}}});var I;(function(T){function S(C){return C===T.None||C===T.Cancelled||C instanceof A?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=I.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=I.None}}e.CancellationTokenSource=D}),define(Se[147],ye([1,0,21]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new a.CancellationTokenSource,S=this.b(T.token);return this.a={promise:S,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=t;class I{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const S=JSON.stringify(T);return this.b!==S&&(this.b=S,this.a=this.c(T)),this.a}}e.LRUCachedFunction=I;class A{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const S=this.b(T);return this.a.set(T,S),S}}e.CachedFunction=A}),define(Se[102],ye([1,0,10,6]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(h){const b=h;return b?typeof b.read=="function":!1}e.isReadable=I;function A(h){const b=h;return b?[b.on,b.pause,b.resume,b.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=A;function D(h){const b=h;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=D;function T(h,b){return new S(h,b)}e.newWriteableStream=T;class S{constructor(b,o){this.e=b,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(o=>o(b))}h(b){this.c.error.length===0?(0,a.onUnexpectedError)(b):this.c.error.slice(0).forEach(o=>o(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,o){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(b,o){if(this.a.destroyed)return;let r;switch(b){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const c=r.indexOf(o);c>=0&&r.splice(c,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function C(h,b){const o=[];let r;for(;(r=h.read())!==null;)o.push(r);return b(o)}e.consumeReadable=C;function R(h,b,o){const r=[];let c;for(;(c=h.read())!==null&&r.length<o;)r.push(c);return c===null&&r.length>0?b(r):{read:()=>{if(r.length>0)return r.shift();if(typeof c<"u"){const u=c;return c=void 0,u}return h.read()}}}e.peekReadable=R;function P(h,b){return new Promise((o,r)=>{const c=[];E(h,{onData:u=>{b&&c.push(u)},onError:u=>{b?r(u):o(void 0)},onEnd:()=>{o(b?b(c):void 0)}})})}e.consumeStream=P;function E(h,b){let o=!1;return h.on("error",r=>{o||b.onError(r)}),h.on("end",()=>{o||b.onEnd()}),h.on("data",r=>{o||b.onData(r)}),(0,t.toDisposable)(()=>o=!0)}e.listenStream=E;function y(h,b){return new Promise((o,r)=>{const c=new t.DisposableStore,u=[],i=l=>{if(u.push(l),u.length>b)return c.dispose(),h.pause(),o({stream:h,buffer:u,ended:!1})},s=l=>r(l),n=()=>o({stream:h,buffer:u,ended:!0});c.add((0,t.toDisposable)(()=>h.removeListener("error",s))),h.on("error",s),c.add((0,t.toDisposable)(()=>h.removeListener("end",n))),h.on("end",n),c.add((0,t.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=y;function v(h,b){const o=T(b);return o.end(h),o}e.toStream=v;function d(){const h=T(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let b=!1;return{read:()=>b?null:(b=!0,h)}}e.toReadable=g;function m(h,b,o){const r=T(o);return E(h,{onData:c=>r.write(b.data(c)),onError:c=>r.error(b.error?b.error(c):c),onEnd:()=>r.end()}),r}e.transform=m;function w(h,b,o){let r=!1;return{read:()=>{const c=b.read();return r?c:(r=!0,c!==null?o([h,c]):h)}}}e.prefixedReadable=w;function f(h,b,o){let r=!1;const c=T(o);return E(b,{onData:u=>r?c.write(u):(r=!0,c.write(o([h,u]))),onError:u=>c.error(u),onEnd:()=>{r||(r=!0,c.write(h)),c.end()}}),c}e.prefixedStream=f}),define(Se[22],ye([1,0,102]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let I,A;class D{static alloc(l){return t?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return t&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,p){return!(p?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(l)):(I||(I=new TextEncoder),new D(I.encode(l)))}static fromByteArray(l){const p=D.alloc(l.length);for(let k=0,L=l.length;k<L;k++)p.buffer[k]=l[k];return p}static concat(l,p){if(typeof p>"u"){p=0;for(let B=0,K=l.length;B<K;B++)p+=l[B].byteLength}const k=D.alloc(p);let L=0;for(let B=0,K=l.length;B<K;B++){const G=l[B];k.set(G,L),L+=G.byteLength}return k}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(l,p){return new D(this.buffer.subarray(l,p))}set(l,p){if(l instanceof D)this.buffer.set(l.buffer,p);else if(l instanceof Uint8Array)this.buffer.set(l,p);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),p);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return C(this.buffer,l)}writeUInt32BE(l,p){R(this.buffer,l,p)}readUInt32LE(l){return P(this.buffer,l)}writeUInt32LE(l,p){E(this.buffer,l,p)}readUInt8(l){return y(this.buffer,l)}writeUInt8(l,p){v(this.buffer,l,p)}}e.VSBuffer=D;function T(n,l){return n[l+0]<<0>>>0|n[l+1]<<8>>>0}e.readUInt16LE=T;function S(n,l,p){n[p+0]=l&255,l=l>>>8,n[p+1]=l&255}e.writeUInt16LE=S;function C(n,l){return n[l]*2**24+n[l+1]*2**16+n[l+2]*2**8+n[l+3]}e.readUInt32BE=C;function R(n,l,p){n[p+3]=l,l=l>>>8,n[p+2]=l,l=l>>>8,n[p+1]=l,l=l>>>8,n[p]=l}e.writeUInt32BE=R;function P(n,l){return n[l+0]<<0>>>0|n[l+1]<<8>>>0|n[l+2]<<16>>>0|n[l+3]<<24>>>0}e.readUInt32LE=P;function E(n,l,p){n[p+0]=l&255,l=l>>>8,n[p+1]=l&255,l=l>>>8,n[p+2]=l&255,l=l>>>8,n[p+3]=l&255}e.writeUInt32LE=E;function y(n,l){return n[l]}e.readUInt8=y;function v(n,l,p){n[p]=l}e.writeUInt8=v;function d(n){return a.consumeReadable(n,l=>D.concat(l))}e.readableToBuffer=d;function g(n){return a.toReadable(n)}e.bufferToReadable=g;function m(n){return a.consumeStream(n,l=>D.concat(l))}e.streamToBuffer=m;async function w(n){return n.ended?D.concat(n.buffer):D.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=w;function f(n){return a.toStream(n,l=>D.concat(l))}e.bufferToStream=f;function h(n){return a.transform(n,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.streamToBufferReadableStream=h;function b(n){return a.newWriteableStream(l=>D.concat(l),n)}e.newWriteableBufferStream=b;function o(n,l){return a.prefixedReadable(n,l,p=>D.concat(p))}e.prefixedBufferReadable=o;function r(n,l){return a.prefixedStream(n,l,p=>D.concat(p))}e.prefixedBufferStream=r;function c(n){let l=0,p=0,k=0;const L=new Uint8Array(Math.floor(n.length/4*3)),B=G=>{switch(p){case 3:L[k++]=l|G,p=0;break;case 2:L[k++]=l|G>>>2,l=G<<6,p=3;break;case 1:L[k++]=l|G>>>4,l=G<<4,p=2;break;default:l=G<<2,p=1}};for(let G=0;G<n.length;G++){const O=n.charCodeAt(G);if(O>=65&&O<=90)B(O-65);else if(O>=97&&O<=122)B(O-97+26);else if(O>=48&&O<=57)B(O-48+52);else if(O===43||O===45)B(62);else if(O===47||O===95)B(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${n[G]}`)}}const K=k;for(;p>0;)B(0);return D.wrap(L).slice(0,K)}e.decodeBase64=c;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:n},l=!0,p=!1){const k=p?i:u;let L="";const B=n.byteLength%3;let K=0;for(;K<n.byteLength-B;K+=3){const G=n[K+0],O=n[K+1],U=n[K+2];L+=k[G>>>2],L+=k[(G<<4|O>>>4)&63],L+=k[(O<<2|U>>>6)&63],L+=k[U&63]}if(B===1){const G=n[K+0];L+=k[G>>>2],L+=k[G<<4&63],l&&(L+="==")}else if(B===2){const G=n[K+0],O=n[K+1];L+=k[G>>>2],L+=k[(G<<4|O>>>4)&63],L+=k[O<<2&63],l&&(L+="=")}return L}e.encodeBase64=s}),define(Se[8],ye([1,0,147,82]),function(ee,e,a,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=A;const D=/{(\d+)}/g;function T(W,...ae){return ae.length===0?W:W.replace(D,function(De,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ae.length?De:ae[Be]})}e.format=T;const S=/{([^}]+)}/g;function C(W,ae){return W.replace(S,(De,Le)=>ae[Le]??De)}e.format2=C;function R(W){return W.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=R;function P(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function E(W,ae){let De=0;const Le=ae.charCodeAt(0);for(let Be=W.length-1;Be>=0;Be--)W.charCodeAt(Be)===Le&&De++;return De}e.count=E;function y(W,ae,De="\u2026"){return W.length<=ae?W:`${W.substr(0,ae)}${De}`}e.truncate=y;function v(W,ae=" "){const De=d(W,ae);return g(De,ae)}e.trim=v;function d(W,ae){if(!W||!ae)return W;const De=ae.length;if(De===0||W.length===0)return W;let Le=0;for(;W.indexOf(ae,Le)===Le;)Le=Le+De;return W.substring(Le)}e.ltrim=d;function g(W,ae){if(!W||!ae)return W;const De=ae.length,Le=W.length;if(De===0||Le===0)return W;let Be=Le,xe=-1;for(;xe=W.lastIndexOf(ae,Be-1),!(xe===-1||xe+De!==Be);){if(xe===0)return"";Be=xe}return W.substring(0,Be)}e.rtrim=g;function m(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function w(W){return W.replace(/\*/g,"")}e.stripWildcards=w;function f(W,ae,De={}){if(!W)throw new Error("Cannot create regex from empty string");ae||(W=P(W)),De.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Le="";return De.global&&(Le+="g"),De.matchCase||(Le+="i"),De.multiline&&(Le+="m"),De.unicode&&(Le+="u"),new RegExp(W,Le)}e.createRegExp=f;function h(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function b(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function o(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=o;function r(W){return W.split(/\r\n|\r|\n/)}e.splitLines=r;function c(W){for(let ae=0,De=W.length;ae<De;ae++){const Le=W.charCodeAt(ae);if(Le!==32&&Le!==9)return ae}return-1}e.firstNonWhitespaceIndex=c;function u(W,ae=0,De=W.length){for(let Le=ae;Le<De;Le++){const Be=W.charCodeAt(Le);if(Be!==32&&Be!==9)return W.substring(ae,Le)}return W.substring(ae,De)}e.getLeadingWhitespace=u;function i(W,ae=W.length-1){for(let De=ae;De>=0;De--){const Le=W.charCodeAt(De);if(Le!==32&&Le!==9)return De}return-1}e.lastNonWhitespaceIndex=i;function s(W,ae,De){const Le=[];let Be=0;for(const xe of W.matchAll(ae)){if(Le.push(W.slice(Be,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Be=xe.index+xe[0].length,Le.push(De(xe[0],...xe.slice(1),xe.index,W,xe.groups))}return Le.push(W.slice(Be)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=s;function n(W,ae){return W<ae?-1:W>ae?1:0}e.compare=n;function l(W,ae,De=0,Le=W.length,Be=0,xe=ae.length){for(;De<Le&&Be<xe;De++,Be++){const ft=W.charCodeAt(De),lt=ae.charCodeAt(Be);if(ft<lt)return-1;if(ft>lt)return 1}const Ze=Le-De,mt=xe-Be;return Ze<mt?-1:Ze>mt?1:0}e.compareSubstring=l;function p(W,ae){return k(W,ae,0,W.length,0,ae.length)}e.compareIgnoreCase=p;function k(W,ae,De=0,Le=W.length,Be=0,xe=ae.length){for(;De<Le&&Be<xe;De++,Be++){let ft=W.charCodeAt(De),lt=ae.charCodeAt(Be);if(ft===lt)continue;if(ft>=128||lt>=128)return l(W.toLowerCase(),ae.toLowerCase(),De,Le,Be,xe);B(ft)&&(ft-=32),B(lt)&&(lt-=32);const ot=ft-lt;if(ot!==0)return ot}const Ze=Le-De,mt=xe-Be;return Ze<mt?-1:Ze>mt?1:0}e.compareSubstringIgnoreCase=k;function L(W){return W>=48&&W<=57}e.isAsciiDigit=L;function B(W){return W>=97&&W<=122}e.isLowerAsciiLetter=B;function K(W){return W>=65&&W<=90}e.isUpperAsciiLetter=K;function G(W,ae){return W.length===ae.length&&k(W,ae)===0}e.equalsIgnoreCase=G;function O(W,ae){const De=ae.length;return ae.length>W.length?!1:k(W,ae,0,De)===0}e.startsWithIgnoreCase=O;function U(W,ae){const De=Math.min(W.length,ae.length);let Le;for(Le=0;Le<De;Le++)if(W.charCodeAt(Le)!==ae.charCodeAt(Le))return Le;return De}e.commonPrefixLength=U;function F(W,ae){const De=Math.min(W.length,ae.length);let Le;const Be=W.length-1,xe=ae.length-1;for(Le=0;Le<De;Le++)if(W.charCodeAt(Be-Le)!==ae.charCodeAt(xe-Le))return Le;return De}e.commonSuffixLength=F;function z(W){return 55296<=W&&W<=56319}e.isHighSurrogate=z;function M(W){return 56320<=W&&W<=57343}e.isLowSurrogate=M;function V(W,ae){return(W-55296<<10)+(ae-56320)+65536}e.computeCodePoint=V;function q(W,ae,De){const Le=W.charCodeAt(De);if(z(Le)&&De+1<ae){const Be=W.charCodeAt(De+1);if(M(Be))return V(Le,Be)}return Le}e.getNextCodePoint=q;function H(W,ae){const De=W.charCodeAt(ae-1);if(M(De)&&ae>1){const Le=W.charCodeAt(ae-2);if(z(Le))return V(Le,De)}return De}class Q{get offset(){return this.e}constructor(ae,De=0){this.c=ae,this.d=ae.length,this.e=De}setOffset(ae){this.e=ae}prevCodePoint(){const ae=H(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=q(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}e.CodePointIterator=Q;class Y{get offset(){return this.c.offset}constructor(ae,De=0){this.c=new Q(ae,De)}nextGraphemeLength(){const ae=et.getInstance(),De=this.c,Le=De.offset;let Be=ae.getGraphemeBreakType(De.nextCodePoint());for(;!De.eol();){const xe=De.offset,Ze=ae.getGraphemeBreakType(De.nextCodePoint());if(je(Be,Ze)){De.setOffset(xe);break}Be=Ze}return De.offset-Le}prevGraphemeLength(){const ae=et.getInstance(),De=this.c,Le=De.offset;let Be=ae.getGraphemeBreakType(De.prevCodePoint());for(;De.offset>0;){const xe=De.offset,Ze=ae.getGraphemeBreakType(De.prevCodePoint());if(je(Ze,Be)){De.setOffset(xe);break}Be=Ze}return Le-De.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Y;function ce(W,ae){return new Y(W,ae).nextGraphemeLength()}e.nextCharLength=ce;function ie(W,ae){return new Y(W,ae).prevGraphemeLength()}e.prevCharLength=ie;function fe(W,ae){ae>0&&M(W.charCodeAt(ae))&&ae--;const De=ae+ce(W,ae);return[De-ie(W,De),De]}e.getCharContainingOffset=fe;function J(W){const ae=new Y(W);let De=0;for(;!ae.eol();)De++,ae.nextGraphemeLength();return De}e.charCount=J;let pe;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ie(W){return pe||(pe=we()),pe.test(W)}e.containsRTL=Ie;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze(W){return Re.test(W)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function re(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=re;function ue(W){return W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ue;function de(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129008||W>=129280&&W<=129535||W>=129648&&W<=129782}e.isEmojiImprecise=de;function Z(W,ae){if(W.length<ae)return W;const De=/\b/g;let Le=0;for(;De.test(W)&&!(W.length-De.lastIndex<ae);)Le=De.lastIndex,De.lastIndex+=1;return W.substring(Le).replace(/^\s/,"")}e.lcut=Z;const se=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function $(W){return W&&(W=W.replace(se,""),W=W.replace(ne,""),W=W.replace(N,"")),W}e.removeAnsiEscapeCodes=$,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function x(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=x;function _(W){return x(W)?W.substr(1):W}e.stripUTF8BOM=_;function le(W,ae){if(!W||!ae||W.length<ae.length)return!1;const De=ae.length,Le=W.toLowerCase();let Be=0,xe=-1;for(;Be<De;){const Ze=Le.indexOf(ae[Be],xe+1);if(Ze<0)return!1;xe=Ze,Be++}return!0}e.fuzzyContains=le;function be(W,ae=!1){return W?(ae&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=be;function Pe(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=Pe;function ge(W,ae=1){if(ae===0)return"";let De=-1;do De=W.indexOf(`
`,De+1),ae--;while(ae>0&&De>=0);return De===-1?W:(W[De-1]==="\r"&&De--,W.substr(0,De))}e.getNLines=ge;function Ce(W){return W=W%(2*26),W<26?String.fromCharCode(97+W):String.fromCharCode(65+W-26)}e.singleLetterHash=Ce;function ke(W){return et.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ke;function je(W,ae){return W===0?ae!==5&&ae!==7:W===2&&ae===3?!1:W===4||W===2||W===3||ae===4||ae===2||ae===3?!0:!(W===8&&(ae===8||ae===9||ae===11||ae===12)||(W===11||W===9)&&(ae===9||ae===10)||(W===12||W===10)&&ae===10||ae===5||ae===13||ae===7||W===1||W===13&&ae===14||W===6&&ae===6)}var Ge;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const De=this.d,Le=De.length/3;let Be=1;for(;Be<=Le;)if(ae<De[3*Be])Be=2*Be;else if(ae>De[3*Be+1])Be=2*Be+1;else return De[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(W,ae){if(W===0)return 0;const De=st(W,ae);if(De!==void 0)return De;const Le=new Q(ae,W);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st(W,ae){const De=new Q(ae,W);let Le=De.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(De.offset===0)return;Le=De.prevCodePoint()}if(!de(Le))return;let Be=De.offset;return Be>0&&De.prevCodePoint()===8205&&(Be=De.offset),Be}function ht(W){return 127995<=W&&W<=127999}var Me;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ae){return it.d.get(Array.from(ae))}static getLocales(){return it.e.getValue()}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,I=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new a.LRUCachedFunction(W=>{function ae(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function De(lt,ot){const rt=new Map(lt);for(const[At,Rt]of ot)rt.set(At,Rt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[At,Rt]of lt)ot.has(At)&&rt.set(At,Rt);return rt}const Be=I.c.getValue();let xe=W.filter(lt=>!lt.startsWith("_")&&lt in Be);xe.length===0&&(xe=["_default"]);let Ze;for(const lt of xe){const ot=ae(Be[lt]);Ze=Le(Ze,ot)}const mt=ae(Be._common),ft=De(mt,Ze);return new it(ft)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter(W=>!W.startsWith("_")));class oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(oe.c())),this.d}static isInvisibleCharacter(ae){return oe.e().has(ae)}static get codePoints(){return oe.e()}}e.InvisibleCharacters=oe,oe.d=void 0}),define(Se[103],ye([1,0,28,8]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ne){return function(N,$){for(let x=0,_=ne.length;x<_;x++){const le=ne[x](N,$);if(le)return le}return null}}e.or=I,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ne,N,$){if(!$||$.length<N.length)return null;let x;return ne?x=t.startsWithIgnoreCase($,N):x=$.indexOf(N)===0,x?N.length>0?[{start:0,end:N.length}]:[]:null}function D(ne,N){const $=N.toLowerCase().indexOf(ne.toLowerCase());return $===-1?null:[{start:$,end:$+ne.length}]}e.matchesContiguousSubString=D;function T(ne,N){return S(ne.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=T;function S(ne,N,$,x){if($===ne.length)return[];if(x===N.length)return null;if(ne[$]===N[x]){let _=null;return(_=S(ne,N,$+1,x+1))?m({start:x,end:x+1},_):null}return S(ne,N,$,x+1)}function C(ne){return 97<=ne&&ne<=122}function R(ne){return 65<=ne&&ne<=90}e.isUpper=R;function P(ne){return 48<=ne&&ne<=57}function E(ne){return ne===32||ne===9||ne===10||ne===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>y.add(ne.charCodeAt(0)));function v(ne){return E(ne)||y.has(ne)}function d(ne,N){return ne===N||v(ne)&&v(N)}function g(ne){return C(ne)||R(ne)||P(ne)}function m(ne,N){return N.length===0?N=[ne]:ne.end===N[0].start?N[0].start=ne.start:N.unshift(ne),N}function w(ne,N){for(let $=N;$<ne.length;$++){const x=ne.charCodeAt($);if(R(x)||P(x)||$>0&&!g(ne.charCodeAt($-1)))return $}return ne.length}function f(ne,N,$,x){if($===ne.length)return[];if(x===N.length)return null;if(ne[$]!==N[x].toLowerCase())return null;{let _=null,le=x+1;for(_=f(ne,N,$+1,x+1);!_&&(le=w(N,le))<N.length;)_=f(ne,N,$+1,le),le++;return _===null?null:m({start:x,end:x+1},_)}}function h(ne){let N=0,$=0,x=0,_=0,le=0;for(let ke=0;ke<ne.length;ke++)le=ne.charCodeAt(ke),R(le)&&N++,C(le)&&$++,g(le)&&x++,P(le)&&_++;const be=N/ne.length,Pe=$/ne.length,ge=x/ne.length,Ce=_/ne.length;return{upperPercent:be,lowerPercent:Pe,alphaPercent:ge,numericPercent:Ce}}function b(ne){const{upperPercent:N,lowerPercent:$}=ne;return $===0&&N>.6}function o(ne){const{upperPercent:N,lowerPercent:$,alphaPercent:x,numericPercent:_}=ne;return $>.2&&N<.8&&x>.6&&_<.2}function r(ne){let N=0,$=0,x=0,_=0;for(let le=0;le<ne.length;le++)x=ne.charCodeAt(le),R(x)&&N++,C(x)&&$++,E(x)&&_++;return(N===0||$===0)&&_===0?ne.length<=30:N<=5}function c(ne,N){if(!N||(N=N.trim(),N.length===0)||!r(ne)||N.length>60)return null;const $=h(N);if(!o($)){if(!b($))return null;N=N.toLowerCase()}let x=null,_=0;for(ne=ne.toLowerCase();_<N.length&&(x=f(ne,N,0,_))===null;)_=w(N,_+1);return x}e.matchesCamelCase=c;function u(ne,N,$=!1){if(!N||N.length===0)return null;let x=null,_=0;for(ne=ne.toLowerCase(),N=N.toLowerCase();_<N.length&&(x=i(ne,N,0,_,$))===null;)_=s(N,_+1);return x}e.matchesWords=u;function i(ne,N,$,x,_){if($===ne.length)return[];if(x===N.length)return null;if(d(ne.charCodeAt($),N.charCodeAt(x))){let le=null,be=x+1;if(le=i(ne,N,$+1,x+1,_),!_)for(;!le&&(be=s(N,be))<N.length;)le=i(ne,N,$+1,be,_),be++;return le?ne.charCodeAt($)!==N.charCodeAt(x)?le:m({start:x,end:x+1},le):null}else return null}function s(ne,N){for(let $=N;$<ne.length;$++)if(v(ne.charCodeAt($))||$>0&&v(ne.charCodeAt($-1)))return $;return ne.length}const n=I(e.matchesPrefix,c,D),l=I(e.matchesPrefix,c,T),p=new a.LRUCache(1e4);function k(ne,N,$=!1){if(typeof ne!="string"||typeof N!="string")return null;let x=p.get(ne);x||(x=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),p.set(ne,x));const _=x.exec(N);return _?[{start:_.index,end:_.index+_[0].length}]:$?l(ne,N):n(ne,N)}e.matchesFuzzy=k;function L(ne,N){const $=Re(ne,ne.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?K($):null}e.matchesFuzzy2=L;function B(ne,N,$,x,_,le){const be=Math.min(13,ne.length);for(;$<be;$++){const Pe=Re(ne,N,$,x,_,le,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Pe)return Pe}return[0,le]}e.anyScore=B;function K(ne){if(typeof ne>"u")return[];const N=[],$=ne[1];for(let x=ne.length-1;x>1;x--){const _=ne[x]+$,le=N[N.length-1];le&&le.end===_?le.end=_+1:N.push({start:_,end:_+1})}return N}e.createMatches=K;const G=128;function O(){const ne=[],N=[];for(let $=0;$<=G;$++)N[$]=0;for(let $=0;$<=G;$++)ne.push(N.slice(0));return ne}function U(ne){const N=[];for(let $=0;$<=ne;$++)N[$]=0;return N}const F=U(2*G),z=U(2*G),M=O(),V=O(),q=O(),H=!1;function Q(ne,N,$,x,_){function le(Pe,ge,Ce=" "){for(;Pe.length<ge;)Pe=Ce+Pe;return Pe}let be=` |   |${x.split("").map(Pe=>le(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=$;Pe++)Pe===0?be+=" |":be+=`${N[Pe-1]}|`,be+=ne[Pe].slice(0,_+1).map(ge=>le(ge.toString(),3)).join("|")+`
`;return be}function Y(ne,N,$,x){ne=ne.substr(N),$=$.substr(x),console.log(Q(V,ne,ne.length,$,$.length)),console.log(Q(q,ne,ne.length,$,$.length)),console.log(Q(M,ne,ne.length,$,$.length))}function ce(ne,N){if(N<0||N>=ne.length)return!1;const $=ne.codePointAt(N);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise($)}}function ie(ne,N){if(N<0||N>=ne.length)return!1;switch(ne.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function fe(ne,N,$){return N[ne]!==$[ne]}function J(ne,N,$,x,_,le,be=!1){for(;N<$&&_<le;)ne[N]===x[_]&&(be&&(F[N]=_),N+=1),_+=1;return N===$}e.isPatternInWord=J;var pe;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var we;(function(ne){ne.Default=[-100,0];function N($){return!$||$.length===2&&$[0]===-100&&$[1]===0}ne.isDefault=N})(we=e.FuzzyScore||(e.FuzzyScore={}));class Ie{constructor(N,$){this.firstMatchCanBeWeak=N,this.boostFullMatch=$}}e.FuzzyScoreOptions=Ie,Ie.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,N,$,x,_,le,be=Ie.default){const Pe=ne.length>G?G:ne.length,ge=x.length>G?G:x.length;if($>=Pe||le>=ge||Pe-$>ge-le||!J(N,$,Pe,_,le,ge,!0))return;ze(Pe,ge,$,le,N,_);let Ce=1,ke=1,je=$,Ge=le;const et=[!1];for(Ce=1,je=$;je<Pe;Ce++,je++){const Me=F[je],it=z[je],oe=je+1<Pe?z[je+1]:ge;for(ke=Me-le+1,Ge=Me;Ge<oe;ke++,Ge++){let W=Number.MIN_SAFE_INTEGER,ae=!1;Ge<=it&&(W=re(ne,N,je,$,x,_,Ge,ge,le,M[Ce-1][ke-1]===0,et));let De=0;W!==Number.MAX_SAFE_INTEGER&&(ae=!0,De=W+V[Ce-1][ke-1]);const Le=Ge>Me,Be=Le?V[Ce][ke-1]+(M[Ce][ke-1]>0?-5:0):0,xe=Ge>Me+1&&M[Ce][ke-1]>0,Ze=xe?V[Ce][ke-2]+(M[Ce][ke-2]>0?-5:0):0;if(xe&&(!Le||Ze>=Be)&&(!ae||Ze>=De))V[Ce][ke]=Ze,q[Ce][ke]=3,M[Ce][ke]=0;else if(Le&&(!ae||Be>=De))V[Ce][ke]=Be,q[Ce][ke]=2,M[Ce][ke]=0;else if(ae)V[Ce][ke]=De,q[Ce][ke]=1,M[Ce][ke]=M[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(H&&Y(ne,$,x,le),!et[0]&&!be.firstMatchCanBeWeak)return;Ce--,ke--;const _e=[V[Ce][ke],le];let nt=0,st=0;for(;Ce>=1;){let Me=ke;do{const it=q[Ce][Me];if(it===3)Me=Me-2;else if(it===2)Me=Me-1;else break}while(Me>=1);nt>1&&N[$+Ce-1]===_[le+ke-1]&&!fe(Me+le-1,x,_)&&nt+1>M[Ce][Me]&&(Me=ke),Me===ke?nt++:nt=1,st||(st=Me),Ce--,ke=Me-1,_e.push(ke)}ge===Pe&&be.boostFullMatch&&(_e[0]+=2);const ht=st-Pe;return _e[0]-=ht,_e}e.fuzzyScore=Re;function ze(ne,N,$,x,_,le){let be=ne-1,Pe=N-1;for(;be>=$&&Pe>=x;)_[be]===le[Pe]&&(z[be]=Pe,be--),Pe--}function re(ne,N,$,x,_,le,be,Pe,ge,Ce,ke){if(N[$]!==le[be])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return be===$-x?je=ne[$]===_[be]?7:5:fe(be,_,le)&&(be===0||!fe(be-1,_,le))?(je=ne[$]===_[be]?7:5,Ge=!0):ce(le,be)&&(be===0||!ce(le,be-1))?je=5:(ce(le,be-1)||ie(le,be-1))&&(je=5,Ge=!0),je>1&&$===x&&(ke[0]=!0),Ge||(Ge=fe(be,_,le)||ce(le,be-1)||ie(le,be-1)),$===x?be>ge&&(je-=Ge?3:5):Ce?je+=Ge?2:0:je+=Ge?0:1,be+1===Pe&&(je-=Ge?3:5),je}function ue(ne,N,$,x,_,le,be){return Z(ne,N,$,x,_,le,!0,be)}e.fuzzyScoreGracefulAggressive=ue;function de(ne,N,$,x,_,le,be){return Z(ne,N,$,x,_,le,!1,be)}e.fuzzyScoreGraceful=de;function Z(ne,N,$,x,_,le,be,Pe){let ge=Re(ne,N,$,x,_,le,Pe);if(ge&&!be)return ge;if(ne.length>=3){const Ce=Math.min(7,ne.length-1);for(let ke=$+1;ke<Ce;ke++){const je=se(ne,ke);if(je){const Ge=Re(je,je.toLowerCase(),$,x,_,le,Pe);Ge&&(Ge[0]-=3,(!ge||Ge[0]>ge[0])&&(ge=Ge))}}}return ge}function se(ne,N){if(N+1>=ne.length)return;const $=ne[N],x=ne[N+1];if($!==x)return ne.slice(0,N)+x+$+ne.slice(N+2)}}),define(Se[85],ye([1,0,8]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return I(m,0)}e.hash=t;function I(m,w){switch(typeof m){case"object":return m===null?A(349,w):Array.isArray(m)?S(m,w):C(m,w);case"string":return T(m,w);case"boolean":return D(m,w);case"number":return A(m,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=I;function A(m,w){return(w<<5)-w+m|0}e.numberHash=A;function D(m,w){return A(m?433:863,w)}function T(m,w){w=A(149417,w);for(let f=0,h=m.length;f<h;f++)w=A(m.charCodeAt(f),w);return w}e.stringHash=T;function S(m,w){return w=A(104579,w),m.reduce((f,h)=>I(h,f),w)}function C(m,w){return w=A(181387,w),Object.keys(m).sort().reduce((f,h)=>(f=T(h,f),I(m[h],f)),w)}class R{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=I(w,this.g),this.g}}e.Hasher=R;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(m,w,f=32){const h=f-w,b=~((1<<h)-1);return(m<<w|(b&m)>>>h)>>>0}function y(m,w=0,f=m.byteLength,h=0){for(let b=0;b<f;b++)m[w+b]=h}function v(m,w,f="0"){for(;m.length<w;)m=f+m;return m}function d(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):v((m>>>0).toString(16),w/4)}e.toHexString=d;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const f=w.length;if(f===0)return;const h=this.p;let b=this.r,o=this.u,r,c;for(o!==0?(r=o,c=-1,o=0):(r=w.charCodeAt(0),c=0);;){let u=r;if(a.isHighSurrogate(r))if(c+1<f){const i=w.charCodeAt(c+1);a.isLowSurrogate(i)?(c++,u=a.computeCodePoint(r,i)):u=65533}else{o=r;break}else a.isLowSurrogate(r)&&(u=65533);if(b=this.w(h,b,u),c++,c<f)r=w.charCodeAt(c);else break}this.r=b,this.u=o}w(w,f,h){return h<128?w[f++]=h:h<2048?(w[f++]=192|(h&1984)>>>6,w[f++]=128|(h&63)>>>0):h<65536?(w[f++]=224|(h&61440)>>>12,w[f++]=128|(h&4032)>>>6,w[f++]=128|(h&63)>>>0):(w[f++]=240|(h&1835008)>>>18,w[f++]=128|(h&258048)>>>12,w[f++]=128|(h&4032)>>>6,w[f++]=128|(h&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=g.g,f=this.q;for(let n=0;n<64;n+=4)w.setUint32(n,f.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)w.setUint32(n,E(w.getUint32(n-12,!1)^w.getUint32(n-32,!1)^w.getUint32(n-56,!1)^w.getUint32(n-64,!1),1),!1);let h=this.h,b=this.l,o=this.m,r=this.n,c=this.o,u,i,s;for(let n=0;n<80;n++)n<20?(u=b&o|~b&r,i=1518500249):n<40?(u=b^o^r,i=1859775393):n<60?(u=b&o|b&r|o&r,i=2400959708):(u=b^o^r,i=3395469782),s=E(h,5)+u+c+i+w.getUint32(n*4,!1)&4294967295,c=r,r=o,o=E(b,30),b=h,h=s;this.h=this.h+h&4294967295,this.l=this.l+b&4294967295,this.m=this.m+o&4294967295,this.n=this.n+r&4294967295,this.o=this.o+c&4294967295}}e.StringSHA1=g,g.g=new DataView(new ArrayBuffer(320))}),define(Se[148],ye([1,0,80,103,8]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",D=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(a.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${D.source}`,"g");function C(m){return m.replace(S,(w,f)=>f?w:`\\${w}`)}e.escapeIcons=C;const R=new RegExp(`\\\\${D.source}`,"g");function P(m){return m.replace(R,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=P;const E=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function y(m){return m.indexOf(A)===-1?m:m.replace(E,(w,f,h,b)=>h?w:f||b||"")}e.stripIcons=y;function v(m){const w=m.indexOf(A);return w===-1?{text:m}:d(m,w)}e.parseLabelWithIcons=v;function d(m,w){const f=[];let h="";function b(l){if(l){h+=l;for(const p of l)f.push(c)}}let o=-1,r="",c=0,u,i,s=w;const n=m.length;for(b(m.substr(0,w));s<n;)u=m[s],i=m[s+1],u===A[0]&&i===A[1]?(o=s,b(r),r=A,s++):u===")"&&o!==-1?(c+=s-o+1,o=-1,r=""):o!==-1?T.test(u)?r+=u:(b(r),o=-1,r=""):b(u),s++;return b(r),{text:h,iconOffsets:f}}function g(m,w,f=!1){const{text:h,iconOffsets:b}=w;if(!b||b.length===0)return(0,t.matchesFuzzy)(m,h,f);const o=(0,I.ltrim)(h," "),r=h.length-o.length,c=(0,t.matchesFuzzy)(m,o,f);if(c)for(const u of c){const i=b[u.start+r]+r;u.start+=i,u.end+=i}return c}e.matchesFuzzyIconAware=g}),define(Se[42],ye([1,0,8]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const A="error",D="warning",T="warn",S="info",C="ignore";function R(E){return E?a.equalsIgnoreCase(A,E)?I.Error:a.equalsIgnoreCase(D,E)||a.equalsIgnoreCase(T,E)?I.Warning:a.equalsIgnoreCase(S,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function P(E){switch(E){case I.Error:return A;case I.Warning:return D;case I.Info:return S;default:return C}}I.toString=P}(t||(t={})),e.default=t}),define(Se[65],ye([1,0,17,8]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const v=y.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.StringIterator=I;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,t.compareSubstring)(y,this.b,0,y.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class D{constructor(y=!0,v=!0){this.f=y,this.g=v}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let v=y.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,t.compareSubstring)(y,this.b,0,y.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var T;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(y,v){this.f=y,this.g=v,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(y,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,t.compare)(y,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(R||(R={}));class P{static forUris(y=()=>!1,v=()=>!1){return new P(new S(y,v))}static forPaths(y=!1){return new P(new D(void 0,!y))}static forStrings(){return new P(new I)}static forConfigKeys(){return new P(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,v){if(v){const d=v.slice(0);(0,a.shuffle)(d);for(const g of d)this.set(g,y)}else{const d=y.slice(0);(0,a.shuffle)(d);for(const g of d)this.set(g[0],g[1])}}set(y,v){const d=this.b.reset(y);let g;this.c||(this.c=new C,this.c.segment=d.value());const m=[];for(g=this.c;;){const f=d.cmp(g.segment);if(f>0)g.left||(g.left=new C,g.left.segment=d.value()),m.push([-1,g]),g=g.left;else if(f<0)g.right||(g.right=new C,g.right.segment=d.value()),m.push([1,g]),g=g.right;else if(d.hasNext())d.next(),g.mid||(g.mid=new C,g.mid.segment=d.value()),m.push([0,g]),g=g.mid;else break}const w=g.value;g.value=v,g.key=y;for(let f=m.length-1;f>=0;f--){const h=m[f][1];h.updateHeight();const b=h.balanceFactor();if(b<-1||b>1){const o=m[f][0],r=m[f+1][0];if(o===1&&r===1)m[f][1]=h.rotateLeft();else if(o===-1&&r===-1)m[f][1]=h.rotateRight();else if(o===1&&r===-1)h.right=m[f+1][1]=m[f+1][1].rotateRight(),m[f][1]=h.rotateLeft();else if(o===-1&&r===1)h.left=m[f+1][1]=m[f+1][1].rotateLeft(),m[f][1]=h.rotateRight();else throw new Error;if(f>0)switch(m[f-1][0]){case-1:m[f-1][1].left=m[f][1];break;case 1:m[f-1][1].right=m[f][1];break;case 0:m[f-1][1].mid=m[f][1];break}else this.c=m[0][1]}}return w}get(y){return this.d(y)?.value}d(y){const v=this.b.reset(y);let d=this.c;for(;d;){const g=v.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(y){const v=this.d(y);return!(v?.value===void 0&&v?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,v){const d=this.b.reset(y),g=[];let m=this.c;for(;m;){const w=d.cmp(m.segment);if(w>0)g.push([-1,m]),m=m.left;else if(w<0)g.push([1,m]),m=m.right;else if(d.hasNext())d.next(),g.push([0,m]),m=m.mid;else break}if(!!m){if(v?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const w=this.f(m.right);if(w.key){const{key:f,value:h,segment:b}=w;this.e(w.key,!1),m.key=f,m.value=h,m.segment=b}}else{const w=m.left??m.right;if(g.length>0){const[f,h]=g[g.length-1];switch(f){case-1:h.left=w;break;case 0:h.mid=w;break;case 1:h.right=w;break}}else this.c=w}for(let w=g.length-1;w>=0;w--){const f=g[w][1];f.updateHeight();const h=f.balanceFactor();if(h>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),g[w][1]=f.rotateLeft()):h<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),g[w][1]=f.rotateRight()),w>0)switch(g[w-1][0]){case-1:g[w-1][1].left=g[w][1];break;case 1:g[w-1][1].right=g[w][1];break;case 0:g[w-1][1].mid=g[w][1];break}else this.c=g[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const v=this.b.reset(y);let d=this.c,g;for(;d;){const m=v.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(v.hasNext())v.next(),g=d.value||g,d=d.mid;else break}return d&&d.value||g}findSuperstr(y){const v=this.b.reset(y);let d=this.c;for(;d;){const g=v.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(y){for(const[v,d]of this)y(d,v)}*[Symbol.iterator](){yield*this.g(this.c)}g(y){const v=[];return this.h(y,v),v[Symbol.iterator]()}h(y,v){!y||(y.left&&this.h(y.left,v),y.value&&v.push([y.key,y.value]),y.mid&&this.h(y.mid,v),y.right&&this.h(y.right,v))}_isBalanced(){const y=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:y(v.left)&&y(v.right)};return y(this.c)}}e.TernarySearchTree=P}),define(Se[12],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(r){return typeof r=="string"}e.isString=a;function t(r){return Array.isArray(r)&&r.every(c=>a(c))}e.isStringArray=t;function I(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=I;function A(r){const c=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof c}e.isTypedArray=A;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function T(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=T;function S(r){return r===!0||r===!1}e.isBoolean=S;function C(r){return typeof r>"u"}e.isUndefined=C;function R(r){return!P(r)}e.isDefined=R;function P(r){return C(r)||r===null}e.isUndefinedOrNull=P;function E(r,c){if(!r)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=E;function y(r){if(P(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=y;function v(...r){const c=[];for(let u=0;u<r.length;u++){const i=r[u];if(P(i))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);c.push(i)}return c}e.assertAllDefined=v;const d=Object.prototype.hasOwnProperty;function g(r){if(!I(r))return!1;for(const c in r)if(d.call(r,c))return!1;return!0}e.isEmptyObject=g;function m(r){return typeof r=="function"}e.isFunction=m;function w(...r){return r.length>0&&r.every(m)}e.areFunctions=w;function f(r,c){const u=Math.min(r.length,c.length);for(let i=0;i<u;i++)h(r[i],c[i])}e.validateConstraints=f;function h(r,c){if(a(c)){if(typeof r!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(m(c)){try{if(r instanceof c)return}catch{}if(!P(r)&&r.constructor===c||c.length===1&&c.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function b(r){return r===null?void 0:r}e.withNullAsUndefined=b;function o(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=o}),define(Se[32],ye([1,0,9,11,8,12]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(i){return i===47||i===92}e.isPathSeparator=D;function T(i){return i.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=T;function S(i){return i.indexOf("/")===-1&&(i=T(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=S;function C(i,s=a.posix.sep){if(!i)return"";const n=i.length,l=i.charCodeAt(0);if(D(l)){if(D(i.charCodeAt(1))&&!D(i.charCodeAt(2))){let k=3;const L=k;for(;k<n&&!D(i.charCodeAt(k));k++);if(L!==k&&!D(i.charCodeAt(k+1))){for(k+=1;k<n;k++)if(D(i.charCodeAt(k)))return i.slice(0,k+1).replace(/[\\/]/g,s)}}return s}else if(m(l)&&i.charCodeAt(1)===58)return D(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let p=i.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(D(i.charCodeAt(p)))return i.slice(0,p+1)}return""}e.getRoot=C;function R(i){if(!t.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let n=2;const l=n;for(;n<i.length&&(s=i.charCodeAt(n),s!==92);n++);return!(l===n||(s=i.charCodeAt(n+1),isNaN(s)||s===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(i,s=t.isWindows){const n=s?P:E;return!(!i||i.length===0||/^\s+$/.test(i)||(n.lastIndex=0,n.test(i))||s&&y.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=v;function d(i,s,n){const l=i===s;return!n||l?l:!i||!s?!1:(0,I.equalsIgnoreCase)(i,s)}e.isEqual=d;function g(i,s,n,l=a.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(n){if(!(0,I.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let k=s.length;return s.charAt(s.length-1)===l&&k--,i.charAt(k)===l}return s.charAt(s.length-1)!==l&&(s+=l),i.indexOf(s)===0}e.isEqualOrParent=g;function m(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=m;function w(i,s){return t.isWindows&&i.endsWith(":")&&(i+=a.sep),(0,a.isAbsolute)(i)||(i=(0,a.join)(s,i)),i=(0,a.normalize)(i),t.isWindows?(i=(0,I.rtrim)(i,a.sep),i.endsWith(":")&&(i+=a.sep)):(i=(0,I.rtrim)(i,a.sep),i||(i=a.sep)),i}e.sanitizeFilePath=w;function f(i){const s=(0,a.normalize)(i);return t.isWindows?i.length>3?!1:h(s)&&(i.length===2||s.charCodeAt(2)===92):s===a.posix.sep}e.isRootOrDriveLetter=f;function h(i,s=t.isWindows){return s?m(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function b(i){return h(i)?i[0]:void 0}e.getDriveLetter=b;function o(i,s,n){return s.length>i.length?-1:i===s?0:(n&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=o;function r(i){const s=i.split(":");let n,l,p;for(const k of s){const L=Number(k);(0,A.isNumber)(L)?l===void 0?l=L:p===void 0&&(p=L):n=n?[n,k].join(":"):k}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:l!==void 0?l:void 0,column:p!==void 0?p:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(i,s,n=8){let l="";for(let k=0;k<n;k++)l+=c.charAt(Math.floor(Math.random()*c.length));let p;return s?p=`${s}-${l}`:p=l,i?(0,a.join)(i,p):p}e.randomPath=u}),define(Se[23],ye([1,0,12]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const w=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([f,h])=>{w[f]=h&&typeof h=="object"?t(h):h}),w}e.deepClone=t;function I(m){if(!m||typeof m!="object")return m;const w=[m];for(;w.length>0;){const f=w.shift();Object.freeze(f);for(const h in f)if(A.call(f,h)){const b=f[h];typeof b=="object"&&!Object.isFrozen(b)&&!(0,a.isTypedArray)(b)&&w.push(b)}}return m}e.deepFreeze=I;const A=Object.prototype.hasOwnProperty;function D(m,w){return T(m,w,new Set)}e.cloneAndChange=D;function T(m,w,f){if((0,a.isUndefinedOrNull)(m))return m;const h=w(m);if(typeof h<"u")return h;if(Array.isArray(m)){const b=[];for(const o of m)b.push(T(o,w,f));return b}if((0,a.isObject)(m)){if(f.has(m))throw new Error("Cannot clone recursive data-structure");f.add(m);const b={};for(const o in m)A.call(m,o)&&(b[o]=T(m[o],w,f));return f.delete(m),b}return m}function S(m,w,f=!0){return(0,a.isObject)(m)?((0,a.isObject)(w)&&Object.keys(w).forEach(h=>{h in m?f&&((0,a.isObject)(m[h])&&(0,a.isObject)(w[h])?S(m[h],w[h],f):m[h]=w[h]):m[h]=w[h]}),m):w}e.mixin=S;function C(m,w){if(m===w)return!0;if(m==null||w===null||w===void 0||typeof m!=typeof w||typeof m!="object"||Array.isArray(m)!==Array.isArray(w))return!1;let f,h;if(Array.isArray(m)){if(m.length!==w.length)return!1;for(f=0;f<m.length;f++)if(!C(m[f],w[f]))return!1}else{const b=[];for(h in m)b.push(h);b.sort();const o=[];for(h in w)o.push(h);if(o.sort(),!C(b,o))return!1;for(f=0;f<b.length;f++)if(!C(m[b[f]],w[b[f]]))return!1}return!0}e.equals=C;function R(m){const w=new Set;return JSON.stringify(m,(f,h)=>{if((0,a.isObject)(h)||Array.isArray(h)){if(w.has(h))return"[Circular]";w.add(h)}return h})}e.safeStringify=R;function P(m,w){const f=Object.create(null);return!m||!w||Object.keys(w).forEach(b=>{const o=m[b],r=w[b];C(o,r)||(f[b]=r)}),f}e.distinct=P;function E(m,w){const f=w.toLowerCase(),h=Object.keys(m).find(b=>b.toLowerCase()===f);return h?m[h]:m[w]}e.getCaseInsensitive=E;function y(m,w){const f=Object.create(null);for(const[h,b]of Object.entries(m))w(h,b)&&(f[h]=b);return f}e.filter=y;function v(m){let w=[],f=Object.getPrototypeOf(m);for(;Object.prototype!==f;)w=w.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return w}e.getAllPropertyNames=v;function d(m){const w=[];for(const f of v(m))typeof m[f]=="function"&&w.push(f);return w}e.getAllMethodNames=d;function g(m,w){const f=b=>function(){const o=Array.prototype.slice.call(arguments,0);return w(b,o)},h={};for(const b of m)h[b]=f(b);return h}e.createProxyObject=g}),define(Se[104],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function I(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=I}),define(Se[2],ye([1,0,9,11]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function T(c,u){if(!c.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!I.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!A.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(c,u){return!c&&!u?"file":c}function C(c,u){switch(c){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const R="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(u){return u instanceof y?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,i,s,n,l,p=!1){typeof u=="object"?(this.scheme=u.scheme||R,this.authority=u.authority||R,this.path=u.path||R,this.query=u.query||R,this.fragment=u.fragment||R):(this.scheme=S(u,p),this.authority=i||R,this.path=C(this.scheme,s||R),this.query=n||R,this.fragment=l||R,T(this,p))}get fsPath(){return f(this,!1)}with(u){if(!u)return this;let{scheme:i,authority:s,path:n,query:l,fragment:p}=u;return i===void 0?i=this.scheme:i===null&&(i=R),s===void 0?s=this.authority:s===null&&(s=R),n===void 0?n=this.path:n===null&&(n=R),l===void 0?l=this.query:l===null&&(l=R),p===void 0?p=this.fragment:p===null&&(p=R),i===this.scheme&&s===this.authority&&n===this.path&&l===this.query&&p===this.fragment?this:new d(i,s,n,l,p)}static parse(u,i=!1){const s=E.exec(u);return s?new d(s[2]||R,r(s[4]||R),r(s[5]||R),r(s[7]||R),r(s[9]||R),i):new d(R,R,R,R,R)}static file(u){let i=R;if(t.isWindows&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const s=u.indexOf(P,2);s===-1?(i=u.substring(2),u=P):(i=u.substring(2,s),u=u.substring(s)||P)}return new d("file",i,u,R,R)}static from(u){const i=new d(u.scheme,u.authority,u.path,u.query,u.fragment);return T(i,!0),i}static joinPath(u,...i){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&u.scheme==="file"?s=y.file(a.win32.join(f(u,!0),...i)).path:s=a.posix.join(u.path,...i),u.with({path:s})}toString(u=!1){return h(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof y)return u;{const i=new d(u);return i._formatted=u.external,i._fsPath=u._sep===v?u.fsPath:null,i}}else return u}}e.URI=y;const v=t.isWindows?1:void 0;class d extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(u=!1){return u?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=v),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(c,u){let i,s=-1;for(let n=0;n<c.length;n++){const l=c.charCodeAt(n);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||u&&l===47)s!==-1&&(i+=encodeURIComponent(c.substring(s,n)),s=-1),i!==void 0&&(i+=c.charAt(n));else{i===void 0&&(i=c.substr(0,n));const p=g[l];p!==void 0?(s!==-1&&(i+=encodeURIComponent(c.substring(s,n)),s=-1),i+=p):s===-1&&(s=n)}}return s!==-1&&(i+=encodeURIComponent(c.substring(s))),i!==void 0?i:c}function w(c){let u;for(let i=0;i<c.length;i++){const s=c.charCodeAt(i);s===35||s===63?(u===void 0&&(u=c.substr(0,i)),u+=g[s]):u!==void 0&&(u+=c[i])}return u!==void 0?u:c}function f(c,u){let i;return c.authority&&c.path.length>1&&c.scheme==="file"?i=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?u?i=c.path.substr(1):i=c.path[1].toLowerCase()+c.path.substr(2):i=c.path,t.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=f;function h(c,u){const i=u?w:m;let s="",{scheme:n,authority:l,path:p,query:k,fragment:L}=c;if(n&&(s+=n,s+=":"),(l||n==="file")&&(s+=P,s+=P),l){let B=l.indexOf("@");if(B!==-1){const K=l.substr(0,B);l=l.substr(B+1),B=K.indexOf(":"),B===-1?s+=i(K,!1):(s+=i(K.substr(0,B),!1),s+=":",s+=i(K.substr(B+1),!1)),s+="@"}l=l.toLowerCase(),B=l.indexOf(":"),B===-1?s+=i(l,!1):(s+=i(l.substr(0,B),!1),s+=l.substr(B))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const B=p.charCodeAt(1);B>=65&&B<=90&&(p=`/${String.fromCharCode(B+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const B=p.charCodeAt(0);B>=65&&B<=90&&(p=`${String.fromCharCode(B+32)}:${p.substr(2)}`)}s+=i(p,!0)}return k&&(s+="?",s+=i(k,!1)),L&&(s+="#",s+=u?L:m(L,!1)),s}function b(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+b(c.substr(3)):c}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(c){return c.match(o)?c.replace(o,u=>b(u)):c}}),define(Se[86],ye([1,0,22,8,2]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(C){return JSON.stringify(C,T)}e.stringify=A;function D(C){let R=JSON.parse(C);return R=S(R),R}e.parse=D;function T(C,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function S(C,R=0){if(!C||R>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return I.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 16:return new Date(C.source)}if(C instanceof a.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=S(C[P],R+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=S(C[P],R+1))}return C}e.revive=S}),define(Se[15],ye([1,0,11,2]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${I.vscodeRemoteResource}`}set(C,R,P){this.a[C]=R,this.b[C]=P}setConnectionToken(C,R){this.c[C]=R}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)return this.e(C);const R=C.authority;let P=this.a[R];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const E=this.b[R],y=this.c[R];let v=`path=${encodeURIComponent(C.path)}`;return typeof y=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:a.isWeb?this.d:I.vscodeRemoteResource,authority:`${P}:${E}`,path:a.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:v})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(C){const R=this.b(C,ee);return this.uriToBrowserUri(R)}uriToBrowserUri(C){return C.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===I.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${I.vscodeFileResource}://${D.a}`)?C.with({scheme:I.vscodeFileResource,authority:C.authority||D.a,query:null,fragment:null}):C}asFileUri(C){const R=this.b(C,ee);return this.uriToFileUri(R)}uriToFileUri(C){return C.scheme===I.vscodeFileResource?C.with({scheme:I.file,authority:C.authority!==D.a?C.authority:null,query:null,fragment:null}):C}b(C,R){return t.URI.isUri(C)?C:t.URI.parse(R.toUrl(C))}}D.a="vscode-app",e.FileAccess=new D;var T;(function(S){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(C.get("3"));const R="vscode-coi";function P(y){let v;typeof y=="string"?v=new URL(y).searchParams:y instanceof URL?v=y.searchParams:t.URI.isUri(y)&&(v=new URL(y.toString(!0)).searchParams);const d=v?.get(R);if(!!d)return C.get(d)}S.getHeadersFromQuery=P;function E(y,v,d){if(!globalThis.crossOriginIsolated)return;const g=v&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(R,g):y[R]=g}S.addSearchParam=E})(T=e.COI||(e.COI={}))}),define(Se[24],ye([1,0,32,15,9,11,8,2]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(y){return(0,T.uriToFsPath)(y,!0)}e.originalFSPath=S;class C{constructor(v){this.a=v}compare(v,d,g=!1){return v===d?0:(0,D.compare)(this.getComparisonKey(v,g),this.getComparisonKey(d,g))}isEqual(v,d,g=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,g)===this.getComparisonKey(d,g)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,g=!1){if(v.scheme===d.scheme){if(v.scheme===t.Schemas.file)return a.isEqualOrParent(S(v),S(d),this.a(v))&&v.query===d.query&&(g||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return a.isEqualOrParent(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(g||v.fragment===d.fragment)}return!1}joinPath(v,...d){return T.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return I.posix.basename(v.path)}extname(v){return I.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(I.dirname(S(v))).path:(d=I.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(I.normalize(S(v))).path:d=I.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===t.Schemas.file){const w=I.relative(S(v),S(d));return A.isWindows?a.toSlashes(w):w}let g=v.path||"/";const m=d.path||"/";if(this.a(v)){let w=0;for(const f=Math.min(g.length,m.length);w<f&&!(g.charCodeAt(w)!==m.charCodeAt(w)&&g.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);g=m.substr(0,w)+g.substr(w)}return I.posix.relative(g,m)}resolvePath(v,d){if(v.scheme===t.Schemas.file){const g=T.URI.file(I.resolve(S(v),d));return v.with({authority:g.authority,path:g.path})}return d=a.toPosixPath(d),v.with({path:I.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,D.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=I.sep){if(v.scheme===t.Schemas.file){const g=S(v);return g.length>a.getRoot(g).length&&g[g.length-1]===d}else{const g=v.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=I.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=I.sep){let g=!1;if(v.scheme===t.Schemas.file){const m=S(v);g=m!==void 0&&m.length===a.getRoot(m).length&&m[m.length-1]===d}else{d="/";const m=v.path;g=m.length===1&&m.charCodeAt(m.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(y=>y.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new C(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,v){const d=[];for(let g=0;g<y.length;g++){const m=v(y[g]);y.some((w,f)=>f===g?!1:(0,e.isEqualOrParent)(m,v(w)))||d.push(y[g])}return d}e.distinctParents=R;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(f=>{const[h,b]=f.split(":");h&&b&&g.set(h,b)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&g.set(y.META_DATA_MIME,w),g}y.parseMetaData=v})(P=e.DataUri||(e.DataUri={}));function E(y,v,d){if(v){let g=y.path;return g&&g[0]!==I.posix.sep&&(g=I.posix.sep+g),y.with({scheme:d,authority:v,path:g})}return y.with({scheme:d})}e.toLocalResource=E}),define(Se[18],ye([1,0,21,10,4,6,24,11]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=S;function C(fe){const J=new a.CancellationTokenSource,pe=fe(J.token),we=new Promise((Ie,Re)=>{const ze=J.token.onCancellationRequested(()=>{ze.dispose(),J.dispose(),Re(new t.CancellationError)});Promise.resolve(pe).then(re=>{ze.dispose(),J.dispose(),Ie(re)},re=>{ze.dispose(),J.dispose(),Re(re)})});return new class{cancel(){J.cancel()}then(Ie,Re){return we.then(Ie,Re)}catch(Ie){return this.then(void 0,Ie)}finally(Ie){return we.finally(Ie)}}}e.createCancelablePromise=C;function R(fe,J,pe){return new Promise((we,Ie)=>{const Re=J.onCancellationRequested(()=>{Re.dispose(),we(pe)});fe.then(we,Ie).finally(()=>Re.dispose())})}e.raceCancellation=R;function P(fe,J){return new Promise((pe,we)=>{const Ie=J.onCancellationRequested(()=>{Ie.dispose(),we(new t.CancellationError)});fe.then(pe,we).finally(()=>Ie.dispose())})}e.raceCancellationError=P;async function E(fe){let J=-1;const pe=fe.map((Ie,Re)=>Ie.then(ze=>(J=Re,ze))),we=await Promise.race(pe);return fe.forEach((Ie,Re)=>{Re!==J&&Ie.cancel()}),we}e.raceCancellablePromises=E;function y(fe,J,pe){let we;const Ie=setTimeout(()=>{we?.(void 0),pe?.()},J);return Promise.race([fe.finally(()=>clearTimeout(Ie)),new Promise(Re=>we=Re)])}e.raceTimeout=y;function v(fe){return new Promise((J,pe)=>{const we=fe();S(we)?we.then(J,pe):J(we)})}e.asPromise=v;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(J){if(this.a){if(this.d=J,!this.b){const pe=()=>{this.b=null;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(pe,pe).then(we)})}return new Promise((pe,we)=>{this.b.then(pe,we)})}return this.a=J(),new Promise((pe,we)=>{this.a.then(Ie=>{this.a=null,pe(Ie)},Ie=>{this.a=null,we(Ie)})})}}e.Throttler=d;class g{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.Sequencer=g;class m{constructor(){this.a=new Map}queue(J,pe){const Ie=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(J)===Ie&&this.a.delete(J)});return this.a.set(J,Ie),Ie}}e.SequencerByKey=m;const w=(fe,J)=>{let pe=!0;const we=setTimeout(()=>{pe=!1,J()},fe);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(we),pe=!1}}},f=fe=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,fe())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,pe=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((Ie,Re)=>{this.d=Ie,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const Ie=this.g;return this.g=null,Ie()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=pe===e.MicrotaskDelay?f(we):w(pe,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=h;class b{constructor(J){this.a=new h(J),this.b=new d}trigger(J,pe){return this.a.trigger(()=>this.b.queue(J),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=b;class o{constructor(){this.a=!1,this.b=new Promise((J,pe)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class r extends o{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function c(fe,J){return J?new Promise((pe,we)=>{const Ie=setTimeout(()=>{Re.dispose(),pe()},fe),Re=J.onCancellationRequested(()=>{clearTimeout(Ie),Re.dispose(),we(new t.CancellationError)})}):C(pe=>c(fe,pe))}e.timeout=c;function u(fe,J=0){const pe=setTimeout(fe,J);return(0,A.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=u;function i(fe){const J=[];let pe=0;const we=fe.length;function Ie(){return pe<we?fe[pe++]():null}function Re(ze){ze!=null&&J.push(ze);const re=Ie();return re?re.then(Re):Promise.resolve(J)}return Promise.resolve(null).then(Re)}e.sequence=i;function s(fe,J=we=>!!we,pe=null){let we=0;const Ie=fe.length,Re=()=>{if(we>=Ie)return Promise.resolve(pe);const ze=fe[we++];return Promise.resolve(ze()).then(ue=>J(ue)?Promise.resolve(ue):Re())};return Re()}e.first=s;function n(fe,J=we=>!!we,pe=null){if(fe.length===0)return Promise.resolve(pe);let we=fe.length;const Ie=()=>{we=-1;for(const Re of fe)Re.cancel?.()};return new Promise((Re,ze)=>{for(const re of fe)re.then(ue=>{--we>=0&&J(ue)?(Ie(),Re(ue)):we===0&&Re(pe)}).catch(ue=>{--we>=0&&(Ie(),ze(ue))})})}e.firstParallel=n;class l{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new I.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((pe,we)=>{this.f.push({factory:J,c:pe,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const pe=J.factory();pe.then(J.c,J.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=l;class p extends l{constructor(){super(1)}}e.Queue=p;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const J=new q;return this.b.add(J),J.p}d(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,pe=D.extUri){const we=pe.getComparisonKey(J);let Ie=this.a.get(we);return Ie||(Ie=new p,I.Event.once(Ie.onDrained)(()=>{Ie?.dispose(),this.a.delete(we),this.f()}),this.a.set(we,Ie)),Ie}f(){!this.d()||this.g()}g(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.g()}}e.ResourceQueue=k;class L{constructor(J,pe){this.a=-1,typeof J=="function"&&typeof pe=="number"&&this.setIfNotSet(J,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},pe)}setIfNotSet(J,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},pe))}}e.TimeoutTimer=L;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,pe){this.cancel(),this.a=setInterval(()=>{J()},pe)}}e.IntervalTimer=B;class K{constructor(J,pe){this.b=-1,this.a=J,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class G{constructor(J,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=J,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class O extends K{constructor(J,pe){super(J,pe),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=O;class U extends A.Disposable{constructor(J,pe){super(),this.g=J,this.h=pe,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...J),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,T.setTimeout0)(()=>{if(J)return;const pe=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(fe,J)=>{const pe=requestIdleCallback(fe,typeof J=="number"?{timeout:J}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(pe))}}}}();class F{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function z(fe,J,pe){let we;for(let Ie=0;Ie<pe;Ie++)try{return await fe()}catch(Re){we=Re,await c(J)}throw we}e.retry=z;class M{hasPending(J){return this.a?typeof J=="number"?this.a.taskId===J:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(J,pe,we){return this.a={taskId:J,cancel:()=>we?.(),promise:pe},pe.then(()=>this.d(J),()=>this.d(J)),pe}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this.b)this.b.run=J;else{let pe,we;const Ie=new Promise((Re,ze)=>{pe=Re,we=ze});this.b={run:J,promise:Ie,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=M;class V{constructor(J,pe=()=>Date.now()){this.d=J,this.f=pe,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class q{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((J,pe)=>{this.a=J,this.b=pe})}complete(J){return new Promise(pe=>{this.a(J),this.f=!0,pe()})}error(J){return new Promise(pe=>{this.b(J),this.d=!0,pe()})}cancel(){new Promise(J=>{this.b(new t.CancellationError),this.d=!0,J()})}}e.DeferredPromise=q;var H;(function(fe){async function J(we){let Ie;const Re=await Promise.all(we.map(ze=>ze.then(re=>re,re=>{Ie||(Ie=re)})));if(typeof Ie<"u")throw Ie;return Re}fe.settled=J;function pe(we){return new Promise(async(Ie,Re)=>{try{await we(Ie,Re)}catch(ze){Re(ze)}})}fe.withAsyncBody=pe})(H=e.Promises||(e.Promises={}));var Q;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(Q||(Q={}));class Y{static fromArray(J){return new Y(pe=>{pe.emitMany(J)})}static fromPromise(J){return new Y(async pe=>{pe.emitMany(await J)})}static fromPromises(J){return new Y(async pe=>{await Promise.all(J.map(async we=>pe.emitOne(await we)))})}static merge(J){return new Y(async pe=>{await Promise.all(J.map(async we=>{for await(const Ie of we)pe.emitOne(Ie)}))})}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new I.Emitter,queueMicrotask(async()=>{const pe={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(J(pe)),this.j()}catch(we){this.k(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(J,pe){return new Y(async we=>{for await(const Ie of J)we.emitOne(pe(Ie))})}map(J){return Y.map(this,J)}static filter(J,pe){return new Y(async we=>{for await(const Ie of J)pe(Ie)&&we.emitOne(Ie)})}filter(J){return Y.filter(this,J)}static coalesce(J){return Y.filter(J,pe=>!!pe)}coalesce(){return Y.coalesce(this)}static async toPromise(J){const pe=[];for await(const we of J)pe.push(we);return pe}toPromise(){return Y.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class ce extends Y{constructor(J,pe){super(pe),this.l=J}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ce;function ie(fe){const J=new a.CancellationTokenSource,pe=fe(J.token);return new ce(J,async we=>{const Ie=J.token.onCancellationRequested(()=>{Ie.dispose(),J.dispose(),we.reject(new t.CancellationError)});try{for await(const Re of pe){if(J.token.isCancellationRequested)return;we.emitOne(Re)}Ie.dispose(),J.dispose()}catch(Re){Ie.dispose(),J.dispose(),we.reject(Re)}})}e.createCancelableAsyncIterable=ie}),define(Se[105],ye([1,0,18,9]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new a.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),A=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(p,k,L=!1){const B=p||"",K=k||"",G=I.value.collator.compare(B,K);return I.value.collatorIsNumeric&&G===0&&B!==K?B<K?-1:1:G}e.compareFileNames=T;function S(p,k){const L=A.value.collator;return p=p||"",k=k||"",b(L,p,k)}e.compareFileNamesDefault=S;function C(p,k){const L=A.value.collator;return p=p||"",k=k||"",u(p,k)||b(L,p,k)}e.compareFileNamesUpper=C;function R(p,k){const L=A.value.collator;return p=p||"",k=k||"",c(p,k)||b(L,p,k)}e.compareFileNamesLower=R;function P(p,k){return p=p||"",k=k||"",p===k?0:p<k?-1:1}e.compareFileNamesUnicode=P;function E(p,k,L=!1){L||(p=p&&p.toLowerCase(),k=k&&k.toLowerCase());const[B,K]=f(p),[G,O]=f(k);return B!==G?B<G?-1:1:K===O?0:K<O?-1:1}e.noIntlCompareFileNames=E;function y(p,k){const[L,B]=f(p),[K,G]=f(k);let O=I.value.collator.compare(B,G);if(O===0){if(I.value.collatorIsNumeric&&B!==G)return B<G?-1:1;if(O=I.value.collator.compare(L,K),I.value.collatorIsNumeric&&O===0&&L!==K)return L<K?-1:1}return O}e.compareFileExtensions=y;function v(p,k){p=p||"",k=k||"";const L=h(p),B=h(k),K=A.value.collator,G=D.value.collator;return b(G,L,B)||b(K,p,k)}e.compareFileExtensionsDefault=v;function d(p,k){p=p||"",k=k||"";const L=h(p),B=h(k),K=A.value.collator,G=D.value.collator;return b(G,L,B)||u(p,k)||b(K,p,k)}e.compareFileExtensionsUpper=d;function g(p,k){p=p||"",k=k||"";const L=h(p),B=h(k),K=A.value.collator,G=D.value.collator;return b(G,L,B)||c(p,k)||b(K,p,k)}e.compareFileExtensionsLower=g;function m(p,k){p=p||"",k=k||"";const L=h(p).toLowerCase(),B=h(k).toLowerCase();return L!==B?L<B?-1:1:p!==k?p<k?-1:1:0}e.compareFileExtensionsUnicode=m;const w=/^(.*?)(\.([^.]*))?$/;function f(p,k=!1){const L=p?w.exec(p):[];let B=[L&&L[1]||"",L&&L[3]||""];return k&&(!B[0]&&B[1]||B[0]&&B[0].charAt(0)===".")&&(B=[B[0]+"."+B[1],""]),B}function h(p){const k=p?w.exec(p):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function b(p,k,L){const B=p.compare(k,L);return B!==0?B:k.length!==L.length?k.length<L.length?-1:1:0}function o(p){const k=p.charAt(0);return k.toLocaleUpperCase()!==k}function r(p){const k=p.charAt(0);return k.toLocaleLowerCase()!==k}function c(p,k){return o(p)&&r(k)?-1:r(p)&&o(k)?1:0}function u(p,k){return r(p)&&o(k)?-1:o(p)&&r(k)?1:0}function i(p,k,L=!1){return L||(p=p&&p.toLowerCase(),k=k&&k.toLowerCase()),p===k?0:p<k?-1:1}function s(p,k,L=!1){const B=p.split(t.sep),K=k.split(t.sep),G=B.length-1,O=K.length-1;let U,F;for(let z=0;;z++){if(U=G===z,F=O===z,U&&F)return T(B[z],K[z],L);if(U)return-1;if(F)return 1;const M=i(B[z],K[z],L);if(M!==0)return M}}e.comparePaths=s;function n(p,k,L){const B=p.toLowerCase(),K=k.toLowerCase(),G=l(p,k,L);if(G)return G;const O=B.endsWith(L),U=K.endsWith(L);if(O!==U)return O?-1:1;const F=T(B,K);return F!==0?F:B.localeCompare(K)}e.compareAnything=n;function l(p,k,L){const B=p.toLowerCase(),K=k.toLowerCase(),G=B.startsWith(L),O=K.startsWith(L);if(G!==O)return G?-1:1;if(G&&O){if(B.length<K.length)return-1;if(B.length>K.length)return 1}return 0}e.compareByPrefix=l}),define(Se[106],ye([1,0,105,103,85,9,11,8]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,C=[S,[]];function R(M,V,q,H){if(!M||!V)return C;const Q=M.length,Y=V.length;if(Q<Y)return C;const ce=M.toLowerCase();return P(V,q,Y,M,ce,Q,H)}e.scoreFuzzy=R;function P(M,V,q,H,Q,Y,ce){const ie=[],fe=[];for(let Ie=0;Ie<q;Ie++){const Re=Ie*Y,ze=Re-Y,re=Ie>0,ue=M[Ie],de=V[Ie];for(let Z=0;Z<Y;Z++){const se=Z>0,ne=Re+Z,N=ne-1,$=ze+Z-1,x=se?ie[N]:0,_=re&&se?ie[$]:0,le=re&&se?fe[$]:0;let be;!_&&re?be=0:be=E(ue,de,H,Q,Z,le),be&&_+be>=x&&(ce||re||Q.startsWith(V,Z))?(fe[ne]=le+1,ie[ne]=_+be):(fe[ne]=S,ie[ne]=x)}}const J=[];let pe=q-1,we=Y-1;for(;pe>=0&&we>=0;){const Ie=pe*Y+we;fe[Ie]===S||(J.push(we),pe--),we--}return[ie[q*Y-1],J.reverse()]}function E(M,V,q,H,Q,Y){let ce=0;if(!y(V,H[Q]))return ce;if(ce+=1,Y>0&&(ce+=Y*5),M===q[Q]&&(ce+=1),Q===0)ce+=8;else{const ie=v(q.charCodeAt(Q-1));ie?ce+=ie:(0,t.isUpper)(q.charCodeAt(Q))&&Y===0&&(ce+=2)}return ce}function y(M,V){return M===V?!0:M==="/"||M==="\\"?V==="/"||V==="\\":!1}function v(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function g(M,V,q=0,H=0){const Q=V;return Q.values&&Q.values.length>1?m(M,Q.values,q,H):w(M,V,q,H)}e.scoreFuzzy2=g;function m(M,V,q,H){let Q=0;const Y=[];for(const ce of V){const[ie,fe]=w(M,ce,q,H);if(typeof ie!="number")return d;Q+=ie,Y.push(...fe)}return[Q,l(Y)]}function w(M,V,q,H){const Q=(0,t.fuzzyScore)(V.original,V.originalLowercase,q,M,M.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:d}const f=Object.freeze({score:0}),h=1<<18,b=1<<17,o=1<<16;function r(M,V,q,H){const Q=H.values?H.values:[H];return(0,I.hash)({[H.normalized]:{values:Q.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:M,description:V,allowNonContiguousMatches:q}})}function c(M,V,q,H,Q){if(!M||!V.normalized)return f;const Y=H.getItemLabel(M);if(!Y)return f;const ce=H.getItemDescription(M),ie=r(Y,ce,q,V),fe=Q[ie];if(fe)return fe;const J=u(Y,ce,H.getItemPath(M),V,q);return Q[ie]=J,J}e.scoreItemFuzzy=c;function u(M,V,q,H,Q){const Y=!q||!H.containsPathSeparator;return q&&(D.isLinux?H.pathNormalized===q:(0,T.equalsIgnoreCase)(H.pathNormalized,q))?{score:h,labelMatch:[{start:0,end:M.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:H.values&&H.values.length>1?i(M,V,q,H.values,Y,Q):s(M,V,q,H,Y,Q)}function i(M,V,q,H,Q,Y){let ce=0;const ie=[],fe=[];for(const J of H){const{score:pe,labelMatch:we,descriptionMatch:Ie}=s(M,V,q,J,Q,Y);if(pe===S)return f;ce+=pe,we&&ie.push(...we),Ie&&fe.push(...Ie)}return{score:ce,labelMatch:l(ie),descriptionMatch:l(fe)}}function s(M,V,q,H,Q,Y){if(Q||!V){const[ce,ie]=R(M,H.normalized,H.normalizedLowercase,Y&&!H.expectContiguousMatch);if(ce){const fe=(0,t.matchesPrefix)(H.normalized,M);let J;return fe?(J=b,J+=Math.round(H.normalized.length/M.length*100)):J=o,{score:J+ce,labelMatch:fe||n(ie)}}}if(V){let ce=V;q&&(ce=`${V}${A.sep}`);const ie=ce.length,fe=`${ce}${M}`,[J,pe]=R(fe,H.normalized,H.normalizedLowercase,Y&&!H.expectContiguousMatch);if(J){const we=n(pe),Ie=[],Re=[];return we.forEach(ze=>{ze.start<ie&&ze.end>ie?(Ie.push({start:0,end:ze.end-ie}),Re.push({start:ze.start,end:ie})):ze.start>=ie?Ie.push({start:ze.start-ie,end:ze.end-ie}):Re.push(ze)}),{score:J,labelMatch:Ie,descriptionMatch:Re}}}return f}function n(M){const V=[];if(!M)return V;let q;for(const H of M)q&&q.end===H?q.end+=1:(q={start:H,end:H+1},V.push(q));return V}function l(M){const V=M.sort((Q,Y)=>Q.start-Y.start),q=[];let H;for(const Q of V)!H||!p(H,Q)?(H=Q,q.push(Q)):(H.start=Math.min(H.start,Q.start),H.end=Math.max(H.end,Q.end));return q}function p(M,V){return!(M.end<V.start||V.end<M.start)}function k(M,V,q,H,Q,Y){const ce=c(M,q,H,Q,Y),ie=c(V,q,H,Q,Y),fe=ce.score,J=ie.score;if((fe===h||J===h)&&fe!==J)return fe===h?-1:1;if(fe>o||J>o){if(fe!==J)return fe>J?-1:1;if(fe<b&&J<b){const ue=B(ce.labelMatch,ie.labelMatch);if(ue!==0)return ue}const ze=Q.getItemLabel(M)||"",re=Q.getItemLabel(V)||"";if(ze.length!==re.length)return ze.length-re.length}if(fe!==J)return fe>J?-1:1;const pe=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,we=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(pe&&!we)return-1;if(we&&!pe)return 1;const Ie=L(M,ce,Q),Re=L(V,ie,Q);return Ie&&Re&&Ie!==Re?Re>Ie?-1:1:K(M,V,q,Q)}e.compareItemsByFuzzyScore=k;function L(M,V,q){let H=-1,Q=-1;if(V.descriptionMatch&&V.descriptionMatch.length?H=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(H=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(Q=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const Y=q.getItemDescription(M);Y&&(Q+=Y.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(Q=V.descriptionMatch[V.descriptionMatch.length-1].end);return Q-H}function B(M,V){if(!M&&!V||(!M||!M.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!M||!M.length)return 1;const q=M[0].start,Q=M[M.length-1].end-q,Y=V[0].start,ie=V[V.length-1].end-Y;return Q===ie?0:ie<Q?1:-1}function K(M,V,q,H){const Q=H.getItemLabel(M)||"",Y=H.getItemLabel(V)||"",ce=H.getItemDescription(M),ie=H.getItemDescription(V),fe=Q.length+(ce?ce.length:0),J=Y.length+(ie?ie.length:0);if(fe!==J)return fe-J;const pe=H.getItemPath(M),we=H.getItemPath(V);return pe&&we&&pe.length!==we.length?pe.length-we.length:Q!==Y?(0,a.compareAnything)(Q,Y,q.normalized):ce&&ie&&ce!==ie?(0,a.compareAnything)(ce,ie,q.normalized):pe&&we&&pe!==we?(0,a.compareAnything)(pe,we,q.normalized):0}function G(M){return M.startsWith('"')&&M.endsWith('"')}const O=" ";function U(M){typeof M!="string"&&(M="");const V=M.toLowerCase(),{pathNormalized:q,normalized:H,normalizedLowercase:Q}=F(M),Y=q.indexOf(A.sep)>=0,ce=G(M);let ie;const fe=M.split(O);if(fe.length>1)for(const J of fe){const pe=G(J),{pathNormalized:we,normalized:Ie,normalizedLowercase:Re}=F(J);Ie&&(ie||(ie=[]),ie.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:we,normalized:Ie,normalizedLowercase:Re,expectContiguousMatch:pe}))}return{original:M,originalLowercase:V,pathNormalized:q,normalized:H,normalizedLowercase:Q,values:ie,containsPathSeparator:Y,expectContiguousMatch:ce}}e.prepareQuery=U;function F(M){let V;D.isWindows?V=M.replace(/\//g,A.sep):V=M.replace(/\\/g,A.sep);const q=(0,T.stripWildcards)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:q,normalizedLowercase:q.toLowerCase()}}function z(M){return Array.isArray(M)?U(M.map(V=>V.original).join(O)):U(M.original)}e.pieceToQuery=z}),define(Se[36],ye([1,0,17,18,32,28,9,11,8]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",P="[^/\\\\]",E=/\//g;function y(q,H){switch(q){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}${H?`|${R}${P}+`:""})*?`}}function v(q,H){if(!q)return[];const Q=[];let Y=!1,ce=!1,ie="";for(const fe of q){switch(fe){case H:if(!Y&&!ce){Q.push(ie),ie="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ie+=fe}return ie&&Q.push(ie),Q}e.splitGlobAware=v;function d(q){if(!q)return"";let H="";const Q=v(q,e.GLOB_SPLIT);if(Q.every(Y=>Y===e.GLOBSTAR))H=".*";else{let Y=!1;Q.forEach((ce,ie)=>{if(ce===e.GLOBSTAR){if(Y)return;H+=y(2,ie===Q.length-1)}else{let fe=!1,J="",pe=!1,we="";for(const Ie of ce){if(Ie!=="}"&&fe){J+=Ie;continue}if(pe&&(Ie!=="]"||!we)){let Re;Ie==="-"?Re=Ie:(Ie==="^"||Ie==="!")&&!we?Re="^":Ie===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(Ie),we+=Re;continue}switch(Ie){case"{":fe=!0;continue;case"[":pe=!0;continue;case"}":{H+=`(?:${v(J,",").map(re=>d(re)).join("|")})`,fe=!1,J="";break}case"]":{H+="["+we+"]",pe=!1,we="";break}case"?":H+=P;continue;case"*":H+=y(1);continue;default:H+=(0,S.escapeRegExpCharacters)(Ie)}}ie<Q.length-1&&(Q[ie+1]!==e.GLOBSTAR||ie+2<Q.length)&&(H+=R)}Y=ce===e.GLOBSTAR})}return H}const g=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new A.LRUCache(1e4),r=function(){return!1},c=function(){return null};function u(q,H){if(!q)return c;let Q;typeof q!="string"?Q=q.pattern:Q=q,Q=Q.trim();const Y=`${Q}_${!!H.trimForExclusions}`;let ce=o.get(Y);if(ce)return i(ce,q);let ie;return g.test(Q)?ce=n(Q.substr(4),Q):(ie=m.exec(s(Q,H)))?ce=l(ie[1],Q):(H.trimForExclusions?f:w).test(Q)?ce=p(Q,H):(ie=h.exec(s(Q,H)))?ce=k(ie[1].substr(1),Q,!0):(ie=b.exec(s(Q,H)))?ce=k(ie[1],Q,!1):ce=L(Q),o.set(Y,ce),i(ce,q)}function i(q,H){if(typeof H=="string")return q;const Q=function(Y,ce){return(0,I.isEqualOrParent)(Y,H.base,!T.isLinux)?q((0,S.ltrim)(Y.substr(H.base.length),D.sep),ce):null};return Q.allBasenames=q.allBasenames,Q.allPaths=q.allPaths,Q.basenames=q.basenames,Q.patterns=q.patterns,Q}function s(q,H){return H.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function n(q,H){return function(Q,Y){return typeof Q=="string"&&Q.endsWith(q)?H:null}}function l(q,H){const Q=`/${q}`,Y=`\\${q}`,ce=function(fe,J){return typeof fe!="string"?null:J?J===q?H:null:fe===q||fe.endsWith(Q)||fe.endsWith(Y)?H:null},ie=[q];return ce.basenames=ie,ce.patterns=[H],ce.allBasenames=ie,ce}function p(q,H){const Q=M(q.slice(1,-1).split(",").map(J=>u(J,H)).filter(J=>J!==c),q),Y=Q.length;if(!Y)return c;if(Y===1)return Q[0];const ce=function(J,pe){for(let we=0,Ie=Q.length;we<Ie;we++)if(Q[we](J,pe))return q;return null},ie=Q.find(J=>!!J.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const fe=Q.reduce((J,pe)=>pe.allPaths?J.concat(pe.allPaths):J,[]);return fe.length&&(ce.allPaths=fe),ce}function k(q,H,Q){const Y=D.sep===D.posix.sep,ce=Y?q:q.replace(E,D.sep),ie=D.sep+ce,fe=D.posix.sep+q;let J;return Q?J=function(pe,we){return typeof pe=="string"&&(pe===ce||pe.endsWith(ie)||!Y&&(pe===q||pe.endsWith(fe)))?H:null}:J=function(pe,we){return typeof pe=="string"&&(pe===ce||!Y&&pe===q)?H:null},J.allPaths=[(Q?"*/":"./")+q],J}function L(q){try{const H=new RegExp(`^${d(q)}$`);return function(Q){return H.lastIndex=0,typeof Q=="string"&&H.test(Q)?q:null}}catch{return c}}function B(q,H,Q){return!q||typeof H!="string"?!1:K(q)(H,void 0,Q)}e.match=B;function K(q,H={}){if(!q)return r;if(typeof q=="string"||G(q)){const Q=u(q,H);if(Q===c)return r;const Y=function(ce,ie){return!!Q(ce,ie)};return Q.allBasenames&&(Y.allBasenames=Q.allBasenames),Q.allPaths&&(Y.allPaths=Q.allPaths),Y}return F(q,H)}e.parse=K;function G(q){const H=q;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=G;function O(q){return q.allBasenames||[]}e.getBasenameTerms=O;function U(q){return q.allPaths||[]}e.getPathTerms=U;function F(q,H){const Q=M(Object.getOwnPropertyNames(q).map(J=>z(J,q[J],H)).filter(J=>J!==c)),Y=Q.length;if(!Y)return c;if(!Q.some(J=>!!J.requiresSiblings)){if(Y===1)return Q[0];const J=function(Ie,Re){let ze;for(let re=0,ue=Q.length;re<ue;re++){const de=Q[re](Ie,Re);if(typeof de=="string")return de;(0,t.isThenable)(de)&&(ze||(ze=[]),ze.push(de))}return ze?(async()=>{for(const re of ze){const ue=await re;if(typeof ue=="string")return ue}return null})():null},pe=Q.find(Ie=>!!Ie.allBasenames);pe&&(J.allBasenames=pe.allBasenames);const we=Q.reduce((Ie,Re)=>Re.allPaths?Ie.concat(Re.allPaths):Ie,[]);return we.length&&(J.allPaths=we),J}const ce=function(J,pe,we){let Ie,Re;for(let ze=0,re=Q.length;ze<re;ze++){const ue=Q[ze];ue.requiresSiblings&&we&&(pe||(pe=(0,D.basename)(J)),Ie||(Ie=pe.substr(0,pe.length-(0,D.extname)(J).length)));const de=ue(J,pe,Ie,we);if(typeof de=="string")return de;(0,t.isThenable)(de)&&(Re||(Re=[]),Re.push(de))}return Re?(async()=>{for(const ze of Re){const re=await ze;if(typeof re=="string")return re}return null})():null},ie=Q.find(J=>!!J.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const fe=Q.reduce((J,pe)=>pe.allPaths?J.concat(pe.allPaths):J,[]);return fe.length&&(ce.allPaths=fe),ce}function z(q,H,Q){if(H===!1)return c;const Y=u(q,Q);if(Y===c)return c;if(typeof H=="boolean")return Y;if(H){const ce=H.when;if(typeof ce=="string"){const ie=(fe,J,pe,we)=>{if(!we||!Y(fe,J))return null;const Ie=ce.replace("$(basename)",pe),Re=we(Ie);return(0,t.isThenable)(Re)?Re.then(ze=>ze?q:null):Re?q:null};return ie.requiresSiblings=!0,ie}}return Y}function M(q,H){const Q=q.filter(J=>!!J.basenames);if(Q.length<2)return q;const Y=Q.reduce((J,pe)=>{const we=pe.basenames;return we?J.concat(we):J},[]);let ce;if(H){ce=[];for(let J=0,pe=Y.length;J<pe;J++)ce.push(H)}else ce=Q.reduce((J,pe)=>{const we=pe.patterns;return we?J.concat(we):J},[]);const ie=function(J,pe){if(typeof J!="string")return null;if(!pe){let Ie;for(Ie=J.length;Ie>0;Ie--){const Re=J.charCodeAt(Ie-1);if(Re===47||Re===92)break}pe=J.substr(Ie)}const we=Y.indexOf(pe);return we!==-1?ce[we]:null};ie.basenames=Y,ie.patterns=ce,ie.allBasenames=Y;const fe=q.filter(J=>!J.basenames);return fe.push(ie),fe}function V(q,H){return(0,a.equals)(q,H,(Q,Y)=>typeof Q=="string"&&typeof Y=="string"?Q===Y:typeof Q!="string"&&typeof Y!="string"?Q.base===Y.base&&Q.pattern===Y.pattern:!1)}e.patternsEquals=V}),define(Se[107],ye([1,0,10,148,24,8,2]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(m="",w=!1){if(this.value=m,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(m,w=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(f,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,w){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}appendLink(m,w,f){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(m),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(m,w){const f=new RegExp((0,A.escapeRegExpCharacters)(w),"g");return m.replace(f,(h,b)=>m.charAt(b-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=S;function C(g){return R(g)?!g.value:Array.isArray(g)?g.every(C):!0}e.isEmptyMarkdownString=C;function R(g){return g instanceof S?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function P(g,m){return g===m?!0:!g||!m?!1:g.value===m.value&&g.isTrusted===m.isTrusted&&g.supportThemeIcons===m.supportThemeIcons&&g.supportHtml===m.supportHtml&&(g.baseUri===m.baseUri||!!g.baseUri&&!!m.baseUri&&(0,I.isEqual)(D.URI.from(g.baseUri),D.URI.from(m.baseUri)))}e.markdownStringEqual=P;function E(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function y(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=y;function v(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function d(g){const m=[],w=g.split("|").map(h=>h.trim());g=w[0];const f=w[1];if(f){const h=/height=(\d+)/.exec(f),b=/width=(\d+)/.exec(f),o=h?h[1]:"",r=b?b[1]:"",c=isFinite(parseInt(r)),u=isFinite(parseInt(o));c&&m.push(`width="${r}"`),u&&m.push(`height="${o}"`)}return{href:g,dimensions:m}}e.parseHrefAndDimensions=d}),define(Se[108],ye([1,0,17,32,9,11,24,8]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(c,u){const{os:i,tildify:s,relative:n}=u;if(n){const k=C(c,n,i);if(typeof k=="string")return k}let l=c.fsPath;if(i===1&&!A.isWindows?l=l.replace(/\//g,"\\"):i!==1&&A.isWindows&&(l=l.replace(/\\/g,"/")),i!==1&&s?.userHome){const k=s.userHome.fsPath;let L;c.scheme!==s.userHome.scheme&&c.path.startsWith(I.posix.sep)?L=s.userHome.with({path:c.path}).fsPath:L=c.fsPath,l=E(L,k,i)}return(i===1?I.win32:I.posix).normalize(R(l,i===1))}e.getPathLabel=S;function C(c,u,i){const s=i===1?I.win32:I.posix,n=i===3?D.extUri:D.extUriIgnorePathCase,l=u.getWorkspace(),p=(0,a.firstOrDefault)(l.folders);if(!p)return;c.scheme!==p.uri.scheme&&c.path.startsWith(I.posix.sep)&&(c=p.uri.with({path:c.path}));const k=u.getWorkspaceFolder(c);if(!k)return;let L;if(n.isEqual(k.uri,c)?L="":L=n.relativePath(k.uri,c)??"",L&&(L=s.normalize(L)),l.folders.length>1&&!u.noPrefix){const B=k.name?k.name:n.basenameOrAuthority(k.uri);L=L?`${B} \u2022 ${L}`:B}return L}function R(c,u=A.isWindows){return(0,t.hasDriveLetter)(c,u)?c.charAt(0).toUpperCase()+c.slice(1):c}e.normalizeDriveLetter=R;let P=Object.create(null);function E(c,u,i=A.OS){if(i===1||!c||!u)return c;let s=P.original===u?P.normalized:void 0;s||(s=u,A.isWindows&&(s=(0,t.toSlashes)(s)),s=`${(0,T.rtrim)(s,I.posix.sep)}${I.posix.sep}`,P={original:u,normalized:s});let n=c;return A.isWindows&&(n=(0,t.toSlashes)(n)),(i===3?n.startsWith(s):(0,T.startsWithIgnoreCase)(n,s))?`~/${n.substr(s.length)}`:c}e.tildify=E;function y(c,u){return c.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=y;const v="\u2026",d="\\\\",g="~";function m(c,u=I.sep){const i=new Array(c.length);let s=!1;for(let n=0;n<c.length;n++){const l=c[n];if(l===""){i[n]=`.${u}`;continue}if(!l){i[n]=l;continue}s=!0;let p="",k=l;k.indexOf(d)===0?(p=k.substr(0,k.indexOf(d)+d.length),k=k.substr(k.indexOf(d)+d.length)):k.indexOf(u)===0?(p=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(g)===0&&(p=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length));const L=k.split(u);for(let B=1;s&&B<=L.length;B++)for(let K=L.length-B;s&&K>=0;K--){s=!1;let G=L.slice(K,K+B).join(u);for(let O=0;!s&&O<c.length;O++)if(O!==n&&c[O]&&c[O].indexOf(G)>-1){const U=K+B===L.length,F=K>0&&c[O].indexOf(u)>-1?u+G:G,z=c[O].endsWith(F);s=!U||z}if(!s){let O="";(L[0].endsWith(":")||p!=="")&&(K===1&&(K=0,B++,G=L[0]+u+G),K>0&&(O=L[0]+u),O=p+O),K>0&&(O=O+v+u),O=O+G,K+B<L.length&&(O=O+u+v),i[n]=O}}s&&(i[n]=l)}return i}e.shorten=m;var w;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function f(c,u=Object.create(null)){const i=[];let s=!1,n="";for(const l of c)if(l==="$"||s&&l==="{")n&&i.push({value:n,type:w.TEXT}),n="",s=!0;else if(l==="}"&&s){const p=u[n];if(typeof p=="string")p.length&&i.push({value:p,type:w.VARIABLE});else if(p){const k=i[i.length-1];(!k||k.type!==w.SEPARATOR)&&i.push({value:p.label,type:w.SEPARATOR})}n="",s=!1}else n+=l;return n&&!s&&i.push({value:n,type:w.TEXT}),i.filter((l,p)=>{if(l.type===w.SEPARATOR){const k=i[p-1],L=i[p+1];return[k,L].every(B=>B&&(B.type===w.VARIABLE||B.type===w.TEXT)&&B.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=f;function h(c,u){return A.isMacintosh||u?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):c.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function b(c,u){return A.isMacintosh||u?c.replace(/\(&&\w\)|&&/g,""):A.isWindows?c.replace(/&&|&/g,i=>i==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function o(c){return c.replace(/&/g,"&&")}e.unmnemonicLabel=o;function r(c){const u=c.indexOf("/")!==-1?I.posix:I.win32,i=u.basename(c),s=u.dirname(c);return i.length?{name:i,parentPath:s}:{name:s,parentPath:""}}e.splitName=r}),define(Se[109],ye([1,0,2]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class I{constructor(P){this.a=P}transformIncoming(P){const E=this.a.transformIncoming(P);return E===P?P:t(a.URI.from(E))}transformOutgoing(P){const E=this.a.transformOutgoing(P);return E===P?P:t(a.URI.from(E))}transformOutgoingURI(P){const E=this.a.transformOutgoing(P);return E===P?P:a.URI.from(E)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function A(R,P,E){if(!R||E>200)return null;if(typeof R=="object"){if(R instanceof a.URI)return P.transformOutgoing(R);for(const y in R)if(Object.hasOwnProperty.call(R,y)){const v=A(R[y],P,E+1);v!==null&&(R[y]=v)}}return null}function D(R,P){const E=A(R,P,0);return E===null?R:E}e.transformOutgoingURIs=D;function T(R,P,E,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return E?a.URI.revive(P.transformIncoming(R)):P.transformIncoming(R);for(const v in R)if(Object.hasOwnProperty.call(R,v)){const d=T(R[v],P,E,y+1);d!==null&&(R[v]=d)}}return null}function S(R,P){const E=T(R,P,!1,0);return E===null?R:E}e.transformIncomingURIs=S;function C(R,P){const E=T(R,P,!0,0);return E===null?R:E}e.transformAndReviveIncomingURIs=C}),define(Se[30],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(I){return a.test(I)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const A=new Uint8Array(16),D=[];for(let T=0;T<256;T++)D.push(T.toString(16).padStart(2,"0"));return function(){I(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,C="";return C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C}}()}),define(Se[149],ye([1,0,17,30]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function I(T){return{id:(0,t.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=I;function A(T,S,C){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:S,data:C}),value:void 0}}e.createFileDataTransferItem=A;class D{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,C){const R=this.a.get(S);R?R.push(C):this.a.set(this.b(S),[C])}replace(S,C){this.a.set(this.b(S),[C])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,C]of this.a.entries())for(const R of C)yield[S,R]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[C,R]of this.entries())S(R,C)}b(S){return S.toLowerCase()}}e.VSDataTransfer=D,e.UriList=Object.freeze({create:T=>(0,a.distinct)(T.map(S=>S.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(S=>!S.startsWith("#"))})}),define(Se[29],ye([1,0,50,66,308,18,32,83,9,11,24,2]),function(ee,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function y(F,z=E.UNLINK){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return z===E.UNLINK?d(F):v(F)}async function v(F){try{const z=(0,D.randomPath)((0,t.tmpdir)());try{await a.promises.rename(F,z)}catch(M){return M.code==="ENOENT"?void 0:d(F)}d(z).catch(M=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function d(F){return(0,I.promisify)(a.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function m(F,z){return h(await(z?w(F):(0,I.promisify)(a.readdir)(F)))}async function w(F){try{return await(0,I.promisify)(a.readdir)(F,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const z=[],M=await m(F);for(const V of M){let q=!1,H=!1,Q=!1;try{const Y=await e.Promises.lstat((0,S.join)(F,V));q=Y.isFile(),H=Y.isDirectory(),Q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}z.push({name:V,isFile:()=>q,isDirectory:()=>H,isSymbolicLink:()=>Q})}return z}function f(F){return h(a.readdirSync(F))}e.readdirSync=f;function h(F){return F.map(z=>typeof z=="string"?C.isMacintosh?(0,T.normalizeNFC)(z):z:(z.name=C.isMacintosh?(0,T.normalizeNFC)(z.name):z.name,z))}async function b(F){const z=await m(F),M=[];for(const V of z)await r.existsDirectory((0,S.join)(F,V))&&M.push(V);return M}function o(F,z=1e3){return new Promise(M=>{let V=!1;const q=setInterval(()=>{V||(V=!0,a.access(F,H=>{V=!1,H&&(clearInterval(q),M(void 0))}))},z)})}e.whenDeleted=o;var r;(function(F){async function z(q){let H;try{if(H=await e.Promises.lstat(q),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(C.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw Y}throw Q}}F.stat=z;async function M(q){try{const{stat:H,symbolicLink:Q}=await F.stat(q);return H.isFile()&&Q?.dangling!==!0}catch{}return!1}F.existsFile=M;async function V(q){try{const{stat:H,symbolicLink:Q}=await F.stat(q);return H.isDirectory()&&Q?.dangling!==!0}catch{}return!1}F.existsDirectory=V})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const c=new A.ResourceQueue;function u(F,z,M){return c.queueFor(P.URI.file(F),R.extUriBiasedIgnorePathCase).queue(()=>{const V=p(M);return new Promise((q,H)=>n(F,z,V,Q=>Q?H(Q):q()))})}let i=!0;function s(F){i=F}e.configureFlushOnWrite=s;function n(F,z,M,V){if(!i)return a.writeFile(F,z,{mode:M.mode,flag:M.flag},V);a.open(F,M.flag,M.mode,(q,H)=>{if(q)return V(q);a.writeFile(H,z,Q=>{if(Q)return a.close(H,()=>V(Q));a.fdatasync(H,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),s(!1)),a.close(H,ce=>V(ce))))})})}function l(F,z,M){const V=p(M);if(!i)return a.writeFileSync(F,z,{mode:V.mode,flag:V.flag});const q=a.openSync(F,V.flag,V.mode);try{a.writeFileSync(q,z);try{a.fdatasyncSync(q)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),s(!1)}}finally{a.closeSync(q)}}e.writeFileSync=l;function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function k(F,z){if(F!==z)try{await e.Promises.rename(F,z)}catch(M){if(F.toLowerCase()!==z.toLowerCase()&&M.code==="EXDEV"||F.endsWith("."))await L(F,z,{preserveSymlinks:!1}),await y(F,E.MOVE);else throw M}}async function L(F,z,M){return K(F,z,{root:{source:F,target:z},options:M,handledSourcePaths:new Set})}const B=511;async function K(F,z,M){if(M.handledSourcePaths.has(F))return;M.handledSourcePaths.add(F);const{stat:V,symbolicLink:q}=await r.stat(F);if(q){if(M.options.preserveSymlinks)try{return await U(F,z,M)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(q.dangling)return}return V.isDirectory()?G(F,z,V.mode&B,M):O(F,z,V.mode&B)}async function G(F,z,M,V){await e.Promises.mkdir(z,{recursive:!0,mode:M});const q=await m(F);for(const H of q)await K((0,S.join)(F,H),(0,S.join)(z,H),V)}async function O(F,z,M){await e.Promises.copyFile(F,z),await e.Promises.chmod(z,M)}async function U(F,z,M){let V=await e.Promises.readlink(F);(0,D.isEqualOrParent)(V,M.root.source,!C.isLinux)&&(V=(0,S.join)(M.root.target,V.substr(M.root.source.length+1))),await e.Promises.symlink(V,z)}e.Promises=new class{get access(){return(0,I.promisify)(a.access)}get stat(){return(0,I.promisify)(a.stat)}get lstat(){return(0,I.promisify)(a.lstat)}get utimes(){return(0,I.promisify)(a.utimes)}get read(){return(F,z,M,V,q)=>new Promise((H,Q)=>{a.read(F,z,M,V,q,(Y,ce,ie)=>Y?Q(Y):H({bytesRead:ce,buffer:ie}))})}get readFile(){return(0,I.promisify)(a.readFile)}get write(){return(F,z,M,V,q)=>new Promise((H,Q)=>{a.write(F,z,M,V,q,(Y,ce,ie)=>Y?Q(Y):H({bytesWritten:ce,buffer:ie}))})}get appendFile(){return(0,I.promisify)(a.appendFile)}get fdatasync(){return(0,I.promisify)(a.fdatasync)}get truncate(){return(0,I.promisify)(a.truncate)}get rename(){return(0,I.promisify)(a.rename)}get copyFile(){return(0,I.promisify)(a.copyFile)}get open(){return(0,I.promisify)(a.open)}get close(){return(0,I.promisify)(a.close)}get symlink(){return(0,I.promisify)(a.symlink)}get readlink(){return(0,I.promisify)(a.readlink)}get chmod(){return(0,I.promisify)(a.chmod)}get mkdir(){return(0,I.promisify)(a.mkdir)}get unlink(){return(0,I.promisify)(a.unlink)}get rmdir(){return(0,I.promisify)(a.rmdir)}get realpath(){return(0,I.promisify)(a.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return b}get writeFile(){return u}get rm(){return y}get move(){return k}get copy(){return L}}}),define(Se[110],ye([1,0,50,9,11,8,29]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(E){if(I.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const g=(0,D.readdirSync)(y).filter(m=>m.toLowerCase()===v);if(g.length===1){const m=T(y);if(m)return(0,t.join)(m,g[0])}else if(g.length>1){const m=g.indexOf(v);if(m>=0){const w=T(y);if(w)return(0,t.join)(w,g[m])}}}catch{}return null}e.realcaseSync=T;async function S(E){if(I.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const g=(await D.Promises.readdir(y)).filter(m=>m.toLowerCase()===v);if(g.length===1){const m=await S(y);if(m)return(0,t.join)(m,g[0])}else if(g.length>1){const m=g.indexOf(v);if(m>=0){const w=await S(y);if(w)return(0,t.join)(w,g[m])}}}catch{}return null}e.realcase=S;async function C(E){try{return await D.Promises.realpath(E)}catch{const v=P(E);return await D.Promises.access(v,a.constants.R_OK),v}}e.realpath=C;function R(E){try{return a.realpathSync(E)}catch{const v=P(E);return a.accessSync(v,a.constants.R_OK),v}}e.realpathSync=R;function P(E){return(0,A.rtrim)((0,t.normalize)(E),t.sep)}}),define(Se[111],ye([1,0,9,11,35,101,12,29]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(P=I.env){return P.comspec||"cmd.exe"}e.getWindowsShell=S;function C(P){let E=[],y=!1;const v=function(d){if(y){E.push(d);return}(!P.send(d,m=>{if(m&&console.error(m),y=!1,E.length>0){const w=E.slice(0);E=[],w.forEach(f=>v(f))}})||t.isWindows)&&(y=!0)};return{send:v}}e.createQueuedSender=C;var R;(function(P){async function E(y,v,d){if(a.isAbsolute(y))return y;if(v===void 0&&(v=I.cwd()),a.dirname(y)!=="."||(d===void 0&&D.isString(I.env.PATH)&&(d=I.env.PATH.split(a.delimiter)),d===void 0||d.length===0))return a.join(v,y);async function m(w){if(await T.Promises.exists(w)){let f;try{f=await T.Promises.stat(w)}catch(h){h.message.startsWith("EACCES")&&(f=await T.Promises.lstat(w))}return f?!f.isDirectory():!1}return!1}for(const w of d){let f;if(a.isAbsolute(w)?f=a.join(w,y):f=a.join(v,w,y),await m(f))return f;let h=f+".com";if(await m(h)||(h=f+".exe",await m(h)))return h}return a.join(v,y)}P.findExecutable=E})(R=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ee,e,a,t){var I=arguments.length,A=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ee,e,a,t);else for(var T=ee.length-1;T>=0;T--)(D=ee[T])&&(A=(I<3?D(A):I>3?D(e,a,A):D(e,a))||A);return I>3&&A&&Object.defineProperty(e,a,A),A};define(Se[112],ye([1,0,17,18,22,21,61,10,4,6,86,8,12]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y||(y={}));function v(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(d||(d={}));function g(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(m||(m={}));class w{constructor(H){this.b=H,this.a=0}read(H){const Q=this.b.slice(this.a,this.a+H);return this.a+=Q.byteLength,Q}}class f{constructor(){this.a=[]}get buffer(){return I.VSBuffer.concat(this.a)}write(H){this.a.push(H)}}var h;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(h||(h={}));function b(q){const H=I.VSBuffer.alloc(4);return H.writeUInt32BE(q,0),H}function o(q){return q.read(4).readUInt32BE(0)}function r(q){const H=I.VSBuffer.alloc(1);return H.writeUInt8(q,0),H}const c={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},u=typeof Buffer<"u";function i(q,H){if(typeof H>"u")q.write(c.Undefined);else if(typeof H=="string"){const Q=I.VSBuffer.fromString(H);q.write(c.String),q.write(b(Q.byteLength)),q.write(Q)}else if(u&&Buffer.isBuffer(H)){const Q=I.VSBuffer.wrap(H);q.write(c.Buffer),q.write(b(Q.byteLength)),q.write(Q)}else if(H instanceof I.VSBuffer)q.write(c.VSBuffer),q.write(b(H.byteLength)),q.write(H);else if(Array.isArray(H)){q.write(c.Array),q.write(b(H.length));for(const Q of H)i(q,Q)}else{const Q=I.VSBuffer.fromString(JSON.stringify(H));q.write(c.Object),q.write(b(Q.byteLength)),q.write(Q)}}function s(q){switch(q.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return q.read(o(q)).toString();case h.Buffer:return q.read(o(q)).buffer;case h.VSBuffer:return q.read(o(q));case h.Array:{const Q=o(q),Y=[];for(let ce=0;ce<Q;ce++)Y.push(s(q));return Y}case h.Object:return JSON.parse(q.read(o(q)).toString())}}class n{constructor(H,Q,Y=null,ce=1e3){this.h=H,this.j=Q,this.k=Y,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.p(ie)),this.m({type:200})}registerChannel(H,Q){this.b.set(H,Q),setTimeout(()=>this.v(H),0)}m(H){switch(H.type){case 200:{const Q=this.n([H.type]);this.k?.logOutgoing(Q,0,1,g(H.type));return}case 201:case 202:case 204:case 203:{const Q=this.n([H.type,H.id],H.data);this.k?.logOutgoing(Q,H.id,1,g(H.type),H.data);return}}}n(H,Q=void 0){const Y=new f;return i(Y,H),i(Y,Q),this.o(Y.buffer)}o(H){try{return this.h.send(H),H.byteLength}catch{return 0}}p(H){const Q=new w(H),Y=s(Q),ce=s(Q),ie=Y[0];switch(ie){case 100:return this.k?.logIncoming(H.byteLength,Y[1],1,`${v(ie)}: ${Y[2]}.${Y[3]}`,ce),this.q({type:ie,id:Y[1],channelName:Y[2],name:Y[3],arg:ce});case 102:return this.k?.logIncoming(H.byteLength,Y[1],1,`${v(ie)}: ${Y[2]}.${Y[3]}`,ce),this.s({type:ie,id:Y[1],channelName:Y[2],name:Y[3],arg:ce});case 101:return this.k?.logIncoming(H.byteLength,Y[1],1,`${v(ie)}`),this.t({type:ie,id:Y[1]});case 103:return this.k?.logIncoming(H.byteLength,Y[1],1,`${v(ie)}`),this.t({type:ie,id:Y[1]})}}q(H){const Q=this.b.get(H.channelName);if(!Q){this.u(H);return}const Y=new A.CancellationTokenSource;let ce;try{ce=Q.call(this.j,H.name,H.arg,Y.token)}catch(J){ce=Promise.reject(J)}const ie=H.id;ce.then(J=>{this.m({id:ie,data:J,type:201}),this.d.delete(H.id)},J=>{J instanceof Error?this.m({id:ie,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:ie,data:J,type:203}),this.d.delete(H.id)});const fe=(0,C.toDisposable)(()=>Y.cancel());this.d.set(H.id,fe)}s(H){const Q=this.b.get(H.channelName);if(!Q){this.u(H);return}const Y=H.id,ie=Q.listen(this.j,H.name,H.arg)(fe=>this.m({id:Y,data:fe,type:204}));this.d.set(H.id,ie)}t(H){const Q=this.d.get(H.id);Q&&(Q.dispose(),this.d.delete(H.id))}u(H){let Q=this.g.get(H.channelName);Q||(Q=[],this.g.set(H.channelName,Q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:H,timeoutTimer:Y})}v(H){const Q=this.g.get(H);if(Q){for(const Y of Q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.q(Y.request);break;case 102:this.s(Y.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,C.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var l;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(H,Q=null){this.l=H,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.r(Y)),this.j=Q}getChannel(H){const Q=this;return{call(Y,ce,ie){return Q.a?Promise.reject(new T.CancellationError):Q.m(H,Y,ce,ie)},listen(Y,ce){return Q.a?S.Event.None:Q.n(H,Y,ce)}}}m(H,Q,Y,ce=A.CancellationToken.None){const ie=this.g++,J={id:ie,type:100,channelName:H,name:Q,arg:Y};if(ce.isCancellationRequested)return Promise.reject(new T.CancellationError);let pe;return new Promise((Ie,Re)=>{if(ce.isCancellationRequested)return Re(new T.CancellationError);const ze=()=>{const Z=se=>{switch(se.type){case 201:this.f.delete(ie),Ie(se.data);break;case 202:{this.f.delete(ie);const ne=new Error(se.data.message);ne.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,ne.name=se.data.name,Re(ne);break}case 203:this.f.delete(ie),Re(se.data);break}};this.f.set(ie,Z),this.o(J)};let re=null;this.b===m.Idle?ze():(re=(0,t.createCancelablePromise)(Z=>this.t()),re.then(()=>{re=null,ze()}));const ue=()=>{re?(re.cancel(),re=null):this.o({id:ie,type:101}),Re(new T.CancellationError)},de=ce.onCancellationRequested(ue);pe=(0,C.combinedDisposable)((0,C.toDisposable)(ue),de),this.d.add(pe)}).finally(()=>{this.d.delete(pe)})}n(H,Q,Y){const ce=this.g++,fe={id:ce,type:102,channelName:H,name:Q,arg:Y};let J=null;const pe=new S.Emitter({onWillAddFirstListener:()=>{J=(0,t.createCancelablePromise)(Ie=>this.t()),J.then(()=>{J=null,this.d.add(pe),this.o(fe)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(pe),this.o({id:ce,type:103}))}}),we=Ie=>pe.fire(Ie.data);return this.f.set(ce,we),pe.event}o(H){switch(H.type){case 100:case 102:{const Q=this.p([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(Q,H.id,0,`${v(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const Q=this.p([H.type,H.id]);this.j?.logOutgoing(Q,H.id,0,v(H.type));return}}}p(H,Q=void 0){const Y=new f;return i(Y,H),i(Y,Q),this.q(Y.buffer)}q(H){try{return this.l.send(H),H.byteLength}catch{return 0}}r(H){const Q=new w(H),Y=s(Q),ce=s(Q),ie=Y[0];switch(ie){case 200:return this.j?.logIncoming(H.byteLength,0,0,g(ie)),this.s({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(H.byteLength,Y[1],0,g(ie),ce),this.s({type:Y[0],id:Y[1],data:ce})}}s(H){if(H.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}t(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,C.dispose)(this.d.values()),this.d.clear()}}qe([D.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class k{get connections(){const H=[];return this.f.forEach(Q=>H.push(Q)),H}constructor(H){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,H(({protocol:Q,onDidClientDisconnect:Y})=>{S.Event.once(Q.onMessage)(ie=>{const fe=new w(ie),J=s(fe),pe=new n(Q,J),we=new p(Q);this.a.forEach((Re,ze)=>pe.registerChannel(ze,Re));const Ie={channelServer:pe,channelClient:we,ctx:J};this.f.add(Ie),this.g.fire(Ie),Y(()=>{pe.dispose(),we.dispose(),this.f.delete(Ie),this.h.fire(Ie)})})})}getChannel(H,Q){const Y=this;return{call(ce,ie,fe){let J;if((0,E.isFunction)(Q)){const we=(0,a.getRandomElement)(Y.connections.filter(Q));J=we?Promise.resolve(we):S.Event.toPromise(S.Event.filter(Y.onDidAddConnection,Q))}else J=Q.routeCall(Y,ce,ie);const pe=J.then(we=>we.channelClient.getChannel(H));return B(pe).call(ce,ie,fe)},listen(ce,ie){if((0,E.isFunction)(Q))return Y.j(H,Q,ce,ie);const fe=Q.routeEvent(Y,ce,ie).then(J=>J.channelClient.getChannel(H));return B(fe).listen(ce,ie)}}}j(H,Q,Y,ce){const ie=this;let fe=new C.DisposableStore;const J=new S.Emitter({onWillAddFirstListener:()=>{fe=new C.DisposableStore;const pe=new S.EventMultiplexer,we=new Map,Ie=ze=>{const ue=ze.channelClient.getChannel(H).listen(Y,ce),de=pe.add(ue);we.set(ze,de)},Re=ze=>{const re=we.get(ze);!re||(re.dispose(),we.delete(ze))};ie.connections.filter(Q).forEach(Ie),S.Event.filter(ie.onDidAddConnection,Q)(Ie,void 0,fe),ie.onDidRemoveConnection(Re,void 0,fe),pe.event(J.fire,J,fe),fe.add(pe)},onDidRemoveLastListener:()=>{fe.dispose()}});return J.event}registerChannel(H,Q){this.a.set(H,Q),this.f.forEach(Y=>{Y.channelServer.registerChannel(H,Q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=k;class L{constructor(H,Q,Y=null){const ce=new f;i(ce,Q),H.send(ce.buffer),this.a=new p(H,Y),this.d=new n(H,Q,Y)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,Q){this.d.registerChannel(H,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=L;function B(q){return{call(H,Q,Y){return q.then(ce=>ce.call(H,Q,Y))},listen(H,Q){const Y=new S.Relay;return q.then(ce=>Y.input=ce.listen(H,Q)),Y.event}}}e.getDelayedChannel=B;function K(q){let H=!1;return{call(Q,Y,ce){return H?q.call(Q,Y,ce):(0,t.timeout)(0).then(()=>H=!0).then(()=>q.call(Q,Y,ce))},listen(Q,Y){if(H)return q.listen(Q,Y);const ce=new S.Relay;return(0,t.timeout)(0).then(()=>H=!0).then(()=>ce.input=q.listen(Q,Y)),ce.event}}}e.getNextTickChannel=K;class G{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const Q of H.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.StaticRouter=G;var O;(function(q){function H(ie,fe){const J=ie,pe=fe&&fe.disableMarshalling,we=new Map;for(const Ie in J)Y(Ie)&&we.set(Ie,S.Event.buffer(J[Ie],!0));return new class{listen(Ie,Re,ze){const re=we.get(Re);if(re)return re;if(ce(Re)){const ue=J[Re];if(typeof ue=="function")return ue.call(J,ze)}throw new Error(`Event not found: ${Re}`)}call(Ie,Re,ze){const re=J[Re];if(typeof re=="function"){if(!pe&&Array.isArray(ze))for(let ue=0;ue<ze.length;ue++)ze[ue]=(0,R.revive)(ze[ue]);return re.apply(J,ze)}throw new Error(`Method not found: ${Re}`)}}}q.fromService=H;function Q(ie,fe){const J=fe&&fe.disableMarshalling;return new Proxy({},{get(pe,we){if(typeof we=="string")return fe?.properties?.has(we)?fe.properties.get(we):ce(we)?function(Ie){return ie.listen(we,Ie)}:Y(we)?ie.listen(we):async function(...Ie){let Re;fe&&!(0,E.isUndefinedOrNull)(fe.context)?Re=[fe.context,...Ie]:Re=Ie;const ze=await ie.call(we,Re);return J?ze:(0,R.revive)(ze)};throw new Error(`Property not found: ${String(we)}`)}})}q.toService=Q;function Y(ie){return ie[0]==="o"&&ie[1]==="n"&&P.isUpperAsciiLetter(ie.charCodeAt(2))}function ce(ie){return/^onDynamic/.test(ie)&&P.isUpperAsciiLetter(ie.charCodeAt(9))}})(O=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const H=q.toString();if(H!=="[object Object]")return H}return q}function z(q){return Array.isArray(q)?q.map(F):F(q)}function M(q,H,Q,Y,ce,ie,fe){fe=z(fe);const J=U[ce],pe=J[Y%J.length];let we=[`%c[${q}]%c[${String(H).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(ie)?(we=we.concat(fe),we.push(")")):we.push(fe),console.log.apply(console,we)}class V{constructor(H,Q){this.d=H,this.f=Q,this.a=0,this.b=0}logOutgoing(H,Q,Y,ce,ie){this.b+=H,M(this.d,this.b,H,Q,Y,ce,ie)}logIncoming(H,Q,Y,ce,ie){this.a+=H,M(this.f,this.a,H,Q,Y,ce,ie)}}e.IPCLogger=V}),define(Se[113],ye([1,0,22,4,6,112]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(u){u.enableDiagnostics=!1,u.records=[];const i=new WeakMap;let s=0;function n(p,k){if(!i.has(p)){const L=String(++s);i.set(p,L)}return i.get(p)}function l(p,k,L,B){if(!u.enableDiagnostics)return;const K=n(p,k);if(B instanceof a.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const G=a.VSBuffer.alloc(B.byteLength);G.set(B),u.records.push({timestamp:Date.now(),id:K,label:k,type:L,buff:G})}else u.records.push({timestamp:Date.now(),id:K,label:k,type:L,data:B})}u.traceSocketEvent=l})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function R(){return C||(C=a.VSBuffer.alloc(0)),C}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,s){if(i===0)return R();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const k=this.a[0];return s&&(this.a.shift(),this.b-=i),k}if(this.a[0].byteLength>i){const k=this.a[0].slice(0,i);return s&&(this.a[0]=this.a[0].slice(i),this.b-=i),k}const n=a.VSBuffer.alloc(i);let l=0,p=0;for(;i>0;){const k=this.a[p];if(k.byteLength>i){const L=k.slice(0,i);n.set(L,l),l+=i,s&&(this.a[p]=k.slice(i),this.b-=i),i-=i}else n.set(k,l),l+=k.byteLength,s?(this.a.shift(),this.b-=k.byteLength):p++,i-=k.byteLength}return n}}e.ChunkStream=P;var E;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(E||(E={}));function y(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(i,s,n,l){this.type=i,this.id=s,this.ack=n,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends I.Disposable{constructor(i){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new P,this.B(this.a.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const s=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=s.readUInt32BE(9),this.g.messageType=s.readUInt8(0),this.g.id=s.readUInt32BE(1),this.g.ack=s.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const n=this.g.messageType,l=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",s),this.f.fire(new d(n,l,p,s)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=a.VSBuffer.alloc(13);s.writeUInt8(i.type,0),s.writeUInt32BE(i.id,1),s.writeUInt32BE(i.ack,5),s.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(s,i.data)}g(i,s){const n=this.f===0;return this.d.push(i,s),this.f+=i.byteLength+s.byteLength,n}h(){const i=a.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,s){this.g(i,s)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class w extends I.Disposable{constructor(i){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new m(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(s=>{s.type===1&&this.f.fire(s.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new d(1,0,0,i))}}e.Protocol=w;class f extends A.IPCClient{static fromSocket(i,s){return new f(new w(i),s)}get onDidDispose(){return this.b.onDidDispose}constructor(i,s,n=null){super(i,s,n),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.Client=f;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.BufferedEmitter=h;class b{constructor(i){this.data=i,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let i=0,s=this.a;for(;s;)s=s.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let s=0,n=this.a;for(;n;)i[s++]=n.data,n=n.next;return i}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const s=new b(i);if(!this.a){this.a=s,this.b=s;return}this.b.next=s,this.b=s}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let s=0;s<r.a;s++)this.c[s]=i-1e3*s;setInterval(()=>{for(let s=r.a;s>=1;s--)this.c[s]=this.c[s-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),s=(1+r.a)*1e3;let n=0;for(let l=0;l<r.a;l++)i-this.c[l]<=s&&n++;return 1-n/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class c{get unacknowledgedCount(){return this.c-this.d}constructor(i,s=null,n=r.getInstance()){this.t=new h,this.onControlMessage=this.t.event,this.u=new h,this.onMessage=this.u.event,this.v=new h,this.onDidDispose=this.v.event,this.w=new h,this.onSocketClose=this.w.event,this.x=new h,this.onSocketTimeout=this.x.event,this.s=n,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=i,this.p=new m(this.o),this.r.push(this.p),this.q=new g(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(l=>this.y(l))),this.r.push(this.o.onClose(l=>this.w.fire(l))),s&&this.q.acceptChunk(s),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,I.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const i=new d(5,0,0,R());this.p.write(i),this.p.flush()}sendPause(){const i=new d(7,0,0,R());this.p.write(i)}sendResume(){const i=new d(8,0,0,R());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,s){this.a=!0,this.r=(0,I.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=new m(this.o),this.r.push(this.p),this.q=new g(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(n=>this.y(n))),this.r.push(this.o.onClose(n=>this.w.fire(n))),this.q.acceptChunk(s)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new d(3,0,this.h,R());this.p.write(i);const s=this.b.toArray();for(let n=0,l=s.length;n<l;n++)this.p.write(s[n]);this.A()}acceptDisconnect(){this.v.fire()}y(i){if(i.ack>this.d){this.d=i.ack;do{const s=this.b.peek();if(s&&s.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const s=Date.now();s-this.m>1e4&&(this.m=s,this.p.write(new d(6,0,0,R())))}else this.g=i.id,this.j=Date.now(),this.z(),this.u.fire(i.data);break}case 2:{this.t.fire(i.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const s=this.b.toArray();for(let n=0,l=s.length;n<l;n++)this.p.write(s[n]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const s=++this.c;this.h=this.g;const n=new d(1,s,this.h,i);this.b.push(n),this.a||(this.p.write(n),this.A())}sendControl(i){const s=new d(2,0,0,i);this.p.write(s)}z(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-i+5)}A(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),s=Date.now()-i.writtenTime,n=Date.now()-this.q.lastReadTime,l=Date.now()-this.n;if(s>=2e4&&n>=2e4&&l>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:s,timeSinceLastReceivedSomeData:n});return}const p=Math.max(2e4-s,2e4-n,2e4-l,500);this.f=setTimeout(()=>{this.f=null,this.A()},p)}B(){if(this.g<=this.h)return;this.h=this.g;const i=new d(3,0,this.h,R());this.p.write(i)}C(){const i=new d(9,0,0,R());this.p.write(i)}}e.PersistentProtocol=c}),define(Se[114],ye([1,0,22,10,4,6,9,11,30,112,113]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(n,l){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,l)}constructor(n,l=""){this.f=!0,this.debugLabel=l,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,t.onUnexpectedError)(p)}},this.socket.on("error",this.a),this.b=p=>{this.traceSocketEvent("close",{hadError:p}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const l=p=>{this.traceSocketEvent("read",p),n(a.VSBuffer.wrap(p))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(n){const l=p=>{n({type:0,hadError:p,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(n){const l=()=>{n()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,t.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,t.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var y;(function(s){s[s.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var v;(function(s){s[s.PeekHeader=1]="PeekHeader",s[s.ReadHeader=2]="ReadHeader",s[s.ReadBody=3]="ReadBody",s[s.Fin=4]="Fin"})(v||(v={}));class d extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,l){this.socket.traceSocketEvent(n,l)}constructor(n,l,p,k){super(),this.f=this.B(new I.Emitter),this.g=this.B(new I.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:p?.byteLength||0,recordInflateBytes:k}),this.a=this.B(new g(this,l,p,k,this.f,(L,B)=>this.k(L,B))),this.B(this.a.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new R.ChunkStream,this.B(this.socket.onData(L=>this.l(L))),this.B(this.socket.onClose(L=>this.g.fire(L)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,l){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let p=2;n.byteLength<126?p+=0:n.byteLength<2**16?p+=2:p+=8;const k=a.VSBuffer.alloc(p);if(l?k.writeUInt8(194,0):k.writeUInt8(130,0),n.byteLength<126)k.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){k.writeUInt8(126,1);let L=1;k.writeUInt8(n.byteLength>>>8&255,++L),k.writeUInt8(n.byteLength>>>0&255,++L)}else{k.writeUInt8(127,1);let L=1;k.writeUInt8(0,++L),k.writeUInt8(0,++L),k.writeUInt8(0,++L),k.writeUInt8(0,++L),k.writeUInt8(n.byteLength>>>24&255,++L),k.writeUInt8(n.byteLength>>>16&255,++L),k.writeUInt8(n.byteLength>>>8&255,++L),k.writeUInt8(n.byteLength>>>0&255,++L)}this.socket.write(a.VSBuffer.concat([k,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const l=this.b.peek(this.j.readLen),p=l.readUInt8(0),k=(p&128)>>>7,L=(p&64)>>>6,B=l.readUInt8(1),K=(B&128)>>>7,G=B&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=k,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(L)),this.j.firstFrameOfMessage=Boolean(k),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const l=this.b.read(this.j.readLen),p=l.readUInt8(1),k=(p&128)>>>7;let L=p&127,B=1;L===126?L=l.readUInt8(++B)*2**8+l.readUInt8(++B):L===127&&(L=l.readUInt8(++B)*0+l.readUInt8(++B)*0+l.readUInt8(++B)*0+l.readUInt8(++B)*0+l.readUInt8(++B)*2**24+l.readUInt8(++B)*2**16+l.readUInt8(++B)*2**8+l.readUInt8(++B));let K=0;k&&(K=l.readUInt8(++B)*2**24+l.readUInt8(++B)*2**16+l.readUInt8(++B)*2**8+l.readUInt8(++B)),this.j.state=3,this.j.readLen=L,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const l=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),f(l,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(l,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await I.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class g extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(n,l,p,k,L,B){super(),this.k=n,this.l=L,this.m=B,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new I.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,l?(this.b=this.B(new m(this.k,k,p,{windowBits:15})),this.f=this.B(new w(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const l=await this.r(this.f,n);this.m(l,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,l){return new Promise((p,k)=>{n.write(l),n.flush(L=>p(L))})}acceptFrame(n,l,p){this.h.push({data:n,isCompressed:l,isLastFrameOfMessage:p}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const l=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(l)}else this.l.fire(n.data)}this.s=!1}}u(n,l,p){return new Promise((k,L)=>{n.write(l),p&&n.write(a.VSBuffer.fromByteArray([0,0,255,255])),n.flush(B=>k(B))})}}class m extends A.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(n,l,p,k){super(),this.h=n,this.j=l,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(k),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(a.VSBuffer.wrap(L))}),p&&(this.h.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this.b.write(p.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const l=a.VSBuffer.concat(this.g);this.g.length=0,n(l)})}}class w extends A.Disposable{constructor(n,l){super(),this.g=n,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",p=>{this.g.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this.a.fire(p)}),this.b.on("data",p=>{this.g.traceSocketEvent("zlibDeflateData",p),this.f.push(a.VSBuffer.wrap(p))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let l=a.VSBuffer.concat(this.f);this.f.length=0,l=l.slice(0,l.byteLength-4),n(l)})}}function f(s,n){if(n===0)return;const l=s.byteLength>>>2;for(let G=0;G<l;G++){const O=s.readUInt32BE(G*4);s.writeUInt32BE(O^n,G*4)}const p=l*4,k=s.byteLength-p,L=n>>>24&255,B=n>>>16&255,K=n>>>8&255;k>=1&&s.writeUInt8(s.readUInt8(p)^L,p),k>=2&&s.writeUInt8(s.readUInt8(p+1)^B,p+1),k>=3&&s.writeUInt8(s.readUInt8(p+2)^K,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function b(){const s=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${s}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${s}.sock`):n=(0,D.join)(P().os.tmpdir(),`vscode-ipc-${s}.sock`),r(n),n}e.createRandomIPCHandle=b;function o(s,n,l){const p=P().crypto.createHash("md5").update(s).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${l}-${n}-sock`;let k;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?k=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${l}-${n}.sock`):k=(0,D.join)(s,`${l}-${n}.sock`),r(k),k}e.createStaticIPCHandle=o;function r(s){const n=h[T.platform];typeof n=="number"&&s.length>=n&&console.warn(`WARNING: IPC handle "${s}" is longer than ${n} chars, try a shorter --user-data-dir`)}class c extends C.IPCServer{static b(n){const l=I.Event.fromNodeEventEmitter(n,"connection");return I.Event.map(l,p=>({protocol:new R.Protocol(new E(p,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(p,"close"))}))}constructor(n){super(c.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=c;function u(s){return new Promise((n,l)=>{const p=P().net.createServer();p.on("error",l),p.listen(s,()=>{p.removeListener("error",l),n(new c(p))})})}e.serve=u;function i(s,n){return new Promise((l,p)=>{const k=P().net.createConnection(s,()=>{k.removeListener("error",p),l(R.Client.fromSocket(new E(k,`ipc-client${n}`),n))});k.once("error",p)})}e.connect=i}),define(Se[115],ye([1,0,104]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,a.toUint8)(T);this.c=S,this.a=t.d(S),this.b=new Map}static d(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const C=(0,a.toUint8)(S);T>=0&&T<256?this.a[T]=C:this.b.set(T,C)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var I;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(I||(I={}));class A{constructor(){this.a=new t(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=A}),define(Se[51],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(I,A){this.lineNumber=I,this.column=A}with(I=this.lineNumber,A=this.column){return I===this.lineNumber&&A===this.column?this:new a(I,A)}delta(I=0,A=0){return this.with(this.lineNumber+I,this.column+A)}equals(I){return a.equals(this,I)}static equals(I,A){return!I&&!A?!0:!!I&&!!A&&I.lineNumber===A.lineNumber&&I.column===A.column}isBefore(I){return a.isBefore(this,I)}static isBefore(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<A.column}isBeforeOrEqual(I){return a.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<=A.column}static compare(I,A){const D=I.lineNumber|0,T=A.lineNumber|0;if(D===T){const S=I.column|0,C=A.column|0;return S-C}return D-T}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new a(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=a}),define(Se[37],ye([1,0,51]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,D,T,S){A>T||A===T&&D>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}static strictContainsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<=A.startColumn||D.lineNumber===A.endLineNumber&&D.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,D){let T,S,C,R;return D.startLineNumber<A.startLineNumber?(T=D.startLineNumber,S=D.startColumn):D.startLineNumber===A.startLineNumber?(T=D.startLineNumber,S=Math.min(D.startColumn,A.startColumn)):(T=A.startLineNumber,S=A.startColumn),D.endLineNumber>A.endLineNumber?(C=D.endLineNumber,R=D.endColumn):D.endLineNumber===A.endLineNumber?(C=D.endLineNumber,R=Math.max(D.endColumn,A.endColumn)):(C=A.endLineNumber,R=A.endColumn),new t(T,S,C,R)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,D){let T=A.startLineNumber,S=A.startColumn,C=A.endLineNumber,R=A.endColumn;const P=D.startLineNumber,E=D.startColumn,y=D.endLineNumber,v=D.endColumn;return T<P?(T=P,S=E):T===P&&(S=Math.max(S,E)),C>y?(C=y,R=v):C===y&&(R=Math.min(R,v)),T>C||T===C&&S>R?null:new t(T,S,C,R)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,D){return!A&&!D?!0:!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new a.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new a.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new t(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new t(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(A){return new t(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,D=A){return new t(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const C=A.startLineNumber|0,R=D.startLineNumber|0;if(C===R){const P=A.startColumn|0,E=D.startColumn|0;if(P===E){const y=A.endLineNumber|0,v=D.endLineNumber|0;if(y===v){const d=A.endColumn|0,g=D.endColumn|0;return d-g}return y-v}return P-E}return C-R}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(Se[150],ye([1,0,51,37]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(T,S,C,R){super(T,S,C,R),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return A.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,T,S):new A(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new A(T,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new A(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new A(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new A(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new A(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let C=0,R=T.length;C<R;C++)if(!this.selectionsEqual(T[C],S[C]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,C,R,P){return P===0?new A(T,S,C,R):new A(C,R,T,S)}}e.Selection=A}),define(Se[151],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[152],ye([1,0,115]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends a.CharacterClassifier{constructor(T){super(0);for(let S=0,C=T.length;S<C;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function A(D){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=D(S)),T[S])}e.getMapForWordSeparators=A(D=>new I(D))}),define(Se[116],ye([1,0,63,6,64]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)P.indexOf(y)>=0||(E+="\\"+y);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=A();function D(P){let E=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)E=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),E=new RegExp(P.source,y)}return E.lastIndex=0,E}e.ensureValidWordDefinition=D;const T=new I.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(P){const E=T.unshift(P);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function C(P,E,y,v,d){if(d||(d=a.Iterable.first(T)),y.length>d.maxLen){let h=P-d.maxLen/2;return h<0?h=0:v+=h,y=y.substring(h,P+d.maxLen/2),C(P,E,y,v,d)}const g=Date.now(),m=P-1-v;let w=-1,f=null;for(let h=1;!(Date.now()-g>=d.timeBudget);h++){const b=m-d.windowSize*h;E.lastIndex=Math.max(0,b);const o=R(E,y,m,w);if(!o&&f||(f=o,b<=0))break;w=b}if(f){const h={word:f[0],startColumn:v+1+f.index,endColumn:v+1+f.index+f[0].length};return E.lastIndex=0,h}return null}e.getWordAtText=C;function R(P,E,y,v){let d;for(;d=P.exec(E);){const g=d.index||0;if(g<=y&&P.lastIndex>=y)return d;if(v>0&&g>v)return null}return null}}),define(Se[153],ye([1,0,36,9]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(A,D,T,S,C,R){if(Array.isArray(A)){let P=0;for(const E of A){const y=I(E,D,T,S,C,R);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===T?10:0:0;if(A){const{language:P,pattern:E,scheme:y,hasAccessToAllModels:v,notebookType:d}=A;if(!S&&!v)return 0;d&&C&&(D=C);let g=0;if(y)if(y===D.scheme)g=10;else if(y==="*")g=5;else return 0;if(P)if(P===T)g=10;else if(P==="*")g=Math.max(g,5);else return 0;if(d)if(d===R)g=10;else if(d==="*"&&R!==void 0)g=Math.max(g,5);else return 0;if(E){let m;if(typeof E=="string"?m=E:m={...E,base:(0,t.normalize)(E.base)},m===D.fsPath||(0,a.match)(m,D.fsPath))g=10;else return 0}return g}else return 0}}e.score=I}),define(Se[154],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let S=0,C=T.notIn.length;S<C;S++)switch(T.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const C=T.findTokenIndexAtOffset(S-2),R=T.getStandardTokenType(C);return this.isOK(R)}g(T,S){for(let C=T;C<=S;C++){const R=String.fromCharCode(C);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class I{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function A(D,T,S){D.has(T)?D.get(T).push(S):D.set(T,[S])}}),define(Se[155],ye([1,0,115]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(v,d,g){const m=new Uint8Array(v*d);for(let w=0,f=v*d;w<f;w++)m[w]=g;this.a=m,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,g){this.a[v*this.cols+d]=g}}class A{constructor(v){let d=0,g=0;for(let w=0,f=v.length;w<f;w++){const[h,b,o]=v[w];b>d&&(d=b),h>g&&(g=h),o>g&&(g=o)}d++,g++;const m=new I(g,d,0);for(let w=0,f=v.length;w<f;w++){const[h,b,o]=v[w];m.set(h,b,o)}this.a=m,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.StateMachine=A;let D=null;function T(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var S;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function R(){if(C===null){C=new a.CharacterClassifier(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<y.length;d++)C.set(y.charCodeAt(d),1);const v=".,;:";for(let d=0;d<v.length;d++)C.set(v.charCodeAt(d),2)}return C}class P{static a(v,d,g,m,w){let f=w-1;do{const h=d.charCodeAt(f);if(v.get(h)!==2)break;f--}while(f>m);if(m>0){const h=d.charCodeAt(m-1),b=d.charCodeAt(f);(h===40&&b===41||h===91&&b===93||h===123&&b===125)&&f--}return{range:{startLineNumber:g,startColumn:m+1,endLineNumber:g,endColumn:f+2},url:d.substring(m,f+1)}}static computeLinks(v,d=T()){const g=R(),m=[];for(let w=1,f=v.getLineCount();w<=f;w++){const h=v.getLineContent(w),b=h.length;let o=0,r=0,c=0,u=1,i=!1,s=!1,n=!1,l=!1;for(;o<b;){let p=!1;const k=h.charCodeAt(o);if(u===13){let L;switch(k){case 40:i=!0,L=0;break;case 41:L=i?0:1;break;case 91:n=!0,s=!0,L=0;break;case 93:n=!1,L=s?0:1;break;case 123:l=!0,L=0;break;case 125:L=l?0:1;break;case 39:case 34:case 96:c===k?L=1:c===39||c===34||c===96?L=0:L=1;break;case 42:L=c===42?1:0;break;case 124:L=c===124?1:0;break;case 32:L=n?0:1;break;default:L=g.get(k)}L===1&&(m.push(P.a(g,h,w,r,o)),p=!0)}else if(u===12){let L;k===91?(s=!0,L=0):L=g.get(k),L===1?p=!0:u=13}else u=d.nextState(u,k),u===0&&(p=!0);p&&(u=1,i=!1,s=!1,l=!1,r=o+1,c=k),o++}u===13&&m.push(P.a(g,h,w,r,b))}return m}}e.LinkComputer=P;function E(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.computeLinks=E}),define(Se[117],ye([1,0,23]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=Math.max(1,h.indentSize|0),this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace),this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class R{constructor(h,b){this._findMatchBrand=void 0,this.range=h,this.matches=b}}e.FindMatch=R;var P;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(f){return f&&typeof f.read=="function"}e.isITextSnapshot=E;var y;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(y=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class d{constructor(h,b,o,r,c,u){this.identifier=h,this.range=b,this.text=o,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.ValidAnnotatedEditOperation=d;class g{constructor(h,b,o){this.regex=h,this.wordSeparators=b,this.simpleSearch=o}}e.SearchData=g;class m{constructor(h,b,o){this.reverseEdits=h,this.changes=b,this.trimAutoWhitespaceLineNumbers=o}}e.ApplyEditsResult=m;function w(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.shouldSynchronizeModel=w}),define(Se[156],ye([1,0,17,104]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,C){S=(0,t.toUint32)(S);const R=this.a,P=this.b,E=C.length;return E===0?!1:(this.a=new Uint32Array(R.length+E),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S),S+E),this.a.set(C,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(S,C){return S=(0,t.toUint32)(S),C=(0,t.toUint32)(C),this.a[S]===C?!1:(this.a[S]=C,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,C){S=(0,t.toUint32)(S),C=(0,t.toUint32)(C);const R=this.a,P=this.b;if(S>=R.length)return!1;const E=R.length-S;return C>=E&&(C=E),C===0?!1:(this.a=new Uint32Array(R.length-C),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S+C),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let C=this.c[0]+1;C===0&&(this.b[0]=this.a[0],C++),S>=this.a.length&&(S=this.a.length-1);for(let R=C;R<=S;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let C=0,R=this.a.length-1,P=0,E=0,y=0;for(;C<=R;)if(P=C+(R-C)/2|0,E=this.b[P],y=E-this.a[P],S<y)R=P-1;else if(S>=E)C=P+1;else break;return new D(P,S-y)}}e.PrefixSumComputer=I;class A{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const C=this.e[S],R=C>0?this.d[C-1]:0;return new D(C,S-R)}removeValues(S,C){this.a.splice(S,C),this.f(S)}insertValues(S,C){this.a=(0,a.arrayInsert)(this.a,S,C),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,C=this.a.length;S<C;S++){const R=this.a[S],P=S>0?this.d[S-1]:0;this.d[S]=P+R;for(let E=0;E<R;E++)this.e[P+E]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,C){this.a[S]!==C&&(this.a[S]=C,this.f(S))}}e.ConstantTimePrefixSumComputer=A;class D{constructor(S,C){this.index=S,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=D}),define(Se[157],ye([1,0,8,51,156]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(T,S,C,R){this.c=T,this.d=S,this.f=C,this.g=R,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const S=T.changes;for(const C of S)this.n(C.range),this.o(new t.Position(C.range.startLineNumber,C.range.startColumn),C.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,S=this.d.length,C=new Uint32Array(S);for(let R=0;R<S;R++)C[R]=this.d[R].length+T;this.h=new I.PrefixSumComputer(C)}}l(T,S){this.d[T]=S,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,S){if(S.length===0)return;const C=(0,a.splitLines)(S);if(C.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+C[0]+this.d[T.lineNumber-1].substring(T.column-1));return}C[C.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+C[0]);const R=new Uint32Array(C.length-1);for(let P=1;P<C.length;P++)this.d.splice(T.lineNumber+P-1,0,C[P]),R[P-1]=C[P].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,R)}}e.MirrorTextModel=A}),define(Se[158],ye([1,0,8,152,51,37,117]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(w,f,h,b){this.searchString=w,this.isRegex=f,this.matchCase=h,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=C(this.searchString):w=this.searchString.indexOf(`
`)>=0;let f=null;try{f=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!f)return null;let h=!this.isRegex&&!w;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new D.SearchData(f,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=S;function C(m){if(!m||m.length===0)return!1;for(let w=0,f=m.length;w<f;w++){const h=m.charCodeAt(w);if(h===10)return!0;if(h===92){if(w++,w>=f)break;const b=m.charCodeAt(w);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=C;function R(m,w,f){if(!f)return new D.FindMatch(m,null);const h=[];for(let b=0,o=w.length;b<o;b++)h[b]=w[b];return new D.FindMatch(m,h)}e.createFindMatch=R;class P{constructor(w){const f=[];let h=0;for(let b=0,o=w.length;b<o;b++)w.charCodeAt(b)===10&&(f[h++]=b);this.a=f}findLineFeedCountBeforeOffset(w){const f=this.a;let h=0,b=f.length-1;if(b===-1||w<=f[0])return 0;for(;h<b;){const o=h+((b-h)/2>>0);f[o]>=w?b=o-1:f[o+1]>=w?(h=o,b=o):h=o+1}return h+1}}class E{static findMatches(w,f,h,b,o){const r=f.parseSearchRequest();return r?r.regex.multiline?this.b(w,h,new g(r.wordSeparators,r.regex),b,o):this.c(w,h,r,b,o):[]}static a(w,f,h,b,o,r){let c,u=0;b?(u=b.findLineFeedCountBeforeOffset(o),c=f+o+u):c=f+o;let i;if(b){const p=b.findLineFeedCountBeforeOffset(o+r.length)-u;i=c+r.length+p}else i=c+r.length;const s=w.getPositionAt(c),n=w.getPositionAt(i);return new A.Range(s.lineNumber,s.column,n.lineNumber,n.column)}static b(w,f,h,b,o){const r=w.getOffsetAt(f.getStartPosition()),c=w.getValueInRange(f,1),u=w.getEOL()===`\r
`?new P(c):null,i=[];let s=0,n;for(h.reset(0);n=h.next(c);)if(i[s++]=R(this.a(w,r,c,u,n.index,n[0]),n,b),s>=o)return i;return i}static c(w,f,h,b,o){const r=[];let c=0;if(f.startLineNumber===f.endLineNumber){const i=w.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return c=this.d(h,i,f.startLineNumber,f.startColumn-1,c,r,b,o),r}const u=w.getLineContent(f.startLineNumber).substring(f.startColumn-1);c=this.d(h,u,f.startLineNumber,f.startColumn-1,c,r,b,o);for(let i=f.startLineNumber+1;i<f.endLineNumber&&c<o;i++)c=this.d(h,w.getLineContent(i),i,0,c,r,b,o);if(c<o){const i=w.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);c=this.d(h,i,f.endLineNumber,0,c,r,b,o)}return r}static d(w,f,h,b,o,r,c,u){const i=w.wordSeparators;if(!c&&w.simpleSearch){const l=w.simpleSearch,p=l.length,k=f.length;let L=-p;for(;(L=f.indexOf(l,L+p))!==-1;)if((!i||d(i,f,k,L,p))&&(r[o++]=new D.FindMatch(new A.Range(h,L+1+b,h,L+1+p+b),null),o>=u))return o;return o}const s=new g(w.wordSeparators,w.regex);let n;s.reset(0);do if(n=s.next(f),n&&(r[o++]=R(new A.Range(h,n.index+1+b,h,n.index+1+n[0].length+b),n,c),o>=u))return o;while(n);return o}static findNextMatch(w,f,h,b){const o=f.parseSearchRequest();if(!o)return null;const r=new g(o.wordSeparators,o.regex);return o.regex.multiline?this.e(w,h,r,b):this.f(w,h,r,b)}static e(w,f,h,b){const o=new I.Position(f.lineNumber,1),r=w.getOffsetAt(o),c=w.getLineCount(),u=w.getValueInRange(new A.Range(o.lineNumber,o.column,c,w.getLineMaxColumn(c)),1),i=w.getEOL()===`\r
`?new P(u):null;h.reset(f.column-1);const s=h.next(u);return s?R(this.a(w,r,u,i,s.index,s[0]),s,b):f.lineNumber!==1||f.column!==1?this.e(w,new I.Position(1,1),h,b):null}static f(w,f,h,b){const o=w.getLineCount(),r=f.lineNumber,c=w.getLineContent(r),u=this.g(h,c,r,f.column,b);if(u)return u;for(let i=1;i<=o;i++){const s=(r+i-1)%o,n=w.getLineContent(s+1),l=this.g(h,n,s+1,1,b);if(l)return l}return null}static g(w,f,h,b,o){w.reset(b-1);const r=w.next(f);return r?R(new A.Range(h,r.index+1,h,r.index+1+r[0].length),r,o):null}static findPreviousMatch(w,f,h,b){const o=f.parseSearchRequest();if(!o)return null;const r=new g(o.wordSeparators,o.regex);return o.regex.multiline?this.h(w,h,r,b):this.j(w,h,r,b)}static h(w,f,h,b){const o=this.b(w,new A.Range(1,1,f.lineNumber,f.column),h,b,10*T);if(o.length>0)return o[o.length-1];const r=w.getLineCount();return f.lineNumber!==r||f.column!==w.getLineMaxColumn(r)?this.h(w,new I.Position(r,w.getLineMaxColumn(r)),h,b):null}static j(w,f,h,b){const o=w.getLineCount(),r=f.lineNumber,c=w.getLineContent(r).substring(0,f.column-1),u=this.k(h,c,r,b);if(u)return u;for(let i=1;i<=o;i++){const s=(o+r-i-1)%o,n=w.getLineContent(s+1),l=this.k(h,n,s+1,b);if(l)return l}return null}static k(w,f,h,b){let o=null,r;for(w.reset(0);r=w.next(f);)o=R(new A.Range(h,r.index+1,h,r.index+1+r[0].length),r,b);return o}}e.TextModelSearch=E;function y(m,w,f,h,b){if(h===0)return!0;const o=w.charCodeAt(h-1);if(m.get(o)!==0||o===13||o===10)return!0;if(b>0){const r=w.charCodeAt(h);if(m.get(r)!==0)return!0}return!1}function v(m,w,f,h,b){if(h+b===f)return!0;const o=w.charCodeAt(h+b);if(m.get(o)!==0||o===13||o===10)return!0;if(b>0){const r=w.charCodeAt(h+b-1);if(m.get(r)!==0)return!0}return!1}function d(m,w,f,h,b){return y(m,w,f,h,b)&&v(m,w,f,h,b)}e.isValidMatch=d;class g{constructor(w,f){this._wordSeparators=w,this.a=f,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const f=w.length;let h;do{if(this.b+this.c===f||(h=this.a.exec(w),!h))return null;const b=h.index,o=h[0].length;if(b===this.b&&o===this.c){if(o===0){a.getNextCodePoint(w,f,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=b,this.c=o,!this._wordSeparators||d(this._wordSeparators,w,f,b,o))return h}while(h);return null}}e.Searcher=g}),define(Se[118],ye([1,0,22,11]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(I||(I={}));function A(P){for(let E=0,y=P.length;E<y;E+=4){const v=P[E+0],d=P[E+1],g=P[E+2],m=P[E+3];P[E+0]=m,P[E+1]=g,P[E+2]=d,P[E+3]=v}}function D(P){const E=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||A(E),a.VSBuffer.wrap(E)}function T(P){const E=P.buffer;if(t.isLittleEndian()||A(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const y=new Uint8Array(E.byteLength);return y.set(E),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function S(P){const E=new Uint32Array(C(P));let y=0;if(E[y++]=P.id,P.type==="full")E[y++]=1,E[y++]=P.data.length,E.set(P.data,y),y+=P.data.length;else{E[y++]=2,E[y++]=P.deltas.length;for(const v of P.deltas)E[y++]=v.start,E[y++]=v.deleteCount,v.data?(E[y++]=v.data.length,E.set(v.data,y),y+=v.data.length):E[y++]=0}return D(E)}e.encodeSemanticTokensDto=S;function C(P){let E=0;if(E+=1+1,P.type==="full")E+=1+P.data.length;else{E+=1,E+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(E+=y.data.length)}return E}function R(P){const E=T(P);let y=0;const v=E[y++];if(E[y++]===1){const w=E[y++],f=E.subarray(y,y+w);return y+=w,{id:v,type:"full",data:f}}const g=E[y++],m=[];for(let w=0;w<g;w++){const f=E[y++],h=E[y++],b=E[y++];let o;b>0&&(o=E.subarray(y,y+b),y+=b),m[w]={start:f,deleteCount:h,data:o}}return{id:v,type:"delta",deltas:m}}e.decodeSemanticTokensDto=R}),define(Se[159],ye([1,0,4,6]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this.a.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this.a.get(T)===S&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,S){this.b.get(T)?.dispose();const C=new A(this,T,S);return this.b.set(T,C),(0,t.toDisposable)(()=>{const R=this.b.get(T);!R||R!==C||(this.b.delete(T),R.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const C=this.b.get(T);return!C||C.isResolved?null:(await C.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const C=this.b.get(T);return!!(!C||C.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=I;class A extends t.Disposable{get isResolved(){return this.c}constructor(T,S,C){super(),this.f=T,this.g=S,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(Se[67],ye([1,0,80,2,37,159]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(p,k,L){this._tokenBrand=void 0,this.offset=p,this.type=k,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class T{constructor(p,k){this._tokenizationResultBrand=void 0,this.tokens=p,this.endState=k}}e.TokenizationResult=T;class S{constructor(p,k){this._encodedTokenizationResultBrand=void 0,this.tokens=p,this.endState=k}}e.EncodedTokenizationResult=S;var C;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(l){const p=new Map;p.set(0,a.Codicon.symbolMethod),p.set(1,a.Codicon.symbolFunction),p.set(2,a.Codicon.symbolConstructor),p.set(3,a.Codicon.symbolField),p.set(4,a.Codicon.symbolVariable),p.set(5,a.Codicon.symbolClass),p.set(6,a.Codicon.symbolStruct),p.set(7,a.Codicon.symbolInterface),p.set(8,a.Codicon.symbolModule),p.set(9,a.Codicon.symbolProperty),p.set(10,a.Codicon.symbolEvent),p.set(11,a.Codicon.symbolOperator),p.set(12,a.Codicon.symbolUnit),p.set(13,a.Codicon.symbolValue),p.set(15,a.Codicon.symbolEnum),p.set(14,a.Codicon.symbolConstant),p.set(15,a.Codicon.symbolEnum),p.set(16,a.Codicon.symbolEnumMember),p.set(17,a.Codicon.symbolKeyword),p.set(27,a.Codicon.symbolSnippet),p.set(18,a.Codicon.symbolText),p.set(19,a.Codicon.symbolColor),p.set(20,a.Codicon.symbolFile),p.set(21,a.Codicon.symbolReference),p.set(22,a.Codicon.symbolCustomColor),p.set(23,a.Codicon.symbolFolder),p.set(24,a.Codicon.symbolTypeParameter),p.set(25,a.Codicon.account),p.set(26,a.Codicon.issues);function k(K){let G=p.get(K);return G||(console.info("No codicon found for CompletionItemKind "+K),G=a.Codicon.symbolProperty),G}l.toIcon=k;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function B(K,G){let O=L.get(K);return typeof O>"u"&&!G&&(O=9),O}l.fromString=B})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(l){l[l.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function w(l){return l&&t.URI.isUri(l.uri)&&I.Range.isIRange(l.range)&&(I.Range.isIRange(l.originSelectionRange)||I.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=w;var f;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var h;(function(l){l[l.Deprecated=1]="Deprecated"})(h=e.SymbolTag||(e.SymbolTag={}));var b;(function(l){const p=new Map;p.set(0,a.Codicon.symbolFile),p.set(1,a.Codicon.symbolModule),p.set(2,a.Codicon.symbolNamespace),p.set(3,a.Codicon.symbolPackage),p.set(4,a.Codicon.symbolClass),p.set(5,a.Codicon.symbolMethod),p.set(6,a.Codicon.symbolProperty),p.set(7,a.Codicon.symbolField),p.set(8,a.Codicon.symbolConstructor),p.set(9,a.Codicon.symbolEnum),p.set(10,a.Codicon.symbolInterface),p.set(11,a.Codicon.symbolFunction),p.set(12,a.Codicon.symbolVariable),p.set(13,a.Codicon.symbolConstant),p.set(14,a.Codicon.symbolString),p.set(15,a.Codicon.symbolNumber),p.set(16,a.Codicon.symbolBoolean),p.set(17,a.Codicon.symbolArray),p.set(18,a.Codicon.symbolObject),p.set(19,a.Codicon.symbolKey),p.set(20,a.Codicon.symbolNull),p.set(21,a.Codicon.symbolEnumMember),p.set(22,a.Codicon.symbolStruct),p.set(23,a.Codicon.symbolEvent),p.set(24,a.Codicon.symbolOperator),p.set(25,a.Codicon.symbolTypeParameter);function k(L){let B=p.get(L);return B||(console.info("No codicon found for SymbolKind "+L),B=a.Codicon.symbolProperty),B}l.toIcon=k})(b=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(p){this.value=p}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var r;(function(l){function p(k){return!k||typeof k!="object"?!1:typeof k.id=="string"&&typeof k.title=="string"}l.is=p})(r=e.Command||(e.Command={}));var c;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(l){l[l.Unresolved=0]="Unresolved",l[l.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var i;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(i=e.CommentMode||(e.CommentMode={}));var s;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(s=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var n;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Se[160],ye([19,20]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Se[161],ye([1,0,160]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,A=I*24,D=A*7,T=A*30,S=A*365;function C(P,E,y){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,a.localize)(0,null,C(new Date().getTime()+v*1e3,!1));if(v<30)return(0,a.localize)(1,null);let d;return v<t?(d=v,E?d===1?y?(0,a.localize)(2,null,d):(0,a.localize)(3,null,d):y?(0,a.localize)(4,null,d):(0,a.localize)(5,null,d):d===1?y?(0,a.localize)(6,null,d):(0,a.localize)(7,null,d):y?(0,a.localize)(8,null,d):(0,a.localize)(9,null,d)):v<I?(d=Math.floor(v/t),E?d===1?y?(0,a.localize)(10,null,d):(0,a.localize)(11,null,d):y?(0,a.localize)(12,null,d):(0,a.localize)(13,null,d):d===1?y?(0,a.localize)(14,null,d):(0,a.localize)(15,null,d):y?(0,a.localize)(16,null,d):(0,a.localize)(17,null,d)):v<A?(d=Math.floor(v/I),E?d===1?y?(0,a.localize)(18,null,d):(0,a.localize)(19,null,d):y?(0,a.localize)(20,null,d):(0,a.localize)(21,null,d):d===1?y?(0,a.localize)(22,null,d):(0,a.localize)(23,null,d):y?(0,a.localize)(24,null,d):(0,a.localize)(25,null,d)):v<D?(d=Math.floor(v/A),E?d===1?(0,a.localize)(26,null,d):(0,a.localize)(27,null,d):d===1?(0,a.localize)(28,null,d):(0,a.localize)(29,null,d)):v<T?(d=Math.floor(v/D),E?d===1?y?(0,a.localize)(30,null,d):(0,a.localize)(31,null,d):y?(0,a.localize)(32,null,d):(0,a.localize)(33,null,d):d===1?y?(0,a.localize)(34,null,d):(0,a.localize)(35,null,d):y?(0,a.localize)(36,null,d):(0,a.localize)(37,null,d)):v<S?(d=Math.floor(v/T),E?d===1?y?(0,a.localize)(38,null,d):(0,a.localize)(39,null,d):y?(0,a.localize)(40,null,d):(0,a.localize)(41,null,d):d===1?y?(0,a.localize)(42,null,d):(0,a.localize)(43,null,d):y?(0,a.localize)(44,null,d):(0,a.localize)(45,null,d)):(d=Math.floor(v/S),E?d===1?y?(0,a.localize)(46,null,d):(0,a.localize)(47,null,d):y?(0,a.localize)(48,null,d):(0,a.localize)(49,null,d):d===1?y?(0,a.localize)(50,null,d):(0,a.localize)(51,null,d):y?(0,a.localize)(52,null,d):(0,a.localize)(53,null,d))}e.fromNow=C;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Se[162],ye([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Se[52],ye([1,0,17,12,162]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,E){return E&&(P.stack||P.stacktrace)?I.localize(0,null,T(P),D(P.stack)||D(P.stacktrace)):T(P)}function D(P){return Array.isArray(P)?P.join(`
`):P}function T(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function S(P=null,E=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const y=a.coalesce(P),v=S(y[0],E);return y.length>1?I.localize(4,null,v,y.length):v}if(t.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return A(y.error,E);if(y.exception)return A(y.exception,E)}return P.stack?A(P,E):P.message?P.message:I.localize(5,null)}e.toErrorMessage=S;function C(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=C;function R(P,E){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=E,y}e.createErrorWithActions=R}),define(Se[163],ye([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Se[119],ye([1,0,163,11,116,17,23,151]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(W){this.c=W}hasChanged(W){return this.c[W]}}e.ConfigurationChangedEvent=C;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class P{constructor(W,ae,De,Le){this.id=W,this.name=ae,this.defaultValue=De,this.schema=Le}applyUpdate(W,ae){return y(W,ae)}compute(W,ae,De){return De}}class E{constructor(W,ae){this.newValue=W,this.didChange=ae}}e.ApplyUpdateResult=E;function y(oe,W){if(typeof oe!="object"||typeof W!="object"||!oe||!W)return new E(W,oe!==W);if(Array.isArray(oe)||Array.isArray(W)){const De=Array.isArray(oe)&&Array.isArray(W)&&A.equals(oe,W);return new E(W,!De)}let ae=!1;for(const De in W)if(W.hasOwnProperty(De)){const Le=y(oe[De],W[De]);Le.didChange&&(oe[De]=Le.newValue,ae=!0)}return new E(oe,ae)}class v{constructor(W){this.schema=void 0,this.id=W,this.name="_never_",this.defaultValue=void 0}applyUpdate(W,ae){return y(W,ae)}validate(W){return this.defaultValue}}class d{constructor(W,ae,De,Le){this.id=W,this.name=ae,this.defaultValue=De,this.schema=Le}applyUpdate(W,ae){return y(W,ae)}validate(W){return typeof W>"u"?this.defaultValue:W}compute(W,ae,De){return De}}function g(oe,W){return typeof oe>"u"?W:oe==="false"?!1:Boolean(oe)}e.boolean=g;class m extends d{constructor(W,ae,De,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=De),super(W,ae,De,Le)}validate(W){return g(W,this.defaultValue)}}function w(oe,W,ae,De){if(typeof oe>"u")return W;let Le=parseInt(oe,10);return isNaN(Le)?W:(Le=Math.max(ae,Le),Le=Math.min(De,Le),Le|0)}e.clampedInt=w;class f extends d{static clampedInt(W,ae,De,Le){return w(W,ae,De,Le)}constructor(W,ae,De,Le,Be,xe=void 0){typeof xe<"u"&&(xe.type="integer",xe.default=De,xe.minimum=Le,xe.maximum=Be),super(W,ae,De,xe),this.minimum=Le,this.maximum=Be}validate(W){return f.clampedInt(W,this.defaultValue,this.minimum,this.maximum)}}class h extends d{static clamp(W,ae,De){return W<ae?ae:W>De?De:W}static float(W,ae){if(typeof W=="number")return W;if(typeof W>"u")return ae;const De=parseFloat(W);return isNaN(De)?ae:De}constructor(W,ae,De,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=De),super(W,ae,De,Be),this.validationFn=Le}validate(W){return this.validationFn(h.float(W,this.defaultValue))}}class b extends d{static string(W,ae){return typeof W!="string"?ae:W}constructor(W,ae,De,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=De),super(W,ae,De,Le)}validate(W){return b.string(W,this.defaultValue)}}function o(oe,W,ae){return typeof oe!="string"||ae.indexOf(oe)===-1?W:oe}e.stringSet=o;class r extends d{constructor(W,ae,De,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=De),super(W,ae,De,Be),this.c=Le}validate(W){return o(W,this.defaultValue,this.c)}}class c extends P{constructor(W,ae,De,Le,Be,xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super(W,ae,De,Ze),this.c=Be,this.d=xe}validate(W){return typeof W!="string"?this.defaultValue:this.c.indexOf(W)===-1?this.defaultValue:this.d(W)}}function u(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(W){switch(W){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(W,ae,De){return De===0?W.accessibilitySupport:De}}class s extends P{constructor(){const W={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",W,{"editor.comments.insertSpace":{type:"boolean",default:W.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:W.ignoreEmptyLines,description:a.localize(5,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{insertSpace:g(ae.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(ae.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function k(oe){switch(oe){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function L(oe){switch(oe){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class B extends v{constructor(){super(133)}compute(W,ae,De){const Le=["monaco-editor"];return ae.get(34)&&Le.push(ae.get(34)),W.extraEditorClassName&&Le.push(W.extraEditorClassName),ae.get(68)==="default"?Le.push("mouse-default"):ae.get(68)==="copy"&&Le.push("mouse-copy"),ae.get(103)&&Le.push("showUnused"),ae.get(131)&&Le.push("showDeprecated"),Le.join(" ")}}class K extends m{constructor(){super(33,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(W,ae,De){return De&&W.emptySelectionClipboard}}class G extends P{constructor(){const W={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",W,{"editor.find.cursorMoveOnType":{type:"boolean",default:W.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:W.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:W.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:W.globalFindClipboard,description:a.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:W.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:W.loop,description:a.localize(18,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{cursorMoveOnType:g(ae.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof W.seedSearchStringFromSelection=="boolean"?W.seedSearchStringFromSelection?"always":"never":o(ae.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof W.autoFindInSelection=="boolean"?W.autoFindInSelection?"always":"never":o(ae.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(ae.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(ae.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(ae.loop,this.defaultValue.loop)}}}class O extends P{constructor(){super(46,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?O.OFF:W==="true"?O.ON:W:Boolean(W)?O.ON:O.OFF}}e.EditorFontLigatures=O,O.OFF='"liga" off, "calt" off',O.ON='"liga" on, "calt" on';class U extends P{constructor(){super(49,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?U.OFF:W==="true"?U.TRANSLATE:W:Boolean(W)?U.TRANSLATE:U.OFF}compute(W,ae,De){return W.fontInfo.fontVariationSettings}}e.EditorFontVariations=U,U.OFF="normal",U.TRANSLATE="translate";class F extends v{constructor(){super(45)}compute(W,ae,De){return W.fontInfo}}class z extends d{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(W){const ae=h.float(W,this.defaultValue);return ae===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ae,6,100)}compute(W,ae,De){return W.fontInfo.fontSize}}class M extends P{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:M.d,maximum:M.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:M.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(W){return W==="normal"||W==="bold"?W:String(f.clampedInt(W,e.EDITOR_FONT_DEFAULTS.fontWeight,M.d,M.e))}}M.c=["normal","bold","100","200","300","400","500","600","700","800","900"],M.d=1,M.e=1e3;class V extends P{constructor(){const W={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ae={type:"string",enum:["peek","gotoAndPeek","goto"],default:W.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},De=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",W,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...ae},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...ae},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...ae},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...ae},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...ae},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:W.alternativeDefinitionCommand,enum:De,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:W.alternativeTypeDefinitionCommand,enum:De,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:W.alternativeDeclarationCommand,enum:De,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:W.alternativeImplementationCommand,enum:De,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:W.alternativeReferenceCommand,enum:De,description:a.localize(41,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{multiple:o(ae.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ae.multipleDefinitions??o(ae.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ae.multipleTypeDefinitions??o(ae.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ae.multipleDeclarations??o(ae.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ae.multipleImplementations??o(ae.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ae.multipleReferences??o(ae.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ae.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ae.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ae.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ae.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ae.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends P{constructor(){const W={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",W,{"editor.hover.enabled":{type:"boolean",default:W.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:W.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:W.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:W.above,description:a.localize(45,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),delay:f.clampedInt(ae.delay,this.defaultValue.delay,0,1e4),sticky:g(ae.sticky,this.defaultValue.sticky),above:g(ae.above,this.defaultValue.above)}}}var H;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(H=e.RenderMinimap||(e.RenderMinimap={}));class Q extends v{constructor(){super(136)}compute(W,ae,De){return Q.computeLayout(ae,{memory:W.memory,outerWidth:W.outerWidth,outerHeight:W.outerHeight,isDominatedByLongLines:W.isDominatedByLongLines,lineHeight:W.fontInfo.lineHeight,viewLineCount:W.viewLineCount,lineNumbersDigitCount:W.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:W.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:W.fontInfo.maxDigitWidth,pixelRatio:W.pixelRatio})}static computeContainedMinimapLineCount(W){const ae=W.height/W.lineHeight,De=W.scrollBeyondLastLine?ae-1:0,Le=(W.viewLineCount+De)/(W.pixelRatio*W.height),Be=Math.floor(W.viewLineCount/Le);return{typicalViewportLineCount:ae,extraLinesBeyondLastLine:De,desiredRatio:Le,minimapLineCount:Be}}static c(W,ae){const De=W.outerWidth,Le=W.outerHeight,Be=W.pixelRatio;if(!W.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const xe=ae.stableMinimapLayoutInput,Ze=xe&&W.outerHeight===xe.outerHeight&&W.lineHeight===xe.lineHeight&&W.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&W.pixelRatio===xe.pixelRatio&&W.scrollBeyondLastLine===xe.scrollBeyondLastLine&&W.minimap.enabled===xe.minimap.enabled&&W.minimap.side===xe.minimap.side&&W.minimap.size===xe.minimap.size&&W.minimap.showSlider===xe.minimap.showSlider&&W.minimap.renderCharacters===xe.minimap.renderCharacters&&W.minimap.maxColumn===xe.minimap.maxColumn&&W.minimap.scale===xe.minimap.scale&&W.verticalScrollbarWidth===xe.verticalScrollbarWidth&&W.isViewportWrapping===xe.isViewportWrapping,mt=W.lineHeight,ft=W.typicalHalfwidthCharacterWidth,lt=W.scrollBeyondLastLine,ot=W.minimap.renderCharacters;let rt=Be>=2?Math.round(W.minimap.scale*2):W.minimap.scale;const At=W.minimap.maxColumn,Rt=W.minimap.size,Ft=W.minimap.side,pt=W.verticalScrollbarWidth,kt=W.viewLineCount,Bt=W.remainingWidth,Mt=W.isViewportWrapping,Xe=ot?2:3;let Ot=Math.floor(Be*Le);const Ut=Ot/Be;let Ht=!1,bt=!1,Lt=Xe*rt,Ae=rt/Be,Oe=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:It,desiredRatio:Et,minimapLineCount:Tt}=Q.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:lt,height:Le,lineHeight:mt,pixelRatio:Be});if(kt/Tt>1)Ht=!0,bt=!0,rt=1,Lt=1,Ae=rt/Be;else{let vt=!1,yt=rt+1;if(Rt==="fit"){const zt=Math.ceil((kt+It)*Lt);Mt&&Ze&&Bt<=ae.stableFitRemainingWidth?(vt=!0,yt=ae.stableFitMaxMinimapScale):vt=zt>Ot}if(Rt==="fill"||vt){Ht=!0;const zt=rt;Lt=Math.min(mt*Be,Math.max(1,Math.floor(1/Et))),Mt&&Ze&&Bt<=ae.stableFitRemainingWidth&&(yt=ae.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(Lt/Xe))),rt>zt&&(Oe=Math.min(2,rt/zt)),Ae=rt/Be/Oe,Ot=Math.ceil(Math.max(tt,kt+It)*Lt),Mt?(ae.stableMinimapLayoutInput=W,ae.stableFitRemainingWidth=Bt,ae.stableFitMaxMinimapScale=rt):(ae.stableMinimapLayoutInput=null,ae.stableFitRemainingWidth=0)}}}const Ee=Math.floor(At*Ae),te=Math.min(Ee,Math.max(0,Math.floor((Bt-pt-2)*Ae/(ft+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*te);const $e=Ne/Be;Ne=Math.floor(Ne*Oe);const Qe=ot?1:2,Ve=Ft==="left"?0:De-te-pt;return{renderMinimap:Qe,minimapLeft:Ve,minimapWidth:te,minimapHeightIsEditorHeight:Ht,minimapIsSampling:bt,minimapScale:rt,minimapLineHeight:Lt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout(W,ae){const De=ae.outerWidth|0,Le=ae.outerHeight|0,Be=ae.lineHeight|0,xe=ae.lineNumbersDigitCount|0,Ze=ae.typicalHalfwidthCharacterWidth,mt=ae.maxDigitWidth,ft=ae.pixelRatio,lt=ae.viewLineCount,ot=W.get(128),rt=ot==="inherit"?W.get(127):ot,At=rt==="inherit"?W.get(123):rt,Rt=W.get(126),Ft=ae.isDominatedByLongLines,pt=W.get(52),kt=W.get(62).renderType!==0,Bt=W.get(63),Mt=W.get(97),Xe=W.get(67),Ot=W.get(95),Ut=Ot.verticalScrollbarSize,Ht=Ot.verticalHasArrows,bt=Ot.arrowSize,Lt=Ot.horizontalScrollbarSize,Ae=W.get(38),Oe=W.get(102)!=="never";let Ee=W.get(60);Ae&&Oe&&(Ee+=16);let te=0;if(kt){const St=Math.max(xe,Bt);te=Math.round(St*mt)}let Ne=0;pt&&(Ne=Be);let $e=0,Qe=$e+Ne,Ve=Qe+te,tt=Ve+Ee;const It=De-Ne-te-Ee;let Et=!1,Tt=!1,wt=-1;rt==="inherit"&&Ft?(Et=!0,Tt=!0):At==="on"||At==="bounded"?Tt=!0:At==="wordWrapColumn"&&(wt=Rt);const vt=Q.c({outerWidth:De,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:ft,scrollBeyondLastLine:Mt,minimap:Xe,verticalScrollbarWidth:Ut,viewLineCount:lt,remainingWidth:It,isViewportWrapping:Tt},ae.memory||new R);vt.renderMinimap!==0&&vt.minimapLeft===0&&($e+=vt.minimapWidth,Qe+=vt.minimapWidth,Ve+=vt.minimapWidth,tt+=vt.minimapWidth);const yt=It-vt.minimapWidth,zt=Math.max(1,Math.floor((yt-Ut-2)/Ze)),Xt=Ht?bt:0;return Tt&&(wt=Math.max(1,zt),At==="bounded"&&(wt=Math.min(wt,Rt))),{width:De,height:Le,glyphMarginLeft:$e,glyphMarginWidth:Ne,lineNumbersLeft:Qe,lineNumbersWidth:te,decorationsLeft:Ve,decorationsWidth:Ee,contentLeft:tt,contentWidth:yt,minimap:vt,viewportColumn:zt,isWordWrapMinified:Et,isViewportWrapping:Tt,wrappingColumn:wt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Lt,overviewRuler:{top:Xt,width:Ut,height:Le-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=Q;class Y extends P{constructor(){super(130,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(W){return o(W,"simple",["simple","advanced"])}compute(W,ae,De){return ae.get(2)===2?"advanced":De}}class ce extends P{constructor(){const W={enabled:!0};super(59,"lightbulb",W,{"editor.lightbulb.enabled":{type:"boolean",default:W.enabled,description:a.localize(49,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:g(W.enabled,this.defaultValue.enabled)}}}class ie extends P{constructor(){const W={enabled:!1,maxLineCount:5};super(107,"stickyScroll",W,{"editor.stickyScroll.enabled":{type:"boolean",default:W.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:W.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(ae.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class fe extends P{constructor(){const W={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(132,"inlayHints",W,{"editor.inlayHints.enabled":{type:"string",default:W.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:W.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:W.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:W.padding,description:a.localize(59,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return typeof ae.enabled=="boolean"&&(ae.enabled=ae.enabled?"on":"off"),{enabled:o(ae.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(ae.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ae.fontFamily,this.defaultValue.fontFamily),padding:g(ae.padding,this.defaultValue.padding)}}}class J extends P{constructor(){super(60,"lineDecorationsWidth",10)}validate(W){return typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)?-parseFloat(W.substring(0,W.length-2)):f.clampedInt(W,this.defaultValue,0,1e3)}compute(W,ae,De){return De<0?f.clampedInt(-De*W.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):De}}class pe extends h{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,W=>h.clamp(W,0,150),{markdownDescription:a.localize(60,null)})}compute(W,ae,De){return W.fontInfo.lineHeight}}class we extends P{constructor(){const W={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",W,{"editor.minimap.enabled":{type:"boolean",default:W.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:W.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:W.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:W.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:W.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:W.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:W.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:W.maxColumn,description:a.localize(71,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),autohide:g(ae.autohide,this.defaultValue.autohide),size:o(ae.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(ae.side,this.defaultValue.side,["right","left"]),showSlider:o(ae.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(ae.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(ae.scale,1,1,3),maxColumn:f.clampedInt(ae.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ie(oe){return oe==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Re extends P{constructor(){super(78,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{top:f.clampedInt(ae.top,0,0,1e3),bottom:f.clampedInt(ae.bottom,0,0,1e3)}}}class ze extends P{constructor(){const W={enabled:!0,cycle:!1};super(79,"parameterHints",W,{"editor.parameterHints.enabled":{type:"boolean",default:W.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:W.cycle,description:a.localize(75,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),cycle:g(ae.cycle,this.defaultValue.cycle)}}}class re extends v{constructor(){super(134)}compute(W,ae,De){return W.pixelRatio}}class ue extends P{constructor(){const W={other:"on",comments:"off",strings:"off"},ae=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(82,"quickSuggestions",W,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ae,default:W.strings,description:a.localize(79,null)},comments:{anyOf:ae,default:W.comments,description:a.localize(80,null)},other:{anyOf:ae,default:W.other,description:a.localize(81,null)}},default:W,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=W}validate(W){if(typeof W=="boolean"){const ft=W?"on":"off";return{comments:ft,strings:ft,other:ft}}if(!W||typeof W!="object")return this.defaultValue;const{other:ae,comments:De,strings:Le}=W,Be=["on","inline","off"];let xe,Ze,mt;return typeof ae=="boolean"?xe=ae?"on":"off":xe=o(ae,this.defaultValue.other,Be),typeof De=="boolean"?Ze=De?"on":"off":Ze=o(De,this.defaultValue.comments,Be),typeof Le=="boolean"?mt=Le?"on":"off":mt=o(Le,this.defaultValue.strings,Be),{other:xe,comments:Ze,strings:mt}}}var de;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Z extends P{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate(W){let ae=this.defaultValue.renderType,De=this.defaultValue.renderFn;return typeof W<"u"&&(typeof W=="function"?(ae=4,De=W):W==="interval"?ae=3:W==="relative"?ae=2:W==="on"?ae=1:ae=0),{renderType:ae,renderFn:De}}}function se(oe){const W=oe.get(90);return W==="editable"?oe.get(84):W!=="on"}e.filterValidationDecorations=se;class ne extends P{constructor(){const W=[],ae={type:"number",description:a.localize(88,null)};super(94,"rulers",W,{type:"array",items:{anyOf:[ae,{type:["object"],properties:{column:ae,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:W,description:a.localize(90,null)})}validate(W){if(Array.isArray(W)){const ae=[];for(const De of W)if(typeof De=="number")ae.push({column:f.clampedInt(De,0,0,1e4),color:null});else if(De&&typeof De=="object"){const Le=De;ae.push({column:f.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ae.sort((De,Le)=>De.column-Le.column),ae}return this.defaultValue}}function N(oe,W){if(typeof oe!="string")return W;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends P{constructor(){const W={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(95,"scrollbar",W,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:W.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:W.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:W.scrollByPage,description:a.localize(101,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W,De=f.clampedInt(ae.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=f.clampedInt(ae.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(ae.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ae.vertical,this.defaultValue.vertical),horizontal:N(ae.horizontal,this.defaultValue.horizontal),useShadows:g(ae.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(ae.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(ae.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(ae.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(ae.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:De,horizontalSliderSize:f.clampedInt(ae.horizontalSliderSize,De,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:f.clampedInt(ae.verticalSliderSize,Le,0,1e3),scrollByPage:g(ae.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends P{constructor(){const W={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(117,"unicodeHighlight",W,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:W.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:W.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:W.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:W.allowedLocales,description:a.localize(108,null)}})}applyUpdate(W,ae){let De=!1;ae.allowedCharacters&&W&&(D.equals(W.allowedCharacters,ae.allowedCharacters)||(W={...W,allowedCharacters:ae.allowedCharacters},De=!0)),ae.allowedLocales&&W&&(D.equals(W.allowedLocales,ae.allowedLocales)||(W={...W,allowedLocales:ae.allowedLocales},De=!0));const Le=super.applyUpdate(W,ae);return De?new E(Le.newValue,!0):Le}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{nonBasicASCII:Pe(ae.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(ae.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(ae.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(ae.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(ae.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(W.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(W.allowedLocales,this.defaultValue.allowedLocales)}}c(W,ae){if(typeof W!="object"||!W)return ae;const De={};for(const[Le,Be]of Object.entries(W))Be===!0&&(De[Le]=!0);return De}}class _ extends P{constructor(){const W={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",W,{"editor.inlineSuggest.enabled":{type:"boolean",default:W.enabled,description:a.localize(109,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),mode:o(ae.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class le extends P{constructor(){const W={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",W,{"editor.bracketPairColorization.enabled":{type:"boolean",default:W.enabled,markdownDescription:a.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:W.independentColorPoolPerBracketType,description:a.localize(111,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(ae.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class be extends P{constructor(){const W={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",W,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(112,null),a.localize(113,null),a.localize(114,null)],default:W.bracketPairs,description:a.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(116,null),a.localize(117,null),a.localize(118,null)],default:W.bracketPairsHorizontal,description:a.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:W.highlightActiveBracketPair,description:a.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:W.indentation,description:a.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(122,null),a.localize(123,null),a.localize(124,null)],default:W.highlightActiveIndentation,description:a.localize(125,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{bracketPairs:Pe(ae.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(ae.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(ae.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(ae.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(ae.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(oe,W,ae){const De=ae.indexOf(oe);return De===-1?W:ae[De]}class ge extends P{constructor(){const W={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(110,"suggest",W,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(126,null),a.localize(127,null)],default:W.insertMode,description:a.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:W.filterGraceful,description:a.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:W.localityBonus,description:a.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:W.shareSuggestSelections,markdownDescription:a.localize(131,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:W.snippetsPreventQuickSuggestions,description:a.localize(132,null)},"editor.suggest.showIcons":{type:"boolean",default:W.showIcons,description:a.localize(133,null)},"editor.suggest.showStatusBar":{type:"boolean",default:W.showStatusBar,description:a.localize(134,null)},"editor.suggest.preview":{type:"boolean",default:W.preview,description:a.localize(135,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:W.showInlineDetails,description:a.localize(136,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(137,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(138,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{insertMode:o(ae.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(ae.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(ae.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(ae.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(ae.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:g(ae.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:g(ae.showIcons,this.defaultValue.showIcons),showStatusBar:g(ae.showStatusBar,this.defaultValue.showStatusBar),preview:g(ae.preview,this.defaultValue.preview),previewMode:o(ae.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(ae.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(ae.showMethods,this.defaultValue.showMethods),showFunctions:g(ae.showFunctions,this.defaultValue.showFunctions),showConstructors:g(ae.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(ae.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(ae.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(ae.showFields,this.defaultValue.showFields),showVariables:g(ae.showVariables,this.defaultValue.showVariables),showClasses:g(ae.showClasses,this.defaultValue.showClasses),showStructs:g(ae.showStructs,this.defaultValue.showStructs),showInterfaces:g(ae.showInterfaces,this.defaultValue.showInterfaces),showModules:g(ae.showModules,this.defaultValue.showModules),showProperties:g(ae.showProperties,this.defaultValue.showProperties),showEvents:g(ae.showEvents,this.defaultValue.showEvents),showOperators:g(ae.showOperators,this.defaultValue.showOperators),showUnits:g(ae.showUnits,this.defaultValue.showUnits),showValues:g(ae.showValues,this.defaultValue.showValues),showConstants:g(ae.showConstants,this.defaultValue.showConstants),showEnums:g(ae.showEnums,this.defaultValue.showEnums),showEnumMembers:g(ae.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(ae.showKeywords,this.defaultValue.showKeywords),showWords:g(ae.showWords,this.defaultValue.showWords),showColors:g(ae.showColors,this.defaultValue.showColors),showFiles:g(ae.showFiles,this.defaultValue.showFiles),showReferences:g(ae.showReferences,this.defaultValue.showReferences),showFolders:g(ae.showFolders,this.defaultValue.showFolders),showTypeParameters:g(ae.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(ae.showSnippets,this.defaultValue.showSnippets),showUsers:g(ae.showUsers,this.defaultValue.showUsers),showIssues:g(ae.showIssues,this.defaultValue.showIssues)}}}class Ce extends P{constructor(){super(105,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(169,null),default:!0,type:"boolean"}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(W.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends v{constructor(){super(135)}compute(W,ae,De){return ae.get(84)?!0:W.tabFocusMode}}var je;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(129,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(170,null),a.localize(171,null),a.localize(172,null),a.localize(173,null)],description:a.localize(174,null),default:"same"}})}validate(W){switch(W){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(W,ae,De){return ae.get(2)===2?0:De}}class et extends v{constructor(){super(137)}compute(W,ae,De){const Le=ae.get(136);return{isDominatedByLongLines:W.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends P{constructor(){const W={enabled:!0};super(32,"dropIntoEditor",W,{"editor.dropIntoEditor.enabled":{type:"boolean",default:W.enabled,markdownDescription:a.localize(175,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:g(W.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var it;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.autoClosingBrackets=5]="autoClosingBrackets",oe[oe.autoClosingDelete=6]="autoClosingDelete",oe[oe.autoClosingOvertype=7]="autoClosingOvertype",oe[oe.autoClosingQuotes=8]="autoClosingQuotes",oe[oe.autoIndent=9]="autoIndent",oe[oe.automaticLayout=10]="automaticLayout",oe[oe.autoSurround=11]="autoSurround",oe[oe.bracketPairColorization=12]="bracketPairColorization",oe[oe.guides=13]="guides",oe[oe.codeLens=14]="codeLens",oe[oe.codeLensFontFamily=15]="codeLensFontFamily",oe[oe.codeLensFontSize=16]="codeLensFontSize",oe[oe.colorDecorators=17]="colorDecorators",oe[oe.columnSelection=18]="columnSelection",oe[oe.comments=19]="comments",oe[oe.contextmenu=20]="contextmenu",oe[oe.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=22]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=24]="cursorStyle",oe[oe.cursorSurroundingLines=25]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=27]="cursorWidth",oe[oe.disableLayerHinting=28]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",oe[oe.domReadOnly=30]="domReadOnly",oe[oe.dragAndDrop=31]="dragAndDrop",oe[oe.dropIntoEditor=32]="dropIntoEditor",oe[oe.emptySelectionClipboard=33]="emptySelectionClipboard",oe[oe.extraEditorClassName=34]="extraEditorClassName",oe[oe.fastScrollSensitivity=35]="fastScrollSensitivity",oe[oe.find=36]="find",oe[oe.fixedOverflowWidgets=37]="fixedOverflowWidgets",oe[oe.folding=38]="folding",oe[oe.foldingStrategy=39]="foldingStrategy",oe[oe.foldingHighlight=40]="foldingHighlight",oe[oe.foldingImportsByDefault=41]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=42]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=44]="fontFamily",oe[oe.fontInfo=45]="fontInfo",oe[oe.fontLigatures=46]="fontLigatures",oe[oe.fontSize=47]="fontSize",oe[oe.fontWeight=48]="fontWeight",oe[oe.fontVariations=49]="fontVariations",oe[oe.formatOnPaste=50]="formatOnPaste",oe[oe.formatOnType=51]="formatOnType",oe[oe.glyphMargin=52]="glyphMargin",oe[oe.gotoLocation=53]="gotoLocation",oe[oe.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",oe[oe.hover=55]="hover",oe[oe.inDiffEditor=56]="inDiffEditor",oe[oe.inlineSuggest=57]="inlineSuggest",oe[oe.letterSpacing=58]="letterSpacing",oe[oe.lightbulb=59]="lightbulb",oe[oe.lineDecorationsWidth=60]="lineDecorationsWidth",oe[oe.lineHeight=61]="lineHeight",oe[oe.lineNumbers=62]="lineNumbers",oe[oe.lineNumbersMinChars=63]="lineNumbersMinChars",oe[oe.linkedEditing=64]="linkedEditing",oe[oe.links=65]="links",oe[oe.matchBrackets=66]="matchBrackets",oe[oe.minimap=67]="minimap",oe[oe.mouseStyle=68]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=70]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=72]="multiCursorModifier",oe[oe.multiCursorPaste=73]="multiCursorPaste",oe[oe.multiCursorLimit=74]="multiCursorLimit",oe[oe.occurrencesHighlight=75]="occurrencesHighlight",oe[oe.overviewRulerBorder=76]="overviewRulerBorder",oe[oe.overviewRulerLanes=77]="overviewRulerLanes",oe[oe.padding=78]="padding",oe[oe.parameterHints=79]="parameterHints",oe[oe.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=82]="quickSuggestions",oe[oe.quickSuggestionsDelay=83]="quickSuggestionsDelay",oe[oe.readOnly=84]="readOnly",oe[oe.renameOnType=85]="renameOnType",oe[oe.renderControlCharacters=86]="renderControlCharacters",oe[oe.renderFinalNewline=87]="renderFinalNewline",oe[oe.renderLineHighlight=88]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=90]="renderValidationDecorations",oe[oe.renderWhitespace=91]="renderWhitespace",oe[oe.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",oe[oe.roundedSelection=93]="roundedSelection",oe[oe.rulers=94]="rulers",oe[oe.scrollbar=95]="scrollbar",oe[oe.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=97]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=98]="scrollPredominantAxis",oe[oe.selectionClipboard=99]="selectionClipboard",oe[oe.selectionHighlight=100]="selectionHighlight",oe[oe.selectOnLineNumbers=101]="selectOnLineNumbers",oe[oe.showFoldingControls=102]="showFoldingControls",oe[oe.showUnused=103]="showUnused",oe[oe.snippetSuggestions=104]="snippetSuggestions",oe[oe.smartSelect=105]="smartSelect",oe[oe.smoothScrolling=106]="smoothScrolling",oe[oe.stickyScroll=107]="stickyScroll",oe[oe.stickyTabStops=108]="stickyTabStops",oe[oe.stopRenderingLineAfter=109]="stopRenderingLineAfter",oe[oe.suggest=110]="suggest",oe[oe.suggestFontSize=111]="suggestFontSize",oe[oe.suggestLineHeight=112]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",oe[oe.suggestSelection=114]="suggestSelection",oe[oe.tabCompletion=115]="tabCompletion",oe[oe.tabIndex=116]="tabIndex",oe[oe.unicodeHighlighting=117]="unicodeHighlighting",oe[oe.unusualLineTerminators=118]="unusualLineTerminators",oe[oe.useShadowDOM=119]="useShadowDOM",oe[oe.useTabStops=120]="useTabStops",oe[oe.wordBreak=121]="wordBreak",oe[oe.wordSeparators=122]="wordSeparators",oe[oe.wordWrap=123]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=126]="wordWrapColumn",oe[oe.wordWrapOverride1=127]="wordWrapOverride1",oe[oe.wordWrapOverride2=128]="wordWrapOverride2",oe[oe.wrappingIndent=129]="wrappingIndent",oe[oe.wrappingStrategy=130]="wrappingStrategy",oe[oe.showDeprecated=131]="showDeprecated",oe[oe.inlayHints=132]="inlayHints",oe[oe.editorClassName=133]="editorClassName",oe[oe.pixelRatio=134]="pixelRatio",oe[oe.tabFocusMode=135]="tabFocusMode",oe[oe.layoutInfo=136]="layoutInfo",oe[oe.wrappingInfo=137]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(176,null)})),acceptSuggestionOnEnter:Me(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(177,null),""],markdownDescription:a.localize(178,null)})),accessibilitySupport:Me(new i),accessibilityPageSize:Me(new f(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(179,null),tags:["accessibility"]})),ariaLabel:Me(new b(4,"ariaLabel",a.localize(180,null))),autoClosingBrackets:Me(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(181,null),a.localize(182,null),""],description:a.localize(183,null)})),autoClosingDelete:Me(new r(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(184,null),""],description:a.localize(185,null)})),autoClosingOvertype:Me(new r(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(186,null),""],description:a.localize(187,null)})),autoClosingQuotes:Me(new r(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(188,null),a.localize(189,null),""],description:a.localize(190,null)})),autoIndent:Me(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[a.localize(191,null),a.localize(192,null),a.localize(193,null),a.localize(194,null),a.localize(195,null)],description:a.localize(196,null)})),automaticLayout:Me(new m(10,"automaticLayout",!1)),autoSurround:Me(new r(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(197,null),a.localize(198,null),a.localize(199,null),""],description:a.localize(200,null)})),bracketPairColorization:Me(new le),bracketPairGuides:Me(new be),stickyTabStops:Me(new m(108,"stickyTabStops",!1,{description:a.localize(201,null)})),codeLens:Me(new m(14,"codeLens",!0,{description:a.localize(202,null)})),codeLensFontFamily:Me(new b(15,"codeLensFontFamily","",{description:a.localize(203,null)})),codeLensFontSize:Me(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(204,null)})),colorDecorators:Me(new m(17,"colorDecorators",!0,{description:a.localize(205,null)})),columnSelection:Me(new m(18,"columnSelection",!1,{description:a.localize(206,null)})),comments:Me(new s),contextmenu:Me(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new m(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(207,null)})),cursorBlinking:Me(new c(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:a.localize(208,null)})),cursorSmoothCaretAnimation:Me(new m(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(209,null)})),cursorStyle:Me(new c(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:a.localize(210,null)})),cursorSurroundingLines:Me(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(211,null)})),cursorSurroundingLinesStyle:Me(new r(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(212,null),a.localize(213,null)],description:a.localize(214,null)})),cursorWidth:Me(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(215,null)})),disableLayerHinting:Me(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new m(30,"domReadOnly",!1)),dragAndDrop:Me(new m(31,"dragAndDrop",!0,{description:a.localize(216,null)})),emptySelectionClipboard:Me(new K),dropIntoEditor:Me(new _e),stickyScroll:Me(new ie),extraEditorClassName:Me(new b(34,"extraEditorClassName","")),fastScrollSensitivity:Me(new h(35,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:a.localize(217,null)})),find:Me(new G),fixedOverflowWidgets:Me(new m(37,"fixedOverflowWidgets",!1)),folding:Me(new m(38,"folding",!0,{description:a.localize(218,null)})),foldingStrategy:Me(new r(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(219,null),a.localize(220,null)],description:a.localize(221,null)})),foldingHighlight:Me(new m(40,"foldingHighlight",!0,{description:a.localize(222,null)})),foldingImportsByDefault:Me(new m(41,"foldingImportsByDefault",!1,{description:a.localize(223,null)})),foldingMaximumRegions:Me(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(224,null)})),unfoldOnClickAfterEndOfLine:Me(new m(43,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(225,null)})),fontFamily:Me(new b(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(226,null)})),fontInfo:Me(new F),fontLigatures2:Me(new O),fontSize:Me(new z),fontWeight:Me(new M),fontVariations:Me(new U),formatOnPaste:Me(new m(50,"formatOnPaste",!1,{description:a.localize(227,null)})),formatOnType:Me(new m(51,"formatOnType",!1,{description:a.localize(228,null)})),glyphMargin:Me(new m(52,"glyphMargin",!0,{description:a.localize(229,null)})),gotoLocation:Me(new V),hideCursorInOverviewRuler:Me(new m(54,"hideCursorInOverviewRuler",!1,{description:a.localize(230,null)})),hover:Me(new q),inDiffEditor:Me(new m(56,"inDiffEditor",!1)),letterSpacing:Me(new h(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>h.clamp(oe,-5,20),{description:a.localize(231,null)})),lightbulb:Me(new ce),lineDecorationsWidth:Me(new J),lineHeight:Me(new pe),lineNumbers:Me(new Z),lineNumbersMinChars:Me(new f(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new m(64,"linkedEditing",!1,{description:a.localize(232,null)})),links:Me(new m(65,"links",!0,{description:a.localize(233,null)})),matchBrackets:Me(new r(66,"matchBrackets","always",["always","near","never"],{description:a.localize(234,null)})),minimap:Me(new we),mouseStyle:Me(new r(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new h(69,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:a.localize(235,null)})),mouseWheelZoom:Me(new m(70,"mouseWheelZoom",!1,{markdownDescription:a.localize(236,null)})),multiCursorMergeOverlapping:Me(new m(71,"multiCursorMergeOverlapping",!0,{description:a.localize(237,null)})),multiCursorModifier:Me(new c(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ie,{markdownEnumDescriptions:[a.localize(238,null),a.localize(239,null)],markdownDescription:a.localize(240,null)})),multiCursorPaste:Me(new r(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(241,null),a.localize(242,null)],markdownDescription:a.localize(243,null)})),multiCursorLimit:Me(new f(74,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(244,null)})),occurrencesHighlight:Me(new m(75,"occurrencesHighlight",!0,{description:a.localize(245,null)})),overviewRulerBorder:Me(new m(76,"overviewRulerBorder",!0,{description:a.localize(246,null)})),overviewRulerLanes:Me(new f(77,"overviewRulerLanes",3,0,3)),padding:Me(new Re),parameterHints:Me(new ze),peekWidgetDefaultFocus:Me(new r(80,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(247,null),a.localize(248,null)],description:a.localize(249,null)})),definitionLinkOpensInPeek:Me(new m(81,"definitionLinkOpensInPeek",!1,{description:a.localize(250,null)})),quickSuggestions:Me(new ue),quickSuggestionsDelay:Me(new f(83,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(251,null)})),readOnly:Me(new m(84,"readOnly",!1)),renameOnType:Me(new m(85,"renameOnType",!1,{description:a.localize(252,null),markdownDeprecationMessage:a.localize(253,null)})),renderControlCharacters:Me(new m(86,"renderControlCharacters",!0,{description:a.localize(254,null),restricted:!0})),renderFinalNewline:Me(new m(87,"renderFinalNewline",!0,{description:a.localize(255,null)})),renderLineHighlight:Me(new r(88,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(256,null)],description:a.localize(257,null)})),renderLineHighlightOnlyWhenFocus:Me(new m(89,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(258,null)})),renderValidationDecorations:Me(new r(90,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new r(91,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(259,null),a.localize(260,null),a.localize(261,null),""],description:a.localize(262,null)})),revealHorizontalRightPadding:Me(new f(92,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new m(93,"roundedSelection",!0,{description:a.localize(263,null)})),rulers:Me(new ne),scrollbar:Me(new $),scrollBeyondLastColumn:Me(new f(96,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(264,null)})),scrollBeyondLastLine:Me(new m(97,"scrollBeyondLastLine",!0,{description:a.localize(265,null)})),scrollPredominantAxis:Me(new m(98,"scrollPredominantAxis",!0,{description:a.localize(266,null)})),selectionClipboard:Me(new m(99,"selectionClipboard",!0,{description:a.localize(267,null),included:t.isLinux})),selectionHighlight:Me(new m(100,"selectionHighlight",!0,{description:a.localize(268,null)})),selectOnLineNumbers:Me(new m(101,"selectOnLineNumbers",!0)),showFoldingControls:Me(new r(102,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(269,null),a.localize(270,null),a.localize(271,null)],description:a.localize(272,null)})),showUnused:Me(new m(103,"showUnused",!0,{description:a.localize(273,null)})),showDeprecated:Me(new m(131,"showDeprecated",!0,{description:a.localize(274,null)})),inlayHints:Me(new fe),snippetSuggestions:Me(new r(104,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(275,null),a.localize(276,null),a.localize(277,null),a.localize(278,null)],description:a.localize(279,null)})),smartSelect:Me(new Ce),smoothScrolling:Me(new m(106,"smoothScrolling",!1,{description:a.localize(280,null)})),stopRenderingLineAfter:Me(new f(109,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ge),inlineSuggest:Me(new _),suggestFontSize:Me(new f(111,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(281,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new f(112,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(282,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new m(113,"suggestOnTriggerCharacters",!0,{description:a.localize(283,null)})),suggestSelection:Me(new r(114,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(284,null),a.localize(285,null),a.localize(286,null)],description:a.localize(287,null)})),tabCompletion:Me(new r(115,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(288,null),a.localize(289,null),a.localize(290,null)],description:a.localize(291,null)})),tabIndex:Me(new f(116,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new x),unusualLineTerminators:Me(new r(118,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),useShadowDOM:Me(new m(119,"useShadowDOM",!0)),useTabStops:Me(new m(120,"useTabStops",!0,{description:a.localize(296,null)})),wordBreak:Me(new r(121,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],description:a.localize(299,null)})),wordSeparators:Me(new b(122,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:a.localize(300,null)})),wordWrap:Me(new r(123,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null),a.localize(304,null)],description:a.localize(305,null)})),wordWrapBreakAfterCharacters:Me(new b(124,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new b(125,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new f(126,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(306,null)})),wordWrapOverride1:Me(new r(127,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new r(128,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new B),pixelRatio:Me(new re),tabFocusMode:Me(new ke),layoutInfo:Me(new Q),wrappingInfo:Me(new et),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new Y)}}),define(Se[164],ye([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[165],ye([19,20]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[166],ye([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[167],ye([19,20]),function(ee,e){return ee.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[168],ye([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Se[169],ye([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Se[170],ye([19,20]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Se[171],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[172],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[173],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[174],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[175],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[176],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[177],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[178],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[179],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Se[180],ye([19,20]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Se[181],ye([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[182],ye([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[183],ye([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[184],ye([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[185],ye([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[186],ye([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[187],ye([19,20]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[188],ye([19,20]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[189],ye([1,0,10]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(A,D){this.a.set(A,D)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const D in A.contributes){const T=this.a.get(D);if(!T)continue;const S=A.contributes[D],C=Array.isArray(S)?S:[S];try{T(C,A.activationEvents)}catch(R){(0,a.onUnexpectedError)(R)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(Se[190],ye([1,0,24,42,166,309]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(m){return m=m.trim(),m==="*"||D.test(m)}e.isValidVersionStr=S;function C(m){if(!S(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=m.match(D);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=C;function R(m){if(!m)return null;const w=m.majorBase,f=m.majorMustEqual,h=m.minorBase;let b=m.minorMustEqual;const o=m.patchBase;let r=m.patchMustEqual;m.hasCaret&&(w===0||(b=!1),r=!1);let c=0;if(m.preRelease){const u=T.exec(m.preRelease);if(u){const[,i,s,n]=u;c=Date.UTC(Number(i),Number(s)-1,Number(n))}}return{majorBase:w,majorMustEqual:f,minorBase:h,minorMustEqual:b,patchBase:o,patchMustEqual:r,isMinimum:m.hasGreaterEquals,notBefore:c}}e.normalizeVersion=R;function P(m,w,f){let h;typeof m=="string"?h=R(C(m)):h=m;let b;w instanceof Date?b=w.getTime():typeof w=="string"&&(b=new Date(w).getTime());let o;if(typeof f=="string"?o=R(C(f)):o=f,!h||!o)return!1;const r=h.majorBase,c=h.minorBase,u=h.patchBase;let i=o.majorBase,s=o.minorBase,n=o.patchBase;const l=o.notBefore;let p=o.majorMustEqual,k=o.minorMustEqual,L=o.patchMustEqual;return o.isMinimum?r>i?!0:r<i?!1:c>s?!0:c<s||b&&b<l?!1:u>=n:(r===1&&i===0&&(!p||!k||!L)&&(i=1,s=0,n=0,p=!0,k=!1,L=!1),r<i?!1:r>i?!p:c<s?!1:c>s?!k:u<n?!1:u>n?!L:!(b&&b<l))}e.isValidVersion=P;function E(m,w,f,h,b){const o=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return o.push([t.default.Error,I.localize(0,null)]),o;if(typeof h.name!="string")return o.push([t.default.Error,I.localize(1,null,"name")]),o;if(typeof h.version!="string")return o.push([t.default.Error,I.localize(2,null,"version")]),o;if(!h.engines)return o.push([t.default.Error,I.localize(3,null,"engines")]),o;if(typeof h.engines.vscode!="string")return o.push([t.default.Error,I.localize(4,null,"engines.vscode")]),o;if(typeof h.extensionDependencies<"u"&&!g(h.extensionDependencies))return o.push([t.default.Error,I.localize(5,null,"extensionDependencies")]),o;if(typeof h.activationEvents<"u"){if(!g(h.activationEvents))return o.push([t.default.Error,I.localize(6,null,"activationEvents")]),o;if(typeof h.main>"u"&&typeof h.browser>"u")return o.push([t.default.Error,I.localize(7,null,"activationEvents","main")]),o}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&o.push([t.default.Warning,I.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return o.push([t.default.Error,I.localize(9,null,"main")]),o;{const u=(0,a.joinPath)(f,h.main);(0,a.isEqualOrParent)(u,f)||o.push([t.default.Warning,I.localize(10,null,u.path,f.path)])}if(typeof h.activationEvents>"u")return o.push([t.default.Error,I.localize(11,null,"activationEvents","main")]),o}if(typeof h.browser<"u"){if(typeof h.browser!="string")return o.push([t.default.Error,I.localize(12,null,"browser")]),o;{const u=(0,a.joinPath)(f,h.browser);(0,a.isEqualOrParent)(u,f)||o.push([t.default.Warning,I.localize(13,null,u.path,f.path)])}if(typeof h.activationEvents>"u")return o.push([t.default.Error,I.localize(14,null,"activationEvents","browser")]),o}if(!A.valid(h.version))return o.push([t.default.Error,I.localize(15,null)]),o;const r=[];if(!y(m,w,h,b,r))for(const u of r)o.push([t.default.Error,u]);return o}e.validateExtensionManifest=E;function y(m,w,f,h,b){return h||typeof f.main>"u"&&typeof f.browser>"u"?!0:d(m,w,f.engines.vscode,b)}e.isValidExtensionVersion=y;function v(m,w,f){return m==="*"||d(w,f,m)}e.isEngineValid=v;function d(m,w,f,h=[]){const b=R(C(f));if(!b)return h.push(I.localize(16,null,f)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return h.push(I.localize(17,null,f)),!1}else if(!b.majorMustEqual)return h.push(I.localize(18,null,f)),!1;return P(m,w,b)?!0:(h.push(I.localize(19,null,m,f)),!1)}function g(m){if(!Array.isArray(m))return!1;for(let w=0,f=m.length;w<f;w++)if(typeof m[w]!="string")return!1;return!0}}),define(Se[120],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(I,A=[],D=!1){this.ctor=I,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=a}),define(Se[87],ye([1,0,120]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var I;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function A(T,S,C){S instanceof a.SyncDescriptor||(S=new a.SyncDescriptor(S,[],Boolean(C))),t.push([T,S])}e.registerSingleton=A;function D(){return t}e.getSingletonServiceDescriptors=D}),define(Se[191],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class t{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const T=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(D);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const T of this.a.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let T=this.a.get(D);return T||(T=new a(D,A),this.a.set(D,T)),T}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,T]of this.a)A.push(`${D}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const T=new Set([A]),S=this.c(D,T);if(S)return S}}c(A,D){for(const[T,S]of A.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const C=this.c(S,D);if(C)return C;D.delete(T)}}}e.Graph=t}),define(Se[3],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=T})(a=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(D,T,S){T[a.DI_TARGET]===T?T[a.DI_DEPENDENCIES].push({id:D,index:S}):(T[a.DI_DEPENDENCIES]=[{id:D,index:S}],T[a.DI_TARGET]=T)}function I(D){if(a.serviceIds.has(D))return a.serviceIds.get(D);const T=function(S,C,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,R)};return T.toString=()=>D,a.serviceIds.set(D,T),T}e.createDecorator=I;function A(D){return D}e.refineServiceDecorator=A}),define(Se[53],ye([1,0,12,2,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=A;function D(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var T;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(m,w){const f=Object.create(null);for(const h in m)R(f,h,m[h],w);return f}e.toValuesTree=C;function R(m,w,f,h){const b=w.split("."),o=b.pop();let r=m;for(let c=0;c<b.length;c++){const u=b[c];let i=r[u];switch(typeof i){case"undefined":i=r[u]=Object.create(null);break;case"object":break;default:h(`Ignoring ${w} as ${b.slice(0,c+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[o]=f}catch{h(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=R;function P(m,w){const f=w.split(".");E(m,f)}e.removeFromValueTree=P;function E(m,w){const f=w.shift();if(w.length===0){delete m[f];return}if(Object.keys(m).indexOf(f)!==-1){const h=m[f];typeof h=="object"&&!Array.isArray(h)&&(E(h,w),Object.keys(h).length===0&&delete m[f])}}function y(m,w,f){function h(r,c){let u=r;for(const i of c){if(typeof u!="object"||u===null)return;u=u[i]}return u}const b=w.split("."),o=h(m,b);return typeof o>"u"?f:o}e.getConfigurationValue=y;function v(m,w,f){Object.keys(w).forEach(h=>{h!=="__proto__"&&(h in m?a.isObject(m[h])&&a.isObject(w[h])?v(m[h],w[h],f):f&&(m[h]=w[h]):m[h]=w[h])})}e.merge=v;function d(m,w,f){const h=m.inspect(w),b=m.inspect(f);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:h.defaultValue}e.getMigratedSettingValue=d;function g(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(Se[54],ye([1,0,11,8,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",a.isMacintosh),A.set("isLinux",a.isLinux),A.set("isWindows",a.isWindows),A.set("isWeb",a.isWeb),A.set("isMacNative",a.isMacintosh&&!a.isWeb),A.set("isEdge",a.isEdge),A.set("isFirefox",a.isFirefox),A.set("isChrome",a.isChrome),A.set("isSafari",a.isSafari);const D=Object.prototype.hasOwnProperty;var T;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return P.INSTANCE}static true(){return E.INSTANCE}static has(O){return y.create(O)}static equals(O,U){return v.create(O,U)}static notEquals(O,U){return m.create(O,U)}static regex(O,U){return c.create(O,U)}static in(O,U){return d.create(O,U)}static notIn(O,U){return g.create(O,U)}static not(O){return w.create(O)}static and(...O){return s.create(O,null,!0)}static or(...O){return n.create(O,null,!0)}static greater(O,U){return h.create(O,U)}static greaterEquals(O,U){return b.create(O,U)}static smaller(O,U){return o.create(O,U)}static smallerEquals(O,U){return r.create(O,U)}static deserialize(O,U=!1){if(!!O)return this.c(O,U)}static c(O,U){const F=O.split("||");return n.create(F.map(z=>this.d(z,U)),null,!0)}static d(O,U){const F=O.split("&&");return s.create(F.map(z=>this.f(z,U)),null,!0)}static f(O,U){if(O=O.trim(),O.indexOf("!=")>=0){const F=O.split("!=");return m.create(F[0].trim(),this.g(F[1],U))}if(O.indexOf("==")>=0){const F=O.split("==");return v.create(F[0].trim(),this.g(F[1],U))}if(O.indexOf("=~")>=0){const F=O.split("=~");return c.create(F[0].trim(),this.h(F[1],U))}if(O.indexOf(" not in ")>=0){const F=O.split(" not in ");return g.create(F[0].trim(),this.g(F[1],U))}if(O.indexOf(" in ")>=0){const F=O.split(" in ");return d.create(F[0].trim(),this.g(F[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const F=O.split(">=");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const F=O.split(">");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const F=O.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const F=O.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(O)?w.create(O.substr(1).trim()):y.create(O)}static g(O,U){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const F=/^'([^']*)'$/.exec(O);return F?F[1].trim():O}static h(O,U){if((0,t.isFalsyOrWhitespace)(O)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=O.indexOf("/"),z=O.lastIndexOf("/");if(F===z||F<0){if(U)throw new Error(`bad regexp-value '${O}', missing /-enclosure`);return console.warn(`bad regexp-value '${O}', missing /-enclosure`),null}const M=O.slice(F+1,z),V=O[z+1]==="i"?"i":"";try{return new RegExp(M,V)}catch(q){if(U)throw new Error(`bad regexp-value '${O}', parse error: ${q}`);return console.warn(`bad regexp-value '${O}', parse error: ${q}`),null}}}e.ContextKeyExpr=S;function C(G,O){const U=G?G.substituteConstants():void 0,F=O?O.substituteConstants():void 0;return!U&&!F?!0:!U||!F?!1:U.equals(F)}e.expressionsAreEqualWithConstantSubstitution=C;function R(G,O){return G.cmp(O)}class P{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class E{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class y{static create(O,U=null){const F=A.get(O);return typeof F=="boolean"?F?E.INSTANCE:P.INSTANCE:new y(O,U)}constructor(O,U){this.key=O,this.c=U,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:p(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=A.get(this.key);return typeof O=="boolean"?O?E.INSTANCE:P.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=w.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=y;class v{static create(O,U,F=null){if(typeof U=="boolean")return U?y.create(O,F):w.create(O,F);const z=A.get(O);return typeof z=="boolean"?U===(z?"true":"false")?E.INSTANCE:P.INSTANCE:new v(O,U,F)}constructor(O,U,F){this.c=O,this.d=U,this.f=F,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=A.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?E.INSTANCE:P.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class d{static create(O,U){return new d(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:k(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.f),F=O.getValue(this.d);return Array.isArray(U)?U.includes(F):typeof F=="string"&&typeof U=="object"&&U!==null?D.call(U,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class g{static create(O,U){return new g(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=11,this.c=d.create(O,U)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=g;class m{static create(O,U,F=null){if(typeof U=="boolean")return U?w.create(O,F):y.create(O,F);const z=A.get(O);return typeof z=="boolean"?U===(z?"true":"false")?P.INSTANCE:E.INSTANCE:new m(O,U,F)}constructor(O,U,F){this.c=O,this.d=U,this.f=F,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=A.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?P.INSTANCE:E.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=m;class w{static create(O,U=null){const F=A.get(O);return typeof F=="boolean"?F?P.INSTANCE:E.INSTANCE:new w(O,U)}constructor(O,U){this.c=O,this.d=U,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:p(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=A.get(this.c);return typeof O=="boolean"?O?P.INSTANCE:E.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.ContextKeyNotExpr=w;function f(G,O){if(typeof G=="string"){const U=parseFloat(G);isNaN(U)||(G=U)}return typeof G=="string"||typeof G=="number"?O(G):P.INSTANCE}class h{static create(O,U,F=null){return f(U,z=>new h(O,z,F))}constructor(O,U,F){this.c=O,this.d=U,this.f=F,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=h;class b{static create(O,U,F=null){return f(U,z=>new b(O,z,F))}constructor(O,U,F){this.c=O,this.d=U,this.f=F,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=b;class o{static create(O,U,F=null){return f(U,z=>new o(O,z,F))}constructor(O,U,F){this.c=O,this.d=U,this.f=F,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=o;class r{static create(O,U,F=null){return f(U,z=>new r(O,z,F))}constructor(O,U,F){this.c=O,this.d=U,this.f=F,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class c{static create(O,U){return new c(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const U=this.f?this.f.source:"",F=O.f?O.f.source:"";return U<F?-1:U>F?1:0}equals(O){if(O.type===this.type){const U=this.f?this.f.source:"",F=O.f?O.f.source:"";return this.d===O.d&&U===F}return!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=c;class u{static create(O){return new u(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(O){return new u(this.c.map(O))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function i(G){let O=null;for(let U=0,F=G.length;U<F;U++){const z=G[U].substituteConstants();if(G[U]!==z&&O===null){O=[];for(let M=0;M<U;M++)O[M]=G[M]}O!==null&&(O[U]=z)}return O===null?G:O}class s{static create(O,U,F){return s.d(O,U,F)}constructor(O,U){this.expr=O,this.c=U,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=R(this.expr[U],O.expr[U]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=i(this.expr);return O===this.expr?this:s.create(O,this.c,!1)}evaluate(O){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(O))return!1;return!0}static d(O,U,F){const z=[];let M=!1;for(const V of O)if(!!V){if(V.type===1){M=!0;continue}if(V.type===0)return P.INSTANCE;if(V.type===6){z.push(...V.expr);continue}z.push(V)}if(z.length===0&&M)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(R);for(let V=1;V<z.length;V++)z[V-1].equals(z[V])&&(z.splice(V,1),V--);if(z.length===1)return z[0];for(;z.length>1;){const V=z[z.length-1];if(V.type!==9)break;z.pop();const q=z.pop(),H=z.length===0,Q=n.create(V.expr.map(Y=>s.create([Y,q],null,F)),null,H);Q&&(z.push(Q),z.sort(R))}if(z.length===1)return z[0];if(F){for(let V=0;V<z.length;V++)for(let q=V+1;q<z.length;q++)if(z[V].negate().equals(z[q]))return P.INSTANCE;if(z.length===1)return z[0]}return new s(z,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new s(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());this.c=n.create(O,this,!0)}return this.c}}class n{static create(O,U,F){return n.d(O,U,F)}constructor(O,U){this.expr=O,this.c=U,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=R(this.expr[U],O.expr[U]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=i(this.expr);return O===this.expr?this:n.create(O,this.c,!1)}evaluate(O){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(O))return!0;return!1}static d(O,U,F){let z=[],M=!1;if(O){for(let V=0,q=O.length;V<q;V++){const H=O[V];if(!!H){if(H.type===0){M=!0;continue}if(H.type===1)return E.INSTANCE;if(H.type===9){z=z.concat(H.expr);continue}z.push(H)}}if(z.length===0&&M)return P.INSTANCE;z.sort(R)}if(z.length!==0){if(z.length===1)return z[0];for(let V=1;V<z.length;V++)z[V-1].equals(z[V])&&(z.splice(V,1),V--);if(z.length===1)return z[0];if(F){for(let V=0;V<z.length;V++)for(let q=V+1;q<z.length;q++)if(z[V].negate().equals(z[q]))return E.INSTANCE;if(z.length===1)return z[0]}return new n(z,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new n(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());for(;O.length>1;){const U=O.shift(),F=O.shift(),z=[];for(const M of K(U))for(const V of K(F))z.push(s.create([M,V],null,!1));O.unshift(n.create(z,null,!1))}this.c=n.create(O,this,!0)}return this.c}}class l extends y{static all(){return l.d.values()}constructor(O,U,F){super(O,null),this.f=U,typeof F=="object"?l.d.push({...F,key:O}):F!==!0&&l.d.push({key:O,description:F,type:U!=null?typeof U:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return v.create(this.key,O)}notEqualsTo(O){return m.create(this.key,O)}}e.RawContextKey=l,l.d=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(G,O){return G<O?-1:G>O?1:0}function k(G,O,U,F){return G<U?-1:G>U?1:O<F?-1:O>F?1:0}function L(G,O){if(G.type===0||O.type===1)return!0;if(G.type===9)return O.type===9?B(G.expr,O.expr):!1;if(O.type===9){for(const U of O.expr)if(L(G,U))return!0;return!1}if(G.type===6){if(O.type===6)return B(O.expr,G.expr);for(const U of G.expr)if(L(U,O))return!0;return!1}return G.equals(O)}e.implies=L;function B(G,O){let U=0,F=0;for(;U<G.length&&F<O.length;){const z=G[U].cmp(O[F]);if(z<0)return!1;z===0&&U++,F++}return U===G.length}function K(G){return G.type===9?G.expr:[G]}}),define(Se[192],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[121],ye([1,0,165,3]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function I(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function A(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function D(m,w){switch(m){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function T(m,w){return w==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(m,w,f){return T(w,f)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===f?!0:C(f).includes(m)}e.isTargetPlatformCompatible=S;function C(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function R(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=R;var P;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var E;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var y;(function(m){m.Install="install",m.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var v;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal",m.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(w,f){super(w),this.code=f,this.name=f}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Se[193],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(Se[194],ye([1,0,44,15,9,11,101,29,111,167,193]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=C.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends E{openTerminal(h,b){return this.spawnTerminal(a,h,S.getWindowsShell(),b)}spawnTerminal(h,b,o,r){const c=b.windowsExec||y.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=I.basename(c).toLowerCase();if(u==="cmder"||u==="cmder.exe")return h.spawn(c,r?[r]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return c.indexOf(" ")>=0&&i.push('""'),i.push(c),(u==="wt"||u==="wt.exe")&&i.push("-d ."),new Promise((s,n)=>{const l=g(process),p=h.spawn(o,i,{cwd:r,env:l});p.on("error",n),p.on("exit",()=>s())})}runInTerminal(h,b,o,r,c){const u="windowsExec"in c&&c.windowsExec?c.windowsExec:y.getDefaultTerminalWindows();return new Promise((i,s)=>{const n=`"${b} - ${P}"`,l=`""${o.join('" "')}" & pause"`,p=["/c","start",n,"/wait",u,"/c",l],k=Object.assign({},g(process),r);Object.keys(k).filter(K=>k[K]===null).forEach(K=>delete k[K]);const L={cwd:b,env:k,windowsVerbatimArguments:!0};a.spawn(y.b,p,L).on("error",K=>{s(m(K))}),i(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.WindowsExternalTerminalService=y,y.b="cmd.exe";class v extends E{openTerminal(h,b){return this.spawnTerminal(a,h,b)}runInTerminal(h,b,o,r,c){const u=c.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{if(u===R.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",h||P,"-w",b];for(const B of o)p.push("-a"),p.push(B);if(r){const B=Object.assign({},g(process),r);for(const K in B){const G=B[K];G===null?(p.push("-u"),p.push(K)):(p.push("-e"),p.push(`${K}=${G}`))}}let k="";const L=a.spawn(v.b,p);L.on("error",B=>{s(m(B))}),L.stderr.on("data",B=>{k+=B.toString()}),L.on("exit",B=>{if(B===0)i(void 0);else if(k){const K=k.split(`
`,1);s(new Error(K[0]))}else s(new Error(C.localize(1,null,n,B)))})}else s(new Error(C.localize(2,null,u)))})}spawnTerminal(h,b,o){const r=b.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((c,u)=>{const i=["-a",r];o&&i.push(o);const s=g(process),n=h.spawn("/usr/bin/open",i,{cwd:o,env:s});n.on("error",u),n.on("exit",()=>c())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class d extends E{openTerminal(h,b){return this.spawnTerminal(a,h,b)}runInTerminal(h,b,o,r,c){const u=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{const n=[];u.then(l=>{l.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const p=`${w(o)}; echo; read -p "${d.b}" -n1;`;n.push(`''${p}''`);const k=Object.assign({},g(process),r);Object.keys(k).filter(G=>k[G]===null).forEach(G=>delete k[G]);const L={cwd:b,env:k};let B="";const K=a.spawn(l,n,L);K.on("error",G=>{s(m(G))}),K.stderr.on("data",G=>{B+=G.toString()}),K.on("exit",G=>{if(G===0)i(void 0);else if(B){const O=B.split(`
`,1);s(new Error(O[0]))}else s(new Error(C.localize(4,null,l,G)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!A.isLinux)d.d=Promise.resolve("xterm");else{const h=await T.Promises.exists("/etc/debian_version");d.d=new Promise(b=>{h?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return d.d}spawnTerminal(h,b,o){const r=b.linuxExec?Promise.resolve(b.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((c,u)=>{r.then(i=>{const s=g(process),n=h.spawn(i,[],{cwd:o,env:s});n.on("error",u),n.on("exit",()=>c())})})}}e.LinuxExternalTerminalService=d,d.b=C.localize(3,null);function g(f){const h={...f.env};return(0,D.sanitizeProcessEnvironment)(h),h}function m(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(C.localize(5,null,f.path)):f}function w(f){let h="";for(const b of f)b.indexOf(" ")>=0?h+='"'+b+'"':h+=b,h+=" ";return h}}),define(Se[38],ye([1,0,65,9,8,12,2,168,3]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(M){return M.create===!0}e.isFileOpenForWriteOptions=C;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var P;(function(M){M[M.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function v(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=d;function g(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function m(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=m;function w(M){return y(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var f;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(V,q){super(V),this.code=q}}e.FileSystemProviderError=h;function b(M,V){const q=new h(M.toString(),V);return r(q,V),q}e.createFileSystemProviderError=b;function o(M){return M||b((0,T.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=o;function r(M,V){return M.name=V?`${V} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=r;function c(M){if(!M)return f.Unknown;if(M instanceof h)return M.code;const V=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!V)return f.Unknown;switch(V[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=c;function u(M){if(M instanceof k)return M.fileOperationResult;switch(c(M)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(V,q,H){this.resource=V,this.operation=q,this.target=H}isOperation(V){return this.operation===V}}e.FileOperationEvent=s;var n;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class l{constructor(V,q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const H=new Map;for(const Q of V){const Y=H.get(Q.type);switch(Y?Y.push([Q.resource,Q]):H.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,Y]of H)switch(Q){case 1:this.a=a.TernarySearchTree.forUris(()=>q),this.a.fill(Y);break;case 0:this.b=a.TernarySearchTree.forUris(()=>q),this.b.fill(Y);break;case 2:this.c=a.TernarySearchTree.forUris(()=>q),this.c.fill(Y);break}}contains(V,...q){return this.d(V,{includeChildren:!1},...q)}affects(V,...q){return this.d(V,{includeChildren:!0},...q)}d(V,q,...H){if(!V)return!1;const Q=H.length>0;return!!((!Q||H.includes(1))&&(this.a?.get(V)||q.includeChildren&&this.a?.findSuperstr(V))||(!Q||H.includes(0))&&(this.b?.get(V)||q.includeChildren&&this.b?.findSuperstr(V))||(!Q||H.includes(2))&&(this.c?.findSubstr(V)||q.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=l;function p(M,V,q){return!M||!V||M===V||V.length>M.length?!1:(V.charAt(V.length-1)!==t.sep&&(V+=t.sep),q?(0,I.startsWithIgnoreCase)(M,V):M.indexOf(V)===0)}e.isParent=p;class k extends Error{constructor(V,q,H){super(V),this.fileOperationResult=q,this.options=H}}e.FileOperationError=k;class L extends k{constructor(V,q,H){super(V,2,H),this.stat=q}}e.NotModifiedSinceFileOperationError=L;var B;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(B=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var K;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(K=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=G;async function O(M,V){if(!V.hasProvider(D.URI.from({scheme:M.scheme})))return new Promise(q=>{const H=V.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===M.scheme&&Q.added&&(H.dispose(),q())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<U.KB?(0,T.localize)(1,null,V.toFixed(0)):V<U.MB?(0,T.localize)(2,null,(V/U.KB).toFixed(2)):V<U.GB?(0,T.localize)(3,null,(V/U.MB).toFixed(2)):V<U.TB?(0,T.localize)(4,null,(V/U.GB).toFixed(2)):(0,T.localize)(5,null,(V/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function z(M){return{maxFileSize:M===0?300*U.MB:16*U.GB,maxHeapSize:M===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=z}),define(Se[88],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...I){this.a=new Map;for(const[A,D]of I)this.set(A,D)}set(I,A){const D=this.a.get(I);return this.a.set(I,A),D}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.ServiceCollection=a}),define(Se[195],ye([1,0,18,10,6,120,191,3,88,64]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class P extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class E{constructor(g=new S.ServiceCollection,m=!1,w,f=R){this.f=g,this.g=m,this.h=w,this.i=f,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=f?w?._globalGraph??new D.Graph(h=>h):void 0}createChild(g){return new E(g,this.g,this,this.i)}invokeFunction(g,...m){const w=v.traceInvocation(this.i,g);let f=!1;try{return g({get:b=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const o=this.m(b,w);if(!o)throw new Error(`[invokeFunction] unknown service '${b}'`);return o}},...m)}finally{f=!0,w.stop()}}createInstance(g,...m){let w,f;return g instanceof A.SyncDescriptor?(w=v.traceCreation(this.i,g.ctor),f=this.j(g.ctor,g.staticArguments.concat(m),w)):(w=v.traceCreation(this.i,g),f=this.j(g,m,w)),w.stop(),f}j(g,m=[],w){const f=T._util.getServiceDependencies(g).sort((o,r)=>o.index-r.index),h=[];for(const o of f){const r=this.m(o.id,w);r||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${o.id}.`,!1),h.push(r)}const b=f.length>0?f[0].index:m.length;if(m.length!==b){console.trace(`[createInstance] First service dependency of ${g.name} at position ${b+1} conflicts with ${m.length} static arguments`);const o=b-m.length;o>0?m=m.concat(new Array(o)):m=m.slice(0,b)}return Reflect.construct(g,m.concat(h))}k(g,m){if(this.f.get(g)instanceof A.SyncDescriptor)this.f.set(g,m);else if(this.h)this.h.k(g,m);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const m=this.f.get(g);return!m&&this.h?this.h.l(g):m}m(g,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const w=this.l(g);return w instanceof A.SyncDescriptor?this.q(g,w,m.branch(g,!0)):(m.branch(g,!1),w)}q(g,m,w){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,m,w)}finally{this.o.delete(g)}}r(g,m,w){const f=new D.Graph(o=>o.id.toString());let h=0;const b=[{id:g,desc:m,_trace:w}];for(;b.length;){const o=b.pop();if(f.lookupOrInsertNode(o),h++>1e3)throw new P(f);for(const r of T._util.getServiceDependencies(o.desc.ctor)){const c=this.l(r.id);if(c||this.u(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(o.id),String(r.id)),c instanceof A.SyncDescriptor){const u={id:r.id,desc:c,_trace:o._trace.branch(r.id,!0)};f.insertEdge(o,u),b.push(u)}}}for(;;){const o=f.roots();if(o.length===0){if(!f.isEmpty())throw new P(f);break}for(const{data:r}of o){if(this.l(r.id)instanceof A.SyncDescriptor){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}f.removeNode(r)}}return this.l(g)}s(g,m,w=[],f,h){if(this.f.get(g)instanceof A.SyncDescriptor)return this.t(g,m,w,f,h);if(this.h)return this.h.s(g,m,w,f,h);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}t(g,m,w=[],f,h){if(f){const b=new E(void 0,this.g,this,this.i);b.c=String(g);const o=new Map,r=new a.IdleValue(()=>{const c=b.j(m,w,h);for(const[u,i]of o){const s=c[u];if(typeof s=="function")for(const n of i)s.apply(c,n)}return o.clear(),c});return new Proxy(Object.create(null),{get(c,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=o.get(u);return n||(n=new C.LinkedList,o.set(u,n)),(p,k,L)=>{const B=n.push([p,k,L]);return(0,I.toDisposable)(B)}}if(u in c)return c[u];const i=r.value;let s=i[u];return typeof s!="function"||(s=s.bind(i),c[u]=s),s},set(c,u,i){return r.value[u]=i,!0},getPrototypeOf(c){return m.prototype}})}else return this.j(m,w,h)}u(g,m){if(m&&console.warn(g),this.g)throw new Error(g)}}e.InstantiationService=E;var y;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(y||(y={}));class v{static traceInvocation(g,m){return g?new v(1,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(g,m){return g?new v(0,m.name):v.c}constructor(g,m){this.type=g,this.name=m,this.g=Date.now(),this.h=[]}branch(g,m){const w=new v(2,g.toString());return this.h.push([g,m,w]),w}stop(){const g=Date.now()-this.g;v.f+=g;let m=!1;function w(h,b){const o=[],r=new Array(h+1).join("	");for(const[c,u,i]of b.h)if(u&&i){m=!0,o.push(`${r}CREATES -> ${c}`);const s=w(h+1,i);s&&o.push(s)}else o.push(`${r}uses -> ${c}`);return o.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(g>2||m)&&v.all.add(f.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v.f=0}),define(Se[13],ye([1,0,52,4,6,28,11,2,3]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function C(){return new Date().toISOString()}var R;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function P(s,n,l){switch(n){case R.Trace:s.trace(l);break;case R.Debug:s.debug(l);break;case R.Info:s.info(l);break;case R.Warning:s.warn(l);break;case R.Error:s.error(l);break;case R.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=P;function E(s){let n="";for(let l=0;l<s.length;l++){let p=s[l];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(l>0?" ":"")+p}return n}e.format=E;class y extends I.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==R.Off&&this.b<=n}}e.AbstractLogger=y;class v extends y{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...l){this.f(R.Trace)&&this.g(R.Trace,E([n,...l]))}debug(n,...l){this.f(R.Debug)&&this.g(R.Debug,E([n,...l]))}info(n,...l){this.f(R.Info)&&this.g(R.Info,E([n,...l]))}warn(n,...l){this.f(R.Warning)&&this.g(R.Warning,E([n,...l]))}error(n,...l){if(this.f(R.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.g(R.Error,E(p))}else this.g(R.Error,E([n,...l]))}flush(){}}e.AbstractMessageLogger=v;class d extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!D.isWindows}trace(n,...l){this.f(R.Trace)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...l):console.log(`[main ${C()}]`,n,...l))}debug(n,...l){this.f(R.Debug)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...l):console.log(`[main ${C()}]`,n,...l))}info(n,...l){this.f(R.Info)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...l):console.log(`[main ${C()}]`,n,...l))}warn(n,...l){this.f(R.Warning)&&(this.g?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,n,...l):console.warn(`[main ${C()}]`,n,...l))}error(n,...l){this.f(R.Error)&&(this.g?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,n,...l):console.error(`[main ${C()}]`,n,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class g extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...l){this.f(R.Trace)&&console.log("%cTRACE","color: #888",n,...l)}debug(n,...l){this.f(R.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...l)}info(n,...l){this.f(R.Info)&&console.log("%c INFO","color: #33f",n,...l)}warn(n,...l){this.f(R.Warning)&&console.log("%c WARN","color: #993",n,...l)}error(n,...l){this.f(R.Error)&&console.log("%c  ERR","color: #f33",n,...l)}dispose(){}flush(){}}e.ConsoleLogger=g;class m extends y{constructor(n,l=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(l)}trace(n,...l){this.f(R.Trace)&&this.g.log(R.Trace,[this.h(n),...l])}debug(n,...l){this.f(R.Debug)&&this.g.log(R.Debug,[this.h(n),...l])}info(n,...l){this.f(R.Info)&&this.g.log(R.Info,[this.h(n),...l])}warn(n,...l){this.f(R.Warning)&&this.g.log(R.Warning,[this.h(n),...l])}error(n,...l){this.f(R.Error)&&this.g.log(R.Error,[this.h(n),...l])}h(n){return typeof n=="string"?n:(0,a.toErrorMessage)(n,this.f(R.Trace))}dispose(){}flush(){}}e.AdapterLogger=m;class w extends y{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const l of this.g)l.setLevel(n);super.setLevel(n)}trace(n,...l){for(const p of this.g)p.trace(n,...l)}debug(n,...l){for(const p of this.g)p.debug(n,...l)}info(n,...l){for(const p of this.g)p.info(n,...l)}warn(n,...l){for(const p of this.g)p.warn(n,...l)}error(n,...l){for(const p of this.g)p.error(n,...l)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=w;class f extends I.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...l){this.b.trace(n,...l)}debug(n,...l){this.b.debug(n,...l)}info(n,...l){this.b.info(n,...l)}warn(n,...l){this.b.warn(n,...l)}error(n,...l){this.b.error(n,...l)}flush(){this.b.flush()}}e.LogService=f;class h extends I.Disposable{constructor(n,l){super(),this.c=n,this.b=new A.ResourceMap,this.B(l(p=>this.setLevel(p)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,l,p){let k=this.b.get(n)?.logger;return k||(p=l?.always?R.Trace:p,k=this.f(n,p??this.c,l),this.b.set(n,{logger:k,logLevel:p})),k}setLevel(n,l){const p=T.URI.isUri(n)?n:void 0,k=p?l:n;if(p){const L=this.b.get(p);L&&L.logLevel!==k&&(L.logLevel=k,L.logger.setLevel(k))}else this.c=k,this.b.forEach(({logLevel:L,logger:B})=>{L===void 0&&B.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return R.Info}trace(n,...l){}debug(n,...l){}info(n,...l){}warn(n,...l){}error(n,...l){}critical(n,...l){}dispose(){}flush(){}}e.NullLogger=b;class o extends b{}e.NullLogService=o;class r extends h{constructor(){super(R.Info,t.Event.None)}f(n,l,p){return new b}}e.NullLoggerService=r;function c(s){if(s.verbose)return R.Trace;if(typeof s.logLevel=="string"){const n=i(s.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(s){switch(s){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Off:return"off"}}e.LogLevelToString=u;function i(s){switch(s){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Error;case"off":return R.Off}}e.parseLogLevel=i}),define(Se[196],ye([1,0,38,13]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(I||(I={}));async function A(C,R,P,E,y){try{const v=await new Promise((g,m)=>{ee(["spdlog"],g,m)});v.setFlushOn(I.Trace);const d=await v.createAsyncRotatingLogger(C,R,P,E);return y?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function D(C,R,P){switch(R){case t.LogLevel.Trace:C.trace(P);break;case t.LogLevel.Debug:C.debug(P);break;case t.LogLevel.Info:C.info(P);break;case t.LogLevel.Warning:C.warn(P);break;case t.LogLevel.Error:C.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function T(C,R){switch(R){case t.LogLevel.Trace:C.setLevel(I.Trace);break;case t.LogLevel.Debug:C.setLevel(I.Debug);break;case t.LogLevel.Info:C.setLevel(I.Info);break;case t.LogLevel.Warning:C.setLevel(I.Warning);break;case t.LogLevel.Error:C.setLevel(I.Error);break;case t.LogLevel.Off:C.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class S extends t.AbstractMessageLogger{constructor(R,P,E,y,v){super(),this.k=[],this.setLevel(v),this.l=this.n(R,P,E,y),this.B(this.onDidChangeLogLevel(d=>{this.m&&T(this.m,d)}))}async n(R,P,E,y){const v=E?6:1,d=30/v*a.ByteSize.MB,g=await A(R,P,d,v,y);if(g){this.m=g,T(this.m,this.getLevel());for(const{level:m,message:w}of this.k)D(this.m,m,w);this.k=[]}}g(R,P){this.m?D(this.m,R,P):this.getLevel()<=R&&this.k.push({level:R,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(Se[122],ye([1,0,42,169,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(v,d){return d-v}S.compare=C;const R=Object.create(null);R[S.Error]=(0,t.localize)(0,null),R[S.Warning]=(0,t.localize)(1,null),R[S.Info]=(0,t.localize)(2,null);function P(v){return R[v]||""}S.toString=P;function E(v){switch(v){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=E;function y(v){switch(v){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=y}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const C="";function R(E){return P(E,!0)}S.makeKey=R;function P(E,y){const v=[C];return E.source?v.push(E.source.replace("\xA6","\\\xA6")):v.push(C),E.code?typeof E.code=="string"?v.push(E.code.replace("\xA6","\\\xA6")):v.push(E.code.value.replace("\xA6","\\\xA6")):v.push(C),E.severity!==void 0&&E.severity!==null?v.push(D.toString(E.severity)):v.push(C),E.message&&y?v.push(E.message.replace("\xA6","\\\xA6")):v.push(C),E.startLineNumber!==void 0&&E.startLineNumber!==null?v.push(E.startLineNumber.toString()):v.push(C),E.startColumn!==void 0&&E.startColumn!==null?v.push(E.startColumn.toString()):v.push(C),E.endLineNumber!==void 0&&E.endLineNumber!==null?v.push(E.endLineNumber.toString()):v.push(C),E.endColumn!==void 0&&E.endColumn!==null?v.push(E.endColumn.toString()):v.push(C),v.push(C),v.join("\xA6")}S.makeKeyOptionalMessage=P})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Se[197],ye([1,0,4,42,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(Se[123],ye([1,0,8,2,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function A(C,R){return t.URI.isUri(C)?(0,a.equalsIgnoreCase)(C.scheme,R):(0,a.startsWithIgnoreCase)(C,R+":")}e.matchesScheme=A;function D(C,...R){return R.some(P=>A(C,P))}e.matchesSomeScheme=D;function T(C,R){return C.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=T;function S(C){let R;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return P&&(R={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},C=C.with({fragment:""})),{selection:R,uri:C}}e.extractSelection=S}),define(Se[198],ye([1,0,11,35]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const A=a.globals.vscode.context.configuration();if(A)I=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(I=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`,serverDataFolderName:I.serverDataFolderName?`${I.serverDataFolderName}-dev`:void 0}),!I.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(I,{version:A.version})}Object.assign(I,{extensionsGallery:t.env.EXTENSIONS_GALLERY?JSON.parse(t.env.EXTENSIONS_GALLERY):I.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else I={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.74.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.74.1",commit:"1ad8d514439d5077d2b0b7ee64d2ce82a9308e5a",date:"2022-12-22T17:30:42.591Z"},Object.keys(I).length===0&&Object.assign(I,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=I}),define(Se[199],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ee,e){return function(a,t){e(a,t,ee)}};define(Se[124],ye([1,0,18,21,6,3]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(P,E){super(),this.a=new a.DeferredPromise,E.withProgress(P,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,I.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};S=qe([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends I.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new I.DisposableStore)}start(P){this.stop();const E=++this.a,y=new t.CancellationTokenSource;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,I.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,I.toDisposable)(()=>y.cancel())),this.b.add((0,I.toDisposable)(()=>this.c?this.c.done():void 0)),{id:E,token:y.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Se[43],ye([1,0,48,12]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.a=new Map}add(D,T){a.ok(t.isString(D)),a.ok(t.isObject(T)),a.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,T)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new I}),define(Se[125],ye([1,0,4,43]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,C){this.a[I(S)]=C,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Se[126],ye([1,0,17,4,12,164,53,125,43]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=S.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(o,r=!0){this.registerConfigurations([o],r)}registerConfigurations(o,r=!0){const c=this.k(o,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(o){const r=this.l(o);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:o,remove:r}){const c=[];c.push(...this.l(r)),c.push(...this.k(o,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,a.distinct)(c)})}registerDefaultConfigurations(o){const r=[],c=[];for(const{overrides:u,source:i}of o)for(const s in u)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const n=this.a.get(s),l=n?.valuesSources??new Map;if(i)for(const B of Object.keys(u[s]))l.set(B,i);const p={...n?.value||{},...u[s]};this.a.set(s,{source:i,value:p,valuesSources:l});const k=(0,D.getLanguageTagSettingPlainKey)(s),L={type:"object",default:p,description:A.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:I.isString(i)?void 0:i,defaultValueSource:i};c.push(...d(s)),this.d[s]=L,this.b.properties[s]=L}else{this.a.set(s,{value:u[s],source:i});const n=this.d[s];n&&(this.s(s,n),this.o(s,n))}this.registerOverrideIdentifiers(c),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const r=[];for(const{overrides:c,source:u}of o)for(const i in c){const s=this.a.get(i),n=I.isString(u)?u:u?.id,l=I.isString(s?.source)?s?.source:s?.source?.id;if(n===l)if(r.push(i),this.a.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.d[i],delete this.b.properties[i];else{const p=this.d[i];p&&(this.s(i,p),this.o(i,p))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this.i.fire()}registerOverrideIdentifiers(o){for(const r of o)this.h.add(r);this.q()}k(o,r){const c=[];return o.forEach(u=>{c.push(...this.m(u,r,u.extensionInfo,u.restrictedProperties)),this.c.push(u),this.n(u)}),c}l(o){const r=[],c=u=>{if(u.properties)for(const i in u.properties){r.push(i);const s=this.d[i];s?.policy?.name&&this.e.delete(s.policy.name),delete this.d[i],this.p(i,u.properties[i])}u.allOf?.forEach(i=>c(i))};for(const u of o){c(u);const i=this.c.indexOf(u);i!==-1&&this.c.splice(i,1)}return r}m(o,r=!0,c,u,i=3){i=I.isUndefinedOrNull(o.scope)?i:o.scope;const s=[],n=o.properties;if(n)for(const p in n){const k=n[p];if(r&&f(p,k)){delete n[p];continue}if(k.source=c,k.defaultDefaultValue=n[p].default,this.s(p,k),e.OVERRIDE_PROPERTY_REGEX.test(p)?k.scope=void 0:(k.scope=I.isUndefinedOrNull(k.scope)?i:k.scope,k.restricted=I.isUndefinedOrNull(k.restricted)?!!u?.includes(p):k.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.f[p]=n[p],delete n[p];continue}else this.d[p]=n[p],n[p].policy?.name&&this.e.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),s.push(p)}const l=o.allOf;if(l)for(const p of l)s.push(...this.m(p,r,c,u,i));return s}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(o){const r=c=>{const u=c.properties;if(u)for(const s in u)this.o(s,u[s]);c.allOf?.forEach(r)};r(o)}o(o,r){switch(e.allSettings.properties[o]=r,r.scope){case 1:e.applicationSettings.properties[o]=r;break;case 2:e.machineSettings.properties[o]=r;break;case 6:e.machineOverridableSettings.properties[o]=r;break;case 3:e.windowSettings.properties[o]=r;break;case 4:e.resourceSettings.properties[o]=r;break;case 5:e.resourceSettings.properties[o]=r,this.g.properties[o]=r;break}}p(o,r){switch(delete e.allSettings.properties[o],r.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.g.properties[o];break}}q(){for(const o of this.h.values()){const r=`[${o}]`,c={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,c),e.allSettings.properties[r]=c,e.applicationSettings.properties[r]=c,e.machineSettings.properties[r]=c,e.machineOverridableSettings.properties[r]=c,e.windowSettings.properties[r]=c,e.resourceSettings.properties[r]=c}this.i.fire()}r(){const o={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this.i.fire()}s(o,r){const c=this.a.get(o);let u=c?.value,i=c?.source;I.isUndefined(u)&&(u=r.defaultDefaultValue,i=void 0),I.isUndefined(u)&&(u=m(r.type)),r.default=u,r.defaultValueSource=i}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(b){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let r=v.exec(b);for(;r?.length;){const c=r[1].trim();c&&o.push(c),r=v.exec(b)}}return(0,a.distinct)(o)}e.overrideIdentifiersFromKey=d;function g(b){return b.reduce((o,r)=>`${o}[${r}]`,"")}e.keyFromOverrideIdentifiers=g;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const w=new E;S.Registry.add(e.Extensions.Configuration,w);function f(b,o){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?A.localize(7,null,b):w.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):o.policy?.name&&w.getPolicyConfigurations().get(o.policy?.name)!==void 0?A.localize(9,null,b,o.policy?.name,w.getPolicyConfigurations().get(o.policy?.name)):null:A.localize(6,null)}e.validateProperty=f;function h(){const b=[],o=w.getConfigurationProperties();for(const r of Object.keys(o))b.push([r,o[r].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=h}),define(Se[200],ye([1,0,17,4,145,6,28,23,12,2,53,126,43]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},c=[],u=[],i){this.c=r,this.d=c,this.f=u,this.raw=i,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof y)return c;const u=new v("");return u.parseRaw(c),u.configurationModel});this.g=r.reduce((c,u)=>u===c?u:c.merge(u),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}inspect(r,c){const u=this.rawConfiguration.getValue(r),i=c?this.rawConfiguration.getOverrideValue(r,c):void 0,s=c?this.rawConfiguration.override(c).getValue(r):u;return{value:u,override:i,merged:s}}getOverrideValue(r,c){const u=this.l(c);return u?r?(0,R.getConfigurationValue)(u,r):u:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const u of this.overrides)u.identifiers.includes(r)&&c.push(...u.keys);return a.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return a.distinct(r)}override(r){let c=this.b.get(r);return c||(c=this.h(r),this.b.set(r,c)),c}merge(...r){const c=T.deepClone(this.contents),u=T.deepClone(this.overrides),i=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const n of r)if(s.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(c,n.contents);for(const l of n.overrides){const[p]=u.filter(k=>a.equals(k.identifiers,l.identifiers));p?(this.j(p.contents,l.contents),p.keys.push(...l.keys),p.keys=a.distinct(p.keys)):u.push(T.deepClone(l))}for(const l of n.keys)i.indexOf(l)===-1&&i.push(l)}return new y(c,i,u,s.every(n=>n instanceof y)?void 0:s)}freeze(){return this.a=!0,this}clone(){return new y(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}h(r){const c=this.l(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const i of a.distinct([...Object.keys(this.contents),...Object.keys(c)])){let s=this.contents[i];const n=c[i];n&&(typeof s=="object"&&typeof n=="object"?(s=T.deepClone(s),this.j(s,n)):s=n),u[i]=s}return new y(u,this.keys,this.overrides)}j(r,c){for(const u of Object.keys(c)){if(u in r&&S.isObject(r[u])&&S.isObject(c[u])){this.j(r[u],c[u]);continue}r[u]=T.deepClone(c[u])}}k(r){return this.a&&!Object.isFrozen(r)?T.deepFreeze(r):r}l(r){let c=null,u=null;const i=s=>{s&&(u?this.j(u,s):u=T.deepClone(s))};for(const s of this.overrides)a.equals(s.identifiers,[r])?c=s.contents:s.identifiers.includes(r)&&i(s.contents);return i(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,c){this.m(r),(0,R.addToValueTree)(this.contents,r,c,u=>{throw new Error(u)})}removeValue(r){this.n(r)&&(0,R.removeFromValueTree)(this.contents,r)}m(r){let c=this.keys.length;for(let u=0;u<c;u++)r.indexOf(this.keys[u])===0&&(c=u);this.keys.splice(c,1,r)}n(r){const c=this.keys.indexOf(r);return c!==-1?(this.keys.splice(c,1),!0):!1}}e.ConfigurationModel=y;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!S.isUndefinedOrNull(r)){const u=this.g(r);this.parseRaw(u,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:u,keys:i,overrides:s,restricted:n,hasExcludedProperties:l}=this.h(r,c);this.b=new y(u,i,s,l?[r]:void 0),this.c=n||[]}g(r){let c={},u=null,i=[];const s=[],n=[];function l(k){Array.isArray(i)?i.push(k):u!==null&&(i[u]=k)}const p={onObjectBegin:()=>{const k={};l(k),s.push(i),i=k,u=null},onObjectProperty:k=>{u=k},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const k=[];l(k),s.push(i),i=k,u=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:l,onError:(k,L,B)=>{n.push({error:k,offset:L,length:B})}};if(r)try{I.visit(r,p),c=i[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return c}h(r,c){const u=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),i=this.j(r,u,!0,c);r=i.raw;const s=(0,R.toValuesTree)(r,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),n=Object.keys(r),l=this.l(r,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:s,keys:n,overrides:l,restricted:i.restricted,hasExcludedProperties:i.hasExcludedProperties}}j(r,c,u,i){let s=!1;if(!i?.scopes&&!i?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const n={},l=[];for(const p in r)if(P.OVERRIDE_PROPERTY_REGEX.test(p)&&u){const k=this.j(r[p],c,!1,i);n[p]=k.raw,s=s||k.hasExcludedProperties,l.push(...k.restricted)}else{const k=c[p],L=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&l.push(p),(L===void 0||i.scopes===void 0||i.scopes.includes(L))&&!(i.skipRestricted&&k?.restricted)?n[p]=r[p]:s=!0}return{raw:n,restricted:l,hasExcludedProperties:s}}l(r,c){const u=[];for(const i of Object.keys(r))if(P.OVERRIDE_PROPERTY_REGEX.test(i)){const s={};for(const n in r[i])s[n]=r[i][n];u.push({identifiers:(0,P.overrideIdentifiersFromKey)(i),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,c)})}return u}}e.ConfigurationModelParser=v;class d extends A.Disposable{constructor(r,c,u,i){super(),this.f=r,this.g=c,this.h=i,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&u.isEqual(s.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class g{constructor(r,c,u,i,s,n,l,p,k,L,B,K,G){this.a=r,this.b=c,this.value=u,this.overrideIdentifiers=i,this.c=s,this.d=n,this.f=l,this.g=p,this.h=k,this.j=L,this.k=B,this.l=K,this.m=G}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class m{constructor(r,c,u,i,s=new y,n=new y,l=new D.ResourceMap,p=new y,k=new D.ResourceMap,L=!0){this.c=r,this.d=c,this.f=u,this.g=i,this.h=s,this.j=n,this.l=l,this.m=p,this.n=k,this.p=L,this.a=null,this.b=new D.ResourceMap,this.q=null}getValue(r,c,u){return this.s(r,c,u).getValue(r)}updateValue(r,c,u={}){let i;u.resource?(i=this.n.get(u.resource),i||(i=new y,this.n.set(u.resource,i))):i=this.m,c===void 0?i.removeValue(r):i.setValue(r,c),u.resource||(this.a=null)}inspect(r,c,u){const i=this.s(r,c,u),s=a.distinct(i.overrides.map(p=>p.identifiers).flat()).filter(p=>i.getOverrideValue(r,p)!==void 0),n=this.w(c.resource,u),l=c.resource?this.n.get(c.resource)||this.m:this.m;return new g(r,c,i.getValue(r),s.length?s:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,n?n.freeze():void 0,l.inspect(r,c.overrideIdentifier))}keys(r){const c=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:c?c.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,c){this.l.set(r,c),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const u=[];if(!c){const{added:i,updated:s,removed:n}=h(this.c,r);c=[...i,...s,...n]}for(const i of c)for(const s of(0,P.overrideIdentifiersFromKey)(i)){const n=this.c.getKeysForOverrideIdentifier(s),l=r.getKeysForOverrideIdentifier(s),p=[...l.filter(k=>n.indexOf(k)===-1),...n.filter(k=>l.indexOf(k)===-1),...n.filter(k=>!T.equals(this.c.override(s).getValue(k),r.override(s).getValue(k)))];u.push([s,p])}return this.updateDefaultConfiguration(r),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:u,removed:i}=h(this.d,r),s=[...c,...u,...i];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:u,removed:i,overrides:s}=h(this.applicationConfiguration,r),n=[...c,...u,...i];return n.length&&this.updateApplicationConfiguration(r),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:u,removed:i,overrides:s}=h(this.localUserConfiguration,r),n=[...c,...u,...i];return n.length&&this.updateLocalUserConfiguration(r),{keys:n,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:u,removed:i,overrides:s}=h(this.remoteUserConfiguration,r),n=[...c,...u,...i];return n.length&&this.updateRemoteUserConfiguration(r),{keys:n,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:u,removed:i,overrides:s}=h(this.workspaceConfiguration,r),n=[...c,...u,...i];return n.length&&this.updateWorkspaceConfiguration(r),{keys:n,overrides:s}}compareAndUpdateFolderConfiguration(r,c){const u=this.r.get(r),{added:i,updated:s,removed:n,overrides:l}=h(u,c),p=[...i,...s,...n];return(p.length||!u)&&this.updateFolderConfiguration(r,c),{keys:p,overrides:l}}compareAndDeleteFolderConfiguration(r){const c=this.r.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:u,updated:i,removed:s,overrides:n}=h(c,void 0);return{keys:[...u,...i,...s],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,c,u){let i=this.t(c,u);return c.overrideIdentifier&&(i=i.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(i=i.merge(this.d)),i}t({resource:r},c){let u=this.u();if(c&&r){const i=c.getFolder(r);i&&(u=this.v(i.uri)||u);const s=this.n.get(r);s&&(u=u.merge(s))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let c=this.b.get(r);if(!c){const u=this.u(),i=this.l.get(r);i?(c=u.merge(i),this.p&&(c=c.freeze()),this.b.set(r,c)):c=u}return c}w(r,c){if(c&&r){const u=c.getFolder(r);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,c)=>{const{contents:u,overrides:i,keys:s}=this.l.get(c);return r.push([c,{contents:u,overrides:i,keys:s}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(c=>r.add(c)),this.userConfiguration.freeze().keys.forEach(c=>r.add(c)),this.j.freeze().keys.forEach(c=>r.add(c)),this.l.forEach(c=>c.freeze().keys.forEach(u=>r.add(u))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.j.freeze().getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.l.forEach(c=>c.freeze().getAllOverrideIdentifiers().forEach(u=>r.add(u))),[...r.values()]}y(r){const c=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>c.add(u)),this.j.getKeysForOverrideIdentifier(r).forEach(u=>c.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(r).forEach(i=>c.add(i))),[...c.values()]}static parse(r){const c=this.z(r.defaults),u=this.z(r.policy),i=this.z(r.application),s=this.z(r.user),n=this.z(r.workspace),l=r.folders.reduce((p,k)=>(p.set(C.URI.revive(k[0]),this.z(k[1])),p),new D.ResourceMap);return new m(c,u,i,s,new y,n,l,new y,new D.ResourceMap,!1)}static z(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=m;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,c=new Map;for(const i of o)i.keys.forEach(s=>r.add(s)),i.overrides.forEach(([s,n])=>{const l=(0,D.getOrSet)(c,s,new Set);n.forEach(p=>l.add(p))});const u=[];return c.forEach((i,s)=>u.push([s,[...i.values()]])),{keys:[...r.values()],overrides:u}}e.mergeChanges=w;class f{constructor(r,c,u,i){this.change=r,this.b=c,this.c=u,this.d=i,this.f=void 0;const s=new Set;r.keys.forEach(l=>s.add(l)),r.overrides.forEach(([,l])=>l.forEach(p=>s.add(p))),this.affectedKeys=[...s.values()];const n=new y;this.affectedKeys.forEach(l=>n.setValue(l,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=m.parse(this.b.data)),this.f}affectsConfiguration(r,c){if(this.g(this.a,r)){if(c){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.b?.workspace):void 0,i=this.c.getValue(r,c,this.d);return!T.equals(u,i)}return!0}return!1}g(r,c){let u=(0,R.toValuesTree)({[c]:!0},()=>{}),i;for(;typeof u=="object"&&(i=Object.keys(u)[0]);){if(r=r[i],!r)return!1;u=u[i]}return!0}}e.ConfigurationChangeEvent=f;function h(o,r){const{added:c,removed:u,updated:i}=b(r?.rawConfiguration,o?.rawConfiguration),s=[],n=o?.getAllOverrideIdentifiers()||[],l=r?.getAllOverrideIdentifiers()||[];if(r){const p=l.filter(k=>!n.includes(k));for(const k of p)s.push([k,r.getKeysForOverrideIdentifier(k)])}if(o){const p=n.filter(k=>!l.includes(k));for(const k of p)s.push([k,o.getKeysForOverrideIdentifier(k)])}if(r&&o){for(const p of n)if(l.includes(p)){const k=b({contents:o.getOverrideValue(void 0,p)||{},keys:o.getKeysForOverrideIdentifier(p)},{contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)});s.push([p,[...k.added,...k.removed,...k.updated]])}}return{added:c,removed:u,updated:i,overrides:s}}function b(o,r){const c=o?r?o.keys.filter(s=>r.keys.indexOf(s)===-1):[...o.keys]:[],u=r?o?r.keys.filter(s=>o.keys.indexOf(s)===-1):[...r.keys]:[],i=[];if(o&&r){for(const s of r.keys)if(o.keys.indexOf(s)!==-1){const n=(0,R.getConfigurationValue)(r.contents,s),l=(0,R.getConfigurationValue)(o.contents,s);T.equals(n,l)||i.push(s)}}return{added:c,removed:u,updated:i}}}),define(Se[127],ye([1,0,10,3]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends a.ErrorNoTelemetry{static isNotAvailable(T){return T instanceof A&&T._code===I.NotAvailable}static isTemporarilyNotAvailable(T){return T instanceof A&&T._code===I.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof A&&T._code===I.NoResolverFound}static isHandled(T){return T instanceof A&&T.isHandled}constructor(T,S=I.Unknown,C){super(T),this._message=T,this._code=S,this._detail=C,this.isHandled=S===I.NotAvailable&&C===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(Se[68],ye([1,0,15]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===a.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function I(C){if(!C)return;const R=C.indexOf("+");return R<0?C:C.substr(0,R)}e.getRemoteName=I;function A(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=A;function D(C){const{host:R,port:P}=S(C);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:P}}e.parseAuthorityWithPort=D;function T(C,R){let{host:P,port:E}=S(C);return typeof E>"u"&&(E=R),{host:P,port:E}}e.parseAuthorityWithOptionalPort=T;function S(C){const R=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const P=C.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=C.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:C,port:void 0}}}),define(Se[27],ye([1,0,8,3,68]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A;function D(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,g){if(typeof d>"u"||d===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof d=="string"||typeof g=="string"){const m=typeof d=="string"?d:d.value,w=typeof g=="string"?g:g.value;return a.equalsIgnoreCase(m,w)}return d.c===g.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=C;function R(v){return P(v)}e.isApplicationScopedExtension=R;function P(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function E(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function y(v,d){if(d){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(d)}`;return v.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[201],ye([1,0,8,121,27,11,2,10,35]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,a.compareIgnoreCase)(r.id,c.id)===0}e.areSameExtensions=C;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(c){const u=c.manifest?c.manifest.version:c.version,i=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new P(c.identifier,u,i)}static parse(c){const u=R.exec(c);return u&&u[1]&&u[2]?new P({id:u[1]},u[2],u[4]||void 0):null}constructor(c,u,i="undefined"){this.version=u,this.targetPlatform=i,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof P?C(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=P;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const c=E.exec(r);return c&&c[1]?[d(c[1]),c[2]]:[d(r),void 0]}e.getIdAndVersion=y;function v(r,c){return`${r}.${c}`}e.getExtensionId=v;function d(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function g(r,c){return d(v(r,c))}e.getGalleryExtensionId=g;function m(r,c){const u=[],i=s=>{for(const n of u)if(n.some(l=>C(c(l),c(s))))return n;return null};for(const s of r){const n=i(s);n?n.push(s):u.push([s])}return u}e.groupByExtension=m;function w(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function f(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function h(r,c){const u=[],i=c.manifest.extensionDependencies?.slice(0)??[];for(;i.length;){const s=i.shift();if(s&&u.every(n=>!C(n.identifier,{id:s}))){const n=r.filter(l=>C(l.identifier,{id:s}));n.length===1&&(u.push(n[0]),i.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=h;async function b(r,c){if(!A.isLinux)return!1;let u;try{u=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){c.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(s))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function o(r,c){const u=await b(r,c),i=(0,t.getTargetPlatform)(u?"alpine":A.platform,S.arch);return c.debug("ComputeTargetPlatform:",i),i}e.computeTargetPlatform=o}),define(Se[202],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((I,A)=>ee(["vsda"],I,A))}async createNewMessage(I){try{const A=await this.c(),D=new A.validator;if(D){const T=String(a.a++);return this.b.set(T,D),{id:T,data:D.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,A){if(!I.id)return!0;const D=this.b.get(I.id);if(!D)return!1;this.b.delete(I.id);try{return D.validate(A)==="ok"}catch{return!1}}async sign(I){try{const A=await this.c(),D=new A.signer;if(D)return D.sign(I)}catch{}return I}}e.SignService=a,a.a=1}),define(Se[203],ye([1,0,11,35,2,30]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(C){if(a.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function T(C,R,P,E,y,v,d,g,m,w){const f=Object.create(null);f["common.machineId"]=d,f.sessionID=(0,A.generateUuid)()+Date.now(),f.commitHash=y,f.version=v,f["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,a.PlatformToString)(a.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=E,f["common.product"]=w||"desktop",g&&(f["common.msftInternal"]=g);let h=0;const b=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),a.isLinuxSnap&&(f["common.snap"]="true");const o=D(P);o&&(f["common.platformDetail"]=o);try{const r=await C.readFile(I.URI.file(m));f["common.source"]=r.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=T;function S(C){const R=t.env.USERDNSDOMAIN;if(!R)return!1;const P=R.toLowerCase();return C.some(E=>P===E)}e.verifyMicrosoftInternalDomain=S}),define(Se[204],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Se[128],ye([1,0,23,12,53,68,203,204]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(s){this.value=s}}e.TrustedTelemetryValue=S;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,n){return Promise.resolve(void 0)}publicLog2(s,n){return this.publicLog(s,n)}publicLogError(s,n){return Promise.resolve(void 0)}publicLogError2(s,n){return this.publicLogError(s,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class R{async publicLog(s,n,l){}async publicLogError(s,n,l){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(i,s){return s.onDidChangeConfiguration(n=>{n.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(n.source),configurationKeys:f(n.sourceConfig)})})}e.configurationTelemetry=P;function E(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=E;function y(i,s){return!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=y;function v(i){const s=i.getValue(T.TELEMETRY_SETTING_ID),n=i.getValue("telemetry.enableCrashReporter");if(i.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function d(i){const s={},n={},l={};w(i,l);for(let p in l){p=p.length>150?p.substr(p.length-149):p;const k=l[p];typeof k=="number"?n[p]=k:typeof k=="boolean"?n[p]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${k.length}`),s[p]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(s[p]=k)}return{properties:s,measurements:n}}e.validateTelemetryData=d;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(i){if(!i)return"none";const s=(0,A.getRemoteName)(i);return g.has(s)?s:"other"}e.cleanRemoteAuthority=m;function w(i,s,n=0,l){if(!!i)for(const p of Object.getOwnPropertyNames(i)){const k=i[p],L=l?l+p:p;Array.isArray(k)?s[L]=(0,a.safeStringify)(k):k instanceof Date?s[L]=k.toISOString():(0,t.isObject)(k)?n<2?w(k,s,n+1,L+"."):s[L]=(0,a.safeStringify)(k):s[L]=k}}function f(i){if(!i)return[];const s=[];return h(s,"",i),s}function h(i,s,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(l=>h(i,s?`${s}.${l}`:l,n[l])):i.push(s)}function b(i,s){const n=i.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(n)||l}e.isInternalTelemetry=b;function o(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=o;function r(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const l=[];for(const B of s)for(;;){const K=B.exec(i);if(!K)break;l.push([K.index,B.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let L=0;for(n="";;){const B=k.exec(i);if(!B)break;const K=l.some(([G,O])=>B.index<O&&G<k.lastIndex);!p.test(B[0])&&!K&&(n+=i.substring(L,B.index)+"<REDACTED: user-file-path>",L=k.lastIndex)}return L<i.length&&(n+=i.substr(L)),n}function c(i){if(!i)return i;const s=i.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of n)if(l.regex.test(s))return`<REDACTED: ${l.label}>`;return i}function u(i,s){return(0,a.cloneAndChange)(i,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let l=n.replaceAll("%20"," ");l=r(l,s);for(const p of s)l=l.replace(p,"");return l=c(l),l}})}e.cleanData=u}),define(Se[205],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,A,D=5){const T=A(S=>{const C=typeof S=="string"?S:S.data;let R=this.a.get(I);if(R){R.data.push(C);return}const P=setTimeout(()=>this.flushBuffer(I),D);R={data:[C],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(I),T.dispose()}},this.a.set(I,R)});return T}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const A=this.a.get(I);A&&(this.a.delete(I),this.b(I,A.data.join("")))}}e.TerminalDataBufferer=a}),define(Se[206],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function t(A){return A===a.HIGH_CONTRAST_DARK||A===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function I(A){return A===a.DARK||A===a.HIGH_CONTRAST_DARK}e.isDark=I}),define(Se[89],ye([1,0,80,4,6,3,43,206]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(g){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}g.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function C(g){return{id:g}}e.themeColorFromId=C;var R;(function(g){function m(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||S.isThemeColor(u.color))}g.isThemeIcon=m;const w=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function f(u){const i=w.exec(u);if(!i)return;const[,s]=i;return{id:s}}g.fromString=f;function h(u){return{id:u}}g.fromId=h;function b(u,i){let s=u.id;const n=s.lastIndexOf("~");return n!==-1&&(s=s.substring(0,n)),i&&(s=`${s}~${i}`),{id:s}}g.modify=b;function o(u){const i=u.id.lastIndexOf("~");if(i!==-1)return u.id.substring(i+1)}g.getModifier=o;function r(u,i){return u.id===i.id&&u.color?.id===i.color?.id}g.isEqual=r;function c(u,i){return{id:u.id,color:i?C(i):void 0}}g.asThemeIcon=c,g.asClassNameArray=a.CSSIcon.asClassNameArray,g.asClassName=a.CSSIcon.asClassName,g.asCSSSelector=a.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function P(g){switch(g){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(m){return this.a.push(m),this.b.fire(m),(0,I.toDisposable)(()=>{const w=this.a.indexOf(m);this.a.splice(w,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const y=new E;D.Registry.add(e.Extensions.ThemingContribution,y);function v(g){return y.onColorThemeChange(g)}e.registerThemingParticipant=v;class d extends I.Disposable{constructor(m){super(),this.k=m,this.h=m.getColorTheme(),this.B(this.k.onDidColorThemeChange(w=>this.n(w)))}n(m){this.h=m,this.updateStyles()}updateStyles(){}w(m,w){let f=this.h.getColor(m);return f&&w&&(f=w(f,this.h)),f?f.toString():null}}e.Themable=d}),define(Se[129],ye([1,0,4,53,3,13]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function E(d,g,m,w){if(m===1)return!1;if(m===2&&P(g)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(f?.length===4&&parseInt(f[1])>=18)return!1}return d<1024}e.isPortPrivileged=E;class y{constructor(g,m,w){this.remoteAddress=g,this.localAddress=m,this.b=w,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=y;let v=class{constructor(g,m){this.i=g,this.j=m,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const g=this.j.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.e=g,g?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.f=g.elevation,this.g=g.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const g=[],m=Array.from(this.d.values());for(const w of m){const f=Array.from(w.values());for(const h of f){const b=await h.value;b&&g.push(b)}}return g}async dispose(){for(const g of this.d.values()){for(const{value:m}of g.values())await m.then(w=>w?.dispose());g.clear()}this.d.clear()}setEnvironmentTunnel(g,m,w,f,h){this.o(g,m,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:m,localAddress:w,privacy:f,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,m){(P(g)||R(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const w=this.q(g,m);if(w)return++w.refcount,w.value}openTunnel(g,m,w,f,h=!1,b,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${w} on local port ${f}.`),!g)return;if(m||(m="localhost"),this.e&&this.h.has(w)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(g,m,w,f,h,b,o);return r?r.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(m,w);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(c);return(c.tunnelRemoteHost!==m||c.tunnelRemotePort!==w)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const m=this.d.get(g.tunnelRemoteHost);if(m){const w=m.get(g.tunnelRemotePort);w&&(w.refcount--,await this.n(g.tunnelRemoteHost,g.tunnelRemotePort,w))}}}}async n(g,m,w){if(w.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${m}.`);const f=w.value.then(async h=>{h&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.d.has(g)&&this.d.get(g).delete(m),f}}async closeTunnel(g,m){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${m} `);const w=this.d.get(g);if(w&&w.has(m)){const f=w.get(m);f.refcount=0,await this.n(g,m,f)}}o(g,m,w){this.d.has(g)||this.d.set(g,new Map),this.d.get(g).set(m,{refcount:1,value:w})}async p(g,m){const w=this.d.get(g);w&&(await w.get(m)||w.delete(m),w.size===0&&this.d.delete(g))}q(g,m){const w=[g];R(g)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):P(g)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const f=w.map(h=>this.d.get(h));for(const h of f){const b=h?.get(m);if(b)return b}}canTunnel(g){return!!C(g)}s(g,m,w,f,h,b,o){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${w} on local port ${f}.`);const r=w;this.h.add(r);const c=f===void 0?w:f,u={elevationRequired:h?this.isPortPrivileged(c):!1},i={remoteAddress:{host:m,port:w},localAddressPort:f,privacy:b,public:b?b!==T.Private:void 0,protocol:o},s=g.forwardPort(i,u);return s?(this.o(m,w,s),s.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),s}};v=qe([We(0,A.ILogService),We(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(Se[207],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var t;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Se[208],ye([1,0,15]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==a.Schemas.file&&S.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=t;function I(S){if(S.folders.length)return S.folders.every(C=>t(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=I;function A(S){return I(S)?.scheme}e.getVirtualWorkspaceScheme=A;function D(S){return I(S)?.authority}e.getVirtualWorkspaceAuthority=D;function T(S){return I(S)!==void 0}e.isVirtualWorkspace=T}),define(Se[45],ye([1,0,170,9,65,24,2,3,15]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function C(r){const c=r;return typeof c?.id=="string"&&D.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(r,c){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const u=r;if(u.configuration)return{id:u.id,configPath:u.configuration};if(u.folders.length===1)return{id:u.id,uri:u.folders[0].uri}}e.toWorkspaceIdentifier=R;function P(r){const c=r;return typeof c?.id=="string"&&D.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=P;function E(r){const c=r;if(c?.uri)return{id:c.id,uri:D.URI.revive(c.uri)};const u=r;if(u?.configPath)return{id:u.id,configPath:D.URI.revive(u.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=E;var y;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function v(r){const c=r;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=v;function d(r){const c=r;return!!(c&&typeof c=="object"&&D.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=d;class g{constructor(c,u,i,s,n){this.h=c,this.j=i,this.k=s,this.l=n,this.c=I.TernarySearchTree.forUris(this.l,()=>!0),this.folders=u}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=I.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class m{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,A.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function w(r){return new m({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(r,c){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,c.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function h(r){let c;return D.URI.isUri(r)?c=r:c=r.configuration,c?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=h;function b(r,c){return!f(r,c)&&!h(r)}e.isSavedWorkspace=b;function o(r){return(typeof r=="string"?(0,t.extname)(r):(0,A.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(Se[69],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const A=this.c++;return this.b.set(A,I),this.e(),A}get(I,A){return this.b.has(I)?this.b.get(I)[A]:void 0}delete(I){this.b.delete(I),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=a,a.a=!1}),define(Se[46],ye([1,0,15,24,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(T=>{const S=this.b.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this.b.delete(T.scheme):this.b.set(T.scheme,S)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Se[25],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Se[209],ye([1,0,18]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(D,T,S){this.h=new Map,this.a=D,this.b=T,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(C=>(this.f=C,this)),this.g=this.c.onDidChangeStorage(C=>{C.shared===this.b&&C.key===this.a&&(this.f=C.value)}),this.i=new a.RunOnceScheduler(()=>{const C=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of C.values())R.complete()}catch(R){for(const P of C.values())P.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this.d}get(D,T){let S=this.f[D];return typeof S>"u"&&(S=T),S}update(D,T){this.f[D]=T;const S=this.h.get(D);if(S!==void 0)return S.p;const C=new a.DeferredPromise;return this.h.set(D,C),this.i.isScheduled()||this.i.schedule(),C.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class I extends t{setKeysForSync(D){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},D)}constructor(D,T){super(D.identifier.value,!0,T),this.j=D}}e.ExtensionGlobalMemento=I}),define(Se[210],ye([1,0,4,2]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(D){this.c=D,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(D,T,S,C){const P=this.c.getNotebookDocument(t.URI.revive(D)).acceptModelChanged(T.value,S,C);this.b.fire(P)}$acceptDirtyStateChanged(D,T){this.c.getNotebookDocument(t.URI.revive(D)).acceptDirty(T)}$acceptModelSaved(D){const T=this.c.getNotebookDocument(t.URI.revive(D));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Se[16],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[211],ye([1,0,27,4]),function(ee,e,a,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,S){I.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(T.identifier),Je(this,I,S,"f"),Fe(this,I,"f").onDidChangePassword(C=>{C.extensionId===this.a&&this.b.fire({key:C.key})})}get(T){return Fe(this,I,"f").get(this.a,T)}store(T,S){return Fe(this,I,"f").store(this.a,T,S)}delete(T){return Fe(this,I,"f").delete(this.a,T)}}e.ExtensionSecrets=A,I=new WeakMap}),define(Se[55],ye([1,0,3,129,4,16]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(S){function C(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=C;function R(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=R})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let T=class{constructor(C){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,R){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,R){return{dispose:()=>{}}}async $providePortAttributes(C,R,P,E,y){return[]}async $forwardPort(C,R){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=qe([We(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(Se[56],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=t}),define(Se[212],ye([1,0,22]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function I(T,S){if(S.serializeBuffersForPostMessage){const C=new t,R=(y,v)=>{if(v instanceof ArrayBuffer){const d=C.add(v);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(v)){const d=A(v);if(d){const g=C.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},P=JSON.stringify(T,R),E=C.buffers.map(y=>{const v=new Uint8Array(y);return a.VSBuffer.wrap(v)});return{message:P,buffers:E}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=I;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(T,S){const C=S.map(E=>{const y=new ArrayBuffer(E.byteLength);return new Uint8Array(y).set(E.buffer),y}),R=S.length?(E,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const v=y,{index:d}=v,g=C[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(g,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return y}:void 0;return{message:JSON.parse(T,R),arrayBuffers:C}}e.deserializeWebviewMessage=D}),define(Se[213],ye([1,0,109]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:A,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function I(A){return new a.URITransformer(t(A))}e.createURITransformer=I}),define(Se[130],ye([1,0,180,12,2,6,3,43,38,15]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(q){q[q.PROGRAMMATIC=1]="PROGRAMMATIC",q[q.USER=2]="USER",q[q.EDIT=3]="EDIT",q[q.NAVIGATION=4]="NAVIGATION",q[q.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var P;(function(q){q[q.IDENTICAL=1]="IDENTICAL",q[q.SIMILAR=2]="SIMILAR",q[q.DIFFERENT=3]="DIFFERENT"})(P=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(q){const H=q;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=E;function y(q,H,Q){for(const Y of Q.visibleEditorPanes)if(Y.group.id===H&&q.matches(Y.input))return Y.getViewState()}e.findViewStateForEditor=y;function v(q){if(i(q))return!1;const H=q;return I.URI.isUri(H?.resource)}e.isResourceEditorInput=v;function d(q){if(i(q))return!1;const H=q;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=d;function g(q){if(i(q)||d(q))return!1;const H=q;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function m(q){if(i(q))return!1;const H=q;return H?H.resource===void 0||H.resource.scheme===C.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;const w=/Untitled-\d+/;function f(q){return q.scheme===C.Schemas.untitled&&q.path.length>1&&!w.test(q.path)}e.isUntitledWithAssociatedResource=f;function h(q){if(i(q))return!1;const H=q;return I.URI.isUri(H?.base?.resource)&&I.URI.isUri(H?.input1?.resource)&&I.URI.isUri(H?.input2?.resource)&&I.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=h;var b;(function(q){q[q.SHORT=0]="SHORT",q[q.MEDIUM=1]="MEDIUM",q[q.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var o;(function(q){q[q.EXPLICIT=1]="EXPLICIT",q[q.AUTO=2]="AUTO",q[q.FOCUS_CHANGE=3]="FOCUS_CHANGE",q[q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(H,Q){let Y=this.a.get(H);return Y||(Y={source:H,label:Q},this.a.set(H,Y)),Y.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.SaveSourceRegistry=new r;var c;(function(q){q[q.None=0]="None",q[q.Readonly=2]="Readonly",q[q.Untitled=4]="Untitled",q[q.Singleton=8]="Singleton",q[q.RequiresTrust=16]="RequiresTrust",q[q.CanSplitInGroup=32]="CanSplitInGroup",q[q.ForceDescription=64]="ForceDescription",q[q.CanDropIntoEditor=128]="CanDropIntoEditor",q[q.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends A.Disposable{}e.AbstractEditorInput=u;function i(q){return q instanceof u}e.isEditorInput=i;function s(q){const H=q;return I.URI.isUri(H?.preferredResource)}function n(q){const H=q;return i(H?.primary)&&i(H?.secondary)}e.isSideBySideEditorInput=n;function l(q){const H=q;return i(H?.modified)&&i(H?.original)}e.isDiffEditorInput=l;function p(q){return i(q?.editor)}e.isEditorInputWithOptions=p;function k(q){const H=q;return p(q)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=k;function L(q){const H=q;return typeof H?.groupId=="number"&&i(H.editor)}e.isEditorIdentifier=L;var B;(function(q){q[q.UNKNOWN=0]="UNKNOWN",q[q.REPLACE=1]="REPLACE",q[q.MOVE=2]="MOVE",q[q.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var K;(function(q){q[q.GROUP_ACTIVE=0]="GROUP_ACTIVE",q[q.GROUP_INDEX=1]="GROUP_INDEX",q[q.GROUP_LOCKED=2]="GROUP_LOCKED",q[q.EDITOR_OPEN=3]="EDITOR_OPEN",q[q.EDITOR_CLOSE=4]="EDITOR_CLOSE",q[q.EDITOR_MOVE=5]="EDITOR_MOVE",q[q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",q[q.EDITOR_LABEL=7]="EDITOR_LABEL",q[q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",q[q.EDITOR_PIN=9]="EDITOR_PIN",q[q.EDITOR_STICKY=10]="EDITOR_STICKY",q[q.EDITOR_DIRTY=11]="EDITOR_DIRTY",q[q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(K=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var G;(function(q){q[q.PRIMARY=1]="PRIMARY",q[q.SECONDARY=2]="SECONDARY",q[q.BOTH=3]="BOTH",q[q.ANY=4]="ANY"})(G=e.SideBySideEditor||(e.SideBySideEditor={}));class O{getOriginalUri(H,Q){if(!H)return;if(h(H))return e.EditorResourceAccessor.getOriginalUri(H.result,Q);if(Q?.supportSideBySide){const{primary:ce,secondary:ie}=this.a(H);if(ce&&ie){if(Q?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===G.ANY)return this.getOriginalUri(ce,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:Q.filterByScheme});H=Q.supportSideBySide===G.PRIMARY?ce:ie}}if(d(H)||g(H)||h(H))return;const Y=s(H)?H.preferredResource:H.resource;return!Y||!Q||!Q.filterByScheme?Y:this.b(Y,Q.filterByScheme)}a(H){return n(H)||g(H)?{primary:H.primary,secondary:H.secondary}:l(H)||d(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,Q){if(!H)return;if(h(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,Q);if(Q?.supportSideBySide){const{primary:ce,secondary:ie}=this.a(H);if(ce&&ie){if(Q?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===G.ANY)return this.getCanonicalUri(ce,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:Q.filterByScheme});H=Q.supportSideBySide===G.PRIMARY?ce:ie}}if(d(H)||g(H)||h(H))return;const Y=H.resource;return!Y||!Q||!Q.filterByScheme?Y:this.b(Y,Q.filterByScheme)}b(H,Q){if(Array.isArray(Q)){if(Q.some(Y=>H.scheme===Y))return H}else if(Q===H.scheme)return H}}e.EditorResourceAccessor=new O;var U;(function(q){q[q.LEFT=0]="LEFT",q[q.RIGHT=1]="RIGHT"})(U=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(H){const Q=this.a=H.get(D.IInstantiationService);for(const[Y,ce]of this.c)this.e(Y,ce,Q);this.c.clear()}e(H,Q,Y){const ce=Y.createInstance(Q);this.d.set(H,ce)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(H,Q){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,Q,this.a):this.c.set(H,Q),(0,A.toDisposable)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new F);async function z(q,H,Q){return!q||!q.length?[]:await Promise.all(q.map(async Y=>{const ce=I.URI.revive(Y.fileUri);if(!ce){Q.info("Cannot resolve the path because it is not valid.",Y);return}if(!await H.canHandleResource(ce)){Q.info("Cannot resolve the path because it cannot be handled",Y);return}let fe=Y.exists,J=Y.type;if(typeof fe!="boolean"||typeof J!="number")try{J=(await H.stat(ce)).isDirectory?S.FileType.Directory:S.FileType.Unknown,fe=!0}catch(we){Q.error(we),fe=!1}if(!fe&&Y.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",Y);return}if(J===S.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",Y);return}const pe={...Y.options,pinned:!0};return fe?{resource:ce,options:pe}:{resource:ce,options:pe,forceUntitled:!0}}))}e.pathsToEditors=z;var M;(function(q){q[q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",q[q.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}));function V(q){const H=q;if(!H)return!1;const Q=H;if(Q.modified)return V(Q.modified);const Y=H;return!!(Y.contributionsState&&Y.viewState&&Array.isArray(Y.cursorState))}e.isTextEditorViewState=V}),define(Se[131],ye([1,0,4,18,181]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,S,C,R){const P={command:T};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.s("request",P),typeof R=="number"){const E=setTimeout(()=>{clearTimeout(E);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:T,message:(0,I.localize)(0,null,R,T)};y(v)}},R)}return C&&this.f.set(P.seq,C),P.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,S){return T.type!=="event"||S.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,t.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const S=T,C=this.f.get(S.request_seq);C&&(this.f.delete(S.request_seq),C(S));break}}}}s(T,S){S.type=T,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((S,C)=>T.set(C,S)),await(0,t.timeout)(500),T.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.f.delete(C)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=A}),define(Se[214],ye([1,0,182,54,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(49,null)});const A=E=>a.localize(50,null,E);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(51,null)};var D;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(D=e.State||(e.State={}));function T(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)("debugService");var P;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[215],ye([1,0,8,2,9,23,15]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(c,u,i){return c.replace(T,function(s,n){return u&&n.length>0&&n[0]!=="_"?s:i&&i.hasOwnProperty(n)?i[n]:s})}e.formatPII=S;function C(c){const u={};for(const i of Object.keys(c))i.startsWith("!")||(u[i]=c[i]);return u}e.filterExceptionsFromTelemetry=C;function R(c){return c.configuration.request==="attach"&&!P(c)&&(!c.parentSession||R(c.parentSession))}e.isSessionAttach=R;function P(c){let u=c.configuration.type;if(!!u)return u==="vslsShare"&&(u=c.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(u,"extensionhost")||(0,a.equalsIgnoreCase)(u,"pwa-extensionhost")?c:c.parentSession?P(c.parentSession):void 0}e.getExtensionHostDebugSession=P;function E(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=E;function y(c,u,i){let s,n=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=l.exec(c);){const k=p.index+1,L=k+p[0].length;if(k<=u&&L>=i){s=p[0],n=k;break}}if(s){const k=/\w+/g;let L=null;for(;(L=k.exec(s))&&!(L.index+1+n+L[0].length>=i););L&&(s=s.substring(0,k.lastIndex))}return s?{start:n,end:n+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=y;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(c){return!!(c&&c.match(v))}e.isUri=d;function g(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(d(c.path))return t.URI.parse(c.path);if((0,I.isAbsolute)(c.path))return t.URI.file(c.path)}return c.path}function m(c){if(typeof c.path=="object"){const u=t.URI.revive(c.path);if(u)return u.scheme===D.Schemas.file?u.fsPath:u.toString()}return c.path}function w(c,u){const i=u?g:m,s=(0,A.deepClone)(c);return h(s,(n,l)=>{n&&l&&(l.path=i(l))}),s}e.convertToDAPaths=w;function f(c,u){const i=u?g:m,s=(0,A.deepClone)(c);return h(s,(n,l)=>{!n&&l&&(l.path=i(l))}),s}e.convertToVSCPaths=f;function h(c,u){switch(c.type){case"event":{const i=c;switch(i.event){case"output":u(!1,i.body.source);break;case"loadedSource":u(!1,i.body.source);break;case"breakpoint":u(!1,i.body.breakpoint.source);break;default:break}break}case"request":{const i=c;switch(i.command){case"setBreakpoints":u(!0,i.arguments.source);break;case"breakpointLocations":u(!0,i.arguments.source);break;case"source":u(!0,i.arguments.source);break;case"gotoTargets":u(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(s=>u(!1,s));break;default:break}break}case"response":{const i=c;if(i.success&&i.body)switch(i.command){case"stackTrace":i.body.stackFrames.forEach(s=>u(!1,s.source));break;case"loadedSources":i.body.sources.forEach(s=>u(!1,s));break;case"scopes":i.body.scopes.forEach(s=>u(!1,s.source));break;case"setFunctionBreakpoints":i.body.breakpoints.forEach(s=>u(!1,s.source));break;case"setBreakpoints":i.body.breakpoints.forEach(s=>u(!1,s.source));break;case"disassemble":i.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function b(c){return c.filter(u=>!u.presentation?.hidden).sort((u,i)=>u.presentation?i.presentation?u.presentation.group?i.presentation.group?u.presentation.group!==i.presentation.group?u.presentation.group.localeCompare(i.presentation.group):o(u.presentation.order,i.presentation.order):-1:i.presentation.group?1:o(u.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=b;function o(c,u){return typeof c!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:c-u}async function r(c,u){const i=c.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(i!=="none"&&(await u.saveAll(),i==="allEditorsInActiveGroup")){const s=u.activeEditorPane;s&&s.input.resource?.scheme===D.Schemas.untitled&&await u.save({editor:s.input,groupId:s.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(Se[216],ye([1,0,44,217,23,9,11,8,29,183,131]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends R.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(m,w){this.p=w,this.r=Buffer.allocUnsafe(0),this.t=-1,m.on("data",f=>this.w(f))}sendMessage(m){if(this.p){const w=JSON.stringify(m);this.p.write(`Content-Length: ${Buffer.byteLength(w,"utf8")}${P.a}${w}`,"utf8")}}w(m){for(this.r=Buffer.concat([this.r,m]);;){if(this.t>=0){if(this.r.length>=this.t){const w=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,w.length>0)try{this.acceptMessage(JSON.parse(w))}catch(f){this.m.fire(new Error((f.message||f)+`
`+w))}continue}}else{const w=this.r.indexOf(P.a);if(w!==-1){const h=this.r.toString("utf8",0,w).split(P.b);for(const b of h){const o=b.split(P.l);o[0]==="Content-Length"&&(this.t=Number(o[1]))}this.r=this.r.slice(w+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class E extends P{startSession(){return new Promise((m,w)=>{let f=!1;this.x=this.y(()=>{this.v(this.x,this.x),m(),f=!0}),this.x.on("close",()=>{f?this.m.fire(new Error("connection closed")):w(new Error("connection closed"))}),this.x.on("error",h=>{f?this.m.fire(h):w(h)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=E;class y extends E{constructor(m){super(),this.z=m}y(m){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",m)}}e.SocketDebugAdapter=y;class v extends E{constructor(m){super(),this.z=m}y(m){return t.createConnection(this.z.path,m)}}e.NamedPipeDebugAdapter=v;class d extends P{constructor(m,w){super(),this.y=m,this.z=w}async startSession(){const m=this.y.command,w=this.y.args,f=this.y.options||{};try{if(m)if(A.isAbsolute(m)){if(!await S.Promises.exists(m))throw new Error(C.localize(0,null,m))}else m.indexOf("/")<0&&m.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.z));let h=process.env;if(f.env&&Object.keys(f.env).length>0&&(h=I.mixin(I.deepClone(process.env),f.env)),m==="node")if(Array.isArray(w)&&w.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:h,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(o.cwd=f.cwd);const r=a.fork(w[0],w.slice(1),o);if(!r.pid)throw new Error(C.localize(2,null,w[0]));this.x=r}else throw new Error(C.localize(3,null));else{const b={env:h};f.cwd&&(b.cwd=f.cwd),this.x=a.spawn(m,w,b)}this.x.on("error",b=>{this.m.fire(b)}),this.x.on("exit",(b,o)=>{this.n.fire(b)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",b=>{this.m.fire(b)}),this.x.stdin.on("error",b=>{this.m.fire(b)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(h){this.m.fire(h)}}async stopSession(){return this.x?(await this.u(),D.isWindows?new Promise((m,w)=>{const f=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(h,b,o){if(h)return w(h)});f.on("exit",m),f.on("error",w)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(m,w){if(!m)return;const f=Object.create(null);m.runtime&&(m.runtime.indexOf("./")===0?f.runtime=A.join(w,m.runtime):f.runtime=m.runtime),m.runtimeArgs&&(f.runtimeArgs=m.runtimeArgs),m.program&&(A.isAbsolute(m.program)?f.program=m.program:f.program=A.join(w,m.program)),m.args&&(f.args=m.args);const h=m;return h.win&&(f.win=d.A(h.win,w)),h.winx86&&(f.winx86=d.A(h.winx86,w)),h.windows&&(f.windows=d.A(h.windows,w)),h.osx&&(f.osx=d.A(h.osx,w)),h.linux&&(f.linux=d.A(h.linux,w)),f}static platformAdapterExecutable(m,w){let f=Object.create(null);w=w.toLowerCase();for(const u of m)if(u.contributes){const i=u.contributes.debuggers;i&&i.length>0&&i.filter(s=>typeof s.type=="string"&&T.equalsIgnoreCase(s.type,w)).forEach(s=>{const n=d.A(s,u.extensionLocation.fsPath);f=I.mixin(f,n,u.isBuiltin)})}let h;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=f.winx86||f.win||f.windows:D.isWindows?h=f.win||f.windows:D.isMacintosh?h=f.osx:D.isLinux&&(h=f.linux),h=h||f;const b=h.program||f.program,o=h.args||f.args,r=h.runtime||f.runtime,c=h.runtimeArgs||f.runtimeArgs;if(r)return{type:"executable",command:r,args:(c||[]).concat(typeof b=="string"?[b]:[]).concat(o||[])};if(b)return{type:"executable",command:b,args:o||[]}}}e.ExecutableDebugAdapter=d}),define(Se[218],ye([1,0,44,32,11]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(C,R){return new Promise((P,E)=>{let y="";const v=a.spawn(C,R);v.pid&&v.stdout.on("data",d=>{y+=d.toString()}),v.on("error",d=>{E(d)}),v.on("close",d=>{P(y)})})}async function D(C){if(C)if(I.isWindows){const R=await new Promise((P,E)=>{ee(["windows-process-tree"],P,E)});return new Promise(P=>{R.getProcessTree(C,E=>{P(!!E&&E.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(C)]).then(R=>{const P=R.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var T;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(T||(T={}));function S(C,R,P,E,y){C=C.trim().toLowerCase();let v;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?v=1:C.indexOf("cmd.exe")>=0?v=0:C.indexOf("bash")>=0?v=2:I.isWindows?v=0:v=2;let d,g=" ";switch(v){case 1:if(d=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),E){const m=(0,t.getDriveLetter)(E);m&&(g+=`${m}:; `),g+=`cd ${d(E)}; `}if(y)for(const m in y){const w=y[m];w===null?g+=`Remove-Item env:${m}; `:g+=`\${env:${m}}='${w}'; `}if(R.length>0){const m=R.shift(),w=P?m:d(m);g+=w[0]==="'"?`& ${w} `:`${w} `;for(const f of R)g+=f==="<"||f===">"||P?f:d(f),g+=" "}break;case 0:if(d=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(w=>m.includes(w))||m.length===0?`"${m}"`:m),E){const m=(0,t.getDriveLetter)(E);m&&(g+=`${m}: && `),g+=`cd ${d(E)} && `}if(y){g+='cmd /C "';for(const m in y){let w=y[m];w===null?g+=`set "${m}=" && `:(w=w.replace(/[&^|<>]/g,f=>`^${f}`),g+=`set "${m}=${w}" && `)}}for(const m of R)g+=m==="<"||m===">"||P?m:d(m),g+=" ";y&&(g+='"');break;case 2:{d=w=>(w=w.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),w.length===0?'""':w);const m=w=>/[^\w@%\/+=,.:^-]/.test(w)?`'${w.replace(/'/g,"'\\''")}'`:w;if(E&&(g+=`cd ${d(E)} ; `),y){g+="/usr/bin/env";for(const w in y){const f=y[w];f===null?g+=` -u ${m(w)}`:g+=` ${m(`${w}=${f}`)}`}g+=" "}for(const w of R)g+=w==="<"||w===">"||P?w:d(w),g+=" ";break}}return g}e.prepareCommand=S}),define(Se[90],ye([1,0,22,36,63,84,15,9,11,54]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var w;(function(z){z.scheme=D.Schemas.vscodeNotebookCell;const M=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${M.join("")}]+`),q=7;function H(J,pe){const we=pe.toString(q),Re=`${we.length<M.length?M[we.length-1]:"z"}${we}s${(0,a.encodeBase64)(a.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:z.scheme,fragment:Re})}z.generate=H;function Q(J){if(J.scheme!==z.scheme)return;const pe=J.fragment.indexOf("s");if(pe<0)return;const we=parseInt(J.fragment.substring(0,pe).replace(V,""),q),Ie=(0,a.decodeBase64)(J.fragment.substring(pe+1)).toString();if(!isNaN(we))return{handle:we,notebook:J.with({scheme:Ie,fragment:null})}}z.parse=Q;function Y(J,pe){return J.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${J.scheme!==D.Schemas.file?J.scheme:""}`})}z.generateCellOutputUri=Y;function ce(J){if(J.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!pe)return;const we=pe[1]&&pe[1]!==""?pe[1]:void 0,Ie=pe[2];return{outputId:we,notebook:J.with({scheme:Ie||D.Schemas.file,fragment:null})}}z.parseCellOutputUri=ce;function ie(J,pe,we){return z.generate(J,pe).with({scheme:we})}z.generateCellPropertyUri=ie;function fe(J,pe){if(J.scheme===pe)return z.parse(J.with({scheme:z.scheme}))}z.parseCellPropertyUri=fe})(w=e.CellUri||(e.CellUri={}));const f=z=>S.isWindows?z.replace(/\//g,"\\"):z;class h{constructor(M=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(M)].map(q=>({pattern:q,matches:t.parse(f(q))}))}sort(M){const V=new Map(I.Iterable.map(M,H=>[H,f(H)]));let q=[];for(const{matches:H}of this.d)for(const[Q,Y]of V)if(H(Y)){q.push(Q),V.delete(Q);break}return V.size&&(q=q.concat([...V.keys()].sort((H,Q)=>this.e.indexOf(H)-this.e.indexOf(Q)))),q}prioritize(M,V){const q=this.f(M);if(q===-1){this.d.unshift({pattern:M,matches:t.parse(f(M))});return}const H=new Set(V.map(Y=>this.f(Y,q)));H.delete(-1);const Q=Array.from(H).sort();this.d.splice(q+1,0,...Q.map(Y=>this.d[Y]));for(let Y=Q.length-1;Y>=0;Y--)this.d.splice(Q[Y],1)}toArray(){return this.d.map(M=>M.pattern)}f(M,V=this.d.length){const q=f(M);for(let H=0;H<V;H++)if(this.d[H].matches(q))return H;return-1}}e.MimeTypeDisplayOrder=h;function b(z,M,V,q=(H,Q)=>H===Q){const H=[];function Q(ie,fe,J){if(fe===0&&J.length===0)return;const pe=H[H.length-1];pe&&pe.start+pe.deleteCount===ie?(pe.deleteCount+=fe,pe.toInsert.push(...J)):H.push({start:ie,deleteCount:fe,toInsert:J})}let Y=0,ce=0;for(;;){if(Y===z.length){Q(Y,0,M.slice(ce));break}if(ce===M.length){Q(Y,z.length-Y,[]);break}const ie=z[Y],fe=M[ce];if(q(ie,fe)){Y+=1,ce+=1;continue}V(fe)?(Q(Y,1,[]),Y+=1):(Q(Y,0,[fe]),ce+=1)}return H}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(z){z.default="default",z.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(z){const M=z;return!!((typeof M.include=="string"||t.isRelativePattern(M.include))&&(typeof M.exclude=="string"||t.isRelativePattern(M.exclude)))}e.isDocumentExcludePattern=r;function c(z,M,V){if(Array.isArray(z.viewType)&&z.viewType.indexOf(M)>=0||z.viewType===M)return!0;if(z.filenamePattern){const q=r(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,H=r(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(t.match(q,(0,T.basename)(V.fsPath).toLowerCase()))return!(H&&t.match(H,(0,T.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class i{static create(M){return`${i.d}${M}`}static parse(M){if(M.startsWith(i.d))return M.substring(i.d.length)}}e.NotebookWorkingCopyTypeIdentifier=i,i.d="notebook/";function s(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.isTextStreamMime=s;const n=new TextDecoder;function l(z){const M=[];let V=!1;for(const q of z)(M.length===0||V)&&(M.push(q),V=!0);return B(M),F(a.VSBuffer.concat(M.map(q=>a.VSBuffer.wrap(q))))}e.compressOutputItemStreams=l;const p=`${String.fromCharCode(27)}[A`,k=p.split("").map(z=>z.charCodeAt(0)),L=10;function B(z){z.forEach((M,V)=>{if(V===0||M.length<p.length)return;const q=z[V-1],H=M.subarray(0,p.length);if(H[0]===k[0]&&H[1]===k[1]&&H[2]===k[2]){const Q=q.lastIndexOf(L);if(Q===-1)return;z[V-1]=q.subarray(0,Q),z[V]=M.subarray(p.length)}})}function K(z){let M=z;do z=M,M=z.replace(/[^\n]\x08/gm,"");while(M.length<z.length);return z}function G(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const M=z.match(/^(.*)\r+/m)[1];let V=z.match(/\r+(.*)$/m)[1];V=V+M.slice(V.length,M.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return z}const O="\b".charCodeAt(0),U="\r".charCodeAt(0);function F(z){return!z.buffer.includes(O)&&!z.buffer.includes(U)?z:a.VSBuffer.fromString(G(K(n.decode(z.buffer))))}}),define(Se[219],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Se[220],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=a;function t(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=t;function I(D){return Array.from(D.entries()).map(T=>[T[0],a(T[1].map)])}e.serializeEnvironmentVariableCollections=I;function A(D){return new Map(D.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Se[57],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(A){A.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(D,T,S=D.parent){if(D._isRoot)return new I([T]);const C=[D.id];for(let R=S;R&&R.id!==T;R=R.parent)C.push(R.id);return C.push(T),new I(C.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const T=D.indexOf("\0");return T===-1?D:D.slice(0,T)}static fromString(D){return new I(D.split("\0"))}static join(D,T){return new I([...D.path,T])}static joinToString(D,T){return D.toString()+"\0"+T}static parentId(D){const T=D.lastIndexOf("\0");return T===-1?void 0:D.slice(0,T)}static compare(D,T){return D===T?0:T.startsWith(D+"\0")?2:D.startsWith(T+"\0")?3:1}constructor(D,T=D.length){if(this.path=D,this.d=T,D.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new I(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new I(this.path,D)}compare(D){if(typeof D=="string")return I.compare(this.toString(),D);for(let T=0;T<D.d&&T<this.d;T++)if(D.path[T]!==this.path[T])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=I}),define(Se[70],ye([1,0,2,37,57]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var D;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(s){s.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),s.deserialize=n=>({range:t.Range.lift(n.range),uri:a.URI.revive(n.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var C;(function(s){s.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.serialize(n.location)}),s.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.deserialize(n.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(s,n)=>`${n?"s":"e"}${s}`;e.getMarkId=R;var P;(function(s){s.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.serialize(n.location)}),s.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.deserialize(n.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(s){s.serialize=n=>n.type===0?C.serialize(n):P.serialize(n),s.deserialize=n=>n.type===0?C.deserialize(n):P.deserialize(n)})(E=e.ITestMessage||(e.ITestMessage={}));var y;(function(s){s.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),s.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.serialize)}),s.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",d=(s,n)=>s+v+n;e.namespaceTestTag=d;const g=s=>{const n=s.indexOf(v);return{ctrlId:s.slice(0,n),tagId:s.slice(n+1)}};e.denamespaceTestTag=g;var m;(function(s){s.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),s.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?a.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(m=e.ITestItem||(e.ITestItem={}));var w;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var f;(function(s){s.serialize=n=>({expand:n.expand,item:m.serialize(n.item)}),s.deserialize=n=>({controllerId:I.TestId.root(n.item.extId),expand:n.expand,item:m.deserialize(n.item)})})(f=e.InternalTestItem||(e.InternalTestItem={}));var h;(function(s){s.serialize=n=>{let l;return n.item&&(l={},n.item.label!==void 0&&(l.label=n.item.label),n.item.tags!==void 0&&(l.tags=n.item.tags),n.item.busy!==void 0&&(l.busy=n.item.busy),n.item.uri!==void 0&&(l.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(l.range=n.item.range?.toJSON()),n.item.description!==void 0&&(l.description=n.item.description),n.item.error!==void 0&&(l.error=n.item.error),n.item.sortText!==void 0&&(l.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:l}},s.deserialize=n=>{let l;return n.item&&(l={},n.item.label!==void 0&&(l.label=n.item.label),n.item.tags!==void 0&&(l.tags=n.item.tags),n.item.busy!==void 0&&(l.busy=n.item.busy),n.item.range!==void 0&&(l.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(l.description=n.item.description),n.item.error!==void 0&&(l.error=n.item.error),n.item.sortText!==void 0&&(l.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:l}}})(h=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(s,n)=>{n.expand!==void 0&&(s.expand=n.expand),n.item!==void 0&&(s.item=s.item?Object.assign(s.item,n.item):n.item)};e.applyTestItemUpdate=b;var o;(function(s){s.serializeWithoutMessages=n=>({...f.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.serializeWithoutMessages),retired:n.retired}),s.serialize=n=>({...f.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.serialize),retired:n.retired}),s.deserialize=n=>({...f.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var r;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var c;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(s){s.deserialize=n=>n.op===0?{op:n.op,item:f.deserialize(n.item)}:n.op===1?{op:n.op,item:h.deserialize(n.item)}:n.op===2?{op:n.op,uri:a.URI.revive(n.uri),docv:n.docv}:n,s.serialize=n=>n.op===0?{op:n.op,item:f.serialize(n.item)}:n.op===1?{op:n.op,item:h.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class i{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const l=this.o();for(const p of n)switch(p.op){case 0:this.j(f.deserialize(p.item),l);break;case 1:this.k(h.deserialize(p.item),l);break;case 3:this.l(p.itemId,l);break;case 5:this.m(p.itemId);break;case 4:this.updatePendingRoots(p.amount);break;case 6:this.c.set(p.tag.id,p.tag);break;case 7:this.c.delete(p.id);break}l.complete?.()}j(n,l){const p=I.TestId.parentId(n.item.extId)?.toString();let k;if(!p)k=this.p(n),this.f.add(k),this.d.set(n.item.extId,k);else if(this.d.has(p)){const L=this.d.get(p);L.children.add(n.item.extId),k=this.p(n,L),this.d.set(n.item.extId,k)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return l.add?.(k),n.expand===2&&this.g++,k}k(n,l){const p=this.d.get(n.extId);if(!!p)return n.expand!==void 0&&(p.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(p,n),l.update?.(p),p}l(n,l){const p=this.d.get(n);if(!p)return;const k=I.TestId.parentId(p.item.extId)?.toString();k?this.d.get(k).children.delete(p.item.extId):this.f.delete(p);const L=[[n]];for(;L.length;)for(const B of L.pop()){const K=this.d.get(B);K&&(L.push(K.children),this.d.delete(B),l.remove?.(K,K!==p),K.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=i}),define(Se[91],ye([1,0,18,4,6,48,70,57]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(w){w[w.Upsert=0]="Upsert",w[w.SetTags=1]="SetTags",w[w.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",w[w.RemoveChild=3]="RemoveChild",w[w.SetProp=4]="SetProp",w[w.Bulk=5]="Bulk",w[w.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(w,f)=>w===f,P=Object.entries({range:(w,f)=>w===f?!0:!w||!f?!1:w.equalsRange(f),busy:C,label:C,description:C,error:C,sortText:C,tags:(w,f)=>!(w.length!==f.length||w.some(h=>!f.includes(h)))}),E=(w,f)=>{let h;for(const[b,o]of P)o(w[b],f[b])||(h?h[b]=f[b]:h={[b]:f[b]});return h};class y extends I.Disposable{get root(){return this.m.root}constructor(f){super(),this.m=f,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(f){this.h=f;for(const h of this.tree.values())this.G(h)}collectDiff(){const f=this.k;return this.k=[],f}pushDiff(f){switch(f.op){case 2:{for(const h of this.k)if(h.op===2&&h.uri===f.uri){h.docv=f.docv;return}break}case 1:{const h=this.k[this.k.length-1];if(h){if(h.op===1&&h.item.extId===f.item.extId){(0,D.applyTestItemUpdate)(h.item,f.item);return}if(h.op===0&&h.item.item.extId===f.item.extId){(0,D.applyTestItemUpdate)(h.item,f.item);return}}break}}this.k.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,h){const b=this.tree.get(f);if(!!b){if((b.expandLevels===void 0||h>b.expandLevels)&&(b.expandLevels=h),b.expand===1){const o=this.I(b);return o.isOpen()?this.H(b,h-1):o.wait().then(()=>this.H(b,h-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.H(b,h-1)):this.H(b,h-1)}}dispose(){for(const f of this.tree.values())this.m.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(f,h){switch(h.op){case 3:this.L(T.TestId.joinToString(f.fullId,h.id));break;case 0:this.u(h.item,f);break;case 5:for(const b of h.ops)this.p(f,b);break;case 1:this.w(h.new,h.old,f.fullId.toString());break;case 2:this.G(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:h.update}});break;case 6:this.s(f.actual.uri);break;default:(0,A.assertNever)(h)}}s(f){f&&this.pushDiff({op:2,uri:f,docv:this.m.getDocumentVersion(f)})}u(f,h){const b=T.TestId.fromExtHostTestItem(f,this.root.id,h?.actual),o=this.m.getApiFor(f);o.parent&&o.parent!==h?.actual&&this.m.getChildren(o.parent).delete(f.id);let r=this.tree.get(b.toString());if(!r){r={fullId:b,actual:f,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},f.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(f,h),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(f)}}),this.F(f,r,h);return}if(r.actual===f){this.D(f,r,h);return}if(r.actual.uri?.toString()!==f.uri?.toString())return this.L(b.toString()),this.u(f,h);const c=this.m.getChildren(r.actual),u=r.actual,i=E(this.m.toITestItem(u),this.m.toITestItem(f));this.m.getApiFor(u).listener=void 0,r.actual=f,r.expand=0,i&&(i.hasOwnProperty("tags")&&(this.w(f.tags,u.tags,b.toString()),delete i.tags),this.p(r,{op:4,update:i})),this.F(f,r,h);for(const[s,n]of c)this.m.getChildren(f).get(n.id)||this.L(T.TestId.joinToString(b,n.id));this.s(r.actual.uri)}w(f,h,b){const o=new Set(h.map(r=>r.id));for(const r of f)o.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:b,item:{tags:f.map(r=>(0,D.namespaceTestTag)(this.m.controllerId,r.id))}}}),o.forEach(this.z,this)}y(f){const h=this.j.get(f.id);h?h.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,f.id)}}))}z(f){const h=this.j.get(f);h&&!--h.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,f)}))}C(f,h){this.m.getApiFor(f).parent=h&&h.actual!==this.root?h.actual:void 0}D(f,h,b){this.C(f,b);const o=this.m.getApiFor(f);o.parent=b?.actual,o.listener=r=>this.p(h,r),this.G(h)}F(f,h,b){this.D(f,h,b);for(const[o,r]of this.m.getChildren(f))this.u(r,h)}G(f){let h;this.h?f.resolveBarrier?h=f.resolveBarrier.isOpen()?3:2:h=f.actual.canResolveChildren?1:0:h=0,h!==f.expand&&(f.expand=h,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:h}}),h===1&&f.expandLevels!==void 0&&this.I(f))}H(f,h){if(h<0)return;const b=[];for(const[o,r]of this.m.getChildren(f.actual)){const c=this.expand(T.TestId.joinToString(f.fullId,r.id),h);(0,a.isThenable)(c)&&b.push(c)}if(b.length)return Promise.all(b).then(()=>{})}I(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const r=new a.Barrier;return r.open(),r}f.expand=2,this.J(f);const h=f.resolveBarrier=new a.Barrier,b=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let o;try{o=this.h(f.actual===this.root?void 0:f.actual)}catch(r){b(r)}return(0,a.isThenable)(o)?o.catch(b).then(()=>{h.open(),this.G(f)}):(h.open(),this.G(f)),f.resolveBarrier}J(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}L(f){const h=this.tree.get(f);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const b=[h];for(;b.length;){const o=b.pop();if(!!o){this.m.getApiFor(o.actual).listener=void 0;for(const r of o.actual.tags)this.z(r.id);this.tree.delete(o.fullId.toString());for(const[r,c]of this.m.getChildren(o.actual))b.push(this.tree.get(T.TestId.joinToString(o.fullId,c.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.TestItemCollection=y;class v extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=v;class d extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class g extends Error{constructor(f,h,b){super(`TestItem with ID "${f}" is from controller "${h}" and cannot be added as a child of an item from controller "${b}".`)}}e.MixedTestItemController=g;const m=(w,f,h)=>{let b=new Map;return{get size(){return b.size},forEach(o,r){for(const c of b.values())o.call(r,c,this)},[Symbol.iterator](){return b.entries()},replace(o){const r=new Map,c=new Set(b.keys()),u={op:5,ops:[]};for(const i of o){if(!(i instanceof h))throw new d(i.id);const s=f(i).controllerId;if(s!==w.controllerId)throw new g(i.id,s,w.controllerId);if(r.has(i.id))throw new v(i.id);r.set(i.id,i),c.delete(i.id),u.ops.push({op:0,item:i})}for(const i of c.keys())u.ops.push({op:3,id:i});w.listener?.(u),b=r},add(o){if(!(o instanceof h))throw new d(o.id);b.set(o.id,o),w.listener?.({op:0,item:o})},delete(o){b.delete(o)&&w.listener?.({op:3,id:o})},get(o){return b.get(o)},toJSON(){return Array.from(b.values())}}};e.createTestItemChildren=m}),define(Se[132],ye([1,0,91]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,I=(D,T)=>{const S={controllerId:T};return t.set(D,S),S};e.createPrivateApiFor=I;const A=D=>{const T=t.get(D);if(!T)throw new a.InvalidTestItemError(D?.id||"<unknown>");return T};e.getPrivateApiFor=A}),define(Se[92],ye([1,0,15,2]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(T,S){return T.scheme===a.Schemas.http||T.scheme===a.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===a.Schemas.file&&(T=t.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:a.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=I;function A(T){return T.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function D(T){return T.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=D}),define(Se[221],ye([1,0,4,6,92]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,S,C){this.d=T,this.e=S,this.f=C,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const P of this.c.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,S,C,R,P){let E;for(const f of this.e.getVisibleTextEditors(!0))if(f.value===T){E=f;break}if(!E)throw new Error("not a visible editor");const y=this,v=this.a++,d=new a.Emitter,g=new a.Emitter,m=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(f){return(0,I.asWebviewUri)(f,y.f)}get cspSource(){return I.webviewGenericCspSource}set options(f){this.b=f,y.d.$setOptions(v,f)}get options(){return this.b}set html(f){this.a=f,y.d.$setHtml(v,f)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(f){return y.d.$postMessage(v,f)}},w=new class{constructor(){this.editor=T,this.line=S,this.height=C,this.webview=m,this.onDidDispose=g.event}dispose(){y.c.has(v)&&(y.c.delete(v),y.d.$disposeEditorInset(v),g.fire(),g.dispose(),d.dispose())}};return this.d.$createEditorInset(v,E.id,E.value.document.uri,S+1,C,R||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:T,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(T){const S=this.c.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this.c.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(Se[222],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var t;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(D,T){super(T),this.variable=D}}e.VariableError=I}),define(Se[223],ye([1,0,9,35,12,23,11,108,186,222,8]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,v,d,g){this.g=new Map,this.a=y,this.b=v,this.d=d,g&&(this.c=g.then(m=>this.h(m)))}h(y){if(D.isWindows){const v=Object.create(null);return Object.keys(y).forEach(d=>{v[d.toLowerCase()]=y[d]}),v}return y}resolveWithEnvironment(y,v,d){return this.j({env:this.h(y),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(y,v){const d={env:await this.c,userHome:await this.d};return this.j(d,y?y.uri:void 0,v)}async i(y,v,d,g){const m=A.deepClone(v);D.isWindows&&m.windows?Object.keys(m.windows).forEach(f=>m[f]=m.windows[f]):D.isMacintosh&&m.osx?Object.keys(m.osx).forEach(f=>m[f]=m.osx[f]):D.isLinux&&m.linux&&Object.keys(m.linux).forEach(f=>m[f]=m.linux[f]),delete m.windows,delete m.osx,delete m.linux;const w={env:await this.c,userHome:await this.d};return this.j(w,y?y.uri:void 0,m,d,g)}async resolveAnyAsync(y,v,d){return this.i(y,v,d)}async resolveAnyMap(y,v,d){const g=new Map;return{newConfig:await this.i(y,v,d,g),resolvedVariables:g}}resolveWithInteractionReplace(y,v,d,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,d,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this.g.has(y))throw new Error("Variable "+y+" is contributed twice.");this.g.set(y,v)}async j(y,v,d,g,m){if(I.isString(d))return this.l(y,v,d,g,m);if(Array.isArray(d))return Promise.all(d.map(w=>this.j(y,v,w,g,m)));if(I.isObject(d)){const w=Object.create(null),f=await Promise.all(Object.keys(d).map(async h=>[await this.l(y,v,h,g,m),await this.j(y,v,d[h],g,m)]));for(const[h,b]of f)w[h]=b;return w}return d}l(y,v,d,g,m){return(0,R.replaceAsync)(d,P.VARIABLE_REGEXP,async(w,f)=>{if(f.includes(P.VARIABLE_LHS))return w;let h=await this.n(y,w,f,v,g);return m?.set(f,h),h!==w&&I.isString(h)&&h.match(P.VARIABLE_REGEXP)&&(h=await this.l(y,v,h,g,m)),h})}m(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async n(y,v,d,g,m){let w;const f=d.split(":");f.length>1&&(d=f[0],w=f[1]);const h=r=>{const c=this.a.getFilePath();if(c)return c;throw new C.VariableError(r,(0,S.localize)(0,null,v))},b=r=>{const c=h(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return u}throw new C.VariableError(r,(0,S.localize)(1,null,v,a.basename(c)))},o=r=>{if(w){const c=this.a.getFolderUri(w);if(c)return c;throw new C.VariableError(r,(0,S.localize)(2,null,v,w))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new C.VariableError(r,(0,S.localize)(3,null,v)):new C.VariableError(r,(0,S.localize)(4,null,v))};switch(d){case"env":if(w){if(y.env){const r=y.env[D.isWindows?w.toLowerCase():w];if(I.isString(r))return r}return""}throw new C.VariableError(C.VariableKind.Env,(0,S.localize)(5,null,v));case"config":if(w){const r=this.a.getConfigurationValue(g,w);if(I.isUndefinedOrNull(r))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(6,null,v,w));if(I.isObject(r))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(7,null,v,w));return r}throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(8,null,v));case"command":return this.o(C.VariableKind.Command,v,w,m,"command");case"input":return this.o(C.VariableKind.Input,v,w,m,"input");case"extensionInstallFolder":if(w){const r=await this.a.getExtension(w);if(!r)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,v,w));return this.m(r.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(o(C.VariableKind.WorkspaceFolder)));case"cwd":return g||w?(0,T.normalizeDriveLetter)(this.m(o(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.m(o(C.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(y.userHome)return y.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,S.localize)(11,null,v))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new C.VariableError(C.VariableKind.LineNumber,(0,S.localize)(12,null,v))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new C.VariableError(C.VariableKind.SelectedText,(0,S.localize)(13,null,v))}case"file":return h(C.VariableKind.File);case"fileWorkspaceFolder":return b(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return g||w?a.relative(this.m(o(C.VariableKind.RelativeFile)),h(C.VariableKind.RelativeFile)):h(C.VariableKind.RelativeFile);case"relativeFileDirname":{const r=a.dirname(h(C.VariableKind.RelativeFileDirname));if(g||w){const c=a.relative(this.m(o(C.VariableKind.RelativeFileDirname)),r);return c.length===0?".":c}return r}case"fileDirname":return a.dirname(h(C.VariableKind.FileDirname));case"fileExtname":return a.extname(h(C.VariableKind.FileExtname));case"fileBasename":return a.basename(h(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=a.basename(h(C.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-a.extname(r).length)}case"fileDirnameBasename":return a.basename(a.dirname(h(C.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||v}case"execInstallFolder":{const r=this.a.getAppRoot();return r||v}case"pathSeparator":return a.sep;default:try{const r=w?`${d}:${w}`:d;return this.o(C.VariableKind.Unknown,v,r,m,void 0)}catch{return v}}}}o(y,v,d,g,m){if(d&&g){const w=m===void 0?g[d]:g[m+":"+d];if(typeof w=="string")return w;throw new C.VariableError(y,(0,S.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[133],ye([1,0,3,130]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var T;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(v){const d=v;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=C;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function E(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=E;function y(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(Se[224],ye([1,0,3,133]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(A){const D=A;return typeof A=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=I}),define(Se[225],ye([1,0,3,192]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(t.IEnvironmentService)}),define(Se[226],ye([1,0,27,4,9]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=A;class D{constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let E of P.activationEvents)E==="onUri"&&(E=`onUri:${a.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(E)||this.g.set(E,[]),this.g.get(E).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,E){this.d=C(this.d,E),this.d=this.d.concat(P);const y=D.j(this.d);return this.d=C(this.d,y.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new A(y)}static j(P){const E=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,w){this.addNode(m),this.addNode(w),this.c.has(m)?this.c.get(m).push(w):this.c.set(m,[w])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,w){const f=E.getArcs(m);for(let h=0;h<f.length;h++)if(!w.has(f[h]))return!1;return!0}getNodes(){return this.e}},y=new Map;for(const m of P){const w=a.ExtensionIdentifier.toKey(m.identifier);if(y.set(w,m),m.extensionDependencies)for(const f of m.extensionDependencies){const h=a.ExtensionIdentifier.toKey(f);E.addArc(w,h)}}const v=new Set;E.getNodes().filter(m=>E.getArcs(m).length===0).forEach(m=>v.add(m));const d=E.getNodes().filter(m=>!v.has(m));let g;do{g=!1;for(let m=0;m<d.length;m++){const w=d[m];E.hasOnlyGoodArcs(w,v)&&(d.splice(m,1),m--,v.add(w),g=!0)}}while(g);return d.map(m=>y.get(m))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(a.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const E=this.g.get(P);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const E=this.e.get(a.ExtensionIdentifier.toKey(P));return E||void 0}getExtensionDescriptionByUUID(P){for(const E of this.f)if(E.uuid===P)return E}getExtensionDescriptionByIdOrUUID(P,E){return this.getExtensionDescription(P)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=D;var T;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(T||(T={}));function S(R,P){const E=R.isBuiltin?0:R.isUnderDevelopment?2:1,y=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(E!==y)return E-y;const v=I.posix.basename(R.extensionLocation.path),d=I.posix.basename(P.extensionLocation.path);return v<d?-1:v>d?1:0}function C(R,P){const E=new Set;return P.forEach(y=>E.add(a.ExtensionIdentifier.toKey(y))),R.filter(y=>!E.has(a.ExtensionIdentifier.toKey(y.identifier)))}}),define(Se[227],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(P){P[I.ENV_KEY]="1"}}e.SocketExtHostConnection=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(P){P[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(R){delete R[t.ENV_KEY],delete R[I.ENV_KEY],delete R[A.ENV_KEY]}function T(R,P){D(P),R.serialize(P)}e.writeExtHostConnection=T;function S(R){if(R[t.ENV_KEY])return C(R,new t(R[t.ENV_KEY]));if(R[I.ENV_KEY])return C(R,new I);if(R[A.ENV_KEY])return C(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function C(R,P){return D(R),P}}),define(Se[93],ye([1,0,22]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function D(C){const R=a.VSBuffer.alloc(1);switch(C){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=D;function T(C,R){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=T;var S;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Se[94],ye([1,0,3,4,13,25,93,68,128,23,2]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(d,g){this.i=d,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=g.createLogger(R.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(d,g){const m=this.getTelemetryDetails(),w=new E(g,d,this.g,this.f,this.getBuiltInCommonProperties(d),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled});return this.h.set(d.identifier.value,w),w.apiTelemetryLogger}$initializeTelemetryLevel(d,g,m){this.d=d,this.f=g,this.c=m??{usage:!0,error:!0}}getBuiltInCommonProperties(d){const g={};switch(g["common.extname"]=d.name,g["common.extversion"]=d.version,g["common.vscodemachineid"]=this.i.telemetryInfo.machineId,g["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,g["common.vscodeversion"]=this.i.version,g["common.isnewappinstall"]=y(this.i.telemetryInfo.firstSessionDate),g["common.product"]=this.i.environment.appHost,this.i.uiKind){case D.UIKind.Web:g["common.uikind"]="web";break;case D.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),g}$onDidChangeTelemetryLevel(d){this.e=this.getTelemetryConfiguration(),this.d=d;const g=this.getTelemetryDetails();this.h.forEach(m=>{m.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(d,g){const m=this.h.get(d.value);return m?(m.logError(g),!0):!1}};P=qe([We(0,A.IExtHostInitDataService),We(1,I.ILoggerService)],P),e.ExtHostTelemetry=P;class E{constructor(d,g,m,w,f,h){this.e=g,this.f=m,this.g=w,this.h=f,this.b=new t.Emitter,this.a=d,this.c={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(d,g){this.d&&(this.c={isUsageEnabled:d,isErrorsEnabled:g},this.b.fire(this.d))}mixInCommonPropsAndCleanData(d){let g=d.properties??d;return g=(0,S.cleanData)(g,[]),this.a.additionalCommonProperties&&(g=(0,C.mixin)(g,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(g=(0,C.mixin)(g,this.h)),d.properties?d.properties=g:d=g,d}i(d,g){this.e.publisher==="vscode"?d=this.e.name+"/"+d:d=this.e.identifier.value+"/"+d,g=this.mixInCommonPropsAndCleanData(g||{}),this.g||this.a.logEvent(d,g),this.f.trace(d,g)}logUsage(d,g){!this.c.isUsageEnabled||this.i(d,g)}logError(d,g){!this.c.isErrorsEnabled||(typeof d=="string"?this.i(d,g):this.a.logException(d,g))}get apiTelemetryLogger(){if(!this.d){const d=this,g={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.c.isUsageEnabled},get isErrorsEnabled(){return d.c.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.d=Object.freeze(g)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=E;function y(v){const d=Date.now()-new Date(v).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=y,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Se[26],ye([1,0,4,2,3,27,201]),function(ee,e,a,t,I,A,D){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class S{constructor(s){this.affinity=s,this.kind=1}equals(s){return this.kind===s.kind&&this.affinity===s.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class C{constructor(s){this.affinity=s,this.kind=2}equals(s){return this.kind===s.kind&&this.affinity===s.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class R{constructor(){this.kind=3,this.affinity=0}equals(s){return this.kind===s.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class P{constructor(s){this.dependency=s}}e.MissingExtensionDependency=P;var E;(function(i){i[i.LocalProcess=1]="LocalProcess",i[i.LocalWebWorker=2]="LocalWebWorker",i[i.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(i){if(i===null)return"None";switch(i){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=y;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(s,n){const l=[],p=[],k=[],L=[],B=m(this.c),K=m(s),G=(z,M)=>z.extensionLocation.toString()===M.extensionLocation.toString()||z.isBuiltin===M.isBuiltin||z.isUserBuiltin===M.isUserBuiltin||z.isUnderDevelopment===M.isUnderDevelopment;for(const z of this.c){const M=K.get(A.ExtensionIdentifier.toKey(z.identifier));if(!M){l.push(z.identifier),B.delete(A.ExtensionIdentifier.toKey(z.identifier));continue}if(!G(z,M)){l.push(z.identifier),B.delete(A.ExtensionIdentifier.toKey(z.identifier));continue}}for(const z of s){const M=B.get(A.ExtensionIdentifier.toKey(z.identifier));if(!M){p.push(z);continue}if(!G(M,z)){l.push(M.identifier),B.delete(A.ExtensionIdentifier.toKey(M.identifier));continue}}const O=g(this.d),U=g(n);for(const z of this.d)U.has(A.ExtensionIdentifier.toKey(z))||k.push(z);for(const z of n)O.has(A.ExtensionIdentifier.toKey(z))||L.push(z);const F={toRemove:l,toAdd:p,myToRemove:k,myToAdd:L};return this.delta(F),F}delta(s){const{toRemove:n,toAdd:l,myToRemove:p,myToAdd:k}=s,L=g(n),B=g(p);for(let K=0;K<this.c.length;K++)L.has(A.ExtensionIdentifier.toKey(this.c[K].identifier))&&(this.c.splice(K,1),K--);for(let K=0;K<this.d.length;K++)B.has(A.ExtensionIdentifier.toKey(this.d[K]))&&(this.d.splice(K,1),K--);for(const K of l)this.c.push(K);for(const K of k)this.d.push(K)}containsExtension(s){for(const n of this.d)if(A.ExtensionIdentifier.equals(n,s))return!0;return!1}}e.ExtensionHostExtensions=v;class d{constructor(s){if(this[T]="ExtensionIdentifierSet",this.c=new Map,this.d=A.ExtensionIdentifier.toKey,s)for(const n of s)this.add(n)}get size(){return this.c.size}add(s){return this.c.set(this.d(s),s),this}clear(){this.c.clear()}delete(s){return this.c.delete(this.d(s))}has(s){return this.c.has(this.d(s))}forEach(s,n){this.c.forEach(l=>s.call(n,l,l,this))}*entries(){for(const[s,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=d;function g(i){const s=new Set;for(const n of i)s.add(A.ExtensionIdentifier.toKey(n));return s}e.extensionIdentifiersArrayToSet=g;function m(i){const s=new Map;for(const n of i)s.set(A.ExtensionIdentifier.toKey(n.identifier),n);return s}function w(i,s){return!0}e.isProposedApiEnabled=w;function f(i,s){if(!w(i,s))throw new Error(`Extension '${i.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${i.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${i.identifier.value}`)}e.checkProposedApiEnabled=f;class h{constructor(s,n,l,p){this.codeLoadingTime=s,this.activateCallTime=n,this.activateResolvedTime=l,this.activationReason=p}}e.ActivationTimes=h;class b{constructor(s,n){this.description=s,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var o;(function(i){i[i.Normal=0]="Normal",i[i.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function r(i){return{type:i.isBuiltin?0:1,isBuiltin:i.isBuiltin||i.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(i.publisher,i.name),uuid:i.uuid},manifest:i,location:i.extensionLocation,targetPlatform:i.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function c(i,s){return{identifier:new A.ExtensionIdentifier((0,D.getExtensionId)(i.manifest.publisher,i.manifest.name)),isBuiltin:i.type===0,isUserBuiltin:i.type===1&&i.isBuiltin,isUnderDevelopment:!!s,extensionLocation:i.location,...i.manifest,uuid:i.identifier.uuid,targetPlatform:i.targetPlatform,browserNlsBundleUris:i.browserNlsBundleUris}}e.toExtensionDescription=c;class u{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(s,n){return Promise.resolve(0)}getInspectPorts(s,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Se[228],ye([1,0,10,27,26,13,18]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class T{constructor(g,m,w,f){this.startup=g,this.codeLoadingTime=m,this.activateCallTime=w,this.activateResolvedTime=f}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(g){this.a=g,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(g,m){return g===-1||m===-1?-1:m-g}build(){return new T(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=S;class C{constructor(g,m,w,f,h,b){this.activationFailed=g,this.activationFailedError=m,this.activationTimes=w,this.module=f,this.exports=h,this.subscriptions=b}}e.ActivatedExtension=C;class R extends C{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class P extends C{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class E extends C{constructor(g){super(!0,g,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(g,m,w,f,h){this.h=h,this.a=g,this.b=new Set,m.forEach(b=>this.b.add(t.ExtensionIdentifier.toKey(b))),this.c=new Map,w.forEach(b=>this.c.set(t.ExtensionIdentifier.toKey(b),b)),this.d=f,this.f=new Map,this.g=Object.create(null)}dispose(){for(const[g,m]of this.f)m.dispose()}isActivated(g){const m=this.f.get(t.ExtensionIdentifier.toKey(g));return Boolean(m&&m.value)}getActivatedExtension(g){const m=this.f.get(t.ExtensionIdentifier.toKey(g));if(!m||!m.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return m.value}async activateByEvent(g,m){if(this.g[g])return;const w=this.a.getExtensionDescriptionsForActivationEvent(g);await this.j(w.map(f=>({id:f.identifier,reason:{startup:m,extensionId:f.identifier,activationEvent:g}}))),this.g[g]=!0}activateById(g,m){const w=this.a.getExtensionDescription(g);if(!w)throw new Error(`Extension '${g}' is not known`);return this.j([{id:w.identifier,reason:m}])}async j(g){const m=g.filter(w=>!this.isActivated(w.id)).map(w=>this.k(w));await Promise.all(m.map(w=>w.wait()))}k(g){if(this.f.has(t.ExtensionIdentifier.toKey(g.id)))return this.f.get(t.ExtensionIdentifier.toKey(g.id));if(this.c.has(t.ExtensionIdentifier.toKey(g.id)))return this.l(g,null,[],null);const m=this.a.getExtensionDescription(g.id);if(!m){const h=new Error(`Cannot activate unknown extension '${g.id.value}'`),b=this.l(g,null,[],new E(h));return this.d.onExtensionActivationError(g.id,h,new I.MissingExtensionDependency(g.id.value)),b}const w=[],f=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const h of f){if(this.b.has(t.ExtensionIdentifier.toKey(h)))continue;const b=this.f.get(t.ExtensionIdentifier.toKey(h));if(b){w.push(b);continue}if(this.c.has(t.ExtensionIdentifier.toKey(h))){w.push(this.k({id:this.c.get(t.ExtensionIdentifier.toKey(h)),reason:g.reason}));continue}const o=this.a.getExtensionDescription(h);if(o){if(!o.main&&!o.browser)continue;w.push(this.k({id:o.identifier,reason:g.reason}));continue}const r=m.displayName||m.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${h}'`),u=this.l(g,m.displayName,[],new E(c));return this.d.onExtensionActivationError(m.identifier,c,new I.MissingExtensionDependency(h)),u}return this.l(g,m.displayName,w,null)}l(g,m,w,f){const h=new v(g.id,m,g.reason,w,f,this.d,this.h);return this.f.set(t.ExtensionIdentifier.toKey(g.id),h),h}};y=qe([We(4,A.ILogService)],y),e.ExtensionsActivator=y;let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(g,m,w,f,h,b,o){this.c=g,this.d=m,this.f=w,this.g=f,this.h=h,this.j=b,this.k=o,this.a=new D.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let g=0;g<this.g.length;g++){const m=this.g[g];if(m.value&&!m.value.activationFailed){this.g.splice(g,1),g--;continue}if(m.value&&m.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);w.detail=m.value.activationFailedError,this.h=new E(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(g=>g.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(g){const m=new Error;if(g&&g.name&&(m.name=g.name),g&&g.message?m.message=`Activating extension '${this.c.value}' failed: ${g.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${g}.`,g&&g.stack&&(m.stack=g.stack),this.h=new E(m),this.b&&a.isCancellationError(g))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(g)}}};v=qe([We(6,A.ILogService)],v)}),define(Se[229],ye([1,0,13,25,26]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends a.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};A=qe([We(0,a.ILoggerService),We(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[7],ye([1,0,17,10,107,28,84,8,12,2,30,38,127,90,26]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v){"use strict";var d,g,m,w,f,h,b,o,r,c,u,i,s,n,l,p,k,L,B,K,G,O,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(X){return Object.assign(X,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(X,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(X,[]);{const[he,...Te]=arguments;return Reflect.construct(X,Te,he.constructor)}}})}var z;(function(X){X.top="top",X.bottom="bottom"})(z=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var M;(function(X){X.command="command",X.opener="opener"})(M=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let V=h=class{static from(...j){let he=j;return new h(function(){if(he){for(const Te of he)Te&&typeof Te.dispose=="function"&&Te.dispose();he=void 0}})}constructor(j){d.set(this,void 0),Je(this,d,j,"f")}dispose(){typeof Fe(this,d,"f")=="function"&&(Fe(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,V=h=qe([F],V),e.Disposable=V;let q=b=class{static Min(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(j){if(!j)return!1;if(j instanceof b)return!0;const{line:he,character:Te}=j;return typeof he=="number"&&typeof Te=="number"}static of(j){if(j instanceof b)return j;if(this.isPosition(j))return new b(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=j,this.e=he}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,he=0){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,he=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&he===0?this:new b(this.line+Te,this.character+he)}with(j,he=this.character){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,he=typeof j.character=="number"?j.character:this.character),Te===this.line&&he===this.character?this:new b(Te,he)}toJSON(){return{line:this.line,character:this.character}}};q=b=qe([F],q),e.Position=q;let H=o=class{static isRange(j){return j instanceof o?!0:j?q.isPosition(j.start)&&q.isPosition(j.end):!1}static of(j){if(j instanceof o)return j;if(this.isRange(j))return new o(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,he,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new q(j,he),ct=new q(Te,Ke)):q.isPosition(j)&&q.isPosition(he)&&(Ye=q.of(j),ct=q.of(he)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(j){return o.isRange(j)?this.contains(j.start)&&this.contains(j.end):q.isPosition(j)?!(q.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const he=q.Max(j.start,this.c),Te=q.Min(j.end,this.e);if(!he.isAfter(Te))return new o(he,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const he=q.Min(j.start,this.c),Te=q.Max(j.end,this.end);return new o(he,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,he=this.end){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return j?q.isPosition(j)?Te=j:(Te=j.start||this.start,he=j.end||this.end):Te=this.start,Te.isEqual(this.c)&&he.isEqual(this.end)?this:new o(Te,he)}toJSON(){return[this.start,this.end]}};H=o=qe([F],H),e.Range=H;let Q=r=class extends H{static isSelection(j){return j instanceof r?!0:j?H.isRange(j)&&q.isPosition(j.anchor)&&q.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,he,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new q(j,he),ct=new q(Te,Ke)):q.isPosition(j)&&q.isPosition(he)&&(Ye=q.of(j),ct=q.of(he)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Q=r=qe([F],Q),e.Selection=Q;class Y{constructor(j,he,Te){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(he),this.connectionToken=Te}}e.ResolvedAuthority=Y;class ce extends Error{static NotAvailable(j,he){return new ce(j,E.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(j){return new ce(j,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,he=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j),this._message=j,this._code=he,this._detail=Te,Object.setPrototypeOf(this,ce.prototype)}}e.RemoteAuthorityResolverError=ce;var ie;(function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"})(ie=e.EndOfLine||(e.EndOfLine={}));var fe;(function(X){X[X.Replace=1]="Replace",X[X.Append=2]="Append",X[X.Prepend=3]="Prepend"})(fe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=c=class{static isTextEdit(j){return j instanceof c?!0:j?H.isRange(j)&&typeof j.newText=="string":!1}static replace(j,he){return new c(j,he)}static insert(j,he){return c.replace(new H(j,j),he)}static delete(j){return c.replace(j,"")}static setEndOfLine(j){const he=new c(new H(new q(0,0),new q(0,0)),"");return he.newEol=j,he}get range(){return this.c}set range(j){if(j&&!H.isRange(j))throw(0,t.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,t.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,t.illegalArgument)("newEol");this.f=j}constructor(j,he){this.c=j,this.e=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};J=c=qe([F],J),e.TextEdit=J;let pe=u=class{static isNotebookCellEdit(j){return j instanceof u?!0:j?Kt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,he){return new u(j,he)}static insertCells(j,he){return new u(new Kt(j,j),he)}static deleteCells(j){return new u(j,[])}static updateCellMetadata(j,he){const Te=new u(new Kt(j,j),[]);return Te.newCellMetadata=he,Te}static updateNotebookMetadata(j){const he=new u(new Kt(0,0),[]);return he.newNotebookMetadata=j,he}constructor(j,he){this.range=j,this.newCells=he}};pe=u=qe([F],pe),e.NotebookEdit=pe;class we{static isSnippetTextEdit(j){return j instanceof we?!0:j?H.isRange(j.range)&&ze.isSnippetString(j.snippet):!1}static replace(j,he){return new we(j,he)}static insert(j,he){return we.replace(new H(j,j),he)}constructor(j,he){this.range=j,this.snippet=he}}e.SnippetTextEdit=we;var Ie;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.Cell=3]="Cell",X[X.CellReplace=5]="CellReplace",X[X.Snippet=6]="Snippet"})(Ie=e.FileEditType||(e.FileEditType={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,he,Te,Ke){this.c.push({_type:1,from:j,to:he,options:Te,metadata:Ke})}createFile(j,he,Te){this.c.push({_type:1,from:void 0,to:j,options:he,metadata:Te})}deleteFile(j,he,Te){this.c.push({_type:1,from:j,to:void 0,options:he,metadata:Te})}e(j,he,Te){this.c.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:he},notebookMetadata:he})}f(j,he,Te,Ke){const Ye=he.start,ct=he.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:j,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(j,he,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:he,metadata:Te}})}replace(j,he,Te,Ke){this.c.push({_type:2,uri:j,edit:new J(he,Te),metadata:Ke})}insert(j,he,Te,Ke){this.replace(j,new H(he,he),Te,Ke)}delete(j,he,Te){this.replace(j,he,"",Te)}has(j){return this.c.some(he=>he._type===2&&he.uri.toString()===j.toString())}set(j,he){if(he)for(const Te of he){if(!Te)continue;let Ke,Ye;Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,pe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ye):this.f(j,Ke.range,Ke.newCells,Ye):we.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Te]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(j){const he=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===j.toString()&&he.push(Te.edit);return he}entries(){const j=new A.ResourceMap;for(const he of this.c)if(he._type===2){let Te=j.get(he.uri);Te||(Te=[he.uri,[]],j.set(he.uri,Te)),Te[1].push(he.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Re=qe([F],Re),e.WorkspaceEdit=Re;let ze=i=class{static isSnippetString(j){return j instanceof i?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=i.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,he=this.e++){if(typeof j=="function"){const Te=new i;Te.e=this.e,j(Te),this.e=Te.e,j=Te.value}else j=i.c(j);return this.value+="${",this.value+=he,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,he=this.e++){const Te=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,he){if(typeof he=="function"){const Te=new i;Te.e=this.e,he(Te),this.e=Te.e,he=Te.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,he&&(this.value+=":",this.value+=he),this.value+="}",this}};ze=i=qe([F],ze),e.SnippetString=ze;var re;(function(X){X[X.Unnecessary=1]="Unnecessary",X[X.Deprecated=2]="Deprecated"})(re=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(X){X[X.Hint=3]="Hint",X[X.Information=2]="Information",X[X.Warning=1]="Warning",X[X.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=s=class{static isLocation(j){return j instanceof s?!0:j?H.isRange(j.range)&&C.URI.isUri(j.uri):!1}constructor(j,he){if(this.uri=j,he)if(H.isRange(he))this.range=H.of(he);else if(q.isPosition(he))this.range=new H(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};de=s=qe([F],de),e.Location=de;let Z=class{static is(j){return j?typeof j.message=="string"&&j.location&&H.isRange(j.location.range)&&C.URI.isUri(j.location.uri):!1}constructor(j,he){this.location=j,this.message=he}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.location.range.isEqual(he.location.range)&&j.location.uri.toString()===he.location.uri.toString()}};Z=qe([F],Z),e.DiagnosticRelatedInformation=Z;let se=class{constructor(j,he,Te=ue.Error){if(!H.isRange(j))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=j,this.message=he,this.severity=Te}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.severity===he.severity&&j.code===he.code&&j.severity===he.severity&&j.source===he.source&&j.range.isEqual(he.range)&&(0,a.equals)(j.tags,he.tags)&&(0,a.equals)(j.relatedInformation,he.relatedInformation,Z.isEqual)}};se=qe([F],se),e.Diagnostic=se;let ne=class{constructor(j,he){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=he}};ne=qe([F],ne),e.Hover=ne;var N;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(j,he=N.Text){this.range=j,this.kind=he}toJSON(){return{range:this.range,kind:N[this.kind]}}};$=qe([F],$),e.DocumentHighlight=$;var x;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(x=e.SymbolKind||(e.SymbolKind={}));var _;(function(X){X[X.Deprecated=1]="Deprecated"})(_=e.SymbolTag||(e.SymbolTag={}));let le=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,he,Te,Ke,Ye){this.name=j,this.kind=he,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof de?this.location=Ke:Te instanceof H&&(this.location=new de(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};le=n=qe([F],le),e.SymbolInformation=le;let be=l=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(l.validate)}constructor(j,he,Te,Ke,Ye){this.name=j,this.detail=he,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],l.validate(this)}};be=l=qe([F],be),e.DocumentSymbol=be;var Pe;(function(X){X[X.Invoke=1]="Invoke",X[X.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ge=class{constructor(j,he){this.title=j,this.kind=he}};ge=qe([F],ge),e.CodeAction=ge;let Ce=p=class{constructor(j){this.value=j}append(j){return new p(this.value?this.value+p.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+p.c)}};Ce.c=".",Ce=p=qe([F],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(j,he){if(this.range=j,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([F],ke),e.SelectionRange=ke;class je{constructor(j,he,Te,Ke,Ye,ct){this.kind=j,this.name=he,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(j,he){this.fromRanges=he,this.from=j}}e.CallHierarchyIncomingCall=Ge;class et{constructor(j,he){this.fromRanges=he,this.to=j}}e.CallHierarchyOutgoingCall=et;var _e;(function(X){X[X.Information=0]="Information",X[X.Warning=1]="Warning",X[X.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(j,he){this.range=j,this.command=he}get isResolved(){return!!this.command}};nt=qe([F],nt),e.CodeLens=nt;let st=k=class{static isMarkdownString(j){return j instanceof k?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,he=!1){g.set(this,void 0),Je(this,g,new I.MarkdownString(j,{supportThemeIcons:he}),"f")}get value(){return Fe(this,g,"f").value}set value(j){Fe(this,g,"f").value=j}get isTrusted(){return Fe(this,g,"f").isTrusted}set isTrusted(j){Fe(this,g,"f").isTrusted=j}get supportThemeIcons(){return Fe(this,g,"f").supportThemeIcons}set supportThemeIcons(j){Fe(this,g,"f").supportThemeIcons=j}get supportHtml(){return Fe(this,g,"f").supportHtml}set supportHtml(j){Fe(this,g,"f").supportHtml=j}get baseUri(){return Fe(this,g,"f").baseUri}set baseUri(j){Fe(this,g,"f").baseUri=j}appendText(j){return Fe(this,g,"f").appendText(j),this}appendMarkdown(j){return Fe(this,g,"f").appendMarkdown(j),this}appendCodeblock(j,he){return Fe(this,g,"f").appendCodeblock(he??"",j),this}};g=new WeakMap,st=k=qe([F],st),e.MarkdownString=st;let ht=class{constructor(j,he){this.label=j,this.documentation=he}};ht=qe([F],ht),e.ParameterInformation=ht;let Me=class{constructor(j,he){this.label=j,this.documentation=he,this.parameters=[]}};Me=qe([F],Me),e.SignatureInformation=Me;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([F],it),e.SignatureHelp=it;var oe;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var W;(function(X){X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})(W=e.InlayHintKind||(e.InlayHintKind={}));let ae=class{constructor(j){this.value=j}};ae=qe([F],ae),e.InlayHintLabelPart=ae;let De=class{constructor(j,he,Te){this.position=j,this.label=he,this.kind=Te}};De=qe([F],De),e.InlayHint=De;var Le;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(X){X[X.Text=0]="Text",X[X.Method=1]="Method",X[X.Function=2]="Function",X[X.Constructor=3]="Constructor",X[X.Field=4]="Field",X[X.Variable=5]="Variable",X[X.Class=6]="Class",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Unit=10]="Unit",X[X.Value=11]="Value",X[X.Enum=12]="Enum",X[X.Keyword=13]="Keyword",X[X.Snippet=14]="Snippet",X[X.Color=15]="Color",X[X.File=16]="File",X[X.Reference=17]="Reference",X[X.Folder=18]="Folder",X[X.EnumMember=19]="EnumMember",X[X.Constant=20]="Constant",X[X.Struct=21]="Struct",X[X.Event=22]="Event",X[X.Operator=23]="Operator",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var xe;(function(X){X[X.Deprecated=1]="Deprecated"})(xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(j,he){this.label=j,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([F],Ze),e.CompletionItem=Ze;let mt=class{constructor(j=[],he=!1){this.items=j,this.isIncomplete=he}};mt=qe([F],mt),e.CompletionList=mt;let ft=class{constructor(j,he,Te){this.insertText=j,this.range=he,this.command=Te}};ft=qe([F],ft),e.InlineSuggestion=ft;let lt=class{constructor(j){this.commands=void 0,this.items=j}};lt=qe([F],lt),e.InlineSuggestionList=lt;var ot;(function(X){X[X.Active=-1]="Active",X[X.Beside=-2]="Beside",X[X.One=1]="One",X[X.Two=2]="Two",X[X.Three=3]="Three",X[X.Four=4]="Four",X[X.Five=5]="Five",X[X.Six=6]="Six",X[X.Seven=7]="Seven",X[X.Eight=8]="Eight",X[X.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var At;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative"})(At=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Rt;(function(X){X[X.Manual=1]="Manual",X[X.AfterDelay=2]="AfterDelay",X[X.FocusOut=3]="FocusOut"})(Rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(X){X[X.Keyboard=1]="Keyboard",X[X.Mouse=2]="Mouse",X[X.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(X){X[X.Undo=1]="Undo",X[X.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(X){X[X.OpenOpen=0]="OpenOpen",X[X.ClosedClosed=1]="ClosedClosed",X[X.OpenClosed=2]="OpenClosed",X[X.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(X){function j(he){switch(he){case"keyboard":return X.Keyboard;case"mouse":return X.Mouse;case"api":return X.Command}}X.fromValue=j}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Mt=class{constructor(j,he){if(he&&!C.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!H.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.target=he}};Mt=qe([F],Mt),e.DocumentLink=Mt;let Xe=class{constructor(j,he,Te,Ke){this.red=j,this.green=he,this.blue=Te,this.alpha=Ke}};Xe=qe([F],Xe),e.Color=Xe;let Ot=class{constructor(j,he){if(he&&!(he instanceof Xe))throw(0,t.illegalArgument)("color");if(!H.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.color=he}};Ot=qe([F],Ot),e.ColorInformation=Ot;let Ut=class{constructor(j){if(!j||typeof j!="string")throw(0,t.illegalArgument)("label");this.label=j}};Ut=qe([F],Ut),e.ColorPresentation=Ut;var Ht;(function(X){X[X.RGB=0]="RGB",X[X.HEX=1]="HEX",X[X.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var bt;(function(X){X[X.Error=0]="Error",X[X.Warning=1]="Warning",X[X.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Lt;(function(X){X[X.Unknown=0]="Unknown",X[X.Shutdown=1]="Shutdown",X[X.Process=2]="Process",X[X.User=3]="User",X[X.Extension=4]="Extension"})(Lt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(j,he,Te){if(this.startIndex=j,this.length=he,this.tooltip=Te,typeof j!="number"||j<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ae;var Oe;(function(X){X[X.Panel=1]="Panel",X[X.Editor=2]="Editor"})(Oe=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(j){if(this.options=j,typeof j!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ee;var te;(function(X){X[X.Always=1]="Always",X[X.Silent=2]="Silent",X[X.Never=3]="Never"})(te=e.TaskRevealKind||(e.TaskRevealKind={}));var Ne;(function(X){X[X.Shared=1]="Shared",X[X.Dedicated=2]="Dedicated",X[X.New=3]="New"})(Ne=e.TaskPanelKind||(e.TaskPanelKind={}));let $e=L=class{static from(j){switch(j){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(j,he){if(this.label=he,typeof j!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this.c=j}get id(){return this.c}};$e.Clean=new L("clean","Clean"),$e.Build=new L("build","Build"),$e.Rebuild=new L("rebuild","Rebuild"),$e.Test=new L("test","Test"),$e=L=qe([F],$e),e.TaskGroup=$e;function Qe(X){let j="";for(let he=0;he<X.length;he++)j+=X[he].replace(/,/g,",,")+",";return j}let Ve=class{constructor(j,he,Te){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=j,he!==void 0&&(Array.isArray(he)?(this.e=he,this.f=Te):this.f=he)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const he of this.e)j.push(he);return Qe(j)}};Ve=qe([F],Ve),e.ProcessExecution=Ve;let tt=class{constructor(j,he,Te){if(this.f=[],Array.isArray(he)){if(!j)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j,this.f=he,this.g=Te}else{if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j,this.g=he}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const he of this.f)j.push(typeof he=="string"?he:he.value);return Qe(j)}};tt=qe([F],tt),e.ShellExecution=tt;var It;(function(X){X[X.Escape=1]="Escape",X[X.Strong=2]="Strong",X[X.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class Tt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=Tt;let wt=B=class{constructor(j,he,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=j;let dt;typeof he=="string"?(this.m=this.name=he,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):he===Et.Global||he===Et.Workspace?(this.target=he,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=he,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Ve?this.k={type:B.e,id:this.n.computeId()}:this.n instanceof tt?this.k={type:B.f,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:B.c,id:this.n.computeId()}:this.k={type:B.g,id:(0,R.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const he=this.k.type;(B.g===he||B.e===he||B.f===he||B.c===he)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};wt.c="customExecution",wt.e="process",wt.f="shell",wt.g="$empty",wt=B=qe([F],wt),e.Task=wt;var vt;(function(X){X[X.SourceControl=1]="SourceControl",X[X.Window=10]="Window",X[X.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));var yt;(function(X){function j(he){const Te=he;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}X.isViewBadge=j})(yt=e.ViewBadge||(e.ViewBadge={}));let zt=K=class{static isTreeItem(j,he){if(j instanceof K)return!0;const Te=j;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!C.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!C.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!C.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!C.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<Xt.None&&Te.collapsibleState>Xt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==St.Checked&&Ke!==St.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(j,he=Xt.None){this.collapsibleState=he,C.URI.isUri(j)?this.resourceUri=j:this.label=j}};zt=K=qe([F],zt),e.TreeItem=zt;var Xt;(function(X){X[X.None=0]="None",X[X.Collapsed=1]="Collapsed",X[X.Expanded=2]="Expanded"})(Xt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var St;(function(X){X[X.Unchecked=0]="Unchecked",X[X.Checked=1]="Checked"})(St=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let on=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,he){this.value=j,this.id=he??(0,R.generateUuid)()}};on=qe([F],on),e.DataTransferItem=on;let an=class{constructor(j){m.set(this,new Map);for(const[he,Te]of j??[]){const Ke=Fe(this,m,"f").get(he);Ke?Ke.push(Te):Fe(this,m,"f").set(he,[Te])}}get(j){return Fe(this,m,"f").get(j)?.[0]}set(j,he){Fe(this,m,"f").set(j,[he])}forEach(j,he){for(const[Te,Ke]of Fe(this,m,"f"))for(const Ye of Ke)j.call(he,Ye,Te,this)}*[(m=new WeakMap,Symbol.iterator)](){for(const[j,he]of Fe(this,m,"f"))for(const Te of he)yield[j,Te]}};an=qe([F],an),e.DataTransfer=an;let Zt=class{constructor(j){this.insertText=j}};Zt=qe([F],Zt),e.DocumentDropEdit=Zt;let bn=class{constructor(j){this.insertText=j}};bn=qe([F],bn),e.DocumentPasteEdit=bn;let Ct=class{constructor(j,he){this.id=j,this.color=he}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};Ct=qe([F],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let cn=class{constructor(j){this.id=j}};cn=qe([F],cn),e.ThemeColor=cn;var On;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace",X[X.WorkspaceFolder=3]="WorkspaceFolder"})(On=e.ConfigurationTarget||(e.ConfigurationTarget={}));let en=class{get base(){return this.c}set base(j){this.c=j,this.e=C.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,he){if(typeof j!="string"&&(!j||!C.URI.isUri(j)&&!C.URI.isUri(j.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof j=="string"?this.baseUri=C.URI.file(j):C.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};en=qe([F],en),e.RelativePattern=en;let jt=class{constructor(j,he,Te,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof he=="string"&&(this.condition=he),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,R.generateUuid)()),this.c}};jt=qe([F],jt),e.Breakpoint=jt;let ut=class extends jt{constructor(j,he,Te,Ke,Ye){if(super(he,Te,Ke,Ye),j===null)throw(0,t.illegalArgument)("location");this.location=j}};ut=qe([F],ut),e.SourceBreakpoint=ut;let wn=class extends jt{constructor(j,he,Te,Ke,Ye){super(he,Te,Ke,Ye),this.functionName=j}};wn=qe([F],wn),e.FunctionBreakpoint=wn;let Vt=class extends jt{constructor(j,he,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!he)throw(0,t.illegalArgument)("dataId");this.label=j,this.dataId=he,this.canPersist=Te}};Vt=qe([F],Vt),e.DataBreakpoint=Vt;let _t=class{constructor(j,he,Te){this.command=j,this.args=he||[],this.options=Te}};_t=qe([F],_t),e.DebugAdapterExecutable=_t;let ln=class{constructor(j,he){this.port=j,this.host=he}};ln=qe([F],ln),e.DebugAdapterServer=ln;let vn=class{constructor(j){this.path=j}};vn=qe([F],vn),e.DebugAdapterNamedPipeServer=vn;let un=class{constructor(j){this.implementation=j}};un=qe([F],un),e.DebugAdapterInlineImplementation=un;let En=class{constructor(j,he){this.range=j,this.expression=he}};En=qe([F],En),e.EvaluatableExpression=En;var kn;(function(X){X[X.Invoke=0]="Invoke",X[X.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let tn=class{constructor(j,he){this.range=j,this.text=he}};tn=qe([F],tn),e.InlineValueText=tn;let Sn=class{constructor(j,he,Te=!0){this.range=j,this.variableName=he,this.caseSensitiveLookup=Te}};Sn=qe([F],Sn),e.InlineValueVariableLookup=Sn;let rn=class{constructor(j,he){this.range=j,this.expression=he}};rn=qe([F],rn),e.InlineValueEvaluatableExpression=rn;let sn=class{constructor(j,he){this.frameId=j,this.stoppedLocation=he}};sn=qe([F],sn),e.InlineValueContext=sn;var Nn;(function(X){X[X.Changed=1]="Changed",X[X.Created=2]="Created",X[X.Deleted=3]="Deleted"})(Nn=e.FileChangeType||(e.FileChangeType={}));let yn=G=class extends Error{static FileExists(j){return new G(j,P.FileSystemProviderErrorCode.FileExists,G.FileExists)}static FileNotFound(j){return new G(j,P.FileSystemProviderErrorCode.FileNotFound,G.FileNotFound)}static FileNotADirectory(j){return new G(j,P.FileSystemProviderErrorCode.FileNotADirectory,G.FileNotADirectory)}static FileIsADirectory(j){return new G(j,P.FileSystemProviderErrorCode.FileIsADirectory,G.FileIsADirectory)}static NoPermissions(j){return new G(j,P.FileSystemProviderErrorCode.NoPermissions,G.NoPermissions)}static Unavailable(j){return new G(j,P.FileSystemProviderErrorCode.Unavailable,G.Unavailable)}constructor(j,he=P.FileSystemProviderErrorCode.Unknown,Te){super(C.URI.isUri(j)?j.toString(!0):j),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,he),Object.setPrototypeOf(this,G.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};yn=G=qe([F],yn),e.FileSystemError=yn;let Qt=class{constructor(j,he,Te){this.start=j,this.end=he,this.kind=Te}};Qt=qe([F],Qt),e.FoldingRange=Qt;var Fn;(function(X){X[X.Comment=1]="Comment",X[X.Imports=2]="Imports",X[X.Region=3]="Region"})(Fn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mn;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(Mn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Un;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(Un=e.CommentMode||(e.CommentMode={}));var Bn;(function(X){X[X.Unresolved=0]="Unresolved",X[X.Resolved=1]="Resolved"})(Bn=e.CommentThreadState||(e.CommentThreadState={}));class zn{constructor(j,he=[]){this.tokenTypes=j,this.tokenModifiers=he}}e.SemanticTokensLegend=zn;function Cn(X){return typeof X>"u"||(0,S.isStringArray)(X)}class dn{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let he=0,Te=j.tokenTypes.length;he<Te;he++)this.j.set(j.tokenTypes[he],he);for(let he=0,Te=j.tokenModifiers.length;he<Te;he++)this.k.set(j.tokenModifiers[he],he)}}push(j,he,Te,Ke,Ye){if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(j,he,Te,Ke,Ye);if(H.isRange(j)&&typeof he=="string"&&Cn(Te))return this.m(j,he,Te);throw(0,t.illegalArgument)()}m(j,he,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ye=j.start.character,ct=j.end.character-j.start.character,dt=this.j.get(he);let Nt=0;if(Te)for(const Wt of Te){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Wt);Nt|=1<<qt>>>0}this.n(Ke,Ye,ct,dt,Nt)}n(j,he,Te,Ke,Ye){if(this.f&&(j<this.c||j===this.c&&he<this.e)){this.f=!1;const Nt=this.g.length/5|0;let Wt=0,qt=0;for(let xt=0;xt<Nt;xt++){let Yt=this.g[5*xt],Dn=this.g[5*xt+1];Yt===0?(Yt=Wt,Dn+=qt):Yt+=Wt,this.g[5*xt]=Yt,this.g[5*xt+1]=Dn,Wt=Yt,qt=Dn}}let ct=j,dt=he;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=j,this.e=he}static o(j){const he=[],Te=j.length/5|0;for(let dt=0;dt<Te;dt++)he[dt]=dt;he.sort((dt,Nt)=>{const Wt=j[5*dt],qt=j[5*Nt];if(Wt===qt){const xt=j[5*dt+1],Yt=j[5*Nt+1];return xt-Yt}return Wt-qt});const Ke=new Uint32Array(j.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Nt=5*he[dt],Wt=j[Nt+0],qt=j[Nt+1],xt=j[Nt+2],Yt=j[Nt+3],Dn=j[Nt+4],ti=Wt-Ye,Ii=ti===0?qt-ct:qt,In=5*dt;Ke[In+0]=ti,Ke[In+1]=Ii,Ke[In+2]=xt,Ke[In+3]=Yt,Ke[In+4]=Dn,Ye=Wt,ct=qt}return Ke}build(j){return this.f?new hn(new Uint32Array(this.g),j):new hn(dn.o(this.g),j)}}e.SemanticTokensBuilder=dn;class hn{constructor(j,he){this.resultId=he,this.data=j}}e.SemanticTokens=hn;class He{constructor(j,he,Te){this.start=j,this.deleteCount=he,this.data=Te}}e.SemanticTokensEdit=He;class Gt{constructor(j,he){this.resultId=he,this.edits=j}}e.SemanticTokensEdits=Gt;var Tn;(function(X){X[X.Separate=0]="Separate",X[X.MergeWithParent=1]="MergeWithParent"})(Tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let gt=class{constructor(){}};gt.Back={iconPath:new Ct("arrow-left")},gt=qe([F],gt),e.QuickInputButtons=gt;var $n;(function(X){X[X.Separator=-1]="Separator",X[X.Default=0]="Default"})($n=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Wn;(function(X){X[X.Info=1]="Info",X[X.Warning=2]="Warning",X[X.Error=3]="Error"})(Wn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Pn;(function(X){X[X.UI=1]="UI",X[X.Workspace=2]="Workspace"})(Pn=e.ExtensionKind||(e.ExtensionKind={}));class Hn{static validate(j){if(typeof j.badge=="string"){let he=(0,T.nextCharLength)(j.badge,0);if(he<j.badge.length&&(he+=(0,T.nextCharLength)(j.badge,he)),j.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Ct.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,he,Te){this.badge=j,this.tooltip=he,this.color=Te}}e.FileDecoration=Hn;let nn=class{constructor(j){this.kind=j}};nn=qe([F],nn),e.ColorTheme=nn;var jn;(function(X){X[X.Light=1]="Light",X[X.Dark=2]="Dark",X[X.HighContrast=3]="HighContrast",X[X.HighContrastLight=4]="HighContrastLight"})(jn=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(j){return j instanceof Kt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");j<=he?(this.c=j,this.e=he):(this.c=he,this.e=j)}with(j){let he=this.c,Te=this.e;return j.start!==void 0&&(he=j.start),j.end!==void 0&&(Te=j.end),he===this.c&&Te===this.e?this:new Kt(he,Te)}}e.NotebookRange=Kt;class fn{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(he=>fn.isNotebookCellData(he))}static isNotebookCellData(j){return!0}constructor(j,he,Te,Ke,Ye,ct,dt){this.kind=j,this.value=he,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,fn.validate(this)}}e.NotebookCellData=fn;class An{constructor(j){this.cells=j}}e.NotebookData=An;class $t{static isNotebookCellOutputItem(j){return j instanceof $t?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const he={name:j.name,message:j.message,stack:j.stack};return $t.json(he,"application/vnd.code.notebook.error")}static stdout(j){return $t.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return $t.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,he="application/octet-stream"){return new $t(j,he)}static text(j,he=D.Mimes.text){const Te=Fe($t,w,"f",f).encode(String(j));return new $t(Te,he)}static json(j,he="text/x-json"){const Te=JSON.stringify(j,void 0,"	");return $t.text(Te,he)}constructor(j,he){this.data=j,this.mime=he;const Te=(0,D.normalizeMimeType)(he,!0);if(!Te)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=$t,w=$t,f={value:new TextEncoder};class mn{static isNotebookCellOutput(j){return j instanceof mn?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,he=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<j.length;Ye++){const ct=j[Ye],dt=(0,D.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,y.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),he&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ye,ct)=>!Ke.has(ct))}constructor(j,he,Te){this.items=mn.ensureUniqueMimeTypes(j,!0),typeof he=="string"?(this.id=he,this.metadata=Te):(this.id=(0,R.generateUuid)(),this.metadata=he??Te)}}e.NotebookCellOutput=mn;var Vn;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(Vn=e.NotebookCellKind||(e.NotebookCellKind={}));var qn;(function(X){X[X.Idle=1]="Idle",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(qn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Gn;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(Gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Kn;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class me{constructor(j,he){this.text=j,this.alignment=he}}e.NotebookCellStatusBarItem=me;var ve;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred"})(ve=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Ue;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred",X[X.Hidden=-1]="Hidden"})(Ue=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class at{constructor(j,he=[]){this.uri=j,this.provides=(0,a.asArray)(he)}}e.NotebookRendererScript=at;class Dt{constructor(j){this.label=j}}e.NotebookKernelSourceAction=Dt;let Pt=class{constructor(j,he){this.label=j,this.timestamp=he}};Pt=qe([F],Pt),e.TimelineItem=Pt;var si;(function(X){X[X.Production=1]="Production",X[X.Development=2]="Development",X[X.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(X){X[X.Node=1]="Node",X[X.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(X){X[X.Other=0]="Other",X[X.Comment=1]="Comment",X[X.String=2]="String",X[X.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(j,he){this.ranges=j,this.wordPattern=he}}e.LinkedEditingRanges=ci;class li{constructor(j,he){this.c=j,this.e=he}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=li;var ui;(function(X){X[X.Queued=1]="Queued",X[X.Running=2]="Running",X[X.Passed=3]="Passed",X[X.Failed=4]="Failed",X[X.Skipped=5]="Skipped",X[X.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(X){X[X.Run=1]="Run",X[X.Debug=2]="Debug",X[X.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xn=class{constructor(j=void 0,he=void 0,Te=void 0){this.include=j,this.exclude=he,this.profile=Te}};xn=qe([F],xn),e.TestRunRequest=xn;let Xn=O=class{static diff(j,he,Te){const Ke=new O(j);return Ke.expectedOutput=he,Ke.actualOutput=Te,Ke}constructor(j){this.message=j}};Xn=O=qe([F],Xn),e.TestMessage=Xn;let _n=class{constructor(j){this.id=j}};_n=qe([F],_n),e.TestTag=_n;let gn=class{constructor(j,he){this.covered=j,this.total=he}};gn=qe([F],gn),e.CoveredCount=gn;let Qn=U=class{static fromDetails(j,he){const Te=new gn(0,0),Ke=new gn(0,0),Ye=new gn(0,0);for(const dt of he)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Nt of dt.branches)Ke.total+=1,Ke.covered+=Nt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new U(j,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=he,ct}constructor(j,he,Te,Ke){this.uri=j,this.statementCoverage=he,this.branchCoverage=Te,this.functionCoverage=Ke}};Qn=U=qe([F],Qn),e.FileCoverage=Qn;let Yn=class{constructor(j,he,Te=[]){this.executionCount=j,this.location=he,this.branches=Te}};Yn=qe([F],Yn),e.StatementCoverage=Yn;let Jn=class{constructor(j,he){this.executionCount=j,this.location=he}};Jn=qe([F],Jn),e.BranchCoverage=Jn;let Zn=class{constructor(j,he){this.executionCount=j,this.location=he}};Zn=qe([F],Zn),e.FunctionCoverage=Zn;var hi;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(X){X[X.Untrusted=0]="Untrusted",X[X.Trusted=1]="Trusted",X[X.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(X){X[X.Notify=1]="Notify",X[X.OpenBrowser=2]="OpenBrowser",X[X.OpenPreview=3]="OpenPreview",X[X.Silent=4]="Silent",X[X.Ignore=5]="Ignore",X[X.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(j,he,Te,Ke,Ye,ct){this.kind=j,this.name=he,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=gi;class pi{constructor(j){this.uri=j}}e.TextTabInput=pi;class bi{constructor(j,he){this.original=j,this.modified=he}}e.TextDiffTabInput=bi;class wi{constructor(j,he,Te,Ke){this.base=j,this.input1=he,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=wi;class vi{constructor(j,he){this.uri=j,this.viewType=he}}e.CustomEditorTabInput=vi;class Ei{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=Ei;class Si{constructor(j,he){this.uri=j,this.notebookType=he}}e.NotebookEditorTabInput=Si;class yi{constructor(j,he,Te){this.original=j,this.modified=he,this.notebookType=Te}}e.NotebookDiffEditorTabInput=yi;class Ci{constructor(){}}e.TerminalEditorTabInput=Ci;class Di{constructor(j,he){this.uri=j,this.inputBoxUri=he}}e.InteractiveWindowInput=Di}),define(Se[134],ye([1,0,48,15,8,157,116,7,17]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function R(v,d){d?C.set(v,d):C.delete(v)}e.setWordDefinitionFor=R;function P(v){return C.get(v)}class E extends A.MirrorTextModel{constructor(d,g,m,w,f,h,b,o){super(g,m,w,f),this.m=d,this.p=h,this.q=b,this.notebook=o,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===t.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(g){return g?d.s(g):d.getText()},get eol(){return d.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(g){return d.t(g)},offsetAt(g){return d.u(g)},positionAt(g){return d.v(g)},validateRange(g){return d.w(g)},validatePosition(g){return d.x(g)},getWordRangeAtPosition(g,m){return d.y(g,m)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,a.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,a.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const g=this.w(d);if(g.isEmpty)return"";if(g.isSingleLine)return this.d[g.start.line].substring(g.start.character,g.end.character);const m=this.f,w=g.start.line,f=g.end.line,h=[];h.push(this.d[w].substring(g.start.character));for(let b=w+1;b<f;b++)h.push(this.d[b]);return h.push(this.d[f].substring(0,g.end.character)),h.join(m)}t(d){let g;if(d instanceof T.Position?g=d.line:typeof d=="number"&&(g=d),typeof g!="number"||g<0||g>=this.d.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new y(g,this.d[g],g===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const g=this.h.getIndexOf(d),m=this.d[g.index].length;return new T.Position(g.index,Math.min(g.remainder,m))}w(d){if(!(d instanceof T.Range))throw new Error("Invalid argument");const g=this.x(d.start),m=this.x(d.end);return g===d.start&&m===d.end?d:new T.Range(g.line,g.character,m.line,m.character)}x(d){if(!(d instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:g,character:m}=d,w=!1;if(g<0)g=0,m=0,w=!0;else if(g>=this.d.length)g=this.d.length-1,m=this.d[g].length,w=!0;else{const f=this.d[g].length;m<0?(m=0,w=!0):m>f&&(m=f,w=!0)}return w?new T.Position(g,m):d}y(d,g){const m=this.x(d);if(!g)g=P(this.p);else if((0,I.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const w=(0,D.getWordAtText)(m.character+1,(0,D.ensureValidWordDefinition)(g),this.d[m.line],0);if(w)return new T.Range(m.line,w.startColumn-1,m.line,w.endColumn-1)}}e.ExtHostDocumentData=E;class y{constructor(d,g,m){this.a=d,this.b=g,this.c=m}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=y}),define(Se[230],ye([1,0,7,16,4]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new I.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let S;switch(T){case"light":S=a.ColorThemeKind.Light;break;case"hcDark":S=a.ColorThemeKind.HighContrast;break;case"hcLight":S=a.ColorThemeKind.HighContrastLight;break;default:S=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Se[14],ye([1,0,17,22,149,62,107,28,146,86,84,23,12,2,37,67,122,132,130,90,57,70,224,7]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h,b,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Ae){function Oe(te){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Ve}=te,tt=new r.Position(Ne-1,$e-1),It=new r.Position(Qe-1,Ve-1);return new r.Selection(tt,It)}Ae.to=Oe;function Ee(te){const{anchor:Ne,active:$e}=te;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Ae.from=Ee})(c=e.Selection||(e.Selection={}));var u;(function(Ae){function Oe(te){if(!te)return;const{start:Ne,end:$e}=te;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Ae.from=Oe;function Ee(te){if(!te)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:Qe,endColumn:Ve}=te;return new r.Range(Ne-1,$e-1,Qe-1,Ve-1)}Ae.to=Ee})(u=e.Range||(e.Range={}));var i;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ae.to=Oe})(i=e.TokenType||(e.TokenType={}));var s;(function(Ae){function Oe(te){return new r.Position(te.lineNumber-1,te.column-1)}Ae.to=Oe;function Ee(te){return{lineNumber:te.line+1,column:te.character+1}}Ae.from=Ee})(s=e.Position||(e.Position={}));var n;(function(Ae){function Oe(Ne,$e){return(0,a.coalesce)((0,a.asArray)(Ne).map(Qe=>Ee(Qe,$e)))}Ae.from=Oe;function Ee(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:te(Ne.scheme,$e),pattern:W.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function te(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var l;(function(Ae){function Oe(te){switch(te){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Ee(te){switch(te){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(Ae){function Oe(te){let Ne;return te.code&&((0,E.isString)(te.code)||(0,E.isNumber)(te.code)?Ne=String(te.code):Ne={value:String(te.code.value),target:te.code.target}),{...u.from(te.range),message:te.message,source:te.source,code:Ne,severity:L.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(k.from),tags:Array.isArray(te.tags)?(0,a.coalesce)(te.tags.map(l.from)):void 0}}Ae.from=Oe;function Ee(te){const Ne=new r.Diagnostic(u.to(te),te.message,L.to(te.severity));return Ne.source=te.source,Ne.code=(0,E.isString)(te.code)?te.code:te.code?.value,Ne.relatedInformation=te.relatedInformation&&te.relatedInformation.map(k.to),Ne.tags=te.tags&&(0,a.coalesce)(te.tags.map(l.to)),Ne}Ae.to=Ee})(p=e.Diagnostic||(e.Diagnostic={}));var k;(function(Ae){function Oe(te){return{...u.from(te.location.range),message:te.message,resource:te.location.uri}}Ae.from=Oe;function Ee(te){return new r.DiagnosticRelatedInformation(new r.Location(te.resource,u.to(te)),te.message)}Ae.to=Ee})(k=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(Ae){function Oe(te){switch(te){case r.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ae.from=Oe;function Ee(te){switch(te){case g.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ae.to=Ee})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var B;(function(Ae){function Oe(te){return typeof te=="number"&&te>=r.ViewColumn.One?te-1:te===r.ViewColumn.Beside?o.SIDE_GROUP:o.ACTIVE_GROUP}Ae.from=Oe;function Ee(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(B=e.ViewColumn||(e.ViewColumn={}));function K(Ae){return typeof Ae.range<"u"}function G(Ae){return Ae.length===0?!0:!!K(Ae[0])}e.isDecorationOptionsArr=G;var O;(function(Ae){function Oe(Ve){return Ve.map(Ae.from)}Ae.fromMany=Oe;function Ee(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function te(Ve){let tt;if(Ee(Ve)){const{language:wt,value:vt}=Ve;tt={value:"```"+wt+`
`+vt+"\n```\n"}}else r.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const It=Object.create(null);tt.uris=It;const Et=wt=>{try{let vt=y.URI.parse(wt,!0);vt=vt.with({query:Ne(vt.query,It)}),It[wt]=vt}catch{}return""},Tt=new S.marked.Renderer;return Tt.link=Et,Tt.image=wt=>typeof wt=="string"?Et(D.parseHrefAndDimensions(wt).href):"",(0,S.marked)(tt.value,{renderer:Tt}),tt}Ae.from=te;function Ne(Ve,tt){if(!Ve)return Ve;let It;try{It=(0,C.parse)(Ve)}catch{}if(!It)return Ve;let Et=!1;return It=(0,P.cloneAndChange)(It,Tt=>{if(y.URI.isUri(Tt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[wt]=Tt,Et=!0,wt}else return}),Et?JSON.stringify(It):Ve}function $e(Ve){const tt=new r.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?y.URI.from(Ve.baseUri):void 0,tt}Ae.to=$e;function Qe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ae.from(Ve)}Ae.fromStrict=Qe})(O=e.MarkdownString||(e.MarkdownString={}));function U(Ae){return G(Ae)?Ae.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?O.fromMany(Oe.hoverMessage):Oe.hoverMessage?O.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=U;function F(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?y.URI.file(Ae):Ae}e.pathOrURIToURI=F;var z;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?F(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Oe})(z=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?z.from(Ee.before):void 0,after:Ee.after?z.from(Ee.after):void 0}}Ae.from=Oe})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(Ae){function Oe(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(Ae){function Oe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?V.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?M.from(Ee.light):void 0,dark:Ee.dark?M.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?z.from(Ee.before):void 0,after:Ee.after?z.from(Ee.after):void 0}}Ae.from=Oe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(Ae){function Oe(te){return{text:te.newText,eol:te.newEol&&st.from(te.newEol),range:u.from(te.range)}}Ae.from=Oe;function Ee(te){const Ne=new r.TextEdit(u.to(te.range),te.text);return Ne.newEol=typeof te.eol>"u"?void 0:st.to(te.eol),Ne}Ae.to=Ee})(H=e.TextEdit||(e.TextEdit={}));var Q;(function(Ae){function Oe(te,Ne){const $e={edits:[]};if(te instanceof r.WorkspaceEdit){const Qe=new T.ResourceSet;for(const Ve of te._allEntries())Ve._type===1&&y.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of te._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:H.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:u.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(mt.from)}})}return $e}Ae.from=Oe;function Ee(te){const Ne=new r.WorkspaceEdit;for(const $e of te.edits)$e.textEdit?Ne.replace(y.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(y.URI.revive($e.oldResource),y.URI.revive($e.newResource),$e.options);return Ne}Ae.to=Ee})(Q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Y;(function(Ae){const Oe=Object.create(null);Oe[r.SymbolKind.File]=0,Oe[r.SymbolKind.Module]=1,Oe[r.SymbolKind.Namespace]=2,Oe[r.SymbolKind.Package]=3,Oe[r.SymbolKind.Class]=4,Oe[r.SymbolKind.Method]=5,Oe[r.SymbolKind.Property]=6,Oe[r.SymbolKind.Field]=7,Oe[r.SymbolKind.Constructor]=8,Oe[r.SymbolKind.Enum]=9,Oe[r.SymbolKind.Interface]=10,Oe[r.SymbolKind.Function]=11,Oe[r.SymbolKind.Variable]=12,Oe[r.SymbolKind.Constant]=13,Oe[r.SymbolKind.String]=14,Oe[r.SymbolKind.Number]=15,Oe[r.SymbolKind.Boolean]=16,Oe[r.SymbolKind.Array]=17,Oe[r.SymbolKind.Object]=18,Oe[r.SymbolKind.Key]=19,Oe[r.SymbolKind.Null]=20,Oe[r.SymbolKind.EnumMember]=21,Oe[r.SymbolKind.Struct]=22,Oe[r.SymbolKind.Event]=23,Oe[r.SymbolKind.Operator]=24,Oe[r.SymbolKind.TypeParameter]=25;function Ee(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Ae.from=Ee;function te(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return r.SymbolKind.Property}Ae.to=te})(Y=e.SymbolKind||(e.SymbolKind={}));var ce;(function(Ae){function Oe(te){switch(te){case r.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Ee(te){switch(te){case 1:return r.SymbolTag.Deprecated}}Ae.to=Ee})(ce=e.SymbolTag||(e.SymbolTag={}));var ie;(function(Ae){function Oe(te){return{name:te.name,kind:Y.from(te.kind),tags:te.tags&&te.tags.map(ce.from),containerName:te.containerName,location:Ie.from(te.location)}}Ae.from=Oe;function Ee(te){const Ne=new r.SymbolInformation(te.name,Y.to(te.kind),te.containerName,Ie.to(te.location));return Ne.tags=te.tags&&te.tags.map(ce.to),Ne}Ae.to=Ee})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(Ae){function Oe(te){const Ne={name:te.name||"!!MISSING: name!!",detail:te.detail,range:u.from(te.range),selectionRange:u.from(te.selectionRange),kind:Y.from(te.kind),tags:te.tags?.map(ce.from)??[]};return te.children&&(Ne.children=te.children.map(Oe)),Ne}Ae.from=Oe;function Ee(te){const Ne=new r.DocumentSymbol(te.name,te.detail,Y.to(te.kind),u.to(te.range),u.to(te.selectionRange));return(0,a.isNonEmptyArray)(te.tags)&&(Ne.tags=te.tags.map(ce.to)),te.children&&(Ne.children=te.children.map(Ee)),Ne}Ae.to=Ee})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(Ae){function Oe(te){const Ne=new r.CallHierarchyItem(Y.to(te.kind),te.name,te.detail||"",y.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Ne._sessionId=te._sessionId,Ne._itemId=te._itemId,Ne}Ae.to=Oe;function Ee(te,Ne,$e){if(Ne=Ne??te._sessionId,$e=$e??te._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:te.name,detail:te.detail,kind:Y.from(te.kind),uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(ce.from)}}Ae.from=Ee})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(Ae){function Oe(Ee){return new r.CallHierarchyIncomingCall(J.to(Ee.from),Ee.fromRanges.map(te=>u.to(te)))}Ae.to=Oe})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(Ae){function Oe(Ee){return new r.CallHierarchyOutgoingCall(J.to(Ee.to),Ee.fromRanges.map(te=>u.to(te)))}Ae.to=Oe})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ie;(function(Ae){function Oe(te){return{range:te.range&&u.from(te.range),uri:te.uri}}Ae.from=Oe;function Ee(te){return new r.Location(y.URI.revive(te.uri),u.to(te.range))}Ae.to=Ee})(Ie=e.location||(e.location={}));var Re;(function(Ae){function Oe(te){const Ne=te,$e=te;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:u.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Ae.from=Oe;function Ee(te){return{targetUri:y.URI.revive(te.uri),targetRange:u.to(te.range),targetSelectionRange:te.targetSelectionRange?u.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?u.to(te.originSelectionRange):void 0}}Ae.to=Ee})(Re=e.DefinitionLink||(e.DefinitionLink={}));var ze;(function(Ae){function Oe(te){return{range:u.from(te.range),contents:O.fromMany(te.contents)}}Ae.from=Oe;function Ee(te){return new r.Hover(te.contents.map(O.to),u.to(te.range))}Ae.to=Ee})(ze=e.Hover||(e.Hover={}));var re;(function(Ae){function Oe(te){return{range:u.from(te.range),expression:te.expression}}Ae.from=Oe;function Ee(te){return new r.EvaluatableExpression(u.to(te.range),te.expression)}Ae.to=Ee})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ue;(function(Ae){function Oe(te){if(te instanceof r.InlineValueText)return{type:"text",range:u.from(te.range),text:te.text};if(te instanceof r.InlineValueVariableLookup)return{type:"variable",range:u.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Ee(te){switch(te.type){case"text":return{range:u.to(te.range),text:te.text};case"variable":return{range:u.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:u.to(te.range),expression:te.expression}}}Ae.to=Ee})(ue=e.InlineValue||(e.InlineValue={}));var de;(function(Ae){function Oe(te){return{frameId:te.frameId,stoppedLocation:u.from(te.stoppedLocation)}}Ae.from=Oe;function Ee(te){return new r.InlineValueContext(te.frameId,u.to(te.stoppedLocation))}Ae.to=Ee})(de=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Ae){function Oe(te){return{range:u.from(te.range),kind:te.kind}}Ae.from=Oe;function Ee(te){return new r.DocumentHighlight(u.to(te.range),te.kind)}Ae.to=Ee})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var se;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ae.to=Oe})(se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ne;(function(Ae){function Oe(Ee){return{triggerKind:se.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Oe})(ne=e.CompletionContext||(e.CompletionContext={}));var N;(function(Ae){function Oe(te){switch(te){case r.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Ee(te){switch(te){case 1:return r.CompletionItemTag.Deprecated}}Ae.to=Ee})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(Ae){const Oe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ee($e){return Oe.get($e)??9}Ae.from=Ee;const te=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ne($e){return te.get($e)??r.CompletionItemKind.Property}Ae.to=Ne})($=e.CompletionItemKind||(e.CompletionItemKind={}));var x;(function(Ae){function Oe(Ee,te){const Ne=new r.CompletionItem(Ee.label);return Ne.insertText=Ee.insertText,Ne.kind=$.to(Ee.kind),Ne.tags=Ee.tags?.map(N.to),Ne.detail=Ee.detail,Ne.documentation=D.isMarkdownString(Ee.documentation)?O.to(Ee.documentation):Ee.documentation,Ne.sortText=Ee.sortText,Ne.filterText=Ee.filterText,Ne.preselect=Ee.preselect,Ne.commitCharacters=Ee.commitCharacters,v.Range.isIRange(Ee.range)?Ne.range=u.to(Ee.range):typeof Ee.range=="object"&&(Ne.range={inserting:u.to(Ee.range.insert),replacing:u.to(Ee.range.replace)}),Ne.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Ne.insertText=new r.SnippetString(Ee.insertText):(Ne.insertText=Ee.insertText,Ne.textEdit=Ne.range instanceof r.Range?new r.TextEdit(Ne.range,Ne.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ee.additionalTextEdits.map($e=>H.to($e))),Ne.command=te&&Ee.command?te.fromInternal(Ee.command):void 0,Ne}Ae.to=Oe})(x=e.CompletionItem||(e.CompletionItem={}));var _;(function(Ae){function Oe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:O.fromStrict(te.documentation)}}Ae.from=Oe;function Ee(te){return{label:te.label,documentation:D.isMarkdownString(te.documentation)?O.to(te.documentation):te.documentation}}Ae.to=Ee})(_=e.ParameterInformation||(e.ParameterInformation={}));var le;(function(Ae){function Oe(te){return{label:te.label,documentation:O.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(_.from):[],activeParameter:te.activeParameter}}Ae.from=Oe;function Ee(te){return{label:te.label,documentation:D.isMarkdownString(te.documentation)?O.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(_.to):[],activeParameter:te.activeParameter}}Ae.to=Ee})(le=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(Ae){function Oe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(le.from):[]}}Ae.from=Oe;function Ee(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(le.to):[]}}Ae.to=Ee})(be=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ae){function Oe(Ee,te){const Ne=new r.InlayHint(s.to(te.position),typeof te.label=="string"?te.label:te.label.map(ge.to.bind(void 0,Ee)),te.kind&&Ce.to(te.kind));return Ne.textEdits=te.textEdits&&te.textEdits.map(H.to),Ne.tooltip=D.isMarkdownString(te.tooltip)?O.to(te.tooltip):te.tooltip,Ne.paddingLeft=te.paddingLeft,Ne.paddingRight=te.paddingRight,Ne}Ae.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var ge;(function(Ae){function Oe(Ee,te){const Ne=new r.InlayHintLabelPart(te.label);return Ne.tooltip=D.isMarkdownString(te.tooltip)?O.to(te.tooltip):te.tooltip,d.Command.is(te.command)&&(Ne.command=Ee.fromInternal(te.command)),te.location&&(Ne.location=Ie.to(te.location)),Ne}Ae.to=Oe})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(te){return te}Ae.from=Oe;function Ee(te){return te}Ae.to=Ee})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(te){return{range:u.from(te.range),url:te.target,tooltip:te.tooltip}}Ae.from=Oe;function Ee(te){let Ne;if(te.url)try{Ne=typeof te.url=="string"?y.URI.parse(te.url,!0):y.URI.revive(te.url)}catch{}return new r.DocumentLink(u.to(te.range),Ne)}Ae.to=Ee})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Ae){function Oe(te){const Ne=new r.ColorPresentation(te.label);return te.textEdit&&(Ne.textEdit=H.to(te.textEdit)),te.additionalTextEdits&&(Ne.additionalTextEdits=te.additionalTextEdits.map($e=>H.to($e))),Ne}Ae.to=Oe;function Ee(te){return{label:te.label,textEdit:te.textEdit?H.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Ne=>H.from(Ne)):void 0}}Ae.from=Ee})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Ae){function Oe(te){return new r.Color(te[0],te[1],te[2],te[3])}Ae.to=Oe;function Ee(te){return[te.red,te.green,te.blue,te.alpha]}Ae.from=Ee})(Ge=e.Color||(e.Color={}));var et;(function(Ae){function Oe(te){return{range:u.from(te.range)}}Ae.from=Oe;function Ee(te){return new r.SelectionRange(u.to(te.range))}Ae.to=Ee})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Ae){function Oe(Ee){switch(Ee){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Ae){function Oe(te){switch(te){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Ee(te){switch(te){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Ae){function Oe(te){if(te===r.EndOfLine.CRLF)return 1;if(te===r.EndOfLine.LF)return 0}Ae.from=Oe;function Ee(te){if(te===1)return r.EndOfLine.CRLF;if(te===0)return r.EndOfLine.LF}Ae.to=Ee})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Ae){function Oe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Ae){function Oe(Ee){const te={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(te.kind=it.from(Ee.kind)),te}Ae.from=Oe})(Me=e.FoldingRange||(e.FoldingRange={}));var it;(function(Ae){function Oe(Ee){if(Ee)switch(Ee){case r.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Ae.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Ae){function Oe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?u.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?w.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var W;(function(Ae){function Oe($e){return $e instanceof r.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Ee($e)||te($e)?new r.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Ae.from=Oe;function Ee($e){const Qe=$e;return Qe?y.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function te($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new r.RelativePattern(y.URI.revive($e.baseUri),$e.pattern)}Ae.to=Ne})(W=e.GlobPattern||(e.GlobPattern={}));var ae;(function(Ae){function Oe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Oe);if(typeof Ee=="string")return Ee;{const te=Ee;return{language:te.language,scheme:te.scheme,pattern:W.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Ae.from=Oe})(ae=e.LanguageSelector||(e.LanguageSelector={}));var De;(function(Ae){function Oe(te){return{start:te.start,end:te.end}}Ae.from=Oe;function Ee(te){return new r.NotebookRange(te.start,te.end)}Ae.to=Ee})(De=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Ae){function Oe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Ae.to=Oe;function Ee(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Ae.from=Ee})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Ae){function Oe(Ee){if(Ee===f.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ee===f.NotebookCellExecutionState.Pending)return;if(Ee===f.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xe;(function(Ae){function Oe(te){switch(te){case r.NotebookCellKind.Markup:return f.CellKind.Markup;case r.NotebookCellKind.Code:default:return f.CellKind.Code}}Ae.from=Oe;function Ee(te){switch(te){case f.CellKind.Markup:return r.NotebookCellKind.Markup;case f.CellKind.Code:default:return r.NotebookCellKind.Code}}Ae.to=Ee})(xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Ae){function Oe(te){const Ne={metadata:te.metadata??Object.create(null),cells:[]};for(const $e of te.cells)r.NotebookCellData.validate($e),Ne.cells.push(mt.from($e));return Ne}Ae.from=Oe;function Ee(te){const Ne=new r.NotebookData(te.cells.map(mt.to));return(0,E.isEmptyObject)(te.metadata)||(Ne.metadata=te.metadata),Ne}Ae.to=Ee})(Ze=e.NotebookData||(e.NotebookData={}));var mt;(function(Ae){function Oe(te){return{cellKind:xe.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Le.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(lt.from):[]}}Ae.from=Oe;function Ee(te){return new r.NotebookCellData(xe.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(lt.to):void 0,te.metadata,te.internalMetadata?Le.to(te.internalMetadata):void 0)}Ae.to=Ee})(mt=e.NotebookCellData||(e.NotebookCellData={}));var ft;(function(Ae){function Oe(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Ae.from=Oe;function Ee(te){return new r.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Ae.to=Ee})(ft=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Ae){function Oe(te){return{outputId:te.id,items:te.items.map(ft.from),metadata:te.metadata}}Ae.from=Oe;function Ee(te){const Ne=te.items.map(ft.to);return new r.NotebookCellOutput(Ne,te.outputId,te.metadata)}Ae.to=Ee})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Ae){function Oe(Ne){return te(Ne)?{include:(0,E.withNullAsUndefined)(W.from(Ne.include)),exclude:(0,E.withNullAsUndefined)(W.from(Ne.exclude))}:(0,E.withNullAsUndefined)(W.from(Ne))}Ae.from=Oe;function Ee(Ne){return te(Ne)?{include:W.to(Ne.include),exclude:W.to(Ne.exclude)}:W.to(Ne)}Ae.to=Ee;function te(Ne){const $e=Ne;return $e?!(0,E.isUndefinedOrNull)($e.include)&&!(0,E.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Ae){function Oe(Ee,te,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal($e,Ne),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var At;(function(Ae){function Oe(Ee,te,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:te.toInternal($e,Ne),label:Ee.label,description:Ee.description,detail:Ee.detail}}Ae.from=Oe})(At=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Rt;(function(Ae){function Oe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Ae.from=Oe})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(Ae){function Oe(te){return{uri:te.uri,provides:te.provides}}Ae.from=Oe;function Ee(te){return new r.NotebookRendererScript(y.URI.revive(te.uri),te.provides)}Ae.to=Ee})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Ae){function Oe(te){return{message:O.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:u.from(te.location.range),uri:te.location.uri}}}Ae.from=Oe;function Ee(te){const Ne=new r.TestMessage(typeof te.message=="string"?te.message:O.to(te.message));return Ne.actualOutput=te.actual,Ne.expectedOutput=te.expected,Ne.location=te.location?Ie.to(te.location):void 0,Ne}Ae.to=Ee})(pt=e.TestMessage||(e.TestMessage={}));var kt;(function(Ae){Ae.namespace=b.namespaceTestTag,Ae.denamespace=b.denamespaceTestTag})(kt=e.TestTag||(e.TestTag={}));var Bt;(function(Ae){function Oe(te){const Ne=(0,m.getPrivateApiFor)(te).controllerId;return{extId:h.TestId.fromExtHostTestItem(te,Ne).toString(),label:te.label,uri:y.URI.revive(te.uri),busy:te.busy,tags:te.tags.map($e=>kt.namespace(Ne,$e.id)),range:v.Range.lift(u.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&O.fromStrict(te.error)||null}}Ae.from=Oe;function Ee(te){return{parent:void 0,error:void 0,id:h.TestId.fromString(te.extId).localId,label:te.label,uri:y.URI.revive(te.uri),tags:(te.tags||[]).map(Ne=>{const{tagId:$e}=kt.denamespace(Ne);return new r.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Ae.toPlain=Ee})(Bt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(te){return{id:te.id}}Ae.from=Oe;function Ee(te){return new r.TestTag(te.id)}Ae.to=Ee}(kt=e.TestTag||(e.TestTag={}));var Mt;(function(Ae){const Oe=(te,Ne)=>{const $e=[];for(const[Ve,tt]of Ne)h.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),$e.push(tt));const Qe={...Bt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:$e.map(Ve=>Oe(Ve,Ne))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function Ee(te){const Ne=[],$e=new Map;for(const Qe of te.items){$e.set(Qe.item.extId,Qe);const Ve=h.TestId.root(Qe.item.extId);te.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:te.completedAt,results:Ne.map(Qe=>Oe(Qe,$e))}}Ae.to=Ee})(Mt=e.TestResults||(e.TestResults={}));var Xe;(function(Ae){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Ee($e){return"line"in $e?s.from($e):u.from($e)}function te($e){return"branches"in $e?{count:$e.executionCount,location:Ee($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Ee(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:Ee($e.location)}}Ae.fromDetailed=te;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(te)}}Ae.fromFile=Ne})(Xe=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Ae){function Oe(te){const Ne=new r.TypeHierarchyItem(Y.to(te.kind),te.name,te.detail||"",y.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Ne._sessionId=te._sessionId,Ne._itemId=te._itemId,Ne}Ae.to=Oe;function Ee(te,Ne,$e){if(Ne=Ne??te._sessionId,$e=$e??te._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:Y.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(ce.from)}}Ae.from=Ee})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ht;(function(Ae){function Oe(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Oe})(Ht=e.ViewBadge||(e.ViewBadge={}));var bt;(function(Ae){function Oe($e,Qe,Ve){const tt=Qe.fileData;return tt?new class extends r.DataTransferItem{asFile(){return{name:tt.name,uri:y.URI.revive(tt.uri),data:(0,A.once)(()=>Ve())}}}("",Qe.id):$e===R.Mimes.uriList&&Qe.uriListData?new r.DataTransferItem(Ne(Qe.uriListData)):new r.DataTransferItem(Qe.asString)}Ae.to=Oe;async function Ee($e,Qe){const Ve=await Qe.asString();if($e===R.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:te(Ve)};const tt=Qe.asFile();return{id:Qe.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Ae.from=Ee;function te($e){return I.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return y.URI.parse(Qe)}catch{}return Qe})}function Ne($e){return I.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:y.URI.revive(Qe)))}})(bt=e.DataTransferItem||(e.DataTransferItem={}));var Lt;(function(Ae){function Oe(te,Ne){const $e=te.items.map(([Qe,Ve])=>[Qe,bt.to(Qe,Ve,()=>Ne(Ve.id))]);return new r.DataTransfer($e)}Ae.toDataTransfer=Oe;async function Ee(te){const Ne={items:[]},$e=[];return te.forEach((Qe,Ve)=>{$e.push((async()=>{Ne.items.push([Ve,await bt.from(Ve,Qe)])})())}),await Promise.all($e),Ne}Ae.toDataTransferDTO=Ee})(Lt=e.DataTransfer||(e.DataTransfer={}))}),define(Se[231],ye([1,0,2,10,7,14,64]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(C,R,P,E={timeout:1500,errors:3}){this.c=C,this.d=R,this.f=P,this.g=E,this.a=new D.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(R,P,E)=>{const v={dispose:this.a.push([R,P,C])};return Array.isArray(E)&&E.push(v),v}}async $participateInSave(C,R){const P=a.URI.revive(C);let E=!1;const y=setTimeout(()=>E=!0,this.g.timeout),v=[];try{for(const d of[...this.a]){if(E)break;const g=this.d.getDocument(P),m=await this.h(d,{document:g,reason:A.TextDocumentSaveReason.to(R)});v.push(m)}}finally{clearTimeout(y)}return v}h([C,R,P],E){const y=this.b.get(C);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,C,R,E).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this.b.get(C);this.b.set(C,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,R,P,E){const y=[],v=Date.now(),{document:d,reason:g}=E,{version:m}=d,w=Object.freeze({document:d,reason:g,waitUntil(f){if(Object.isFrozen(y))throw(0,t.illegalState)("waitUntil can not be called async");y.push(Promise.resolve(f))}});try{R.apply(P,[w])}catch(f){return Promise.reject(f)}return Object.freeze(y),new Promise((f,h)=>{const b=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(y).then(o=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(b),f(o)}).catch(o=>{clearTimeout(b),h(o)})}).then(f=>{const h={edits:[]};for(const b of f)if(Array.isArray(b)&&b.every(o=>o instanceof I.TextEdit))for(const{newText:o,newEol:r,range:c}of b)h.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:c&&A.Range.from(c),text:o,eol:r&&A.EndOfLine.from(r)}});if(h.edits.length!==0)return m===d.version?this.f.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Se[232],ye([1,0,15,2,14,7,90]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(P,E,y,v){this.start=P,this.deletedCount=E,this.deletedItems=y,this.items=v}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(P,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,E,y){this.notebook=P,this.h=E,this.j=y,this.handle=y.handle,this.uri=t.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(I.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,E=this.h.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:E.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(I.NotebookCellOutput.to)}setOutputItems(P,E,y){const v=y.map(I.NotebookCellOutputItem.to),d=this.a.find(g=>g.id===P);if(d&&(E||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(g=>D.isTextStreamMime(g.mime)))){const g=new Map,m=[];d.items.forEach(w=>{let f;g.has(w.mime)?f=g.get(w.mime):(f=[],g.set(w.mime,f),m.push(w.mime)),f.push(w.data)}),d.items.length=0,m.forEach(w=>{const f=D.compressOutputItemStreams(g.get(w));d.items.push({mime:w,data:f.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=S;class C{constructor(P,E,y,v,d){this.k=P,this.l=E,this.m=y,this.uri=v,this.handle=C.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,E={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===a.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(E)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,E,y){this.g=P.versionId,this.h=E,this.acceptDocumentPropertiesChanged({metadata:y});const v={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},d=[];for(const m of P.rawEvents)m.kind===D.NotebookCellsChangeType.ModelChange?this.r(m.changes,!1,v.contentChanges):m.kind===D.NotebookCellsChangeType.Move?this.s(m.index,m.length,m.newIdx,v.contentChanges):m.kind===D.NotebookCellsChangeType.Output?(this.t(m.index,m.outputs),d.push({cell:this.b[m.index].apiCell,outputs:this.b[m.index].apiCell.outputs})):m.kind===D.NotebookCellsChangeType.OutputItem?(this.u(m.index,m.outputId,m.append,m.outputItems),d.push({cell:this.b[m.index].apiCell,outputs:this.b[m.index].apiCell.outputs})):m.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this.v(m.index,m.language),d.push({cell:this.b[m.index].apiCell,document:this.b[m.index].apiCell.document})):m.kind===D.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[m.index].apiCell,document:this.b[m.index].apiCell.document}):m.kind===D.NotebookCellsChangeType.ChangeCellMime?this.w(m.index,m.mime):m.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this.x(m.index,m.metadata),d.push({cell:this.b[m.index].apiCell,metadata:this.b[m.index].apiCell.metadata})):m.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(m.index,m.internalMetadata),d.push({cell:this.b[m.index].apiCell,executionSummary:this.b[m.index].apiCell.executionSummary}));const g=new Map;for(let m=0;m<d.length;m++){const w=d[m],f=g.get(w.cell);if(f===void 0){const h=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...w});g.set(w.cell,h-1)}else v.cellChanges[f]={...v.cellChanges[f],...w}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let E=P.start|0,y=P.end|0;return E<0&&(E=0),y>this.b.length&&(y=this.b.length),P.with({start:E,end:y})}p(P){P=this.o(P);const E=[];for(let y=P.start;y<P.end;y++)E.push(this.b[y]);return E}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,E,y){if(this.j)return;const v=[],d=[],g=[];if(P.reverse().forEach(m=>{const f=m[2].map(o=>{const r=new S(this,this.l,o);return E||d.push(S.asModelAddData(this.apiNotebook,o)),r}),h=new T(m[0],m[1],[],f),b=this.b.splice(m[0],m[1],...f);for(const o of b)g.push(o.uri),h.deletedItems.push(o.apiCell);v.push(h)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:g}),y)for(const m of v)y.push(m.asApiEvent())}s(P,E,y,v){const d=this.b.splice(P,E);this.b.splice(y,0,...d);const g=[new T(P,E,d.map(m=>m.apiCell),[]),new T(y,0,[],d)];for(const m of g)v.push(m.asApiEvent())}t(P,E){this.b[P].setOutputs(E)}u(P,E,y,v){this.b[P].setOutputItems(E,y,v)}v(P,E){const y=this.b[P];y.apiCell.document.languageId!==E&&this.m.$acceptModelLanguageChanged(y.uri,E)}w(P,E){const y=this.b[P];y.apiCell.mime=E}x(P,E){this.b[P].setMetadata(E)}y(P,E){this.b[P].setInternalMetadata(E)}getCellFromApiCell(P){return this.b.find(E=>E.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(E=>E.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=C,C.a=0}),define(Se[135],ye([1,0,10,14,7]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(T,S,C,R,P,E){this.id=T,this.f=S,this.notebookData=C,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=R,this.c=E}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(S){this.selections=[S]},get selections(){return T.a},set selections(S){if(!Array.isArray(S)||!S.every(I.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");T.a=S,T.g(S)},get visibleRanges(){return T.b},revealRange(S,C){T.f.$tryRevealRange(T.id,t.NotebookRange.from(S),C??I.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[233],ye([1,0,4,13,14]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(T,S){this.c=T,this.d=S,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const C=this.d.getEditorById(T);S.visibleRanges&&C._acceptVisibleRanges(S.visibleRanges.ranges.map(I.NotebookRange.to)),S.selections&&C._acceptSelections(S.selections.selections.map(I.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this.d.getEditorById(S)._acceptViewColumn(I.ViewColumn.to(T[S]))}};A=qe([We(0,t.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Se[234],ye([1,0,14,124,173,21,61,10]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,y,v){const d=this.b++,{title:g,location:m,cancellable:w}=y,f={label:(0,I.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this.a.$startProgress(d,{location:a.ProgressLocation.from(m),title:g,source:f,cancellable:w},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.onUnexpectedExternalError),this.d(d,v,!!w)}d(E,y,v){let d;v&&(d=new A.CancellationTokenSource,this.c.set(E,d));const g=w=>{this.a.$progressEnd(w),this.c.delete(w),d?.dispose()};let m;try{m=y(new R(this.a,E),v&&d?d.token:A.CancellationToken.None)}catch(w){throw g(E),w}return m.then(w=>g(E),w=>g(E)),m}$acceptProgressCanceled(E){const y=this.c.get(E);y&&(y.cancel(),this.c.delete(E))}}e.ExtHostProgress=S;function C(P,E){return P.message=E.message,typeof E.increment=="number"&&(typeof P.increment=="number"?P.increment+=E.increment:P.increment=E.increment),P}class R extends t.Progress{constructor(E,y){super(v=>this.throttledReport(v)),this.c=E,this.d=y}throttledReport(E){this.c.$progressReport(this.d,E)}}qe([(0,D.throttle)(100,(P,E)=>C(P,E),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[136],ye([1,0,37,132,57,91,70,14,2]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(f,h,b,o)=>{let r=h;return{enumerable:!0,configurable:!1,get(){return r},set(c){if(!b(r,c)){const u=r;r=c,f.listener?.(o(c,u))}}}},R=(f,h)=>f===h,P={range:(f,h)=>f===h?!0:!f||!h?!1:f.isEqual(h),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,h)=>!(f.length!==h.length||f.some(b=>!h.find(o=>b.id===o.id)))},E=f=>h=>({op:4,update:f(h)}),y=(f,h)=>({range:(()=>{let b;const o=E(r=>({range:a.Range.lift(T.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return b},set(r){f.listener?.({op:6}),P.range(b,r)||(b=r,f.listener?.(o(r)))}}})(),label:C(f,h,P.label,E(b=>({label:b}))),description:C(f,void 0,P.description,E(b=>({description:b}))),sortText:C(f,void 0,P.sortText,E(b=>({sortText:b}))),canResolveChildren:C(f,!1,P.canResolveChildren,b=>({op:2,state:b})),busy:C(f,!1,P.busy,E(b=>({busy:b}))),error:C(f,void 0,P.error,E(b=>({error:T.MarkdownString.fromStrict(b)||null}))),tags:C(f,[],P.tags,(b,o)=>({op:1,new:b.map(T.TestTag.from),old:o.map(T.TestTag.from)}))}),v=f=>{const h=I.TestId.fromString(f.extId),b=new g(h.controllerId,h.localId,f.label,S.URI.revive(f.uri)||void 0);return b.range=T.Range.to(f.range||void 0),b.description=f.description||void 0,b.sortText=f.sortText||void 0,b.tags=f.tags.map(o=>T.TestTag.to({id:(0,D.denamespaceTestTag)(o).tagId})),b},d=f=>{let h;for(const b of f.tests){const o=v(b.item);(0,t.getPrivateApiFor)(o).parent=h,h=o}return h};e.toItemFromContext=d;class g{constructor(h,b,o,r){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const c=(0,t.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof m?void 0:c.parent}},children:{value:(0,A.createTestItemChildren)(c,t.getPrivateApiFor,g),enumerable:!0,writable:!1},...y(c,o)})}}e.TestItemImpl=g;class m extends g{constructor(h,b){super(h,h,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=m;class w extends A.TestItemCollection{constructor(h,b,o){super({controllerId:h,getDocumentVersion:r=>r&&o.getDocument(r)?.version,getApiFor:t.getPrivateApiFor,getChildren:r=>r.children,root:new m(h,b),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=w}),define(Se[137],ye([1,0,48,10,99,14,7]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(E,y,v){const d=T.c.nextId();E.$registerTextEditorDecorationType(y.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){E.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=T,T.c=new I.IdGenerator("TextEditorDecorationType");class S{constructor(E,y){this.g=[],this.h=void 0,this.j=!1,this.c=E,this.d=E.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(E,y){this.k();let v=null;if(E instanceof D.Position)v=new D.Range(E,E);else if(E instanceof D.Range)v=E;else throw new Error("Unrecognized location");this.l(v,y,!1)}insert(E,y){this.k(),this.l(new D.Range(E,E),y,!0)}delete(E){this.k();let y=null;if(E instanceof D.Range)y=E;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(E,y,v){const d=this.c.validateRange(E);this.g.push({range:d,text:y,forceMoveMarkers:v})}setEndOfLine(E){if(this.k(),E!==D.EndOfLine.LF&&E!==D.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=E}}e.TextEditorEdit=S;class C{constructor(E,y,v,d){this.c=E,this.d=y,this._accept(v),this.e=d;const g=this;this.value={get tabSize(){return g.f},set tabSize(m){g.m(m)},get indentSize(){return g.g},set indentSize(m){g.o(m)},get insertSpaces(){return g.h},set insertSpaces(m){g.q(m)},get cursorStyle(){return g.j},set cursorStyle(m){g.s(m)},get lineNumbers(){return g.k},set lineNumbers(m){g.t(m)}}}_accept(E){this.f=E.tabSize,this.g=E.indentSize,this.h=E.insertSpaces,this.j=E.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to(E.lineNumbers)}l(E){if(E==="auto")return"auto";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}m(E){const y=this.l(E);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(E){if(E==="tabSize")return"tabSize";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}o(E){const y=this.n(E);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}q(E){const y=this.p(E);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(E){this.j!==E&&(this.j=E,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:E})))}t(E){this.k!==E&&(this.k=E,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(E)})))}assign(E){const y={};let v=!1;if(typeof E.tabSize<"u"){const d=this.l(E.tabSize);d==="auto"?(v=!0,y.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,y.tabSize=d)}if(typeof E.indentSize<"u"){const d=this.n(E.indentSize);d==="tabSize"?(v=!0,y.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,v=!0,y.indentSize=d)}if(typeof E.insertSpaces<"u"){const d=this.p(E.insertSpaces);d==="auto"?(v=!0,y.insertSpaces=d):this.h!==d&&(this.h=d,v=!0,y.insertSpaces=d)}typeof E.cursorStyle<"u"&&this.j!==E.cursorStyle&&(this.j=E.cursorStyle,v=!0,y.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this.k!==E.lineNumbers&&(this.k=E.lineNumbers,v=!0,y.lineNumbers=A.TextEditorLineNumbersStyle.from(E.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(E,y){y.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=C;class R{constructor(E,y,v,d,g,m,w,f){this.id=E,this.j=y,this.k=v,this.g=!1,this.h=new Set,this.c=g,this.d=new C(this.j,this.id,m,v),this.e=w,this.f=f;const h=this;this.value=Object.freeze({get document(){return d.getValue()},set document(b){throw(0,t.readonly)("document")},get selection(){return h.c&&h.c[0]},set selection(b){if(!(b instanceof D.Selection))throw(0,t.illegalArgument)("selection");h.c=[b],h.l()},get selections(){return h.c},set selections(b){if(!Array.isArray(b)||b.some(o=>!(o instanceof D.Selection)))throw(0,t.illegalArgument)("selections");h.c=b,h.l()},get visibleRanges(){return h.e},set visibleRanges(b){throw(0,t.readonly)("visibleRanges")},get options(){return h.d.value},set options(b){h.g||h.d.assign(b)},get viewColumn(){return h.f},set viewColumn(b){throw(0,t.readonly)("viewColumn")},edit(b,o={undoStopBefore:!0,undoStopAfter:!0}){if(h.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(d.getValue(),o);return b(r),h.m(r)},insertSnippet(b,o,r={undoStopBefore:!0,undoStopAfter:!0}){if(h.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!o||Array.isArray(o)&&o.length===0)c=h.c.map(u=>A.Range.from(u));else if(o instanceof D.Position){const{lineNumber:u,column:i}=A.Position.from(o);c=[{startLineNumber:u,startColumn:i,endLineNumber:u,endColumn:i}]}else if(o instanceof D.Range)c=[A.Range.from(o)];else{c=[];for(const u of o)if(u instanceof D.Range)c.push(A.Range.from(u));else{const{lineNumber:i,column:s}=A.Position.from(u);c.push({startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s})}}return y.$tryInsertSnippet(E,d.getValue().version,b.value,c,r)},setDecorations(b,o){const r=o.length===0;r&&!h.h.has(b.key)||(r?h.h.delete(b.key):h.h.add(b.key),h.n(()=>{if(A.isDecorationOptionsArr(o))return y.$trySetDecorations(E,b.key,A.fromRangeOrRangeWithMessage(o));{const c=new Array(4*o.length);for(let u=0,i=o.length;u<i;u++){const s=o[u];c[4*u]=s.start.line+1,c[4*u+1]=s.start.character+1,c[4*u+2]=s.end.line+1,c[4*u+3]=s.end.character+1}return y.$trySetDecorationsFast(E,b.key,c)}}))},revealRange(b,o){h.n(()=>y.$tryRevealRange(E,A.Range.from(b),o||D.TextEditorRevealType.Default))},show(b){y.$tryShowEditor(E,A.ViewColumn.from(b))},hide(){y.$tryHideEditor(E)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(E){(0,a.ok)(!this.g),this.d._accept(E)}_acceptVisibleRanges(E){(0,a.ok)(!this.g),this.e=E}_acceptViewColumn(E){(0,a.ok)(!this.g),this.f=E}_acceptSelections(E){(0,a.ok)(!this.g),this.c=E}async l(){const E=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,E)),this.value}m(E){const y=E.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const v=y.edits.map(g=>g.range);v.sort((g,m)=>g.end.line===m.end.line?g.end.character===m.end.character?g.start.line===m.start.line?g.start.character-m.start.character:g.start.line-m.start.line:g.end.character-m.end.character:g.end.line-m.end.line);for(let g=0,m=v.length-1;g<m;g++){const w=v[g].end;if(v[g+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=y.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,d,{setEndOfLine:typeof y.setEndOfLine=="number"?A.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(E){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.ExtHostTextEditor=R}),define(Se[235],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[236],ye([1,0,187,10,42,121,125,43,27,235,199,189]),function(ee,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=T.Registry.as(D.Extensions.JSONContribution);class y{constructor(b,o,r){this.a=b,this.b=o,this.c=r}d(b,o){this.a({type:b,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(I.default.Error,b)}warn(b){this.d(I.default.Warning,b)}info(b){this.d(I.default.Info,b)}}e.ExtensionMessageCollector=y;class v{static a(b){const o=new Set;for(let r=0,c=b.length;r<c;r++)o.add(S.ExtensionIdentifier.toKey(b[r].description.identifier));return o}static compute(b,o){if(!b||!b.length)return new v(o,[]);if(!o||!o.length)return new v([],b);const r=this.a(b),c=this.a(o),u=o.filter(s=>!r.has(S.ExtensionIdentifier.toKey(s.description.identifier))),i=b.filter(s=>!c.has(S.ExtensionIdentifier.toKey(s.description.identifier)));return new v(u,i)}constructor(b,o){this.added=b,this.removed=o}}e.ExtensionPointUserDelta=v;class d{constructor(b,o){this.name=b,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=v.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,t.onUnexpectedError)(b)}}}e.ExtensionPoint=d;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},m="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},activationEvents:{description:a.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(30,null)},{label:"onUri",body:"onUri",description:a.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(35,null)},{label:"onRenderer",description:a.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(37,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(39,null)},{label:"*",description:a.localize(40,null),body:"*"}]}},badges:{type:"array",description:a.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(42,null)},href:{type:"string",description:a.localize(43,null)},description:{type:"string",description:a.localize(44,null)}}}},markdown:{type:"string",description:a.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(49,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(50,null)},{body:["workspace"],description:a.localize(51,null)},{body:["ui","workspace"],description:a.localize(52,null)},{body:["workspace","ui"],description:a.localize(53,null)},{body:[],description:a.localize(54,null)}]},capabilities:{description:a.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(58,null),a.localize(59,null),a.localize(60,null)]},description:{type:"string",markdownDescription:a.localize(61,null)}}},untrustedWorkspaces:{description:a.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(64,null),a.localize(65,null),a.localize(66,null)]},restrictedConfigurations:{description:a.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(68,null)}}}}},sponsor:{description:a.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(71,null),type:"string"},"vscode:uninstall":{description:a.localize(72,null),type:"string"}}},icon:{type:"string",description:a.localize(73,null)},l10n:{type:"string",description:a.localize(74,null)}}};class w{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const o=new d(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,o),b.activationEventsGenerator&&P.ImplicitActivationEvents.register(b.extensionPoint,b.activationEventsGenerator),e.schema.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,E.registerSchema(m,e.schema),o}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=w;const f={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(f.ExtensionsRegistry,new w),e.ExtensionsRegistry=T.Registry.as(f.ExtensionsRegistry),E.registerSchema(m,e.schema),E.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(Se[237],ye([1,0,184,12,23,236,54,4]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var C;(function(E){function y(v,d,g){if(!v)return;const m=t.isString(v.type)?v.type:void 0;if(!m||m.length===0){g.error(a.localize(3,null));return}const w=[];if(Array.isArray(v.required))for(const f of v.required)t.isString(f)&&w.push(f);return{extensionId:d.value,taskType:m,required:w,properties:v.properties?I.deepClone(v.properties):{},when:v.when?D.ContextKeyExpr.deserialize(v.when):void 0}}E.from=y})(C||(C={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:S}});class P{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,v)=>{R.setHandler((d,g)=>{this.c=void 0;try{for(const m of g.removed){const w=m.value;for(const f of w)this.a&&f.type&&this.a[f.type]&&delete this.a[f.type]}for(const m of g.added){const w=m.value;for(const f of w){const h=C.from(f,m.description.identifier,m.collector);h&&(this.a[h.taskType]=h)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=I.deepClone(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},y.push(d)}this.c={oneOf:y}}return this.c}}e.TaskDefinitionRegistry=new P}),define(Se[238],ye([1,0,185,12,24,23,54,237]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function z(M){if(!M)return F.Strong;switch(M.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=z}(S=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(F){function z(M){switch(M.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=z}(R=e.RevealKind||(e.RevealKind={}));var P;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function z(M){switch(M.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=z}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(F){function z(M){switch(M.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=z}(E=e.PanelKind||(e.PanelKind={}));var y;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:P.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(y=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(F){function z(V){switch(V.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=z;function M(V){switch(V){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=M}(v=e.RuntimeType||(e.RuntimeType={}));var d;(function(F){function z(M){return t.isString(M)?M:M.value}F.value=z})(d=e.CommandString||(e.CommandString={}));var g;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function z(V){return V===F.Clean._id||V===F.Build._id||V===F.Rebuild._id||V===F.Test._id}F.is=z;function M(V){if(V!==void 0)return t.isString(V)?z(V)?{_id:V,isDefault:!1}:void 0:V}F.from=M})(g=e.TaskGroup||(e.TaskGroup={}));var m;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(m=e.TaskScope||(e.TaskScope={}));var w;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function z(M){switch(M){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=z})(w=e.TaskSourceKind||(e.TaskSourceKind={}));var f;(function(F){F.parallel="parallel",F.sequence="sequence"})(f=e.DependsOrder||(e.DependsOrder={}));var h;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(h=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:h.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class o{constructor(z,M,V,q,H,Q){this._label="",this._id=z,M&&(this._label=M),V&&(this.type=V),this.runOptions=q,this.configurationProperties=H,this._source=Q}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,M=!1){if(z===void 0)return!1;if(t.isString(z))return z===this._label||z===this.configurationProperties.identifier||M&&z===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.CommonTask=o;class r extends o{constructor(z,M,V,q,H,Q,Y,ce){super(z,V,void 0,Y,ce,M),this.command={},this._source=M,this.hasDefinedMatchers=Q,H&&(this.command=H)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let M;switch(this.command?this.command.runtime:void 0){case v.Shell:M="shell";break;case v.Process:M="process";break;case v.CustomExecution:M="customExecution";break;case void 0:M="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:M,_key:this._id,id:this._id}}}static is(z){return z instanceof r}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let M=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(M+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:M};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new r(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=r;class c extends o{constructor(z,M,V,q,H,Q,Y){super(z,V,q,Q,Y,M),this._source=M,this.configures=H}static is(z){return z instanceof c}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let M=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(M+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:M};return JSON.stringify(V)}}e.ConfiguringTask=c;class u extends o{constructor(z,M,V,q,H,Q,Y,ce,ie){super(z,V,q,ce,ie,M),this.defines=H,this.hasDefinedMatchers=Y,this.command=Q,this.icon=ie.icon,this.hide=ie.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof u}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new u(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=u;class i extends o{constructor(z,M,V,q,H,Q){super(z,V,q,H,Q,M),this._source=M}clone(){return new i(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof i}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new i(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=i;var s;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(s=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(s=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor(z){this.c=new Map;for(let M=0;M<z.length;M++)this.c.set(z[M].uri.toString(),M)}compare(z,M){const V=z.getWorkspaceFolder(),q=M.getWorkspaceFolder();if(V&&q){let H=this.c.get(V.uri.toString());H=H===void 0?0:H+1;let Q=this.c.get(q.uri.toString());return Q=Q===void 0?0:Q+1,H===Q?z._label.localeCompare(M._label):H-Q}else return!V&&q?-1:V&&!q?1:0}}e.TaskSorter=l;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var k;(function(F){F.SingleRun="singleRun",F.Background="background"})(k=e.TaskRunType||(e.TaskRunType={}));var L;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var B;(function(F){function z(M,V,q,H){if(V){const Q={kind:M,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:q,__task:V};return M==="start"?Q.resolvedVariables=H:M==="processStarted"?Q.processId=H:M==="processEnded"&&(Q.exitCode=H),Object.freeze(Q)}else return Object.freeze({kind:"changed"})}F.create=z})(B=e.TaskEvent||(e.TaskEvent={}));var K;(function(F){function z(V){const q=Object.keys(V).sort();let H="";for(const Q of q){let Y=V[Q];Y instanceof Object?Y=z(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),H+=Q+","+Y+","}return H}function M(V){const H={_key:z(V),type:V.taskType};return Object.assign(H,V),H}F.create=M})(K=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var G;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(G=e.TaskSettingId||(e.TaskSettingId={}));var O;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(O=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(F){function z(M,V){const q=T.TaskDefinitionRegistry.get(M.type);if(q===void 0){const ce=A.deepClone(M);return delete ce._key,K.create(ce)}const H=Object.create(null);H.type=q.taskType;const Q=new Set;q.required.forEach(ce=>Q.add(ce));const Y=q.properties;for(const ce of Object.keys(Y)){const ie=M[ce];if(ie!=null)H[ce]=ie;else if(Q.has(ce)){const fe=Y[ce];if(fe.default!==void 0)H[ce]=A.deepClone(fe.default);else switch(fe.type){case"boolean":H[ce]=!1;break;case"number":case"integer":H[ce]=0;break;case"string":H[ce]="";break;default:V.error(a.localize(2,null,JSON.stringify(M,void 0,0),ce));return}}}return K.create(H)}F.createTaskIdentifier=z})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(Se[239],ye([1,0,10]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((D,T)=>{this.b=D,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(D){this.f||this.h||(this.f=!0,this.g=D,this.a&&this.b(D))}resolveErr(D){this.f||this.h||(this.h=!0,this.i=D,this.a?this.d(D):(0,a.onUnexpectedError)(D))}then(D,T){return this.j().then(D,T)}catch(D){return this.j().then(void 0,D)}finally(D){return this.j().finally(D)}}e.LazyPromise=t;class I extends t{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=I}),define(Se[58],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const t=[];function I(T){const S=new a(T);return t[S.nid]=S,S}e.createProxyIdentifier=I;function A(T){return t[T].sid}e.getStringIdentifierForProxy=A;class D{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=D}),define(Se[5],ye([1,0,58]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(g){return g._id=P.a++,g}}e.IdObject=P,P.a=0;var E;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var y;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(y=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(Se[71],ye([1,0,3,13,5,16]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(S,C){this.c=C,this.a=new Set,this.b=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,C,R){const P=this.d(S,C);this.a.has(P)||(this.a.add(P),C.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}d(S,C){return`${S}-${C.identifier.value}`}};D=qe([We(0,A.IExtHostRpcService),We(1,t.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,C){}})}),define(Se[240],ye([1,0,4,5,7,27]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(S){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,C,R,P={}){const E=A.ExtensionIdentifier.toKey(S.identifier),y=this.f.get(E)||[],v=[...R].sort().join(" ");let d=y.find(g=>g.providerId===C&&g.scopes===v);if(d)return d.result;{const g=this.g(S,E,C,R,P);d={providerId:C,scopes:v,result:g},y.push(d),this.f.set(E,y);try{await g}finally{const m=y.findIndex(w=>w.providerId===C&&w.scopes===v);m>-1&&(y.splice(m),this.f.set(E,y))}return g}}async g(S,C,R,P,E={}){await this.a.$ensureProvider(R);const y=S.displayName||S.name;return this.a.$getSession(R,P,C,y,E)}async removeSession(S,C){const R=this.b.get(S);return R?R.provider.removeSession(C):this.a.$removeSession(S,C)}registerAuthenticationProvider(S,C,R,P){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:C,provider:R,options:P??{supportsMultipleAccounts:!1}}),this.c.find(y=>y.id===S)||this.c.push({id:S,label:C});const E=R.onDidChangeSessions(y=>{this.a.$sendDidChangeSessions(S,{added:y.added??[],changed:y.changed??[],removed:y.removed??[]})});return this.a.$registerAuthenticationProvider(S,C,P?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this.b.delete(S);const y=this.c.findIndex(v=>v.id===S);y>-1&&this.c.splice(y),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this.d.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(Se[241],ye([1,0,5,16,14]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,S){this.a=T.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>S.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,C){const R=I.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,C?.isRefactoring??!1)}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Se[242],ye([1,0,5]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const D=A.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(T){return D.$writeText(T)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[39],ye([1,0,12,7,14,23,5,17,13,86,37,51,2,6,3,16,136,22,58,52]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f){"use strict";var h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(n,l){h.set(this,void 0),this.b=new Map,this.c=new Map,b.set(this,void 0),Je(this,h,n.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=l,Je(this,b,n.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new r(this,p=>{const k=this.c.get(p);return k?.result===u.Void?k:void 0},l),this.f=[{processArgument(p){return(0,C.revive)(p)}},{processArgument(p){return(0,A.cloneAndChange)(p,function(k){if(R.Range.isIRange(k))return I.Range.to(k);if(P.Position.isIPosition(k))return I.Position.to(k);if(R.Range.isIRange(k.range)&&E.URI.isUri(k.uri))return I.location.to(k);if(k instanceof m.VSBuffer)return k.buffer.buffer;if(!Array.isArray(k))return k})}}]}registerArgumentProcessor(n){this.f.push(n)}registerApiCommand(n){const l=this.registerCommand(!1,n.id,async(...p)=>{const k=n.args.map((B,K)=>{if(!B.validate(p[K]))throw new Error(`Invalid argument '${B.name}' when running '${n.id}', received: ${p[K]}`);return B.convert(p[K])}),L=await this.executeCommand(n.internalId,...k);return n.result.convert(L,p,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this.c.set(n.id,n),new t.Disposable(()=>{l.dispose(),this.c.delete(n.id)})}registerCommand(n,l,p,k,L,B){if(this.d.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this.b.has(l))throw new Error(`command '${l}' already exists`);return this.b.set(l,{callback:p,thisArg:k,description:L,extension:B}),n&&Fe(this,h,"f").$registerCommand(l),new t.Disposable(()=>{this.b.delete(l)&&n&&Fe(this,h,"f").$unregisterCommand(l)})}executeCommand(n,...l){return this.d.trace("ExtHostCommands#executeCommand",n),this.g(n,l,!0)}async g(n,l,p){if(this.b.has(n))return Fe(this,h,"f").$fireCommandActivationEvent(n),this.h(n,l,!1);{let k=!1;const L=(0,A.cloneAndChange)(l,function(B){if(B instanceof t.Position)return I.Position.from(B);if(B instanceof t.Range)return I.Range.from(B);if(B instanceof t.Location)return I.location.from(B);if(t.NotebookRange.isNotebookRange(B))return I.NotebookRange.from(B);if(B instanceof ArrayBuffer)return k=!0,m.VSBuffer.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return k=!0,m.VSBuffer.wrap(B);if(B instanceof m.VSBuffer)return k=!0,B;if(!Array.isArray(B))return B});try{const B=await Fe(this,h,"f").$executeCommand(n,k?new w.SerializableObjectWithBuffers(L):L,p);return(0,C.revive)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(n,l,!1);throw B}}}async h(n,l,p){const k=this.b.get(n);if(!k)throw new Error("Unknown command");const{callback:L,thisArg:B,description:K}=k;if(K)for(let O=0;O<K.args.length;O++)try{(0,a.validateConstraint)(l[O],K.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${K.args[O].name}' - ${K.args[O].description}`)}const G=Date.now();try{return await L.apply(B,l)}catch(O){if(n===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...l);U&&(n=U.command)}throw this.d.error(O,n,k.extension?.identifier),p?new class extends Error{constructor(){super((0,f.toErrorMessage)(O)),this.id=n,this.source=k.extension?.displayName??k.extension?.name}}:O}finally{this.j(k,n,Date.now()-G)}}j(n,l,p){!n.extension||n.extension.isBuiltin||Fe(this,b,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:l,duration:p})}$executeContributedCommand(n,...l){return this.d.trace("ExtHostCommands#$executeContributedCommand",n),this.b.has(n)?(l=l.map(p=>this.f.reduce((k,L)=>L.processArgument(k),p)),this.h(n,l,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this.d.trace("ExtHostCommands#getCommands",n),Fe(this,h,"f").$getCommands().then(l=>(n&&(l=l.filter(p=>p[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[l,p]of this.b){const{description:k}=p;k&&(n[l]=k)}return Promise.resolve(n)}};h=new WeakMap,b=new WeakMap,o=qe([We(0,d.IExtHostRpcService),We(1,S.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class r{constructor(n,l,p){this.d=n,this.f=l,this.g=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(n,l){if(!n)return;const p={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return p;const k=this.f(n.command);if(k)p.id=k.internalId,p.arguments=k.args.map((L,B)=>L.convert(n.arguments&&n.arguments[B]));else if((0,T.isNonEmptyArray)(n.arguments)){const L=`${n.command}/${++this.c}`;this.b.set(L,n),l.add((0,y.toDisposable)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),p.$ident=L,p.id=this.delegatingCommandId,p.arguments=[L],this.g.trace("CommandsConverter#CREATE",n.command,L)}return p}fromInternal(n){return typeof n.$ident=="string"?this.b.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this.b.get(n[0])}h(...n){const l=this.getActualCommand(...n);return this.g.trace("CommandsConverter#EXECUTE",n[0],l?l.command:"MISSING"),l?this.d.executeCommand(l.command,...l.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${n[0]}`)}}e.CommandsConverter=r;class c{constructor(n,l,p,k){this.name=n,this.description=l,this.validate=p,this.convert=k}optional(){return new c(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,l){return new c(n??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",s=>E.URI.isUri(s),s=>s),c.Position=new c("position","A position in a text document",s=>t.Position.isPosition(s),I.Position.from),c.Range=new c("range","A range in a text document",s=>t.Range.isRange(s),I.Range.from),c.Selection=new c("selection","A selection in a text document",s=>t.Selection.isSelection(s),I.Selection.from),c.Number=new c("number","",s=>typeof s=="number",s=>s),c.String=new c("string","",s=>typeof s=="string",s=>s),c.CallHierarchyItem=new c("item","A call hierarchy item",s=>s instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",s=>s instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",s=>s instanceof g.TestItemImpl,I.TestItem.from);class u{constructor(n,l){this.description=n,this.convert=l}}e.ApiCommandResult=u,u.Void=new u("no result",s=>s);class i{constructor(n,l,p,k,L){this.id=n,this.internalId=l,this.description=p,this.args=k,this.result=L}}e.ApiCommand=i}),define(Se[243],ye([1,0,2,14,7,67,39,17,118,123,15]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",y(t.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,g)=>{if((0,T.isFalsyOrEmpty)(d))return;class m extends I.SymbolInformation{static to(f){const h=new m(f.name,t.SymbolKind.to(f.kind),f.containerName||"",new I.Location(g[0],t.Range.to(f.range)));return h.detail=f.detail,h.range=h.location.range,h.selectionRange=t.Range.to(f.selectionRange),h.children=f.children?f.children.map(m.to):[],h}}return d.map(m.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",y(t.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",y(t.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(g=>I.Position.isPosition(g)),d=>d.map(t.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(g=>{let m;for(const w of g.reverse())m=new I.SelectionRange(t.Range.to(w),m);return m}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,S.decodeSemanticTokensDto)(d);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,S.decodeSemanticTokensDto)(d);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,g,m)=>{if(!d)return new I.CompletionList([]);const w=d.suggestions.map(f=>t.CompletionItem.to(f,m));return new I.CompletionList(w,d.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,g,m)=>y(w=>new I.CodeLens(t.Range.to(w.range),w.command&&m.fromInternal(w.command)))(d))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.Range.isRange(d),d=>I.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,g,m)=>y(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(w.command)}else{const f=new I.CodeAction(w.title,w.kind?new I.CodeActionKind(w.kind):void 0);return w.edit&&(f.edit=t.WorkspaceEdit.to(w.edit)),w.command&&(f.command=m.fromInternal(w.command)),f.isPreferred=w.isPreferred,f}})(d))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(g=>new I.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",d=>d instanceof I.Color,t.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,g,m)=>d.map(t.InlayHint.to.bind(void 0,m)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",y(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>a.URI.isUri(d)||typeof d=="string"&&(0,C.matchesSomeScheme)(d,R.Schemas.http,R.Schemas.https),d=>d),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class E{static register(g){P.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=E;function y(d){return g=>{if(Array.isArray(g))return g.map(d)}}function v(d){if(!Array.isArray(d))return;const g=[];for(const m of d)A.isLocationLink(m)?g.push(t.DefinitionLink.to(m)):g.push(t.location.to(m));return g}}),define(Se[244],ye([1,0,18,61,4,6,2,67,27,14,7,26,5]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function y(v,d,g){const m=v.getProxy(E.MainContext.MainThreadComments);class w{constructor(){this.b=new Map,this.c=new Map,d.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const n=this.b.get(s.handle);return n?n.value:s}else if(s&&s.$mid===7){const n=this.b.get(s.commentControlHandle);if(!n)return s;const l=n.getCommentThread(s.commentThreadHandle);return l?l.value:s}else if(s&&(s.$mid===9||s.$mid===8)){const n=this.b.get(s.thread.commentControlHandle);if(!n)return s;const l=n.getCommentThread(s.thread.commentThreadHandle);return l?s.$mid===8?l.value:{thread:l.value,text:s.text}:s}else if(s&&s.$mid===10){const n=this.b.get(s.thread.commentControlHandle);if(!n)return s;const l=n.getCommentThread(s.thread.commentThreadHandle);if(!l)return s;const p=s.commentUniqueId,k=l.getCommentByUniqueId(p);return k||s}else if(s&&s.$mid===11){const n=this.b.get(s.thread.commentControlHandle);if(!n)return s;const l=n.getCommentThread(s.thread.commentThreadHandle);if(!l)return s;const p=s.text,k=s.commentUniqueId,L=l.getCommentByUniqueId(k);return L?(typeof L.body=="string"?L.body=p:L.body.value=p,L):s}return s}})}createCommentController(s,n,l){const p=w.a++,k=new h(s,p,n,l);this.b.set(k.handle,k);const L=this.c.get(S.ExtensionIdentifier.toKey(s.identifier))||[];return L.push(k),this.c.set(S.ExtensionIdentifier.toKey(s.identifier),L),k.value}$createCommentThreadTemplate(s,n,l){const p=this.b.get(s);!p||p.$createCommentThreadTemplate(n,l)}async $updateCommentThreadTemplate(s,n,l){const p=this.b.get(s);!p||p.$updateCommentThreadTemplate(n,l)}$deleteCommentThread(s,n){this.b.get(s)?.$deleteCommentThread(n)}$provideCommentingRanges(s,n,l){const p=this.b.get(s);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const k=g.getDocument(D.URI.revive(n));return(0,a.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(k,l)).then(L=>L?L.map(B=>C.Range.from(B)):void 0)}$toggleReaction(s,n,l,p,k){const L=this.b.get(s);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const B=L.getCommentThread(n);if(B){const K=B.getCommentByUniqueId(p.uniqueIdInThread);if(L!==void 0&&K&&L.reactionHandler)return L.reactionHandler(K,r(k))}return Promise.resolve(void 0)})}dispose(){}}w.a=0;class f{set threadId(s){this.n=s}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(s){s.isEqual(this.p)||(this.p=s,this.b.range=s,this.c.fire())}get range(){return this.p}set canReply(s){this.d!==s&&(this.d=s,this.b.canReply=s,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(s){this.e=s,this.b.label=s,this.c.fire()}get contextValue(){return this.f}set contextValue(s){this.f=s,this.b.contextValue=s,this.c.fire()}get comments(){return this.q}set comments(s){this.q=s,this.b.comments=s,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(s){this.g=s,this.b.collapsibleState=s,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(s){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=s,this.b.state=s,this.c.fire()}get isDisposed(){return this.j}constructor(s,n,l,p,k,L,B,K){this.m=n,this.n=l,this.o=p,this.p=k,this.q=L,this.extensionDescription=B,this.r=K,this.handle=f.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.MutableDisposable,this.l.value=new A.DisposableStore,this.n===void 0&&(this.n=`${s}.${this.handle}`),m.$createCommentThread(n,this.handle,this.n,this.o,C.Range.from(this.p),B.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{m.$deleteCommentThread(n,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(O){G.range=O},get comments(){return G.comments},set comments(O){G.comments=O},get collapsibleState(){return G.collapsibleState},set collapsibleState(O){G.collapsibleState=O},get canReply(){return G.canReply},set canReply(O){G.canReply=O},get contextValue(){return G.contextValue},set contextValue(O){G.contextValue=O},get label(){return G.label},set label(O){G.label=O},get state(){return G.state},set state(O){G.state=O},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.DisposableStore);const s=l=>Object.prototype.hasOwnProperty.call(this.b,l),n={};s("range")&&(n.range=C.Range.from(this.p)),s("label")&&(n.label=this.label),s("contextValue")&&(n.contextValue=this.contextValue??null),s("comments")&&(n.comments=this.q.map(l=>b(this,l,this.k))),s("collapsibleState")&&(n.collapseState=c(this.g)),s("canReply")&&(n.canReply=this.canReply),s("state")&&(n.state=u(this.h)),s("isTemplate")&&(n.isTemplate=this.r),this.b={},m.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(s){for(const n of this.k){const l=n[0],p=n[1];if(s===p)return l}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(s=>s.dispose())}}f.a=0,qe([(0,t.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class h{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(s){this.b=s,m.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(s){this.c=s,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this.d}set options(s){this.d=s,m.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(s,n,l,p){this.f=s,this.g=n,this.h=l,this.i=p,this.a=new Map,m.$registerCommentController(this.handle,l,p);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(L){k.options=L},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(L){k.commentingRangeProvider=L},get reactionHandler(){return k.reactionHandler},set reactionHandler(L){k.reactionHandler=L},createCommentThread(L,B,K){return k.createCommentThread(L,B,K).value},dispose:()=>{k.dispose()}}),this.e=[],this.e.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(s,n,l,p){if(typeof s=="string"){const k=new f(this.id,this.handle,s,n,l,p,this.f,!1);return this.a.set(k.handle,k),k}else{const k=new f(this.id,this.handle,void 0,s,n,l,this.f,!1);return this.a.set(k.handle,k),k}}$createCommentThreadTemplate(s,n){const l=new f(this.id,this.handle,void 0,D.URI.revive(s),C.Range.to(n),[],this.f,!0);return l.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(l.handle,l),l}$updateCommentThreadTemplate(s,n){const l=this.a.get(s);l&&(l.range=C.Range.to(n))}$deleteCommentThread(s){this.a.get(s)?.dispose(),this.a.delete(s)}getCommentThread(s){return this.a.get(s)}dispose(){this.a.forEach(s=>{s.dispose()}),this.e.forEach(s=>s.dispose())}}function b(i,s,n){let l=n.get(s);l||(l=++i.commentHandle,n.set(s,l));const p=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:l,body:typeof s.body=="string"?s.body:C.MarkdownString.from(s.body),userName:s.author.name,userIconPath:p,label:s.label,commentReactions:s.reactions?s.reactions.map(k=>o(k)):void 0,timestamp:s.timestamp?.toJSON()}}function o(i){return{label:i.label,iconPath:i.iconPath?C.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function r(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?D.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function c(i){if(i!==void 0)switch(i){case R.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function u(i){if(i!==void 0)switch(i){case R.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new w}e.createExtHostComments=y}),define(Se[245],ye([1,0,23,5,25,16]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(R,P){this.a=R.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,P){const E=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){E.e(R,P,y,arguments)}})}e(R,P,E,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:S(y,this.b)}),this.c&&this.f(R,E,y)}};D=qe([We(0,A.IExtHostRpcService),We(1,I.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const T=1e5;function S(C,R){const P=[];if(C.length)for(let E=0;E<C.length;E++){let y=C[E];if(typeof y>"u")y="undefined";else if(y instanceof Error){const v=y;v.stack?y=v.stack:y=v.toString()}P.push(y)}if(R){const E=new Error().stack;E&&P.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,a.safeStringify)(P);return E.length>T?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Se[138],ye([1,0,2,5,7,3,16,13,17,8,9,26]),function(ee,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Rn{constructor(v,d){this.h=d,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,d){const g=Rn.c++;this.f.set(g,{provider:v,extensionDescription:d}),this.g.$registerDecorationProvider(g,d.identifier.value);const m=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(w=>{if(!w){this.g.$onDidChange(g,null);return}const f=(0,S.asArray)(w);if(f.length<=Rn.d){this.g.$onDidChange(g,f);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,f.length);const h=f.map(r=>({uri:r,rank:(0,C.count)(r.path,"/")})),b=(0,S.groupBy)(h,(r,c)=>r.rank-c.rank||(0,C.compare)(r.uri.path,c.uri.path)),o=[];e:for(const r of b){let c;for(const u of r){const i=(0,R.dirname)(u.uri.path);if(c!==i&&(c=i,o.push(u.uri)>=Rn.d))break e}}this.g.$onDidChange(g,o)});return new I.Disposable(()=>{m?.dispose(),this.g.$unregisterDecorationProvider(g),this.f.delete(g)})}async $provideDecorations(v,d,g){if(!this.f.has(v))return Object.create(null);const m=Object.create(null),{provider:w,extensionDescription:f}=this.f.get(v);return await Promise.all(d.map(async h=>{try{const{uri:b,id:o}=h,r=await Promise.resolve(w.provideFileDecoration(a.URI.revive(b),g));if(!r)return;try{I.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,P.checkProposedApiEnabled)(f,"codiconDecoration"),m[o]=[r.propagate,r.tooltip,r.badge,r.color]}catch(c){this.h.warn(`INVALID decoration from extension '${f}': ${c}`)}}catch(b){this.h.error(b)}})),m}};E.c=0,E.d=250,E=qe([We(0,D.IExtHostRpcService),We(1,T.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[246],ye([1,0,171,122,2,5,7,14,4,13,28,46]),function(ee,e,a,t,I,A,D,T,S,C,R,P){"use strict";var E,y,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(w,f,h,b,o,r,c){this.d=w,this.e=f,this.f=h,this.g=b,E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),this.c=!1,Je(this,v,new R.ResourceMap(u=>o.getComparisonKey(u)),"f"),Je(this,E,r,"f"),Je(this,y,c,"f")}dispose(){this.c||(Fe(this,y,"f").fire([...Fe(this,v,"f").keys()]),Fe(this,E,"f")?.$clear(this.e),Fe(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(w,f){if(!w){this.clear();return}this.h();let h=[];if(I.URI.isUri(w)){if(!f){this.delete(w);return}Fe(this,v,"f").set(w,f.slice()),h=[w]}else if(Array.isArray(w)){h=[];let o;w=[...w].sort(d.j);for(const r of w){const[c,u]=r;if((!o||c.toString()!==o.toString())&&(o&&Fe(this,v,"f").get(o).length===0&&Fe(this,v,"f").delete(o),o=c,h.push(c),Fe(this,v,"f").set(c,[])),u)Fe(this,v,"f").get(c)?.push(...u);else{const i=Fe(this,v,"f").get(c);i&&(i.length=0)}}}if(Fe(this,y,"f").fire(h),!Fe(this,E,"f"))return;const b=[];for(const o of h){let r=[];const c=Fe(this,v,"f").get(o);if(c)if(c.length>this.f){r=[];const u=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const s of c)if(s.severity===u[i]&&r.push({...T.Diagnostic.from(s),modelVersionId:this.g(o)})===this.f)break e;r.push({severity:t.MarkerSeverity.Info,message:(0,a.localize)(0,null,c.length-this.f),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=c.map(u=>({...T.Diagnostic.from(u),modelVersionId:this.g(o)}));b.push([o,r])}Fe(this,E,"f").$changeMany(this.e,b)}delete(w){this.h(),Fe(this,y,"f").fire([w]),Fe(this,v,"f").delete(w),Fe(this,E,"f")?.$changeMany(this.e,[[w,void 0]])}clear(){this.h(),Fe(this,y,"f").fire([...Fe(this,v,"f").keys()]),Fe(this,v,"f").clear(),Fe(this,E,"f")?.$clear(this.e)}forEach(w,f){this.h();for(const[h,b]of this)w.call(f,h,b,this)}*[(E=new WeakMap,y=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const w of Fe(this,v,"f").keys())yield[w,this.get(w)]}get(w){this.h();const f=Fe(this,v,"f").get(w);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(w){return this.h(),Array.isArray(Fe(this,v,"f").get(w))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(w,f){return w[0].toString()<f[0].toString()?-1:w[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=d;let g=class pn{static _mapper(w){const f=new R.ResourceMap;for(const h of w)f.set(h,h);return{uris:Object.freeze(Array.from(f.values()))}}constructor(w,f,h,b){this.h=f,this.j=h,this.k=b,this.f=new Map,this.g=new S.DebounceEmitter({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pn._mapper),this.e=w.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(w,f){const{f:h,e:b,g:o,h:r,j:c,k:u}=this,i=new class{$changeMany(l,p){b.$changeMany(l,p),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,l,p.length===0?"CLEARING":p)}$clear(l){b.$clear(l),r.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,l)}dispose(){b.dispose()}};let s;if(!f)f="_generated_diagnostic_collection_name_#"+pn.c++,s=f;else if(!h.has(f))s=f;else{this.h.warn(`DiagnosticCollection with name '${f}' does already exist.`);do s=f+pn.c++;while(h.has(s))}return new class extends d{constructor(){super(f,s,pn.d,l=>u.getDocument(l)?.version,c.extUri,i,o),h.set(s,this)}dispose(){super.dispose(),h.delete(s)}}}getDiagnostics(w){if(w)return this.l(w);{const f=new Map,h=[];for(const b of this.f.values())b.forEach((o,r)=>{let c=f.get(o.toString());typeof c>"u"&&(c=h.length,f.set(o.toString(),c),h.push([o,[]])),h[c][1]=h[c][1].concat(...r)});return h}}l(w){let f=[];for(const h of this.f.values())h.has(w)&&(f=f.concat(h.get(w)));return f}$acceptMarkersChange(w){if(!this.m){const f="_generated_mirror",h=new d(f,f,pn.d,b=>{},this.j.extUri,void 0,this.g);this.f.set(f,h),this.m=h}for(const[f,h]of w)this.m.set(I.URI.revive(f),h.map(T.Diagnostic.to))}};g.c=0,g.d=1e3,g=qe([We(1,C.ILogService),We(2,P.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(Se[247],ye([1,0,2,5]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(D){this.a=D.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(D){return this.a.$showOpenDialog(D).then(T=>T?T.map(S=>a.URI.revive(S)):void 0)}showSaveDialog(D){return this.a.$showSaveDialog(D).then(T=>T?a.URI.revive(T):void 0)}}e.ExtHostDialogs=I}),define(Se[248],ye([1,0,10,2,7,5,15,21,8]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(P,E,y){this.d=E,this.e=y,this.b=new Map,this.c=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,E){if(Object.keys(D.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=C.a++;this.b.set(y,E),this.c.$registerTextContentProvider(y,P);let v;return typeof E.onDidChange=="function"&&(v=E.onDidChange(d=>{if(d.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(y,d).then(g=>{if(!g&&typeof g!="string")return;const m=this.d.getDocument(d);if(!m)return;const w=(0,S.splitLines)(g);if(!m.equalLines(w))return this.c.$onVirtualDocumentChange(d,g)},a.onUnexpectedError)})),new I.Disposable(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,E){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(t.URI.revive(E),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=C,C.a=0}),define(Se[249],ye([1,0,4,6,2,5,134,14,12,23,7]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(y,v){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=y.getProxy(A.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const g of d)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const g of d)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const v=this.g.getDocument(y);if(v)return v}getDocument(y){const v=this.getDocumentData(y);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return v.document}ensureDocumentData(y){const v=this.g.getDocument(y);if(v)return Promise.resolve(v);let d=this.h.get(y.toString());return d||(d=this.f.$tryOpenDocument(y).then(g=>{this.h.delete(y.toString());const m=I.URI.revive(g);return(0,S.assertIsDefined)(this.g.getDocument(m))},g=>(this.h.delete(y.toString()),Promise.reject(g))),this.h.set(y.toString(),d)),d}createDocumentData(y){return this.f.$tryCreateDocument(y).then(v=>I.URI.revive(v))}$acceptModelLanguageChanged(y,v){const d=I.URI.revive(y),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(v),this.a.fire(g.document)}$acceptModelSaved(y){const v=I.URI.revive(y),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(y,v){const d=I.URI.revive(y),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");g._acceptIsDirty(v),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,v,d){const g=I.URI.revive(y),m=this.g.getDocument(g);if(!m)throw new Error("unknown document");m._acceptIsDirty(d),m.onEvents(v);let w;v.isUndoing?w=R.TextDocumentChangeReason.Undo:v.isRedoing&&(w=R.TextDocumentChangeReason.Redo),this.c.fire((0,C.deepFreeze)({document:m.document,contentChanges:v.changes.map(f=>({range:T.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:w}))}setWordDefinitionFor(y,v){(0,D.setWordDefinitionFor)(y,v)}}e.ExtHostDocuments=P}),define(Se[59],ye([1,0,48,4,6,2,3,5,134,16,137,14,13,28,15,63,82]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(h){this.value=h,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let w=class{constructor(h,b){this.h=h,this.i=b,this.a=null,this.b=new Map,this.c=new y.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const b=[],o=[],r=[];if(h.removedDocuments)for(const c of h.removedDocuments){const u=A.URI.revive(c),i=this.c.get(u);i?.unref()&&(this.c.delete(u),b.push(i.value))}if(h.addedDocuments)for(const c of h.addedDocuments){const u=A.URI.revive(c.uri);let i=this.c.get(u);if(i&&u.scheme!==v.Schemas.vscodeNotebookCell&&u.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);i||(i=new m(new S.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),u,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(u,i),o.push(i.value)),i.ref()}if(h.removedEditors)for(const c of h.removedEditors){const u=this.b.get(c);this.b.delete(c),u&&r.push(u)}if(h.addedEditors)for(const c of h.addedEditors){const u=A.URI.revive(c.documentUri);a.ok(this.c.has(u),`document '${u}' does not exist`),a.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const i=this.c.get(u).value,s=new R.ExtHostTextEditor(c.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new g.Lazy(()=>i.document),c.selections.map(P.Selection.to),c.options,c.visibleRanges.map(n=>P.Range.to(n)),typeof c.editorPosition=="number"?P.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,s)}h.newActiveEditor!==void 0&&(a.ok(h.newActiveEditor===null||this.b.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this.a=h.newActiveEditor),(0,I.dispose)(b),(0,I.dispose)(r),h.removedDocuments&&this.e.fire(b),h.addedDocuments&&this.d.fire(o),(h.removedEditors||h.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),h.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(h){return this.c.get(h)?.value}allDocuments(){return d.Iterable.map(this.c.values(),h=>h.value)}getEditor(h){return this.b.get(h)}activeEditor(h){if(!this.a)return;const b=this.b.get(this.a);return h?b:b?.value}allEditors(){return[...this.b.values()]}};w=qe([We(0,C.IExtHostRpcService),We(1,E.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[60],ye([1,0,14,5,2,4,3,7,16,12,81]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class P{constructor(g,m,w){this.e=w,this.d=m,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,m={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(m)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(I.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class E{constructor(g,m){this.c=[],this.d="",this.b=g,this.e=m;for(const w of g.tabs)w.isActive&&(this.d=w.id),this.c.push(new P(w,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,m={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return a.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(w=>w.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(w=>w.apiObject))}};this.a=Object.freeze(m)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const w=new P(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,w),g.tabDto.isActive&&(this.d=w.tabId),w}else if(g.kind===1){const w=this.c.splice(g.index,1)[0];if(!w)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return w.tabId===this.d&&(this.d=""),w}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const w=this.c.splice(g.oldIndex,1)[0];if(!w)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,w),w}const m=this.c.find(w=>w.tabId===g.tabDto.id);if(!m)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),m.acceptDtoUpdate(g.tabDto),m}activeTabId(){return this.d}}let y=class{constructor(g){this.b=new A.Emitter,this.c=new A.Emitter,this.e=[],this.a=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,m={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(w=>w.apiObject))},get activeTabGroup(){const w=g.d;return(0,C.assertIsDefined)(g.e.find(h=>h.groupId===w)?.apiObject)},close:async(w,f)=>{const h=Array.isArray(w)?w:[w];return h.length?v(h[0])?this.j(h,f):this.i(h,f):!0}};this.f=Object.freeze(m)}return this.f}$acceptEditorTabModel(g){const m=new Set(this.e.map(c=>c.groupId)),w=new Set(g.map(c=>c.groupId)),f=(0,R.diffSets)(m,w),h=this.e.filter(c=>f.removed.includes(c.groupId)).map(c=>c.apiObject),b=[],o=[];this.e=g.map(c=>{const u=new E(c,()=>this.d);return f.added.includes(u.groupId)?b.push(u.apiObject):o.push(u.apiObject),u});const r=(0,C.assertIsDefined)(g.find(c=>c.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:b,closed:h,changed:o}))}$acceptTabGroupUpdate(g){const m=this.e.find(w=>w.groupId===g.groupId);if(!m)throw new Error("Update Group IPC call received before group creation.");m.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[m.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const m=this.e.find(f=>f.groupId===g.groupId);if(!m)throw new Error("Update Tabs IPC call received before group creation.");const w=m.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[w.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[w.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[w.apiObject]}));return}}g(g){for(const m of this.e)for(const w of m.tabs)if(w.apiObject===g)return w}h(g){return this.e.find(m=>m.apiObject===g)}async i(g,m){const w=[];for(const f of g){const h=this.g(f);if(!h)throw new Error("Tab close: Invalid tab not found!");w.push(h.tabId)}return this.a.$closeTab(w,m)}async j(g,m){const w=[];for(const f of g){const h=this.h(f);if(!h)throw new Error("Group close: Invalid group not found!");w.push(h.groupId)}return this.a.$closeGroup(w,m)}};y=qe([We(0,S.IExtHostRpcService)],y),e.ExtHostEditorTabs=y;function v(d){return d.tabs!==void 0}}),define(Se[250],ye([1,0,2,5,6,7,14,155,8,22,26]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const d=this.a.indexOf(v);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),d=[];let g,m,w=14,f=14;for(const h of v){let b=g?(0,S.commonPrefixLength)(g,h):0;for(b===0?m=1:m=f;b<h.length;b++)b+1===h.length?(w=f,f=9):f+=1,d.push([m,h.toUpperCase().charCodeAt(b),f]),d.push([m,h.toLowerCase().charCodeAt(b),f]),m=f;g=h,f=w}d.push([9,58,10]),d.push([10,47,12]),this.b=new T.StateMachine(d)}}provideDocumentLinks(v){this.c();const d=[],g=T.LinkComputer.computeLinks({getLineContent(m){return v.lineAt(m-1).text},getLineCount(){return v.lineCount}},this.b);for(const m of g){const w=D.DocumentLink.to(m);w.target&&d.push(w)}return d}}class E{constructor(v,d){this.i=d,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,d,g,m={}){if(this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const w=this.h++;this.b.add(d),this.d.add(d),this.c.set(w,g);let f=2;m.isCaseSensitive&&(f+=1024),m.isReadonly&&(f+=2048),typeof g.copy=="function"&&(f+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,R.checkProposedApiEnabled)(v,"fsChunks"),f+=4),this.a.$registerFileSystemProvider(w,d,f).catch(b=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${d}`),console.error(b)});const h=g.onDidChangeFile(b=>{const o=[];for(const r of b){const{uri:c,type:u}=r;if(c.scheme!==d)continue;let i;switch(u){case A.FileChangeType.Changed:i=0;break;case A.FileChangeType.Created:i=1;break;case A.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:c,type:i})}this.a.$onFileSystemChange(w,o)});return(0,I.toDisposable)(()=>{h.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(w),this.a.$unregisterProvider(w)})}static j(v){const{type:d,ctime:g,mtime:m,size:w,permissions:f}=v;return{type:d,ctime:g,mtime:m,size:w,permissions:f}}$stat(v,d){return Promise.resolve(this.k(v).stat(a.URI.revive(d))).then(g=>E.j(g))}$readdir(v,d){return Promise.resolve(this.k(v).readDirectory(a.URI.revive(d)))}$readFile(v,d){return Promise.resolve(this.k(v).readFile(a.URI.revive(d))).then(g=>C.VSBuffer.wrap(g))}$writeFile(v,d,g,m){return Promise.resolve(this.k(v).writeFile(a.URI.revive(d),g.buffer,m))}$delete(v,d,g){return Promise.resolve(this.k(v).delete(a.URI.revive(d),g))}$rename(v,d,g,m){return Promise.resolve(this.k(v).rename(a.URI.revive(d),a.URI.revive(g),m))}$copy(v,d,g,m){const w=this.k(v);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(a.URI.revive(d),a.URI.revive(g),m))}$mkdir(v,d){return Promise.resolve(this.k(v).createDirectory(a.URI.revive(d)))}$watch(v,d,g,m){const w=this.k(v).watch(a.URI.revive(g),m);this.f.set(d,w)}$unwatch(v,d){const g=this.f.get(d);g&&(g.dispose(),this.f.delete(d))}$open(v,d,g){const m=this.k(v);if(!m.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(m.open(a.URI.revive(d),g))}$close(v,d){const g=this.k(v);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(d))}$read(v,d,g,m){const w=this.k(v);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const f=C.VSBuffer.alloc(m);return Promise.resolve(w.read(d,g,f.buffer,0,m)).then(h=>f.slice(0,h))}$write(v,d,g,m){const w=this.k(v);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(d,g,m.buffer,0,m.byteLength))}k(v){const d=this.c.get(v);if(!d){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return d}}e.ExtHostFileSystem=E}),define(Se[72],ye([1,0,5,38,7,22,3,16,46,6]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Jt{constructor(E,y){this.b=new Map,this.a=E.getProxy(a.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(d){try{const g=v.b.get(d.scheme);if(!g)return await v.a.$stat(d);await v.a.$ensureActivation(d.scheme);const m=await g.stat(d);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions}}catch(g){Jt.c(g)}},async readDirectory(d){try{const g=v.b.get(d.scheme);return g?(await v.a.$ensureActivation(d.scheme),(await g.readDirectory(d)).slice()):await v.a.$readdir(d)}catch(g){return Jt.c(g)}},async createDirectory(d){try{return await v.a.$mkdir(d)}catch(g){return Jt.c(g)}},async readFile(d){try{const g=v.b.get(d.scheme);return g?(await v.a.$ensureActivation(d.scheme),(await g.readFile(d)).slice()):(await v.a.$readFile(d)).buffer}catch(g){return Jt.c(g)}},async writeFile(d,g){try{return await v.a.$writeFile(d,A.VSBuffer.wrap(g))}catch(m){return Jt.c(m)}},async delete(d,g){try{const m=v.b.get(d.scheme);return m?(await v.a.$ensureActivation(d.scheme),await m.delete(d,{recursive:!1,...g})):await v.a.$delete(d,{recursive:!1,useTrash:!1,...g})}catch(m){return Jt.c(m)}},async rename(d,g,m){try{return await v.a.$rename(d,g,{overwrite:!1,...m})}catch(w){return Jt.c(w)}},async copy(d,g,m){try{return await v.a.$copy(d,g,{overwrite:!1,...m})}catch(w){return Jt.c(w)}},isWritableFileSystem(d){const g=y.getCapabilities(d);if(typeof g=="number")return!(g&2048)}})}static c(E){if(E instanceof I.FileSystemError)throw E;if(!(E instanceof Error))throw new I.FileSystemError(String(E));if(E.name==="ENOPRO")throw I.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(E.message);default:throw new I.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,y){return this.b.set(E,y),(0,C.toDisposable)(()=>this.b.delete(E))}};R=qe([We(0,T.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[251],ye([1,0,4,36,2,5,14,7]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,E,y,v,d,g,m,w){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const f=this.h(P,y,d);this.g=0,g&&(this.g+=1),m&&(this.g+=2),w&&(this.g+=4);const h=(0,t.parse)(d),b=typeof d=="string",o=v(r=>{if(!g)for(const c of r.created){const u=I.URI.revive(c);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.a.fire(u)}if(!m)for(const c of r.changed){const u=I.URI.revive(c);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.b.fire(u)}if(!w)for(const c of r.deleted){const u=I.URI.revive(c);h(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=T.Disposable.from(f,this.a,this.b,this.c,o)}h(P,E,y){const v=T.Disposable.from();if(typeof y=="string")return v;const d=P.getProxy(A.MainContext.MainThreadFileSystem);let g=!1;(y.pattern.includes(t.GLOBSTAR)||y.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const m=Math.random();return d.$watch(E.identifier.value,m,y.baseUri,{recursive:g,excludes:[]}),T.Disposable.from({dispose:()=>d.$unwatch(m)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class C{constructor(P,E,y){this.j=P,this.k=E,this.l=y,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,E,y,v,d,g){return new S(this.j,P,E,this.a.event,D.GlobPattern.from(y),v,d,g)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,E){switch(P){case 2:this.b.fire(Object.freeze({files:E.map(y=>({oldUri:I.URI.revive(y.source),newUri:I.URI.revive(y.target)}))}));break;case 1:this.d.fire(Object.freeze({files:E.map(y=>I.URI.revive(y.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:E.map(y=>I.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,E){return(y,v,d)=>{const g=function(w){y.call(v,w)};return g.extension=P,E.event(g,void 0,d)}}async $onWillRunFileOperation(P,E,y,v){switch(P){case 2:return await this.n(this.g,{files:E.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},y,v);case 1:return await this.n(this.i,{files:E.map(d=>I.URI.revive(d.target))},y,v);case 0:case 3:return await this.n(this.h,{files:E.map(d=>I.URI.revive(d.target))},y,v)}}async n(P,E,y,v){const d=new Set,g=[];if(await P.fireAsync(E,v,async(w,f)=>{const h=Date.now(),b=await Promise.resolve(w);b instanceof T.WorkspaceEdit&&(g.push([f.extension,b]),d.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-h>y&&this.k.warn("SLOW file-participant",f.extension.identifier)}),v.isCancellationRequested||g.length===0)return;const m={edits:[]};for(const[,w]of g){const{edits:f}=D.WorkspaceEdit.from(w,{getTextDocumentVersion:h=>this.l.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}});m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=C}),define(Se[252],ye([1,0,2,39]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(D,T,S,C,R){this.a=T,this.b=S,this.c=C;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const y=this.a.getEditorById(E.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:a.URI.revive(E.notebookUri),inputUri:a.URI.revive(E.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:a.URI.revive(E.notebookUri),inputUri:a.URI.revive(E.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(D,T,S,C){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:D,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=I}),define(Se[253],ye([1,0,6,5]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(D){this.b=0,this.a=D.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,D),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=I}),define(Se[254],ye([1,0,2,23,14,7,67,5,8,37,17,12,150,21,6,118,99,69,49,10,18,26]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class o{constructor(N,$){this.d=N,this.e=$}async provideDocumentSymbols(N,$){const x=this.d.getDocument(N),_=await this.e.provideDocumentSymbols(x,$);if(!(0,R.isFalsyOrEmpty)(_))return _[0]instanceof A.DocumentSymbol?_.map(I.DocumentSymbol.from):o.f(_)}static f(N){N=N.slice(0).sort((_,le)=>{let be=_.location.range.start.compareTo(le.location.range.start);return be===0&&(be=le.location.range.end.compareTo(_.location.range.end)),be});const $=[],x=[];for(const _ of N){const le={name:_.name||"!!MISSING: name!!",kind:I.SymbolKind.from(_.kind),tags:_.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:I.Range.from(_.location.range),selectionRange:I.Range.from(_.location.range),children:[]};for(;;){if(x.length===0){x.push(le),$.push(le);break}const be=x[x.length-1];if(C.Range.containsRange(be.range,le.range)&&!C.Range.equalsRange(be.range,le.range)){be.children?.push(le),x.push(le);break}x.pop()}}return $}}class r{constructor(N,$,x){this.g=N,this.h=$,this.j=x,this.e=new m.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,$){const x=this.g.getDocument(N),_=await this.j.provideCodeLenses(x,$);if(!_||$.isCancellationRequested)return;const le=this.e.add(_),be=new v.DisposableStore;this.f.set(le,be);const Pe={cacheId:le,lenses:[]};for(let ge=0;ge<_.length;ge++)Pe.lenses.push({cacheId:[le,ge],range:I.Range.from(_[ge].range),command:this.h.toInternal(_[ge].command,be)});return Pe}async resolveCodeLens(N,$){const x=N.cacheId&&this.e.get(...N.cacheId);if(!x)return;let _;if(typeof this.j.resolveCodeLens!="function"||x.isResolved?_=x:_=await this.j.resolveCodeLens(x,$),_||(_=x),$.isCancellationRequested)return;const le=N.cacheId&&this.f.get(N.cacheId[0]);if(!!le)return N.command=this.h.toInternal(_.command??r.d,le),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}r.d={command:"missing",title:"!!MISSING: command!!"};function c(ne){return Array.isArray(ne)?ne.map(I.DefinitionLink.from):ne?[I.DefinitionLink.from(ne)]:[]}class u{constructor(N,$){this.d=N,this.e=$}async provideDefinition(N,$,x){const _=this.d.getDocument(N),le=I.Position.to($),be=await this.e.provideDefinition(_,le,x);return c(be)}}class i{constructor(N,$){this.d=N,this.e=$}async provideDeclaration(N,$,x){const _=this.d.getDocument(N),le=I.Position.to($),be=await this.e.provideDeclaration(_,le,x);return c(be)}}class s{constructor(N,$){this.d=N,this.e=$}async provideImplementation(N,$,x){const _=this.d.getDocument(N),le=I.Position.to($),be=await this.e.provideImplementation(_,le,x);return c(be)}}class n{constructor(N,$){this.d=N,this.e=$}async provideTypeDefinition(N,$,x){const _=this.d.getDocument(N),le=I.Position.to($),be=await this.e.provideTypeDefinition(_,le,x);return c(be)}}class l{constructor(N,$){this.d=N,this.e=$}async provideHover(N,$,x){const _=this.d.getDocument(N),le=I.Position.to($),be=await this.e.provideHover(_,le,x);if(!(!be||(0,R.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=_.getWordRangeAtPosition(le)),be.range||(be.range=new A.Range(le,le)),I.Hover.from(be)}}class p{constructor(N,$){this.d=N,this.e=$}async provideEvaluatableExpression(N,$,x){const _=this.d.getDocument(N),le=I.Position.to($),be=await this.e.provideEvaluatableExpression(_,le,x);if(be)return I.EvaluatableExpression.from(be)}}class k{constructor(N,$){this.d=N,this.e=$}async provideInlineValues(N,$,x,_){const le=this.d.getDocument(N),be=await this.e.provideInlineValues(le,I.Range.to($),I.InlineValueContext.to(x),_);if(Array.isArray(be))return be.map(Pe=>I.InlineValue.from(Pe))}}class L{constructor(N,$){this.d=N,this.e=$}async provideDocumentHighlights(N,$,x){const _=this.d.getDocument(N),le=I.Position.to($),be=await this.e.provideDocumentHighlights(_,le,x);if(Array.isArray(be))return be.map(I.DocumentHighlight.from)}}class B{constructor(N,$){this.d=N,this.e=$}async provideLinkedEditingRanges(N,$,x){const _=this.d.getDocument(N),le=I.Position.to($),be=await this.e.provideLinkedEditingRanges(_,le,x);if(be&&Array.isArray(be.ranges))return{ranges:(0,R.coalesce)(be.ranges.map(I.Range.from)),wordPattern:be.wordPattern}}}class K{constructor(N,$){this.d=N,this.e=$}async provideReferences(N,$,x,_){const le=this.d.getDocument(N),be=I.Position.to($),Pe=await this.e.provideReferences(le,be,x,_);if(Array.isArray(Pe))return Pe.map(I.location.from)}}class G{constructor(N,$,x,_,le,be,Pe){this.g=N,this.h=$,this.j=x,this.k=_,this.l=le,this.m=be,this.n=Pe,this.e=new m.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,$,x,_){const le=this.g.getDocument(N),be=E.Selection.isISelection($)?I.Selection.to($):I.Range.to($),Pe=[];for(const et of this.j.getDiagnostics(N))if(be.intersection(et.range)&&Pe.push(et)>G.d)break;const ge={diagnostics:Pe,only:x.only?new A.CodeActionKind(x.only):void 0,triggerKind:I.CodeActionTriggerKind.to(x.trigger)},Ce=await this.k.provideCodeActions(le,be,ge,_);if(!(0,R.isNonEmptyArray)(Ce)||_.isCancellationRequested)return;const ke=this.e.add(Ce),je=new v.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<Ce.length;et++){const _e=Ce[et];!_e||(G.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(ge.only&&(_e.kind?ge.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(I.Diagnostic.from),edit:_e.edit&&I.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(N,$){const[x,_]=N,le=this.e.get(x,_);if(!le||G.o(le)||!this.k.resolveCodeAction)return;const be=await this.k.resolveCodeAction(le,$)??le;return be?.edit?I.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}G.d=1e3;class O{constructor(N,$,x,_){this.d=N,this.e=$,this.f=x,this.g=_}async prepareDocumentPaste(N,$,x,_){if(!this.f.prepareDocumentPaste)return;const le=this.e.getDocument(N),be=$.map(ge=>I.Range.to(ge)),Pe=I.DataTransfer.toDataTransfer(x,()=>{throw new f.NotImplementedError});return await this.f.prepareDocumentPaste(le,be,Pe,_),I.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(N,$,x,_,le){const be=this.e.getDocument($),Pe=x.map(ke=>I.Range.to(ke)),ge=I.DataTransfer.toDataTransfer(_,async ke=>(await this.d.$resolvePasteFileData(this.g,N,ke)).buffer),Ce=await this.f.provideDocumentPasteEdits(be,Pe,ge,le);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?I.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class U{constructor(N,$){this.d=N,this.e=$}async provideDocumentFormattingEdits(N,$,x){const _=this.d.getDocument(N),le=await this.e.provideDocumentFormattingEdits(_,$,x);if(Array.isArray(le))return le.map(I.TextEdit.from)}}class F{constructor(N,$){this.d=N,this.e=$}async provideDocumentRangeFormattingEdits(N,$,x,_){const le=this.d.getDocument(N),be=I.Range.to($),Pe=await this.e.provideDocumentRangeFormattingEdits(le,be,x,_);if(Array.isArray(Pe))return Pe.map(I.TextEdit.from)}}class z{constructor(N,$){this.d=N,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,$,x,_,le){const be=this.d.getDocument(N),Pe=I.Position.to($),ge=await this.e.provideOnTypeFormattingEdits(be,Pe,x,_,le);if(Array.isArray(ge))return ge.map(I.TextEdit.from)}}class M{constructor(N,$){this.e=N,this.f=$,this.d=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,$){const x=await this.e.provideWorkspaceSymbols(N,$);if(!(0,R.isNonEmptyArray)(x))return{symbols:[]};const _=this.d.add(x),le={cacheId:_,symbols:[]};for(let be=0;be<x.length;be++){const Pe=x[be];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}le.symbols.push({...I.WorkspaceSymbol.from(Pe),cacheId:[_,be]})}return le}async resolveWorkspaceSymbol(N,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const x=this.d.get(...N.cacheId);if(x){const _=await this.e.resolveWorkspaceSymbol(x,$);return _&&(0,t.mixin)(N,I.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class V{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,$,x){this.d=N,this.e=$,this.f=x}async provideRenameEdits(N,$,x,_){const le=this.d.getDocument(N),be=I.Position.to($);try{const Pe=await this.e.provideRenameEdits(le,be,x,_);return Pe?I.WorkspaceEdit.from(Pe):void 0}catch(Pe){const ge=V.g(Pe);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(N,$,x){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(N),le=I.Position.to($);try{const be=await this.e.prepareRename(_,le,x);let Pe,ge;if(A.Range.isRange(be)?(Pe=be,ge=_.getText(be)):(0,P.isObject)(be)&&(Pe=be.range,ge=be.placeholder),!Pe||!ge)return;if(Pe.start.line>le.line||Pe.end.line<le.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Pe),text:ge}}catch(be){const Pe=V.g(be);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(be)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class q{constructor(N,$){this.resultId=N,this.tokens=$}}class H{constructor(N,$){this.f=N,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,$,x){const _=this.f.getDocument(N),le=$!==0?this.d.get($):null;let be=typeof le?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,le.resultId,x):await this.g.provideDocumentSemanticTokens(_,x);return le&&this.d.delete($),be?(be=H.h(be),this.o(H.n(le,be),be)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return H.j(N)?H.k(N)?N:new A.SemanticTokens(new Uint32Array(N.data),N.resultId):H.l(N)?H.m(N)?N:new A.SemanticTokensEdits(N.edits.map($=>new A.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const $ of N.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(N,$){if(!H.j($)||!N||!N.tokens)return $;const x=N.tokens,_=x.length,le=$.data,be=le.length;let Pe=0;const ge=Math.min(_,be);for(;Pe<ge&&x[Pe]===le[Pe];)Pe++;if(Pe===_&&Pe===be)return new A.SemanticTokensEdits([],$.resultId);let Ce=0;const ke=ge-Pe;for(;Ce<ke&&x[_-Ce-1]===le[be-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Pe,deleteCount:_-Pe-Ce,data:le.subarray(Pe,be-Ce)}],$.resultId)}o(N,$){if(H.j(N)){const x=this.e++;return this.d.set(x,new q(N.resultId,N.data)),(0,d.encodeSemanticTokensDto)({id:x,type:"full",data:N.data})}if(H.l(N)){const x=this.e++;return H.j($)?this.d.set(x,new q($.resultId,$.data)):this.d.set(x,new q(N.resultId)),(0,d.encodeSemanticTokensDto)({id:x,type:"delta",deltas:(N.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class Q{constructor(N,$){this.d=N,this.e=$}async provideDocumentRangeSemanticTokens(N,$,x){const _=this.d.getDocument(N),le=await this.e.provideDocumentRangeSemanticTokens(_,I.Range.to($),x);return le?this.f(le):null}f(N){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class Y{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,$,x,_,le){this.f=N,this.g=$,this.h=x,this.j=_,this.k=le,this.d=new m.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,$,x,_){const le=this.f.getDocument(N),be=I.Position.to($),Pe=le.getWordRangeAtPosition(be)||new A.Range(be,be),ge=Pe.with({end:be}),Ce=new w.StopWatch(!0),ke=await this.h.provideCompletionItems(le,be,_,I.CompletionContext.to(x));if(!ke||_.isCancellationRequested)return;const je=Array.isArray(ke)?new A.CompletionList(ke):ke,Ge=Y.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new v.DisposableStore;this.e.set(Ge,et);const _e=[],nt={x:Ge,b:_e,a:{replace:I.Range.from(Pe),insert:I.Range.from(ge)},c:je.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Me=this.l(ht,[Ge,st],ge,Pe);_e.push(Me)}return nt}async resolveCompletionItem(N,$){if(typeof this.h.resolveCompletionItem!="function")return;const x=this.d.get(...N);if(!x)return;const _=await this.h.resolveCompletionItem(x,$);if(!!_)return this.l(_,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,$,x,_){const le=this.e.get($[0]);if(!le)throw Error("DisposableStore is missing...");const be=this.g.toInternal(N.command,le),Pe={x:$,a:N.label,b:N.kind!==void 0?I.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(I.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:I.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(I.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=N.textEdit.newText):typeof N.insertText=="string"?Pe.h=N.insertText:N.insertText instanceof A.SnippetString&&(Pe.h=N.insertText.value,Pe.i|=4);let ge;return N.textEdit?ge=N.textEdit.range:N.range&&(ge=N.range),A.Range.isRange(ge)?Pe.j=I.Range.from(ge):ge&&(!x?.isEqual(ge.inserting)||!_?.isEqual(ge.replacing))&&(Pe.j={insert:I.Range.from(ge.inserting),replace:I.Range.from(ge.replacing)}),Pe}}class ce{async provideInlineCompletions(N,$,x,_){}disposeCompletions(N){}handleDidShowCompletionItem(N,$){}}class ie extends ce{constructor(N,$,x,_){super(),this.f=N,this.g=$,this.h=x,this.j=_,this.d=new fe,this.e=(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[D.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,$,x,_){const le=this.g.getDocument(N),be=I.Position.to($),Pe=await this.h.provideInlineCompletionItems(le,be,{selectedCompletionInfo:x.selectedSuggestionInfo?{range:I.Range.to(x.selectedSuggestionInfo.range),text:x.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[x.triggerKind]},_);if(!Pe||_.isCancellationRequested)return;const ge=Array.isArray(Pe)?Pe:Pe.items,Ce=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:ge}),items:ge.map((Ge,et)=>{let _e;Ge.command&&(ke||(ke=new v.DisposableStore),_e=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?I.Range.from(Ge.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ce.map(Ge=>(ke||(ke=new v.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,$){const x=this.d.get(N)?.items[$];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x)}}class fe{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const $=this.e++;return this.d.set($,N),$}disposeReferenceId(N){const $=this.d.get(N);return this.d.delete(N),$}get(N){return this.d.get(N)}}class J{constructor(N,$){this.e=N,this.f=$,this.d=new m.Cache("SignatureHelp")}async provideSignatureHelp(N,$,x,_){const le=this.e.getDocument(N),be=I.Position.to($),Pe=this.g(x),ge=await this.f.provideSignatureHelp(le,be,_,Pe);if(ge){const Ce=this.d.add([ge]);return{...I.SignatureHelp.from(ge),id:Ce}}}g(N){let $;if(N.activeSignatureHelp){const x=I.SignatureHelp.to(N.activeSignatureHelp),_=this.d.get(N.activeSignatureHelp.id,0);_?($=_,$.activeSignature=x.activeSignature,$.activeParameter=x.activeParameter):$=x}return{...N,activeSignatureHelp:$}}releaseSignatureHelp(N){this.d.delete(N)}}class pe{constructor(N,$,x,_,le){this.f=N,this.g=$,this.h=x,this.j=_,this.k=le,this.d=new m.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,$,x){const _=this.f.getDocument(N),le=I.Range.to($),be=await this.h.provideInlayHints(_,le,x);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(x.isCancellationRequested)return;const Pe=this.d.add(be);this.e.set(Pe,new v.DisposableStore);const ge={hints:[],cacheId:Pe};for(let Ce=0;Ce<be.length;Ce++)this.l(be[Ce],le)&&ge.hints.push(this.m(be[Ce],[Pe,Ce]));return this.j.trace(`[InlayHints] ${ge.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ge}async resolveInlayHint(N,$){if(typeof this.h.resolveInlayHint!="function")return;const x=this.d.get(...N);if(!x)return;const _=await this.h.resolveInlayHint(x,$);if(!!_&&!!this.l(_))return this.m(_,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,$){return N.label.length===0||Array.isArray(N.label)&&N.label.every(x=>x.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!($&&!$.contains(N.position))}m(N,$){const x=this.e.get($[0]);if(!x)throw Error("DisposableStore is missing...");const _={label:"",cacheId:$,tooltip:I.MarkdownString.fromStrict(N.tooltip),position:I.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(I.TextEdit.from),kind:N.kind&&I.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?_.label=N.label:_.label=N.label.map(le=>{const be={label:le.value};return be.tooltip=I.MarkdownString.fromStrict(le.tooltip),A.Location.isLocation(le.location)&&(be.location=I.location.from(le.location)),le.command&&(be.command=this.g.toInternal(le.command,x)),be}),_}}class we{constructor(N,$){this.e=N,this.f=$,this.d=new m.Cache("DocumentLink")}async provideLinks(N,$){const x=this.e.getDocument(N),_=await this.f.provideDocumentLinks(x,$);if(!(!Array.isArray(_)||_.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(we.g).map(I.DocumentLink.from)};{const le=this.d.add(_),be={links:[],cacheId:le};for(let Pe=0;Pe<_.length;Pe++){if(!we.g(_[Pe]))continue;const ge=I.DocumentLink.from(_[Pe]);ge.cacheId=[le,Pe],be.links.push(ge)}return be}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,$){if(typeof this.f.resolveDocumentLink!="function")return;const x=this.d.get(...N);if(!x)return;const _=await this.f.resolveDocumentLink(x,$);if(!(!_||!we.g(_)))return I.DocumentLink.from(_)}releaseLinks(N){this.d.delete(N)}}class Ie{constructor(N,$){this.d=N,this.e=$}async provideColors(N,$){const x=this.d.getDocument(N),_=await this.e.provideDocumentColors(x,$);return Array.isArray(_)?_.map(be=>({color:I.Color.from(be.color),range:I.Range.from(be.range)})):[]}async provideColorPresentations(N,$,x){const _=this.d.getDocument(N),le=I.Range.to($.range),be=I.Color.to($.color),Pe=await this.e.provideColorPresentations(be,{document:_,range:le},x);if(!!Array.isArray(Pe))return Pe.map(I.ColorPresentation.from)}}class Re{constructor(N,$){this.d=N,this.e=$}async provideFoldingRanges(N,$,x){const _=this.d.getDocument(N),le=await this.e.provideFoldingRanges(_,$,x);if(!!Array.isArray(le))return le.map(I.FoldingRange.from)}}class ze{constructor(N,$,x){this.d=N,this.e=$,this.f=x}async provideSelectionRanges(N,$,x){const _=this.d.getDocument(N),le=$.map(I.Position.to),be=await this.e.provideSelectionRanges(_,le,x);if(!(0,R.isNonEmptyArray)(be))return[];if(be.length!==le.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let ge=0;ge<le.length;ge++){const Ce=[];Pe.push(Ce);let ke=le[ge],je=be[ge];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(I.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Pe}}class re{constructor(N,$){this.f=N,this.g=$,this.d=new g.IdGenerator(""),this.e=new Map}async prepareSession(N,$,x){const _=this.f.getDocument(N),le=I.Position.to($),be=await this.g.prepareCallHierarchy(_,le,x);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(ge=>this.h(Pe,ge)):[this.h(Pe,be)]}async provideCallsTo(N,$,x){const _=this.j(N,$);if(!_)throw new Error("missing call hierarchy item");const le=await this.g.provideCallHierarchyIncomingCalls(_,x);if(!!le)return le.map(be=>({from:this.h(N,be.from),fromRanges:be.fromRanges.map(Pe=>I.Range.from(Pe))}))}async provideCallsFrom(N,$,x){const _=this.j(N,$);if(!_)throw new Error("missing call hierarchy item");const le=await this.g.provideCallHierarchyOutgoingCalls(_,x);if(!!le)return le.map(be=>({to:this.h(N,be.to),fromRanges:be.fromRanges.map(Pe=>I.Range.from(Pe))}))}releaseSession(N){this.e.delete(N)}h(N,$){const x=this.e.get(N),_=I.CallHierarchyItem.from($,N,x.size.toString(36));return x.set(_._itemId,$),_}j(N,$){return this.e.get(N)?.get($)}}class ue{constructor(N,$){this.f=N,this.g=$,this.d=new g.IdGenerator(""),this.e=new Map}async prepareSession(N,$,x){const _=this.f.getDocument(N),le=I.Position.to($),be=await this.g.prepareTypeHierarchy(_,le,x);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(ge=>this.h(Pe,ge)):[this.h(Pe,be)]}async provideSupertypes(N,$,x){const _=this.j(N,$);if(!_)throw new Error("missing type hierarchy item");const le=await this.g.provideTypeHierarchySupertypes(_,x);if(!!le)return le.map(be=>this.h(N,be))}async provideSubtypes(N,$,x){const _=this.j(N,$);if(!_)throw new Error("missing type hierarchy item");const le=await this.g.provideTypeHierarchySubtypes(_,x);if(!!le)return le.map(be=>this.h(N,be))}releaseSession(N){this.e.delete(N)}h(N,$){const x=this.e.get(N),_=I.TypeHierarchyItem.from($,N,x.size.toString(36));return x.set(_._itemId,$),_}j(N,$){return this.e.get(N)?.get($)}}class de{constructor(N,$,x,_){this.d=N,this.e=$,this.f=x,this.g=_}async provideDocumentOnDropEdits(N,$,x,_,le){const be=this.e.getDocument($),Pe=I.Position.to(x),ge=I.DataTransfer.toDataTransfer(_,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,ke)).buffer),Ce=await this.f.provideDocumentDropEdits(be,Pe,ge,le);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?I.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class Z{constructor(N,$){this.adapter=N,this.extension=$}}class se{constructor(N,$,x,_,le,be,Pe,ge){this.g=$,this.h=x,this.j=_,this.k=le,this.l=be,this.m=Pe,this.n=ge,this.f=new Map,this.e=N.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(N){return I.DocumentSelector.from(N,this.g)}p(N){return new A.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return se.d++}async s(N,$,x,_,le,be=!1){const Pe=this.f.get(N);if(!Pe||!(Pe.adapter instanceof $))return _;const ge=Date.now();be||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${x.toString().replace(/[\r\n]/g,"")}'`);const Ce=x(Pe.adapter,Pe.extension);return Promise.resolve(Ce).catch(ke=>{(0,f.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{be||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-ge}ms`)}),y.CancellationToken.isCancellationToken(le)?(0,h.raceCancellationError)(Ce,le):Ce}t(N,$){const x=this.q();return this.f.set(x,new Z(N,$)),x}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,$,x,_){const le=this.t(new o(this.h,x),N),be=_&&_.label||se.u(N);return this.e.$registerDocumentSymbolProvider(le,this.o($),be),this.p(le)}$provideDocumentSymbols(N,$,x){return this.s(N,o,_=>_.provideDocumentSymbols(a.URI.revive($),x),void 0,x)}registerCodeLensProvider(N,$,x){const _=this.q(),le=typeof x.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new Z(new r(this.h,this.j.converter,x),N)),this.e.$registerCodeLensSupport(_,this.o($),le);let be=this.p(_);if(le!==void 0){const Pe=x.onDidChangeCodeLenses(ge=>this.e.$emitCodeLensEvent(le));be=A.Disposable.from(be,Pe)}return be}$provideCodeLenses(N,$,x){return this.s(N,r,_=>_.provideCodeLenses(a.URI.revive($),x),void 0,x)}$resolveCodeLens(N,$,x){return this.s(N,r,_=>_.resolveCodeLens($,x),void 0,void 0)}$releaseCodeLenses(N,$){this.s(N,r,x=>Promise.resolve(x.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(N,$,x){const _=this.t(new u(this.h,x),N);return this.e.$registerDefinitionSupport(_,this.o($)),this.p(_)}$provideDefinition(N,$,x,_){return this.s(N,u,le=>le.provideDefinition(a.URI.revive($),x,_),[],_)}registerDeclarationProvider(N,$,x){const _=this.t(new i(this.h,x),N);return this.e.$registerDeclarationSupport(_,this.o($)),this.p(_)}$provideDeclaration(N,$,x,_){return this.s(N,i,le=>le.provideDeclaration(a.URI.revive($),x,_),[],_)}registerImplementationProvider(N,$,x){const _=this.t(new s(this.h,x),N);return this.e.$registerImplementationSupport(_,this.o($)),this.p(_)}$provideImplementation(N,$,x,_){return this.s(N,s,le=>le.provideImplementation(a.URI.revive($),x,_),[],_)}registerTypeDefinitionProvider(N,$,x){const _=this.t(new n(this.h,x),N);return this.e.$registerTypeDefinitionSupport(_,this.o($)),this.p(_)}$provideTypeDefinition(N,$,x,_){return this.s(N,n,le=>le.provideTypeDefinition(a.URI.revive($),x,_),[],_)}registerHoverProvider(N,$,x,_){const le=this.t(new l(this.h,x),N);return this.e.$registerHoverProvider(le,this.o($)),this.p(le)}$provideHover(N,$,x,_){return this.s(N,l,le=>le.provideHover(a.URI.revive($),x,_),void 0,_)}registerEvaluatableExpressionProvider(N,$,x,_){const le=this.t(new p(this.h,x),N);return this.e.$registerEvaluatableExpressionProvider(le,this.o($)),this.p(le)}$provideEvaluatableExpression(N,$,x,_){return this.s(N,p,le=>le.provideEvaluatableExpression(a.URI.revive($),x,_),void 0,_)}registerInlineValuesProvider(N,$,x,_){const le=typeof x.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new k(this.h,x),N);this.e.$registerInlineValuesProvider(be,this.o($),le);let Pe=this.p(be);if(le!==void 0){const ge=x.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(le));Pe=A.Disposable.from(Pe,ge)}return Pe}$provideInlineValues(N,$,x,_,le){return this.s(N,k,be=>be.provideInlineValues(a.URI.revive($),x,_,le),void 0,le)}registerDocumentHighlightProvider(N,$,x){const _=this.t(new L(this.h,x),N);return this.e.$registerDocumentHighlightProvider(_,this.o($)),this.p(_)}$provideDocumentHighlights(N,$,x,_){return this.s(N,L,le=>le.provideDocumentHighlights(a.URI.revive($),x,_),void 0,_)}registerLinkedEditingRangeProvider(N,$,x){const _=this.t(new B(this.h,x),N);return this.e.$registerLinkedEditingRangeProvider(_,this.o($)),this.p(_)}$provideLinkedEditingRanges(N,$,x,_){return this.s(N,B,async le=>{const be=await le.provideLinkedEditingRanges(a.URI.revive($),x,_);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?se.w(be.wordPattern):void 0}},void 0,_)}registerReferenceProvider(N,$,x){const _=this.t(new K(this.h,x),N);return this.e.$registerReferenceSupport(_,this.o($)),this.p(_)}$provideReferences(N,$,x,_,le){return this.s(N,K,be=>be.provideReferences(a.URI.revive($),x,_,le),void 0,le)}registerCodeActionProvider(N,$,x,_){const le=new v.DisposableStore,be=this.t(new G(this.h,this.j.converter,this.k,x,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(be,this.o($),{providedKinds:_?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:_?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,le)}))},se.u(N),Boolean(x.resolveCodeAction)),le.add(this.p(be)),le}$provideCodeActions(N,$,x,_,le){return this.s(N,G,be=>be.provideCodeActions(a.URI.revive($),x,_,le),void 0,le)}$resolveCodeAction(N,$,x){return this.s(N,G,_=>_.resolveCodeAction($,x),void 0,void 0)}$releaseCodeActions(N,$){this.s(N,G,x=>Promise.resolve(x.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(N,$,x){const _=this.t(new U(this.h,x),N);return this.e.$registerDocumentFormattingSupport(_,this.o($),N.identifier,N.displayName||N.name),this.p(_)}$provideDocumentFormattingEdits(N,$,x,_){return this.s(N,U,le=>le.provideDocumentFormattingEdits(a.URI.revive($),x,_),void 0,_)}registerDocumentRangeFormattingEditProvider(N,$,x){const _=this.t(new F(this.h,x),N);return this.e.$registerRangeFormattingSupport(_,this.o($),N.identifier,N.displayName||N.name),this.p(_)}$provideDocumentRangeFormattingEdits(N,$,x,_,le){return this.s(N,F,be=>be.provideDocumentRangeFormattingEdits(a.URI.revive($),x,_,le),void 0,le)}registerOnTypeFormattingEditProvider(N,$,x,_){const le=this.t(new z(this.h,x),N);return this.e.$registerOnTypeFormattingSupport(le,this.o($),_,N.identifier),this.p(le)}$provideOnTypeFormattingEdits(N,$,x,_,le,be){return this.s(N,z,Pe=>Pe.provideOnTypeFormattingEdits(a.URI.revive($),x,_,le,be),void 0,be)}registerWorkspaceSymbolProvider(N,$){const x=this.t(new M($,this.l),N);return this.e.$registerNavigateTypeSupport(x,typeof $.resolveWorkspaceSymbol=="function"),this.p(x)}$provideWorkspaceSymbols(N,$,x){return this.s(N,M,_=>_.provideWorkspaceSymbols($,x),{symbols:[]},x)}$resolveWorkspaceSymbol(N,$,x){return this.s(N,M,_=>_.resolveWorkspaceSymbol($,x),void 0,void 0)}$releaseWorkspaceSymbols(N,$){this.s(N,M,x=>x.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(N,$,x){const _=this.t(new V(this.h,x,this.l),N);return this.e.$registerRenameSupport(_,this.o($),V.supportsResolving(x)),this.p(_)}$provideRenameEdits(N,$,x,_,le){return this.s(N,V,be=>be.provideRenameEdits(a.URI.revive($),x,_,le),void 0,le)}$resolveRenameLocation(N,$,x,_){return this.s(N,V,le=>le.resolveRenameLocation(a.URI.revive($),x,_),void 0,_)}registerDocumentSemanticTokensProvider(N,$,x,_){const le=this.t(new H(this.h,x),N),be=typeof x.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(le,this.o($),_,be);let Pe=this.p(le);if(be){const ge=x.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(be));Pe=A.Disposable.from(Pe,ge)}return Pe}$provideDocumentSemanticTokens(N,$,x,_){return this.s(N,H,le=>le.provideDocumentSemanticTokens(a.URI.revive($),x,_),null,_)}$releaseDocumentSemanticTokens(N,$){this.s(N,H,x=>x.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,$,x,_){const le=this.t(new Q(this.h,x),N);return this.e.$registerDocumentRangeSemanticTokensProvider(le,this.o($),_),this.p(le)}$provideDocumentRangeSemanticTokens(N,$,x,_){return this.s(N,Q,le=>le.provideDocumentRangeSemanticTokens(a.URI.revive($),x,_),null,_)}registerCompletionItemProvider(N,$,x,_){const le=this.t(new Y(this.h,this.j.converter,x,this.m,N),N);return this.e.$registerCompletionsProvider(le,this.o($),_,Y.supportsResolving(x),`${N.identifier.value}(${_.join("")})`),this.p(le)}$provideCompletionItems(N,$,x,_,le){return this.s(N,Y,be=>be.provideCompletionItems(a.URI.revive($),x,_,le),void 0,le)}$resolveCompletionItem(N,$,x){return this.s(N,Y,_=>_.resolveCompletionItem($,x),void 0,x)}$releaseCompletionItems(N,$){this.s(N,Y,x=>x.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(N,$,x){const _=new ie(N,this.h,x,this.j.converter),le=this.t(_,N);return this.e.$registerInlineCompletionsSupport(le,this.o($),_.supportsHandleDidShowCompletionItem),this.p(le)}$provideInlineCompletions(N,$,x,_,le){return this.s(N,ce,be=>be.provideInlineCompletions(a.URI.revive($),x,_,le),void 0,le)}$handleInlineCompletionDidShow(N,$,x){this.s(N,ce,async _=>{_.handleDidShowCompletionItem($,x)},void 0,void 0)}$freeInlineCompletionsList(N,$){this.s(N,ce,async x=>{x.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(N,$,x,_){const le=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,be=this.t(new J(this.h,x),N);return this.e.$registerSignatureHelpProvider(be,this.o($),le),this.p(be)}$provideSignatureHelp(N,$,x,_,le){return this.s(N,J,be=>be.provideSignatureHelp(a.URI.revive($),x,_,le),void 0,le)}$releaseSignatureHelp(N,$){this.s(N,J,x=>x.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(N,$,x){const _=typeof x.onDidChangeInlayHints=="function"?this.q():void 0,le=this.t(new pe(this.h,this.j.converter,x,this.l,N),N);this.e.$registerInlayHintsProvider(le,this.o($),typeof x.resolveInlayHint=="function",_,se.u(N));let be=this.p(le);if(_!==void 0){const Pe=x.onDidChangeInlayHints(ge=>this.e.$emitInlayHintsEvent(_));be=A.Disposable.from(be,Pe)}return be}$provideInlayHints(N,$,x,_){return this.s(N,pe,le=>le.provideInlayHints(a.URI.revive($),x,_),void 0,_)}$resolveInlayHint(N,$,x){return this.s(N,pe,_=>_.resolveInlayHint($,x),void 0,x)}$releaseInlayHints(N,$){this.s(N,pe,x=>x.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(N,$,x){const _=this.t(new we(this.h,x),N);return this.e.$registerDocumentLinkProvider(_,this.o($),typeof x.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(N,$,x){return this.s(N,we,_=>_.provideLinks(a.URI.revive($),x),void 0,x,$.scheme==="output")}$resolveDocumentLink(N,$,x){return this.s(N,we,_=>_.resolveLink($,x),void 0,void 0,!0)}$releaseDocumentLinks(N,$){this.s(N,we,x=>x.releaseLinks($),void 0,void 0,!0)}registerColorProvider(N,$,x){const _=this.t(new Ie(this.h,x),N);return this.e.$registerDocumentColorProvider(_,this.o($)),this.p(_)}$provideDocumentColors(N,$,x){return this.s(N,Ie,_=>_.provideColors(a.URI.revive($),x),[],x)}$provideColorPresentations(N,$,x,_){return this.s(N,Ie,le=>le.provideColorPresentations(a.URI.revive($),x,_),void 0,_)}registerFoldingRangeProvider(N,$,x){const _=this.q(),le=typeof x.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new Z(new Re(this.h,x),N)),this.e.$registerFoldingRangeProvider(_,this.o($),N.identifier,le);let be=this.p(_);if(le!==void 0){const Pe=x.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(le));be=A.Disposable.from(be,Pe)}return be}$provideFoldingRanges(N,$,x,_){return this.s(N,Re,le=>le.provideFoldingRanges(a.URI.revive($),x,_),void 0,_)}registerSelectionRangeProvider(N,$,x){const _=this.t(new ze(this.h,x,this.l),N);return this.e.$registerSelectionRangeProvider(_,this.o($)),this.p(_)}$provideSelectionRanges(N,$,x,_){return this.s(N,ze,le=>le.provideSelectionRanges(a.URI.revive($),x,_),[],_)}registerCallHierarchyProvider(N,$,x){const _=this.t(new re(this.h,x),N);return this.e.$registerCallHierarchyProvider(_,this.o($)),this.p(_)}$prepareCallHierarchy(N,$,x,_){return this.s(N,re,le=>Promise.resolve(le.prepareSession(a.URI.revive($),x,_)),void 0,_)}$provideCallHierarchyIncomingCalls(N,$,x,_){return this.s(N,re,le=>le.provideCallsTo($,x,_),void 0,_)}$provideCallHierarchyOutgoingCalls(N,$,x,_){return this.s(N,re,le=>le.provideCallsFrom($,x,_),void 0,_)}$releaseCallHierarchy(N,$){this.s(N,re,x=>Promise.resolve(x.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(N,$,x){const _=this.t(new ue(this.h,x),N);return this.e.$registerTypeHierarchyProvider(_,this.o($)),this.p(_)}$prepareTypeHierarchy(N,$,x,_){return this.s(N,ue,le=>Promise.resolve(le.prepareSession(a.URI.revive($),x,_)),void 0,_)}$provideTypeHierarchySupertypes(N,$,x,_){return this.s(N,ue,le=>le.provideSupertypes($,x,_),void 0,_)}$provideTypeHierarchySubtypes(N,$,x,_){return this.s(N,ue,le=>le.provideSubtypes($,x,_),void 0,_)}$releaseTypeHierarchy(N,$){this.s(N,ue,x=>Promise.resolve(x.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(N,$,x){const _=this.q();return this.f.set(_,new Z(new de(this.e,this.h,x,_),N)),this.e.$registerDocumentOnDropEditProvider(_,this.o($)),this.p(_)}$provideDocumentOnDropEdits(N,$,x,_,le,be){return this.s(N,de,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits($,a.URI.revive(x),_,le,be)),void 0,void 0)}registerDocumentPasteEditProvider(N,$,x,_){const le=this.q();return this.f.set(le,new Z(new O(this.e,this.h,x,le),N)),this.e.$registerPasteEditProvider(le,this.o($),!!x.prepareDocumentPaste,_.pasteMimeTypes),this.p(le)}$prepareDocumentPaste(N,$,x,_,le){return this.s(N,O,be=>be.prepareDocumentPaste(a.URI.revive($),x,_,le),void 0,le)}$providePasteEdits(N,$,x,_,le,be){return this.s(N,O,Pe=>Pe.providePasteEdits($,a.URI.revive(x),_,le,be),void 0,be)}static w(N){return{pattern:N.source,flags:(0,S.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:se.w(N.decreaseIndentPattern),increaseIndentPattern:se.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?se.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?se.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:se.w(N.beforeText),afterText:N.afterText?se.w(N.afterText):void 0,previousLineText:N.previousLineText?se.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(se.z)}setLanguageConfiguration(N,$,x){const{wordPattern:_}=x;if(_&&(0,S.regExpLeadsToEndlessLoop)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor($,_):this.h.setWordDefinitionFor($,void 0),x.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),x.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const le=this.q(),be={comments:x.comments,brackets:x.brackets,wordPattern:x.wordPattern?se.w(x.wordPattern):void 0,indentationRules:x.indentationRules?se.y(x.indentationRules):void 0,onEnterRules:x.onEnterRules?se.B(x.onEnterRules):void 0,__electricCharacterSupport:x.__electricCharacterSupport,__characterPairSupport:x.__characterPairSupport};return this.e.$setLanguageConfiguration(le,$,be),this.p(le)}$setWordDefinitions(N){for(const $ of N)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=se,se.d=0}),define(Se[255],ye([1,0,5,14,7,42,18,6]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,P,E,y){this.c=P,this.d=E,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this.b=R}async getLanguages(){return this.b.slice(0)}async changeLanguage(R,P){await this.a.$changeLanguage(R,P);const E=this.c.getDocumentData(R);if(!E)throw new Error(`document '${R.toString()}' NOT found`);return E.document}async tokenAtPosition(R,P){const E=R.version,y=t.Position.from(P),v=await this.a.$tokensAtPosition(R.uri,y),d={type:I.StandardTokenType.Other,range:R.getWordRangeAtPosition(P)??new I.Range(P.line,P.character,P.line,P.character)};if(!v)return d;const g={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!g.range.contains(P)||E!==R.version?d:g}createLanguageStatusItem(R,P,E){const y=this.f++,v=this.a,d=this.g,g=`${R.identifier.value}/${P}`;if(d.has(g))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);d.add(g);const m={selector:E,id:P,name:R.displayName??R.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w;const f=new T.DisposableStore,h=()=>{w?.dispose(),w=(0,D.disposableTimeout)(()=>{f.clear(),this.a.$setLanguageStatus(y,{id:g,name:m.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(m.selector,this.e),label:m.text,detail:m.detail??"",severity:m.severity===I.LanguageStatusSeverity.Error?A.default.Error:m.severity===I.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:m.command&&this.d.toInternal(m.command,f),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},b={dispose(){f.dispose(),w?.dispose(),v.$removeLanguageStatus(y),d.delete(g)},get id(){return m.id},get name(){return m.name},set name(o){m.name=o,h()},get selector(){return m.selector},set selector(o){m.selector=o,h()},get text(){return m.text},set text(o){m.text=o,h()},get detail(){return m.detail},set detail(o){m.detail=o,h()},get severity(){return m.severity},set severity(o){m.severity=o,h()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(o){m.accessibilityInformation=o,h()},get command(){return m.command},set command(o){m.command=o,h()},get busy(){return m.busy},set busy(o){m.busy=o,h()}};return h(),b}}e.ExtHostLanguages=S}),define(Se[95],ye([1,0,11,8,2,3,13,5,25,16]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(E,y,v){this.f=v,this.d=new Map,this.a=y.getProxy(T.MainContext.MainThreadLocalization),this.b=E.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(E,y){const{message:v,args:d,comment:g}=y;if(this.c)return(0,t.format2)(v,d??{});let m=v;g&&g.length>0&&(m+=`/${Array.isArray(g)?g.join():g}`);const w=this.d.get(E)?.contents[m];return w||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${m}`),(0,t.format2)(w??v,d??{})}getBundle(E){return this.d.get(E)?.contents}getBundleUri(E){return this.d.get(E)?.uri}async initializeLocalizedMessages(E){if(this.c||!E.l10n&&!E.isBuiltin||this.d.has(E.identifier.value))return;let y;const v=await this.g(E);if(!v){this.f.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),g=JSON.parse(d);y=E.isBuiltin?g.contents?.bundle:g}catch(d){this.f.error(`Failed to load translations for ${E.identifier.value} from ${v}: ${d.message}`);return}y&&this.d.set(E.identifier.value,{contents:y,uri:v})}async g(E){if(E.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(E.identifier.value);return I.URI.revive(y)}return E.l10n?I.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.b}.json`):void 0}};R=qe([We(0,S.IExtHostInitDataService),We(1,C.IExtHostRpcService),We(2,D.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Se[139],ye([1,0,13,5,25,16,2,4,12]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends a.AbstractLoggerService{constructor(E,y){super(y.logLevel,T.Event.None),this.g=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,y){y?this.setLevel(D.URI.revive(y),E):(0,S.isUndefined)(E)||this.setLevel(E)}f(E,y,v){return new R(this.g,E,y,v)}};C=qe([We(0,A.IExtHostRpcService),We(1,I.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class R extends a.AbstractMessageLogger{constructor(E,y,v,d){super(d?.always),this.m=E,this.n=y,this.k=!1,this.l=[],this.setLevel(v),this.m.$createLogger(y,d).then(()=>{this.r(this.l),this.k=!0})}g(E,y){const v=[[E,y]];this.k?this.r(v):this.l.push(...v)}r(E){this.m.$log(this.n,E)}}}),define(Se[256],ye([1,0,5,13,26]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let D=class{constructor(S,C){this.b=C,this.a=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,C,R,P,E){const y={source:{identifier:S.identifier,label:S.displayName||S.name}};let v;typeof P=="string"||A(P)?v=[P,...E]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,v=E),y.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let g=0;g<v.length;g++){const m=v[g];if(typeof m=="string")d.push({title:m,handle:g,isCloseAffordance:!1});else if(typeof m=="object"){const{title:w,isCloseAffordance:f}=m;d.push({title:w,isCloseAffordance:!!f,handle:g})}else this.b.warn("Invalid message item:",m)}return this.a.$showMessage(C,R,y,d).then(g=>{if(typeof g=="number")return v[g]})}};D=qe([We(1,t.ILogService)],D),e.ExtHostMessageService=D}),define(Se[257],ye([1,0,22,4,6,28,8,12,2,69,5,39,14,7,58,232,135]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class m{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,h,b,o){this.q=b,this.r=o,this.f=new Map,this.g=new A.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=f.getProxy(R.MainContext.MainThreadNotebook),this.c=f.getProxy(R.MainContext.MainThreadNotebookDocuments),this.d=f.getProxy(R.MainContext.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const c=r.notebookEditor?.notebookUri,u=r.cell.handle,s=this.g.get(c)?.getCell(u);if(s)return s.apiCell}if(r&&r.$mid===14){const c=r.uri,u=this.g.get(c);if(u)return u.apiNotebook}return r}}),m.x(h)}getEditorById(f){const h=this.h.get(f);if(!h)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(f){for(const[h,b]of this.h)if(b.apiEditor===f)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,h){const b=this.g.get(f);if(!b&&!h)throw new Error(`NO notebook document for '${f}'`);return b}static s(f,h){if(!h)return;const b=h.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(h.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:h.displayName,filenamePattern:b,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,h,b){const o=m.a++,r=typeof b.onDidChangeCellStatusBarItems=="function"?m.a++:void 0;this.f.set(o,b),this.b.$registerNotebookCellStatusBarItemProvider(o,r,h);let c;return r!==void 0&&(c=b.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(r))),new y.Disposable(()=>{this.f.delete(o),this.b.$unregisterNotebookCellStatusBarItemProvider(o,r),c?.dispose()})}async createNotebookDocument(f){const h=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&E.NotebookData.from(f.content)});return S.URI.revive(h)}async openNotebookDocument(f){const h=this.g.get(f);if(h)return h.apiNotebook;const b=await this.c.$tryOpenNotebook(f),o=this.g.get(S.URI.revive(b));return(0,T.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(f,h){S.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let b;typeof h=="object"?b={position:E.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(E.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:b={preserveFocus:!1};const o=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,b),r=o&&this.h.get(o)?.apiEditor;if(r)return r;throw o?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,h,b,o){const r=this.f.get(f),c=S.URI.revive(h),u=this.g.get(c);if(!u||!r)return;const i=u.getCellFromIndex(b);if(!i)return;const s=await r.provideCellStatusBarItems(i.apiCell,o);if(!s)return;const n=new I.DisposableStore,l=this.p.add([n]),k=(Array.isArray(s)?s:[s]).map(L=>E.NotebookStatusBarItem.from(L,this.i,n));return{cacheId:l,items:k}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,h,b,o,r){if((0,D.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const c=this.t++;return this.u.set(c,b),this.b.$registerNotebookSerializer(c,{id:f.identifier,location:f.extensionLocation},h,E.NotebookDocumentContentOptions.from(o),m.s(f,r)),(0,I.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(c)})}async $dataToNotebook(f,h,b){const o=this.u.get(f);if(!o)throw new Error("NO serializer found");const r=await o.deserializeNotebook(h.buffer,b);return new v.SerializableObjectWithBuffers(E.NotebookData.from(r))}async $notebookToData(f,h,b){const o=this.u.get(f);if(!o)throw new Error("NO serializer found");const r=await o.serializeNotebook(E.NotebookData.to(h.value),b);return a.VSBuffer.wrap(r)}w(f,h,b){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const o=new g.ExtHostNotebookEditor(h,this.d,f,b.visibleRanges.map(E.NotebookRange.to),b.selections.map(E.NotebookRange.to),typeof b.viewColumn=="number"?E.ViewColumn.to(b.viewColumn):void 0);this.h.set(h,o)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const b of f.value.removedDocuments){const o=S.URI.revive(b),r=this.g.get(o);r&&(r.dispose(),this.g.delete(o),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(c=>c.document.uri)}),this.n.fire(r.apiNotebook));for(const c of this.h.values())c.notebookData.uri.toString()===o.toString()&&this.h.delete(c.id)}if(f.value.addedDocuments){const b=[];for(const o of f.value.addedDocuments){const r=S.URI.revive(o.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const c=new d.ExtHostNotebookDocument(this.c,this.q,this.r,r,o);b.push(...o.cells.map(u=>d.ExtHostCell.asModelAddData(c.apiNotebook,u))),this.g.get(r)?.dispose(),this.g.set(r,c),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(c.apiNotebook)}}if(f.value.addedEditors)for(const b of f.value.addedEditors){if(this.h.has(b.id))return;const o=S.URI.revive(b.documentUri),r=this.g.get(o);r&&this.w(r,b.id,b)}const h=[];if(f.value.removedEditors)for(const b of f.value.removedEditors){const o=this.h.get(b);o&&(this.h.delete(b),this.k?.id===o.id&&(this.k=void 0),h.push(o))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(o=>this.h.get(o)).filter(o=>!!o);const b=new Set;this.l.forEach(o=>b.add(o.id));for(const o of this.h.values()){const r=b.has(o.id);o._acceptVisibility(r)}this.l=[...this.h.values()].map(o=>o).filter(o=>o.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(f){const h=P.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new P.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>a.VSBuffer.wrap(r))],new P.ApiCommandResult("Notebook Data",r=>E.NotebookData.to(r.value))),o=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new v.SerializableObjectWithBuffers(E.NotebookData.from(r)))],new P.ApiCommandResult("Bytes",r=>r.buffer));f.registerApiCommand(b),f.registerApiCommand(o)}}e.ExtHostNotebookController=m,m.a=0}),define(Se[258],ye([1,0,17,18,21,4,6,28,2,27,13,69,5,39,14,7,92,219,26,58]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let h=class{constructor(i,s,n,l,p){this.k=s,this.l=n,this.m=l,this.n=p,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=i.getProxy(E.MainContext.MainThreadNotebookKernels);const k=new y.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const B=this.l.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:B}}else if(L&&"notebookEditor"in L){const B=this.l.getIdByEditor(L.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return L})],y.ApiCommandResult.Void);this.m.registerApiCommand(k)}createNotebookController(i,s,n,l,p,k){for(const ce of this.h.values())if(ce.controller.id===s&&C.ExtensionIdentifier.equals(i.identifier,ce.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const L=this.i++,B=this;this.n.trace(`NotebookController[${L}], CREATED by ${i.identifier.value}, ${s}`);const K=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${i.identifier}'`);let G=!1;const O=new D.DisposableStore,U=new A.Emitter,F=new A.Emitter,z={id:c(i.identifier,s),notebookType:n,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:l||i.identifier.value,preloads:k?k.map(v.NotebookRendererScript.from):[]};let M=p??K,V;this.a.$addKernel(L,z).catch(ce=>{console.log(ce),G=!0});let q=0;const H=()=>{if(G)return;const ce=++q;Promise.resolve().then(()=>{ce===q&&this.a.$updateKernel(L,z)})},Q=new T.ResourceMap,Y={get id(){return s},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return z.label},set label(ce){z.label=ce??i.displayName??i.name,H()},get detail(){return z.detail??""},set detail(ce){z.detail=ce,H()},get description(){return z.description??""},set description(ce){z.description=ce,H()},get kind(){return(0,w.checkProposedApiEnabled)(i,"notebookControllerKind"),z.kind??""},set kind(ce){(0,w.checkProposedApiEnabled)(i,"notebookControllerKind"),z.kind=ce,H()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ce){z.supportedLanguages=ce,H()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){z.supportsExecutionOrder=ce,H()},get rendererScripts(){return z.preloads?z.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(ce){M=ce??K},get interruptHandler(){return V},set interruptHandler(ce){V=ce,z.supportsInterrupt=Boolean(ce),H()},createNotebookCellExecution(ce){if(G)throw new Error("notebook controller is DISPOSED");if(!Q.has(ce.notebook.uri))throw B.n.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return B._createNotebookCellExecution(ce,c(i.identifier,this.id))},dispose:()=>{G||(this.n.trace(`NotebookController[${L}], DISPOSED`),G=!0,this.h.delete(L),O.dispose(),U.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(ce,ie){ie===d.NotebookControllerAffinity2.Hidden&&(0,w.checkProposedApiEnabled)(i,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(L,ce.uri,ie)},onDidReceiveMessage:F.event,postMessage(ce,ie){return(0,w.checkProposedApiEnabled)(i,"notebookMessaging"),B.a.$postMessage(L,ie&&B.l.getIdByEditor(ie),ce)},asWebviewUri(ce){return(0,w.checkProposedApiEnabled)(i,"notebookMessaging"),(0,g.asWebviewUri)(ce,B.k.remote)}};return this.h.set(L,{extensionId:i.identifier,controller:Y,onDidReceiveMessage:F,onDidChangeSelection:U,associatedNotebooks:Q}),Y}getIdByController(i){for(const[s,n]of this.h)if(n.controller===i)return c(n.extensionId,i.id);return null}createNotebookControllerDetectionTask(i,s){const n=this.d++,l=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${i.identifier.value}`),this.a.$addKernelDetectionTask(n,s);const p={dispose:()=>{this.c.delete(n),l.a.$removeKernelDetectionTask(n)}};return this.c.set(n,p),p}registerKernelSourceActionProvider(i,s,n){const l=this.f++,p=this;return this.e.set(l,n),this.n.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${i.identifier.value}`),this.a.$addKernelSourceActionProvider(l,s),{dispose:()=>{this.e.delete(l),p.a.$removeKernelSourceActionProvider(l)}}}async $provideKernelSourceActions(i,s){const n=this.e.get(i);if(n){const l=new D.DisposableStore;return this.g.add([l]),(await n.provideNotebookKernelSourceActions(s)??[]).map(k=>v.NotebookKernelSourceAction.from(k,this.m.converter,l))}return[]}$acceptNotebookAssociation(i,s,n){const l=this.h.get(i);if(l){const p=this.l.getNotebookDocument(S.URI.revive(s));n?l.associatedNotebooks.set(p.uri,!0):l.associatedNotebooks.delete(p.uri),this.n.trace(`NotebookController[${i}] ASSOCIATE notebook`,p.uri.toString(),n),l.onDidChangeSelection.fire({selected:n,notebook:p.apiNotebook})}}async $executeCells(i,s,n){const l=this.h.get(i);if(!l)return;const p=this.l.getNotebookDocument(S.URI.revive(s)),k=[];for(const L of n){const B=p.getCell(L);B&&k.push(B.apiCell)}try{this.n.trace(`NotebookController[${i}] EXECUTE cells`,p.uri.toString(),k.length),await l.controller.executeHandler.call(l.controller,k,p.apiNotebook,l.controller)}catch(L){this.n.error(`NotebookController[${i}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(i,s,n){const l=this.h.get(i);if(!l)return;const p=this.l.getNotebookDocument(S.URI.revive(s));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,p.apiNotebook);else for(const k of n){const L=p.getCell(k);L&&this.b.get(L.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,s,n){const l=this.h.get(i);if(!l)return;const p=this.l.getEditorById(s);l.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:n}))}$cellExecutionChanged(i,s,n){const p=this.l.getNotebookDocument(S.URI.revive(i)).getCell(s);if(p){const k=n?v.NotebookCellExecutionState.to(n):d.NotebookCellExecutionState.Idle;k!==void 0&&this.j.fire({cell:p.apiCell,state:k})}}_createNotebookCellExecution(i,s){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.l.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const p=new o(s,l,this.a);this.b.set(l.uri,p);const k=p.onDidChangeState(()=>{p.state===b.Resolved&&(p.dispose(),k.dispose(),this.b.delete(l.uri))});return p.asApiObject()}};h=qe([We(4,R.ILogService)],h),e.ExtHostNotebookKernels=h;var b;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(b||(b={}));class o extends D.Disposable{get state(){return this.f}constructor(i,s,n){super(),this.j=s,this.k=n,this.b=o.a++,this.c=new A.Emitter,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new I.CancellationTokenSource),this.h=new r(10,l=>this.m(l)),this.i=s.internalMetadata.executionOrder,this.k.$createExecution(this.b,i,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(i){await this.h.addItem(i)}async m(i){const s=Array.isArray(i)?i:[i];return this.k.$updateExecution(this.b,new f.SerializableObjectWithBuffers(s))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(i){let s=this.j;if(i&&(s=this.j.notebook.getCellFromApiCell(i)),!s)throw new Error("INVALID cell");return s.handle}s(i){return i.map(s=>{const n=d.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return n===s.items?v.NotebookCellOutput.from(s):v.NotebookCellOutput.from({items:n,id:s.id,metadata:s.metadata})})}async t(i,s,n){const l=this.r(s),p=this.s((0,a.asArray)(i));return this.l({editType:m.CellExecutionUpdateType.Output,cellHandle:l,append:n,outputs:p})}async w(i,s,n){return i=d.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(i),!0),this.l({editType:m.CellExecutionUpdateType.OutputItems,items:i.map(v.NotebookCellOutputItem.from),outputId:s.id,append:n})}asApiObject(){const i=this;return Object.freeze({get token(){return i.g.token},get cell(){return i.j.apiCell},get executionOrder(){return i.i},set executionOrder(n){i.i=n,i.m([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:i.i}])},start(n){if(i.f===b.Resolved||i.f===b.Started)throw new Error("Cannot call start again");i.f=b.Started,i.c.fire(),i.m({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,l){if(i.f===b.Resolved)throw new Error("Cannot call resolve twice");i.f=b.Resolved,i.c.fire(),i.h.flush(),i.k.$completeExecution(i.b,new f.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:n}))},clearOutput(n){return i.n(),i.t([],n,!1)},appendOutput(n,l){return i.n(),i.t(n,l,!0)},replaceOutput(n,l){return i.n(),i.t(n,l,!1)},appendOutputItems(n,l){return i.n(),i.w(n,l,!0)},replaceOutputItems(n,l){return i.n(),i.w(n,l,!1)}})}}o.a=0;class r{constructor(i,s){this.d=i,this.e=s,this.a=[],this.b=Date.now()}addItem(i){return this.a.push(i),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const i=this.c;this.c=void 0;const s=this.a;return this.a=[],this.e(s).finally(()=>i.complete())}}function c(u,i){return`${u.value}/${i}`}e.createKernelId=c}),define(Se[259],ye([1,0,4,5,135]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(T,S){this.c=S,this.a=new Map,this.b=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,C){const R=this.c.getEditorById(T);this.a.get(S)?.fire({editor:R.apiEditor,message:C})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(R=>R.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(R,P,E)=>this.d(S).event(R,P,E),postMessage:(R,P)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,P]=[P,R]);const E=P&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(E?.id,S,R)}}}d(T){let S=this.a.get(T);return S||(S=new a.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(T)}}),this.a.set(T,S),S)}}e.ExtHostNotebookRenderers=A}),define(Se[260],ye([1,0,6,2,26,5]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class D{constructor(S){this.b=new Map,this.a=S.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,C,R){if((0,I.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,R),this.a.$registerProfileContentHandler(C,R.name,S.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(S,C,R,P){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(C,R,P)}async $readProfile(S,C,R){const P=this.b.get(S);if(!P)throw new Error(`Unknown handler with id: ${S}`);return P.readProfile(t.URI.revive(C),R)}}e.ExtHostProfileContentHandlers=D}),define(Se[261],ye([1,0,21,4,6,5,2,7,10,17,42,89]),function(ee,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(y,v,d){const g=y.getProxy(A.MainContext.MainThreadQuickOpen);class m{constructor(i,s){this.e=new Map,this.f=0,this.a=i,this.b=s}showQuickPick(i,s,n=a.CancellationToken.None){this.c=void 0;const l=Promise.resolve(i),p=++this.f,k=g.$show(p,{title:s?.title,placeHolder:s?.placeHolder,matchOnDescription:s?.matchOnDescription,matchOnDetail:s?.matchOnDetail,ignoreFocusLost:s?.ignoreFocusOut,canPickMany:s?.canPickMany},n),L={},B=k.then(()=>L);return Promise.race([B,l]).then(K=>{if(K!==L)return l.then(G=>{const O=[];for(let U=0;U<G.length;U++){const F=G[U];typeof F=="string"?O.push({label:F,handle:U}):F.kind===T.QuickPickItemKind.Separator?O.push({type:"separator",label:F.label}):O.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:U})}return s&&typeof s.onDidSelectItem=="function"&&(this.c=U=>{s.onDidSelectItem(G[U])}),g.$setItems(p,O),k.then(U=>{if(typeof U=="number")return G[U];if(Array.isArray(U))return U.map(F=>G[F])})})}).then(void 0,K=>{if(!(0,S.isCancellationError)(K))return g.$setError(p,K),Promise.reject(K)})}$onItemSelected(i){this.c?.(i)}showInput(i,s=a.CancellationToken.None){return this.d=i?.validateInput,g.$input(i,typeof this.d=="function",s).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(i){if(!this.d)return;const s=await this.d(i);if(!s||typeof s=="string")return s;let n;switch(s.severity){case T.InputBoxValidationSeverity.Info:n=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=R.default.Error;break;default:n=s.message?R.default.Error:R.default.Ignore;break}return{content:s.message,severity:n}}async showWorkspaceFolderPick(i,s=a.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!n)return;const l=await this.a.getWorkspaceFolders2();if(!!l)return l.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(i){const s=new r(i,()=>this.e.delete(s._id));return this.e.set(s._id,s),s}createInputBox(i){const s=new c(i,()=>this.e.delete(s._id));return this.e.set(s._id,s),s}$onDidChangeValue(i,s){this.e.get(i)?._fireDidChangeValue(s)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,s){const n=this.e.get(i);n instanceof r&&n._fireDidChangeActive(s)}$onDidChangeSelection(i,s){const n=this.e.get(i);n instanceof r&&n._fireDidChangeSelection(s)}$onDidTriggerButton(i,s){this.e.get(i)?._fireDidTriggerButton(s)}$onDidTriggerItemButton(i,s,n){const l=this.e.get(i);l instanceof r&&l._fireDidTriggerItemButton(s,n)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class w{constructor(i,s){this.x=i,this.y=s,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((s,n)=>{const l=s===T.QuickInputButtons.Back?-1:n;this.o.set(l,s)}),this.z({buttons:i.map((s,n)=>({...o(s),tooltip:s.tooltip,handle:s===T.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const s=this.o.get(i);s&&this.r.fire(s)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}z(i){if(!this.v){for(const s of Object.keys(i)){const n=i[s];this.u[s]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){g.$createOrUpdate(this.u),this.u={id:this._id}}}w.a=1;function f(u){if(u instanceof T.ThemeIcon)return{id:u.id};const i=b(u),s=h(u);return{dark:typeof i=="string"?D.URI.file(i):i,light:typeof s=="string"?D.URI.file(s):s}}function h(u){return typeof u=="object"&&"light"in u?u.light:u}function b(u){return typeof u=="object"&&"dark"in u?u.dark:u}function o(u){const i=f(u.iconPath);let s,n;return"id"in i?n=P.ThemeIcon.asClassName(i):s=i,{iconPath:s,iconClass:n}}class r extends w{constructor(i,s){super(i.identifier,s),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((n,l)=>{this.C.set(l,n),this.D.set(n,l)});const s=[];for(let n=0;n<i.length;n++){const l=i[n];l.kind===T.QuickPickItemKind.Separator?s.push({type:"separator",label:l.label}):s.push({handle:n,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((p,k)=>({...o(p),tooltip:p.tooltip,handle:k}))})}this.z({items:s})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(s=>this.D.has(s)),this.z({activeItems:this.J.map(s=>this.D.get(s))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(s=>this.D.has(s)),this.z({selectedItems:this.L.map(s=>this.D.get(s))})}_fireDidChangeActive(i){const s=(0,C.coalesce)(i.map(n=>this.C.get(n)));this.J=s,this.K.fire(s)}_fireDidChangeSelection(i){const s=(0,C.coalesce)(i.map(n=>this.C.get(n)));this.L=s,this.M.fire(s)}_fireDidTriggerItemButton(i,s){const n=this.C.get(i);if(!n||!n.buttons||!n.buttons.length)return;const l=n.buttons[s];l&&this.N.fire({button:l,item:n})}}class c extends w{constructor(i,s){super(i.identifier,s),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:R.default.Error}):this.z({validationMessage:i.message,severity:i.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new m(v,d)}e.createExtHostQuickOpen=E});var Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a};define(Se[262],ye([1,0,2,4,61,6,18,5,17,105,13,27,89,14,26]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v){"use strict";var d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(l){if(l)return typeof l.iconPath=="string"?a.URI.file(l.iconPath):a.URI.isUri(l.iconPath)||E.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function w(l,p){if(!l.iconPath&&!p.iconPath)return 0;if(l.iconPath){if(!p.iconPath)return 1}else return-1;const k=typeof l.iconPath=="string"?l.iconPath:a.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,L=typeof p.iconPath=="string"?p.iconPath:a.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,C.comparePaths)(k,L)}function f(l,p){let k=0;if(l.strikeThrough!==p.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==p.faded)return l.faded?1:-1;if(l.tooltip!==p.tooltip)return(l.tooltip||"").localeCompare(p.tooltip||"");if(k=w(l,p),k!==0)return k;if(l.light&&p.light)k=w(l.light,p.light);else{if(l.light)return 1;if(p.light)return-1}if(k!==0)return k;if(l.dark&&p.dark)k=w(l.dark,p.dark);else{if(l.dark)return 1;if(p.dark)return-1}return k}function h(l,p){if(l.command!==p.command)return l.command<p.command?-1:1;if(l.title!==p.title)return l.title<p.title?-1:1;if(l.tooltip!==p.tooltip){if(l.tooltip!==void 0&&p.tooltip!==void 0)return l.tooltip<p.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(l.arguments===p.arguments)return 0;if(l.arguments)if(p.arguments){if(l.arguments.length!==p.arguments.length)return l.arguments.length-p.arguments.length}else return 1;else return-1;for(let k=0;k<l.arguments.length;k++){const L=l.arguments[k],B=p.arguments[k];if(L!==B)return L<B?-1:1}return 0}function b(l,p){let k=(0,C.comparePaths)(l.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(k!==0)return k;if(l.command&&p.command)k=h(l.command,p.command);else{if(l.command)return 1;if(p.command)return-1}if(k!==0)return k;if(l.decorations&&p.decorations)k=f(l.decorations,p.decorations);else{if(l.decorations)return 1;if(p.decorations)return-1}return k}function o(l,p){for(let k=0;k<l.length;k++)if(l[k]!==p[k])return!1;return!0}function r(l,p){return l.command===p.command&&l.title===p.title&&l.tooltip===p.tooltip&&(l.arguments&&p.arguments?o(l.arguments,p.arguments):l.arguments===p.arguments)}function c(l,p){return(0,S.equals)(l,p,r)}class u{get value(){return this.d}set value(p){p=p??"",Fe(this,d,"f").$setInputBoxValue(this.l,p),this.m(p)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(p){Fe(this,d,"f").$setInputBoxPlaceholder(this.l,p),this.f=p}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(p){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=p,Fe(this,d,"f").$setValidationProviderIsEnabled(this.l,!!p)}get enabled(){return this.h}set enabled(p){p=!!p,this.h!==p&&(this.h=p,Fe(this,d,"f").$setInputBoxEnablement(this.l,p))}get visible(){return this.j}set visible(p){p=!!p,this.j!==p&&(this.j=p,Fe(this,d,"f").$setInputBoxVisibility(this.l,p))}constructor(p,k,L){this.k=p,this.l=L,d.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,k,"f")}showValidationMessage(p,k){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Fe(this,d,"f").$showValidationMessage(this.l,p,k)}$onInputBoxValueChange(p){this.m(p)}m(p){this.d=p,this.e.fire(p)}}e.ExtHostSCMInputBox=u,d=new WeakMap;class i{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(p){this.v=p,this.q.$updateGroupLabel(this.t,this.handle,p)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(p){this.p=p,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(p){this.f=[...p],this.k.fire()}constructor(p,k,L,B,K){this.q=p,this.s=k,this.t=L,this.u=B,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=i.d++}getResourceState(p){return this.g.get(p)}$executeResourceCommand(p,k){const L=this.h.get(p);return L?(0,D.asPromise)(()=>this.s.executeCommand(L.command,...L.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this.f].sort(b),L=(0,S.sortedDiff)(this.o,p,b).map(G=>{const O=G.toInsert.map(U=>{const F=this.e++;this.g.set(F,U);const z=U.resourceUri;let M;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const pe=new A.DisposableStore;M=this.s.converter.toInternal(U.command,pe),this.j.set(F,pe)}else this.h.set(F,U.command);const V=m(U.decorations),q=U.decorations&&m(U.decorations.light)||V,H=U.decorations&&m(U.decorations.dark)||V,Q=[q,H],Y=U.decorations&&U.decorations.tooltip||"",ce=U.decorations&&!!U.decorations.strikeThrough,ie=U.decorations&&!!U.decorations.faded,fe=U.contextValue||"";return{rawResource:[F,z,Q,Y,ce,ie,fe,M],handle:F}});return{start:G.start,deleteCount:G.deleteCount,toInsert:O}}),B=L.map(({start:G,deleteCount:O,toInsert:U})=>[G,O,U.map(F=>F.rawResource)]),K=L.reverse();for(const{start:G,deleteCount:O,toInsert:U}of K){const F=U.map(M=>M.handle),z=this.n.splice(G,O,...F);for(const M of z)this.g.delete(M),this.h.delete(M),this.j.get(M)?.dispose(),this.j.delete(M)}return this.o=p,B}dispose(){this.l=!0,this.m.fire()}}i.d=0;class s{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(p){this.g!==p&&(this.g=p,Fe(this,g,"f").$updateSourceControl(this.t,{count:p}))}get quickDiffProvider(){return this.h}set quickDiffProvider(p){this.h=p,Fe(this,g,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this.j}set commitTemplate(p){p!==this.j&&(this.j=p,Fe(this,g,"f").$updateSourceControl(this.t,{commitTemplate:p}))}get acceptInputCommand(){return this.l}set acceptInputCommand(p){this.k.value=new A.DisposableStore,this.l=p;const k=this.v.converter.toInternal(p,this.k.value);Fe(this,g,"f").$updateSourceControl(this.t,{acceptInputCommand:k})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(p){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new A.DisposableStore,this.n=p;const k=p!==void 0?{command:this.v.converter.toInternal(p.command,this.m.value),secondaryCommands:p.secondaryCommands?.map(L=>L.map(B=>this.v.converter.toInternal(B,this.m.value))),description:p.description,enabled:p.enabled}:void 0;Fe(this,g,"f").$updateSourceControl(this.t,{actionButton:k??null})}get statusBarCommands(){return this.p}set statusBarCommands(p){if(this.p&&p&&c(this.p,p))return;this.o.value=new A.DisposableStore,this.p=p;const k=(p||[]).map(L=>this.v.converter.toInternal(L,this.o.value));Fe(this,g,"f").$updateSourceControl(this.t,{statusBarCommands:k})}get selected(){return this.q}constructor(p,k,L,B,K,G){this.u=p,this.v=L,this.w=B,this.x=K,this.y=G,g.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new A.MutableDisposable,this.l=void 0,this.m=new A.MutableDisposable,this.o=new A.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=s.d++,this.z=new Map,this.A=new Set,Je(this,g,k,"f"),this.f=new u(p,Fe(this,g,"f"),this.t),Fe(this,g,"f").$registerSourceControl(this.t,B,K,G)}createResourceGroup(p,k){const L=new i(Fe(this,g,"f"),this.v,this.t,p,k),B=t.Event.once(L.onDidDispose)(()=>this.z.delete(L));return this.z.set(L,B),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const p=[],k=[];for(const[L,B]of this.z){B.dispose();const K=L.onDidUpdateResourceStates(()=>{this.A.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.A.delete(L),K.dispose(),this.e.delete(L.handle),Fe(this,g,"f").$unregisterGroup(this.t,L.handle)}),p.push([L.handle,L.id,L.label,L.features]);const G=L._takeResourceStateSnapshot();G.length>0&&k.push([L.handle,G]),this.e.set(L.handle,L)}Fe(this,g,"f").$registerGroups(this.t,p,k),this.z.clear()}eventuallyUpdateResourceStates(){const p=[];this.A.forEach(k=>{const L=k._takeResourceStateSnapshot();L.length!==0&&p.push([k.handle,L])}),p.length>0&&Fe(this,g,"f").$spliceResourceStates(this.t,p),this.A.clear()}getResourceGroup(p){return this.e.get(p)}setSelectionState(p){this.q=p,this.s.fire(p)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(p=>p.dispose()),Fe(this,g,"f").$unregisterSourceControl(this.t)}}g=new WeakMap,s.d=0,qe([(0,I.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),qe([(0,I.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let n=class ni{get onDidChangeActiveProvider(){return this.j.event}constructor(p,k,L){this.l=k,this.m=L,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=p.getProxy(T.MainContext.MainThreadSCM),this.f=p.getProxy(T.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===3){const K=this.g.get(B.sourceControlHandle);if(!K)return B;const G=K.getResourceGroup(B.groupHandle);return G?G.getResourceState(B.handle):B}else if(B&&B.$mid===4){const K=this.g.get(B.sourceControlHandle);return K?K.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===5){const K=this.g.get(B.handle);return K||B}return B}})}createSourceControl(p,k,L,B){this.m.trace("ExtHostSCM#createSourceControl",p.identifier.value,k,L,B),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const K=ni.d++,G=new s(p,this.e,this.l,k,L,B);this.g.set(K,G);const O=this.h.get(P.ExtensionIdentifier.toKey(p.identifier))||[];return O.push(G),this.h.set(P.ExtensionIdentifier.toKey(p.identifier),O),G}getLastInputBox(p){this.m.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const k=this.h.get(P.ExtensionIdentifier.toKey(p.identifier)),L=k&&k[k.length-1];return L&&L.inputBox}$provideOriginalResource(p,k,L){const B=a.URI.revive(k);this.m.trace("ExtHostSCM#$provideOriginalResource",p,B.toString());const K=this.g.get(p);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>K.quickDiffProvider.provideOriginalResource(B,L)).then(G=>G||null)}$onInputBoxValueChange(p,k){this.m.trace("ExtHostSCM#$onInputBoxValueChange",p);const L=this.g.get(p);return L&&L.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(p,k,L,B){this.m.trace("ExtHostSCM#$executeResourceCommand",p,k,L);const K=this.g.get(p);if(!K)return Promise.resolve(void 0);const G=K.getResourceGroup(k);return G?G.$executeResourceCommand(L,B):Promise.resolve(void 0)}$validateInput(p,k,L){this.m.trace("ExtHostSCM#$validateInput",p);const B=this.g.get(p);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>B.inputBox.validateInput(k,L)).then(K=>{if(!K)return Promise.resolve(void 0);const G=y.MarkdownString.fromStrict(K.message);return G?Promise.resolve([G,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this.g.get(p)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=p,Promise.resolve(void 0)}};n.d=0,n=qe([We(2,R.ILogService)],n),e.ExtHostSCM=n}),define(Se[96],ye([1,0,5,4,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,S){return this.a.$getPassword(T,S)}store(T,S,C){return this.a.$setPassword(T,S,C)}delete(T,S){return this.a.$deletePassword(T,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[263],ye([1,0,7,5,174,6,14,12]),function(ee,e,a,t,I,A,D,T){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(v,d,g,m,w=a.StatusBarAlignment.Left,f){S.set(this,void 0),C.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new A.DisposableStore,Je(this,S,v,"f"),Je(this,C,d,"f"),this.c=R.a++,this.e=g,this.f=m,this.g=w,this.h=this.t(f)}t(v){if(!!(0,T.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(v){this.k=v,this.u()}set name(v){this.m=v,this.u()}set tooltip(v){this.l=v,this.u()}set color(v){this.n=v,this.u()}set backgroundColor(v){v&&!R.b.has(v.id)&&(v=void 0),this.o=v,this.u()}set command(v){this.q?.fromApi!==v&&(this.p.clear(),typeof v=="string"?this.q={fromApi:v,internal:Fe(this,C,"f").toInternal({title:"",command:v},this.p)}:v?this.q={fromApi:v,internal:Fe(this,C,"f").toInternal(v,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(v){this.s=v,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Fe(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let d;this.m?d=this.m:d=(0,I.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=R.b.get(this.o.id));const m=D.MarkdownString.fromStrict(this.l);Fe(this,S,"f").$setEntry(this.c,v,d,this.k,m,this.q?.internal,g,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,C=new WeakMap,R.a=0,R.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const d={message:v};return this.b.unshift(d),this.c(),new a.Disposable(()=>{const g=this.b.indexOf(d);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class E{constructor(v,d){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=d,this.c=new P(this)}createStatusBarEntry(v,d,g,m){return new R(this.a,this.b,v,d,g,m)}setStatusBarMessage(v,d){const g=this.c.setMessage(v);let m;return typeof d=="number"?m=setTimeout(()=>g.dispose(),d):typeof d<"u"&&d.then(()=>g.dispose(),()=>g.dispose()),new a.Disposable(()=>{g.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=E}),define(Se[97],ye([1,0,5,4,3]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T,S){this.c=S,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this.a.$registerExtensionStorageKeysToSync(T,S)}async initializeExtensionStorage(T,S,C){const R=await this.a.$initializeExtensionStorage(T,S);let P;return R&&(P=this.d(T,S,R)),P||C}setValue(T,S,C){return this.a.$setValue(T,S,C)}$acceptValue(T,S,C){const R=this.d(T,S,C);R&&this.b.fire({shared:T,key:S,value:R})}d(T,S,C){try{return JSON.parse(C)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${T}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Se[73],ye([1,0,3,25,13,72,2]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let T=class{constructor(C,R,P){this.d=R,this.f=P,this.a=C.workspace??void 0,this.b=C.environment,this.whenReady=this.h().then(E=>this.c=E)}async g(C){return D.URI.joinPath(this.b.workspaceStorageHome,C)}async h(){if(!this.a)return Promise.resolve(void 0);const C=this.a.id,R=await this.g(C);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(D.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:D.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(C){if(this.c)return D.URI.joinPath(this.c,C.identifier.value)}globalValue(C){return D.URI.joinPath(this.b.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=qe([We(0,t.IExtHostInitDataService),We(1,I.ILogService),We(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Se[40],ye([1,0,4,5,3,2,16,6,7,175,10,220,21,30,205,89,12,18,14]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class f{constructor(n,l,p,k){this.k=n,this._id=l,this.l=p,this.m=k,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(B=>this.f=B);const L=this;this.value={get name(){return L.m||""},get processId(){return L.b},get creationOptions(){return L.l},get exitStatus(){return L.h},get state(){return L.j},sendText(B,K=!0){L.o(),L.k.$sendText(L._id,B,K)},show(B){L.o(),L.k.$show(L._id,B)},hide(){L.o(),L.k.$hide(L._id)},dispose(){L.a||(L.a=!0,L.k.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(n,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(u(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this.n(n.location,l?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,l,p,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:p,color:d.ThemeColor.isThemeColor(k)?k.id:void 0,location:this.n(n,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,l){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in n?{viewColumn:w.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,l){this.h=Object.freeze({code:n,reason:l})}setDimensions(n,l){return n===this.d&&l===this.g||n===0||l===0?!1:(this.d=n,this.g=l,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(l=>{l!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=f;class h{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,l){this.g.setDimensions?.({columns:n,rows:l})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=h;let b=1,o=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,l){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=l.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[p,k]of this.g)k.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,l){const p=new f(this.a,(0,y.generateUuid)(),n,n.name),k=new h(n.pty);return p.createExtensionTerminal(n.location,this.L(n,l).resolvedExtHostIdentifier,u(n.iconPath),i(n.color)).then(L=>{const B=this.M(L,k);this.h[L]=B}),this.f.push(p),p.value}L(n,l){if(l=l||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const k=this.f.find(L=>L.value===p);k&&(l.resolvedExtHostIdentifier=k._id)}}else n.location&&typeof n.location!="object"?l.location=n.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(n,l){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const k=new h(l),L=this.M(n,k);this.h[n]=L}async $acceptActiveTerminalChanged(n){const l=this.b;if(n===null){this.b=void 0,l!==this.b&&this.F.fire(this.b);return}const p=this.O(n);p&&(this.b=p,l!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,l){const p=this.O(n);p&&this.I.fire({terminal:p.value,data:l})}async $acceptTerminalDimensions(n,l,p){const k=this.O(n);k&&k.setDimensions(l,p)&&this.G.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(n,l,p){this.g.get(n)?.resize(l,p)}async $acceptTerminalTitleChange(n,l){const p=this.O(n);p&&(p.name=l)}async $acceptTerminalClosed(n,l,p){const k=this.Q(this.f,n);if(k!==null){const L=this.f.splice(k,1)[0];L.setExitStatus(l,p),this.C.fire(L.value)}}$acceptTerminalOpened(n,l,p,k){if(l){const K=this.Q(this.f,l);if(K!==null){this.f[K]._id=n,this.D.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const L={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:A.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},B=new f(this.a,n,L,p);this.f.push(B),this.D.fire(B.value),B.isOpen=!0}async $acceptTerminalProcessId(n,l){this.O(n)?._setProcessId(l)}async $startExtensionTerminal(n,l){const p=this.O(n);if(!p)return{message:(0,C.localize)(0,null,n)};p.isOpen||await new Promise(L=>{const B=this.onDidOpenTerminal(async K=>{K===p.value&&(B.dispose(),L())})});const k=this.g.get(n);k?k.startSendingEvents(l):this.j[n]={initialDimensions:l}}M(n,l){const p=new T.DisposableStore;p.add(l.onProcessReady(L=>this.a.$sendProcessReady(n,L.pid,L.cwd))),p.add(l.onDidChangeProperty(L=>this.a.$sendProcessProperty(n,L))),this.s.startBuffering(n,l.onProcessData),p.add(l.onProcessExit(L=>this.N(n,L))),this.g.set(n,l);const k=this.j[n];return k&&l instanceof h&&(l.startSendingEvents(k.initialDimensions),delete this.j[n]),p}$acceptProcessAckDataEvent(n,l){this.g.get(n)?.acknowledgeDataEvent(l)}$acceptProcessInput(n,l){this.g.get(n)?.input(l)}$acceptTerminalInteraction(n){const l=this.O(n);l?.setInteractedWith()&&this.H.fire(l.value)}$acceptProcessResize(n,l,p){try{this.g.get(n)?.resize(l,p)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(n,l){this.g.get(n)?.shutdown(l)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(l=>this.a.$sendProcessProperty(n,{type:"cwd",value:l}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,l,p){if(this.v.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.v.set(l,p),this.a.$registerProfileProvider(l,n.identifier.value),new S.Disposable(()=>{this.v.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(n,l,p){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,p),this.a.$registerQuickFixProvider(n,l),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,l){const p=new E.CancellationTokenSource().token;if(p.isCancellationRequested)return;const k=this.w.get(n);if(!!k)return k.provideTerminalQuickFixes(l,p)}async $createContributedProfileTerminal(n,l){const p=new E.CancellationTokenSource().token;let k=await this.v.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(k&&!("options"in k)&&(k={options:k}),!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,l);return}this.createTerminalFromOptions(k.options,l)}}async $provideLinks(n,l){const p=this.O(n);if(!p)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const L=new E.CancellationTokenSource;this.z.set(n,L);const B=[],K={terminal:p.value,line:l},G=[];for(const F of this.u)G.push(m.Promises.withAsyncBody(async z=>{L.token.onCancellationRequested(()=>z({provider:F,links:[]}));const M=await F.provideTerminalLinks(K,L.token)||[];L.token.isCancellationRequested||z({provider:F,links:M})}));const O=await Promise.all(G);if(L.token.isCancellationRequested)return[];const U=new Map;for(const F of O)F&&F.links.length>0&&B.push(...F.links.map(z=>{const M={id:b++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return U.set(M.id,{provider:F.provider,link:z}),M}));return this.y.set(n,U),B}$activateLink(n,l){const p=this.y.get(n)?.get(l);!p||p.provider.handleTerminalLink(p.link)}N(n,l){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const p=this.h[n];p&&(p.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,l)}O(n){return this.P(this.f,n)}P(n,l){const p=this.Q(n,l);return p!==null?n[p]:null}Q(n,l){let p=null;return n.some((k,L)=>k._id===l?(p=L,!0):!1),p}getEnvironmentVariableCollection(n){let l=this.l.get(n.identifier.value);return l||(l=new r,this.S(n.identifier.value,l)),l}R(n,l){const p=(0,P.serializeEnvironmentVariableCollection)(l.map);this.a.$setEnvironmentVariableCollection(n,l.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(l=>{const p=l[0],k=new r(l[1]);this.S(p,k)})}$acceptDefaultProfile(n,l){const p=this.m;this.m=n,this.n=l,p?.path!==n.path&&this.J.fire(n.path)}S(n,l){this.l.set(n,l),l.onDidChangeCollection(()=>{this.R(n,l)})}};o=qe([We(1,D.IExtHostRpcService)],o),e.BaseExtHostTerminalService=o;class r{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,l){this.d(n,{value:l,type:S.EnvironmentVariableMutatorType.Replace})}append(n,l){this.d(n,{value:l,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,l){this.d(n,{value:l,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,l){const p=this.map.get(n);(!p||p.value!==l.value||p.type!==l.type)&&(this.map.set(n,l),this.b.fire())}get(n){return this.map.get(n)}forEach(n,l){this.map.forEach((p,k)=>n.call(l,k,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}e.EnvironmentVariableCollection=r;let c=class extends o{constructor(n){super(!1,n)}createTerminal(n,l,p){throw new R.NotSupportedError}createTerminalFromOptions(n,l){throw new R.NotSupportedError}};c=qe([We(0,D.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c;function u(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function i(s){return d.ThemeColor.isThemeColor(s)?s:void 0}});var Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a};define(Se[264],ye([1,0,17,22,21,4,62,85,6,23,12,30,5,16,136,14,7,57,91,70]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f){"use strict";var h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(K,G,O){this.j=O,this.c=new A.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=K.getProxy(E.MainContext.MainThreadTesting),this.h=new p(this.f),this.g=new c(this.f),G.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const F=U,z=F.tests[F.tests.length-1].item.extId;return this.d.get(m.TestId.root(z))?.collection.tree.get(z)?.actual??(0,v.toItemFromContext)(U)}})}createTestController(K,G,O){if(this.d.has(K))throw new Error(`Attempt to insert a duplicate controller with ID "${K}"`);const U=new S.DisposableStore,F=U.add(new v.ExtHostTestItemCollection(K,G,this.j));F.root.label=G;const z=new Map,M=this.f,V={items:F.root.children,get label(){return G},set label(H){G=H,F.root.label=H,M.$updateController(K,{label:G})},get refreshHandler(){return O},set refreshHandler(H){O=H,M.$updateController(K,{canRefresh:!!H})},get id(){return K},createRunProfile:(H,Q,Y,ce,ie)=>{let fe=(0,T.hash)(H);for(;z.has(fe);)fe++;return new k(this.f,z,K,fe,H,Q,Y,ce,ie)},createTestItem(H,Q,Y){return new v.TestItemImpl(K,H,Q,Y)},createTestRun:(H,Q,Y=!0)=>this.g.createTestRun(K,F,H,Q,Y),set resolveHandler(H){F.resolveHandler=H},get resolveHandler(){return F.resolveHandler},dispose:()=>{U.dispose()}};M.$registerTestController(K,G,!!O),U.add((0,S.toDisposable)(()=>M.$unregisterTestController(K)));const q={controller:V,collection:F,profiles:z};return this.d.set(K,q),U.add((0,S.toDisposable)(()=>this.d.delete(K))),U.add(F.onDidGenerateDiff(H=>M.$publishDiff(K,H.map(f.TestsDiffOp.serialize)))),V}createTestObserver(){return this.h.checkout()}async runTests(K,G=I.CancellationToken.None){const O=u(K);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.d.get(O.controllerId);if(!U)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:K.include?.map(F=>m.TestId.fromExtHostTestItem(F,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:L[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:K.exclude?.map(F=>F.id)},G)}$syncTests(){for(const{collection:K}of this.d.values())K.flushDiff();return Promise.resolve()}$provideFileCoverage(K,G,O){return(0,a.mapFind)(this.g.trackers,F=>F.id===K?F.getCoverage(G):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(K,G,O,U){return(0,a.mapFind)(this.g.trackers,z=>z.id===K?z.getCoverage(G):void 0)?.resolveFileCoverage(O,U)??Promise.resolve([])}$configureRunProfile(K,G){this.d.get(K)?.profiles.get(G)?.configureHandler?.()}async $refreshTests(K,G){await this.d.get(K)?.controller.refreshHandler?.(G)}$publishTestResults(K){this.results=Object.freeze(K.map(G=>(0,C.deepFreeze)(d.TestResults.to(G))).concat(this.results).sort((G,O)=>O.completedAt-G.completedAt).slice(0,32)),this.c.fire()}async $expandTest(K,G){const O=this.d.get(m.TestId.fromString(K).controllerId)?.collection;O&&(await O.expand(K,G<0?1/0:G),O.flushDiff())}$acceptDiff(K){this.h.applyDiff(K.map(f.TestsDiffOp.deserialize))}async $runControllerTests(K,G){return Promise.all(K.map(O=>this.runControllerTestRequest(O,G)))}async runControllerTestRequest(K,G){const O=this.d.get(K.controllerId);if(!O)return{};const{collection:U,profiles:F}=O,z=F.get(K.profileId);if(!z)return{};const M=K.testIds.map(Q=>U.tree.get(Q)).filter(R.isDefined),V=K.excludeExtIds.map(Q=>O.collection.tree.get(Q)).filter(R.isDefined).filter(Q=>M.some(Y=>Y.fullId.compare(Q.fullId)===2));if(!M.length)return{};const q=new g.TestRunRequest(M.some(Q=>Q.actual instanceof v.TestItemRootImpl)?void 0:M.map(Q=>Q.actual),V.map(Q=>Q.actual),z),H=this.g.prepareForMainThreadTestRun(q,i.fromInternal(K,O.collection),G);try{return await z.runHandler(q,G),{}}catch(Q){return{error:String(Q)}}finally{H.isRunning&&!G.isCancellationRequested&&await A.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(K){K===void 0?this.g.cancelAllRuns():this.g.cancelRunById(K)}};o=qe([We(0,y.IExtHostRpcService)],o),e.ExtHostTesting=o;class r extends S.Disposable{get isRunning(){return this.c.size>0}get id(){return this.k.id}constructor(K,G,O){super(),this.k=K,this.l=G,this.c=new Map,this.f=new Set,this.h=this.B(new A.Emitter),this.j=!1,this.onEnd=this.h.event,this.g=this.B(new I.CancellationTokenSource(O)),this.B(this.g.token.onCancellationRequested(()=>{for(const{run:U}of this.c.values())U.end()}))}getCoverage(K){return this.c.get(K)?.coverage}createRun(K){const G=this.k.id,O=this.k.controllerId,U=(0,P.generateUuid)(),F=new s(this.l,G,U),z=H=>(Q,...Y)=>{if(V){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(Q)||(this.m(Q),H(Q,...Y))},M=(H,Q)=>{const Y=Q instanceof Array?Q.map(d.TestMessage.from):[d.TestMessage.from(Q)];if(H.uri&&H.range){const ce={range:d.Range.from(H.range),uri:H.uri};for(const ie of Y)ie.location=ie.location||ce}this.l.$appendTestMessagesInRun(G,U,m.TestId.fromExtHostTestItem(H,O).toString(),Y)};let V=!1;const q={isPersisted:this.k.isPersisted,token:this.g.token,name:K,get coverageProvider(){return F.coverageProvider},set coverageProvider(H){F.coverageProvider=H},enqueued:z(H=>{this.l.$updateTestStateInRun(G,U,m.TestId.fromExtHostTestItem(H,O).toString(),1)}),skipped:z(H=>{this.l.$updateTestStateInRun(G,U,m.TestId.fromExtHostTestItem(H,O).toString(),5)}),started:z(H=>{this.l.$updateTestStateInRun(G,U,m.TestId.fromExtHostTestItem(H,O).toString(),2)}),errored:z((H,Q,Y)=>{M(H,Q),this.l.$updateTestStateInRun(G,U,m.TestId.fromExtHostTestItem(H,O).toString(),6,Y)}),failed:z((H,Q,Y)=>{M(H,Q),this.l.$updateTestStateInRun(G,U,m.TestId.fromExtHostTestItem(H,O).toString(),4,Y)}),passed:z((H,Q)=>{this.l.$updateTestStateInRun(G,U,m.TestId.fromExtHostTestItem(H,this.k.controllerId).toString(),3,Q)}),appendOutput:(H,Q,Y)=>{V||(Y&&(this.k.isIncluded(Y)?this.m(Y):Y=void 0),this.l.$appendOutputToRun(G,U,t.VSBuffer.fromString(H),Q&&d.location.from(Q),Y&&m.TestId.fromExtHostTestItem(Y,O).toString()))},end:()=>{V||(V=!0,this.l.$finishedTestRunTask(G,U),this.c.delete(U),this.isRunning||this.dispose())}};return this.c.set(U,{run:q,coverage:F}),this.l.$startedTestRunTask(G,{id:U,name:K,running:!0}),q}dispose(){this.j||(this.j=!0,this.h.fire(),this.g.cancel(),super.dispose())}m(K){if(!(K instanceof v.TestItemImpl))throw new w.InvalidTestItemError(K.id);if(this.f.has(m.TestId.fromExtHostTestItem(K,this.k.controllerId).toString()))return;const G=[],O=this.k.colllection.root;for(;;){const U=d.TestItem.from(K);if(G.unshift(U),this.f.has(U.extId)||(this.f.add(U.extId),K===O))break;K=K.parent||O}this.l.$addTestsToRun(this.k.controllerId,this.k.id,G)}}class c{get trackers(){return this.c.values()}constructor(K){this.d=K,this.c=new Map}prepareForMainThreadTestRun(K,G,O){return this.f(K,G,O)}cancelRunById(K){for(const G of this.c.values())if(G.id===K){G.dispose();return}}cancelAllRuns(){for(const K of this.c.values())K.dispose()}createTestRun(K,G,O,U,F){const z=this.c.get(O);if(z)return z.createRun(U);const M=i.fromPublic(K,G,O,F),V=u(O);this.d.$startedExtensionTestRun({controllerId:K,profile:V&&{group:L[V.kind],id:V.profileId},exclude:O.exclude?.map(H=>m.TestId.fromExtHostTestItem(H,G.root.id).toString())??[],id:M.id,include:O.include?.map(H=>m.TestId.fromExtHostTestItem(H,G.root.id).toString())??[G.root.id],persist:F});const q=this.f(O,M);return q.onEnd(()=>this.d.$finishedExtensionTestRun(M.id)),q.createRun(U)}f(K,G,O){const U=new r(G,this.d,O);return this.c.set(K,U),U.onEnd(()=>this.c.delete(K)),U}}e.TestRunCoordinator=c;const u=B=>{if(!!B.profile){if(!(B.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class i{static fromPublic(K,G,O,U){return new i(K,(0,P.generateUuid)(),O.include?.map(F=>m.TestId.fromExtHostTestItem(F,K).toString())??[K],O.exclude?.map(F=>m.TestId.fromExtHostTestItem(F,K).toString())??[],U,G)}static fromInternal(K,G){return new i(K.controllerId,K.runId,K.testIds,K.excludeExtIds,!0,G)}constructor(K,G,O,U,F,z){this.controllerId=K,this.id=G,this.isPersisted=F,this.colllection=z,this.c=O.map(M=>M+"\0"),this.d=U.map(M=>M+"\0")}isIncluded(K){const G=m.TestId.fromExtHostTestItem(K,this.controllerId).toString()+"\0";for(const O of this.d)if(G===O||G.startsWith(O))return!1;for(const O of this.c)if(G===O||G.startsWith(O))return!0;return!1}}e.TestRunDto=i;class s{set coverageProvider(K){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!K||(this.c=K,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(K,G,O){this.f=K,this.g=G,this.h=O}async provideFileCoverage(K){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(K))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(G){throw this.d=void 0,G}}async resolveFileCoverage(K,G){const O=await this.d;let U=O?.[K];return!this.c||!O||!U?[]:(U.detailedCoverage||(U=O[K]=await this.c.resolveFileCoverage?.(U,G)??U),U.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class n{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(K){this.h=K,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(K){this.c.add(K)}update(K){Object.assign(K.revived,d.TestItem.toPlain(K.item)),this.c.has(K)||this.d.add(K)}remove(K){if(this.c.has(K)){this.c.delete(K);return}this.d.delete(K);const G=m.TestId.parentId(K.item.extId);if(G&&this.g.has(G.toString())){this.g.add(K.item.extId);return}this.f.add(K)}getChangeEvent(){const{c:K,d:G,f:O}=this;return{get added(){return[...K].map(U=>U.revived)},get updated(){return[...G].map(U=>U.revived)},get removed(){return[...O].map(U=>U.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class l extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new A.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(K){return this.d.get(K)}getMirroredTestDataByReference(K){return this.d.get(K.id)}p(K,G){return{...K,revived:d.TestItem.toPlain(K.item),depth:G?G.depth+1:0,children:new Set}}o(){return new n(this.q)}}e.MirroredTestCollection=l;class p{constructor(K){this.d=K}checkout(){this.c||(this.c=this.f());const K=this.c;return K.observers++,{onDidChangeTest:K.tests.onDidChangeTests,get tests(){return[...K.tests.rootTests].map(G=>G.revived)},dispose:(0,D.once)(()=>{--K.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(K){return this.c?.tests.getMirroredTestDataByReference(K)}applyDiff(K){this.c?.tests.apply(K)}f(){const K=new l;return this.d.$subscribeToDiffs(),{observers:0,tests:K}}}class k{get label(){return this.d}set label(K){K!==this.d&&(this.d=K,Fe(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:K}))}get isDefault(){return this.f}set isDefault(K){K!==this.f&&(this.f=K,Fe(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:K}))}get tag(){return this._tag}set tag(K){K?.id!==this._tag?.id&&(this._tag=K,Fe(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:K?d.TestTag.namespace(this.controllerId,K.id):null}))}get configureHandler(){return this.c}set configureHandler(K){K!==this.c&&(this.c=K,Fe(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!K}))}constructor(K,G,O,U,F,z,M,V=!1,q=void 0){this.controllerId=O,this.profileId=U,this.d=F,this.kind=z,this.runHandler=M,this.f=V,this._tag=q,h.set(this,void 0),b.set(this,void 0),Je(this,h,K,"f"),Je(this,b,G,"f"),G.set(U,this);const H=L[z];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);Fe(this,h,"f").$publishTestRunProfile({profileId:U,controllerId:O,tag:q?d.TestTag.namespace(this.controllerId,q.id):null,label:F,group:H,isDefault:V,hasConfigurationHandler:!1})}dispose(){Fe(this,b,"f")?.delete(this.profileId)&&(Je(this,b,void 0,"f"),Fe(this,h,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=k,h=new WeakMap,b=new WeakMap;const L={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(Se[265],ye([1,0,17,4,5,137,14,7]),function(ee,e,a,t,I,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(I.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(E=>this.g.fire(E)),this.i.onDidChangeActiveTextEditor(E=>this.f.fire(E))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const P=this.i.allEditors();return R?P:P.map(E=>E.value)}async showTextDocument(R,P,E){let y;typeof P=="number"?y={position:D.ViewColumn.from(P),preserveFocus:E}:typeof P=="object"?y={position:D.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?D.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:y={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(R.uri,y),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,P){return new A.TextEditorDecorationType(this.h,R,P).value}$acceptEditorPropertiesChanged(R,P){const E=this.i.getEditor(R);if(!E)throw new Error("unknown text editor");if(P.options&&E._acceptOptions(P.options),P.selections){const y=P.selections.selections.map(D.Selection.to);E._acceptSelections(y)}if(P.visibleRanges){const y=a.coalesce(P.visibleRanges.map(D.Range.to));E._acceptVisibleRanges(y)}if(P.options&&this.b.fire({textEditor:E.value,options:{...P.options,lineNumbers:D.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const y=T.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(D.Selection.to);this.a.fire({textEditor:E.value,selections:v,kind:y})}if(P.visibleRanges){const y=a.coalesce(P.visibleRanges.map(D.Range.to));this.c.fire({textEditor:E.value,visibleRanges:y})}}$acceptEditorPositionData(R){for(const P in R){const E=this.i.getEditor(P);if(!E)throw new Error("Unknown text editor");const y=D.ViewColumn.to(R[P]);E.value.viewColumn!==y&&(E._acceptViewColumn(y),this.d.fire({textEditor:E.value,viewColumn:y}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(Se[266],ye([1,0,2,3,5,6,7,14,12]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class C{constructor(E,y){this.b=new Map,this.c=new Map,this.a=E.getProxy(I.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===12){const d=v.uri===void 0?void 0:a.URI.revive(v.uri);return this.c.get(v.source)?.get(R(d))?.get(v.handle)}return v}})}async $getTimeline(E,y,v,d){return this.b.get(E)?.provideTimeline(a.URI.revive(y),v,d)}registerTimelineProvider(E,y,v,d){const g=new A.DisposableStore,m=this.d(y.id,d,g).bind(this);let w;y.onDidChange&&(w=y.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:y.id}),this));const f=this.c;return this.f({...y,scheme:E,onDidChange:void 0,async provideTimeline(h,b,o){b?.resetCache&&(g.clear(),f.get(y.id)?.clear());const r=await y.provideTimeline(h,b,o);if(r==null)return;const c=m(h,b);return{...r,source:y.id,items:r.items.map(c)}},dispose(){for(const h of f.values())h.get(y.id)?.clear();w?.dispose(),g.dispose()}})}d(E,y,v){return(d,g)=>{let m;if(g?.cacheResults){let w=this.c.get(E);w===void 0&&(w=new Map,this.c.set(E,w));const f=R(d);m=w.get(f),m===void 0&&(m=new Map,w.set(f,m))}return w=>{const{iconPath:f,...h}=w,b=`${E}|${w.id??w.timestamp}`;m?.set(b,w);let o,r,c;w.iconPath&&(f instanceof D.ThemeIcon?c={id:f.id,color:f.color}:a.URI.isUri(f)?(o=f,r=f):{light:o,dark:r}=f);let u;return D.MarkdownString.isMarkdownString(h.tooltip)?u=T.MarkdownString.from(h.tooltip):(0,S.isString)(h.tooltip)?u=h.tooltip:D.MarkdownString.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=T.MarkdownString.from(h.detail)):(0,S.isString)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=h.detail),{...h,id:h.id??void 0,handle:b,source:E,command:w.command?y.toInternal(w.command,v):void 0,icon:o,iconDark:r,themeIcon:c,tooltip:u,accessibilityInformation:w.accessibilityInformation}}}}f(E){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,E),(0,A.toDisposable)(()=>{for(const v of this.c.values())v.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=C;function R(P){return P?.toString()}}),define(Se[267],ye([1,0,6,15,2,5]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(S){this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,R,P){if(this.c.has(C))throw new Error(`Opener with id '${C}' already registered`);const E=P.schemes.find(y=>!D.a.has(y));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this.c.set(C,R),this.b.$registerUriOpener(C,P.schemes,S,P.label),(0,a.toDisposable)(()=>{this.c.delete(C),this.b.$unregisterUriOpener(C)})}async $canOpenUri(S,C,R){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const E=I.URI.revive(C);return P.canOpenExternalUri(E,R)}async $openUri(S,C,R){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(I.URI.revive(C.resolvedUri),{sourceUri:I.URI.revive(C.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.a=new Set([t.Schemas.http,t.Schemas.https])}),define(Se[268],ye([1,0,5,2,6,10,27]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(C){this.c=new Set,this.d=new Map,this.b=C.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(C,R){if(this.c.has(D.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const P=T.a++;return this.c.add(D.ExtensionIdentifier.toKey(C)),this.d.set(P,R),this.b.$registerUriHandler(P,C),(0,I.toDisposable)(()=>{this.c.delete(D.ExtensionIdentifier.toKey(C)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(C,R){const P=this.d.get(C);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(R))}catch(E){(0,A.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(C){return t.URI.revive(await this.b.$createAppUri(C))}}e.ExtHostUrls=T,T.a=0});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[74],ye([1,0,4,15,23,2,190,212,92,5]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";var R,P,E,y,v,d,g,m,w,f,h,b,o;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class r{constructor(L,B,K,G,O,U,F){R.set(this,void 0),P.set(this,void 0),E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,""),m.set(this,void 0),w.set(this,!1),f.set(this,!1),h.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new a.Emitter),this._onDidDispose=Fe(this,o,"f").event,Je(this,R,L,"f"),Je(this,P,B,"f"),Je(this,m,K,"f"),Je(this,y,G,"f"),Je(this,v,O,"f"),Je(this,d,U,"f"),Je(this,h,c(U),"f"),Je(this,b,u(U),"f"),Je(this,E,F,"f")}dispose(){Je(this,w,!0,"f"),Fe(this,o,"f").fire(),Fe(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Je(this,f,!0,"f"),(0,S.asWebviewUri)(L,Fe(this,y,"f"))}get cspSource(){const L=Fe(this,d,"f").extensionLocation;if(L.scheme===t.Schemas.https||L.scheme===t.Schemas.http){let B=L.toString();return B.endsWith("/")||(B+="/"),B+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Fe(this,g,"f")}set html(L){this.a(),Fe(this,g,"f")!==L&&(Je(this,g,L,"f"),Fe(this,b,"f")&&!Fe(this,f,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Je(this,f,!0,"f"),Fe(this,E,"f").report("Webview vscode-resource: uris",Fe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,P,"f").$setHtml(Fe(this,R,"f"),this.b(L)))}get options(){return this.a(),Fe(this,m,"f")}set options(L){this.a(),I.equals(Fe(this,m,"f"),L)||Fe(this,P,"f").$setOptions(Fe(this,R,"f"),n(Fe(this,d,"f"),Fe(this,v,"f"),L)),Je(this,m,L,"f")}async postMessage(L){if(Fe(this,w,"f"))return!1;const B=(0,T.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Fe(this,h,"f")});return Fe(this,P,"f").$postMessage(Fe(this,R,"f"),B.message,...B.buffers)}a(){if(Fe(this,w,"f"))throw new Error("Webview is disposed")}b(L){if(!Fe(this,b,"f"))return L;const B=Fe(this,d,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,K=Fe(this,d,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Fe(this,d,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,O,U,F,z,M)=>{const V=A.URI.from({scheme:F||"file",path:decodeURIComponent(z)}),q=(0,S.asWebviewUri)(V,{isRemote:B,authority:K}).toString();return`${O}${q}${M}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,O,U,F,z,M)=>{const V=A.URI.from({scheme:F||"file",path:decodeURIComponent(z)}),q=(0,S.asWebviewUri)(V,{isRemote:B,authority:K}).toString();return`${O}${q}${M}`})}}e.ExtHostWebview=r,R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,m=new WeakMap,w=new WeakMap,f=new WeakMap,h=new WeakMap,b=new WeakMap,o=new WeakMap;function c(k){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(k.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;function u(k){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(k.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class i{constructor(L,B,K,G,O){this.c=B,this.d=K,this.e=G,this.f=O,this.b=new Map,this.a=L.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(L,B,K){const G=this.g(L);if(G){const{message:O}=(0,T.deserializeWebviewMessage)(B,K.value);G._onMessageEmitter.fire(O)}}$onMissingCsp(L,B){this.e.warn(`${B} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,B,K){const G=new r(L,this.a,l(B),this.c,this.d,K,this.f);return this.b.set(L,G),G._onDidDispose(()=>{this.b.delete(L)}),G}deleteWebview(L){this.b.delete(L)}g(L){return this.b.get(L)}}e.ExtHostWebviews=i;function s(k){return{id:k.identifier,location:k.extensionLocation}}e.toExtensionData=s;function n(k,L,B){return{enableCommandUris:B.enableCommandUris,enableScripts:B.enableScripts,enableForms:B.enableForms,portMapping:B.portMapping,localResourceRoots:B.localResourceRoots||p(k,L)}}e.serializeWebviewOptions=n;function l(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(L=>A.URI.from(L))}}function p(k,L){return[...(L?.getWorkspaceFolders()||[]).map(B=>B.uri),k.extensionLocation]}}),define(Se[269],ye([1,0,21,85,6,15,24,2,14,74,69,5,7]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class y{constructor(r,c){this.document=r,this.b=c,this.a=1,this.c=new R.Cache("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,c){await this.f(r).undo(),c||this.disposeBackup()}async redo(r,c){await this.f(r).redo(),c||this.disposeBackup()}disposeEdits(r){for(const c of r)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=b(this.document.uri)+this.a++;return(0,D.joinPath)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const c=this.c.get(r,0);if(!c)throw new Error("No edit found");return c}}class v{constructor(){this.a=new Map}get(r,c){return this.a.get(this.b(r,c))}add(r,c,u){const i=this.b(r,c.uri);if(this.a.has(i))throw new Error(`Document already exists for viewType:${r} resource:${c.uri}`);const s=new y(c,u);return this.a.set(i,s),s}delete(r,c){const u=this.b(r,c.uri);this.a.delete(u)}b(r,c){return`${r}@@@${c}`}}var d;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(d||(d={}));class g{constructor(){this.a=new Map}addTextProvider(r,c,u){return this.b(0,r,c,u)}addCustomProvider(r,c,u){return this.b(1,r,c,u)}get(r){return this.a.get(r)}b(r,c,u,i){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:r,extension:u,provider:i}),new E.Disposable(()=>this.a.delete(c))}}class m{constructor(r,c,u,i,s){this.d=c,this.f=u,this.g=i,this.h=s,this.b=new g,this.c=new v,this.a=r.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,c,u,i){const s=new I.DisposableStore;return f(u)?(s.add(this.b.addTextProvider(c,r,u)),this.a.$registerTextEditorProvider((0,C.toExtensionData)(r),c,i.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(r))):(s.add(this.b.addCustomProvider(c,r,u)),w(u)&&s.add(u.onDidChangeCustomDocument(n=>{const l=this.i(c,n.document.uri);if(h(n)){const p=l.addEdit(n);this.a.$onDidEdit(n.document.uri,c,p,n.label)}else this.a.$onContentChange(n.document.uri,c)})),this.a.$registerCustomEditorProvider((0,C.toExtensionData)(r),c,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(r))),E.Disposable.from(s,new E.Disposable(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(r,c,u,i,s){const n=this.b.get(c);if(!n)throw new Error(`No provider found for '${c}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${c}'`);const l=T.URI.revive(r),p=await n.provider.openCustomDocument(l,{backupId:u,untitledDocumentData:i?.buffer},s);let k;return w(n.provider)&&this.f&&(k=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(c,p,k),{editable:w(n.provider)}}async $disposeCustomDocument(r,c){const u=this.b.get(c);if(!u)throw new Error(`No provider found for '${c}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${c}'`);const i=T.URI.revive(r),{document:s}=this.i(c,i);this.c.delete(c,s),s.dispose()}async $resolveWebviewEditor(r,c,u,i,s,n){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);const p=S.ViewColumn.to(s),k=this.g.createNewWebview(c,i.contentOptions,l.extension),L=this.h.createNewWebviewPanel(c,u,i.title,p,i.options,k,!0),B=T.URI.revive(r);switch(l.type){case 1:{const{document:K}=this.i(u,B);return l.provider.resolveCustomEditor(K,L,n)}case 0:{const K=this.d.getDocument(B);return l.provider.resolveCustomTextEditor(K,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,c,u){this.i(c,r).disposeEdits(u)}async $onMoveCustomEditor(r,c,u){const i=this.b.get(u);if(!i)throw new Error(`No provider found for '${u}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const s=this.h.getWebviewPanel(r);if(!s)throw new Error("No webview found");const n=T.URI.revive(c),l=this.d.getDocument(n);await i.provider.moveCustomTextEditor(l,s,a.CancellationToken.None)}async $undo(r,c,u,i){return this.i(c,r).undo(u,i)}async $redo(r,c,u,i){return this.i(c,r).redo(u,i)}async $revert(r,c,u){const i=this.i(c,r);await this.j(c).revertCustomDocument(i.document,u),i.disposeBackup()}async $onSave(r,c,u){const i=this.i(c,r);await this.j(c).saveCustomDocument(i.document,u),i.disposeBackup()}async $onSaveAs(r,c,u,i){const s=this.i(c,r);return this.j(c).saveCustomDocumentAs(s.document,T.URI.revive(u),i)}async $backup(r,c,u){const i=this.i(c,r),n=await this.j(c).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},u);return i.updateBackup(n),n.id}i(r,c){const u=this.c.get(r,T.URI.revive(c));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!w(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=m;function w(o){return!!o.onDidChangeCustomDocument}function f(o){return typeof o.resolveCustomTextEditor=="function"}function h(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function b(o){const r=o.scheme===A.Schemas.file||o.scheme===A.Schemas.untitled?o.fsPath:o.toString();return(0,t.hash)(r)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[270],ye([1,0,4,6,2,30,14,74,5,7]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";var R,P,E,y,v,d,g,m,w,f,h,b,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends t.Disposable{constructor(s,n,l,p){super(),R.set(this,void 0),P.set(this,void 0),E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,void 0),m.set(this,void 0),w.set(this,!0),f.set(this,void 0),h.set(this,!1),b.set(this,this.B(new a.Emitter)),this.onDidDispose=Fe(this,b,"f").event,o.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Fe(this,o,"f").event,Je(this,R,s,"f"),Je(this,P,n,"f"),Je(this,y,l,"f"),Je(this,E,p.viewType,"f"),Je(this,v,p.panelOptions,"f"),Je(this,m,p.viewColumn,"f"),Je(this,d,p.title,"f"),Je(this,f,p.active,"f")}dispose(){Fe(this,h,"f")||(Je(this,h,!0,"f"),Fe(this,b,"f").fire(),Fe(this,P,"f").$disposeWebview(Fe(this,R,"f")),Fe(this,y,"f").dispose(),super.dispose())}get webview(){return this.c(),Fe(this,y,"f")}get viewType(){return this.c(),Fe(this,E,"f")}get title(){return this.c(),Fe(this,d,"f")}set title(s){this.c(),Fe(this,d,"f")!==s&&(Je(this,d,s,"f"),Fe(this,P,"f").$setTitle(Fe(this,R,"f"),s))}get iconPath(){return this.c(),Fe(this,g,"f")}set iconPath(s){this.c(),Fe(this,g,"f")!==s&&(Je(this,g,s,"f"),Fe(this,P,"f").$setIconPath(Fe(this,R,"f"),I.URI.isUri(s)?{light:s,dark:s}:s))}get options(){return Fe(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Fe(this,m,"f")=="number"&&Fe(this,m,"f")<0))return Fe(this,m,"f")}get active(){return this.c(),Fe(this,f,"f")}get visible(){return this.c(),Fe(this,w,"f")}_updateViewState(s){Fe(this,h,"f")||(this.active!==s.active||this.visible!==s.visible||this.viewColumn!==s.viewColumn)&&(Je(this,f,s.active,"f"),Je(this,w,s.visible,"f"),Je(this,m,s.viewColumn,"f"),Fe(this,o,"f").fire({webviewPanel:this}))}reveal(s,n){this.c(),Fe(this,P,"f").$reveal(Fe(this,R,"f"),{viewColumn:typeof s>"u"?void 0:D.ViewColumn.from(s),preserveFocus:!!n})}c(){if(Fe(this,h,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,m=new WeakMap,w=new WeakMap,f=new WeakMap,h=new WeakMap,b=new WeakMap,o=new WeakMap;class c{static c(){return(0,A.generateUuid)()}constructor(s,n,l){this.g=n,this.h=l,this.e=new Map,this.f=new Map,this.d=s.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(s,n,l,p,k={}){const L=typeof p=="object"?p.viewColumn:p,B={viewColumn:D.ViewColumn.from(L),preserveFocus:typeof p=="object"&&!!p.preserveFocus},K=(0,T.shouldSerializeBuffersForPostMessage)(s),G=c.c();this.d.$createWebviewPanel((0,T.toExtensionData)(s),G,n,{title:l,panelOptions:u(k),webviewOptions:(0,T.serializeWebviewOptions)(s,this.h,k),serializeBuffersForPostMessage:K},B);const O=this.g.createNewWebview(G,k,s);return this.createNewWebviewPanel(G,n,l,L,k,O,!0)}$onDidChangeWebviewPanelViewStates(s){const n=Object.keys(s);n.sort((l,p)=>{const k=s[l],L=s[p];return k.active?1:L.active?-1:+k.visible-+L.visible});for(const l of n){const p=this.getWebviewPanel(l);if(!p)continue;const k=s[l];p._updateViewState({active:k.active,visible:k.visible,viewColumn:D.ViewColumn.to(k.position)})}}async $onDidDisposeWebviewPanel(s){this.getWebviewPanel(s)?.dispose(),this.e.delete(s),this.g.deleteWebview(s)}registerWebviewPanelSerializer(s,n,l){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:l,extension:s}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(s)}),new C.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(s,n,l,p){const k=this.f.get(n);if(!k)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:B}=k,K=this.g.createNewWebview(s,l.webviewOptions,B),G=this.createNewWebviewPanel(s,n,l.title,p,l.panelOptions,K,l.active);await L.deserializeWebviewPanel(G,l.state)}createNewWebviewPanel(s,n,l,p,k,L,B){const K=new r(s,this.d,L,{viewType:n,title:l,viewColumn:p,panelOptions:k,active:B});return this.e.set(s,K),K}getWebviewPanel(s){return this.e.get(s)}}e.ExtHostWebviewPanels=c;function u(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[271],ye([1,0,4,6,74,14,5,7]),function(ee,e,a,t,I,A,D,T){"use strict";var S,C,R,P,E,y,v,d,g,m,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends t.Disposable{constructor(o,r,c,u,i,s){super(),S.set(this,void 0),C.set(this,void 0),R.set(this,void 0),P.set(this,void 0),E.set(this,!1),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,void 0),m.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Fe(this,m,"f").event,w.set(this,this.B(new a.Emitter)),this.onDidDispose=Fe(this,w,"f").event,Je(this,R,c,"f"),Je(this,v,u,"f"),Je(this,S,o,"f"),Je(this,C,r,"f"),Je(this,P,i,"f"),Je(this,y,s,"f")}dispose(){Fe(this,E,"f")||(Je(this,E,!0,"f"),Fe(this,w,"f").fire(),Fe(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Fe(this,v,"f")}set title(o){this.a(),Fe(this,v,"f")!==o&&(Je(this,v,o,"f"),Fe(this,C,"f").$setWebviewViewTitle(Fe(this,S,"f"),o))}get description(){return this.a(),Fe(this,d,"f")}set description(o){this.a(),Fe(this,d,"f")!==o&&(Je(this,d,o,"f"),Fe(this,C,"f").$setWebviewViewDescription(Fe(this,S,"f"),o))}get visible(){return Fe(this,y,"f")}get webview(){return Fe(this,P,"f")}get viewType(){return Fe(this,R,"f")}_setVisible(o){o===Fe(this,y,"f")||Fe(this,E,"f")||(Je(this,y,o,"f"),Fe(this,m,"f").fire())}get badge(){return this.a(),Fe(this,g,"f")}set badge(o){this.a(),!(o?.value===Fe(this,g,"f")?.value&&o?.tooltip===Fe(this,g,"f")?.tooltip)&&(Je(this,g,A.ViewBadge.from(o),"f"),Fe(this,C,"f").$setWebviewViewBadge(Fe(this,S,"f"),o))}show(o){this.a(),Fe(this,C,"f").$show(Fe(this,S,"f"),!!o)}a(){if(Fe(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,C=new WeakMap,R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,m=new WeakMap,w=new WeakMap;class h{constructor(o,r){this.d=r,this.b=new Map,this.c=new Map,this.a=o.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,r,c,u){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:c,extension:o}),this.a.$registerWebviewViewProvider((0,I.toExtensionData)(o),r,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(o)}),new T.Disposable(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(o,r,c,u,i){const s=this.b.get(r);if(!s)throw new Error(`No view provider found for '${r}'`);const{provider:n,extension:l}=s,p=this.d.createNewWebview(o,{},l),k=new f(o,this.a,r,c,p,!0);this.c.set(o,k),await n.resolveWebviewView(k,{state:u},i)}async $onDidChangeWebviewViewVisibility(o,r){this.e(o)._setVisible(r)}async $disposeWebviewView(o){const r=this.e(o);this.c.delete(o),r.dispose(),this.d.deleteWebview(o)}e(o){const r=this.c.get(o);if(!r)throw new Error("No webview found");return r}}e.ExtHostWebviewViews=h}),define(Se[140],ye([1,0,4,5,2,15,8,3,16]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class ii{get state(){return this.d}constructor(P){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ii.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,E){let y;if(typeof P=="string"){y=P;try{P=I.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,D.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,y,E)}async asExternalUri(P,E){if((0,D.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const y=await this.b.$asExternalUri(P,E);return I.URI.from(y)}};C.a={focused:!0},C=qe([We(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Se[272],ye([1,0,114,273,50,39,2,13,45]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(E,y,v){this.b=E,this.c=y,this.f=v,this.a=t.createServer((d,g)=>this.h(d,g)),this.g().catch(d=>(y.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,y){const v=(g,m)=>{y.writeHead(g,{"content-type":"application/json"}),y.end(JSON.stringify(m||null),w=>w&&this.c.error(w))},d=[];E.setEncoding("utf8"),E.on("data",g=>d.push(g)),E.on("end",async()=>{try{const g=JSON.parse(d.join(""));let m;switch(g.type){case"open":m=await this.i(g);break;case"openExternal":m=await this.j(g);break;case"status":m=await this.l(g);break;case"extensionManagement":m=await this.k(g);break;default:v(404,`Unknown message type: ${g.type}`);break}v(200,m)}catch(g){const m=g instanceof Error?g.message:JSON.stringify(g);v(500,m),this.c.error("Error while processing pipe request",g)}})}async i(E){const{fileURIs:y,folderURIs:v,forceNewWindow:d,diffMode:g,mergeMode:m,addMode:w,forceReuseWindow:f,gotoLineMode:h,waitMarkerFilePath:b,remoteAuthority:o}=E,r=[];if(Array.isArray(v))for(const s of v)try{r.push({folderUri:D.URI.parse(s)})}catch{}if(Array.isArray(y))for(const s of y)try{(0,S.hasWorkspaceFileExtension)(s)?r.push({workspaceUri:D.URI.parse(s)}):r.push({fileUri:D.URI.parse(s)})}catch{}const c=b?D.URI.file(b):void 0,i={forceNewWindow:d,diffMode:g,mergeMode:m,addMode:w,gotoLineMode:h,forceReuseWindow:f,preferNewWindow:!f&&!c&&!w,waitMarkerFileURI:c,remoteAuthority:o};return this.b.executeCommand("_remoteCLI.windowOpen",r,i),""}async j(E){for(const y of E.uris){const v=D.URI.parse(y),d=v.scheme==="file"?v:y;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(E){const y=d=>d?.map(g=>/\.vsix$/i.test(g)?D.URI.parse(g):g),v={list:E.list,install:y(E.install),uninstall:y(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&I.existsSync(this.f)&&I.unlinkSync(this.f)}}e.CLIServerBase=C;let R=class extends C{constructor(E,y){super(E,y,(0,a.createRandomIPCHandle)())}};R=qe([We(0,A.IExtHostCommands),We(1,T.ILogService)],R),e.CLIServer=R}),define(Se[274],ye([1,0,245,25,16]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let D=class extends a.AbstractExtHostConsoleForwarder{constructor(S,C){super(S,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,C,R){const P=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),C.apply(console,R),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,C){const R=process[S],P=R.write;let E="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(y,v,d)=>{if(!this.g){E+=y.toString(v);const g=E.length>A?E.length:E.lastIndexOf(`
`);g!==-1&&(console[C](E.slice(0,g)),E=E.slice(g+1))}P.call(R,y,v,d)}})}};D=qe([We(0,I.IExtHostRpcService),We(1,t.IExtHostInitDataService)],D),e.ExtHostConsoleForwarder=D}),define(Se[275],ye([1,0,9,66,30,39,6,5,2,16]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(E,y){super();const v=E.getProxy(T.MainContext.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async d=>{const g=S.URI.file((0,a.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await v.$download(d,g),g})}};R=qe([We(0,C.IExtHostRpcService),We(1,A.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Se[276],ye([1,0,139,15,196,30]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends a.ExtHostLoggerService{f(S,C,R){return S.scheme===t.Schemas.file?new I.SpdLogLogger(R?.name||(0,A.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,C):super.f(S,C,R)}}e.ExtHostLoggerService=D}),define(Se[277],ye([1,0,50,9,2,73,6,15,18,29]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(o){const r=await super.g(o);if(r.scheme!==T.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const c=r.fsPath;let u=0;do{let i;u===0?i=c:i=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${u}`:`${c}-${u}`,await P(i);const s=t.join(i,"vscode.lock"),n=await d(this.d,s,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),I.URI.file(i);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function P(b){try{await C.Promises.stat(b);return}catch{}try{await C.Promises.mkdir(b,{recursive:!0})}catch{}}const E=1e3,y=10*60*1e3;class v extends D.Disposable{constructor(o,r){super(),this.b=o,this.c=r,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const c=await g(o,r);(!c||c.pid!==process.pid)&&(o.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await C.Promises.utimes(r,new Date,new Date)}catch(u){o.error(u),o.info(`Lock '${r}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(o){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+o};await C.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function d(b,o,r){try{const u={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(o,JSON.stringify(u),{flag:"wx"})}catch(u){b.error(u)}const c=await g(b,o);return!c||c.pid!==process.pid?r?(b.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),f(b,o)):(b.info(`Lock '${o}': Lock acquired.`),new v(b,o))}async function g(b,o){let r;try{r=await C.Promises.readFile(o)}catch(c){return b.error(c),null}try{return JSON.parse(String(r))}catch(c){return b.error(c),null}}async function m(b,o){let r;try{r=await C.Promises.stat(o)}catch(c){return b.error(c),0}return r.mtime.getTime()}function w(b){try{return process.kill(b,0),!0}catch{return!1}}async function f(b,o){const r=await g(b,o);if(!r)return b.info(`Lock '${o}': Could not read pid of lock holder.`),h(b,o);if(r.willReleaseAt){let n=r.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${o}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${o}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await m(b,o)===0)return h(b,o);n=r.willReleaseAt-Date.now()}return h(b,o)}}if(!w(r.pid))return b.info(`Lock '${o}': The pid ${r.pid} appears to be gone.`),h(b,o);const c=await m(b,o),u=Date.now()-c;if(u<=y)return b.info(`Lock '${o}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;b.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const i=await m(b,o),s=Date.now()-i;return s<=y?(b.info(`Lock '${o}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null):(b.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),h(b,o))}async function h(b,o){b.info(`Lock '${o}': Deleting a stale lock.`);try{await C.Promises.unlink(o)}catch{}return d(b,o,!0)}}),define(Se[278],ye([1,0,30,16,40]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends I.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,C){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:C})}createTerminalFromOptions(T,S){const C=new I.ExtHostTerminal(this.a,(0,a.generateUuid)(),T,T.name);return this.f.push(C),C.create(T,this.L(T,S)),C.value}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Se[279],ye([1,0,5,16,179,6,25,2,44,24,29,7,11,55,4,129,100,13]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class w extends d.DisposableTunnel{}function f(n){const l=n.trim().split(`
`),p=[];return l.forEach(L=>{const B=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);B&&B.length>=3&&p.push({pid:parseInt(B[1],10),socket:parseInt(B[2],10)})}),p.reduce((L,B)=>(L[B.socket]=B,L),{})}e.getSockets=f;function h(...n){const l=[].concat(...n.map(o));return[...new Map(l.filter(p=>p.st==="0A").map(p=>{const k=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:b(k[0]),port:parseInt(k[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=h;function b(n){let l="";if(n.length===8)for(let p=n.length-2;p>=0;p-=2)l+=parseInt(n.substr(p,2),16),p!==0&&(l+=".");else for(let p=n.length-4;p>=0;p-=4)l+=parseInt(n.substr(p,4),16).toString(16),p!==0&&(l+=":");return l}function o(n){const l=n.trim().split(`
`),p=l.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return l.map(L=>L.trim().split(/\s+/).reduce((B,K,G)=>(B[p[G]||G]=K,B),{}))}e.loadConnectionTable=o;function r(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function c(n){const l=n.trim().split(`
`),p=[];return l.forEach(k=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(k);L&&L.length>=4&&p.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),p}e.getRootProcesses=c;async function u(n,l,p){const k=p.reduce((B,K)=>(B[K.pid]=K,B),{}),L=[];return n.forEach(({socket:B,ip:K,port:G})=>{const O=l[B]?l[B].pid:void 0,U=O?k[O]?.cmd:void 0;O&&U&&!r(U)&&L.push({host:K,port:G,detail:U,pid:O})}),L}e.findPorts=u;function i(n,l,p){const k=new Map,L=c(l);for(const B of n){const K=p.get(B.port);if(K){k.set(B.port,K);continue}const G=L.find(O=>O.cmd.includes(`${B.port}`));if(G){let O=G,U;do U=L.find(F=>F.ppid===O.pid),U&&(O=U);while(U);k.set(B.port,{host:B.ip,port:B.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else k.set(B.port,{host:B.ip,port:B.port,ppid:Number.MAX_VALUE})}return k}e.tryFindRootPorts=i;let s=class extends A.Disposable{constructor(l,p,k){super(),this.n=k,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=l.getProxy(a.MainContext.MainThreadTunnelService),E.isLinux&&p.remote.isRemote&&p.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(l,p){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const k=await this.a.$openTunnel(p,l.displayName);if(k){const L=new w(k.remoteAddress,k.localAddress,()=>this.a.$closeTunnel(k.remoteAddress));return this.B(L),L}}async getTunnels(){return this.a.$getTunnels()}p(l){return Math.max(l*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(l,p){const k=this.r();return this.l.set(k,{selector:l,provider:p}),this.a.$registerPortsAttributesProvider(l,k),new P.Disposable(()=>{this.l.delete(k),this.a.$unregisterPortsAttributesProvider(k)})}async $providePortAttributes(l,p,k,L,B){const K=[];for(const O of l){const U=this.l.get(O);if(!U)return[];K.push(...await Promise.all(p.map(async F=>U.provider.providePortAttributes(F,k,L,B))))}const G=K.filter(O=>!!O);return G.length>0?G.map(O=>({autoForwardAction:O.autoForwardAction,port:O.port})):[]}async $registerCandidateFinder(l){if(l&&this.h)return;this.h=l;const p=new g.MovingAverage;let k;for(;this.h;){const L=new Date().getTime(),B=(await this.findCandidatePorts()).filter(G=>(0,d.isLocalhost)(G.host)||(0,d.isAllInterfaces)(G.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${B.map(G=>G.port).join(", ")}`);const K=new Date().getTime()-L;p.update(K),(!k||JSON.stringify(k)!==JSON.stringify(B))&&(k=B,await this.a.$onFoundNewCandidates(k)),await new Promise(G=>setTimeout(()=>G(),this.p(p.value)))}}async setTunnelFactory(l){if(l){if(l.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this.c=l.showCandidatePort,this.a.$setCandidateFilter()),l.tunnelFactory){this.b=l.tunnelFactory;let p=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const k=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:p}:void 0;this.a.$setTunnelProvider(k)}}else this.b=void 0;return(0,A.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(l,p){if(this.f.has(l.host)){const k=this.f.get(l.host);k.has(l.port)&&(p&&k.get(l.port).disposeListener.dispose(),await k.get(l.port).tunnel.dispose(),k.delete(l.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(l,p){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const k=this.b(l,p);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),k!==void 0){const L=await k;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(l.remoteAddress.host)||this.f.set(l.remoteAddress.host,new Map);const B=this.B(L.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(L.remoteAddress))));return this.f.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:L,disposeListener:B}),y.TunnelDtoConverter.fromApiTunnel(L)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const p=await Promise.all(l.map(L=>this.c(L.host,L.port,L.detail??""))),k=l.filter((L,B)=>p[B]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(L=>L.port).join(", ")} to ${k.map(L=>L.port).join(", ")}`),k}async findCandidatePorts(){let l="",p="";try{l=await R.Promises.readFile("/proc/net/tcp","utf8"),p=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const k=h(l,p),L=await new Promise(M=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(V,q,H)=>{M(q)})}),B=f(L),K=await R.Promises.readdir("/proc"),G=[];for(const M of K)try{const V=Number(M),q=C.joinPath(T.URI.file("/proc"),M);if((await R.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(V)){const Q=await R.Promises.readlink(C.joinPath(q,"cwd").fsPath),Y=await R.Promises.readFile(C.joinPath(q,"cmdline").fsPath,"utf8");G.push({pid:V,cwd:Q,cmd:Y})}}catch{}const O=[],U=k.filter(M=>{const V=B[M.socket];return V||O.push(M),V}),F=u(U,B,G);let z;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const M=await new Promise(V=>{(0,S.exec)("ps -F -A -l | grep root",(q,H,Q)=>{V(H)})});this.j=i(O,M,this.j),z=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.join(", ")}`)}return F.then(M=>z?M.concat(z):M)}};s=qe([We(0,t.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,m.ILogService)],s),e.ExtHostTunnelService=s}),define(Se[280],ye([1,0,18,22,21,10,4,6,109,239,58]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(k,L){try{return JSON.stringify(k,L)}catch{return"null"}}const y="$$ref$$",v={[y]:-1};class d{constructor(L,B){this.jsonString=L,this.referencedBuffers=B}}function g(k,L=null,B=!1){const K=[];return{jsonString:(B?E:JSON.stringify)(k,(O,U)=>{if(typeof U>"u")return v;if(typeof U=="object"){if(U instanceof t.VSBuffer){const F=K.push(U)-1;return{[y]:F}}if(L)return L(O,U)}return U}),referencedBuffers:K}}e.stringifyJsonWithBufferRefs=g;function m(k,L,B){return JSON.parse(k,(K,G)=>{if(G){const O=G[y];if(typeof O=="number")return L[O];if(B&&G.$mid===1)return B.transformIncoming(G)}return G})}e.parseJsonAndRestoreBufferRefs=m;function w(k,L){return JSON.stringify(k,L)}function f(k){return k?(L,B)=>B&&B.$mid===1?k.transformOutgoing(B):B:null}var h;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},r=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class u extends T.Disposable{constructor(L,B=null,K=null){super(),this[P]=!0,this.b=this.B(new D.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=B,this.g=K,this.h=f(this.g),this.j=!1,this.k=[],this.l=[];for(let G=0,O=R.ProxyIdentifier.count;G<O;G++)this.k[G]=null,this.l[G]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(G=>this.G(G))}dispose(){this.j=!0,Object.keys(this.s).forEach(L=>{this.s[L].resolveErr(A.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(L){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(L){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(L){this.t!==L&&(this.t=L,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(L){return this.g?(0,S.transformIncomingURIs)(L,this.g):L}getProxy(L){const{nid:B,sid:K}=L;return this.l[B]||(this.l[B]=this.F(B,K)),this.l[B]}F(L,B){const K={get:(G,O)=>(typeof O=="string"&&!G[O]&&O.charCodeAt(0)===36&&(G[O]=(...U)=>this.O(L,O,U)),O===c?B:G[O])};return new Proxy(Object.create(null),K)}set(L,B){return this.k[L.nid]=B,B}assertRegistered(L){for(let B=0,K=L.length;B<K;B++){const G=L[B];if(!this.k[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}G(L){if(this.j)return;const B=L.byteLength,K=i.read(L,0),G=K.readUInt8(),O=K.readUInt32();switch(G){case 1:case 2:{let{rpcId:U,method:F,args:z}=n.deserializeRequestJSONArgs(K);this.g&&(z=(0,S.transformIncomingURIs)(z,this.g)),this.H(B,O,U,F,z,G===2);break}case 3:case 4:{let{rpcId:U,method:F,args:z}=n.deserializeRequestMixedArgs(K);this.g&&(z=(0,S.transformIncomingURIs)(z,this.g)),this.H(B,O,U,F,z,G===4);break}case 5:{this.f?.logIncoming(B,O,0,"ack"),this.z(O);break}case 6:{this.I(B,O);break}case 7:{this.J(B,O,void 0);break}case 9:{let U=n.deserializeReplyOKJSON(K);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.J(B,O,U);break}case 10:{const U=n.deserializeReplyOKJSONWithBuffers(K,this.g);this.J(B,O,U);break}case 8:{const U=n.deserializeReplyOKVSBuffer(K);this.J(B,O,U);break}case 11:{let U=n.deserializeReplyErrError(K);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.L(B,O,U);break}case 12:{this.L(B,O,void 0);break}default:console.error("received unexpected message"),console.error(L)}}H(L,B,K,G,O,U){this.f?.logIncoming(L,B,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(K)}.${G}(`,O);const F=String(B);let z,M;if(U){const q=new I.CancellationTokenSource;O.push(q.token),z=this.M(K,G,O),M=()=>q.cancel()}else z=this.M(K,G,O),M=o;this.p[F]=M;const V=n.serializeAcknowledged(B);this.f?.logOutgoing(V.byteLength,B,1,"ack"),this.c.send(V),z.then(q=>{delete this.p[F];const H=n.serializeReplyOK(B,q,this.h);this.f?.logOutgoing(H.byteLength,B,1,"reply:",q),this.c.send(H)},q=>{delete this.p[F];const H=n.serializeReplyErr(B,q);this.f?.logOutgoing(H.byteLength,B,1,"replyErr:",q),this.c.send(H)})}I(L,B){this.f?.logIncoming(L,B,1,"receiveCancel");const K=String(B);this.p[K]?.()}J(L,B,K){this.f?.logIncoming(L,B,0,"receiveReply:",K);const G=String(B);if(!this.s.hasOwnProperty(G))return;const O=this.s[G];delete this.s[G],O.resolveOk(K)}L(L,B,K){this.f?.logIncoming(L,B,0,"receiveReplyErr:",K);const G=String(B);if(!this.s.hasOwnProperty(G))return;const O=this.s[G];delete this.s[G];let U;K&&(K.$isError?(U=new Error,U.name=K.name,U.message=K.message,U.stack=K.stack):U=K),O.resolveErr(U)}M(L,B,K){try{return Promise.resolve(this.N(L,B,K))}catch(G){return Promise.reject(G)}}N(L,B,K){const G=this.k[L];if(!G)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const O=G[B];if(typeof O!="function")throw new Error("Unknown method "+B+" on actor "+(0,R.getStringIdentifierForProxy)(L));return O.apply(G,K)}O(L,B,K){if(this.j)return new C.CanceledLazyPromise;let G=null;if(K.length>0&&I.CancellationToken.isCancellationToken(K[K.length-1])&&(G=K.pop()),G&&G.isCancellationRequested)return Promise.reject(A.canceled());const O=n.serializeRequestArguments(K,this.h),U=++this.m,F=String(U),z=new C.LazyPromise;G&&G.onCancellationRequested(()=>{const V=n.serializeCancel(U);this.f?.logOutgoing(V.byteLength,U,0,"cancel"),this.c.send(n.serializeCancel(U))}),this.s[F]=z,this.y(U);const M=n.serializeRequest(U,L,B,O,!!G);return this.f?.logOutgoing(M.byteLength,U,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${B}(`,K),this.c.send(M),z}}e.RPCProtocol=u,P=r,u.a=3*1e3;class i{static alloc(L,B,K){const G=new i(t.VSBuffer.alloc(K+1+4),0);return G.writeUInt8(L),G.writeUInt32(B),G}static read(L,B){return new i(L,B)}get buffer(){return this.a}constructor(L,B){this.a=L,this.b=B}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+L).toString();return this.b+=L,K}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+L).toString();return this.b+=L,K}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+L);return this.b+=L,B}static sizeMixedArray(L){let B=0;B+=1;for(let K=0,G=L.length;K<G;K++){const O=L[K];switch(B+=1,O.type){case 1:B+=this.sizeLongString(O.value);break;case 2:B+=this.sizeVSBuffer(O.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(O.value);for(let U=0;U<O.buffers.length;++U)B+=this.sizeVSBuffer(O.buffers[U]);break;case 4:break}}return B}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let B=0,K=L.length;B<K;B++){const G=L[B];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let O=0;O<G.buffers.length;++O)this.writeBuffer(G.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const B=new Array(L);for(let K=0;K<L;K++)switch(this.readUInt8()){case 1:B[K]=this.readLongString();break;case 2:B[K]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),U=this.readLongString(),F=[];for(let z=0;z<O;++z)F.push(this.readVSBuffer());B[K]=new R.SerializableObjectWithBuffers(m(U,F,null));break}case 4:B[K]=void 0;break}return B}}i.sizeUInt32=4;var s;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(s||(s={}));class n{static a(L){for(let B=0,K=L.length;B<K;B++)if(L[B]instanceof t.VSBuffer||L[B]instanceof R.SerializableObjectWithBuffers||typeof L[B]>"u")return!0;return!1}static serializeRequestArguments(L,B){if(this.a(L)){const K=[];for(let G=0,O=L.length;G<O;G++){const U=L[G];if(U instanceof t.VSBuffer)K[G]={type:2,value:U};else if(typeof U>"u")K[G]={type:4};else if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:z}=g(U.value,B);K[G]={type:3,value:t.VSBuffer.fromString(F),buffers:z}}else K[G]={type:1,value:t.VSBuffer.fromString(w(U,B))}}return{type:1,args:K}}return{type:0,args:w(L,B)}}static serializeRequest(L,B,K,G,O){switch(G.type){case 0:return this.b(L,B,K,G.args,O);case 1:return this.c(L,B,K,G.args,O)}}static b(L,B,K,G,O){const U=t.VSBuffer.fromString(K),F=t.VSBuffer.fromString(G);let z=0;z+=i.sizeUInt8(),z+=i.sizeShortString(U),z+=i.sizeLongString(F);const M=i.alloc(O?2:1,L,z);return M.writeUInt8(B),M.writeShortString(U),M.writeLongString(F),M.buffer}static deserializeRequestJSONArgs(L){const B=L.readUInt8(),K=L.readShortString(),G=L.readLongString();return{rpcId:B,method:K,args:JSON.parse(G)}}static c(L,B,K,G,O){const U=t.VSBuffer.fromString(K);let F=0;F+=i.sizeUInt8(),F+=i.sizeShortString(U),F+=i.sizeMixedArray(G);const z=i.alloc(O?4:3,L,F);return z.writeUInt8(B),z.writeShortString(U),z.writeMixedArray(G),z.buffer}static deserializeRequestMixedArgs(L){const B=L.readUInt8(),K=L.readShortString(),G=L.readMixedArray(),O=new Array(G.length);for(let U=0,F=G.length;U<F;U++){const z=G[U];typeof z=="string"?O[U]=JSON.parse(z):O[U]=z}return{rpcId:B,method:K,args:O}}static serializeAcknowledged(L){return i.alloc(5,L,0).buffer}static serializeCancel(L){return i.alloc(6,L,0).buffer}static serializeReplyOK(L,B,K){if(typeof B>"u")return this.d(L);if(B instanceof t.VSBuffer)return this.e(L,B);if(B instanceof R.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:O}=g(B.value,K,!0);return this.g(L,G,O)}else return this.f(L,E(B,K))}static d(L){return i.alloc(7,L,0).buffer}static e(L,B){let K=0;K+=i.sizeVSBuffer(B);const G=i.alloc(8,L,K);return G.writeVSBuffer(B),G.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,B){const K=t.VSBuffer.fromString(B);let G=0;G+=i.sizeLongString(K);const O=i.alloc(9,L,G);return O.writeLongString(K),O.buffer}static g(L,B,K){const G=t.VSBuffer.fromString(B);let O=0;O+=i.sizeUInt32,O+=i.sizeLongString(G);for(const F of K)O+=i.sizeVSBuffer(F);const U=i.alloc(10,L,O);U.writeUInt32(K.length),U.writeLongString(G);for(const F of K)U.writeBuffer(F);return U.buffer}static deserializeReplyOKJSON(L){const B=L.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(L,B){const K=L.readUInt32(),G=L.readLongString(),O=[];for(let U=0;U<K;++U)O.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(m(G,O,B))}static serializeReplyErr(L,B){const K=B?E(A.transformErrorForSerialization(B),null):void 0;if(typeof K!="string")return this.h(L);const G=t.VSBuffer.fromString(K);let O=0;O+=i.sizeLongString(G);const U=i.alloc(11,L,O);return U.writeLongString(G),U.buffer}static deserializeReplyErrError(L){const B=L.readLongString();return JSON.parse(B)}static h(L){return i.alloc(12,L,0).buffer}}var l;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var p;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[281],ye([1,0,4,43,54,3,38,10,18]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(d=>v.push(d)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new R);function P(y,v,d,g,m){return(0,S.createCancelablePromise)(async w=>{await(0,D.whenProviderRegistered)(d,g);const f=t.Registry.as(e.Extensions.OutputChannels);try{await E(d,1,g,m,w),f.registerChannel({id:y,label:v,file:d,log:!0})}catch(h){(0,T.isCancellationError)(h)||m.error("Error while registering log channel",d.toString(),(0,T.getErrorMessage)(h))}})}e.registerLogChannel=P;async function E(y,v,d,g,m){if(!await d.exists(y)){if(m.isCancellationRequested)throw new T.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",y.toString()),await(0,S.timeout)(1e3,m),await E(y,v+1,d,g,m)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Se[141],ye([1,0,5,3,16,27,13,281,72,25,46,161,22,12,38,4,6]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class m extends D.AbstractMessageLogger{get disposed(){return this.l}constructor(b,o,r,c,u){super(),this.id=b,this.name=o,this.m=r,this.n=c,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(i=>this.setLevel(i)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.k;this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Clear,b)}replace(b){const o=this.k;this.info(b),this.n.$update(this.id,T.OutputChannelUpdateMode.Replace,o),this.visible&&this.m.flush()}show(b,o){this.m.flush(),this.n.$reveal(this.id,!!(typeof b=="boolean"?b:o))}hide(){this.n.$close(this.id)}g(b,o){this.k+=E.VSBuffer.fromString(o).byteLength,(0,D.log)(this.m,b,o),this.visible&&(this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class w extends m{appendLine(b){this.append(b)}}let f=class{constructor(b,o,r,c,u,i){this.i=o,this.j=r,this.k=c,this.l=u,this.m=i,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[o,r]of this.g)r.visible=o===this.h}createOutputChannel(b,o,r){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const c=typeof o=="object"&&o.log,u=(0,y.isString)(o)?o:void 0;if((0,y.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let i;const s=this.i.environment.extensionLogLevel?.find(([l])=>A.ExtensionIdentifier.equals(r.identifier,l))?.[1];s&&(i=(0,D.parseLogLevel)(s));const n=c?this.o(b,i,r):this.n(b,u,r);return n.then(l=>{this.g.set(l.id,l),l.visible=l.id===this.h}),c?this.r(b,i??this.m.getLevel(),n):this.q(b,n)}async n(b,o,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,u=this.k.extUri.joinPath(c,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),s=await this.a.$register(b,u,!1,o,r.identifier.value);return new m(s,b,i,this.a,r)}async o(b,o,r){const c=await this.p(r),u=this.k.extUri.joinPath(c,`${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.l.createLogger(u,{name:b},o),s=await this.a.$register(b,u,!0,void 0,r.identifier.value);return new w(s,b,i,this.a,r)}p(b){let o=this.d.get(b.identifier.value);if(!o){const r=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(r)}catch(c){if((0,v.toFileSystemProviderErrorCode)(c)!==v.FileSystemProviderErrorCode.FileExists)throw c}return r})())}return o}q(b,o){let r=!1;const c=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return b},append(u){c(),o.then(i=>i.append(u))},appendLine(u){c(),o.then(i=>i.appendLine(u))},clear(){c(),o.then(u=>u.clear())},replace(u){c(),o.then(i=>i.replace(u))},show(u,i){c(),o.then(s=>s.show(u,i))},hide(){c(),o.then(u=>u.hide())},dispose(){r=!0,o.then(u=>u.dispose())}}}r(b,o,r){const c=new g.DisposableStore,u=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},i=c.add(new d.Emitter);return r.then(s=>{c.add(s),c.add(s.onDidChangeLogLevel(n=>{o=n,i.fire(n)}))}),{...this.q(b,r),get logLevel(){return o},onDidChangeLogLevel:i.event,trace(s,...n){u(),r.then(l=>l.trace(s,...n))},debug(s,...n){u(),r.then(l=>l.debug(s,...n))},info(s,...n){u(),r.then(l=>l.info(s,...n))},warn(s,...n){u(),r.then(l=>l.warn(s,...n))},error(s,...n){u(),r.then(l=>l.error(s,...n))},dispose(){c.dispose()}}}};f=qe([We(0,I.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,R.IExtHostFileSystemInfo),We(4,D.ILoggerService),We(5,D.ILogService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(Se[282],ye([1,0,3]),function(ee,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Se[283],ye([1,0,32,15,9,11,24,2,3,208,45,225,282]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class ri{constructor(d,g,m,w){this.d=d,this.e=g,this.f=m,this.g=w,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const f=await this.e.getEnvironment();return this.c=f?.userHome??d})()}hasValidBasename(d,g,m){return typeof g=="string"||typeof g>"u"?this.a.then(w=>this.h(d,w,g)):this.h(d,g,m)}h(d,g,m){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,a.isValidBasename)(m??(0,D.basename)(d),g===1):!0}get defaultUriScheme(){return ri.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,g){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const m=(0,C.getVirtualWorkspaceScheme)(g.getWorkspace());if(m)return m;const w=g.getWorkspace().folders[0];if(w)return w.uri.scheme;const f=g.getWorkspace().configuration;return f?f.scheme:t.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?I.win32:I.posix)}async fileURI(d){let g="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const w=d.indexOf("/",2);w===-1?(g=d.substring(2),d="/"):(g=d.substring(2,w),d=d.substring(w)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:g,path:d,query:"",fragment:""})}};y=qe([We(1,E.IRemoteAgentService),We(2,P.IWorkbenchEnvironmentService),We(3,R.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(Se[75],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(D,T){this.line=D,this.character=T}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,T){return new a(0,0)}with(D){return new a(0,0)}}e.Position=a;class t{constructor(D,T,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(D,T),this.end=new a(S,C)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new t(0,0,0,0)}with(D){return new t(0,0,0,0)}}e.Range=t;var I;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[31],ye([1,0,17,36,23,32,8,3,9,10,75,18]),function(ee,e,a,t,I,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",y=" characters skipped \u27EB",v=(E.length+y.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var d;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function m(Y){return!!Y.preview}e.resultIsMatch=m;function w(Y){return!!Y.resource}e.isFileMatch=w;function f(Y){return!!Y.message}e.isProgressMessage=f;var h;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=b;class o{constructor(ce,ie,fe){this.ranges=ie;const J=Array.isArray(ie)?ie:[ie];if(fe&&fe.matchLines===1&&r(J)){ce=(0,D.getNLines)(ce,fe.matchLines);let pe="",we=0,Ie=0;const Re=Math.floor(fe.charsPerLine/5),ze=[];for(const re of J){const ue=Math.max(re.startColumn-Re,0),de=re.startColumn+fe.charsPerLine;if(ue>Ie+Re+v){const Z=E+(ue-Ie)+y;pe+=Z+ce.slice(ue,de),we+=ue-(Ie+Z.length)}else pe+=ce.slice(Ie,de);ze.push(new u(0,re.startColumn-we,re.endColumn-we)),Ie=de}this.preview={text:pe,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const pe=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:ce,matches:(0,a.mapArrayOrNot)(ie,we=>new c(we.startLineNumber-pe,we.startColumn,we.endLineNumber-pe,we.endColumn))}}}}e.TextSearchMatch=o;function r(Y){const ce=Y[0].startLineNumber;for(const ie of Y)if(ie.startLineNumber!==ce||ie.endLineNumber!==ce)return!1;return!0}class c{constructor(ce,ie,fe,J){this.startLineNumber=ce,this.startColumn=ie,this.endLineNumber=fe,this.endColumn=J}}e.SearchRange=c;class u extends c{constructor(ce,ie,fe){super(ce,ie,ce,fe)}}e.OneLineRange=u;var i;(function(Y){Y.List="list",Y.Tree="tree"})(i=e.ViewMode||(e.ViewMode={}));var s;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Y,ce=!0){const ie=Y&&Y.files&&Y.files.exclude,fe=ce&&Y&&Y.search&&Y.search.exclude;if(!ie&&!fe)return;if(!ie||!fe)return ie||fe;let J=Object.create(null);return J=I.mixin(J,I.deepClone(ie)),J=I.mixin(J,I.deepClone(fe),!0),J}e.getExcludes=n;function l(Y,ce){return Y.excludePattern&&t.match(Y.excludePattern,ce)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&t.match(Y.includePattern,ce)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ie=>{const fe=ie.folder.fsPath;if(A.isEqualOrParent(ce,fe)){const J=S.relative(fe,ce);return!ie.includePattern||!!t.match(ie.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var p;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class k extends Error{constructor(ce,ie){super(ce),this.code=ie}}e.SearchError=k;function L(Y){const ce=Y.message;if((0,C.isCancellationError)(Y))return new k(ce,p.canceled);try{const ie=JSON.parse(ce);return new k(ie.message,ie.code)}catch{return new k(ce,p.other)}}e.deserializeSearchError=L;function B(Y){const ce={message:Y.message,code:Y.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=B;function K(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=K;function G(Y){return Y.type==="success"}e.isSerializedSearchSuccess=G;function O(Y){return!!Y.path}e.isSerializedFileMatch=O;function U(Y,ce){const ie=Y.searchPath?Y.searchPath:Y.relativePath;return(0,D.fuzzyContains)(ie,ce)}e.isFilePatternMatch=U;class F{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function z(Y,ce){const ie={...Y||{},...ce||{}};return Object.keys(ie).filter(fe=>{const J=ie[fe];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=z;class M{constructor(ce,ie){this.c=null,this.a={...ce.excludePattern||{},...ie.excludePattern||{}},this.b=t.parse(this.a);let fe=ce.includePattern;ie.includePattern&&(fe?fe={...fe,...ie.includePattern}:fe=ie.includePattern),fe&&(this.c=t.parse(fe))}matchesExcludesSync(ce,ie,fe){return!!(this.b&&this.b(ce,ie,fe))}includedInQuerySync(ce,ie,fe){return!(this.b&&this.b(ce,ie,fe)||this.c&&!this.c(ce,ie,fe))}includedInQuery(ce,ie,fe){const J=this.b(ce,ie,fe),pe=()=>this.c?!!this.c(ce,ie,fe):!0;return(0,P.isThenable)(J)?J.then(we=>we?!1:pe()):pe()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=M;function V(Y){for(const ce in Y)if(typeof Y[ce]!="boolean")return!0;return!1}function q(Y){if(!Y)return;let ce;return ie=>(ce||(ce=(Y()||Promise.resolve([])).then(fe=>fe?Q(fe):{})),ce.then(fe=>!!fe[ie]))}e.hasSiblingPromiseFn=q;function H(Y){if(!Y)return;let ce;return ie=>{if(!ce){const fe=Y();ce=fe?Q(fe):{}}return!!ce[ie]}}e.hasSiblingFn=H;function Q(Y){const ce={};for(const ie of Y)ce[ie]=!0;return ce}}),define(Se[33],ye([1,0,17,18,21,4,6,65,15,100,24,8,12,2,177,3,13,197,45,46,25,16,14,7,56,31,5]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h,b,o,r,c,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(G,O,U){return new R.ExtUri(F=>k(F,U)).isEqual(G,O)}function n(G,O,U){return s(G.uri,O.uri,U)?0:(0,P.compare)(G.uri.toString(),O.uri.toString())}function l(G,O,U){return G.index!==O.index?G.index<O.index?-1:1:s(G.uri,O.uri,U)?(0,P.compare)(G.name,O.name):(0,P.compare)(G.uri.toString(),O.uri.toString())}function p(G,O,U,F){const z=G.slice(0).sort((V,q)=>U(V,q,F)),M=O.slice(0).sort((V,q)=>U(V,q,F));return(0,a.delta)(z,M,(V,q)=>U(V,q,F))}function k(G,O){const U=O.getCapabilities(G.scheme);return!(U&&U&1024)}class L extends w.Workspace{static toExtHostWorkspace(O,U,F,z){if(!O)return{workspace:null,added:[],removed:[]};const{id:M,name:V,folders:q,configuration:H,transient:Q,isUntitled:Y}=O,ce=[],ie=U;U?q.forEach((we,Ie)=>{const Re=y.URI.revive(we.uri),ze=L.e(F||U,Re,z);ze?(ze.name=we.name,ze.index=we.index,ce.push(ze)):ce.push({uri:Re,name:we.name,index:Ie})}):ce.push(...q.map(({uri:we,name:Ie,index:Re})=>({uri:y.URI.revive(we),name:Ie,index:Re}))),ce.sort((we,Ie)=>we.index<Ie.index?-1:1);const fe=new L(M,V,ce,!!Q,H?y.URI.revive(H):null,!!Y,we=>k(we,z)),{added:J,removed:pe}=p(ie?ie.workspaceFolders:[],fe.workspaceFolders,n,z);return{workspace:fe,added:J,removed:pe}}static e(O,U,F){for(let z=0;z<O.folders.length;z++){const M=O.workspaceFolders[z];if(s(M.uri,U,F))return M}}constructor(O,U,F,z,M,V,q){super(O,F.map(H=>new w.WorkspaceFolder(H)),z,M,q),this.s=U,this.t=V,this.o=[],this.q=T.TernarySearchTree.forUris(q),F.forEach(H=>{this.o.push(H),this.q.set(H.uri,H)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(O,U){return U&&this.q.get(O)&&(O=(0,R.dirname)(O)),this.q.findSubstr(O)}resolveWorkspaceFolder(O){return this.q.get(O)}}let B=class{constructor(O,U,F,z,M){this.c=new A.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new A.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=z,this.q=F,this.s=M,this.h=new C.Counter,this.j=new t.Barrier,this.n=O.getProxy(i.MainContext.MainThreadWorkspace),this.o=O.getProxy(i.MainContext.MainThreadMessageService);const V=U.workspace;this.k=V?new L(V.id,V.name,[],!!V.transient,V.configuration?y.URI.revive(V.configuration):null,!!V.isUntitled,q=>k(q,F)):void 0}$initializeWorkspace(O,U){this.u=U,this.$acceptWorkspaceData(O),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?y.URI.from({scheme:S.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(O,U,F,...z){const M=[];if(Array.isArray(z)&&z.forEach(Y=>{y.URI.isUri(Y.uri)&&!M.some(ce=>s(ce.uri,Y.uri,this.q))&&M.push({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri)})}),this.l||[U,F].some(Y=>typeof Y!="number"||Y<0)||F===0&&M.length===0)return!1;const V=this.w?this.w.workspaceFolders:[];if(U+F>V.length)return!1;const q=V.slice(0);q.splice(U,F,...M.map(Y=>({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<q.length;Y++){const ce=q[Y];if(q.some((ie,fe)=>fe!==Y&&s(ce.uri,ie.uri,this.q)))return!1}q.forEach((Y,ce)=>Y.index=ce);const{added:H,removed:Q}=p(V,q,l,this.q);if(H.length===0&&Q.length===0)return!1;if(this.n){const Y=O.displayName||O.name;this.n.$updateWorkspaceFolders(Y,U,F,M).then(void 0,ce=>{this.l=void 0;const ie={source:{identifier:O.identifier,label:O.displayName||O.name}};this.o.$showMessage(m.Severity.Error,(0,v.localize)(0,null,Y,ce.toString()),ie,[])})}return this.x(q),!0}getWorkspaceFolder(O,U){if(!!this.w)return this.w.getWorkspaceFolder(O,U)}async getWorkspaceFolder2(O,U){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(O,U)}async resolveWorkspaceFolder(O){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(O)}getPath(){if(!this.w)return;const{folders:O}=this.w;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,U){let F,z="";if(typeof O=="string"?(F=y.URI.file(O),z=O):typeof O<"u"&&(F=O,z=O.fsPath),!F)return z;const M=this.getWorkspaceFolder(F,!0);if(!M)return z;typeof U>"u"&&this.w&&(U=this.w.folders.length>1);let V=(0,R.relativePath)(M.uri,F);return U&&M.name&&(V=`${M.name}/${V}`),V}x(O){this.w&&(this.l=L.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:O,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:U,added:F,removed:z}=L.toExtHostWorkspace(O,this.k,this.l,this.q);this.k=U||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:z}))}findFiles(O,U,F,z,M=I.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let V;if(U===null?V=!1:U&&(typeof U=="string"?V=U:V=U.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:q,folder:H}=K(o.GlobPattern.from(O));return this.n.$startFileSearch((0,E.withUndefinedAsNull)(q),(0,E.withUndefinedAsNull)(H),(0,E.withUndefinedAsNull)(V),(0,E.withUndefinedAsNull)(F),M).then(Q=>Array.isArray(Q)?Q.map(Y=>y.URI.revive(Y)):[])}async findTextInFiles(O,U,F,z,M=I.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const V=this.h.getNext(),q=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:H,folder:Q}=K(o.GlobPattern.from(U.include)),Y=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ce={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:q,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:H,excludePattern:Y},ie=!1;if(this.t[V]=fe=>{if(ie)return;const J=y.URI.revive(fe.resource);fe.results.forEach(pe=>{(0,u.resultIsMatch)(pe)?F({uri:J,preview:{text:pe.preview.text,matches:(0,a.mapArrayOrNot)(pe.preview.matches,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,a.mapArrayOrNot)(pe.ranges,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):F({uri:J,text:pe.text,lineNumber:pe.lineNumber})})},M.isCancellationRequested)return{};try{const fe=await this.n.$startTextSearch(O,(0,E.withUndefinedAsNull)(Q),ce,V,M);return delete this.t[V],fe||{}}catch(fe){throw delete this.t[V],fe}}$handleTextSearchResult(O,U){this.t[U]?.(O)}saveAll(O){return this.n.$saveAll(O)}resolveProxy(O){return this.n.$resolveProxy(O)}get trusted(){return this.u}requestWorkspaceTrust(O){return this.n.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(O,U){if(this.v.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.v.set(O,U);const F=this.s.transformOutgoingScheme(O),z=this.y++;return this.n.$registerEditSessionIdentityProvider(z,F),(0,D.toDisposable)(()=>{this.v.delete(O),this.n.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(O,U){this.g.info("Getting edit session identifier for workspaceFolder",O);const F=await this.resolveWorkspaceFolder(y.URI.revive(O));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const z=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!z),!z)return;const M=await z.provideEditSessionIdentity(F,U);if(this.g.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(O,U,F,z){this.g.info("Getting edit session identifier for workspaceFolder",O);const M=await this.resolveWorkspaceFolder(y.URI.revive(O));if(!M){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const V=this.v.get(M.uri.scheme);if(this.g.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!V),!V)return;const q=await V.provideEditSessionIdentityMatch?.(U,F,z);if(this.g.info("Provider returned edit session identifier match result: ",q),!!q)return q}};B=qe([We(0,b.IExtHostRpcService),We(1,h.IExtHostInitDataService),We(2,f.IExtHostFileSystemInfo),We(3,g.ILogService),We(4,c.IURITransformerService)],B),e.ExtHostWorkspace=B,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function K(G){let O,U;return G&&(typeof G=="string"?O=G:(O=G.pattern,U=y.URI.revive(G.baseUri))),{includePattern:O,folder:U}}}),define(Se[34],ye([1,0,23,4,33,5,7,200,126,12,18,3,16,13,2]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(r,c){if(c){const u=c.split(".");let i=r;for(let s=0;i&&s<u.length;s++)i=i[u[s]];return i}}function g(r){return r instanceof v.URI}function m(r){return r&&r.uri instanceof v.URI&&r.languageId&&typeof r.languageId=="string"}function w(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function f(r){return r&&r.uri instanceof v.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function h(r){if(g(r))return{resource:r};if(m(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(w(r))return{overrideIdentifier:r.languageId};if(f(r))return{resource:r.uri};if(r===null)return{resource:null}}let b=class{constructor(c,u,i){this.a=c.getProxy(A.MainContext.MainThreadConfiguration),this.c=u,this.b=i,this.d=new R.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new o(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,u){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(c,u))}};b=qe([We(0,E.IExtHostRpcService),We(1,I.IExtHostWorkspace),We(2,y.ILogService)],b),e.ExtHostConfiguration=b;class o{constructor(c,u,i,s){this.a=new t.Emitter,this.b=c,this.f=s,this.c=u,this.e=T.Configuration.parse(i),this.d=this.k(i.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,u){const i={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(u,i))}getConfiguration(c,u,i){const s=h(u)||{},n=this.g(c?d(this.e.getValue(void 0,s,this.c.workspace),c):this.e.getValue(void 0,s,this.c.workspace));c&&this.h(c,s,i?.identifier);function l(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(k){return typeof d(n,k)<"u"},get:(k,L)=>{this.h(c?`${c}.${k}`:k,s,i?.identifier);let B=d(n,k);if(typeof B>"u")B=L;else{let K;const G=(O,U)=>{let F;const z=()=>{K=K||(0,a.deepClone)(n),F=F||d(K,U)};return(0,C.isObject)(O)?new Proxy(O,{get:(M,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return z(),()=>F;if(K)return F=F||d(K,U),F[V];const q=M[V];return typeof V=="string"?G(q,`${U}.${V}`):q},set:(M,V,q)=>(z(),F&&(F[V]=q),!0),deleteProperty:(M,V)=>(z(),F&&delete F[V],!0),defineProperty:(M,V,q)=>(z(),F&&Object.defineProperty(F,V,q),!0)}):O};B=G(B,k)}return B},update:(k,L,B,K)=>{k=c?`${c}.${k}`:k;const G=l(B);return L!==void 0?this.b.$updateConfigurationOption(G,k,L,s,K):this.b.$removeConfigurationOption(G,k,s,K)},inspect:k=>{k=c?`${c}.${k}`:k;const L=this.e.inspect(k,s,this.c.workspace);if(L)return{key:k,defaultValue:(0,a.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,a.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,a.deepClone)(L.workspace?.value),workspaceFolderValue:(0,a.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(L.default?.override),globalLanguageValue:(0,a.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,a.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(L.workspaceFolder?.override),languageIds:(0,a.deepClone)(L.overrideIdentifiers)}}};return typeof n=="object"&&(0,a.mixin)(p,n,!1),Object.freeze(p)}g(c){const u=i=>(0,C.isObject)(i)?new Proxy(i,{get:(s,n)=>u(s[n]),set:(s,n,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(s,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(s,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:s=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return u(c)}h(c,u,i){const s=S.OVERRIDE_PROPERTY_REGEX.test(c)?4:this.d.get(c),n=i?`[${i.value}] `:"";if(s===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(s===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,u){const i=new T.ConfigurationChangeEvent(c,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(s,n)=>i.affectsConfiguration(s,h(n))})}k(c){return c.reduce((u,i)=>(u.set(i[0],i[1]),u),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[76],ye([1,0,2,18,4,5,7,33,59,34,21,40,16,25,3,15,11,13,71,238,10]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(O){function U(z){if(z!=null)return z}O.from=U;function F(z){if(z!=null)return z}O.to=F})(o||(o={}));var r;(function(O){function U(z){if(z!=null)return z}O.from=U;function F(z){if(z!=null)return z}O.to=F})(r||(r={}));var c;(function(O){function U(z){if(z!=null)return z}O.from=U;function F(z){if(z!=null)return z}O.to=F})(c||(c={}));var u;(function(O){function U(M){if(M){const V=M;return V&&!!V.process}else return!1}O.is=U;function F(M){if(M==null)return;const V={process:M.process,args:M.args};return M.options&&(V.options=c.from(M.options)),V}O.from=F;function z(M){if(M!=null)return new D.ProcessExecution(M.process,M.args,M.options)}O.to=z})(u||(u={}));var i;(function(O){function U(z){if(z!=null)return z}O.from=U;function F(z){if(z!=null)return z}O.to=F})(i||(i={}));var s;(function(O){function U(M){if(M){const V=M;return V&&(!!V.commandLine||!!V.command)}else return!1}O.is=U;function F(M){if(M==null)return;const V={};return M.commandLine!==void 0?V.commandLine=M.commandLine:(V.command=M.command,V.args=M.args),M.options&&(V.options=i.from(M.options)),V}O.from=F;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new D.ShellExecution(M.commandLine,M.options):new D.ShellExecution(M.command,M.args?M.args:[],M.options)}O.to=z})(s||(s={}));var n;(function(O){function U(M){if(M){const V=M;return V&&V.customExecution==="customExecution"}else return!1}O.is=U;function F(M){return{customExecution:"customExecution"}}O.from=F;function z(M,V){return V.get(M)}O.to=z})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function(O){function U(F,z){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===D.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=f.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}O.from=U})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(O){function U(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}O.from=U})(p||(p={}));var k;(function(O){function U(M,V){if(M==null)return[];const q=[];for(const H of M){const Q=F(H,V);Q&&q.push(Q)}return q}O.fromMany=U;function F(M,V){if(M==null)return;let q;M.execution instanceof D.ProcessExecution?q=u.from(M.execution):M.execution instanceof D.ShellExecution?q=s.from(M.execution):M.execution&&M.execution instanceof D.CustomExecution&&(q=n.from(M.execution));const H=o.from(M.definition);let Q;return M.scope?typeof M.scope=="number"?Q=M.scope:Q=M.scope.uri:Q=D.TaskScope.Workspace,!H||!Q?void 0:{_id:M._id,definition:H,name:M.name,source:{extensionId:V.identifier.value,label:M.source,scope:Q},execution:q,isBackground:M.isBackground,group:p.from(M.group),presentationOptions:r.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=F;async function z(M,V,q){if(M==null)return;let H;u.is(M.execution)?H=u.to(M.execution):s.is(M.execution)?H=s.to(M.execution):n.is(M.execution)&&(H=n.to(M._id,q));const Q=o.to(M.definition);let Y;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Y=M.source.scope:Y=await V.resolveWorkspaceFolder(a.URI.revive(M.source.scope)):Y=D.TaskScope.Workspace),!Q||!Y)return;const ce=new D.Task(Q,Y,M.name,M.source.label,H,M.problemMatchers);return M.isBackground!==void 0&&(ce.isBackground=M.isBackground),M.group!==void 0&&(ce.group=D.TaskGroup.from(M.group._id),ce.group&&M.group.isDefault&&(ce.group=new D.TaskGroup(ce.group.id,ce.group.label),M.group.isDefault===!0&&(ce.group.isDefault=M.group.isDefault))),M.presentationOptions&&(ce.presentationOptions=r.to(M.presentationOptions)),M._id&&(ce._id=M._id),M.detail&&(ce.detail=M.detail),ce}O.to=z})(k=e.TaskDTO||(e.TaskDTO={}));var L;(function(O){function U(z){return z}O.from=U;function F(z){if(!!z)return Object.assign(Object.create(null),z)}O.to=F})(L||(L={}));class B{constructor(U,F,z){this._id=F,this.a=z,b.set(this,void 0),Je(this,b,U,"f")}get task(){return this.a}terminate(){Fe(this,b,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}b=new WeakMap;let K=class{constructor(U,F,z,M,V,q,H,Q){this.q=new I.Emitter,this.r=new I.Emitter,this.s=new I.Emitter,this.t=new I.Emitter,this.a=U.getProxy(A.MainContext.MainThreadTask),this.b=z,this.c=M,this.d=V,this.e=q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=H,this.g=Q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,F,z){if(!z)return new D.Disposable(()=>{});const M=this.w();return this.j.set(M,{type:F,provider:z,extension:U}),this.a.$registerTaskProvider(M,F),new D.Disposable(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(U,F){this.a.$registerTaskSystem(U,F)}fetchTasks(U){return this.a.$fetchTasks(L.from(U)).then(async F=>{const z=[];for(const M of F){const V=await k.to(M,this.b,this.m);V&&z.push(V)}return z})}get taskExecutions(){const U=[];return this.k.forEach(F=>U.push(F)),U}terminateTask(U){if(!(U instanceof B))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,F,z){const M=this.m.get(U.id);M&&(this.o.set(U.id,M),this.e.attachPtyToTerminal(F,await M.callback(z))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const F=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const F=await this.y(U.id);this.s.fire({execution:F,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const F=await this.y(U.id);this.t.fire({execution:F,exitCode:U.exitCode})}$provideTasks(U,F){const z=this.j.get(U);if(!z)return Promise.reject(new Error("no handler found"));const M=[],V=(0,t.asPromise)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(q=>this.u(F,M,z,q));return new Promise(q=>{V.then(H=>{Promise.all(M).then(()=>{q(H)})})})}async $resolveTask(U,F){const z=this.j.get(U);if(!z)return Promise.reject(new Error("no handler found"));if(F.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await k.to(F,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const V=await z.provider.resolveTask(M,R.CancellationToken.None);if(!V)return;this.z(V,z);const q=k.from(V,z.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(q.execution)&&await this.x(q,V,!0),await this.v(q)}w(){return this.h++}async x(U,F,z){const M=await this.a.$createTaskId(U);!z&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,F.execution)),this.m.set(M,F.execution)}async y(U,F){if(typeof U=="string"){const V=this.l.get(U);if(!V)throw new h.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const z=this.l.get(U.id);if(z)return z;const M=new Promise((V,q)=>{function H(Q,Y,ce){ce?V(new B(Q,Y.id,ce)):q("Unexpected: Task does not exist.")}F?H(this,U,F):k.to(U.task,this.b,this.m).then(Q=>H(this,U,Q))});return this.l.set(U.id,M),M.then(V=>(this.k.set(U.id,V),V),V=>Promise.reject(V))}z(U,F){U._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const z=this.n.values();let M=z.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=z.next()}};K=qe([We(0,E.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,m.ILogService),We(7,w.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let G=class extends K{constructor(U,F,z,M,V,q,H,Q){super(U,F,z,M,V,q,H,Q),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(U,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const z=k.from(F,U);if(z===void 0)throw new Error("Task is not valid");if(n.is(z.execution))await this.x(z,F,!1);else throw new h.NotSupportedError;const M=await this.y(await this.a.$getTaskExecution(z),F);return this.a.$executeTask(z).catch(V=>{throw new Error(V)}),M}u(U,F,z,M){const V=[];if(M)for(const q of M){this.z(q,z),(!q.definition||!U[q.definition.type])&&this.f.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const H=k.from(q,z.extension);H&&n.is(H.execution)?(V.push(H),F.push(this.x(H,q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:z.extension}}async v(U){if(n.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,F,z){}};G=qe([We(0,E.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,m.ILogService),We(7,w.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(Se[284],ye([1,0,9,21,52,36,24,49,31]),function(ee,e,a,t,I,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(E,y,v){this.k=E,this.l=y,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=E.filePattern,this.b=E.includePattern&&A.parse(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.h=new Set,this.j=E.excludePattern&&A.parse(E.excludePattern)}cancel(){this.g=!0,this.h.forEach(E=>E.cancel()),this.h=new Set}search(E){const y=this.k.folderQueries||[];return new Promise((v,d)=>{const g=m=>{this.f++,E(m)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(m=>{const w=m.toString(),f=a.basename(w);this.j&&this.j(w,f)||this.v(g,{base:m,basename:f})}),Promise.all(y.map(m=>this.p(m,g))).then(m=>{v({limitHit:this.e,stats:m[0]||void 0})},m=>{d(new Error((0,I.toErrorMessage)(m)))})})}async p(E,y){const v=new t.CancellationTokenSource,d=this.q(E),g=this.r(),m=new S.QueryGlobTester(this.k,E),w=!m.hasSiblingExcludeClauses();let f;try{this.h.add(v),f=T.StopWatch.create();const h=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),b=f.elapsed(),o=T.StopWatch.create();return this.g&&!this.e||(h&&h.forEach(r=>{const c=a.posix.relative(E.folder.path,r.path);if(w){const u=a.basename(r.path);this.v(y,{base:E.folder,relativePath:c,basename:u});return}this.s(g,E.folder,c,y)}),this.g&&!this.e)?null:(this.u(g,m,y),{providerTime:b,postProcessTime:o.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(E){const y=(0,S.resolvePatternsForProvider)(this.k.includePattern,E.includePattern),v=(0,S.resolvePatternsForProvider)(this.k.excludePattern,E.excludePattern);return{folder:E.folder,excludes:v,includes:y,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}s({pathToEntries:E},y,v,d){if(v===this.a){const m=a.basename(this.a);this.v(d,{base:y,relativePath:this.a,basename:m})}function g(m){const w=a.basename(m),f=a.dirname(m);let h=E[f];h||(h=E[f]=[],g(f)),h.push({base:y,relativePath:m,basename:w})}g(v)}u({rootEntries:E,pathToEntries:y},v,d){const g=this,m=this.a;function w(f){const h=(0,S.hasSiblingFn)(()=>f.map(b=>b.basename));for(let b=0,o=f.length;b<o;b++){const r=f[b],{relativePath:c,basename:u}=r;if(v.matchesExcludesSync(c,u,m!==u?h:void 0))continue;const i=y[c];if(i)w(i);else{if(c===m)continue;g.v(d,r)}if(g.e)break}}w(E)}v(E,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||E(y))}}class R{constructor(){this.b=new Map}fileSearch(E,y,v,d){const g=this.c(E.cacheKey),m=new C(E,y,g&&g.token);let w=0;const f=h=>{w+=h.length,v(h.map(b=>this.d(b)))};return this.e(m,R.a,f,d).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:h.stats}}))}clearCache(E){this.c(E)?.cancel()}c(E){if(!!E)return this.b.has(E)||this.b.set(E,new t.CancellationTokenSource),this.b.get(E)}d(E){return E.relativePath?{resource:D.joinPath(E.base,E.relativePath)}:{resource:E.base}}e(E,y,v,d){d.onCancellationRequested(()=>{E.cancel()});const g=w=>{w&&(m.push(w),y>0&&m.length>=y&&(v(m),m=[]))};let m=[];return E.search(g).then(w=>(m.length&&v(m),w),w=>(m.length&&v(m),Promise.reject(w)))}}e.FileSearchManager=R,R.a=512}),define(Se[285],ye([1,0,17,81,36,108,28,15,9,24,8,12,2,158,188,53,13,45,133,283,31]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,k,L,B,K){this.a=p,this.b=k,this.c=L,this.d=B,this.e=K}text(p,k,L={}){p=this.f(p,L);const B=this.a.getValue(),K=k&&k.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(k?.map(m.toWorkspaceFolder),L),type:2,contentPattern:p,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:B.search.usePCRE2||K||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(p,k){const L=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const B={...p,wordSeparators:L.editor.wordSeparators};return this.j(p,k)&&(B.isCaseSensitive=!0),this.k(p)&&(B.isMultiline=!0),B}file(p,k={}){return{...this.h(p,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(p,k){return p?(p=Array.isArray(p)?p.map(i):i(p),k?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],k={}){const L=this.g(k.includePattern,k.expandPatterns),B=this.g(k.excludePattern,k.expandPatterns),K=p.length>1,G=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,k,B)):p.map(F=>this.r(F,k,B,K))).filter(F=>!!F),O={_reason:k._reason,folderQueries:G,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:B.pattern,includePattern:L.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const F=a.coalesce(a.flatten(this.c.groups.map(V=>V.editors.map(q=>q.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const z=F.filter(V=>(0,h.pathIncludedInQuery)(O,V.fsPath)),M=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(M)),{...O,...M}}const U=k.extraFileResources&&k.extraFileResources.filter(F=>(0,h.pathIncludedInQuery)(O,F.fsPath));return O.extraFileResources=U&&U.length?U:void 0,O}i(p){const k=[],L=new D.ResourceMap,B={};let K=!1;return p.forEach(G=>{if(G.scheme===T.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(G)){const U=this.b.getWorkspaceFolder(G)?.uri??G.with({path:S.dirname(G.fsPath)});let F=L.get(U);F||(K=!0,F={folder:U,includePattern:{}},k.push(F),L.set(U,F));const z=S.relative(U.fsPath,G.fsPath);(0,P.assertIsDefined)(F.includePattern)[z.replace(/\\/g,"/")]=!0}else G.fsPath&&(K=!0,B[G.fsPath]=!0)}),{folderQueries:k,includePattern:B,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(p,k){if(k.isSmartCase){if(p.isRegExp){if(R.containsUppercaseCharacter(p.pattern,!0))return!0}else if(R.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,y.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const k=M=>S.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),B=(Array.isArray(p)?p:c(p)).map(M=>{const V=this.e.resolvedUserHome;return V?(0,A.untildify)(M,V.scheme===T.Schemas.file?V.fsPath:V.path):M}),K=t.groupBy(B,M=>k(M)?"searchPaths":"exprSegments"),G=(K.exprSegments||[]).map(M=>R.rtrim(M,"/")).map(M=>R.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),u(M))),O={},U=this.m(K.searchPaths||[]);U&&U.length&&(O.searchPaths=U);const F=a.flatten(G),z=r(...F);return z&&(O.pattern=z),O}l(p,k){return k.disregardExcludeSettings?void 0:(0,h.getExcludes)(p,!k.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const k=a.flatten(p.map(B=>{let{pathPortion:K,globPortion:G}=o(B);G&&(G=s(G));const O=this.n(K);return a.flatten(O.map(U=>this.o(U,G)))})),L=new Map;return k.forEach(B=>{const K=B.searchPath.toString(),G=L.get(K);G?B.pattern&&(G.pattern=G.pattern||{},G.pattern[B.pattern]=!0):L.set(K,{searchPath:B.searchPath,pattern:B.pattern?r(B.pattern):void 0})}),Array.from(L.values())}n(p){if(S.isAbsolute(p)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==T.Schemas.file?[{searchPath:k[0].uri.with({path:p})}]:[{searchPath:E.URI.file(S.normalize(p))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(p=i(p),p.startsWith("../")||p===".."){const B=S.posix.resolve(k.path,p);return[{searchPath:k.with({path:B})}]}const L=s(p);return[{searchPath:k,pattern:L}]}else{if(p==="./"||p===".\\")return[];{const k=p.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(K=>{const G=k.match(new RegExp(`^${R.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return G?{match:G,folder:K}:null}).filter(P.isDefined);if(B.length)return B.map(K=>{const G=K.match[1];return{searchPath:K.folder.uri,pattern:G&&s(G)}});{const K=p.match(/\.[\/\\](.+)[\/\\]?/),G=K?K[1]:p,O=v.localize(0,null,G);throw new Error(O)}}}}o(p,k){const L=p.pattern&&k?`${p.pattern}/${k}`:p.pattern||k,B=[{searchPath:p.searchPath,pattern:L}];return L&&!L.endsWith("**")&&B.push({searchPath:p.searchPath,pattern:L+"/**"}),B}q(p,k,L){const B=this.r((0,m.toWorkspaceFolder)(p.searchPath),k,L,!1);return B?{...B,includePattern:p.pattern}:null}r(p,k,L,B){let K;const G=E.URI.isUri(p)?p:p.uri;if(L.searchPaths){const M=L.searchPaths.filter(V=>(0,C.isEqual)(V.searchPath,G))[0];if(M&&!M.pattern)return null;M&&(K=M.pattern)}const O=this.a.getValue({resource:G}),F={...this.l(O,k)||{},...K||{}},z=E.URI.isUri(p)?(0,C.basename)(p):p.name;return{folder:G,folderName:B?z:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!O.search.followSymlinks}}};b=qe([We(0,d.IConfigurationService),We(1,m.IWorkspaceContextService),We(2,w.IEditorGroupsService),We(3,g.ILogService),We(4,f.IPathService)],b),e.QueryBuilder=b;function o(l){const p=l.match(/[\*\{\}\(\)\[\]\?]/);if(p){const k=p.index,L=l.substr(0,k).match(/[/|\\][^/\\]*$/);if(L){let B=l.substr(0,L.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:l.substr((L.index||0)+1)}}}return{pathPortion:l}}function r(...l){return l.length?l.reduce((p,k)=>(p[k]=!0,p),Object.create(null)):void 0}function c(l){return I.splitGlobAware(l,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(l){return[`**/${l}/**`,`**/${l}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function i(l){return l.replace(/\\/g,"/")}function s(l){return i(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(l,p){l=a.distinct(l,B=>B.toString());const k=[],L=p.getWorkspace();return l&&l.forEach(B=>{let K;if(p.getWorkbenchState()===2)K=(0,C.relativePath)(L.folders[0].uri,B),K&&K!=="."&&(K="./"+K);else{const G=p.getWorkspaceFolder(B);if(G){const O=G.name;if(L.folders.filter(F=>F.name===O).length===1){const F=(0,C.relativePath)(G.uri,B);F===""?K=`./${G.name}`:K=`./${G.name}/${F}`}else K=B.fsPath}}K&&k.push(K)}),k}e.resolveResourcesForSearchIncludes=n}),define(Se[286],ye([1,0,24,2,21,10,3,285,31,45]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function P(d,g){const m=g.activationEvents;if(!m)return Promise.resolve(void 0);const w=[],f=[];for(const u of m)if(/^workspaceContains:/.test(u)){const i=u.substr(18);i.indexOf("*")>=0||i.indexOf("?")>=0||d.forceUsingSearch?f.push(i):w.push(i)}if(w.length===0&&f.length===0)return Promise.resolve(void 0);let h;const b=new Promise((u,i)=>{h=u}),o=u=>h({activationEvent:u}),r=Promise.all(w.map(u=>E(d,u,o))).then(()=>{}),c=y(d,g.identifier,f,o);return Promise.all([r,c]).then(()=>{h(void 0)}),b}e.checkActivateWorkspaceContainsExtension=P;async function E(d,g,m){for(const w of d.folders)if(await d.exists(a.joinPath(t.URI.revive(w),g))){m(`workspaceContains:${g}`);return}}async function y(d,g,m,w){if(m.length===0)return Promise.resolve(void 0);const f=new I.CancellationTokenSource,h=d.checkExists(d.folders,m,f.token),b=setTimeout(async()=>{f.cancel(),d.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},R);let o=!1;try{o=await h}catch(r){A.isCancellationError(r)||A.onUnexpectedError(r)}f.dispose(),clearTimeout(b),o&&w(`workspaceContains:${m.join(",")}`)}function v(d,g,m,w){const f=d.get(D.IInstantiationService),h=d.get(S.ISearchService),o=f.createInstance(T.QueryBuilder).file(g.map(r=>(0,C.toWorkspaceFolder)(t.URI.revive(r))),{_reason:"checkExists",includePattern:m,exists:!0});return h.fileSearch(o,w).then(r=>!!r.limitHit,r=>A.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=v});var Je=this&&this.__classPrivateFieldSet||function(ee,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,a):I?I.value=a:e.set(ee,a),a},Fe=this&&this.__classPrivateFieldGet||function(ee,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[41],ye([1,0,172,9,77,24,18,6,65,2,13,5,34,228,97,33,26,226,10,27,22,209,7,127,3,25,73,16,88,55,40,4,286,96,211,15,95]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h,b,o,r,c,u,i,s,n,l,p,k,L,B,K,G,O){"use strict";var U,F,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,c.createDecorator)("IHostUtils");let M=class Ln extends T.Disposable{constructor(ie,fe,J,pe,we,Ie,Re,ze,re,ue,de){super(),this.a=this.B(new k.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=fe,this.g=J,this.f=Re,this.j=pe,this.k=we,this.l=Ie,this.m=re,this.p=ue,this.s=de,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new D.Barrier,this.y=new D.Barrier,this.z=new D.Barrier,this.C=new D.Barrier,this.F=new m.ExtensionDescriptionRegistry(this.f.allExtensions);const Z=(0,g.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new m.ExtensionDescriptionRegistry(H(this.F,Z)),this.G=new v.ExtHostStorage(this.g,this.l),this.H=new B.ExtHostSecretState(this.g),this.I=ze,this.h=ie.createChild(new n.ServiceCollection([v.IExtHostStorage,this.G],[B.IExtHostSecretState,this.H]));const se=this.f.allExtensions.filter($=>!$.main&&!$.browser).map($=>$.identifier),ne=this.f.allExtensions.filter($=>!Z.has(f.ExtensionIdentifier.toKey($.identifier.value))).filter($=>($.main||$.browser)&&$.api==="none").map($=>$.identifier),N=(0,g.extensionIdentifiersArrayToSet)(ne);this.J=this.B(new y.ExtensionsActivator(this.D,se,ne,{onExtensionActivationError:($,x,_)=>{this.v.$onExtensionActivationError($,w.transformErrorForSerialization(x),_)},actualActivateExtension:async($,x)=>{if(N.has(f.ExtensionIdentifier.toKey($)))return await this.v.$activateExtension($,x),new y.HostExtension;const _=this.D.getExtensionDescription($);return this.Y(_,x)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(ie){w.onUnexpectedError(ie)}}async Q(){this.I.onWillDeactivateAll();let ie=[];try{ie=this.D.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.X(we))}catch{}await Promise.all(ie)}terminate(ie,fe=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${ie}`),this.l.flush(),this.p.dispose(),this.J.dispose(),w.setUnexpectedErrorHandler(pe=>{this.l.error(pe)}),this.g.dispose();const J=this.Q();Promise.race([(0,D.timeout)(5e3),J]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${fe}`):this.l.info(`Extension host exiting with code ${fe}`),this.l.flush(),this.l.dispose(),this.c.exit(fe)})}isActivated(ie){return this.z.isOpen()?this.J.isActivated(ie):!1}async getExtension(ie){const fe=await this.v.$getExtension(ie);let J;if(fe?.browserNlsBundleUris){J={};for(const pe of Object.keys(fe.browserNlsBundleUris))J[pe]=C.URI.revive(fe.browserNlsBundleUris[pe])}return fe&&{...fe,identifier:new f.ExtensionIdentifier(fe.identifier.value),extensionLocation:C.URI.revive(fe.extensionLocation),browserNlsBundleUris:J}}R(ie,fe){return this.J.activateByEvent(ie,fe)}S(ie,fe){return this.J.activateById(ie,fe)}activateByIdWithErrors(ie,fe){return this.S(ie,fe).then(()=>{const J=this.J.getActivatedExtension(ie);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ie=>this.D)}getExtensionExports(ie){return this.z.isOpen()?this.J.getActivatedExtension(ie).exports:null}async U(ie){if(ie.scheme!==G.Schemas.file)return ie;const fe=await this.c.realpath(ie.fsPath);return C.URI.file(fe)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(ie=>new Y(ie))),this.L}async W(ie){const fe=S.TernarySearchTree.forUris(J=>A.extUriBiasedIgnorePathCase.ignorePathCasing(J));return await Promise.all(ie.map(async J=>{if(this.ob(J)){const pe=await this.U(J.extensionLocation);fe.set(pe,J)}})),fe}X(ie){let fe=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(ie))return fe;const J=this.J.getActivatedExtension(ie);if(!J)return fe;try{typeof J.module.deactivate=="function"&&(fe=Promise.resolve(J.module.deactivate()).then(void 0,pe=>(this.l.error(pe),Promise.resolve(void 0))))}catch(pe){this.l.error(`An error occurred when deactivating the extension '${ie.value}':`),this.l.error(pe)}try{(0,T.dispose)(J.subscriptions)}catch(pe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.l.error(pe)}return fe}async Y(ie,fe){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ie.identifier):await this.v.$onWillActivateExtension(ie.identifier),this.ab(ie,fe).then(J=>{const pe=J.activationTimes;return this.v.$onDidActivateExtension(ie.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,fe),this.Z(ie,fe,"success",pe),J},J=>{throw this.Z(ie,fe,"failure"),J})}Z(ie,fe,J,pe){const we=V(ie,fe);this.u.$publicLog2("extensionActivationTimes",{...we,...pe||{},outcome:J})}ab(ie,fe){const J=V(ie,fe);this.u.$publicLog2("activatePlugin",J);const pe=this.ob(ie);if(!pe)return Promise.resolve(new y.EmptyExtension(y.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${ie.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this.l.flush();const we=new y.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this.pb(ie,(0,A.joinPath)(ie.extensionLocation,pe),we),this.bb(ie)]).then(Ie=>(I.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),Ln.cb(this.l,ie.identifier,Ie[0],Ie[1],we))).then(Ie=>(I.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),Ie))}bb(ie){const fe=new b.ExtensionGlobalMemento(ie,this.G),J=new b.ExtensionMemento(ie.identifier.value,!1,this.G),pe=new K.ExtensionSecrets(ie,this.H),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Ie=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([fe.whenReady,J.whenReady,this.I.whenReady]).then(()=>{const Re=this;let ze,re;const ue=(0,g.isProposedApiEnabled)(ie,"ipc")?this.f.messagePorts?.get(f.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:J,secrets:pe,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(de){return t.join(ie.extensionLocation.fsPath,de)},get storagePath(){return Re.I.workspaceValue(ie)?.fsPath},get globalStoragePath(){return Re.I.globalValue(ie).fsPath},get logPath(){return t.join(Re.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return C.URI.joinPath(Re.f.logsLocation,ie.identifier.value)},get storageUri(){return Re.I.workspaceValue(ie)},get globalStorageUri(){return Re.I.globalValue(ie)},get extensionMode(){return we},get extension(){return ze===void 0&&(ze=new q(Re,ie.identifier,ie,Ie,!1)),ze},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(ie,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!ue)return;const de=k.Event.buffer(k.Event.fromDOMEventEmitter(ue,"message",Z=>Z.data));ue.start(),re={onDidReceiveMessage:de,postMessage:ue.postMessage.bind(ue)}}return re}})})}static cb(ie,fe,J,pe,we){return J=J||{activate:void 0,deactivate:void 0},this.db(ie,fe,J,pe,we).then(Ie=>new y.ActivatedExtension(!1,null,we.build(),J,Ie,pe.subscriptions))}static db(ie,fe,J,pe,we){if(typeof J.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const Ie=typeof global=="object"?global:self,Re=J.activate.apply(Ie,[pe]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(Re).then(ze=>(we.activateResolveStop(),ze))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(J)}eb(ie,fe){this.S(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:fe}).then(void 0,J=>{this.l.error(J)})}fb(){this.v.$setPerformanceMarks(I.getMarks());for(const ie of this.D.getAllExtensionDescriptions())if(ie.activationEvents)for(const fe of ie.activationEvents)fe==="onStartupFinished"&&this.eb(ie,fe)}gb(){const ie=this.R("*",!0).then(void 0,we=>{this.l.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.hb(we.added)));const fe=this.j.workspace?this.j.workspace.folders:[],J=this.hb(fe),pe=Promise.all([ie,J]).then(()=>{});return Promise.race([pe,(0,D.timeout)(1e4)]).then(()=>{this.fb()}),pe}hb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(fe=>this.ib(ie,fe))).then(()=>{})}async ib(ie,fe){if(this.isActivated(fe.identifier))return;const J=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.l,folders:ie.map(Ie=>Ie.uri),forceUsingSearch:J,exists:Ie=>this.c.exists(Ie.fsPath),checkExists:(Ie,Re,ze)=>this.t.$checkExists(Ie,Re,ze)},we=await(0,L.checkActivateWorkspaceContainsExtension)(pe,fe);if(!!we)return this.S(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:we.activationEvent}).then(void 0,Ie=>this.l.error(Ie))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(ie){throw console.error(ie),ie}}async jb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:fe}=this.f.environment;if(!ie||!fe)throw new Error(a.localize(0,null));const J=await this.pb(null,fe,new y.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(a.localize(1,null,fe.toString()));return new Promise((pe,we)=>{const Ie=(re,ue)=>{re?we(re):pe(typeof ue=="number"&&ue>0?1:0)},Re=(0,A.originalFSPath)(fe),ze=J.run(Re,Ie);ze&&ze.then&&ze.then(()=>{pe(0)}).catch(re=>{we(re instanceof Error&&re.stack?re.stack:String(re))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,fe){return this.M[ie]=fe,(0,T.toDisposable)(()=>{delete this.M[ie]})}async lb(ie){const fe=ie.indexOf("+");if(fe===-1)throw new Error("Not an authority that can be resolved!");const J=ie.substr(0,fe);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this.M[J]}}async $resolveAuthority(ie,fe){this.l.info(`$resolveAuthority invoked for authority (${Q(ie)})`);const{authorityPrefix:J,resolver:pe}=await this.lb(ie);if(!pe)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(pe)),I.mark(`code/extHost/willResolveAuthority/${J}`);const we=await pe.resolve(ie,{resolveAttempt:fe});I.mark(`code/extHost/didResolveAuthorityOK/${J}`);const Ie={authority:ie,host:we.host,port:we.port,connectionToken:we.connectionToken},Re={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ie,options:Re,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(I.mark(`code/extHost/didResolveAuthorityError/${J}`),we instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(ie,fe){this.l.info(`$getCanonicalURI invoked for authority (${Q(ie)})`);const{resolver:J}=await this.lb(ie);if(!J)return null;const pe=C.URI.revive(fe);if(typeof J.getCanonicalURI>"u")return pe;const we=await(0,D.asPromise)(()=>J.getCanonicalURI(pe));return we||pe}static mb(ie,fe,J){const pe=new m.ExtensionDescriptionRegistry(ie.getAllExtensionDescriptions());pe.deltaExtensions(J.toAdd,J.toRemove);const we=(0,g.extensionIdentifiersArrayToSet)(fe.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of J.myToRemove)we.delete(f.ExtensionIdentifier.toKey(Re));for(const Re of J.myToAdd)we.add(f.ExtensionIdentifier.toKey(Re));const Ie=H(pe,we);return{globalRegistry:pe,myExtensions:Ie}}$startExtensionHost(ie){ie.toAdd.forEach(pe=>pe.extensionLocation=C.URI.revive(pe.extensionLocation));const{globalRegistry:fe,myExtensions:J}=Ln.mb(this.F,this.D,ie);return this.F.set(fe.getAllExtensionDescriptions()),this.D.set(J),this.kb()}$activateByEvent(ie,fe){return fe===1?this.R(ie,!1):this.z.wait().then(J=>this.R(ie,!1))}async $activate(ie,fe){return await this.z.wait(),this.D.getExtensionDescription(ie)?(await this.S(ie,fe),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(Ie=>Ie.extensionLocation=C.URI.revive(Ie.extensionLocation));const{globalRegistry:fe,myExtensions:J}=Ln.mb(this.F,this.D,ie),pe=await this.W(J);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.F.set(fe.getAllExtensionDescriptions()),this.D.set(J),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const fe=h.VSBuffer.alloc(ie),J=Math.random()%256;for(let pe=0;pe<ie;pe++)fe.writeUInt8(J,pe);return fe}async $updateRemoteConnectionData(ie){this.P=ie,this.a.fire()}};M=qe([We(0,c.IInstantiationService),We(1,e.IHostUtils),We(2,s.IExtHostRpcService),We(3,d.IExtHostWorkspace),We(4,E.IExtHostConfiguration),We(5,R.ILogService),We(6,u.IExtHostInitDataService),We(7,i.IExtensionStoragePaths),We(8,l.IExtHostTunnelService),We(9,p.IExtHostTerminalService),We(10,O.IExtHostLocalizationService)],M),e.AbstractExtHostExtensionService=M;function V(ce,ie){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}e.IExtHostExtensionService=(0,c.createDecorator)("IExtHostExtensionService");class q{constructor(ie,fe,J,pe,we){U.set(this,void 0),F.set(this,void 0),z.set(this,void 0),Je(this,U,ie,"f"),Je(this,F,fe,"f"),Je(this,z,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=pe,this.isFromDifferentExtensionHost=we}get isActive(){return Fe(this,U,"f").isActivated(Fe(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,U,"f").getExtensionExports(Fe(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,U,"f").activateByIdWithErrors(Fe(this,z,"f"),{startup:!1,extensionId:Fe(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=q,U=new WeakMap,F=new WeakMap,z=new WeakMap;function H(ce,ie){return ce.getAllExtensionDescriptions().filter(fe=>ie.has(f.ExtensionIdentifier.toKey(fe.identifier)))}function Q(ce){const ie=ce.indexOf("+");return ie===-1?ce:ce.substring(0,ie)}class Y{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.ExtensionPaths=Y}),define(Se[287],ye([1,0,77,2,5,34,26,27,16,25,3,41,35,13,8]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(b,o,r,c,u,i,s){this.c=b,this.d=o,this.e=r,this.f=c,this.g=u,this.h=i,this.i=s,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new m(this.c,o,this.d,b,this.i)),this.register(this.e.createInstance(w,o)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,o,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const o of b.nodeModuleName)this.a.set(o,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(o=>b.alternativeModuleName(o))}};d=qe([We(2,R.IInstantiationService),We(3,A.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,C.IExtHostInitDataService),We(6,y.ILogService)],d),e.RequireInterceptor=d;let g=class ei{constructor(b){if(b.environment.appRoot&&ei.a.size){const o=(0,v.escapeRegExpCharacters)(this.c(b.environment.appRoot.fsPath)),r="[a-z0-9_.-]",c=`@${r}+\\/${r}+|${r}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${u}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const o=this.b.exec(this.c(b));if(!o)return;const[,r,c,u]=o,i=ei.a.get(c);if(i!==void 0)return console.warn(`${c} as been renamed to ${i}, please update your imports`),r+i+u}c(b){return b.replace(/\\/g,"/")}};g.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=qe([We(0,C.IExtHostInitDataService)],g);class m{constructor(b,o,r,c,u){this.c=b,this.d=o,this.e=r,this.f=c,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(b,o){const r=this.d.findSubstr(o);if(r){let c=this.a.get(T.ExtensionIdentifier.toKey(r.identifier));return c||(c=this.c(r,this.e,this.f),this.a.set(T.ExtensionIdentifier.toKey(r.identifier),c)),c}if(!this.b){let c="";this.d.forEach((u,i)=>c+=`	${i} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${c}`),this.b=this.c(D.nullExtensionDescription,this.e,this.f)}return this.b}}let w=class{constructor(b,o,r){this.d=b,this.nodeModuleName="keytar",this.a=o.getProxy(I.MainContext.MainThreadTelemetry);const{environment:c}=r,u=o.getProxy(I.MainContext.MainThreadKeytar);if(c.appRoot){let i=c.appRoot.fsPath;E.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.b=new Set,this.b.add(`${i}/node_modules.asar/keytar`),this.b.add(`${i}/node_modules/keytar`)}this.c={getPassword:(i,s)=>u.$getPassword(i,s),setPassword:(i,s,n)=>u.$setPassword(i,s,n),deletePassword:(i,s)=>u.$deletePassword(i,s),findPassword:i=>u.$findPassword(i),findCredentials(i){return u.$findCredentials(i)}}}load(b,o){const r=this.d.findSubstr(o);return this.a.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(b){const o=b.length;if(o<=7||!this.b)return;const r=o-7;if((b.charAt(r)==="/"||b.charAt(r)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.b.has(b)))return"keytar"}};w=qe([We(1,S.IExtHostRpcService),We(2,C.IExtHostInitDataService)],w);let f=class{constructor(b,o,r){this.e=b,this.f=o,this.nodeModuleName=["open","opn"],this.d=r.getProxy(I.MainContext.MainThreadTelemetry);const c=r.getProxy(I.MainContext.MainThreadWindow);this.c=(u,i)=>{const s=t.URI.parse(u);return i?this.g(u,i):s.scheme==="http"||s.scheme==="https"?c.$openUri(s,u,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this.f?c.$openUri(s,u,{}):this.g(u,i)}}load(b,o,r){const c=this.e.findSubstr(o);return c&&(this.a=c.identifier.value,this.h()),this.b=r(b),this.c}g(b,o){return this.i(),this.b(b,o)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=qe([We(2,S.IExtHostRpcService)],f)}),define(Se[47],ye([1,0,82,6,9,35,3,59,60,41,7,33,223,34]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class v extends E.AbstractVariableResolverService{constructor(m,w,f,h,b,o,r){function c(){if(f){const u=f.activeEditor();if(u)return u.document.uri;const i=h.tabGroups.all.find(s=>s.isActive)?.activeTab;if(i!==void 0){if(i.input instanceof R.TextDiffTabInput||i.input instanceof R.NotebookDiffEditorTabInput)return i.input.modified;if(i.input instanceof R.TextTabInput||i.input instanceof R.NotebookEditorTabInput||i.input instanceof R.CustomEditorTabInput)return i.input.uri}}}super({getFolderUri:u=>{const i=o.folders.filter(s=>s.name===u);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(u,i)=>b.getConfiguration(void 0,u).get(i),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=c();if(u)return I.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const u=c();if(u){const i=w.getWorkspaceFolder(u);if(i)return I.normalize(i.uri.fsPath)}}},getSelectedText:()=>{if(f){const u=f.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(f){const u=f.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>m.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(A.env))}}let d=class extends t.Disposable{constructor(m,w,f,h,b){super(),this.b=m,this.c=w,this.g=f,this.h=h,this.i=b,this.a=new a.Lazy(async()=>{const o=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,o,c,this.j())})}getResolver(){return this.a.getValue()}j(){}};d=qe([We(0,C.IExtHostExtensionService),We(1,P.IExtHostWorkspace),We(2,T.IExtHostDocumentsAndEditors),We(3,y.IExtHostConfiguration),We(4,S.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Se[78],ye([1,0,18,4,12,2,3,5,60,41,16,7,33,131,215,34,47]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let m=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(c,u,i,s,n,l){this.D=u,this.E=i,this.F=s,this.G=n,this.H=l,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=c.getProxy(T.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new f(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(p=>{p.onDidChange(k=>{this.I(p)}),this.I(p)})}asDebugSourceUri(c,u){const i=c;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let s=`debug:${encodeURIComponent(i.path||"")}`,n="?";return u&&(s+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),s+=`${n}ref=${i.sourceReference}`,A.URI.parse(s)}else{if(i.path)return A.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(c){const u=[];for(const i of c.getAllExtensionDescriptions())if(i.contributes){const s=i.contributes.debuggers;if(s&&s.length>0)for(const n of s)(0,v.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const c=[];return this.w.forEach(u=>c.push(u)),c}addBreakpoints(c){this.T();const u=c.filter(n=>{const l=n.id;return this.w.has(l)?!1:(this.w.set(l,n),!0)});this.U(u,[],[]);const i=[],s=new Map;for(const n of u)if(n instanceof P.SourceBreakpoint){let l=s.get(n.location.uri.toString());l||(l={type:"sourceMulti",uri:n.location.uri,lines:[]},s.set(n.location.uri.toString(),l),i.push(l)),l.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&i.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(c){this.T();const u=c.filter(l=>this.w.delete(l.id));this.U([],u,[]);const i=u.filter(l=>l instanceof P.SourceBreakpoint).map(l=>l.id),s=u.filter(l=>l instanceof P.FunctionBreakpoint).map(l=>l.id),n=u.filter(l=>l instanceof P.DataBreakpoint).map(l=>l.id);return this.k.$unregisterBreakpoints(i,s,n)}startDebugging(c,u,i){return this.k.$startDebugging(c?c.uri:void 0,u,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(c){return this.k.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,u,i){if(!u)return new P.Disposable(()=>{});const s=this.d++;return this.f.push({type:c,handle:s,provider:u}),this.k.$registerDebugConfigurationProvider(c,i,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,s),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(s)})}registerDebugAdapterDescriptorFactory(c,u,i){if(!i)return new P.Disposable(()=>{});if(!this.P(c,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const s=this.g++;return this.h.push({type:u,handle:s,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(u,s),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(s)})}registerDebugAdapterTrackerFactory(c,u){if(!u)return new P.Disposable(()=>{});const i=this.i++;return this.j.push({type:c,handle:i,factory:u}),new P.Disposable(()=>{this.j=this.j.filter(s=>s.factory!==u)})}async $runInTerminal(c,u){return Promise.resolve(void 0)}async $substituteVariables(c,u){let i;const s=await this.W(c);return s&&(i={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(i,u)}J(c,u){if(c.type==="implementation")return new b(c.implementation)}K(){}async $startDASession(c,u){const i=this,s=await this.V(u);return this.R(this.M(s.type),s).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}' (extension might have failed to activate)`);const l=this.L(n),p=this.J(l,s);if(!p)throw new Error(`Couldn't create a debug adapter for type '${s.type}'.`);const k=p;return this.A.set(c,k),this.Q(s).then(L=>(L&&this.B.set(c,L),k.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const K=B,G={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const O=await this.C.sign(K.arguments.value);G.body={signature:O},k.sendResponse(G)}else throw new Error("no signer")}catch(O){G.success=!1,G.message=O.message,k.sendResponse(G)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(B),B=(0,v.convertToVSCPaths)(B,!0),i.k.$acceptDAMessage(c,B)}),k.onError(B=>{L&&L.onError&&L.onError(B),this.k.$acceptDAError(c,B.name,B.message,B.stack)}),k.onExit(B=>{L&&L.onExit&&L.onExit((0,I.withNullAsUndefined)(B),void 0),this.k.$acceptDAExit(c,(0,I.withNullAsUndefined)(B),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),k.startSession()))})}$sendDAMessage(c,u){u=(0,v.convertToDAPaths)(u,!1);const i=this.B.get(c);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(u),this.A.get(c)?.sendMessage(u)}$stopDASession(c){const u=this.B.get(c);this.B.delete(c),u&&u.onWillStopSession&&u.onWillStopSession();const i=this.A.get(c);return this.A.delete(c),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const u=[],i=[],s=[];if(c.added)for(const n of c.added){const l=n.id;if(l&&!this.w.has(l)){let p;if(n.type==="function")p=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const k=A.URI.revive(n.uri);p=new P.SourceBreakpoint(new P.Location(k,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=l,this.w.set(l,p),u.push(p)}}if(c.removed)for(const n of c.removed){const l=this.w.get(n);l&&(this.w.delete(n),i.push(l))}if(c.changed){for(const n of c.changed)if(n.id){const l=this.w.get(n.id);if(l){if(l instanceof P.FunctionBreakpoint&&n.type==="function"){const p=l;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(l instanceof P.SourceBreakpoint&&n.type==="source"){const p=l;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new P.Location(A.URI.revive(n.uri),new P.Position(n.line,n.character))}s.push(l)}}}this.U(u,i,s)}$provideDebugConfigurations(c,u,i){return(0,a.asPromise)(async()=>{const s=this.O(c);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(u);return s.provideDebugConfigurations(n,i)}).then(s=>{if(!s)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return s})}$resolveDebugConfiguration(c,u,i,s){return(0,a.asPromise)(async()=>{const n=this.O(c);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.W(u);return n.resolveDebugConfiguration(l,i,s)})}$resolveDebugConfigurationWithSubstitutedVariables(c,u,i,s){return(0,a.asPromise)(async()=>{const n=this.O(c);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.W(u);return n.resolveDebugConfigurationWithSubstitutedVariables(l,i,s)})}async $provideDebugAdapter(c,u){const i=this.N(c);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const s=await this.V(u);return this.R(i,s).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(c){const u=await this.V(c);this.m.fire(u)}async $acceptDebugSessionTerminated(c){const u=await this.V(c);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(c){this.q=c?await this.V(c):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(c,u){(await this.V(c))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(c,u){const s={session:await this.V(c),event:u.event,body:u.body};this.u.fire(s)}L(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}M(c){const u=this.h.filter(i=>i.type===c);if(u.length>0)return u[0].factory}N(c){const u=this.h.filter(i=>i.handle===c);if(u.length>0)return u[0].factory}O(c){const u=this.f.filter(i=>i.handle===c);if(u.length>0)return u[0].provider}P(c,u){if(c.contributes){const i=c.contributes.debuggers;if(i&&i.length>0){for(const s of i)if(s.label&&s.type&&s.type===u)return!0}}return!1}Q(c){const i=c.configuration.type,s=this.j.filter(n=>n.type===i||n.type==="*").map(n=>(0,a.asPromise)(()=>n.factory.createDebugAdapterTracker(c)).then(l=>l,l=>null));return Promise.race([Promise.all(s).then(n=>{const l=n.filter(p=>!!p);if(l.length>0)return new h(l)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(c,u){const i=u.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new P.DebugAdapterServer(i));if(c){const n=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>c.createDebugAdapterDescriptor(u,this.S(u,n))).then(l=>{if(l)return l})}const s=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,s))}S(c,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(c,u,i){(c.length>0||u.length>0||i.length>0)&&this.z.fire(Object.freeze({added:c,removed:u,changed:i}))}async V(c){if(c)if(typeof c=="string"){const u=this.l.get(c);if(u)return u}else{let u=this.l.get(c.id);if(!u){const i=await this.W(c.folderUri),s=c.parent?this.l.get(c.parent):void 0;u=new w(this.k,c.id,c.type,c.name,i,c.configuration,s),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(c){if(c){const u=A.URI.revive(c);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};m=qe([We(0,R.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,g.IExtHostVariableResolverProvider)],m),e.ExtHostDebugServiceBase=m;class w{constructor(c,u,i,s,n,l,p){this.d=c,this.f=u,this.g=i,this.h=s,this.i=n,this.j=l,this.k=p}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(c){this.h=c,this.d.$setDebugSessionName(this.f,c)}get parentSession(){return this.k}_acceptNameChanged(c){this.h=c}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(c,u){return this.d.$customDebugAdapterRequest(this.f,c,u)}getDebugProtocolBreakpoint(c){return this.d.$getDebugProtocolBreakpoint(this.f,c.id)}}e.ExtHostDebugSession=w;class f{constructor(c){this.value=Object.freeze({append(u){c.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=f;class h{constructor(c){this.d=c}onWillStartSession(){this.d.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(c):void 0)}onWillStopSession(){this.d.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.d.forEach(u=>u.onError?u.onError(c):void 0)}onExit(c,u){this.d.forEach(i=>i.onExit?i.onExit(c,u):void 0)}}class b extends y.AbstractDebugAdapter{constructor(c){super(),this.h=c,c.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.h.handleMessage(c)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let o=class extends m{constructor(c,u,i,s,n,l){super(c,u,i,s,n,l)}};o=qe([We(0,R.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,g.IExtHostVariableResolverProvider)],o),e.WorkerExtHostDebugService=o}),define(Se[288],ye([1,0,10,77,2,5,280,13,87,88,25,195,16,56,41,94]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{static async installEarlyHandler(f){const h=f.get(T.ILogService),o=f.get(E.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(r=>{h.error(r);const c=a.transformErrorForSerialization(r);o.$onUnexpectedError(c)})}static async installFullHandler(f){const h=f.get(T.ILogService),b=f.get(E.IExtHostRpcService),o=f.get(v.IExtHostExtensionService),r=f.get(d.IExtHostTelemetry),c=b.getProxy(A.MainContext.MainThreadExtensionService),u=b.getProxy(A.MainContext.MainThreadErrors),i=await o.getExtensionPathIndex(),s=new WeakMap;Error.prepareStackTrace=(n,l)=>{let p="",k,L;for(const B of l)p+=`
	at ${B.toString()}`,L=B.getFileName(),!k&&L&&(k=i.findSubstr(I.URI.file(L)));return s.set(n,k?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},a.setUnexpectedErrorHandler(n=>{h.error(n);const l=a.transformErrorForSerialization(n),p=s.get(n);if(!p){u.$onUnexpectedError(l);return}c.$onExtensionRuntimeError(p,l);const k=r.onExtensionError(p,n);h.trace("forwarded error to extension?",k,p)})}}Error.stackTraceLimit=100;class m{constructor(f,h,b,o,r){this.a=b,this.b=new D.RPCProtocol(f,null,o),h=m.e(h,this.b);const c=new C.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());c.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...h,messagePorts:r}),c.set(E.IExtHostRpcService,new E.ExtHostRpcService(this.b)),c.set(y.IURITransformerService,new y.URITransformerService(o)),c.set(v.IHostUtils,b);const u=new P.InstantiationService(c,!0);u.invokeFunction(g.installEarlyHandler),this.d=u.invokeFunction(i=>i.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",h),this.c=u.invokeFunction(i=>i.get(v.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(g.installFullHandler)}async asBrowserUri(f){const h=this.b.getProxy(A.MainContext.MainThreadExtensionService);return I.URI.revive(await h.$asBrowserUri(f))}terminate(f){this.c.terminate(f)}static e(f,h){f.allExtensions.forEach(o=>{o.extensionLocation=I.URI.revive(h.transformIncomingURIs(o.extensionLocation));const r={};o.browserNlsBundleUris&&(Object.keys(o.browserNlsBundleUris).forEach(c=>r[c]=I.URI.revive(h.transformIncomingURIs(o.browserNlsBundleUris[c]))),o.browserNlsBundleUris=r)}),f.environment.appRoot=I.URI.revive(h.transformIncomingURIs(f.environment.appRoot));const b=f.environment.extensionDevelopmentLocationURI;return b&&(f.environment.extensionDevelopmentLocationURI=b.map(o=>I.URI.revive(h.transformIncomingURIs(o)))),f.environment.extensionTestsLocationURI=I.URI.revive(h.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=I.URI.revive(h.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=I.URI.revive(h.transformIncomingURIs(f.environment.workspaceStorageHome)),f.environment.extensionTelemetryLogResource=I.URI.revive(h.transformIncomingURIs(f.environment.extensionTelemetryLogResource)),f.nlsBaseUrl=I.URI.revive(h.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=I.URI.revive(h.transformIncomingURIs(f.logsLocation)),f.logFile=I.URI.revive(h.transformIncomingURIs(f.logFile)),f.workspace=h.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=m}),define(Se[289],ye([1,0,18,11,178,194,202,78,60,41,16,40,7,47,33,216,218,34]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends T.ExtHostDebugServiceBase{constructor(r,c,u,i,s,n,l){super(r,c,u,i,n,l),this.Z=s,this.X=new b}J(r,c){switch(r.type){case"server":return new d.SocketDebugAdapter(r);case"pipeServer":return new d.NamedPipeDebugAdapter(r);case"executable":return new d.ExecutableDebugAdapter(r,c.type)}return super.J(r,c)}S(r,c){const u=d.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),r.type);if(u)return new E.DebugAdapterExecutable(u.command,u.args,u.options)}K(){return new D.SignService}async $runInTerminal(r,c){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(O=>{this.X.onTerminalClosed(O)}));const u=await this.F.getConfigProvider(),i=this.Z.getDefaultShell(!0),s=this.Z.getDefaultShellArgs(!0),n=r.title||I.localize(0,null),l=JSON.stringify({shell:i,shellArgs:s});let p=await this.X.checkout(l,n),k,L=!1;if(p)k=r.cwd;else{const O={shellPath:i,shellArgs:s,cwd:r.cwd,name:n,iconPath:new E.ThemeIcon("debug")};L=!0,p=this.Z.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(p,l)}p.show(!0);const B=await p.processId;L?await new Promise(O=>setTimeout(O,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?p.sendText("cls"):i.indexOf("bash")>=0?p.sendText("clear"):t.isWindows?p.sendText("cls"):p.sendText("clear"));const K=(0,g.prepareCommand)(i,r.args,!!r.argsCanBeInterpretedByShell,k,r.env);p.sendText(K);const G=this.onDidTerminateDebugSession(O=>{O.id===c&&(this.X.free(p),G.dispose())});return B}else if(r.kind==="external")return h(r,await this.F.getConfigProvider());return super.$runInTerminal(r,c)}};w=qe([We(0,R.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,P.IExtHostTerminalService),We(5,S.IExtHostEditorTabs),We(6,y.IExtHostVariableResolverProvider)],w),e.ExtHostDebugService=w;let f;function h(o,r){if(!f)if(t.isWindows)f=new A.WindowsExternalTerminalService;else if(t.isMacintosh)f=new A.MacExternalTerminalService;else if(t.isLinux)f=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=r.getConfiguration("terminal");return f.runInTerminal(o.title,o.cwd,o.args,o.env||{},c.external||{})}class b{constructor(){this.b=new Map}async checkout(r,c){const i=[...this.b.entries()].map(([s,n])=>(0,a.createCancelablePromise)(async l=>{if(s.name!==c||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await s.processId))return null;const p=Date.now();return n.lastUsedAt+b.a>p||l.isCancellationRequested||n.config!==r?null:(n.lastUsedAt=p,s)}));return await(0,a.firstParallel)(i,s=>!!s)}insert(r,c){this.b.set(r,{lastUsedAt:Date.now(),config:c})}free(r){const c=this.b.get(r);c&&(c.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}b.a=1e3}),define(Se[290],ye([1,0,9,2,111,33,59,34,45,40,16,25,76,15,13,71,24,66,47]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends E.ExtHostTaskBase{constructor(b,o,r,c,u,i,s,n,l){super(b,o,r,c,u,i,s,n),this.B=r,this.C=l,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,o){const r=o;if(!o.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const c=E.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(c);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.y(u,o);return this.a.$executeTask(c).catch(()=>{}),i}else{const c=E.TaskDTO.from(o,b);if(c===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(c.execution)&&await this.x(c,o,!1);const u=await this.y(await this.a.$getTaskExecution(c),o);return this.a.$executeTask(c).catch(()=>{}),u}}u(b,o,r,c){const u=[];if(c)for(const i of c){this.z(i,r),(!i.definition||!b[i.definition.type])&&this.f.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const s=E.TaskDTO.from(i,r.extension);s&&(u.push(s),E.CustomExecutionDTO.is(s.execution)&&o.push(this.x(s,i,!0)))}return{tasks:u,extension:r.extension}}async v(b){return b}async F(b){let o=b&&b.length>0?b[0]:void 0;if(!o){const r=t.URI.file((0,m.homedir)());o=new S.WorkspaceFolder({uri:r,name:g.basename(r),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,o){const r=t.URI.revive(b),c={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),i=await this.b.getWorkspaceFolders2()??[],s=await this.C.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(i);for(const l of o.variables)c.variables[l]=await s.resolveAsync(n,l);if(o.process!==void 0){let l;if(o.process.path!==void 0){l=o.process.path.split(a.delimiter);for(let p=0;p<l.length;p++)l[p]=await s.resolveAsync(n,l[p])}c.process=await I.win32.findExecutable(await s.resolveAsync(n,o.process.name),o.process.cwd!==void 0?await s.resolveAsync(n,o.process.cwd):void 0,l)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(b,o,r){return I.win32.findExecutable(b,o,r)}};f=qe([We(0,R.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,C.IExtHostTerminalService),We(6,v.ILogService),We(7,d.IExtHostApiDeprecationService),We(8,w.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(Se[291],ye([1,0,66,47]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class I extends t.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=I}),define(Se[142],ye([1,0,17,18,21,52,15,9,24,2,31]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(w,f,h,b){this.d=w,this.e=f,this.f=h,this.g=b,this.a=null,this.b=!1,this.c=0}search(w,f){const h=this.d.folderQueries||[],b=new I.CancellationTokenSource;return f.onCancellationRequested(()=>b.cancel()),new Promise((o,r)=>{this.a=new y(w);let c=!1;const u=(i,s)=>{if(!c&&!this.b){const n=this.h(i);d(i)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,c=!0,b.cancel(),i=this.j(i,this.d.maxResults-this.c));const l=this.h(i);this.c+=l,(l>0||!d(i))&&this.a.add(i,s)}};Promise.all(h.map((i,s)=>this.k(i,n=>u(n,s),b.token))).then(i=>{b.dispose(),this.a.flush();const s=i.some(n=>!!n&&!!n.limitHit);o({limitHit:this.b||s,messages:(0,a.flatten)(i.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},i=>{b.dispose();const s=(0,A.toErrorMessage)(i);r(new Error(s))})})}h(w){return d(w)?Array.isArray(w.ranges)?w.ranges.length:1:0}j(w,f){const h=Array.isArray(w.ranges)?w.ranges:[w.ranges],b=Array.isArray(w.preview.matches)?w.preview.matches:[w.preview.matches];return{ranges:h.slice(0,f),preview:{matches:b.slice(0,f),text:w.preview.text},uri:w.uri}}async k(w,f,h){const b=new R.QueryGlobTester(this.d,w),o=[],r={report:i=>{if(!this.l(i))return;const s=w.folder.scheme===D.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(i.uri))):void 0,n=S.relativePath(w.folder,i.uri);if(n){const l=b.includedInQuery(n,T.basename(n),s);(0,t.isThenable)(l)?o.push(l.then(p=>{p&&f(i)})):l&&f(i)}}},c=this.n(w),u=await this.e.provideTextSearchResults(E(this.d.contentPattern),c,r,h);return o.length&&await Promise.all(o),u}l(w){if(d(w)){if(Array.isArray(w.ranges)){if(!Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(w.preview.matches.length!==w.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(w){const f=(0,R.resolvePatternsForProvider)(this.d.includePattern,w.includePattern),h=(0,R.resolvePatternsForProvider)(this.d.excludePattern,w.excludePattern),b={folder:C.URI.from(w.folder),excludes:h,includes:f,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,encoding:w.fileEncoding&&this.f.toCanonicalName(w.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.TextSearchManager=P;function E(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class y{constructor(w){this.e=w,this.b=-1,this.d=null,this.a=new g(512,f=>this.g(f))}add(w,f){this.d&&(this.b!==f||!S.isEqual(this.c,w.uri))&&(this.f(),this.d=null),this.d||(this.b=f,this.d={resource:w.uri,results:[]}),this.d.results.push(v(w))}f(){const w=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,w)}flush(){this.f(),this.a.flush()}g(w){this.e(w)}}e.TextSearchResultsCollector=y;function v(m){return d(m)?{preview:{matches:(0,a.mapArrayOrNot)(m.preview.matches,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character})),text:m.preview.text},ranges:(0,a.mapArrayOrNot)(m.ranges,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function d(m){return!!m.preview}e.extensionResultIsMatch=d;class g{constructor(w,f){this.g=w,this.h=f,this.c=0,this.d=[],this.e=0}addItem(w,f){!w||this.j(w,f)}addItems(w,f){!w||this.k(w,f)}j(w,f){this.d.push(w),this.e+=f,this.l()}k(w,f){this.d=this.d.concat(w),this.e+=f,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=g,g.a=4e3,g.b=50}),define(Se[79],ye([1,0,6,5,3,284,16,56,13,2,142]),function(ee,e,a,t,I,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let P=class{constructor(d,g,m){this.k=d,this.l=g,this.n=m,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,g){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const m=this.d++;return this.e.set(m,g),this.c.$registerTextSearchProvider(m,this.o(d)),(0,a.toDisposable)(()=>{this.g.delete(d),this.e.delete(m),this.c.$unregisterProvider(m)})}registerFileSearchProvider(d,g){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const m=this.d++;return this.h.set(m,g),this.c.$registerFileSearchProvider(m,this.o(d)),(0,a.toDisposable)(()=>{this.i.delete(d),this.h.delete(m),this.c.$unregisterProvider(m)})}$provideFileSearchResults(d,g,m,w){const f=E(m),h=this.h.get(d);if(h)return this.j.fileSearch(f,h,b=>{this.c.$handleFileMatch(d,g,b.map(o=>o.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,g,m,w){const f=this.e.get(d);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const h=E(m);return this.q(h,f).search(o=>this.c.$handleTextMatch(d,g,o),w)}$enableExtensionHostSearch(){}q(d,g){return new R.TextSearchManager(d,g,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m},"textSearchProvider")}};P=qe([We(0,D.IExtHostRpcService),We(1,T.IURITransformerService),We(2,S.ILogService)],P),e.ExtHostSearch=P;function E(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(y),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>C.URI.revive(d))}}e.reviveQuery=E;function y(v){return{...v,folder:C.URI.revive(v.folder)}}}),define(Se[292],ye([1,0,87,141,33,138,34,39,59,40,76,78,79,97,55,71,140,72,46,96,94,60,139,13,229,47,95]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h,b,o,r,c,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(i.IExtHostLocalizationService,i.ExtHostLocalizationService,1),(0,a.registerSingleton)(r.ILoggerService,o.ExtHostLoggerService,1),(0,a.registerSingleton)(r.ILogService,c.ExtHostLogService,1),(0,a.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,a.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration,0),(0,a.registerSingleton)(m.IExtHostConsumerFileSystem,m.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,a.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,a.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,a.registerSingleton)(y.IExtHostStorage,y.ExtHostStorage,0),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,a.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,a.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow,0),(0,a.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,a.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState,0),(0,a.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry,0),(0,a.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,0),(0,a.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Se[98],ye([1,0,17,13,31,75]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=D;function T(P,E,y,v){const d=(0,a.mapArrayOrNot)(y,S),g=new I.TextSearchMatch(E,d,v),m=g.preview.matches;return{ranges:(0,a.mapArrayOrNot)(d,C),uri:P,preview:{text:g.preview.text,matches:(0,a.mapArrayOrNot)(m,C)}}}e.createTextSearchResult=T;function S(P){return new I.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function C(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(E,y){this.a=E,this.b=y}appendLine(E){this.b.debug(`${this.a}#search`,E)}};R=qe([We(1,t.ILogService)],R),e.OutputChannel=R}),define(Se[293],ye([1,0,44,9,83,32,11,8,98,294]),function(ee,e,a,t,I,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(f,h,b,o){const r=E(f,h,b,o),c=h.folder.fsPath;return{cmd:a.spawn(R,r.args,{cwd:c}),rgDiskPath:R,siblingClauses:r.siblingClauses,rgArgs:r,cwd:c}}e.spawnRipgrepCmd=P;function E(f,h,b,o){const r=["--files","--hidden","--case-sensitive"];v([h],b,!1).forEach(u=>{const i=(0,S.anchorGlob)(u);if(r.push("-g",i),D.isMacintosh){const s=(0,I.normalizeNFD)(i);s!==i&&r.push("-g",s)}});const c=y([h],o,void 0,!1);return c.globArgs.forEach(u=>{const i=`!${(0,S.anchorGlob)(u)}`;if(r.push("-g",i),D.isMacintosh){const s=(0,I.normalizeNFD)(i);s!==i&&r.push("-g",s)}}),h.disregardIgnoreFiles!==!1?r.push("--no-ignore"):h.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),h.ignoreSymlinks||r.push("--follow"),f.exists&&r.push("--quiet"),r.push("--no-config"),h.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:c.siblingClauses}}function y(f,h,b,o=!0){const r=[];let c={};return f.forEach(u=>{const i=Object.assign({},u.excludePattern||{},h||{}),s=d(i,o?u.folder.fsPath:void 0,b);r.push(...s.globArgs),s.siblingClauses&&(c=Object.assign(c,s.siblingClauses))}),{globArgs:r,siblingClauses:c}}e.foldersToRgExcludeGlobs=y;function v(f,h,b=!0){const o=[];return f.forEach(r=>{const c=Object.assign({},h||{},r.includePattern||{}),u=d(c,b?r.folder.fsPath:void 0);o.push(...u.globArgs)}),o}e.foldersToIncludeGlobs=v;function d(f,h,b){const o=[],r={};return Object.keys(f).forEach(c=>{if(b&&b.has(c)||!c)return;const u=f[c];c=m(h?g(h,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof u=="boolean"&&u?(c.startsWith("\\\\")&&(c+="**"),o.push(w(c))):u&&u.when&&(r[c]=u)}),{globArgs:o,siblingClauses:r}}function g(f,h){return t.isAbsolute(h)?h:t.join(f,h)}e.getAbsoluteGlob=g;function m(f){return f=T.rtrim(f,"\\"),T.rtrim(f,"/")}function w(f){return A.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=w}),define(Se[295],ye([1,0,44,50,9,296,17,52,36,83,32,11,49,8,12,29,31,293,106]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(c=>c())});class h{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&S.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,w.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&S.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(i=>{const s=Object.assign({},i.excludePattern||{},this.a.excludePattern||{}),n=i.folder.fsPath;u.folderQueries.map(l=>l.folder.fsPath).filter(l=>l!==n).forEach(l=>{(0,R.isEqualOrParent)(l,n)&&(s[I.relative(n,l)]=!0)}),this.t.set(n,new o(s,n))})}cancel(){this.l=!0,f.forEach(u=>u())}walk(u,i,s,n,l){if(this.m=E.StopWatch.create(!1),this.l)return l(null,this.j);i.forEach(p=>{const k=I.basename(p.fsPath);this.u&&this.u(p.fsPath,k)||this.J(s,{relativePath:p.fsPath,searchPath:void 0})}),this.r=E.StopWatch.create(!1),this.w(u,(p,k)=>{this.x(this.y,this,p,s,n,L=>{if(L){const B=(0,T.toErrorMessage)(L);console.error(B),this.q.push(B),k(L,void 0)}else k(null,void 0)})},(p,k)=>{this.m.stop();const L=p?D.coalesce(p)[0]:null;l(L,this.j)})}w(u,i,s){const n=new Array(u.length),l=new Array(u.length);let p=!1,k=0;if(u.length===0)return s(null,[]);u.forEach((L,B)=>{i(L,(K,G)=>{if(K?(p=!0,n[B]=null,l[B]=K):(n[B]=G,l[B]=null),++k===u.length)return s(p?l:null,n)})})}x(u,i,...s){try{u.apply(i,s)}catch(n){s[s.length-1](n)}}y(u,i,s,n){const l=u.folder.fsPath,p=P.isMacintosh,k=()=>O&&O.kill();f.add(k);let L=M=>{f.delete(k),L=()=>{},n(M)},B="";const K=this.D(),G=(0,m.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),O=G.cmd,U=!Object.keys(G.siblingClauses).length,F=G.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let z=`${G.rgDiskPath} ${F}
 - cwd: ${G.cwd}`;G.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(G.rgArgs.siblingClauses)}`),s({message:z}),this.s=0,this.z(O,"utf8",s,(M,V,q)=>{if(M){L(M);return}if(this.j){L();return}const Q=(B+(p?C.normalizeNFC(V||""):V)).split(`
`);if(q){const Y=Q.length;Q[Y-1]=Q[Y-1].trim(),Q[Y-1]||Q.pop()}else B=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.s+=Q.length,U){for(const Y of Q)if(this.J(i,{base:l,relativePath:Y,searchPath:this.N(u,Y)}),this.j){k();break}(q||this.j)&&L();return}this.G(u,K,l,Q,i),q&&(this.H(K,l,i),L())})}spawnFindCmd(u){const i=this.t.get(u.folder.fsPath),s=i.getBasenameTerms(),n=i.getPathTerms(),l=["-L","."];if(s.length||n.length){l.push("-not","(","(");for(const p of s)l.push("-name",p),l.push("-o");for(const p of n)l.push("-path",p),l.push("-o");l.pop(),l.push(")","-prune",")")}return l.push("-type","f"),a.spawn("find",l,{cwd:u.folder.fsPath})}readStdout(u,i,s){let n="";this.z(u,i,()=>{},(l,p,k)=>{if(l){s(l);return}n+=p,k&&s(null,n)})}z(u,i,s,n){let l=(L,B,K)=>{(L||K)&&(l=()=>{},this.r?.stop()),n(L,B,K)},p=!1;u.stdout?(this.A(u.stdout,i,l),u.stdout.once("data",()=>p=!0)):s({message:"stdout is null"});let k;u.stderr?k=this.B(u.stderr):s({message:"stderr is null"}),u.on("error",L=>{l(L)}),u.on("close",L=>{let B;!p&&(B=this.C(k,i))&&r(B)?l(new Error(`command failed with error code ${L}: ${this.C(k,i)}`)):(this.g&&L===0&&(this.j=!0),l(null,"",!0))})}A(u,i,s){const n=new A.StringDecoder(i);return u.on("data",l=>{s(null,n.write(l))}),n}B(u){const i=[];return u.on("data",s=>{i.push(s)}),i}C(u,i){const s=new A.StringDecoder(i);return u.map(n=>s.write(n)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:i},s,n,l){n.indexOf(this.b)!==-1&&this.J(l,{base:s,relativePath:this.b,searchPath:this.N(u,this.b)});const p=k=>{const L=I.basename(k),B=I.dirname(k);let K=i[B];K||(K=i[B]=[],p(B)),K.push({base:s,relativePath:k,basename:L,searchPath:this.N(u,k)})};n.forEach(p)}H({rootEntries:u,pathToEntries:i},s,n){const l=this,p=this.t.get(s),k=this.b;function L(B){l.o++;const K=(0,g.hasSiblingFn)(()=>B.map(G=>G.basename));for(let G=0,O=B.length;G<O;G++){const U=B[G],{relativePath:F,basename:z}=U;if(p.test(F,z,k!==z?K:void 0))continue;const M=i[F];if(M)L(M);else{if(l.p++,F===k)continue;l.J(n,U)}if(l.j)break}}L(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,i,s,n,l){const p=u.folder,k=(0,g.hasSiblingFn)(()=>s);this.w(s,(L,B)=>{if(this.l||this.j)return B(null);const K=i?[i,L].join(I.sep):L;if(this.t.get(u.folder.fsPath).test(K,L,this.a.filePattern!==L?k:void 0))return B(null);const G=[p.fsPath,K].join(I.sep);t.lstat(G,(O,U)=>{if(O||this.l||this.j)return B(null);this.L(G,U,(F,z)=>F||this.l||this.j?B(null):z.isDirectory()?(this.o++,this.M(G,U,(M,V)=>M||this.l||this.j||(V=V||"",this.v[V])?B(null):(this.v[V]=!0,d.Promises.readdir(G).then(q=>{if(this.l||this.j)return B(null);this.I(u,K,q,n,H=>B(H||null))},q=>{B(null)})))):(this.p++,K===this.b||this.h&&v.isNumber(z.size)&&z.size>this.h||this.J(n,{base:p.fsPath,relativePath:K,searchPath:this.N(u,K)}),B(null,void 0)))})},L=>{const B=L&&D.coalesce(L);return l(B&&B.length>0?B[0]:void 0)})}J(u,i){this.K(i)&&(!this.d||this.d(i.relativePath,I.basename(i.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(i))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.isFilePatternMatch)(u,this.c)}return!0}L(u,i,s){return i.isSymbolicLink()?t.stat(u,s):s(null,i)}M(u,i,s){return i.isSymbolicLink()?t.realpath(u,(n,l)=>n?s(n):s(null,l)):s(null,u)}N(u,i){return u.folderName?I.join(u.folderName,i):i}}e.FileWalker=h;class b{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new h(u)}search(u,i,s){this.c.walk(this.a,this.b,u,i,(n,l)=>{s(n,{limitHit:l,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=b;class o{constructor(u,i){this.expression=u,this.c=i,this.d(u)}d(u){let i,s;Object.keys(u).filter(n=>u[n]).forEach(n=>{I.isAbsolute(n)?(i=i||S.getEmptyExpression(),i[n]=u[n]):(s=s||S.getEmptyExpression(),s[n]=u[n])}),this.a=i&&S.parse(i,{trimForExclusions:!0}),this.b=s&&S.parse(s,{trimForExclusions:!0})}test(u,i,s){return this.b&&this.b(u,i,s)||this.a&&this.a(I.join(this.c,u),i,s)}getBasenameTerms(){const u=[];return this.a&&u.push(...S.getBasenameTerms(this.a)),this.b&&u.push(...S.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...S.getPathTerms(this.a)),this.b&&u.push(...S.getPathTerms(this.b)),u}}function r(c){const u=c.trim().split(`
`),i=u[0].trim();if(i.startsWith("Error parsing regex"))return i;if(i.startsWith("regex parse error"))return y.uppercaseFirstLetter(u[u.length-1].trim());if(i.startsWith("error parsing glob")||i.startsWith("unsupported encoding"))return i.charAt(0).toUpperCase()+i.substr(1);if(i==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(i.startsWith("Literal "))return i}e.rgErrorMsgForDisplay=r}),define(Se[297],ye([1,0,102,22]),function(ee,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(c){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===c)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,D=512,T=512*8,S=512*128;var C;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(u,i){super(u),this.decodeStreamErrorKind=i}}e.DecodeStreamError=R;class P{static async create(u){let i;if(u!==e.UTF8)i=(await new Promise((n,l)=>{ee(["@vscode/iconv-lite-umd"],n,l)})).getDecoder(d(u));else{const s=new TextDecoder;i={write(n){return s.decode(n,{stream:!0})},end(){return s.decode()}}}return new P(i)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function E(c,u){const i=u.minBytesRequiredForDetection??u.guessEncoding?T:D;return new Promise((s,n)=>{const l=(0,a.newWriteableStream)(G=>G.join("")),p=[];let k=0,L,B;const K=async()=>{try{const G=await r({buffer:t.VSBuffer.concat(p),bytesRead:k},u.guessEncoding);if(G.seemsBinary&&u.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);G.encoding=await u.overwriteEncoding(G.encoding),L=await P.create(G.encoding);const O=L.write(t.VSBuffer.concat(p).buffer);l.write(O),p.length=0,k=0,s({stream:l,detected:G})}catch(G){B?.dispose(),l.destroy(),n(G)}};B=(0,a.listenStream)(c,{onData:async G=>{L?l.write(L.write(G.buffer)):(p.push(G),k+=G.byteLength,k>=i&&(c.pause(),await K(),setTimeout(()=>c.resume())))},onError:G=>l.error(G),onEnd:async()=>{L||await K(),l.end(L?.end())}})})}e.toDecodeStream=E;async function y(c,u,i){const n=(await new Promise((k,L)=>{ee(["@vscode/iconv-lite-umd"],k,L)})).getEncoder(d(u),i);let l=!1,p=!1;return{read(){if(p)return null;const k=c.read();if(typeof k!="string"){if(p=!0,!l&&i?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=n.end();return L&&L.length>0?(l=!0,t.VSBuffer.wrap(L)):null}return l=!0,t.VSBuffer.wrap(n.write(k))}}}e.toEncodeReadable=y;async function v(c){return(await new Promise((i,s)=>{ee(["@vscode/iconv-lite-umd"],i,s)})).encodingExists(d(c))}e.encodingExists=v;function d(c){return c===e.UTF8_with_bom||c===null?e.UTF8:c}e.toNodeEncoding=d;function g(c,u){if(!c||u<e.UTF16be_BOM.length)return null;const i=c.readUInt8(0),s=c.readUInt8(1);if(i===e.UTF16be_BOM[0]&&s===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&s===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=c.readUInt8(2);return i===e.UTF8_BOM[0]&&s===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const m=["ascii","utf-16","utf-32"];async function w(c){const u=await new Promise((p,k)=>{ee(["jschardet"],p,k)}),i=c.slice(0,S),s=b(i.buffer),n=u.detect(s);if(!n||!n.encoding)return null;const l=n.encoding.toLowerCase();return 0<=m.indexOf(l)?null:h(n.encoding)}const f={ibm866:"cp866",big5:"cp950"};function h(c){const u=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[u]||u}function b(c){let u="";for(let i=0;i<c.length;i++)u+=String.fromCharCode(c[i]);return u}function o(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=c.match(/windows(\d+)/);return u?"windows-"+u[1]:c}}}e.toCanonicalName=o;function r({buffer:c,bytesRead:u},i){let s=g(c,u),n=!1;if(s!==e.UTF16be&&s!==e.UTF16le&&c){let l=!0,p=!0,k=!1;for(let L=0;L<u&&L<A;L++){const B=L%2===1,K=c.readUInt8(L)===0;if(K&&(k=!0),l&&(B&&!K||!B&&K)&&(l=!1),p&&(B&&K||!B&&!K)&&(p=!1),K&&!l&&!p)break}k&&(l?s=e.UTF16le:p?s=e.UTF16be:n=!0)}return i&&!n&&!s&&c?w(c.slice(0,u)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:n,encoding:s}}e.detectEncodingFromBuffer=r,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[143],ye([1,0,297,29,142]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends I.TextSearchManager{constructor(T,S,C=t,R="searchProcess"){super(T,S,{readdir:P=>C.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,a.toCanonicalName)(P)},R)}}e.NativeTextSearchManager=A}),define(Se[298],ye([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const A=this.a.get(I);return this.a.delete(I),A}}addDragOperationTransfer(I,A){this.a.set(I,A)}getRenderedTreeElement(I){if(this.b.has(I))return this.b.get(I)}addRenderedTreeItemElement(I,A){this.b.set(I,A)}removeRenderedTreeItemElement(I){this.b.has(I)&&this.b.delete(I)}}e.TreeviewsService=a}),define(Se[299],ye([1,0,176,7,24,2,4,6,18,7,12,17,14,21,298,26]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(f,h){if((0,R.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let b;return Array.isArray(f.highlights)&&(b=f.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),b=b.length?b:void 0),{label:f.label,highlights:b}}}class m{constructor(h,b,o){this.d=h,this.e=b,this.f=o,this.a=new Map,this.b=new v.TreeviewsService;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:c=>r(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(u=>r(u)?this.i(u):u):c})}registerTreeDataProvider(h,b,o){const r=this.createTreeView(h,{treeDataProvider:b},o);return{dispose:()=>r.dispose()}}createTreeView(h,b,o){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=b.dragAndDropController?.dropMimeTypes??[],c=b.dragAndDropController?.dragMimeTypes??[],u=!!b.dragAndDropController?.handleDrag,i=!!b.dragAndDropController?.handleDrop,s=this.h(h,b,o),n=this.d.$registerTreeViewDataProvider(h,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:u,hasHandleDrop:i});return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(o,"treeItemCheckbox"),s.onDidChangeCheckboxState},get message(){return s.message},set message(l){s.message=l},get title(){return s.title},set title(l){s.title=l},get description(){return s.description},set description(l){s.description=l},get badge(){return s.badge},set badge(l){l!==void 0&&C.ViewBadge.isViewBadge(l)?s.badge={value:Math.floor(Math.abs(l.value)),tooltip:l.tooltip}:l===void 0&&(s.badge=void 0)},reveal:(l,p)=>s.reveal(l,p),dispose:async()=>{await n,this.a.delete(h),s.dispose()}}}$getChildren(h,b){const o=this.a.get(h);return o?o.getChildren(b):Promise.reject(new Error((0,a.localize)(0,null,h)))}async $handleDrop(h,b,o,r,c,u,i,s){const n=this.a.get(h);if(!n)return Promise.reject(new Error((0,a.localize)(1,null,h)));const l=E.DataTransfer.toDataTransfer(o,async p=>(await this.d.$resolveDropFileData(h,b,p)).buffer);return i===h&&s&&await this.g(l,n,s,c,u),n.onDrop(l,r,c)}async g(h,b,o,r,c){const u=this.b.removeDragOperationTransfer(c);if(u)(await u)?.forEach((i,s)=>{i&&h.set(s,i)});else if(c&&b.handleDrag){const i=b.handleDrag(o,h,r);this.b.addDragOperationTransfer(c,i),await i}return h}async $handleDrag(h,b,o,r){const c=this.a.get(h);if(!c)return Promise.reject(new Error((0,a.localize)(2,null,h)));const u=await this.g(new t.DataTransfer,c,b,r,o);if(!!u)return E.DataTransfer.toDataTransferDTO(u)}async $hasResolve(h){const b=this.a.get(h);if(!b)throw new Error((0,a.localize)(3,null,h));return b.hasResolve}$resolve(h,b,o){const r=this.a.get(h);if(!r)throw new Error((0,a.localize)(4,null,h));return r.resolveTreeItem(b,o)}$setExpanded(h,b,o){const r=this.a.get(h);if(!r)throw new Error((0,a.localize)(5,null,h));r.setExpanded(b,o)}$setSelection(h,b){const o=this.a.get(h);if(!o)throw new Error((0,a.localize)(6,null,h));o.setSelection(b)}$setFocus(h,b){const o=this.a.get(h);if(!o)throw new Error((0,a.localize)(7,null,h));o.setFocus(b)}$setVisible(h,b){const o=this.a.get(h);if(!o)throw new Error((0,a.localize)(8,null,h));o.setVisible(b)}$changeCheckboxState(h,b){const o=this.a.get(h);if(!o)throw new Error((0,a.localize)(9,null,h));o.setCheckboxState(b)}h(h,b,o){const r=new w(h,b,this.d,this.e.converter,this.f,o);return this.a.set(h,r),r}i(h){const b=this.a.get(h.$treeViewId);return b&&"$treeItemHandle"in h?b.getExtensionElement(h.$treeItemHandle):b&&"$focusedTreeItem"in h&&h.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=m;class w extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.isUndefinedOrNull)(h))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(h,b,o,r,c,u){if(super(),this.C=h,this.D=o,this.F=r,this.G=c,this.H=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new D.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new D.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new D.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new D.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new D.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new D.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new y.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const l of u.contributes.views[n])l.id===h&&(this.J=l.name);this.f=b.treeDataProvider,this.g=b.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let i,s;this.B(D.Event.debounce(this.w.event,(n,l)=>(n||(n={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(p=>s=p),this.y=this.y.then(()=>i)),Array.isArray(l.element)?n.elements.push(...l.element):n.elements.push(l.element)),l.message&&(n.message=!0),n),200,!0)(({message:n,elements:l})=>{l.length&&(this.z=this.z.then(()=>{const p=s;return i=null,this.U(l).then(()=>p())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(h){const b=h?this.getExtensionElement(h):void 0;if(h&&!b)return this.G.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let o=this.Q(h);return o||(o=await this.R(b)),o?o.map(r=>r.item):void 0}getExtensionElement(h){return this.i.get(h)}reveal(h,b){b=b||{select:!0,focus:!1};const o=(0,R.isUndefinedOrNull)(b.select)?!0:b.select,r=(0,R.isUndefinedOrNull)(b.focus)?!1:b.focus,c=(0,R.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.y.then(()=>this.N(h)).then(u=>this.P(h,u[u.length-1]).then(i=>this.D.$reveal(this.C,{item:i.item,parentChain:u.map(s=>s.item)},{select:o,focus:r,expand:c})),u=>this.G.error(u)):this.D.$reveal(this.C,void 0,{select:o,focus:r,expand:c})}get message(){return this.I}set message(h){this.I=h,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(h){this.J=h,this.D.$setTitle(this.C,h,this.L)}get description(){return this.L}set description(h){this.L=h,this.D.$setTitle(this.C,this.J,h)}get badge(){return this.M}set badge(h){this.M?.value===h?.value&&this.M?.tooltip===h?.tooltip||(this.M=E.ViewBadge.from(h),this.D.$setBadge(this.C,h))}setExpanded(h,b){const o=this.getExtensionElement(h);o&&(b?this.r.fire(Object.freeze({element:o})):this.s.fire(Object.freeze({element:o})))}setSelection(h){(0,P.equals)(this.l,h)||(this.l=h,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(h){this.m=h}setVisible(h){h!==this.k&&(this.k=h,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(h){const b=(await Promise.all(h.map(async o=>{const r=this.getExtensionElement(o.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:o.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);b.forEach(o=>{o.treeItem.checkboxState=o.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this.v.fire({items:b.map(o=>[o.extensionItem,o.newState])})}async handleDrag(h,b,o){const r=[];for(const c of h){const u=this.getExtensionElement(c);u&&r.push(u)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,b,o),b}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,b,o){const r=b?this.getExtensionElement(b):void 0;if(!(!r&&b||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,h,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,b){if(!this.f.resolveTreeItem)return;const o=this.i.get(h);if(o){const r=this.j.get(o);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,o,b)??r.extensionItem;return this.db(c),r.item.tooltip=this.ab(c.tooltip),r.item.command=this.bb(r.disposableStore,c.command),r.item}}}N(h){return this.O(h).then(b=>b?this.N(b).then(o=>this.P(b,o[o.length-1]).then(r=>(o.push(r),o))):Promise.resolve([]))}O(h){const b=this.j.get(h);return b?Promise.resolve(b.parent?this.i.get(b.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(h))}P(h,b){const o=this.j.get(h);return o?Promise.resolve(o):(0,S.asPromise)(()=>this.f.getTreeItem(h)).then(r=>this.gb(h,r,b,!0)).then(r=>this.getChildren(b?b.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const u=this.j.get(c);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(h){if(h){let b;if(typeof h=="string"){const o=this.getExtensionElement(h);b=o?this.j.get(o):void 0}else b=h;return b&&b.children||void 0}return this.h}async R(h){this.nb(h);const b=new y.CancellationTokenSource(this.S.token);try{const o=h?this.j.get(h):void 0,r=await this.f.getChildren(h);if(b.token.isCancellationRequested)return;const c=await Promise.all((0,P.coalesce)(r||[]).map(async u=>{const i=await this.f.getTreeItem(u);return i&&!b.token.isCancellationRequested?this.Z(u,i,o):null}));return b.token.isCancellationRequested?void 0:(0,P.coalesce)(c)}finally{b.dispose()}}U(h){if(h.some(o=>!o))return this.S.dispose(!0),this.S=new y.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const o=this.W(h);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(h){const b=new Set,o=h.map(c=>this.j.get(c));for(const c of o)if(c&&!b.has(c.item.handle)){let u=c;for(;u&&u.parent&&o.findIndex(i=>u&&u.parent&&i&&i.item.handle===u.parent.item.handle)===-1;){const i=this.i.get(u.parent.item.handle);u=i?this.j.get(i):void 0}u&&!u.parent&&b.add(c.item.handle)}const r=[];return b.forEach(c=>{const u=this.i.get(c);if(u){const i=this.j.get(u);i&&(!i.parent||!b.has(i.parent.item.handle))&&r.push(c)}}),r}X(h){const b={};return Promise.all(h.map(o=>this.Y(o).then(r=>{r&&(b[o]=r.item)}))).then(()=>Object.keys(b).length?this.D.$refresh(this.C,b):void 0)}Y(h){const b=this.getExtensionElement(h);if(b){const o=this.j.get(b);if(o)return this.nb(b),(0,S.asPromise)(()=>this.f.getTreeItem(b)).then(r=>{if(r){const c=this.eb(b,r,o.parent);return this.lb(b,c,o,o.parent),o.dispose(),c}return null})}return Promise.resolve(null)}Z(h,b,o){const r=this.eb(h,b,o);if(b.id&&this.i.has(r.item.handle))throw new Error((0,a.localize)(10,null,b.id));return this.kb(h,r),this.mb(r,o),r}ab(h){return C.MarkdownString.isMarkdownString(h)?E.MarkdownString.from(h):h}bb(h,b){return b?{...this.F.toInternal(b,h),originalId:b.command}:void 0}cb(h){if(!h.checkboxState)return;let b,o;return typeof h.checkboxState=="number"?b=h.checkboxState:(b=h.checkboxState.state,o=h.checkboxState.tooltip),{isChecked:b===C.TreeItemCheckboxState.Checked,tooltip:o}}db(h){if(!C.TreeItem.isTreeItem(h,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(h,b,o){this.db(b);const r=new T.DisposableStore,c=this.gb(h,b,o),u=this.hb(b);return{item:{handle:c,parentHandle:o?o.item.handle:void 0,label:g(b.label,this.H),description:b.description,resourceUri:b.resourceUri,tooltip:this.ab(b.tooltip),command:this.bb(r,b.command),contextValue:b.contextValue,icon:u,iconDark:this.ib(b)||u,themeIcon:this.fb(b),collapsibleState:(0,R.isUndefinedOrNull)(b.collapsibleState)?C.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.cb(b)},extensionItem:b,parent:o,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(h){return h.iconPath instanceof C.ThemeIcon?h.iconPath:void 0}gb(h,{id:b,label:o,resourceUri:r},c,u){if(b)return`${w.b}/${b}`;const i=g(o,this.H),s=c?c.item.handle:w.a;let n=i?i.label:r?(0,I.basename)(r):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const l=this.j.has(h)?this.j.get(h).item.handle:void 0,p=this.Q(c)||[];let k,L=0;do{if(k=`${s}/${L}:${n}`,u||!this.i.has(k)||l===k)break;L++}while(L<=p.length);return k}hb(h){if(h.iconPath&&!(h.iconPath instanceof C.ThemeIcon))return typeof h.iconPath=="string"||A.URI.isUri(h.iconPath)?this.jb(h.iconPath):this.jb(h.iconPath.light)}ib(h){if(h.iconPath&&!(h.iconPath instanceof C.ThemeIcon)&&h.iconPath.dark)return this.jb(h.iconPath.dark)}jb(h){return A.URI.isUri(h)?h:A.URI.file(h)}kb(h,b){this.i.set(b.item.handle,h),this.j.set(h,b)}lb(h,b,o,r){this.i.delete(b.item.handle),this.j.delete(h),b.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(h,b);const c=this.Q(r)||[],u=c.filter(i=>i.item.handle===o.item.handle)[0];u&&c.splice(c.indexOf(u),1,b)}mb(h,b){b?(b.children||(b.children=[]),b.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}nb(h){if(h){const b=this.j.get(h);if(b){if(b.children)for(const o of b.children){const r=this.i.get(o.item.handle);r&&this.ob(r)}b.children=void 0}}else this.pb()}ob(h){const b=this.j.get(h);if(b){if(b.children)for(const o of b.children){const r=this.i.get(o.item.handle);r&&this.ob(r)}this.j.delete(h),this.i.delete(b.item.handle),b.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(h=>h.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}w.a="0",w.b="1"}),define(Se[300],ye([1,0,21,10,4,42,2,119,117,154,153,38,5,93,243,242,39,244,34,246,247,248,231,249,59,41,250,251,254,255,256,141,234,261,262,263,97,40,265,299,14,7,128,268,74,140,33,221,253,68,138,76,78,79,13,56,16,25,257,230,55,71,240,266,73,72,271,269,270,241,46,264,267,96,60,94,258,75,259,15,123,233,210,252,6,26,214,95,207,260]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h,b,o,r,c,u,i,s,n,l,p,k,L,B,K,G,O,U,F,z,M,V,q,H,Q,Y,ce,ie,fe,J,pe,we,Ie,Re,ze,re,ue,de,Z,se,ne,N,$,x,_,le,be,Pe,ge,Ce,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe,W,ae,De,Le,Be,xe,Ze,mt,ft){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(de.IExtHostInitDataService),At=ot.get(ke.IExtHostFileSystemInfo),Rt=ot.get(le.IExtHostConsumerFileSystem),Ft=ot.get(u.IExtHostExtensionService),pt=ot.get(ce.IExtHostWorkspace),kt=ot.get(nt.IExtHostTelemetry),Bt=ot.get(w.IExtHostConfiguration),Mt=ot.get(re.IURITransformerService),Xe=ot.get(ue.IExtHostRpcService),Ot=ot.get(O.IExtHostStorage),Ut=ot.get(_.IExtensionStoragePaths),Ht=ot.get(ze.ILoggerService),bt=ot.get(ze.ILogService),Lt=ot.get(ne.IExtHostTunnelService),Ae=ot.get(N.IExtHostApiDeprecationService),Oe=ot.get(Y.IExtHostWindow),Ee=ot.get(et.IExtHostSecretState),te=ot.get(_e.IExtHostEditorTabs);Xe.set(E.ExtHostContext.ExtHostFileSystemInfo,At),Xe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Xe.set(E.ExtHostContext.ExtHostWorkspace,pt),Xe.set(E.ExtHostContext.ExtHostConfiguration,Bt),Xe.set(E.ExtHostContext.ExtHostExtensionService,Ft),Xe.set(E.ExtHostContext.ExtHostStorage,Ot),Xe.set(E.ExtHostContext.ExtHostTunnelService,Lt),Xe.set(E.ExtHostContext.ExtHostWindow,Oe),Xe.set(E.ExtHostContext.ExtHostSecretState,Ee),Xe.set(E.ExtHostContext.ExtHostTelemetry,kt),Xe.set(E.ExtHostContext.ExtHostEditorTabs,te);const Ne=Xe.set(E.ExtHostContext.ExtHostDecorations,ot.get(pe.IExtHostDecorations)),$e=Xe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(c.IExtHostDocumentsAndEditors)),Qe=Xe.set(E.ExtHostContext.ExtHostCommands,ot.get(g.IExtHostCommands)),Ve=Xe.set(E.ExtHostContext.ExtHostTerminalService,ot.get(U.IExtHostTerminalService)),tt=Xe.set(E.ExtHostContext.ExtHostDebugService,ot.get(Ie.IExtHostDebugService)),It=Xe.set(E.ExtHostContext.ExtHostSearch,ot.get(Re.IExtHostSearch)),Et=Xe.set(E.ExtHostContext.ExtHostTask,ot.get(we.IExtHostTask)),Tt=Xe.set(E.ExtHostContext.ExtHostOutputService,ot.get(k.IExtHostOutputService)),wt=Xe.set(E.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),vt=Xe.set(E.ExtHostContext.ExtHostUrls,new H.ExtHostUrls(Xe)),yt=Xe.set(E.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Xe,$e)),zt=Xe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Xe,$e,bt)),Xt=Xe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(bt,yt,Xe.getProxy(E.MainContext.MainThreadBulkEdits))),St=Xe.set(E.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(Xe,Qe,$e,yt)),on=Xe.set(E.ExtHostContext.ExtHostNotebookDocuments,new ae.ExtHostNotebookDocuments(St)),an=Xe.set(E.ExtHostContext.ExtHostNotebookEditors,new W.ExtHostNotebookEditors(bt,St)),Zt=Xe.set(E.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,rt,St,Qe,bt)),bn=Xe.set(E.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(Xe,St)),Ct=Xe.set(E.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Xe,$e)),cn=Xe.set(E.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Xe.getProxy(E.MainContext.MainThreadTreeViews),Qe,bt)),On=Xe.set(E.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(Xe.getProxy(E.MainContext.MainThreadEditorInsets),Ct,rt.remote)),en=Xe.set(E.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Xe,bt,At,$e)),jt=Xe.set(E.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Xe,yt,Qe.converter,Mt)),ut=Xe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Mt,yt,Qe,en,bt,Ae,kt)),wn=Xe.set(E.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Xe,ut)),Vt=Xe.set(E.ExtHostContext.ExtHostFileSystemEventService,new s.ExtHostFileSystemEventService(Xe,bt,$e)),_t=Xe.set(E.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(Xe,pt,Qe)),ln=Xe.set(E.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(Xe,Qe,bt)),vn=Xe.set(E.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(Xe,Qe,yt)),un=Xe.set(E.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Xe.getProxy(E.MainContext.MainThreadProgress))),En=Xe.set(E.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Xe)),kn=Xe.set(E.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(Xe)),tn=Xe.set(E.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Xe)),Sn=Xe.set(E.ExtHostContext.ExtHostTimeline,new x.ExtHostTimeline(Xe,Qe)),rn=Xe.set(E.ExtHostContext.ExtHostWebviews,new Q.ExtHostWebviews(Xe,rt.remote,pt,bt,Ae)),sn=Xe.set(E.ExtHostContext.ExtHostWebviewPanels,new ge.ExtHostWebviewPanels(Xe,rn,pt)),Nn=Xe.set(E.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Xe,yt,Ut,rn,sn)),yn=Xe.set(E.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(Xe,rn)),Qt=Xe.set(E.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Xe,Qe,$e)),Fn=Xe.set(E.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),Mn=Xe.set(E.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(Xe));Xe.set(E.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(Xe,St,$e,Qe,bt));const Un=Object.values(E.ExtHostContext);Xe.assertRegistered(Un);const Bn=new Ce.ExtHostBulkEdits(Xe,$e),zn=new d.ExtHostClipboard(Xe),Cn=new p.ExtHostMessageService(Xe,bt),dn=new h.ExtHostDialogs(Xe),hn=new G.ExtHostStatusBar(Xe,Qe.converter);return v.ExtHostApiCommands.register(Qe),function(He,Gt,Tn){const gt=function(){let me=!He.isUnderDevelopment;function ve(){me||(bt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(at){if(Array.isArray(at))at.forEach(Ue);else if(typeof at=="string")ve();else{const Dt=at;typeof Dt.scheme>"u"&&ve(),typeof Dt.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),$n={getSession(me,ve,Ue){return tn.getSession(He,me,ve,Ue)},async hasSession(me,ve){return(0,Be.checkProposedApiEnabled)(He,"authSession"),!!await tn.getSession(He,me,ve,{silent:!0})},get onDidChangeSessions(){return tn.onDidChangeSessions},registerAuthenticationProvider(me,ve,Ue,at){return tn.registerAuthenticationProvider(me,ve,Ue,at)}},Wn={registerCommand(me,ve,Ue){return Qe.registerCommand(!0,me,ve,Ue,void 0,He)},registerTextEditorCommand(me,ve,Ue){return Qe.registerCommand(!0,me,(...at)=>{const Dt=Ct.getActiveTextEditor();if(!Dt){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Dt.edit(Pt=>{ve.apply(Ue,[Dt,Pt,...at])}).then(Pt=>{Pt||bt.warn("Edits from command "+me+" were not applied.")},Pt=>{bt.warn("An error occurred while running command "+me,Pt)})},void 0,void 0,He)},registerDiffInformationCommand:(me,ve,Ue)=>((0,Be.checkProposedApiEnabled)(He,"diffCommand"),Qe.registerCommand(!0,me,async(...at)=>{const Dt=$e.activeEditor(!0);if(!Dt){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Pt=await Ct.getDiffInformation(Dt.id);ve.apply(Ue,[Pt,...at])},void 0,void 0,He)),executeCommand(me,...ve){return Qe.executeCommand(me,...ve)},getCommands(me=!1){return Qe.getCommands(me)}},Pn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return zn.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(He,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Be.checkProposedApiEnabled)(He,"telemetryLogger"),kt.instantiateLogger(He,me)},openExternal(me,ve){return Oe.openUri(me,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===rt.environment.appUriScheme)return vt.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!rt.remote.authority})}catch(ve){if((0,oe.matchesScheme)(me,it.Schemas.http)||(0,oe.matchesScheme)(me,it.Schemas.https))return me;throw ve}},get remoteName(){return(0,J.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(He,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Pn);const Hn={createTestController(me,ve,Ue){return Qt.createTestController(me,ve,Ue)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.createTestObserver()},runTests(me){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.runTests(me)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.results}},nn=rt.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,jn={getExtension(me,ve){(0,Be.isProposedApiEnabled)(He,"extensionsAny")||(ve=!1);const Ue=Gt.mine.getExtensionDescription(me);if(Ue)return new u.Extension(Ft,He.identifier,Ue,nn,!1);if(ve){const at=Gt.all.getExtensionDescription(me);if(at)return new u.Extension(Ft,He.identifier,at,nn,!0)}},get all(){const me=[];for(const ve of Gt.mine.getAllExtensionDescriptions())me.push(new u.Extension(Ft,He.identifier,ve,nn,!1));return me},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(He,"extensionsAny");const me=new Be.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ve=[];for(const Ue of Gt.all.getAllExtensionDescriptions()){const at=!me.has(Ue.identifier);ve.push(new u.Extension(Ft,He.identifier,Ue,nn,at))}return ve},get onDidChange(){return(0,Be.isProposedApiEnabled)(He,"extensionsAny")?I.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},Kt={createDiagnosticCollection(me){return en.createDiagnosticCollection(He.identifier,me)},get onDidChangeDiagnostics(){return en.onDidChangeDiagnostics},getDiagnostics:me=>en.getDiagnostics(me),getLanguages(){return jt.getLanguages()},setTextDocumentLanguage(me,ve){return jt.changeLanguage(me.uri,ve)},match(me,ve){const Ue=yt.getDocumentData(ve.uri)?.notebook;return(0,R.score)(M.LanguageSelector.from(me),ve.uri,ve.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,ve,Ue){return ut.registerCodeActionProvider(He,gt(me),ve,Ue)},registerDocumentPasteEditProvider(me,ve,Ue){return(0,Be.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,gt(me),ve,Ue)},registerCodeLensProvider(me,ve){return ut.registerCodeLensProvider(He,gt(me),ve)},registerDefinitionProvider(me,ve){return ut.registerDefinitionProvider(He,gt(me),ve)},registerDeclarationProvider(me,ve){return ut.registerDeclarationProvider(He,gt(me),ve)},registerImplementationProvider(me,ve){return ut.registerImplementationProvider(He,gt(me),ve)},registerTypeDefinitionProvider(me,ve){return ut.registerTypeDefinitionProvider(He,gt(me),ve)},registerHoverProvider(me,ve){return ut.registerHoverProvider(He,gt(me),ve,He.identifier)},registerEvaluatableExpressionProvider(me,ve){return ut.registerEvaluatableExpressionProvider(He,gt(me),ve,He.identifier)},registerInlineValuesProvider(me,ve){return ut.registerInlineValuesProvider(He,gt(me),ve,He.identifier)},registerDocumentHighlightProvider(me,ve){return ut.registerDocumentHighlightProvider(He,gt(me),ve)},registerLinkedEditingRangeProvider(me,ve){return ut.registerLinkedEditingRangeProvider(He,gt(me),ve)},registerReferenceProvider(me,ve){return ut.registerReferenceProvider(He,gt(me),ve)},registerRenameProvider(me,ve){return ut.registerRenameProvider(He,gt(me),ve)},registerDocumentSymbolProvider(me,ve,Ue){return ut.registerDocumentSymbolProvider(He,gt(me),ve,Ue)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(He,me)},registerDocumentFormattingEditProvider(me,ve){return ut.registerDocumentFormattingEditProvider(He,gt(me),ve)},registerDocumentRangeFormattingEditProvider(me,ve){return ut.registerDocumentRangeFormattingEditProvider(He,gt(me),ve)},registerOnTypeFormattingEditProvider(me,ve,Ue,...at){return ut.registerOnTypeFormattingEditProvider(He,gt(me),ve,[Ue].concat(at))},registerDocumentSemanticTokensProvider(me,ve,Ue){return ut.registerDocumentSemanticTokensProvider(He,gt(me),ve,Ue)},registerDocumentRangeSemanticTokensProvider(me,ve,Ue){return ut.registerDocumentRangeSemanticTokensProvider(He,gt(me),ve,Ue)},registerSignatureHelpProvider(me,ve,Ue,...at){return typeof Ue=="object"?ut.registerSignatureHelpProvider(He,gt(me),ve,Ue):ut.registerSignatureHelpProvider(He,gt(me),ve,typeof Ue>"u"?[]:[Ue,...at])},registerCompletionItemProvider(me,ve,...Ue){return ut.registerCompletionItemProvider(He,gt(me),ve,Ue)},registerInlineCompletionItemProvider(me,ve){return ve.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,gt(me),ve)},registerDocumentLinkProvider(me,ve){return ut.registerDocumentLinkProvider(He,gt(me),ve)},registerColorProvider(me,ve){return ut.registerColorProvider(He,gt(me),ve)},registerFoldingRangeProvider(me,ve){return ut.registerFoldingRangeProvider(He,gt(me),ve)},registerSelectionRangeProvider(me,ve){return ut.registerSelectionRangeProvider(He,me,ve)},registerCallHierarchyProvider(me,ve){return ut.registerCallHierarchyProvider(He,me,ve)},registerTypeHierarchyProvider(me,ve){return ut.registerTypeHierarchyProvider(He,me,ve)},setLanguageConfiguration:(me,ve)=>ut.setLanguageConfiguration(He,me,ve),getTokenInformationAtPosition(me,ve){return(0,Be.checkProposedApiEnabled)(He,"tokenInformation"),jt.tokenAtPosition(me,ve)},registerInlayHintsProvider(me,ve){return ut.registerInlayHintsProvider(He,me,ve)},createLanguageStatusItem(me,ve){return jt.createLanguageStatusItem(He,me,ve)},registerDocumentDropEditProvider(me,ve){return ut.registerDocumentOnDropEditProvider(He,me,ve)}},fn={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(me,ve,Ue){const at=await(D.URI.isUri(me)?Promise.resolve(An.openTextDocument(me)):Promise.resolve(me));return Ct.showTextDocument(at,ve,Ue)},createTextEditorDecorationType(me){return Ct.createTextEditorDecorationType(He,me)},onDidChangeActiveTextEditor(me,ve,Ue){return Ct.onDidChangeActiveTextEditor(me,ve,Ue)},onDidChangeVisibleTextEditors(me,ve,Ue){return Ct.onDidChangeVisibleTextEditors(me,ve,Ue)},onDidChangeTextEditorSelection(me,ve,Ue){return Ct.onDidChangeTextEditorSelection(me,ve,Ue)},onDidChangeTextEditorOptions(me,ve,Ue){return Ct.onDidChangeTextEditorOptions(me,ve,Ue)},onDidChangeTextEditorVisibleRanges(me,ve,Ue){return Ct.onDidChangeTextEditorVisibleRanges(me,ve,Ue)},onDidChangeTextEditorViewColumn(me,ve,Ue){return Ct.onDidChangeTextEditorViewColumn(me,ve,Ue)},onDidCloseTerminal(me,ve,Ue){return Ve.onDidCloseTerminal(me,ve,Ue)},onDidOpenTerminal(me,ve,Ue){return Ve.onDidOpenTerminal(me,ve,Ue)},onDidChangeActiveTerminal(me,ve,Ue){return Ve.onDidChangeActiveTerminal(me,ve,Ue)},onDidChangeTerminalDimensions(me,ve,Ue){return(0,Be.checkProposedApiEnabled)(He,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(me,ve,Ue)},onDidChangeTerminalState(me,ve,Ue){return Ve.onDidChangeTerminalState(me,ve,Ue)},onDidWriteTerminalData(me,ve,Ue){return(0,Be.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(me,ve,Ue)},get state(){return Oe.state},onDidChangeWindowState(me,ve,Ue){return Oe.onDidChangeWindowState(me,ve,Ue)},showInformationMessage(me,...ve){return Cn.showMessage(He,A.default.Info,me,ve[0],ve.slice(1))},showWarningMessage(me,...ve){return Cn.showMessage(He,A.default.Warning,me,ve[0],ve.slice(1))},showErrorMessage(me,...ve){return Cn.showMessage(He,A.default.Error,me,ve[0],ve.slice(1))},showQuickPick(me,ve,Ue){return _t.showQuickPick(me,ve,Ue)},showWorkspaceFolderPick(me){return _t.showWorkspaceFolderPick(me)},showInputBox(me,ve){return _t.showInput(me,ve)},showOpenDialog(me){return dn.showOpenDialog(me)},showSaveDialog(me){return dn.showSaveDialog(me)},createStatusBarItem(me,ve,Ue){let at,Dt,Pt;return typeof me=="string"?(at=me,Dt=ve,Pt=Ue):(Dt=me,Pt=ve),hn.createStatusBarEntry(He,at,Dt,Pt)},setStatusBarMessage(me,ve){return hn.setStatusBarMessage(me,ve)},withScmProgress(me){return Ae.report("window.withScmProgress",He,"Use 'withProgress' instead."),un.withProgress(He,{location:V.ProgressLocation.SourceControl},(ve,Ue)=>me({report(at){}}))},withProgress(me,ve){return un.withProgress(He,me,ve)},createOutputChannel(me,ve){return Tt.createOutputChannel(me,ve,He)},createWebviewPanel(me,ve,Ue,at){return sn.createWebviewPanel(He,me,ve,Ue,at)},createWebviewTextEditorInset(me,ve,Ue,at){return(0,Be.checkProposedApiEnabled)(He,"editorInsets"),On.createWebviewEditorInset(me,ve,Ue,at,He)},createTerminal(me,ve,Ue){return typeof me=="object"?"pty"in me?Ve.createExtensionTerminal(me):Ve.createTerminalFromOptions(me):Ve.createTerminal(me,ve,Ue)},registerTerminalLinkProvider(me){return Ve.registerLinkProvider(me)},registerTerminalProfileProvider(me,ve){return Ve.registerProfileProvider(He,me,ve)},registerTerminalQuickFixProvider(me,ve){return(0,Be.checkProposedApiEnabled)(He,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(me,He.identifier.value,ve)},registerTreeDataProvider(me,ve){return cn.registerTreeDataProvider(me,ve,He)},createTreeView(me,ve){return cn.createTreeView(me,ve,He)},registerWebviewPanelSerializer:(me,ve)=>sn.registerWebviewPanelSerializer(He,me,ve),registerCustomEditorProvider:(me,ve,Ue={})=>Nn.registerCustomEditorProvider(He,me,ve,Ue),registerFileDecorationProvider(me){return Ne.registerFileDecorationProvider(me,He)},registerUriHandler(me){return vt.registerUriHandler(He.identifier,me)},createQuickPick(){return _t.createQuickPick(He)},createInputBox(){return _t.createInputBox(He)},get activeColorTheme(){return kn.activeColorTheme},onDidChangeActiveColorTheme(me,ve,Ue){return kn.onDidChangeActiveColorTheme(me,ve,Ue)},registerWebviewViewProvider(me,ve,Ue){return yn.registerWebviewViewProvider(He,me,ve,Ue?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,ve,Ue){return St.onDidChangeActiveNotebookEditor(me,ve,Ue)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,ve,Ue){return an.onDidChangeNotebookEditorSelection(me,ve,Ue)},onDidChangeNotebookEditorVisibleRanges(me,ve,Ue){return an.onDidChangeNotebookEditorVisibleRanges(me,ve,Ue)},showNotebookDocument(me,ve){return St.showNotebookDocument(me,ve)},registerExternalUriOpener(me,ve,Ue){return(0,Be.checkProposedApiEnabled)(He,"externalUriOpener"),Fn.registerExternalUriOpener(He.identifier,me,ve,Ue)},registerProfileContentHandler(me,ve){return(0,Be.checkProposedApiEnabled)(He,"profileContentHandlers"),Mn.registrProfileContentHandler(He,me,ve)},get tabGroups(){return te.tabGroups}},An={get rootPath(){return Ae.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return pt.getWorkspaceFolder(me)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(me){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,ve,...Ue)=>pt.updateWorkspaceFolders(He,me,ve||0,...Ue),onDidChangeWorkspaceFolders:function(me,ve,Ue){return pt.onDidChangeWorkspace(me,ve,Ue)},asRelativePath:(me,ve)=>pt.getRelativePath(me,ve),findFiles:(me,ve,Ue,at)=>pt.findFiles(me,ve,Ue,He.identifier,at),findTextInFiles:(me,ve,Ue,at)=>{(0,Be.checkProposedApiEnabled)(He,"findTextInFiles");let Dt,Pt;return typeof ve=="object"?(Dt=ve,Pt=Ue):(Dt={},Pt=ve,at=Ue),pt.findTextInFiles(me,Dt||{},Pt,He.identifier,at)},saveAll:me=>pt.saveAll(me),applyEdit(me,ve){return Bn.applyWorkspaceEdit(me,He,ve)},createFileSystemWatcher:(me,ve,Ue,at)=>Vt.createFileSystemWatcher(pt,He,me,ve,Ue,at),get textDocuments(){return yt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let ve;const Ue=me;if(typeof me=="string")ve=Promise.resolve(D.URI.file(me));else if(D.URI.isUri(me))ve=Promise.resolve(me);else if(!Ue||typeof Ue=="object")ve=yt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(at=>yt.ensureDocumentData(at).then(Dt=>Dt.document))},onDidOpenTextDocument:(me,ve,Ue)=>yt.onDidAddDocument(me,ve,Ue),onDidCloseTextDocument:(me,ve,Ue)=>yt.onDidRemoveDocument(me,ve,Ue),onDidChangeTextDocument:(me,ve,Ue)=>yt.onDidChangeDocument(me,ve,Ue),onDidSaveTextDocument:(me,ve,Ue)=>yt.onDidSaveDocument(me,ve,Ue),onWillSaveTextDocument:(me,ve,Ue)=>Xt.getOnWillSaveTextDocumentEvent(He)(me,ve,Ue),get notebookDocuments(){return St.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,ve){let Ue;if(D.URI.isUri(me))Ue=me,await St.openNotebookDocument(me);else if(typeof me=="string")Ue=D.URI.revive(await St.createNotebookDocument({viewType:me,content:ve}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,ve,Ue){return on.onDidSaveNotebookDocument(me,ve,Ue)},onDidChangeNotebookDocument(me,ve,Ue){return on.onDidChangeNotebookDocument(me,ve,Ue)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(me,ve,Ue,at){return St.registerNotebookSerializer(He,me,ve,Ue,(0,Be.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,ve,Ue)=>Tn.onDidChangeConfiguration(me,ve,Ue),getConfiguration(me,ve){return ve=arguments.length===1?void 0:ve,Tn.getConfiguration(me,ve,He)},registerTextDocumentContentProvider(me,ve){return zt.registerTextDocumentContentProvider(me,ve)},registerTaskProvider:(me,ve)=>(Ae.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,me,ve)),registerFileSystemProvider(me,ve,Ue){return(0,Le.combinedDisposable)(wn.registerFileSystemProvider(He,me,ve,Ue),Rt.addFileSystemProvider(me,ve))},get fs(){return Rt.value},registerFileSearchProvider:(me,ve)=>((0,Be.checkProposedApiEnabled)(He,"fileSearchProvider"),It.registerFileSearchProvider(me,ve)),registerTextSearchProvider:(me,ve)=>((0,Be.checkProposedApiEnabled)(He,"textSearchProvider"),It.registerTextSearchProvider(me,ve)),registerRemoteAuthorityResolver:(me,ve)=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Ft.registerRemoteAuthorityResolver(me,ve)),registerResourceLabelFormatter:me=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),En.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,ve,Ue)=>Vt.onDidCreateFile(me,ve,Ue),onDidDeleteFiles:(me,ve,Ue)=>Vt.onDidDeleteFile(me,ve,Ue),onDidRenameFiles:(me,ve,Ue)=>Vt.onDidRenameFile(me,ve,Ue),onWillCreateFiles:(me,ve,Ue)=>Vt.getOnWillCreateFileEvent(He)(me,ve,Ue),onWillDeleteFiles:(me,ve,Ue)=>Vt.getOnWillDeleteFileEvent(He)(me,ve,Ue),onWillRenameFiles:(me,ve,Ue)=>Vt.getOnWillRenameFileEvent(He)(me,ve,Ue),openTunnel:me=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.openTunnel(He,me).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(me,ve,Ue)=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.onDidChangeTunnels(me,ve,Ue)),registerPortAttributesProvider:(me,ve)=>((0,Be.checkProposedApiEnabled)(He,"portsAttributes"),Lt.registerPortsAttributesProvider(me,ve)),registerTimelineProvider:(me,ve)=>((0,Be.checkProposedApiEnabled)(He,"timeline"),Sn.registerTimelineProvider(me,ve,He.identifier,Qe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:me=>((0,Be.checkProposedApiEnabled)(He,"workspaceTrust"),pt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,ve,Ue)=>pt.onDidGrantWorkspaceTrust(me,ve,Ue),registerEditSessionIdentityProvider:(me,ve)=>((0,Be.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(me,ve))},$t={get inputBox(){return Ae.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),ln.getLastInputBox(He)},createSourceControl(me,ve,Ue){return ln.createSourceControl(He,me,ve,Ue)}},mn={createCommentController(me,ve){return vn.createCommentController(He,me,ve)}},Vn={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(me,ve,Ue){return tt.onDidStartDebugSession(me,ve,Ue)},onDidTerminateDebugSession(me,ve,Ue){return tt.onDidTerminateDebugSession(me,ve,Ue)},onDidChangeActiveDebugSession(me,ve,Ue){return tt.onDidChangeActiveDebugSession(me,ve,Ue)},onDidReceiveDebugSessionCustomEvent(me,ve,Ue){return tt.onDidReceiveDebugSessionCustomEvent(me,ve,Ue)},onDidChangeBreakpoints(me,ve,Ue){return tt.onDidChangeBreakpoints(me,ve,Ue)},registerDebugConfigurationProvider(me,ve,Ue){return tt.registerDebugConfigurationProvider(me,ve,Ue||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,ve){return tt.registerDebugAdapterDescriptorFactory(He,me,ve)},registerDebugAdapterTrackerFactory(me,ve){return tt.registerDebugAdapterTrackerFactory(me,ve)},startDebugging(me,ve,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?tt.startDebugging(me,ve,{parentSession:Ue}):tt.startDebugging(me,ve,Ue||{})},stopDebugging(me){return tt.stopDebugging(me)},addBreakpoints(me){return tt.addBreakpoints(me)},removeBreakpoints(me){return tt.removeBreakpoints(me)},asDebugSourceUri(me,ve){return tt.asDebugSourceUri(me,ve)}},qn={registerTaskProvider:(me,ve)=>Et.registerTaskProvider(He,me,ve),fetchTasks:me=>Et.fetchTasks(me),executeTask:me=>Et.executeTask(He,me),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(me,ve,Ue)=>Et.onDidStartTask(me,ve,Ue),onDidEndTask:(me,ve,Ue)=>Et.onDidEndTask(me,ve,Ue),onDidStartTaskProcess:(me,ve,Ue)=>Et.onDidStartTaskProcess(me,ve,Ue),onDidEndTaskProcess:(me,ve,Ue)=>Et.onDidEndTaskProcess(me,ve,Ue)},Gn={createNotebookController(me,ve,Ue,at,Dt){return Zt.createNotebookController(He,me,ve,Ue,at,(0,Be.isProposedApiEnabled)(He,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(me,ve)=>St.registerNotebookCellStatusBarItemProvider(He,me,ve),createRendererMessaging(me){return bn.createRendererMessaging(He,me)},createNotebookControllerDetectionTask(me){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(He,me)},registerKernelSourceActionProvider(me,ve){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(He,me,ve)},onDidChangeNotebookCellExecutionState(me,ve,Ue){return(0,Be.checkProposedApiEnabled)(He,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(me,ve,Ue)}},Kn={t(...me){if(typeof me[0]=="string"){const ve=me.shift(),Ue=!me||typeof me[0]!="object"?me:me[0];return wt.getMessage(He.identifier.value,{message:ve,args:Ue})}return wt.getMessage(He.identifier.value,me[0])},get bundle(){return wt.getBundle(He.identifier.value)},get uri(){return wt.getBundleUri(He.identifier.value)}};return{version:rt.version,authentication:$n,commands:Wn,comments:mn,debug:Vn,env:Pn,extensions:jn,l10n:Kn,languages:Kt,notebooks:Gn,scm:$t,tasks:qn,tests:Hn,window:fn,workspace:An,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:C.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:y.UIKind,Uri:D.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TrustedTelemetryValue:q.TrustedTelemetryValue,LogLevel:ze.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(Se[301],ye([1,0,273,310,311,2,312]),function(ee,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(P,E,y,v,d,g){const m=g.environment.useHostProxy,w=typeof m=="boolean"?m:!g.remote.isRemote,f=(0,D.createProxyResolver)({resolveProxy:b=>P.resolveProxy(b),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(b,o,...r)=>{switch(b){case D.LogLevel.Trace:v.trace(o,...r);break;case D.LogLevel.Debug:v.debug(o,...r);break;case D.LogLevel.Info:v.info(o,...r);break;case D.LogLevel.Warning:v.warn(o,...r);break;case D.LogLevel.Error:v.error(o,...r);break;case D.LogLevel.Critical:v.error(o,...r);break;case D.LogLevel.Off:break;default:c(b,o,r);break}function c(u,i,...s){v.error("Unknown log level",u),v.error(i,...s)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:w,env:process.env}),h=S(E,f);return R(y,h)}e.connectProxyResolver=T;function S(P,E){const y={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{y.config=P.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{v.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"off"},v,!0)),on:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"on"},v,!0)),override:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"override"},v,!0)),onRequest:Object.assign({},a,(0,D.createHttpPatch)(a,E,y,v,!0)),default:Object.assign(a,(0,D.createHttpPatch)(a,E,y,v,!1))},https:{off:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"off"},v,!0)),on:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"on"},v,!0)),override:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,D.createHttpPatch)(t,E,y,v,!0)),default:Object.assign(t,(0,D.createHttpPatch)(t,E,y,v,!1))},tls:Object.assign(I,(0,D.createTlsPatch)(I))}}const C=new Map;function R(P,E){return P.getExtensionPathIndex().then(y=>{const v=globalThis._VSCODE_NODE_MODULES.module,d=v._load;v._load=function(m,w,f){if(m==="tls")return E.tls;if(m!=="http"&&m!=="https")return d.apply(this,arguments);const h=E[m],b=y.findSubstr(A.URI.file(w.filename));let o=C.get(b);if(o||C.set(b,o={}),!o[m]){const r=h.default;o[m]={...r}}return o[m]}})}}),define(Se[302],ye([1,0,50,66,9,77,300,287,301,41,275,2,15,7,272,110,274]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class m extends T.RequireInterceptor{j(){const h=this,b=globalThis._VSCODE_NODE_MODULES.module,o=b._load;b._load=function(i,s,n){return i=c(i),h.a.has(i)?h.a.get(i).load(i,P.URI.file((0,d.realpathSync)(s.filename)),l=>o.apply(this,[l,s,n])):o.apply(this,arguments)};const r=b._resolveLookupPaths;b._resolveLookupPaths=(u,i)=>r.call(this,c(u),i);const c=u=>{for(const i of h.b){const s=i(u);if(s){u=s;break}}return u}}}class w extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=y.ExtensionRuntime.Node}async nb(){this.h.createInstance(g.ExtHostConsoleForwarder);const h=this.h.invokeFunction(D.createApiFactoryAndRegisterActors);if(this.h.createInstance(R.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const r=this.h.createInstance(v.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath,a.promises.writeFile(I.join(t.tmpdir(),"vscode-ipc"),r.ipcHandlePath).catch(c=>{this.l.error(c)})}await this.h.createInstance(m,h,{mine:this.D,all:this.F}).install(),A.mark("code/extHost/didInitAPI");const o=await this.k.getConfigProvider();await(0,S.connectProxyResolver)(this.j,o,this,this.l,this.u,this.f),A.mark("code/extHost/didInitProxyResolver")}ob(h){return h.main}async pb(h,b,o){if(b.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let r=null;o.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this.l.flush();const c=h?.identifier.value;h&&await this.s.initializeLocalizedMessages(h);try{c&&A.mark(`code/extHost/willLoadExtensionCode/${c}`),r=ee.__$__nodeRequire(b.fsPath)}finally{c&&A.mark(`code/extHost/didLoadExtensionCode/${c}`),o.codeLoadingStop()}return r}async $setRemoteEnvironment(h){if(!!this.f.remote.isRemote)for(const b in h){const o=h[b];o===null?delete process.env[b]:process.env[b]=o}}}e.ExtHostExtensionService=w}),define(Se[144],ye([1,0,44,313,296,17,81,36,9,8,2,31,75,314,294,98]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(p){this.a=p}provideTextSearchResults(p,k,L,B){return this.a.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((K,G)=>{B.onCancellationRequested(()=>H());const O=r(p,k),U=k.folder.fsPath,F=O.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.a.appendLine(`${g} ${F}
 - cwd: ${U}`);let z=a.spawn(g,O,{cwd:U});z.on("error",fe=>{console.error(fe),this.a.appendLine("Error: "+(fe&&fe.message)),G((0,P.serializeSearchError)(new P.SearchError(fe&&fe.message,P.SearchErrorCode.rgProcessError)))});let M=!1;const V=new h(k.maxResults,U,k.previewOptions);V.on("result",fe=>{M=!0,Y="",L.report(fe)});let q=!1;const H=()=>{q=!0,z?.kill(),V?.cancel()};let Q=!1;V.on("hitLimit",()=>{Q=!0,H()});let Y="";z.stdout.on("data",fe=>{V.handleData(fe),M||(Y+=fe)});let ce=!1;z.stdout.once("data",()=>ce=!0);let ie="";z.stderr.on("data",fe=>{const J=fe.toString();this.a.appendLine(J),ie.length+J.length<1e6&&(ie+=J)}),z.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(M?"Got result from parser":"No result from parser"),Y&&this.a.appendLine(`Got data without result: ${Y}`),this.a.appendLine(""),q)K({limitHit:Q});else{V.flush(),z=null;let fe;ie&&!ce&&(fe=w(ie))?G((0,P.serializeSearchError)(new P.SearchError(fe.message,fe.code))):K({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=m;function w(l){const p=l.split(`
`),k=p[0].trim();if(p.some(B=>B.startsWith("regex parse error")))return new P.SearchError(f(p),P.SearchErrorCode.regexParseError);const L=k.match(/grep config error: unknown encoding: (.*)/);if(L)return new P.SearchError(`Unknown encoding: ${L[1]}`,P.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new P.SearchError(k.charAt(0).toUpperCase()+k.substr(1),P.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new P.SearchError(k.charAt(0).toUpperCase()+k.substr(1),P.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(k,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function f(l){const p=["Regex parse error"],k=l.filter(L=>L.startsWith("PCRE2:"));if(k.length>=1){const L=k[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const B=L.split(":")[1];p.push(":"+B)}}return p.join("")}e.buildRegexParseError=f;class h extends t.EventEmitter{constructor(p,k,L){super(),this.g=p,this.h=k,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new I.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(p,k){return super.on(p,k),this}handleData(p){if(this.b)return;const k=typeof p=="string"?p:this.d.write(p);this.k(k)}k(p){let k=p.indexOf(`
`);const L=this.a+p;if(k>=0)k+=this.a.length;else{this.a=L;return}let B=0;for(;k>=0;)this.m(L.substring(B,k).trim()),B=k+1,k=L.indexOf(`
`,B);this.a=L.substring(B)}m(p){if(this.b||!p)return;let k;try{k=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(k.type==="match"){const L=b(k.data.path),B=R.URI.file(S.join(this.h,L)),K=this.n(k.data,B);this.p(K),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const L=b(k.data.path),B=R.URI.file(S.join(this.h,L));this.o(k.data,B).forEach(G=>this.p(G))}}n(p,k){const L=p.line_number-1,B=b(p.lines),K=Buffer.from(B);let G=0,O=0,U=L;p.submatches.length===0&&p.submatches.push(B.length?{start:0,end:1,match:{text:B[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(p.submatches.map((z,M)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const V=b(z.match),q=K.slice(G,z.start).toString(),H=o(q),Q=H.numLines>0?H.lastLineLength:H.lastLineLength+O,Y=o(V),ce=H.numLines+U,ie=Y.numLines+ce,fe=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+Q;return G=z.end,O=fe,U=ie,new E.Range(ce,Q,ie,fe)}));return(0,d.createTextSearchResult)(k,B,F,this.j)}o(p,k){const L=b(p.lines),B=p.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((K,G)=>({text:K,uri:k,lineNumber:B+G}))}p(p){this.emit("result",p)}}e.RipgrepParser=h;function b(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function o(l){const p=/\n/g;let k=0,L=-1,B;for(;B=p.exec(l);)k++,L=B.index;const K=L>=0?l.length-L-1:l.length;return{numLines:k,lastLineLength:K}}function r(l,p){const k=["--hidden"];k.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:B}=(0,D.groupBy)(p.includes,G=>G.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(B&&B.length){const G=new Set;B.forEach(O=>{G.add(O)}),k.push("-g","!*"),G.forEach(O=>{c(O).map(d.anchorGlob).forEach(U=>{k.push("-g",U)})})}L&&L.length&&L.forEach(G=>{k.push("-g",G)}),p.excludes.map(d.anchorGlob).forEach(G=>k.push("-g",`!${G}`)),p.maxFileSize&&k.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),p.followSymlinks&&k.push("--follow"),p.encoding&&p.encoding!=="utf8"&&k.push("--encoding",p.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,C.escapeRegExpCharacters)(l.pattern),l.isRegExp=!0),p.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),l.isRegExp&&(l.pattern=u(l.pattern),k.push("--engine","auto"));let K;if(l.isWordMatch){const O=(0,C.createRegExp)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",O)}else if(l.isRegExp){let G=s(l.pattern);G=n(G),k.push("--regexp",G)}else K=l.pattern,k.push("--fixed-strings");return k.push("--no-config"),p.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),l.isMultiline&&k.push("--multiline"),p.beforeContext&&k.push("--before-context",p.beforeContext+""),p.afterContext&&k.push("--after-context",p.afterContext+""),k.push("--"),K&&k.push(K),k.push("."),k}function c(l){const p=(0,T.splitGlobAware)(l,"/");return p.map((k,L)=>p.slice(0,L+1).join("/"))}e.spreadGlobComponents=c;function u(l){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(p);)l=l.replace(p,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(k);)l=l.replace(k,"$1\\x{$2}");return l}e.unicodeEscapesToPCRE2=u;const i=l=>l.type==="Assertion"&&l.kind==="lookbehind";function s(l){let p;try{p=new y.RegExpParser().parsePattern(l)}catch{return l}let k="",L=0;const B=(O,U,F)=>{k+=l.slice(L,O)+F,L=U},K=[];return new y.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const U=K[0];if(!U)B(O.start,O.end,"\\r?\\n");else if(!K.some(i))if(U.type==="CharacterClass")if(U.negate){const F=l.slice(U.start+2,O.start)+l.slice(O.end,U.end-1);U.parent?.type==="Quantifier"?B(U.start,U.end,F?`[^${F}]`:"."):B(U.start,U.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=l.slice(U.start+1,O.start)+l.slice(O.end,U.end-1);B(U.start,U.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else U.type==="Quantifier"&&B(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){K.unshift(O)},onQuantifierLeave(){K.shift()},onCharacterClassRangeEnter(O){K.unshift(O)},onCharacterClassRangeLeave(){K.shift()},onCharacterClassEnter(O){K.unshift(O)},onCharacterClassLeave(){K.shift()},onAssertionEnter(O){i(O)&&K.push(O)},onAssertionLeave(O){K[0]===O&&K.shift()}}).visit(p),k+=l.slice(L),k}e.fixRegexNewline=s;function n(l){return l.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(Se[303],ye([1,0,21,144,124,15]),function(ee,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(C){this.b=C,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(C,R,P,E){const y=new t.RipgrepTextSearchEngine(this.b);if(R.folder.scheme===A.Schemas.vscodeUserData){const v={...R,folder:R.folder.with({scheme:A.Schemas.file})},d=new I.Progress(g=>P.report({...g,uri:g.uri.with({scheme:R.folder.scheme})}));return this.c(E,g=>y.provideTextSearchResults(C,v,d,g))}else return this.c(E,v=>y.provideTextSearchResults(C,R,P,v))}async c(C,R){const P=T(C);this.a.add(P);const E=await R(P.token);return this.a.delete(P),E}d(){this.a.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=D;function T(S){const C=new a.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),C}}),define(Se[304],ye([1,0,29,144,143]),function(ee,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.a=S}search(S,C,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){R({message:y})}},E=new I.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),a);return new Promise((y,v)=>E.search(d=>{C(d.map(D))},S).then(d=>y({limitHit:d.limitHit,type:"success",stats:d.stats}),v))}}e.TextSearchEngineAdapter=A;function D(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,C)=>{if(C.ranges){const R=C;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(Se[305],ye([1,0,17,18,10,4,106,9,49,2,38,31,295,304]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(h="searchProcess"){this.d=h,this.b=Object.create(null)}fileSearch(h){let b;const o=m(h),r=new A.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(c=>this.doFileSearchWithEngine(E.Engine,o,u=>r.fire(u),c)),b.then(c=>r.fire(c),c=>r.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return r.event}textSearch(h){let b;const o=m(h),r=new A.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(c=>this.f(o,u=>r.fire(u),c)),b.then(c=>r.fire(c),c=>r.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return r.event}f(h,b,o){return h.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new y.TextSearchEngineAdapter(h).search(o,b,b)}doFileSearch(h,b,o){return this.doFileSearchWithEngine(E.Engine,h,b,o)}doFileSearchWithEngine(h,b,o,r,c=v.a){let u=0;const i=n=>{Array.isArray(n)?(u+=n.length,o(n.map(l=>this.g(l)))):n.relativePath?(u++,o(this.g(n))):o(n)};if(b.sortByScore){let n=this.k(b,i,r);if(!n){const l=b.maxResults?Object.assign({},b,{maxResults:null}):b,p=new h(l);n=this.h(p,b,o,i,r)}return new Promise((l,p)=>{n.then(([k,L])=>{const B=L.map(K=>this.g(K));this.n(B,o,c),l(k)},p)})}const s=new h(b);return this.q(s,i,c,r).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(h){return{path:h.base?(0,T.join)(h.base,h.relativePath):h.relativePath}}h(h,b,o,r,c){const u=new A.Emitter;let i=(0,t.createCancelablePromise)(n=>{let l=[];const p=k=>{Array.isArray(k)?l=k:(r(k),u.fire(k))};return this.q(h,p,-1,n).then(k=>[k,l])}),s;if(b.cacheKey){s=this.j(b.cacheKey);const n={promise:i,event:u.event,resolved:!1};s.resultsToSearchCache[b.filePattern||""]=n,i.then(()=>{n.resolved=!0},l=>{delete s.resultsToSearchCache[b.filePattern||""]}),i=this.r(i)}return i.then(([n,l])=>{const p=s?s.scorerCache:Object.create(null),k=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.l(b,l,p,c).then(L=>{const B=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:B,fromCache:!1,type:this.d,workspaceFolderCount:b.folderQueries.length,resultCount:L.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&l.length>b.maxResults},L]})})}j(h){const b=this.b[h];return b||(this.b[h]=new d)}k(h,b,o){const r=h.cacheKey&&this.b[h.cacheKey];if(!r)return;const c=this.o(r,h.filePattern||"",b,o);if(c)return c.then(([u,i,s])=>{const n=S.StopWatch.create(!1);return this.l(h,i,r.scorerCache,o).then(l=>{const p=n.elapsed(),k={fromCache:!0,detailStats:s,type:this.d,resultCount:i.length,sortingTime:p};return[{type:"success",limitHit:u.limitHit||typeof h.maxResults=="number"&&i.length>h.maxResults,stats:k},l]})})}l(h,b,o,r){const c=(0,D.prepareQuery)(h.filePattern||""),u=(s,n)=>(0,D.compareItemsByFuzzyScore)(s,n,c,!0,g,o),i=typeof h.maxResults=="number"?h.maxResults:Number.MAX_VALUE;return a.topAsync(b,u,i,1e4,r)}n(h,b,o){if(o&&o>0)for(let r=0;r<h.length;r+=o)b(h.slice(r,r+o));else b(h)}o(h,b,o,r){const c=S.StopWatch.create(!1),u=b.indexOf(T.sep)>=0;let i;for(const p in h.resultsToSearchCache)if(b.startsWith(p)){if(u&&p.indexOf(T.sep)<0&&p!=="")continue;const k=h.resultsToSearchCache[p];i={promise:this.r(k.promise),event:k.event,resolved:k.resolved};break}if(!i)return null;const s=c.elapsed(),n=S.StopWatch.create(!1),l=i.event(o);return r&&r.onCancellationRequested(()=>{l.dispose()}),i.promise.then(([p,k])=>{if(r&&r.isCancellationRequested)throw(0,I.canceled)();const L=[],B=(0,D.prepareQuery)(b).normalizedLowercase;for(const K of k)!(0,P.isFilePatternMatch)(K,B)||L.push(K);return[p,L,{cacheWasResolved:i.resolved,cacheLookupTime:s,cacheFilterTime:n.elapsed(),cacheEntryCount:k.length}]})}q(h,b,o,r){return new Promise((c,u)=>{let i=[];r?.onCancellationRequested(()=>h.cancel()),h.search(s=>{s&&(o?(i.push(s),o>0&&i.length>=o&&(b(i),i=[])):b(s))},s=>{b(s)},(s,n)=>{i.length&&b(i),s?u(s):c(n)})})}clearCache(h){return delete this.b[h],Promise.resolve(void 0)}r(h){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,o){return h.then(b,o)}catch(b){return this.then(void 0,b)}finally(b){return h.finally(b)}}}}e.SearchService=v,v.a=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(f){return(0,T.basename)(f.relativePath)}getItemDescription(f){return(0,T.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(w),extraFileResources:f.extraFileResources&&f.extraFileResources.map(h=>C.URI.revive(h))}}function w(f){return{...f,folder:C.URI.revive(f.folder)}}}),define(Se[306],ye([1,0,6,15,2,29,13,25,16,79,56,31,305,303,98,143]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends C.ExtHostSearch{constructor(w,f,h,b){super(w,h,b),this.s=A,this.t=-1,this.v=null,this.w=!1;const o=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new y.RipgrepSearchProvider(o)),f.remote.isRemote&&f.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const w=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new y.RipgrepSearchProvider(w)),this.y(t.Schemas.file,new E.SearchService("fileSearchProvider"))}y(w,f){const h=this.d++;return this.v=f,this.t=h,this.c.$registerFileSearchProvider(h,this.o(w)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(h)})}$provideFileSearchResults(w,f,h,b){const o=(0,C.reviveQuery)(h);return w===this.t?this.z(w,f,o,b):super.$provideFileSearchResults(w,f,h,b)}z(w,f,h,b){const o=r=>{if((0,P.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this.c.$handleFileMatch(w,f,r.map(c=>I.URI.file(c.path)));return}r.message&&this.n.debug("ExtHostSearch",r.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(h,o,b)}$clearCache(w){return this.v?.clearCache(w),super.$clearCache(w)}q(w,f){return new d.NativeTextSearchManager(w,f,void 0,"textSearchProvider")}};g=qe([We(0,S.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,R.IURITransformerService),We(3,D.ILogService)],g),e.NativeExtHostSearch=g}),define(Se[307],ye([1,0,87,278,290,289,306,302,279,78,41,79,76,40,55,73,277,276,13,291,47]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m,w,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(R.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,a.registerSingleton)(w.ILoggerService,m.ExtHostLoggerService,1),(0,a.registerSingleton)(d.IExtensionStoragePaths,g.ExtensionStoragePaths,0),(0,a.registerSingleton)(C.IExtHostDebugService,A.ExtHostDebugService,0),(0,a.registerSingleton)(P.IExtHostSearch,D.NativeExtHostSearch,0),(0,a.registerSingleton)(E.IExtHostTask,I.ExtHostTask,0),(0,a.registerSingleton)(y.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,a.registerSingleton)(h.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService,0)}),define(Se[315],ye([1,0,217,316,77,10,113,114,198,93,288,22,29,110,18,119,213,227,292,307]),function(ee,e,a,t,I,A,D,T,S,C,R,P,E,y,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const w=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return s.apply(this,arguments)}})();const f=process.exit.bind(process);function h(i){process.exit=function(s){if(i)f(s);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(i){f()};function o(){const i=(0,m.readExtHostConnection)(process.env);if(i.type===3)return new Promise((s,n)=>{const l=p=>{const k=p[0],L=new D.BufferedEmitter;k.on("message",B=>L.fire(P.VSBuffer.wrap(B.data))),k.on("close",()=>{b("renderer closed the MessagePort")}),k.start(),s({onMessage:L.event,send:B=>k.postMessage(B.buffer)})};process?.parentPort.on("message",p=>l(p.ports))});if(i.type===2)return new Promise((s,n)=>{let l=null;const p=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,L=3e5,B=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),k),K=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),L);process.on("message",(O,U)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const F=P.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let z;if(O.skipWebSocketFrames)z=new T.NodeSocket(U,"extHost-socket");else{const M=P.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));z=new T.WebSocketNodeSocket(new T.NodeSocket(U,"extHost-socket"),O.permessageDeflate,M,!1)}l?(B.cancel(),K.cancel(),l.beginAcceptReconnection(z,F),l.endAcceptReconnection(),l.sendResume()):(clearTimeout(p),l=new D.PersistentProtocol(z,F),l.sendResume(),l.onDidDispose(()=>b("renderer disconnected")),s(l),l.onSocketClose(()=>{B.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(K.isScheduled())return;B.isScheduled()&&K.schedule()}});const G={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(G)});{const s=i.pipeName;return new Promise((n,l)=>{const p=a.createConnection(s,()=>{p.removeListener("error",l);const k=new D.PersistentProtocol(new T.NodeSocket(p,"extHost-renderer"));k.sendResume(),n(k)});p.once("error",l),p.on("close",()=>{b("renderer closed the socket")})})}}async function r(){const i=await o();return new class{constructor(){this.a=new D.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,i.onMessage(s=>{(0,C.isMessageOfType)(s,2)?(this.b=!0,b("received terminate message from renderer")):this.a.fire(s)})}send(s){this.b||i.send(s)}async drain(){if(i.drain)return i.drain()}}}function c(i){return new Promise(s=>{const n=i.onMessage(l=>{n.dispose();const p=JSON.parse(l.toString()),k=p.commit,L=S.default.commit;if(k&&L&&k!==L&&f(55),p.parentPid){let B=0;setInterval(function(){try{process.kill(p.parentPid,0),B=0}catch(G){G&&G.code==="EPERM"?(B++,B>=3&&b(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${G.message} (code: ${G.code}) (errno: ${G.errno})`)):b(`parent process ${p.parentPid} does not exist anymore: ${G.message} (code: ${G.code}) (errno: ${G.errno})`)}},1e3);let K;try{K=globalThis._VSCODE_NODE_MODULES["native-watchdog"],K.start(p.parentPid)}catch(G){(0,A.onUnexpectedError)(G)}}i.send((0,C.createMessageOfType)(0)),s({protocol:i,initData:p})});i.send((0,C.createMessageOfType)(1))})}async function u(){const i=[];process.on("unhandledRejection",(B,K)=>{i.push(K),setTimeout(()=>{const G=i.indexOf(K);G>=0&&K.catch(O=>{i.splice(G,1),(0,A.isCancellationError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),B&&(0,A.onUnexpectedError)(B))})},1e3)}),process.on("rejectionHandled",B=>{const K=i.indexOf(B);K>=0&&i.splice(K,1)}),process.on("uncaughtException",function(B){(0,A.onUnexpectedError)(B)}),I.mark("code/extHost/willConnectToRenderer");const s=await r();I.mark("code/extHost/didConnectToRenderer");const n=await c(s);I.mark("code/extHost/didWaitForInitData");const{initData:l}=n;h(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=w.useHostProxy!==void 0?w.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,d.boolean)(w.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(K){f(K)}exists(K){return E.Promises.exists(K)}realpath(K){return(0,y.realpath)(K)}};let k=null;l.remote.authority&&w.transformURIs&&(k=(0,g.createURITransformer)(l.remote.authority));const L=new R.ExtensionHostMain(n.protocol,l,p,k);b=B=>L.terminate(B)}u().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
